# SocketTools Library Error Codes

| Value      | Constant                               | Description                                                             |
|:-----------|:---------------------------------------|:------------------------------------------------------------------------|
| 0x80042711 | ST_ERROR_NOT_HANDLE_OWNER              | Handle not owned by the current thread                                  |
| 0x80042712 | ST_ERROR_FILE_NOT_FOUND                | The specified file or directory does not exist                          |
| 0x80042713 | ST_ERROR_FILE_NOT_CREATED              | The specified file could not be created                                 |
| 0x80042714 | ST_ERROR_OPERATION_CANCELED            | The blocking operation has been canceled                                |
| 0x80042715 | ST_ERROR_INVALID_FILE_TYPE             | The specified file is a block or character device, not a regular file   |
| 0x80042716 | ST_ERROR_INVALID_DEVICE                | The specified device or address does not exist                          |
| 0x80042717 | ST_ERROR_TOO_MANY_PARAMETERS           | The maximum number of function parameters has been exceeded             |
| 0x80042718 | ST_ERROR_INVALID_FILE_NAME             | The specified file name contains invalid characters or is too long      |
| 0x80042719 | ST_ERROR_INVALID_FILE_HANDLE           | Invalid file handle passed to function                                  |
| 0x8004271A | ST_ERROR_FILE_READ_FAILED              | Unable to read data from the specified file                             |
| 0x8004271B | ST_ERROR_FILE_WRITE_FAILED             | Unable to write data to the specified file                              |
| 0x8004271C | ST_ERROR_OUT_OF_MEMORY                 | Out of memory                                                           |
| 0x8004271D | ST_ERROR_ACCESS_DENIED                 | Access denied                                                           |
| 0x8004271E | ST_ERROR_INVALID_PARAMETER             | Invalid argument passed to function                                     |
| 0x8004271F | ST_ERROR_CLIPBOARD_UNAVAILABLE         | The system clipboard is currently unavailable                           |
| 0x80042720 | ST_ERROR_CLIPBOARD_EMPTY               | The system clipboard is empty or does not contain any text data         |
| 0x80042721 | ST_ERROR_FILE_EMPTY                    | The specified file does not contain any data                            |
| 0x80042722 | ST_ERROR_FILE_EXISTS                   | The specified file already exists                                       |
| 0x80042723 | ST_ERROR_END_OF_FILE                   | End of file                                                             |
| 0x80042724 | ST_ERROR_DEVICE_NOT_FOUND              | The specified device could not be found                                 |
| 0x80042725 | ST_ERROR_DIRECTORY_NOT_FOUND           | The specified directory could not be found                              |
| 0x80042726 | ST_ERROR_INVALID_BUFFER                | Invalid memory address passed to function                               |
| 0x80042728 | ST_ERROR_NO_HANDLES                    | No more handles available to this process                               |
| 0x80042733 | ST_ERROR_OPERATION_WOULD_BLOCK         | The specified operation would block the current thread                  |
| 0x80042734 | ST_ERROR_OPERATION_IN_PROGRESS         | A blocking operation is currently in progress                           |
| 0x80042735 | ST_ERROR_ALREADY_IN_PROGRESS           | The specified operation is already in progress                          |
| 0x80042736 | ST_ERROR_INVALID_HANDLE                | Invalid handle passed to function                                       |
| 0x80042737 | ST_ERROR_INVALID_ADDRESS               | Invalid network address specified                                       |
| 0x80042738 | ST_ERROR_INVALID_SIZE                  | Datagram is too large to fit in specified buffer                        |
| 0x80042739 | ST_ERROR_INVALID_PROTOCOL              | Invalid network protocol specified                                      |
| 0x8004273A | ST_ERROR_PROTOCOL_NOT_AVAILABLE        | The specified network protocol is not available                         |
| 0x8004273B | ST_ERROR_PROTOCOL_NOT_SUPPORTED        | The specified protocol is not supported                                 |
| 0x8004273C | ST_ERROR_SOCKET_NOT_SUPPORTED          | The specified socket type is not supported                              |
| 0x8004273D | ST_ERROR_INVALID_OPTION                | The specified option is invalid                                         |
| 0x8004273E | ST_ERROR_PROTOCOL_FAMILY               | Specified protocol family is not supported                              |
| 0x8004273F | ST_ERROR_PROTOCOL_ADDRESS              | The specified address is invalid for this protocol family               |
| 0x80042740 | ST_ERROR_ADDRESS_IN_USE                | The specified address is in use by another process                      |
| 0x80042741 | ST_ERROR_ADDRESS_UNAVAILABLE           | The specified address cannot be assigned                                |
| 0x80042742 | ST_ERROR_NETWORK_UNAVAILABLE           | The networking subsystem is unavailable                                 |
| 0x80042743 | ST_ERROR_NETWORK_UNREACHABLE           | The specified network is unreachable                                    |
| 0x80042744 | ST_ERROR_NETWORK_RESET                 | Network dropped connection on remote reset                              |
| 0x80042745 | ST_ERROR_CONNECTION_ABORTED            | Connection was aborted due to timeout or other failure                  |
| 0x80042746 | ST_ERROR_CONNECTION_RESET              | Connection was reset by remote network                                  |
| 0x80042747 | ST_ERROR_OUT_OF_BUFFERS                | No buffer space is available                                            |
| 0x80042748 | ST_ERROR_ALREADY_CONNECTED             | Connection already established with remote host                         |
| 0x80042749 | ST_ERROR_NOT_CONNECTED                 | No connection established with remote host                              |
| 0x8004274A | ST_ERROR_CONNECTION_SHUTDOWN           | Unable to send or receive data after connection shutdown                |
| 0x8004274C | ST_ERROR_OPERATION_TIMEOUT             | The specified operation has timed out                                   |
| 0x8004274D | ST_ERROR_CONNECTION_REFUSED            | The connection has been refused by the remote host                      |
| 0x80042750 | ST_ERROR_HOST_UNAVAILABLE              | The specified host is unavailable                                       |
| 0x80042751 | ST_ERROR_HOST_UNREACHABLE              | Remote host is unreachable                                              |
| 0x80042753 | ST_ERROR_TOO_MANY_PROCESSES            | Too many processes are using the networking subsystem                   |
| 0x80042755 | ST_ERROR_TOO_MANY_THREADS              | Too many threads have been created by the current process               |
| 0x80042756 | ST_ERROR_TOO_MANY_SESSIONS             | Too many client sessions have been created by the current process       |
| 0x80042762 | ST_ERROR_INTERNAL_FAILURE              | An unexpected internal error has occurred                               |
| 0x8004276B | ST_ERROR_NETWORK_NOT_READY             | Network subsystem is not ready for communication                        |
| 0x8004276C | ST_ERROR_INVALID_VERSION               | This version of the operating system is not supported                   |
| 0x8004276D | ST_ERROR_NETWORK_NOT_INITIALIZED       | The networking subsystem has not been initialized                       |
| 0x80042775 | ST_ERROR_REMOTE_SHUTDOWN               | The remote host has initiated a graceful shutdown sequence              |
| 0x80042AF9 | ST_ERROR_INVALID_HOSTNAME              | The specified hostname is invalid or could not be resolved              |
| 0x80042AFA | ST_ERROR_HOSTNAME_NOT_FOUND            | The specified hostname could not be found                               |
| 0x80042AFB | ST_ERROR_HOSTNAME_REFUSED              | Unable to resolve hostname, request refused                             |
| 0x80042AFC | ST_ERROR_HOSTNAME_NOT_RESOLVED         | Unable to resolve hostname, no address for specified host               |
| 0x80042EE1 | ST_ERROR_INVALID_LICENSE               | The license for this product is invalid                                 |
| 0x80042EE2 | ST_ERROR_PRODUCT_NOT_LICENSED          | This product is not licensed to perform this operation                  |
| 0x80042EE3 | ST_ERROR_NOT_IMPLEMENTED               | This function has not been implemented on this platform                 |
| 0x80042EE4 | ST_ERROR_UNKNOWN_LOCALHOST             | Unable to determine local host name                                     |
| 0x80042EE5 | ST_ERROR_INVALID_HOSTADDRESS           | Invalid host address specified                                          |
| 0x80042EE6 | ST_ERROR_INVALID_SERVICE_PORT          | Invalid service port number specified                                   |
| 0x80042EE7 | ST_ERROR_INVALID_SERVICE_NAME          | Invalid or unknown service name specified                               |
| 0x80042EE8 | ST_ERROR_INVALID_EVENTID               | Invalid event identifier specified                                      |
| 0x80042EE9 | ST_ERROR_OPERATION_NOT_BLOCKING        | No blocking operation in progress on this socket                        |
| 0x80042F45 | ST_ERROR_SECURITY_NOT_INITIALIZED      | Unable to initialize security interface for this process                |
| 0x80042F46 | ST_ERROR_SECURITY_CONTEXT              | Unable to establish security context for this session                   |
| 0x80042F47 | ST_ERROR_SECURITY_CREDENTIALS          | Unable to open client certificate store or establish client credentials |
| 0x80042F48 | ST_ERROR_SECURITY_CERTIFICATE          | Unable to validate the certificate chain for this session               |
| 0x80042F49 | ST_ERROR_SECURITY_DECRYPTION           | Unable to decrypt data stream                                           |
| 0x80042F4A | ST_ERROR_SECURITY_ENCRYPTION           | Unable to encrypt data stream                                           |
| 0x80042FA9 | ST_ERROR_OPERATION_NOT_SUPPORTED       | The specified operation is not supported                                |
| 0x80042FAA | ST_ERROR_INVALID_PROTOCOL_VERSION      | Invalid application protocol version specified                          |
| 0x80042FAB | ST_ERROR_NO_SERVER_RESPONSE            | No data returned from server                                            |
| 0x80042FAC | ST_ERROR_INVALID_SERVER_RESPONSE       | Invalid data returned from server                                       |
| 0x80042FAD | ST_ERROR_UNEXPECTED_SERVER_RESPONSE    | Unexpected response code returned from server                           |
| 0x80042FAE | ST_ERROR_SERVER_TRANSACTION_FAILED     | Server transaction failed                                               |
| 0x80042FAF | ST_ERROR_SERVICE_UNAVAILABLE           | The service is currently unavailable                                    |
| 0x80042FB0 | ST_ERROR_SERVICE_NOT_READY             | The service is not ready, try again later                               |
| 0x80042FB1 | ST_ERROR_SERVER_RESYNC_FAILED          | Unable to resynchronize with server                                     |
| 0x80042FB2 | ST_ERROR_INVALID_PROXY_TYPE            | Invalid proxy server type specified                                     |
| 0x80042FB3 | ST_ERROR_PROXY_REQUIRED                | Resource must be accessed through specified proxy                       |
| 0x80042FB4 | ST_ERROR_INVALID_PROXY_LOGIN           | Unable to login to proxy server using specified credentials             |
| 0x80042FB5 | ST_ERROR_PROXY_RESYNC_FAILED           | Unable to resynchronize with proxy server                               |
| 0x80042FB6 | ST_ERROR_INVALID_COMMAND               | Invalid command specified                                               |
| 0x80042FB7 | ST_ERROR_INVALID_COMMAND_PARAMETER     | Invalid command parameter specified                                     |
| 0x80042FB8 | ST_ERROR_INVALID_COMMAND_SEQUENCE      | Invalid command sequence specified                                      |
| 0x80042FB9 | ST_ERROR_COMMAND_NOT_IMPLEMENTED       | Specified command not implemented on this server                        |
| 0x80042FBA | ST_ERROR_COMMAND_NOT_AUTHORIZED        | Specified command not authorized for the current user                   |
| 0x80042FBB | ST_ERROR_COMMAND_ABORTED               | Specified command was aborted by the remote host                        |
| 0x80042FBC | ST_ERROR_OPTION_NOT_SUPPORTED          | The specified option is not supported on this server                    |
| 0x80042FBD | ST_ERROR_REQUEST_NOT_COMPLETED         | The current client request has not been completed                       |
| 0x80042FBE | ST_ERROR_INVALID_USERNAME              | The specified username is invalid                                       |
| 0x80042FBF | ST_ERROR_INVALID_PASSWORD              | The specified password is invalid                                       |
| 0x80042FC0 | ST_ERROR_INVALID_ACCOUNT               | The specified account name is invalid                                   |
| 0x80042FC1 | ST_ERROR_ACCOUNT_REQUIRED              | Account name has not been specified                                     |
| 0x80042FC2 | ST_ERROR_INVALID_AUTHENTICATION_TYPE   | Invalid authentication protocol specified                               |
| 0x80042FC3 | ST_ERROR_AUTHENTICATION_REQUIRED       | User authentication is required                                         |
| 0x80042FC4 | ST_ERROR_PROXY_AUTHENTICATION_REQUIRED | Proxy authentication required                                           |
| 0x80042FC5 | ST_ERROR_ALREADY_AUTHENTICATED         | User has already been authenticated                                     |
| 0x80042FC6 | ST_ERROR_AUTHENTICATION_FAILED         | Unable to authenticate the specified user                               |
| 0x80042FDB | ST_ERROR_NETWORK_ADAPTER               | Unable to determine network adapter configuration                       |
| 0x80042FDC | ST_ERROR_INVALID_RECORD_TYPE           | Invalid record type specified                                           |
| 0x80042FDD | ST_ERROR_INVALID_RECORD_NAME           | Invalid record name specified                                           |
| 0x80042FDE | ST_ERROR_INVALID_RECORD_DATA           | Invalid record data specified                                           |
| 0x80042FDF | ST_ERROR_CONNECTION_OPEN               | Data connection already established                                     |
| 0x80042FE0 | ST_ERROR_CONNECTION_CLOSED             | Server closed data connection                                           |
| 0x80042FE1 | ST_ERROR_CONNECTION_PASSIVE            | Data connection is passive                                              |
| 0x80042FE2 | ST_ERROR_CONNECTION_FAILED             | Unable to open data connection to server                                |
| 0x80042FE3 | ST_ERROR_INVALID_SECURITY_LEVEL        | Data connection cannot be opened with this security setting             |
| 0x80042FE4 | ST_ERROR_CACHED_TLS_REQUIRED           | Data connection requires cached TLS session                             |
| 0x80042FE5 | ST_ERROR_DATA_READ_ONLY                | Data connection is read-only                                            |
| 0x80042FE6 | ST_ERROR_DATA_WRITE_ONLY               | Data connection is write-only                                           |
| 0x80042FE7 | ST_ERROR_END_OF_DATA                   | End of data                                                             |
| 0x80042FE8 | ST_ERROR_REMOTE_FILE_UNAVAILABLE       | Remote file is unavailable                                              |
| 0x80042FE9 | ST_ERROR_INSUFFICIENT_STORAGE          | Insufficient storage on server                                          |
| 0x80042FEA | ST_ERROR_STORAGE_ALLOCATION            | File exceeded storage allocation on server                              |
| 0x80042FEB | ST_ERROR_DIRECTORY_EXISTS              | The specified directory already exists                                  |
| 0x80042FEC | ST_ERROR_DIRECTORY_EMPTY               | No files returned by the server for the specified directory             |
| 0x80042FED | ST_ERROR_END_OF_DIRECTORY              | End of directory listing                                                |
| 0x80042FEE | ST_ERROR_UNKNOWN_DIRECTORY_FORMAT      | Unknown directory format                                                |
| 0x80042FEF | ST_ERROR_INVALID_RESOURCE              | Invalid resource name specified                                         |
| 0x80042FF0 | ST_ERROR_RESOURCE_REDIRECTED           | The specified resource has been redirected                              |
| 0x80042FF1 | ST_ERROR_RESOURCE_RESTRICTED           | Access to this resource has been restricted                             |
| 0x80042FF2 | ST_ERROR_RESOURCE_NOT_MODIFIED         | The specified resource has not been modified                            |
| 0x80042FF3 | ST_ERROR_RESOURCE_NOT_FOUND            | The specified resource cannot be found                                  |
| 0x80042FF4 | ST_ERROR_RESOURCE_CONFLICT             | Request could not be completed due to the current state of the resource |
| 0x80042FF5 | ST_ERROR_RESOURCE_REMOVED              | The specified resource has been permanently removed from this server    |
| 0x80042FF6 | ST_ERROR_CONTENT_LENGTH_REQUIRED       | Request must include the content length                                 |
| 0x80042FF7 | ST_ERROR_REQUEST_PRECONDITION          | Request could not be completed due to server precondition               |
| 0x80042FF8 | ST_ERROR_UNSUPPORTED_MEDIA_TYPE        | Request specified an unsupported media type                             |
| 0x80042FF9 | ST_ERROR_INVALID_CONTENT_RANGE         | Content range specified for this resource is invalid                    |
| 0x80042FFA | ST_ERROR_INVALID_MESSAGE_PART          | Message is not multipart or an invalid message part was specified       |
| 0x80042FFB | ST_ERROR_INVALID_MESSAGE_HEADER        | The specified message header is invalid or has not been defined         |
| 0x80042FFC | ST_ERROR_INVALID_MESSAGE_BOUNDARY      | The multipart message boundary has not been defined                     |
| 0x80042FFD | ST_ERROR_NO_FILE_ATTACHMENT            | The current message part does not contain a file attachment             |
| 0x80042FFE | ST_ERROR_UNKNOWN_FILE_TYPE             | The specified file type could not be determined                         |
| 0x80042FFF | ST_ERROR_DATA_NOT_ENCODED              | The specified data block could not be encoded                           |
| 0x80043000 | ST_ERROR_DATA_NOT_DECODED              | The specified data block could not be decoded                           |
| 0x80043001 | ST_ERROR_FILE_NOT_ENCODED              | The specified file could not be encoded                                 |
| 0x80043002 | ST_ERROR_FILE_NOT_DECODED              | The specified file could not be decoded                                 |
| 0x80043003 | ST_ERROR_NO_MESSAGE_TEXT               | No message text                                                         |
| 0x80043004 | ST_ERROR_INVALID_CHARACTER_SET         | Invalid character set specified                                         |
| 0x80043005 | ST_ERROR_INVALID_ENCODING_TYPE         | Invalid encoding type specified                                         |
| 0x80043006 | ST_ERROR_INVALID_MESSAGE_NUMBER        | Invalid message number specified                                        |
| 0x80043007 | ST_ERROR_NO_RETURN_ADDRESS             | No valid return address specified                                       |
| 0x80043008 | ST_ERROR_NO_VALID_RECIPIENTS           | No valid recipients specified                                           |
| 0x80043009 | ST_ERROR_INVALID_RECIPIENT             | The specified recipient address is invalid                              |
| 0x8004300A | ST_ERROR_RELAY_NOT_AUTHORIZED          | The specified domain is invalid or server will not relay messages       |
| 0x8004300B | ST_ERROR_MAILBOX_UNAVAILABLE           | Specified mailbox is currently unavailable                              |
| 0x8004300C | ST_ERROR_MAILBOX_READONLY              | The selected mailbox cannot be modified                                 |
| 0x8004300D | ST_ERROR_MAILBOX_NOT_SELECTED          | No mailbox has been selected                                            |
| 0x8004300E | ST_ERROR_INVALID_MAILBOX               | Specified mailbox is invalid                                            |
| 0x8004300F | ST_ERROR_INVALID_DOMAIN                | The specified domain name is invalid or not recognized                  |
| 0x80043010 | ST_ERROR_INVALID_SENDER                | The specified sender address is invalid or not recognized               |
| 0x80043011 | ST_ERROR_MESSAGE_NOT_DELIVERED         | Message not delivered to any of the specified recipients                |
| 0x80043012 | ST_ERROR_END_OF_MESSAGE_DATA           | No more message data available to be read                               |
| 0x80043013 | ST_ERROR_INVALID_MESSAGE_SIZE          | The specified message size is invalid                                   |
| 0x80043014 | ST_ERROR_MESSAGE_NOT_CREATED           | The message could not be created in the specified mailbox               |
| 0x80043015 | ST_ERROR_NO_MORE_MAILBOXES             | No more mailboxes exist on this server                                  |
| 0x80043016 | ST_ERROR_INVALID_EMULATION_TYPE        | The specified terminal emulation type is invalid                        |
| 0x80043017 | ST_ERROR_INVALID_FONT_HANDLE           | The specified font handle is invalid                                    |
| 0x80043018 | ST_ERROR_INVALID_FONT_NAME             | The specified font name is invalid or unavailable                       |
| 0x80043019 | ST_ERROR_INVALID_PACKET_SIZE           | The specified packet size is invalid                                    |
| 0x8004301A | ST_ERROR_INVALID_PACKET_DATA           | The specified packet data is invalid                                    |
| 0x8004301B | ST_ERROR_INVALID_PACKET_ID             | The unique packet identifier is invalid                                 |
| 0x8004301C | ST_ERROR_PACKET_TTL_EXPIRED            | The specified packet time-to-live period has expired                    |
| 0x8004301D | ST_ERROR_INVALID_NEWSGROUP             | Invalid newsgroup specified                                             |
| 0x8004301E | ST_ERROR_NO_NEWSGROUP_SELECTED         | No newsgroup selected                                                   |
| 0x8004301F | ST_ERROR_EMPTY_NEWSGROUP               | No articles in specified newsgroup                                      |
| 0x80043020 | ST_ERROR_INVALID_ARTICLE               | Invalid article number specified                                        |
| 0x80043021 | ST_ERROR_NO_ARTICLE_SELECTED           | No article selected in the current newsgroup                            |
| 0x80043022 | ST_ERROR_FIRST_ARTICLE                 | First article in current newsgroup                                      |
| 0x80043023 | ST_ERROR_LAST_ARTICLE                  | Last article in current newsgroup                                       |
| 0x80043024 | ST_ERROR_ARTICLE_EXISTS                | Unable to transfer article, article already exists                      |
| 0x80043025 | ST_ERROR_ARTICLE_REJECTED              | Unable to transfer article, article rejected                            |
| 0x80043026 | ST_ERROR_ARTICLE_TRANSFER_FAILED       | Article transfer failed                                                 |
| 0x80043027 | ST_ERROR_ARTICLE_POSTING_DENIED        | Posting is not permitted on this server                                 |
| 0x80043028 | ST_ERROR_ARTICLE_POSTING_FAILED        | Posting is not permitted on this server                                 |
| 0x80043029 | ST_ERROR_INVALID_DATE_FORMAT           | The specified date format is not recognized                             |
| 0x8004302A | ST_ERROR_FEATURE_NOT_SUPPORTED         | The specified feature is not supported on this server                   |
| 0x8004302B | ST_ERROR_INVALID_FORM_HANDLE           | The specified form handle is invalid or a form has not been created     |
| 0x8004302C | ST_ERROR_INVALID_FORM_ACTION           | The specified form action is invalid or has not been specified          |
| 0x8004302D | ST_ERROR_INVALID_FORM_METHOD           | The specified form method is invalid or not supported                   |
| 0x8004302E | ST_ERROR_INVALID_FORM_TYPE             | The specified form type is invalid or not supported                     |
| 0x8004302F | ST_ERROR_INVALID_FORM_FIELD            | The specified form field name is invalid or does not exist              |
| 0x80043030 | ST_ERROR_EMPTY_FORM                    | The specified form does not contain any field values                    |
| 0x80043031 | ST_ERROR_MAXIMUM_CONNECTIONS           | The maximum number of client connections exceeded                       |
| 0x80043032 | ST_ERROR_THREAD_CREATION_FAILED        | Unable to create a new thread for the current process                   |
| 0x80043033 | ST_ERROR_INVALID_THREAD_HANDLE         | The specified thread handle is no longer valid                          |
| 0x80043034 | ST_ERROR_THREAD_TERMINATED             | The specified thread has been terminated                                |
| 0x80043035 | ST_ERROR_THREAD_DEADLOCK               | The operation would result in the current thread becoming deadlocked    |
| 0x80043036 | ST_ERROR_INVALID_CLIENT_MONIKER        | The specified moniker is not associated with any client session         |
| 0x80043037 | ST_ERROR_CLIENT_MONIKER_EXISTS         | The specified moniker has been assigned to another client session       |
| 0x80043038 | ST_ERROR_SERVER_INACTIVE               | The specified server is not listening for client connections            |
| 0x80043039 | ST_ERROR_SERVER_SUSPENDED              | The specified server is suspended and not accepting client connections  |
| 0x8004303A | ST_ERROR_NO_MESSAGE_STORE              | No message store has been specified                                     |
| 0x8004303B | ST_ERROR_MESSAGE_STORE_CHANGED         | The message store has changed since it was last accessed                |
| 0x8004303C | ST_ERROR_MESSAGE_NOT_FOUND             | No message was found that matches the specified criteria                |
| 0x8004303D | ST_ERROR_MESSAGE_DELETED               | The specified message has been deleted                                  |
| 0x8004303E | ST_ERROR_FILE_CHECKSUM_MISMATCH        | The specified file checksums do not match                               |
| 0x8004303F | ST_ERROR_FILE_SIZE_MISMATCH            | The specified file sizes do not match                                   |
| 0x80043040 | ST_ERROR_INVALID_FEED_URL              | The news feed URL is invalid or specifies an unsupported protocol       |
| 0x80043041 | ST_ERROR_INVALID_FEED_FORMAT           | The internal format of the news feed is invalid                         |
| 0x80043042 | ST_ERROR_INVALID_FEED_VERSION          | This version of the news feed is not supported                          |
| 0x80043043 | ST_ERROR_CHANNEL_EMPTY                 | There are no valid items found in this news feed                        |
| 0x80043044 | ST_ERROR_INVALID_ITEM_NUMBER           | The specified channel item identifier is invalid                        |
| 0x80043045 | ST_ERROR_ITEM_NOT_FOUND                | The specified channel item could not be found                           |
| 0x80043046 | ST_ERROR_ITEM_EMPTY                    | The specified channel item does not contain any data                    |
| 0x80043047 | ST_ERROR_INVALID_ITEM_PROPERTY         | The specified item property name is invalid                             |
| 0x80043048 | ST_ERROR_ITEM_PROPERTY_NOT_FOUND       | The specified item property has not been defined                        |
| 0x80043049 | ST_ERROR_INVALID_CHANNEL_TITLE         | The channel title is invalid or has not been defined                    |
| 0x8004304A | ST_ERROR_INVALID_CHANNEL_LINK          | The channel hyperlink is invalid or has not been defined                |
| 0x8004304B | ST_ERROR_INVALID_CHANNEL_DESCRIPTION   | The channel description is invalid or has not been defined              |
| 0x8004304C | ST_ERROR_INVALID_ITEM_TEXT             | The description for an item is invalid or has not been defined          |
| 0x8004304D | ST_ERROR_INVALID_ITEM_LINK             | The hyperlink for an item is invalid or has not been defined            |
| 0x8004304E | ST_ERROR_INVALID_SERVICE_TYPE          | The specified service type is invalid                                   |
| 0x8004304F | ST_ERROR_SERVICE_SUSPENDED             | Access to the specified service has been suspended                      |
| 0x80043050 | ST_ERROR_SERVICE_RESTRICTED            | Access to the specified service has been restricted                     |
| 0x80043051 | ST_ERROR_INVALID_PROVIDER_NAME         | The specified provider name is invalid or unknown                       |
| 0x80043052 | ST_ERROR_INVALID_PHONE_NUMBER          | The specified phone number is invalid or not supported in this region   |
| 0x80043053 | ST_ERROR_GATEWAY_NOT_FOUND             | A message gateway cannot be found for the specified provider            |
| 0x80043054 | ST_ERROR_MESSAGE_TOO_LONG              | The message exceeds the maximum number of characters permitted          |
| 0x80043055 | ST_ERROR_INVALID_PROVIDER_DATA         | The request returned invalid or incomplete service provider data        |
| 0x80043056 | ST_ERROR_INVALID_GATEWAY_DATA          | The request returned invalid or incomplete message gateway data         |
| 0x80043057 | ST_ERROR_MULTIPLE_PROVIDERS            | The request has returned multiple service providers                     |
| 0x80043058 | ST_ERROR_PROVIDER_NOT_FOUND            | The specified service provider could not be found                       |
| 0x80043059 | ST_ERROR_INVALID_MESSAGE_SERVICE       | The specified message is not supported with this service type           |
| 0x8004305A | ST_ERROR_INVALID_MESSAGE_FORMAT        | The specified message format is invalid                                 |
| 0x8004305B | ST_ERROR_INVALID_CONFIGURATION         | The specified configuration options are invalid                         |
| 0x8004305C | ST_ERROR_SERVER_ACTIVE                 | The requested action is not permitted while the server is active        |
| 0x8004305D | ST_ERROR_SERVER_PORT_BOUND             | Unable to obtain exclusive use of the specified local port              |
| 0x8004305E | ST_ERROR_INVALID_CLIENT_SESSION        | The specified client identifier is invalid for this session             |
| 0x8004305F | ST_ERROR_CLIENT_NOT_IDENTIFIED         | The specified client has not provided user credentials                  |
| 0x80043060 | ST_ERROR_INVALID_CLIENT_STATE          | The requested action cannot be performed at this time                   |
| 0x80043061 | ST_ERROR_INVALID_RESULT_CODE           | The specified result code is not valid for this protocol                |
| 0x80043062 | ST_ERROR_COMMAND_REQUIRED              | The specified command is required and cannot be disabled                |
| 0x80043063 | ST_ERROR_COMMAND_DISABLED              | The specified command has been disabled                                 |
| 0x80043064 | ST_ERROR_COMMAND_SEQUENCE              | The command cannot be processed at this time                            |
| 0x80043065 | ST_ERROR_COMMAND_COMPLETED             | The previous command has completed                                      |
| 0x80043066 | ST_ERROR_INVALID_PROGRAM_NAME          | The specified program name is invalid or unrecognized                   |
| 0x80043067 | ST_ERROR_INVALID_REQUEST_HEADER        | The request header contains one or more invalid values                  |
| 0x80043068 | ST_ERROR_INVALID_VIRTUAL_HOST          | The specified virtual host name is invalid                              |
| 0x80043069 | ST_ERROR_VIRTUAL_HOST_NOT_FOUND        | The specified virtual host does not exist                               |
| 0x8004306A | ST_ERROR_TOO_MANY_VIRTUAL_HOSTS        | Too many virtual hosts created for this server                          |
| 0x8004306B | ST_ERROR_INVALID_VIRTUAL_PATH          | The specified virtual path name is invalid                              |
| 0x8004306C | ST_ERROR_VIRTUAL_PATH_NOT_FOUND        | The specified virtual path does not exist                               |
| 0x8004306D | ST_ERROR_TOO_MANY_VIRTUAL_PATHS        | Too many virtual paths created for this server                          |
| 0x8004306E | ST_ERROR_INVALID_TASK                  | The asynchronous task identifier is invalid                             |
| 0x8004306F | ST_ERROR_TASK_ACTIVE                   | The asynchronous task has not finished                                  |
| 0x80043070 | ST_ERROR_TASK_QUEUED                   | The asynchronous task has been queued                                   |
| 0x80043071 | ST_ERROR_TASK_SUSPENDED                | The asynchronous task has been suspended                                |
| 0x80043072 | ST_ERROR_TASK_FINISHED                 | The asynchronous task has finished                                      |
| 0x80043073 | ST_ERROR_INVALID_ACCOUNT_UUID          | The account unique identifier is invalid                                |
| 0x80043074 | ST_ERROR_INVALID_ACCOUNT_ID            | The application account identifier is invalid                           |
| 0x80043075 | ST_ERROR_INVALID_PRODUCT_ID            | The product identifier identifier is invalid                            |
| 0x80043076 | ST_ERROR_INVALID_SERIAL_NUMBER         | The product serial number is invalid                                    |
| 0x80043077 | ST_ERROR_INVALID_APPID                 | The application identifier is invalid                                   |
| 0x80043078 | ST_ERROR_INVALID_APIKEY                | The application key is invalid                                          |
| 0x80043079 | ST_ERROR_ACCOUNT_EXISTS                | The application account identifier already exists                       |
| 0x8004307A | ST_ERROR_ACCOUNT_NOT_CREATED           | The application account identifier was not created                      |
| 0x8004307B | ST_ERROR_ACCOUNT_NOT_FOUND             | The application account identifier was not found                        |
| 0x8004307C | ST_ERROR_ACCOUNT_NOT_EXPIRED           | Access to this account has not expired                                  |
| 0x8004307D | ST_ERROR_ACCOUNT_NOT_UPDATED           | The application account could not be updated                            |
| 0x8004307E | ST_ERROR_ACCOUNT_EXPIRED               | Access to this account has expired                                      |
| 0x8004307F | ST_ERROR_ACCOUNT_REVOKED               | Access to this account has been revoked                                 |
| 0x80043080 | ST_ERROR_APIKEY_NOT_CREATED            | The application key could not be created                                |
| 0x80043081 | ST_ERROR_APIKEY_NOT_FOUND              | The application key could not be found                                  |
| 0x80043082 | ST_ERROR_APIKEY_NOT_EXPIRED            | The application key has not expired                                     |
| 0x80043083 | ST_ERROR_APIKEY_NOT_UNIQUE             | The application key identifier is not unique                            |
| 0x80043084 | ST_ERROR_APIKEY_NOT_UPDATED            | They application key could not be updated                               |
| 0x80043085 | ST_ERROR_APIKEY_NOT_DELETED            | The application key could not be deleted                                |
| 0x80043086 | ST_ERROR_APIKEY_EXISTS                 | The application key already exists                                      |
| 0x80043087 | ST_ERROR_APIKEY_EXPIRED                | The application key has expired and must be refreshed                   |
| 0x80043088 | ST_ERROR_APIKEY_REVOKED                | The application key has been revoked                                    |
| 0x80043089 | ST_ERROR_APIKEY_APPID                  | The application was not found or was not specified                      |
| 0x8004308A | ST_ERROR_INVALID_TOKEN                 | The access token is invalid or was not specified                        |
| 0x8004308B | ST_ERROR_TOKEN_NOT_CREATED             | The access token could not be created                                   |
| 0x8004308C | ST_ERROR_TOKEN_NOT_FOUND               | The access token could not be found                                     |
| 0x8004308D | ST_ERROR_TOKEN_NOT_EXPIRED             | The access token has not expired                                        |
| 0x8004308E | ST_ERROR_TOKEN_NOT_UPDATED             | The access token was not updated                                        |
| 0x8004308F | ST_ERROR_TOKEN_NOT_DELETED             | The access token could not be deleted                                   |
| 0x80043090 | ST_ERROR_TOKEN_EXPIRED                 | The access token has expired and must be refreshed                      |
| 0x80043091 | ST_ERROR_TOKEN_REVOKED                 | The access token has been revoked                                       |
| 0x80043092 | ST_ERROR_NO_APIKEYS_FOUND              | No application keys found for this account                              |
| 0x80043093 | ST_ERROR_NO_TOKENS_FOUND               | No access tokens found for this application key                         |
| 0x80043094 | ST_ERROR_NO_TOKENS_REVOKED             | No access tokens have been revoked                                      |
| 0x80043095 | ST_ERROR_INVALID_STORAGE_OBJECT        | Invalid storage object identifier                                       |
| 0x80043096 | ST_ERROR_STORAGE_OBJECT_READONLY       | The storage object is read-only                                         |
| 0x80043097 | ST_ERROR_STORAGE_OBJECT_EXPIRED        | Access to the storage object has expired                                |
| 0x80043098 | ST_ERROR_STORAGE_OBJECT_SIZE           | The storage object size exceeds storage limits                          |
| 0x80043099 | ST_ERROR_STORAGE_OBJECT_DIGEST         | The storage object digest is invalid or cannot be computed              |
| 0x8004309A | ST_ERROR_STORAGE_OBJECT_EXISTS         | A storage object with this label already exists                         |
| 0x8004309B | ST_ERROR_STORAGE_OBJECT_MODIFIED       | A storage object with this label has been modified                      |
| 0x8004309C | ST_ERROR_STORAGE_OBJECT_NOT_OWNER      | The current user is not the storage object owner                        |
| 0x8004309D | ST_ERROR_STORAGE_OBJECT_NOT_FOUND      | The specified storage object does not exist                             |
| 0x8004309E | ST_ERROR_STORAGE_OBJECT_NOT_CREATED    | The storage object was not created                                      |
| 0x8004309F | ST_ERROR_STORAGE_OBJECT_NOT_MODIFIED   | The storage object was not modified                                     |
| 0x800430A0 | ST_ERROR_STORAGE_OBJECT_NOT_RENAMED    | The storage object was not renamed                                      |
| 0x800430A1 | ST_ERROR_STORAGE_FOLDER_EMPTY          | The storage folder does not contain any objects                         |
| 0x800430A2 | ST_ERROR_STORAGE_ACCOUNT_QUOTA         | The storage account has exceeded its quota                              |
| 0x800430A3 | ST_ERROR_STORAGE_ACCOUNT_LIMIT         | The storage account has exceeded its object limit                       |
| 0x800430A4 | ST_ERROR_INVALID_STORAGE_TYPE          | The specified storage type is invalid                                   |
| 0x800430A5 | ST_ERROR_INVALID_STORAGE_PROVIDER      | The specified storage provider is not available                         |
| 0x800430A6 | ST_ERROR_INVALID_STORAGE_REGION        | The specified storage region is not available                           |
| 0x800430A7 | ST_ERROR_INVALID_STORAGE_FOLDER        | The storage folder does not exist or cannot be accessed                 |
| 0x800430A8 | ST_ERROR_INVALID_STORAGE_LABEL         | The storage object label is invalid or undefined                        |
| 0x800430A9 | ST_ERROR_INVALID_QUEUE_HANDLE          | The specified queue handle is invalid or the queue has been deleted     |
| 0x800430AA | ST_ERROR_INVALID_QUEUE_FILE            | The specified file identifier is not valid for this queue               |
| 0x800430AB | ST_ERROR_QUEUE_RUNNING                 | The operation cannot be performed while the queue is running            |
| 0x800430AC | ST_ERROR_QUEUE_STOPPED                 | The operation cannot be performed when the queue has stopped            |
| 0x800430AD | ST_ERROR_QUEUE_EMPTY                   | There are no files in the specified queue                               |
| 0x800430AE | ST_ERROR_QUEUE_PAUSED                  | The operation cannot be performed while the queue is paused             |
| 0x800430AF | ST_ERROR_QUEUE_LOCKED                  | The operation cannot be performed while the queue is locked             |
| 0x800430B0 | ST_ERROR_FILE_NOT_QUEUED               | The specified file cannot be found in the queue                         |
| 0x800430B1 | ST_ERROR_END_OF_QUEUE                  | There are no more files in the specified queue                          |
| 0x800430B2 | ST_ERROR_TOO_MANY_FILES                | The maximum number of files have been queued for transfer               |
| 0x800430B3 | ST_ERROR_NO_QUEUED_TRANSFER            | No queued file transfer is currently in progress                        |
| 0x800430B4 | ST_ERROR_INVALID_X509_CERTIFICATE      | The specified X.509 format certificate is invalid                       |
| 0x800430B5 | ST_ERROR_INVALID_PKCS12_CERTIFICIATE   | The specified PKCS 12 format certificate is invalid                     |
| 0x800430B6 | ST_ERROR_INVALID_CIPHER_SUITE          | The specified cipher suite is invalid or unavailable                    |
| 0x800430B7 | ST_ERROR_DEPRECATED_CIPHER_SUITE       | The specified cipher suite is insecure and has been deprecated          |
| 0x800430B8 | ST_ERROR_INVALID_CERTIFICATE_CHAIN     | The certificate chain could not be validated                            |
| 0x800430B9 | ST_ERROR_INVALID_PRIVATE_KEY           | The private key for the certificate is invalid                          |
| 0x800430BA | ST_ERROR_INVALID_API_SESSION           | The application session identifier is invalid                           |
| 0x800430BB | ST_ERROR_EXPIRED_API_SESSION           | The application session identifier has expired                          |
| 0x800430BC | ST_ERROR_INVALID_API_TOKEN             | The application token for this session is invalid                       |
| 0x800430BD | ST_ERROR_EXPIRED_API_TOKEN             | The application token for this session has expired                      |
| 0x800430BE | ST_ERROR_INVALID_API_AUTHID            | The authorization token for this session is invalid                     |
| 0x800430BF | ST_ERROR_INVALID_API_ENDPOINT          | The endpoint for the specified request is invalid                       |
| 0x800430C0 | ST_ERROR_INVALID_API_PAYLOAD           | The data submitted with the specified request is invalid                |
| 0x800430C1 | ST_ERROR_UNKNOWN_SESSION_OWNER         | The current session owner is unknown or no longer valid                 |
| 0x800430C2 | ST_ERROR_REVOKED_SESSION_AUTH          | The authorization token for this session has been revoked               |
| 0x800430C3 | ST_ERROR_INVALID_URL_SCHEME            | The scheme for the specified URL is invalid or not supported            |
| 0x800430C4 | ST_ERROR_INVALID_URL_HOST              | The host name for the specified URL is invalid                          |
| 0x800430C5 | ST_ERROR_INVALID_URL_PORT              | The port number for the specified URL is invalid                        |
| 0x800430C6 | ST_ERROR_INVALID_URL_PATH              | The resource path for the specified URL is invalid                      |
| 0x800430C7 | ST_ERROR_INVALID_CONTENT_TYPE          | The content type is invalid or not supported                            |
| 0x800430C8 | ST_ERROR_UNKNOWN_CONTENT_TYPE          | The content type cannot be determined                                   |
| 0x800430C9 | ST_ERROR_INVALID_CHARSET               | The specified character set is invalid or not supported                 |
| 0x800430CA | ST_ERROR_INVALID_CODEPAGE              | The specified ANSI code page is invalid or not supported                |
| 0x800430CB | ST_ERROR_INVALID_HEADER_TYPE           | The specified header type is invalid or not supported                   |
| 0x800430CC | ST_ERROR_INVALID_HEADER_NAME           | The specified header name is invalid or not permitted                   |
| 0x800430CD | ST_ERROR_INVALID_HEADER_VALUE          | The specified header value is invalid or not permitted                  |
| 0x800430CE | ST_ERROR_HEADER_NOT_FOUND              | The specified header value is undefined                                 |
| 0x800430CF | ST_ERROR_INVALID_DIGEST_TYPE           | The specified message digest type is invalid                            |
| 0x800430D0 | ST_ERROR_INVALID_DIGEST_VALUE          | The specified message digest value is invalid                           |
| 0x800430D1 | ST_ERROR_FILE_DIGEST_MISMATCH          | The message digest does not match the specified file                    |
| 0x800430D2 | ST_ERROR_FILE_CONTENT_MISMATCH         | The contents of the specified files are not identical                   |
| 0x800430D3 | ST_ERROR_FILE_TIME_MISMATCH            | The timestamps for the specified files are not identical                |