# File Transfer Protocol Server

## Functions

- [FtpAddVirtualUser](#ftpaddvirtualuser-function)
- [FtpAuthenticateClient](#ftpauthenticateclient-function)
- [FtpChangeClientDirectory](#ftpchangeclientdirectory-function)
- [FtpCreateServerCredentials](#ftpcreateservercredentials-function)
- [FtpDeleteServerCredentials](#ftpdeleteservercredentials-function)
- [FtpDeleteVirtualUser](#ftpdeletevirtualuser-function)
- [FtpDisconnectClient](#ftpdisconnectclient-function)
- [FtpEnableClientAccess](#ftpenableclientaccess-function)
- [FtpEnableCommand](#ftpenablecommand-function)
- [FtpEnumServerClients](#ftpenumserverclients-function)
- [FtpGetActiveClient](#ftpgetactiveclient-function)
- [FtpGetClientAccess](#ftpgetclientaccess-function)
- [FtpGetClientAddress](#ftpgetclientaddress-function)
- [FtpGetClientCredentials](#ftpgetclientcredentials-function)
- [FtpGetClientDirectory](#ftpgetclientdirectory-function)
- [FtpGetClientFileType](#ftpgetclientfiletype-function)
- [FtpGetClientHomeDirectory](#ftpgetclienthomedirectory-function)
- [FtpGetClientIdentity](#ftpgetclientidentity-function)
- [FtpGetClientIdleTime](#ftpgetclientidletime-function)
- [FtpGetClientLocalPath](#ftpgetclientlocalpath-function)
- [FtpGetClientServer](#ftpgetclientserver-function)
- [FtpGetClientThreadId](#ftpgetclientthreadid-function)
- [FtpGetClientUserName](#ftpgetclientusername-function)
- [FtpGetClientVirtualPath](#ftpgetclientvirtualpath-function)
- [FtpGetCommandFile](#ftpgetcommandfile-function)
- [FtpGetCommandLine](#ftpgetcommandline-function)
- [FtpGetCommandName](#ftpgetcommandname-function)
- [FtpGetCommandParam](#ftpgetcommandparam-function)
- [FtpGetCommandParamCount](#ftpgetcommandparamcount-function)
- [FtpGetCommandResult](#ftpgetcommandresult-function)
- [FtpGetCommandUsage](#ftpgetcommandusage-function)
- [FtpGetProgramExitCode](#ftpgetprogramexitcode-function)
- [FtpGetProgramName](#ftpgetprogramname-function)
- [FtpGetProgramOutput](#ftpgetprogramoutput-function)
- [FtpGetProgramText](#ftpgetprogramtext-function)
- [FtpGetRenamedFile](#ftpgetrenamedfile-function)
- [FtpGetServerAddress](#ftpgetserveraddress-function)
- [FtpGetServerDirectory](#ftpgetserverdirectory-function)
- [FtpGetServerError](#ftpgetservererror-function)
- [FtpGetServerIdentity](#ftpgetserveridentity-function)
- [FtpGetServerLogFile](#ftpgetserverlogfile-function)
- [FtpGetServerMemoryUsage](#ftpgetservermemoryusage-function)
- [FtpGetServerName](#ftpgetservername-function)
- [FtpGetServerOptions](#ftpgetserveroptions-function)
- [FtpGetServerPriority](#ftpgetserverpriority-function)
- [FtpGetServerStackSize](#ftpgetserverstacksize-function)
- [FtpGetServerTransferInfo](#ftpgetservertransferinfo-function)
- [FtpGetServerUuid](#ftpgetserveruuid-function)
- [FtpGetServerUuidString](#ftpgetserveruuidstring-function)
- [FtpIsClientAnonymous](#ftpisclientanonymous-function)
- [FtpIsClientAuthenticated](#ftpisclientauthenticated-function)
- [FtpIsCommandEnabled](#ftpiscommandenabled-function)
- [FtpRegisterProgram](#ftpregisterprogram-function)
- [FtpRenameServerLogFile](#ftprenameserverlogfile-function)
- [FtpSendResponse](#ftpsendresponse-function)
- [FtpServerAsyncNotify](#ftpserverasyncnotify-function)
- [FtpServerDisableTrace](#ftpserverdisabletrace-function)
- [FtpServerEnableTrace](#ftpserverenabletrace-function)
- [FtpServerInitialize](#ftpserverinitialize-function)
- [FtpServerProc](#ftpserverproc-function)
- [FtpServerRestart](#ftpserverrestart-function)
- [FtpServerResume](#ftpserverresume-function)
- [FtpServerStart](#ftpserverstart-function)
- [FtpServerStop](#ftpserverstop-function)
- [FtpServerSuspend](#ftpserversuspend-function)
- [FtpServerThrottle](#ftpserverthrottle-function)
- [FtpServerUninitialize](#ftpserveruninitialize-function)
- [FtpSetClientAccess](#ftpsetclientaccess-function)
- [FtpSetClientFileType](#ftpsetclientfiletype-function)
- [FtpSetClientIdentity](#ftpsetclientidentity-function)
- [FtpSetClientIdleTime](#ftpsetclientidletime-function)
- [FtpSetCommandFile](#ftpsetcommandfile-function)
- [FtpSetServerAddress](#ftpsetserveraddress-function)
- [FtpSetServerError](#ftpsetservererror-function)
- [FtpSetServerIdentity](#ftpsetserveridentity-function)
- [FtpSetServerLogFile](#ftpsetserverlogfile-function)
- [FtpSetServerName](#ftpsetservername-function)
- [FtpSetServerPriority](#ftpsetserverpriority-function)
- [FtpSetServerStackSize](#ftpsetserverstacksize-function)
## Structures

- [FTPCLIENTCREDENTIALS](#ftpclientcredentials-structure)
- [FTPSERVERCONFIG](#ftpserverconfig-structure)
- [FTPSERVERTRANSFER](#ftpservertransfer-structure)
- [INITDATA](#initdata-structure)
- [SECURITYCREDENTIALS](#securitycredentials-structure)

---

## FtpAddVirtualUser Function

Add a new virtual user for the specified server

### Prototype

```c
BOOL WINAPI FtpAddVirtualUser(
    HSERVER hServer,
    UINT nHostId,
    DWORD dwUserAccess,
    LPCTSTR lpszUserName,
    LPCTSTR lpszPassword,
    LPCTSTR lpszDirectory
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nHostId` | `UINT` | An integer value which identifies the virtual host. This parameter is reserved for future use and must always have a value of zero. |
| `dwUserAccess` | `DWORD` | An integer value which specifies the access clients will be given when authenticated as this user. For a list of user access permissions, see User Access Constants. |
| `lpszUserName` | `LPCTSTR` | A pointer to a string which specifies the user name. The maximum length of a username is 63 characters and it is recommended that names be limited to alphanumeric characters. Whitespace, control characters and certain symbols such as path delimiters and wildcard characters are not permitted. If an invalid character is included in the name, the function will fail with an error indicating the username is invalid. This parameter cannot be NULL and the name must be at least three characters in length. Usernames are not case sensitive. |
| `lpszPassword` | `LPCTSTR` | A pointer to a string which specifies the user password. The maximum length of a password is 63 characters and is limited to printable characters. Whitespace and control characters are not permitted. If an invalid character is included in the password, the function will fail with an error indicating the password is invalid. This parameter cannot be NULL and must be at least one character in length. Passwords are case sensitive. |
| `lpszDirectory` | `LPCTSTR` | A pointer to a string which specifies the directory that will be the virtual user's home directory. If the server was started in multi-user mode, this directory will be relative to the user directory created by the server, otherwise it will be relative to the server root directory. If the directory does not exist, it will be created the first time that the virtual user successfully logs in to the server. If this parameter is NULL or an empty string, a default home directory will be created for the virtual user. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle is invalid or the virtual host ID does not specify a valid host, the function will return zero. If the function fails, the last error code will be updated to indicate the cause of the failure.

### Remarks

- The FtpAddVirtualUser function adds a virtual user that is associated with the specified virtual host. When a client connects with the server and provides authentication credentials, the server will check if the username has been created using this function. If a match is found, the client access rights will be updated.
- If you wish to modify the information for a user, it is not necessary to delete the username first. If this function is called with a username that already exists, that record is replaced with the values passed to this function. You cannot use this function to create a virtual user named "anonymous".
- The virtual users created by this function exist only as long as the server is active. If you wish to maintain a persistent database of users and passwords, you are responsible for its implementation based on the requirements of your specific application. For example, a simple implementation would be to store the user information in a local XML or INI file and then read that configuration file after the server has started, calling this function for each user that is listed.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpDeleteVirtualUser](#ftpdeletevirtualuser-function)

---

## FtpAuthenticateClient Function

Authenticate the client and assign access rights for the session

### Prototype

```c
BOOL WINAPI FtpAuthenticateClient(
    HSERVER hServer,
    UINT nClientId,
    DWORD dwUserAccess,
    BOOL bCreateHome,
    LPCTSTR lpszDirectory
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `dwUserAccess` | `DWORD` | An unsigned integer which specifies one or more user access rights. For a list of user access rights that can be granted to the client, see User Access Constants. |
| `bCreateHome` | `BOOL` | An integer value that specifics if the server should create the home directory for the authenticated client if it does not already exist. If this value is non-zero, the home directory will be created. If value is zero, the home directory will not be created and if it does not exist, this function will fail. |
| `lpszDirectory` | `LPCTSTR` | A pointer to a string that specifies the home directory for the user. If an absolute path is specified, it will be relative to the server root directory. If a relative path is specified, it will be a subdirectory of the home directory for the server instance. If this parameter is NULL or an empty string, a home directory will be assigned based on the server home directory and the user name. |

### Return Value

- **Type**: `BOOL`
- If the the client session could be authenticated, the return value is non-zero. If the server handle and client ID do not specify a valid client session, or the client has already been authenticated, this function will return zero.

### Remarks

- The FtpAuthenticateClient function is used to authenticate a specific client session, typically in response to an FTP_CLIENT_USERAUTH event that indicates a client has requested authentication. This function is also used internally to automatically grant the appropriate access rights to local user and anonymous client sessions.
- It is recommended that most applications specify FTP_ACCESS_DEFAULT as the dwUserAccess value for a client session, since this allows the server automatically grant the appropriate access based on the server configuration options for normal and anonymous users. If the server is going to be publicly accessible or third-party FTP clients will be used to access the server, you should always grant the FTP_ACCESS_LIST permission to clients. Many client applications will not function correctly if they are unable to obtain a list of files in the user's home directory.
- If FTP_ACCESS_RESTRICTED is specified and the server was started in multi-user mode, the client session will be effectively locked to its home directory and cannot navigate to the server root directory. By default, restricted client sessions are also limited to only downloading files and requesting directory listings. If a client session is not restricted, the client can access files outside of its home directory. Regardless of this option, a client cannot access files outside of the server root directory.
- If FTP_ACCESS_RESTRICTED or FTP_ACCESS_ANONYMOUS is specified, the client session will be authenticated in a restricted mode and the access rights for the session will persist until the client disconnects from the server. Unlike regular users, the access rights for a restricted client cannot be changed by the server at a later point. This restriction is designed to prevent the inadvertent granting of rights to an untrusted client that could compromise the security of the server.
- If the lpszDirectory parameter is NULL or an empty string and the server has been started in multi-user mode, each user is assigned their own home directory based on their username. If the server has not been started in multi-user mode, then the default home directory will be the server root directory and is shared by all users. The FtpGetClientHomeDirectory function will return the full path to the home directory for an authenticated client.
- If the FTP_ACCESS_EXECUTE permission is granted to the client session, it can execute external programs using the SITE EXEC command. Because the program is executed in the context of the server process, it is recommended that you limit access to this functionality and ensure that the programs being executed do not introduce any security risks to the operating system. This permission is never granted by default, and the SITE EXEC command will return an error if the client session is anonymous, regardless of whether this permission is granted or not.
- This function is should only be used for custom authentication schemes and is not necessary if you have used the FtpAddVirtualUser function to create virtual users.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAddVirtualUser](#ftpaddvirtualuser-function)
- [FtpChangeClientDirectory](#ftpchangeclientdirectory-function)
- [FtpGetClientCredentials](#ftpgetclientcredentials-function)
- [FtpGetClientDirectory](#ftpgetclientdirectory-function)
- [FtpGetClientHomeDirectory](#ftpgetclienthomedirectory-function)

---

## FtpChangeClientDirectory Function

Change the current working directory for the client session

### Prototype

```c
BOOL WINAPI FtpChangeClientDirectory(
    HSERVER hServer,
    UINT nClientId,
    LPCTSTR lpszDirectory
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszDirectory` | `LPCTSTR` | A pointer to a string which specifies the new current working directory for the client session. If this parameter is NULL or an empty string, the current working directory will be changed to the client home directory. If this parameter is not NULL, it must specify a directory that exists and is accessible by the server process. |

### Return Value

- **Type**: `BOOL`
- If the current working directory was changed, the return value is non-zero. If the server handle and client ID do not specify a valid client session, or the directory is invalid, this function will return zero.

### Remarks

- The FtpChangeClientDirectory function will change the current working directory for the specified client session. This function is called internally when the client sends the CWD or CDUP commands, however it may be explicitly used by the application to change the client's working directory in response to a server event.
- This function cannot be used to change the current working directory for a client to an arbitrary directory outside of the server root directory. If the lpszDirectory parameter specifies a relative path (i.e.: a path that does not begin with a drive letter or leading path delimiter) then the new working directory will be relative to the current working directory. If an absolute path is specified, the absolute path must include the complete path to either the server root directory or the user's home directory, based on the permissions granted to the client session. If a path outside of the server root directory is specified, this function will fail with an access denied error.
- Use caution when calling this function to override the directory specified by the client when it sends the CWD or CDUP commands. If your application changes the current working directory to one not specified by the client, it may cause unpredictable behavior in the client application because the actual path of the current working directory will not match the directory that was requested.
- If this function is used to change the current working directory in response to the CWD command, you should not call the FtpGetCommandParam function and pass the command parameter as an argument to this function. You must use the FtpGetCommandFile function to obtain the directory name provided by the client prior to calling this function.
- The application should never call the SetCurrentDirectory function in the Windows API to change the current directory for the process to the working directory of a client session. Because the server is multithreaded and each client session is managed in its own thread, an application using this library should avoid using relative paths.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetClientDirectory](#ftpgetclientdirectory-function)
- [FtpGetClientHomeDirectory](#ftpgetclienthomedirectory-function)
- [FtpGetCommandFile](#ftpgetcommandfile-function)

---

## FtpCreateServerCredentials Function

Create a new server security credentials structure

### Prototype

```c
BOOL WINAPI FtpCreateServerCredentials(
    DWORD dwProtocol,
    DWORD dwOptions,
    LPCTSTR lpszUserName,
    LPCTSTR lpszPassword,
    LPCTSTR lpszCertStore,
    LPCTSTR lpszCertName,
    LPVOID lpvReserved,
    LPSECURITYCREDENTIALS lppCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `dwProtocol` | `DWORD` | A bitmask of supported security protocols. This parameter is constructed by using a bitwise operator with any of the following values: |
| `dwOptions` | `DWORD` | A value which specifies one or options. This member is constructed by using a bitwise operator with any of the following values: |
| `lpszUserName` | `LPCTSTR` | A pointer to a string which specifies the certificate owner's username. A value of NULL specifies that no username is required. Currently this parameter is not used and any value specified will be ignored. |
| `lpszPassword` | `LPCTSTR` | A pointer to a string which specifies the certificate owner's password. A value of NULL specifies that no password is required. This parameter is only used if a PKCS #12 (PFX) certificate file is specified and that certificate has been secured with a password. This value will be ignored the current user or local machine certificate store is specified. |
| `lpszCertStore` | `LPCTSTR` | A pointer to a string which specifies the name of the certificate store to open. A certificate store is a collection of certificates and their private keys, typically organized by how they are used. If this value is NULL or points to an empty string, the default certificate store "MY" will be used. |
| `lpszCertName` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the certificate to use. The function will first search the certificate store for a certificate with a matching "friendly name"; this is a name for the certificate that is assigned by the user. Note that the name must match completely, but the comparison is not case sensitive. If no matching certificate is found, the function will then attempt to find a certificate that has a matching common name (also called the certificate subject). This comparison is less stringent, and the first partial match will be returned. If this second search fails, the function will return an error indicating that the certificate could not be found. |
| `lpvReserved` | `LPVOID` | Pointer reserved for future use. Set it to NULL when using this function. |
| `lppCredentials` | `LPSECURITYCREDENTIALS` | Pointer to an LPSECURITYCREDENTIALS pointer. The memory for the credentials structure will be allocated by this function and must be released by calling the FtpDeleteServerCredentials function when it is no longer needed. The pointer value must be set to NULL before the function is called. It is important to note that this is a pointer to a pointer variable, not a pointer to the SECURITYCREDENTIALS structure itself. |

### Options

- **dwProtocol** Parameter

    - `SECURITY_PROTOCOL_DEFAULT`: The default security protocol will be used when establishing a connection. This option will always request the latest version of the preferred security protocol and is the recommended value. Currently the default security protocol is TLS 1.2.
    - `SECURITY_PROTOCOL_TLS`: Either the TLS 1.2 or 1.3 protocol should be used when establishing a secure connection. The correct protocol is automatically selected, based on what version of the protocol is supported by the server. If this is the only protocol specified, SSL will be excluded from the list of supported protocols. This may be necessary for some servers which reject any attempt to use the older SSL protocol and require that only TLS be used.
    - `SECURITY_PROTOCOL_TLS10`: The TLS 1.0 protocol should be used when establishing a secure connection. This version is supported on all Windows platforms, however some servers may reject connections using version 1.0 in favor of using version 1.2. This version should only be used for backwards compatibility with older servers that have not been updated to use the current version of TLS.
    - `SECURITY_PROTOCOL_TLS11`: The TLS 1.1 protocol should be used when establishing a secure connection. This version is supported on Windows 7 and later desktop platforms, and Windows Server 2008 R2 and later server platforms. Some servers may reject connections using version 1.1 in favor of using version 1.2. This version should only be used for backwards compatibility with older servers that have not been updated to use the current version of TLS.
    - `SECURITY_PROTOCOL_TLS12`: The TLS 1.2 protocol should be used when establishing a secure connection. This version is supported on Windows 7 and later desktop platforms, and Windows Server 2008 R2 and later server platforms. This version of TLS offers the broadest compatibility with most servers.
    - `SECURITY_PROTOCOL_TLS13`: The TLS 1.3 protocol should be used when establishing a secure connection. This is the newest version of the protocol and is only supported on Windows 11, Windows Server 2022 and later versions of Windows. If this version is not supported by the operating system, TLS 1.2 will be used instead.
- **dwOptions** Parameter

    - `CREDENTIAL_STORE_CURRENT_USER`: The library will attempt to open a store for the current user using the certificate store name provided in this structure. If no options are specified, then this is the default behavior.
    - `CREDENTIAL_STORE_LOCAL_MACHINE`: The library will attempt to open a local machine store using the certificate store name provided in this structure. If this option is specified, the library will always search for a local machine store before searching for the store by that name for the current user.
    - `CREDENTIAL_STORE_FILENAME`: The certificate store name is a file that contains the certificate and private key that will be used.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetServerError.

### Remarks

- The structure that is created by this function may be used as client credentials when establishing a secure connection. This is particularly useful for programming languages other than C/C++ which may not support C structures or pointers. The pointer to the SECURITYCREDENTIALS structure can be declared as an unsigned integer variable which is passed by reference to this function, and then passed by value to the FtpServerStart function.

### Example

```cpp
// Create the server credentials that identifies the certificate
// that will be used for secure connections
LPSECURITYCREDENTIALS lpSecCred = NULL;

FtpCreateServerCredentials(SECURITY_PROTOCOL_DEFAULT,
						0,
						NULL,
						NULL,
						lpszCertStore,
						lpszCertName,
						NULL,
						&lpSecCred);

// Start the server
hServer = FtpServerStart(lpszLocalHost,
						FTP_PORT_DEFAULT,
						FTP_SERVER_LOCALUSER | FTP_SERVER_UNIXMODE | FTP_SERVER_SECURE,
						&ftpConfig,
						lpEventHandler,
						0,
						lpSecCred);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpDeleteServerCredentials](#ftpdeleteservercredentials-function)
- [FtpServerStart](#ftpserverstart-function)
- [SECURITYCREDENTIALS](#securitycredentials-function)

---

## FtpDeleteServerCredentials Function

Delete a previously created security credentials structure

### Prototype

```c
VOID WINAPI FtpDeleteServerCredentials(
    LPSECURITYCREDENTIALS lppCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lppCredentials` | `LPSECURITYCREDENTIALS` | Pointer to an LPSECURITYCREDENTIALS pointer. On exit from the function, the pointer value will be NULL. |

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- This function can be used to release the memory allocated for the credentials after the server has been started.

### Example

```cpp
if (lpSecCred != NULL)
	FtpDeleteServerCredentials(&lpSecCred);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpCreateServerCredentials](#ftpcreateservercredentials-function)
- [FtpServerStop](#ftpserverstop-function)

---

## FtpDeleteVirtualUser Function

Delete a virtual user from the specified server

### Prototype

```c
BOOL WINAPI FtpDeleteVirtualUser(
    HSERVER hServer,
    UINT nHostId,
    LPCTSTR lpszUserName
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nHostId` | `UINT` | An integer value which identifies the virtual host. This parameter is reserved for future use and must always have a value of zero. |
| `lpszUserName` | `LPCTSTR` | A pointer to a string which specifies the user that will be removed. This parameter cannot be a NULL pointer or an empty string. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle is invalid or the virtual host ID does not specify a valid host, the function will return zero. If the function fails, the last error code will be updated to indicate the cause of the failure.

### Remarks

- This function removes a virtual user that was created by a previous call to the FtpAddVirtualUser function. This function will not match partial usernames and wildcard characters cannot be used to delete multiple users. Usernames are not case sensitive. You cannot use this function to delete the "anonymous" user.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAddVirtualUser](#ftpaddvirtualuser-function)

---

## FtpDisconnectClient Function

Disconnect the specific client session, closing the control channel and aborting any file transfer

### Prototype

```c
BOOL WINAPI FtpDisconnectClient(
    HSERVER hServer,
    UINT nClientId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- The FtpDisconnectClient function will close the control channel, disconnecting the client from the server and terminating the client session thread. Resources that we allocated for the client, such as memory and open handles, will be released back to the operating system. If the client was in the process of transferring a file, the transfer will be aborted. This performs the same operation as if the client sent the QUIT command to the server.
- This function sends an internal control message that notifies the server that this session should be terminated. When the session thread is signaled that it should terminate, it will abort any active file transfers and begin to release the resources allocated for that session. To ensure that the client session terminates gracefully, there may be a brief period of time where the session thread is still active after this function has returned.
- After this function returns, the application should never use the same client ID with another function. Client IDs are unique to the session over the lifetime of the server, and are not reused.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpServerRestart](#ftpserverrestart-function)
- [FtpServerStop](#ftpserverstop-function)

---

## FtpEnableClientAccess Function

Enable or disable access rights for the specified client session

### Prototype

```c
BOOL WINAPI FtpEnableClientAccess(
    HSERVER hServer,
    UINT nClientId,
    DWORD dwUserAccess,
    BOOL bEnable
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `dwUserAccess` | `DWORD` | An unsigned integer which specifies an access right to enable or disable. For a list of user access rights that can be granted to the client, see User Access Constants. |
| `bEnable` | `BOOL` | An integer value which specifies if permission should be granted or revoked for the specified access right. If this value is non-zero, permission is granted to the client to perform the action specified by the dwUserAccess parameter. If this value is zero, that permission is revoked. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero. This function can only be used with authenticated clients. If the client session has not been authenticated, the return value will be zero.

### Remarks

- The FtpEnableClientAccess function is used to enable or disable access to specific functionality by the client. The function can only change a single access right and cannot be used to enable or disable multiple access rights in a single function call. To change multiple user access rights for the client, use the FtpSetClientAccess function.
- This function cannot be used to change the access rights for a restricted or anonymous user. Those rights are granted when the client session is authenticated and will persist until the client disconnects from the server. This restriction is designed to prevent the inadvertent granting of rights to an untrusted client that could compromise the security of the server.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpAuthenticateClient](#ftpauthenticateclient-function)
- [FtpGetClientAccess](#ftpgetclientaccess-function)
- [FtpSetClientAccess](#ftpsetclientaccess-function)

---

## FtpEnableCommand Function

Enable or disable a specific server command

### Prototype

```c
BOOL WINAPI FtpEnableCommand(
    HSERVER hServer,
    LPCTSTR lpszCommand,
    BOOL bEnable
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszCommand` | `LPCTSTR` | A pointer to a NULL terminated string that specifies the name of the command to be enabled or disabled. The command name is not case-sensitive, but the value must otherwise match the exact name. Partial matches are not recognized by this function. This parameter cannot be NULL. |
| `bEnable` | `BOOL` | An integer value which specifies if the command should be enabled or disabled. If the value is non-zero, the command is enabled. If the value is zero, the command will be disabled. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle is invalid or the command is not recognized, the function will return zero. If the function fails, the FtpGetServerError function will return more information about the last error that has occurred.

### Remarks

- The FtpEnableCommand function is used to enable or disable access to a specific command on the server. When a command is disabled, it will also disable any corresponding feature related to that command. For example, if the MDTM command is disabled and a client issues the FEAT command to request a list of supported features, the command will no longer be listed. This function is typically used to enable or disable certain commands for compatibility with older client software. The FtpIsCommandEnabled function can be used to determine if a command is enabled or not.
- The command name provided to this function must match the commands defined in RFC 959 or related protocol standards. It is important to distinguish between commands recognized by an FTP server and the commands that client programs may use. For example, the standard Windows FTP command line program provides commands such as GET and PUT to download and upload files. However, those are not the actual commands sent to a server. Instead, the corresponding server commands issued by a client application would bet RETR (retrieve) and STOR (store). Refer to File Transfer Protocol Commands for a complete list of server commands.
- Some commands cannot be disabled because they are required to perform essential server functions. For example, the USER and PASS commands are required to perform client authentication and therefore cannot be disabled. If you attempt to disable a required command, this function will return zero and the last error code will be set to ST_ERROR_COMMAND_REQUIRED. Because this function affects all clients connected to the server, it should not be used to limit access to certain commands for specific clients. Instead, either assign the client the appropriate permissions using the FtpAuthenticateClient function, or use an event handler to filter the commands.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAuthenticateClient](#ftpauthenticateclient-function)
- [FtpIsCommandEnabled](#ftpiscommandenabled-function)

---

## FtpEnumServerClients Function

Returns a list of active client sessions established with the specified server

### Prototype

```c
INT WINAPI FtpEnumServerClients(
    HSERVER hServer,
    DWORD dwReserved,
    UINT lpClients,
    INT nMaxClients
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | Handle to the server socket. |
| `dwReserved` | `DWORD` | An unsigned integer value that is reserved for future use. This parameter should always be zero. |
| `lpClients` | `UINT` | Pointer to an array of unsigned integers which will contain client IDs that uniquely identifies each client when the function returns. If this parameter is NULL, then the function will return the number of active client connections established with the server. |
| `nMaxClients` | `INT` | Maximum number of client IDs to be returned in the lpClients array. If the lpClients parameter is NULL, this parameter should have a value of zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of active client connections to the server. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetServerError.

### Remarks

- If the nMaxClients parameter is less than the number of active client connections, the function will fail and the last error code will be set to the error ST_ERROR_BUFFER_TOO_SMALL. To dynamically determine the number of active connections, call the function with the lpClients parameter with a value of NULL, and the nMaxClients parameter with a value of zero.

### Example

```cpp
INT nClients = FtpEnumServerClients(hServer, 0, NULL, 0);

if (nClients > 0)
{
	UINT *lpClients = NULL;

	// Allocate memory for an array of client IDs
	lpClients = (UINT *)LocalAlloc(LPTR, nClients * sizeof(UINT));

	if (lpClients == NULL)
	{
		// Virtual memory has been exhausted
		return;
	}

	nClients = FtpEnumServerClients(hServer, 0, lpClients, nClients);

	if (nClients == FTP_ERROR)
	{
		// Unable to obtain list of connected clients
		return;
	}

	for (INT nIndex = 0; nIndex < nClients; nIndex++)
	{
		TCHAR szUserName[FTP_MAXUSERNAME];

		if (FtpGetClientUserName(hServer, lpClients[nIndex], szUserName, FTP_MAXUSERNAME))
		{
			// Perform some action with the client user name
		}
	}

	// Free the memory allocated for the client IDs
	LocalFree((HLOCAL)lpClients);    
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpServerStart](#ftpserverstart-function)

---

## FtpGetActiveClient Function

Return the client ID for the active client session associated with the current thread

### Prototype

```c
UINT WINAPI FtpGetActiveClient(
    HSERVER hServer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is the unique ID associated with the client session for the current thread. If the server handle is invalid or there is no client session active on the current thread, the return value is zero.

### Remarks

- The FtpGetActiveClient function is used to obtain the client ID associated with the current thread. This means this function will only return a client ID if it is called within an event handler or a function called by an event handler. If this function is called by a function that is not executing within the context of an event handler it will return a value of zero.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpEnumServerClients](#ftpenumserverclients-function)
- [FtpGetClientThreadId](#ftpgetclientthreadid-function)

---

## FtpGetClientAccess Function

Return the access rights that have been granted to the client session

### Prototype

```c
BOOL WINAPI FtpGetClientAccess(
    HSERVER hServer,
    UINT nClientId,
    LPDWORD lpdwUserAccess
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpdwUserAccess` | `LPDWORD` | A pointer to an unsigned integer which specifies one or more access rights for the client session. For a list of user access rights that can be granted to the client, see User Access Constants. This parameter cannot be NULL. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero. This function can only be used with authenticated clients. If the client session has not been authenticated, the return value will be zero.

### Remarks

- The FtpGetClientAccess function is used to obtain all of the access rights that are currently granted to an authenticated client session. The FtpEnableClientAccess function can be used to enable or disable specific permissions, and the FtpSetClientAccess function can change multiple access rights at once.

### Example

```cpp
DWORD dwUserAccess = 0;

// Check if the client is a restricted user

if (FtpGetClientAccess(hServer, nClientId, &dwUserAccess))
{
	if (dwUserAccess & FTP_ACCESS_RESTRICTED)
	{
		_tprintf(_T("Client %u authenticated as a restricted user\n"), nClientId);
		return;
	}
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpAuthenticateClient](#ftpauthenticateclient-function)
- [FtpEnableClientAccess](#ftpenableclientaccess-function)
- [FtpSetClientAccess](#ftpsetclientaccess-function)

---

## FtpGetClientAddress Function

Return the IP address of the specified client session

### Prototype

```c
INT WINAPI FtpGetClientAddress(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszAddress,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszAddress` | `LPTSTR` | A pointer to a string buffer that will contain the client IP address, terminated with a null character. To accommodate both IPv4 and IPv6 addresses, this buffer should be at least 46 characters in length. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters can be copied into the string buffer, including the terminating null character. This value must be greater than zero. If the buffer size is too small, the function will fail. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If either the server handle or the client ID is invalid, or the buffer is not large enough to store the complete address, the function will return a value of zero.

### Remarks

- The format and length of IPv4 and IPv6 address strings are very different. An IPv4 address string looks like "192.168.0.20", while an IPv6 address string can look something like "fd7c:2f6a:4f4f:ba34::a32". If your application checks for the format of these address strings, it needs to be aware of the differences. You also need to make sure that you're providing enough space to display or store an address to avoid buffer overruns.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetServerAddress](#ftpgetserveraddress-function)

---

## FtpGetClientCredentials Function

Return the credentials for the specified client session

### Prototype

```c
BOOL WINAPI FtpGetClientCredentials(
    HSERVER hServer,
    UINT nClientId,
    LPFTPCLIENTCREDENTIALS lpCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpCredentials` | `LPFTPCLIENTCREDENTIALS` | A pointer to an FTPCLIENTCREDENTIALS structure that will contain information about the user when the function returns. This parameter cannot be NULL. |

### Return Value

- **Type**: `BOOL`
- If the user credentials for the client session are available, the return value is non-zero. If the server handle and client ID do not specify a valid client session, or the client has not requested authentication, this function will return zero.

### Remarks

- The FtpGetClientCredentials function is used to obtain the username and password that was provided by the client when it requested authentication. Typically this function is used in an event handler to validate the credentials provided by the client. If the credentials are considered valid, the event handler would then call the FtpAuthenticateClient function to specify that the session has been authenticated.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAuthenticateClient](#ftpauthenticateclient-function)
- [FTPCLIENTCREDENTIALS](#ftpclientcredentials-function)

---

## FtpGetClientDirectory Function

Return the current working directory for a client session

### Prototype

```c
INT WINAPI FtpGetClientDirectory(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszDirectory,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszDirectory` | `LPTSTR` | A pointer to a string buffer that will contain the current working directory for the specified client session, terminated with a null character. This buffer should be at least MAX_PATH characters in length. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. This value must be larger than zero or the function will fail. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- This function returns the full path to the current working directory for the specified client session. For example, if the server root directory is C:\ProgramData\MyServer and the current working directory for the client is /Research/Documents, this function will return C:\ProgramData\MyServer\Research\Documents as the current working directory for the client session.
- It is important to note that the current working directory for client sessions is virtual, and does not reflect the current working directory for the server process. To change the current working directory for a client, use the FtpChangeClientDirectory function.
- This function should only be used with client sessions that have been authenticated. Unauthenticated clients are not assigned a current working directory and this function will return zero, with the last error code set to ST_ERROR_AUTHENTICATION_REQUIRED.
- To convert a full path to the virtual path for a specific client session, use the FtpGetClientVirtualPath function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpChangeClientDirectory](#ftpchangeclientdirectory-function)
- [FtpGetClientHomeDirectory](#ftpgetclienthomedirectory-function)
- [FtpGetClientVirtualPath](#ftpgetclientvirtualpath-function)

---

## FtpGetClientFileType Function

Return the current file type used for transfers by the specified client

### Prototype

```c
BOOL WINAPI FtpGetClientFileType(
    HSERVER hServer,
    UINT nClientId,
    UINT lpnFileType
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpnFileType` | `UINT` | A pointer to an unsigned integer value that will contain the current file type used by the client for data transfers. This parameter cannot be NULL. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- The FtpGetClientFileType function will return the current file type that has been specified by the client sending the TYPE command to the server. The file type determines if there is any conversion performed on the data that is being exchanged between the client and server. The following file types are supported:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpSetClientFileType](#ftpsetclientfiletype-function)

---

## FtpGetClientHomeDirectory Function

Return the home directory for an authenticated client session

### Prototype

```c
INT WINAPI FtpGetClientHomeDirectory(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszDirectory,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszDirectory` | `LPTSTR` | A pointer to a string buffer that will contain the home directory for the specified client session, terminated with a null character. This buffer should be at least MAX_PATH characters in length. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. This value must be larger than zero or the function will fail. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- This function returns the full path to the home working directory assigned to the specified client session. This will be the same path to the home directory specified when the FtpAuthenticateClient function was used to authenticate the client session. If a home directory was not explicitly assigned when the client was authenticated, then this function returns the default home directory that was created for the client, or the server root directory if the FTP_SERVER_MULTIUSER option was not specified when the server was started.
- This function should only be used with client sessions that have been authenticated. Unauthenticated clients are not assigned a home directory and this function will return zero, with the last error code set to ST_ERROR_AUTHENTICATION_REQUIRED.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAuthenticateClient](#ftpauthenticateclient-function)
- [FtpChangeClientDirectory](#ftpchangeclientdirectory-function)
- [FtpGetClientDirectory](#ftpgetclientdirectory-function)
- [FtpGetClientVirtualPath](#ftpgetclientvirtualpath-function)

---

## FtpGetClientIdentity Function

Return the identity of the specified client session

### Prototype

```c
INT WINAPI FtpGetClientIdentity(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszIdentity,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszIdentity` | `LPTSTR` | A pointer to a string buffer that will contain the identity of the client when the function returns, terminated with a null character. This parameter cannot be NULL. It is recommended that this buffer be at least 32 characters in length. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters can be copied into the string buffer, including the terminating null character. This value must be greater than zero. If the buffer size is too small, the function will fail. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If the server handle is invalid, or the buffer is not large enough to store the complete path, the function will return a value of zero. If the client did not identify itself, this function will return zero.

### Remarks

- The FtpGetClientIdentity function returns the string that the client used to identify itself to the server. The client may use either the CLNT or CSID command to identify itself. Although the CLNT command is considered to be deprecated, it is supported for backwards compatibility with older clients. The identity string does not have any standard format and is used for informational purposes only and does not affect the operation of the server in any way. Not all clients identify themselves, in which case this function will return zero and the lpszIdentity string buffer will be set to an empty string.
- If the client does identify itself, it typically uses the name of the client application that was used to establish the connection. The application may choose to assign an identity to a client session for its own internal purposes using the FtpSetClientIdentity function, regardless of whether the client identifies itself.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetServerIdentity](#ftpgetserveridentity-function)
- [FtpSetClientIdentity](#ftpsetclientidentity-function)
- [FtpSetServerIdentity](#ftpsetserveridentity-function)

---

## FtpGetClientIdleTime Function

Return the idle timeout period for the specified client

### Prototype

```c
UINT WINAPI FtpGetClientIdleTime(
    HSERVER hServer,
    UINT nClientId,
    UINT lpnElapsed
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpnElapsed` | `UINT` | A pointer to an unsigned integer value that will contain the number of seconds the client session has been idle. This parameter may be NULL if this information is not required. |

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is client idle timeout period in seconds. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- The FtpGetClientIdleTime function will return the number of seconds that the client may remain idle before being automatically disconnected by the server. The idle time of a client session is based on the last time a command was issued to the server or when a file data transfer completed. The server will never disconnect a client that is in the process of uploading or downloading a file, regardless of the idle timeout period.
- The default idle timeout period for a client is 900 seconds (15 minutes), however the server can be configured to use a different value and individual clients can request the timeout period be changed by sending the IDLE command to the server. For a client to be able to change its own timeout period, it must be granted the FTP_ACCESS_IDLE permission. The minimum timeout period for a client is 60 seconds, the maximum is 7200 seconds (2 hours). An application can change the timeout period for a specific client session using the FtpSetClientIdleTime function.
- It is important to note that the idle timeout period only affects authenticated clients. Unauthenticated clients use a different internal timer that limits the amount of time they can remain connected to the server before successfully authenticating with a valid username and password. By default, the authentication timeout period is 60 seconds and is set when the server is started; it cannot be changed for an individual client session.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpSetClientIdleTime](#ftpsetclientidletime-function)

---

## FtpGetClientLocalPath Function

Return the full local path for the specified virtual path

### Prototype

```c
INT WINAPI FtpGetClientLocalPath(
    HSERVER hServer,
    UINT nClientId,
    LPCTSTR lpszVirtualPath,
    LPTSTR lpszLocalPath,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszVirtualPath` | `LPCTSTR` | A pointer to a string that specifies an virtual path on the server. This parameter cannot be NULL. |
| `lpszLocalPath` | `LPTSTR` | A pointer to a string buffer that will contain the full local path, terminated with a null-character. This buffer should be at least MAX_PATH characters to accommodate the complete path. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. This value must be greater than zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If the server handle and client ID do not specify a valid client session, the function will return zero. If the string buffer is not large enough to contain the complete path, this function will return zero and the last error code will be set to ST_ERROR_BUFFER_TOO_SMALL.

### Remarks

- The FtpGetClientLocalPath function takes a virtual path and returns the full path to the specified file or directory on the local system. The virtual path may be absolute or relative to the current working directory for the client session. This function will recognize a tilde at the beginning of the path to specify the client home directory.
- To obtain the virtual path for a local file or directory, use the FtpGetClientVirtualPath function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetClientVirtualPath](#ftpgetclientvirtualpath-function)

---

## FtpGetClientServer Function

Return the handle to the server that created the specified client session

### Prototype

```c
HSERVER WINAPI FtpGetClientServer(
    UINT nClientId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |

### Return Value

- **Type**: `HSERVER`
- If the function succeeds, the return value is the handle to the server that created the client session. If the function fails, the return value is INVALID_SERVER. To get extended error information, call the FtpGetServerError function.

### Remarks

- The FtpGetClientServer function returns the handle to the server that created the client session and is typically used within a notification message handler. If the server is in the process of shutting down, or the client session thread is terminating, this function will fail and return INVALID_SERVER indicating that the session ID is invalid.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h.`
- Library: `csftsv11.lib`

### See Also

- [FtpServerAsyncNotify](#ftpserverasyncnotify-function)

---

## FtpGetClientThreadId Function

Returns the thread ID associated with the specified client session

### Prototype

```c
DWORD WINAPI FtpGetClientThreadId(
    HSERVER hServer,
    UINT nClientId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is a thread ID. If the function fails, the return value is zero. To get extended error information, call the FtpGetServerError function.

### Remarks

- The FtpGetClientThreadId function returns a thread ID that can be used to identify the thread that is managing the client session. The thread ID can be used with other Windows API functions such as OpenThread. Exercise caution when using thread-related functions, interfering with the normal operation of the thread can have unexpected results. You should never use this function to obtain a thread handle and then call the TerminateThread function to terminate a client session. This will prevent the thread from releasing the resources that were allocated for the session and can leave the server in an unstable state. To terminate a client session, use the FtpDisconnectClient function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpEnumServerClients](#ftpenumserverclients-function)
- [FtpGetActiveClient](#ftpgetactiveclient-function)

---

## FtpGetClientUserName Function

Return the user name associated with the specified client session

### Prototype

```c
INT WINAPI FtpGetClientUserName(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszUserName,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszUserName` | `LPTSTR` | A pointer to a string buffer that will contain the user name associated with the client session. This buffer must be large enough to store the complete user name, including the terminating null character. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. This parameter must have a value larger than zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- The FtpGetClientUserName function returns the user name associated with an authenticated client session. If the client has not authenticated itself by sending the USER and PASS commands, this function will return zero.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAuthenticateClient](#ftpauthenticateclient-function)
- [FtpGetClientAccess](#ftpgetclientaccess-function)
- [FtpGetClientHomeDirectory](#ftpgetclienthomedirectory-function)

---

## FtpGetClientVirtualPath Function

Return the virtual path for a local file on the server

### Prototype

```c
INT WINAPI FtpGetClientVirtualPath(
    HSERVER hServer,
    UINT nClientId,
    LPCTSTR lpszLocalPath,
    LPTSTR lpszVirtualPath,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszLocalPath` | `LPCTSTR` | A pointer to a string that specifies an absolute path on the local system. This parameter cannot be NULL. |
| `lpszVirtualPath` | `LPTSTR` | A pointer to a string buffer that will contain the virtual path, terminated with a null-character. This buffer should be at least MAX_PATH characters to accommodate the complete path. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. This value must be greater than zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If the server handle and client ID do not specify a valid client session, the function will return zero. If the string buffer is not large enough to contain the complete path, this function will return zero and the last error code will be set to ST_ERROR_BUFFER_TOO_SMALL.

### Remarks

- A virtual path for the client is either relative to the server root directory, or the client home directory if the client was authenticated as a restricted user. These virtual paths are what the client will see as an absolute path on the server. For example, if the server was configured to use "C:\ProgramData\MyServer" as the root directory, and the lpszLocalPath parameter was specified as "C:\ProgramData\MyServer\Documents\Research", this function would return the virtual path to that directory as "/Documents/Research".
- If the client session was authenticated as a restricted user, then the virtual path is always relative to the client home directory instead of the server root directory. This is because restricted users are isolated to their own home directory and any subdirectories. For example, if restricted user "John" has a home directory of "C:\ProgramData\MyServer\Users\John" and the lpszLocalPath parameter was specified as "C:\ProgramData\MyServer\Users\John\Accounting\Projections.pdf" this function would return the virtual path as "/Accounting/Projections.pdf".
- If the lpszLocalPath parameter specifies a file or directory outside of the server root directory, this function will return zero and the last error code will be set to ST_ERROR_INVALID_FILE_NAME. This function can only be used with authenticated clients. If the nClientId parameter specifies a client session that has not been authenticated, this function will return zero and the last error code will be ST_ERROR_AUTHENTICATION_REQUIRED.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetCommandFile](#ftpgetcommandfile-function)
- [FtpGetClientLocalPath](#ftpgetclientlocalpath-function)

---

## FtpGetCommandFile Function

Return the full path to the local file name or directory specified by the client

### Prototype

```c
INT WINAPI FtpGetCommandFile(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszFileName,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszFileName` | `LPTSTR` | A pointer to a string buffer that will contain the full path to a file name or directory specified by the client when it issued a command. The string buffer will be null terminated and must be large enough to store the complete file path. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer. It is recommended that the buffer be at least MAX_PATH characters in size. If the maximum length specified is smaller than the actual length of the full path, this function will fail. |

### Return Value

- **Type**: `INT`
- An integer value which specifies the number of characters copied into the buffer, not including the terminating null character. If the function fails, the return value will be zero and the FtpGetServerError function can be used to retrieve the last error code. If the last error code is returned as a value of zero, this means that the command issued by the client accepts a file name as an argument, but the client did not specify one.

### Remarks

- The FtpGetCommandFile function is used to obtain the full path to a local file name or directory specified by the client as an argument to a standard FTP command. For example, if the client sends the RETR command to the server, this function will return the complete path to the local file that the client wants to download. This function will only work with those standard commands that perform some action on a file or directory.
- This function should always be used to obtain the file name for a command that performs a file or directory operation. The FtpGetCommandParam function will return the actual command parameter, but the file name will typically be relative to the user home directory or server root directory, and cannot be passed directly to a Windows API function. The FtpGetCommandFile function normalizes the path provided by the client and ensures that it specifies a file or directory name in the correct location.
- To change the file or directory name that is the target of the current command, use the FtpSetCommandFile function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetClientDirectory](#ftpgetclientdirectory-function)
- [FtpGetClientHomeDirectory](#ftpgetclienthomedirectory-function)
- [FtpGetCommandLine](#ftpgetcommandline-function)
- [FtpGetCommandParam](#ftpgetcommandparam-function)
- [FtpSetCommandFile](#ftpsetcommandfile-function)

---

## FtpGetCommandLine Function

Return the complete command line issued by the client

### Prototype

```c
INT WINAPI FtpGetCommandLine(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszCmdLine,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszCmdLine` | `LPTSTR` | A pointer to a string buffer that will contain the command, including all arguments. The string buffer will be null terminated and must be large enough to store the complete command line. If this parameter is NULL, the function will return the length of the command line. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer. The internal limit on the maximum length of a command is 1024 characters. If the maximum length specified is smaller than the actual length of the complete command, this function will fail. |

### Return Value

- **Type**: `INT`
- An integer value which specifies the number of characters copied into the buffer, not including the terminating null character. If the function fails, the return value will be zero and the FtpGetServerError function can be used to retrieve the last error code. If the last error code has a value of zero then no command has been issued by the client.

### Remarks

- The FtpGetCommandLine function is used to obtain the command that was issued by the client, and is commonly used inside FTP_CLIENT_COMMAND and FTP_CLIENT_RESULT event handlers to pre-process and post-process client commands, respectively. When the function returns, the string buffer provided by the caller will contain the complete command, including all command parameters. Any extraneous whitespace will be removed, however quoted parameters will be retained as-is.
- To obtain a specific parameter to a command, use the FtpGetCommandParam function. The FtpGetCommandParamCount function will return the number of command parameters that were provided by the client. If the command sent by the client is used to perform an action on a file or directory, the FtpGetCommandFile function should be called to obtain the full path to the specified file rather than using the value of the command parameter.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetCommandFile](#ftpgetcommandfile-function)
- [FtpGetCommandParam](#ftpgetcommandparam-function)

---

## FtpGetCommandName Function

Return the name of the last command issued by the client

### Prototype

```c
INT WINAPI FtpGetCommandName(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszCommand,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszCommand` | `LPTSTR` | A pointer to a string buffer that will contain the command name. The string buffer will be null terminated and must be large enough to store the complete command name. If this parameter is NULL, the function will only return the length of the current command in characters, not including the terminating null character. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. If the maximum length specified is smaller than the actual length of the parameter, this function will fail. If the lpszCommand parameter is NULL, this value should be zero. |

### Return Value

- **Type**: `INT`
- An integer value which specifies the number of characters copied into the buffer, not including the terminating null character. If the function fails, the return value will be zero and the FtpGetServerError function can be used to retrieve the last error code. If the last error code is returned as a value of zero, this means that no command has been issued by the client.

### Remarks

- The FtpGetCommandName function is used to obtain the name of the last command that was issued by the client. The command name returned by this function will always be capitalized, regardless of how it was sent by the client. This function is typically used inside FTP_CLIENT_COMMAND and FTP_CLIENT_RESULT event handlers to pre-process and post-process client commands, respectively.
- The FtpGetCommandParam function can be used to return the value of individual command parameters specified by the client. The FtpGetComandLine function can be used to obtain the complete command line issued by the client.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetCommandFile](#ftpgetcommandfile-function)
- [FtpGetCommandLine](#ftpgetcommandline-function)
- [FtpGetCommandParam](#ftpgetcommandparam-function)

---

## FtpGetCommandParam Function

Return the value of the specified parameter for the command issued by the client

### Prototype

```c
INT WINAPI FtpGetCommandParam(
    HSERVER hServer,
    UINT nClientId,
    INT nParam,
    LPTSTR lpszParam,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `nParam` | `INT` | An integer value which specifies the command parameter. A value of zero specifies the command itself, while values greater than zero specify a particular parameter. This function will fail if this value is less than zero or greater than the number of parameters available. |
| `lpszParam` | `LPTSTR` | A pointer to a string buffer that will contain the command parameter. The string buffer will be null terminated and must be large enough to store the complete parameter value. If this parameter is NULL, the function will only return the length of the specified parameter in characters, not including the terminating null character. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. The internal limit on the maximum length of a command is 1024 characters. If the maximum length specified is smaller than the actual length of the parameter, this function will fail. If the lpszParam parameter is NULL, this value should be zero. |

### Return Value

- **Type**: `INT`
- An integer value which specifies the number of characters copied into the buffer, not including the terminating null character. If the function fails, the return value will be zero and the FtpGetServerError function can be used to retrieve the last error code. If the last error code is returned as a value of zero, this means that no command has been issued by the client.

### Remarks

- The FtpGetCommandParam function is used to obtain a specific parameter for the last command that was issued by the client. If the parameter was surrounded in quotes, those quotes will be included in the value returned by this function. This function is typically used inside FTP_CLIENT_COMMAND and FTP_CLIENT_RESULT event handlers to pre-process and post-process client commands, respectively.
- The FtpGetCommandParamCount function will return the number of command parameters that were provided by the client. If the command sent by the client is used to perform an action on a file or directory, the FtpGetCommandFile function should be called to obtain the full path to the specified file rather than using the value of the command parameter. To obtain the complete command line, use the FtpGetCommandLine function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetCommandFile](#ftpgetcommandfile-function)
- [FtpGetCommandLine](#ftpgetcommandline-function)
- [FtpGetCommandName](#ftpgetcommandname-function)
- [FtpGetCommandParamCount](#ftpgetcommandparamcount-function)

---

## FtpGetCommandParamCount Function

Return the number of parameters to the current command issued by the client

### Prototype

```c
INT WINAPI FtpGetCommandParamCount(
    HSERVER hServer,
    UINT nClientId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |

### Return Value

- **Type**: `INT`
- An integer value which specifies the number of parameters that were specified in the last command issued by the client. If the command did not include any parameters, this function will return zero. If the client has not issued a command, or the client session ID is invalid, this function will return -1.

### Remarks

- The FtpGetCommandParamCount function is used to determine the number of parameters specified in the last client command, and the maximum value that may be passed as the parameter index to the FtpGetCommandParam function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpGetCommandLine](#ftpgetcommandline-function)
- [FtpGetCommandName](#ftpgetcommandname-function)
- [FtpGetCommandParam](#ftpgetcommandparam-function)

---

## FtpGetCommandResult Function

Return the result code and a description of the last command processed by the server

### Prototype

```c
INT WINAPI FtpGetCommandResult(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszResult,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszResult` | `LPTSTR` | A pointer to a string buffer that will contain the description of the result code. The string buffer will be null terminated up to the maximum number of characters specified by the caller. This parameter can be NULL if this information is not required. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer. If the lpszResult parameter is NULL, this value should be zero. |

### Return Value

- **Type**: `INT`
- An integer value which specifies the result code for the last command issued by the client. A return value of zero indicates that the command has not completed and there is no result code available.

### Remarks

- The FtpGetCommandResult function is used to determine the result of the last command that was issued by the client and is typically called in the FTP_CLIENT_RESULT event handler. This function should only be called after a command has been processed or the FtpSendResponse function has been called.
- The result code is a three-digit integer value that indicates the success or failure of a command. Whenever a client sends a command to the server, the server must respond with this numeric code, and optionally a text message that further describes the result. The text message may be a single line, or it may span multiple lines, with each line of text terminated by a carriage return and linefeed. Result codes are generally broken down into the following categories:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpSendResponse](#ftpsendresponse-function)

---

## FtpGetCommandUsage Function

Return the number of times a specific command has been issued by all clients

### Prototype

```c
UINT WINAPI FtpGetCommandUsage(
    HSERVER hServer,
    LPCTSTR lpszCommand
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszCommand` | `LPCTSTR` | A pointer to a string that specifies a command name. The name is not case-sensitive, but must match a valid server command exactly. This parameter cannot be NULL. |

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is the number of times the command has been issued by all clients since the server was started. If the server handle or command name is invalid, or the command has never been issued, the return value will be zero.

### Remarks

- The command name provided to this function must match the commands defined in RFC 959 or related protocol standards. It is important to distinguish between commands recognized by an FTP server and the commands that client programs may use. For example, the standard Windows FTP command line program provides commands such as GET and PUT to download and upload files. However, those are not the actual commands sent to a server. Instead, the corresponding server commands issued by a client application would bet RETR (retrieve) and STOR (store). Refer to File Transfer Protocol Commands for a complete list of server commands.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpEnableCommand](#ftpenablecommand-function)
- [FtpGetCommandLine](#ftpgetcommandline-function)
- [FtpGetCommandResult](#ftpgetcommandresult-function)

---

## FtpGetProgramExitCode Function

Return the exit code of the last program executed by the client

### Prototype

```c
BOOL WINAPI FtpGetProgramExitCode(
    HSERVER hServer,
    UINT nClientId,
    LPDWORD lpdwExitCode
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpdwExitCode` | `LPDWORD` | A pointer to an unsigned integer that will contain the program exit code when the function returns. This parameter cannot be NULL. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- The FtpGetProgramExitCode function returns the exit code of a registered program that was executed by the client using the SITE EXEC command. By convention, most programs return an exit code in the range of 0-255, with an exit code of zero indicating success. The exit code is commonly used by custom programs to communicate status information back to the server application.
- Permission to use the SITE EXEC is not granted to authenticated users by default, and is limited to only those programs which are explicitly registered with the server. Exercise caution when allowing a client to execute a program on the server because this can expose the server to significant security risks. The programs that are registered for use with the SITE EXEC command should be thoroughly tested before being deployed on the server and should only be console programs that write to standard output.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpGetProgramName](#ftpgetprogramname-function)
- [FtpGetProgramOutput](#ftpgetprogramoutput-function)
- [FtpRegisterProgram](#ftpregisterprogram-function)

---

## FtpGetProgramName Function

Return the name of the last program executed by the client

### Prototype

```c
INT WINAPI FtpGetProgramName(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszProgramName,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszProgramName` | `LPTSTR` | A pointer to a string buffer that will contain the name of the last program executed by the client. This parameter cannot be NULL and should be at least 32 characters in size. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. This parameter must have a value greater than zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the command name. If the server handle and client ID do not specify a valid client session, the function will return zero. If the client has not executed any programs, this function will return zero.

### Remarks

- The FtpGetProgramName function returns the name of the last program that was executed by the client using the SITE EXEC command. The name that is returned is the alias assigned to the program, not the full path to the executable file. The server application would typically use this function in an event handler when processing the FTP_CLIENT_EXECUTE event to determine which program has been executed on behalf of the client. The FtpGetProgramExitCode function will return the program's exit code and the FtpGetProgramOutput function can be used to obtain a copy of the output generated by the program.
- Permission to use the SITE EXEC is not granted to authenticated users by default, and is limited to only those programs which are explicitly registered with the server. Exercise caution when allowing a client to execute a program on the server because this can expose the server to significant security risks. The programs that are registered for use with the SITE EXEC command should be thoroughly tested before being deployed on the server and should only be console programs that write to standard output.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetProgramExitCode](#ftpgetprogramexitcode-function)
- [FtpGetProgramOutput](#ftpgetprogramoutput-function)
- [FtpRegisterProgram](#ftpregisterprogram-function)

---

## FtpGetProgramOutput Function

Return a copy of the standard output from the last program executed by the client

### Prototype

```c
DWORD WINAPI FtpGetProgramOutput(
    HSERVER hServer,
    UINT nClientId,
    LPBYTE lpBuffer,
    DWORD dwBufferSize
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpBuffer` | `LPBYTE` | A pointer to a buffer that will contain the output from the last program executed by the client. If this parameter is NULL, the function will return the number of bytes of data that was output by the program. Note that this output is not null terminated. |
| `dwBufferSize` | `DWORD` | The maximum number of bytes that can be copied into the buffer. If the lpBuffer parameter is NULL, this value should be zero. |

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is the number of bytes copied into the specified buffer. If the server handle and client ID do not specify a valid client session, the function will return zero. If the client has not executed any programs, the return value will be zero.

### Remarks

- The FtpGetProgramOutput function is used to obtain a copy of the output generated by the program executed using the SITE EXEC command. To determine the number of bytes of output available to read, call this function with the lpBuffer parameter as NULL and the dwBufferSize parameter with a value of zero. The return value will be the number of bytes of data that was output by the program. It should be noted that for Unicode builds, the buffer is a byte array, not an array of characters, and will not be null terminated.
- This function returns the raw output from the command which may contain escape sequences, control characters and embedded nulls. When the application processes the output returned by this function, it should never coerce the buffer pointer to an LPTSTR value because there is no guarantee that the data will be null-terminated. To obtain the output from the command as a string, use the FtpGetProgramText function.

### Example

```cpp
LPBYTE lpBuffer = NULL;  // A pointer to the output buffer
DWORD cbBuffer = 0;      // Number of bytes in the output buffer

// Determine the number of bytes in the output buffer
cbBuffer = FtpGetProgramOutput(hServer, nClientId, NULL, 0);

if (cbBuffer > 0)
{
	// Allocate memory for the buffer
	lpBuffer = (LPBYTE)LocalAlloc(LPTR, cbBuffer + 1);

	// Copy the program output to the buffer
	if (lpBuffer != NULL)
		cbBuffer = FtpGetProgramOutput(hServer, nClientId, lpBuffer, cbBuffer + 1);
}

// Free the memory allocated for the buffer when finished
if (lpBuffer != NULL)
{
	LocalFree((HLOCAL)lpBuffer);
	lpBuffer = NULL;
	cbBuffer = 0;
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpGetProgramExitCode](#ftpgetprogramexitcode-function)
- [FtpGetProgramName](#ftpgetprogramname-function)
- [FtpGetProgramText](#ftpgetprogramtext-function)
- [FtpRegisterProgram](#ftpregisterprogram-function)

---

## FtpGetProgramText Function

Return a copy of the standard output from the last program in a string buffer

### Prototype

```c
INT WINAPI FtpGetProgramText(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszBuffer,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszBuffer` | `LPTSTR` | A pointer to a buffer that will contain the output from the last program executed by the client as a string. If this parameter is NULL, the function will return the number of bytes of characters that was output by the program, not including a terminating null character. |
| `nMaxLength` | `INT` | The maximum number of bytes that can be copied into the buffer. If the lpszBuffer parameter is NULL, this value should be zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the specified string buffer, not including the terminating null character. If the server handle and client ID do not specify a valid client session, the function will return zero. If the client has not executed any programs, the return value will be zero.

### Remarks

- The FtpGetProgramText function is used to obtain a copy of the output generated by the program executed using the SITE EXEC command. To determine the number of characters of output available to read, call this function with the lpszBuffer parameter as NULL and the nMaxLength parameter with a value of zero. The return value will be the number of characters that were output by the program. If the application dynamically allocates the string buffer, make sure that it allocates an extra character for the terminating null character.
- This function will only return textual output from the command and any non-printable control characters and the escape character will be replaced with a space. To obtain the unfiltered output from the last command that was executed, use the FtpGetProgramOutput function.

### Example

```cpp
LPTSTR lpszBuffer = NULL;  // A pointer to the output buffer
INT cchBuffer = 0;         // Number of bytes in the output buffer

// Determine the number of bytes in the output buffer
cchBuffer = FtpGetProgramText(hServer, nClientId, NULL, 0);

if (cchBuffer > 0)
{
	// Allocate memory for the string buffer
	lpszBuffer = (LPTSTR)LocalAlloc(LPTR, (cchBuffer + 1) * sizeof(TCHAR));

	// Copy the program output to the buffer
	if (lpszBuffer != NULL)
		cchBuffer = FtpGetProgramText(hServer, nClientId, lpszBuffer, cchBuffer + 1);
}

// Free the memory allocated for the buffer when finished
if (lpszBuffer != NULL)
{
	LocalFree((HLOCAL)lpszBuffer);
	lpszBuffer = NULL;
	cchBuffer = 0;
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetProgramExitCode](#ftpgetprogramexitcode-function)
- [FtpGetProgramName](#ftpgetprogramname-function)
- [FtpGetProgramOutput](#ftpgetprogramoutput-function)
- [FtpRegisterProgram](#ftpregisterprogram-function)

---

## FtpGetRenamedFile Function

Return the original name of a file being renamed by the client

### Prototype

```c
INT WINAPI FtpGetRenamedFile(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszFileName,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszFileName` | `LPTSTR` | A pointer to a string buffer that will contain the full path of the last file or directory that was renamed. It is recommended that this buffer be at least MAX_PATH characters in size. The value of this parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null characters. This parameter must have a value larger than zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the file or directory path, not including the terminating null character. If the server handle and client ID do not specify a valid client session, the function will return zero. If the client has not renamed a file or directory, this function will return zero.

### Remarks

- When a client wishes to rename a file or directory, it must send two commands in sequence to the server. The first command is RNFR (rename from) which specifies the original name of the file or directory to be renamed. The second command is RNTO (rename to) and must be sent immediately after the RNFR command and specifies the new name for the file or directory. The FtpGetRenamedFile function will return the full path of the local file or directory that was specified by the RNFR command. Typically this function is used by an event handler that processes the FTP_CLIENT_COMMAND event to determine the original path name.
- This function is only guaranteed to return a meaningful value when called within the context of the FTP_CLIENT_COMMAND event. Calling this function outside of the event handler will return the path of the last renamed file, but there is no way to determine at what point the client issued the command to rename a file or directory. To obtain the new file or directory name, the FtpGetCommandFile function should be called from within the event handler.
- The RNFR and RNTO commands can also be used to move a file or directory to a new location. For example, they could be used to move a file from one directory to another. An application should never make the assumption that the paths of the original and new file will be the same.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetCommandFile](#ftpgetcommandfile-function)

---

## FtpGetServerAddress Function

Return the IP address for the server

### Prototype

```c
INT WINAPI FtpGetServerAddress(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszAddress,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. This value may be zero. |
| `lpszAddress` | `LPTSTR` | A pointer to a string buffer that will contain the server IP address, terminated with a null character. To accommodate both IPv4 and IPv6 addresses, this buffer should be at least 46 characters in length. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters can be copied into the string buffer, including the terminating null character. This value must be greater than zero. If the buffer size is too small, the function will fail. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If either the server handle or the client ID is invalid, or the buffer is not large enough to store the complete address, the function will return a value of zero.

### Remarks

- This function will return the IP address assigned to the specified server as a printable string. If the nClientId parameter has a value of zero, this function will return the IP address assigned to the local system. If the FTP_SERVER_NATROUTER option was specified when the server was started, this function will return the external IP address assigned to the system. If the nClientId parameter specifies a valid client session, this function will return the IP address that the client used to establish the connection with the server. To determine the IP address assigned to the client, use the FtpGetClientAddress function.
- The format and length of IPv4 and IPv6 address strings are very different. An IPv4 address string looks like "192.168.0.20", while an IPv6 address string can look something like "fd7c:2f6a:4f4f:ba34::a32". If your application checks for the format of these address strings, it needs to be aware of the differences. You also need to make sure that you're providing enough space to display or store an address to avoid buffer overruns.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetClientAddress](#ftpgetclientaddress-function)
- [FtpGetServerName](#ftpgetservername-function)
- [FtpSetServerAddress](#ftpsetserveraddress-function)

---

## FtpGetServerDirectory Function

Return the full path to the root directory assigned to the specified server

### Prototype

```c
INT WINAPI FtpGetServerDirectory(
    HSERVER hServer,
    LPTSTR lpszDirectory,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszDirectory` | `LPTSTR` | A pointer to a string buffer that will contain the server root directory, terminated with a null character. It is recommended that this buffer be at least MAX_PATH characters in length. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters can be copied into the string buffer, including the terminating null character. This value must be greater than zero. If the buffer size is too small, the function will fail. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If the server handle is invalid, or the buffer is not large enough to store the complete path, the function will return a value of zero.

### Remarks

- The FtpGetServerDirectory function will return the full path to the root directory assigned to the server instance. The root directory may be specified as part of the server configuration, or if no directory is specified by the application, a temporary root directory will be created and this function can be used to obtain the full path to the directory. When the application specifies a root directory, it may use environment variables such as %AppData% in the path. This function will return the fully resolved path name, with all environment variables expanded.
- There is no corresponding function to change the server root directory after the server has started. To change the root directory, you must stop the server using the FtpServerStop function and then start another instance of the server with a configuration that specifies the new directory.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetServerAddress](#ftpgetserveraddress-function)
- [FtpGetServerIdentity](#ftpgetserveridentity-function)
- [FtpGetServerName](#ftpgetservername-function)

---

## FtpGetServerError Function

Return information about the last server error that occurred

### Prototype

```c
DWORD WINAPI FtpGetServerError(
    HSERVER hServer,
    LPTSTR lpszError,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszError` | `LPTSTR` | A pointer to a string buffer that will contain a description of the error. If the error description is not needed, this parameter may be NULL. |
| `nMaxLength` | `INT` | An integer that specifies the maximum number of characters that can be copied into the error string buffer, including the terminating null character. If the lpszError parameter is NULL, this value should be zero. |

### Return Value

- **Type**: `DWORD`
- An unsigned integer value that specifies the last error that occurred. A value of zero indicates that there was no error.

### Remarks

- Error codes are unsigned 32-bit values which are private to each server. You should call the FtpGetServerError function immediately when a function's return value indicates that an error has occurred. That is because some functions clear the last error code when they succeed.
- If the hServer parameter is specified with a value of INVALID_SERVER, this function will return the last error that occurred for the current thread. This value should only be used when the function does not have access to a valid server handle, such as when the FtpServerStart function fails.
- It is important to note that the error codes returned by this function are different than the command result codes that are defined in RFC 959, the standard protocol specification for FTP. This function is used to determine reason that an API function has failed, and should not be used to determine if a command issued by the client was successful. The FtpSendResponse function is used to send result codes to the client, and the FtpGetCommandResult function can be used to determine the result of the last command sent by the client.
- Most functions will set the last error code value when they fail; a few functions set it when they succeed. Function failure is typically indicated by a return value such as FALSE, NULL, INVALID_SERVER or FTP_ERROR. Those functions which clear the last error code when they succeed are noted on the function reference page.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetCommandResult](#ftpgetcommandresult-function)
- [FtpSendResponse](#ftpsendresponse-function)

---

## FtpGetServerIdentity Function

Return the identity and version information for the specified server

### Prototype

```c
INT WINAPI FtpGetServerIdentity(
    HSERVER hServer,
    LPTSTR lpszIdentity,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszIdentity` | `LPTSTR` | A pointer to a string buffer that will contain the identity of the server when the function returns, terminated with a null character. This parameter cannot be NULL. It is recommended that this buffer be at least 32 characters in length. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters can be copied into the string buffer, including the terminating null character. This value must be greater than zero. If the buffer size is too small, the function will fail. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If the server handle is invalid, or the buffer is not large enough to store the complete path, the function will return a value of zero.

### Remarks

- The FtpGetServerIdentity function returns the identity string that was specified as part of the server configuration. It is used for informational purposes only and does not affect the operation of the server. Typically the string specifies the name of the application and a version number, and is displayed whenever a client establishes its initial connection to the server. The FtpSetServerIdentity function can be used to change the identity string associated with the server.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetClientIdentity](#ftpgetclientidentity-function)
- [FtpSetClientIdentity](#ftpsetclientidentity-function)
- [FtpSetServerIdentity](#ftpsetserveridentity-function)

---

## FtpGetServerLogFile Function

Return the current log file format and full path for the file

### Prototype

```c
BOOL WINAPI FtpGetServerLogFile(
    HSERVER hServer,
    UINT lpnLogFormat,
    UINT lpnLogLevel,
    LPTSTR lpszFileName,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpnLogFormat` | `UINT` | A pointer to an integer value that will contain the log file format being used when the function returns. If this information is not needed, this parameter may be NULL. The following formats are supported: |
| `lpnLogLevel` | `UINT` | A pointer to an integer value that will contain the level of detail the server uses when generating the log file. The minimum value is 1 and the maximum value is 10. If this information is not needed, this parameter may be NULL. |
| `lpszFileName` | `LPTSTR` | A pointer to a string buffer that will contain the full path to the log file. This parameter may be NULL if this information is not required. |
| `nMaxLength` | `INT` | An integer that specifies the maximum number of characters that can be copied into the file name string, including the terminating null character. If the lpszFileName parameter is NULL, this value should be zero. |

### Options

- **lpnLogFormat** Parameter

    - `FTP_LOGFILE_NONE`: This value specifies that the server should not create or update a log file.
    - `FTP_LOGFILE_COMMON`: This value specifies that the log file should use the common log format that records a subset of information in a fixed format. This log format usually only provides information about file transfers.
    - `FTP_LOGFILE_EXTENDED`: This value specifies that the log file should use the standard W3C extended log file format. This is an extensible format that can provide additional information about the client session.

### Return Value

- **Type**: `BOOL`
- An integer value which specifies the current log file format. Refer to the FTPSERVERCONFIG structure definition for a list of supported log file formats. If the server handle is invalid or logging has not been enabled, this function will return a value of zero.

### Remarks

- If the server is configured with logging enabled, but a log file name is not explicitly provided, then the server will automatically generate one. This function can be used to get the full path to the current log file along with the format that is being used to record client session data. Normally the log file is held open by the server thread while it is active, however you can call the FtpRenameServerLogFile function to explicitly rename or delete the log file.
- To change the name of the log file, the log file format or level of detail, use the FtpSetServerLogFile function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpRenameServerLogFile](#ftprenameserverlogfile-function)
- [FtpSetServerLogFile](#ftpsetserverlogfile-function)

---

## FtpGetServerMemoryUsage Function

Return the amount of memory allocated for the server and all client sessions

### Prototype

```c
BOOL WINAPI FtpGetServerMemoryUsage(
    HSERVER hServer,
    ULARGE_INTEGER lpMemUsage
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpMemUsage` | `ULARGE_INTEGER` | A pointer to a ULARGE_INTEGER variable which will specify how much memory has been allocated by the server. This parameter will be initialized to a value of zero by the function and updated with the total number of bytes allocated by the server and all active client sessions when it returns. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero and the memory usage value will be updated. If the server handle is invalid, or the server cannot be locked, the return value is zero. Call the FtpGetServerError function to determine the cause of the failure.

### Remarks

- This function returns the amount of memory allocated by the server and all active client sessions. It enumerates all of memory allocations made by the server process and client session threads and returns the total number of bytes allocated for the server process. This value reflects the amount of memory explicitly allocated by this library and does not reflect the total working set size of the process, or memory allocated by any other libraries. To determine the working set size for the process, refer to the Win32 GetProcessWorkingSetSize and GetProcessMemoryInfo functions.
- This function forces the server into a locked state, and all client sessions will block until the function returns. Because this function enumerates all heaps allocated for the server process, it can be an expensive operation, particularly when there are a large number of active clients connected to the server. Frequent use of this function can significantly degrade the performance of the server. It is primarily intended for use as a debugging tool to determine if memory usage is the result of an increase in active client sessions. If the value returned by the function remains reasonably constant, but the amount of memory allocated for the process continues to grow, it could indicate a memory leak in some other area of the application.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpGetServerStackSize](#ftpgetserverstacksize-function)
- [FtpSetServerStackSize](#ftpsetserverstacksize-function)

---

## FtpGetServerName Function

Return the host name assigned to the server or specified client session

### Prototype

```c
INT WINAPI FtpGetServerName(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszHostName,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. This value may be zero. |
| `lpszHostName` | `LPTSTR` | A pointer to a string buffer that will contain the server host name, terminated with a null character. It is recommended that this buffer be at least 64 characters in length. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters can be copied into the string buffer, including the terminating null character. This value must be greater than zero. If the buffer size is too small, the function will fail. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If either the server handle or the client ID is invalid, or the buffer is not large enough to store the complete hostname, the function will return a value of zero.

### Remarks

- This function will return the host name assigned to the specified server. If the nClientId parameter has a value of zero, the function will return the default host name that was specified as part of the server configuration. If no host name was explicitly assigned to the server, then it will return the local system name. If the nClientId parameter specifies a client session, then it this function will return the host name that the client used to establish the connection. If the client sends the HOST command to the server, this function will return the host name provided by the client.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetServerAddress](#ftpgetserveraddress-function)

---

## FtpGetServerOptions Function

Return the configuration options for the specified server

### Prototype

```c
BOOL WINAPI FtpGetServerOptions(
    HSERVER hServer,
    LPDWORD lpdwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpdwOptions` | `LPDWORD` | A pointer to an unsigned integer that will contain the options that were specified when the server was started. This parameter cannot be NULL. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle is invalid, the function will return a value of zero.

### Remarks

- This function will return the options that were specified when the server was started. For a list of server options see Server Option Constants.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpServerStart](#ftpserverstart-function)

---

## FtpGetServerPriority Function

Return the current priority assigned to the specified server

### Prototype

```c
INT WINAPI FtpGetServerPriority(
    HSERVER hServer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the priority for the specified server. If the function fails, the return value is FTP_PRIORITY_INVALID. To get extended error information, call FtpGetServerError.

### Remarks

- The FtpGetServerPriority function can be used to determine the current priority assigned to the server. It will return one of the following values:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h.`
- Library: `csftsv11.lib`

### See Also

- [FtpServerStart](#ftpserverstart-function)
- [FtpSetServerPriority](#ftpsetserverpriority-function)

---

## FtpGetServerStackSize Function

Return the initial size of the stack allocated for threads created by the server

### Prototype

```c
DWORD WINAPI FtpGetServerStackSize(
    SOCKET hServer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `SOCKET` | The server handle. |

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is the amount of memory that will be allocated for the stack in bytes. If the function fails, the return value is zero. To get extended error information, call FtpGetServerError.

### Remarks

- The FtpGetServerStackSize function returns the initial amount of memory that is committed to the stack for each thread created by the server. By default, the stack size for each thread is set to 256K for 32-bit processes and 512K for 64-bit processes.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h.`
- Library: `csftsv11.lib`

### See Also

- [FtpGetServerMemoryUsage](#ftpgetservermemoryusage-function)
- [FtpServerStart](#ftpserverstart-function)
- [FtpSetServerStackSize](#ftpsetserverstacksize-function)

---

## FtpGetServerTransferInfo Function

Return information about the current file transfer for the client session

### Prototype

```c
BOOL WINAPI FtpGetServerTransferInfo(
    HSERVER hServer,
    UINT nClientId,
    LPFTPSERVERTRANSFER lpTransferInfo
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpTransferInfo` | `LPFTPSERVERTRANSFER` | A pointer to an FTPSERVERTRANSFER structure that will contain information about the last file transfer. This parameter cannot be NULL, and the dwSize member of the structure must be initialized to specify the structure size prior to calling this function. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero. This function should only be called after the client has issued the APPE, RETR, STOR or STOU commands to initiate a file transfer, otherwise the return value will be zero.

### Remarks

- The FtpGetServerTransferInfo function is used to obtain information about the last file transfer that was performed by the server for the specified client. This function is typically called within an event handler to determine how many bytes of data were transferred, the type of file and the full path to the file on the local system.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetCommandResult](#ftpgetcommandresult-function)
- [FTPSERVERTRANSFER](#ftpservertransfer-function)

---

## FtpGetServerUuid Function

Return the UUID assigned to the specified server

### Prototype

```c
INT WINAPI FtpGetServerUuid(
    HSERVER hServer,
    UUID lpUuid
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpUuid` | `UUID` | A pointer to a UUID structure that will contain the server UUID when the function returns. This parameter cannot be NULL. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is non-zero. If either the server handle is invalid or the pointer to the UUID structure is NULL, the function will return a value of zero.

### Remarks

- The FtpGetServerUuid function returns the Universally Unique Identifier (UUID) that has been assigned to the server. The UUID may either be generated by the application and assigned as part of the server configuration, or an ephemeral UUID may be automatically generated when the server is started. To obtain a printable string version of the UUID, use the FtpGetServerUuidString function.
- There is no corresponding function to change the UUID assigned to an active server. The server UUID is assigned when the server is started, and it must be a unique value that is maintained throughout the lifetime of the server. To change the UUID associated with the server, the server must be stopped using the FtpServerStop function and another instance of the server started with the new UUID.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpGetServerUuidString](#ftpgetserveruuidstring-function)
- [FTPSERVERCONFIG](#ftpserverconfig-function)

---

## FtpGetServerUuidString Function

Return the UUID assigned to the server as a printable string

### Prototype

```c
INT WINAPI FtpGetServerUuidString(
    HSERVER hServer,
    LPTSTR lpszHostUuid,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszHostUuid` | `LPTSTR` | A pointer to a string buffer that will contain the server UUID, terminated with a null character. It is recommended that this buffer be at least 40 characters in length. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters can be copied into the string buffer, including the terminating null character. This value must be greater than zero. If the buffer size is too small, the function will fail. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If either the server handle or the buffer is not large enough to store the complete UUID string, the function will return a value of zero.

### Remarks

- The FtpGetServerUuidString function returns the Universally Unique Identifier (UUID) that has been assigned to the server. The UUID may either be generated by the application and assigned as part of the server configuration, or an ephemeral UUID may be automatically generated when the server is started. To obtain the numeric UUID value, use the FtpGetServerUuid function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetServerUuid](#ftpgetserveruuid-function)
- [FTPSERVERCONFIG](#ftpserverconfig-function)

---

## FtpIsClientAnonymous Function

Determine if the specified client has authenticated as an anonymous user

### Prototype

```c
BOOL WINAPI FtpIsClientAnonymous(
    HSERVER hServer,
    UINT nClientId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |

### Return Value

- **Type**: `BOOL`
- If the client session has been authenticated, this function will return a non-zero value, otherwise it will return zero. If the server handle and client ID are valid, and the client session has been authenticated, this function will clear the last error code.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpAuthenticateClient](#ftpauthenticateclient-function)
- [FtpGetClientCredentials](#ftpgetclientcredentials-function)
- [FtpIsClientAuthenticated](#ftpisclientauthenticated-function)

---

## FtpIsClientAuthenticated Function

Determine if the specified client session has been authenticated

### Prototype

```c
BOOL WINAPI FtpIsClientAuthenticated(
    HSERVER hServer,
    UINT nClientId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |

### Return Value

- **Type**: `BOOL`
- If the client session has been authenticated, this function will return a non-zero value, otherwise it will return zero. If the server handle and client ID are valid, this function will clear the last error code.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpAuthenticateClient](#ftpauthenticateclient-function)
- [FtpGetClientCredentials](#ftpgetclientcredentials-function)
- [FtpIsClientAnonymous](#ftpisclientanonymous-function)

---

## FtpIsCommandEnabled Function

Determine if the specified command is currently enabled or disabled

### Prototype

```c
BOOL WINAPI FtpIsCommandEnabled(
    HSERVER hServer,
    LPCTSTR lpszCommand
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszCommand` | `LPCTSTR` | A pointer to a NULL terminated string that specifies the name of the command. The command name is not case-sensitive, but the value must otherwise match the exact command name. Partial matches are not recognized by this function. This parameter cannot be NULL. |

### Return Value

- **Type**: `BOOL`
- If the command is enabled, this function will return a non-zero value. If the command is disabled, the server handle is invalid or the command name does not match a supported command, this function will return zero.

### Remarks

- The FtpIsCommandEnabled function is used to determine whether a specific command is enabled. Typically this function is used in an event handler to make sure the command issued by a client is recognized by the server and enabled for use. Commands can be enabled and disabled using the FtpEnableCommand function.
- This function does not account for the permissions granted to a specific client session. Clients are assigned access rights when they are authenticated using the FtpAuthenticateClient function, and certain commands can be limited by the permissions granted to the client. For example, even though the STOR command is enabled, a client must have the FTP_ACCESS_WRITE permission to use the command to upload a file to the server. For a list of access rights, see User Access Constants.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAuthenticateClient](#ftpauthenticateclient-function)
- [FtpEnableCommand](#ftpenablecommand-function)
- [FtpGetCommandName](#ftpgetcommandname-function)

---

## FtpRegisterProgram Function

Register a program for use with the SITE EXEC command

### Prototype

```c
BOOL WINAPI FtpRegisterProgram(
    HSERVER hServer,
    UINT nHostId,
    LPCTSTR lpszCommandName,
    LPCTSTR lpszProgramFile,
    LPCTSTR lpszParameters,
    LPCTSTR lpszDirectory
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nHostId` | `UINT` | An unsigned integer that identifies the virtual host associated with the program. This value should always be zero. |
| `lpszCommandName` | `LPCTSTR` | A pointer to a string which specifies the name of the site specific command. This is the name that is passed to the SITE EXEC command and does not need to match the actual name of the executable file on the local system. The maximum length of the command name is 32 characters. This parameter cannot be NULL. |
| `lpszProgramFile` | `LPCTSTR` | A pointer to a string that specifies the full path to the executable program. This parameter cannot be NULL. |
| `lpszParameters` | `LPCTSTR` | A pointer to a string that specifies additional parameters for the program. If the program does not require any command line parameters, this value may be NULL or point to an empty string. |
| `lpszDirectory` | `LPCTSTR` | A pointer to a string that specifies the current working directory for the program. If this parameter is NULL or points to an empty string, the server will use the current working directory of the client that issues the SITE EXEC command. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- The FtpRegisterProgram function registers an executable program for use with the SITE EXEC command. Because this can present a significant security risk to the server, clients are not given permission to use this command by default. A client must be explicitly granted permission to use SITE EXEC by including FTP_ACCESS_EXECUTE as one of the permissions when authenticating the client session with the FtpAuthenticateClient function or creating a virtual user using the FtpAddVirtualUser function.
- To give the server complete control over what programs can be executed using SITE EXEC, the program must be registered with the server and referenced by an alias specified by the lpszCommandName parameter. The maximum length of a program name is 31 characters and it must be at least 3 characters in length. The name must only consist of alphanumeric characters and the first character of the program name cannot be numeric. The program name is not case-sensitive, however convention is to use upper-case characters. If a program name is specified that already has been registered, it will be updated with the new information provided by this function.
- The lpszProgramFile string specifies file name of the program that will be executed. You should not install any executable programs in the server root directory or its subdirectories. A client should never have the ability to directly access the executable file itself. It is permitted to have multiple command names that reference the same executable file. The only requirement is that the command names be unique. The program name may contain environment variables surrounded by % symbols. For example, %ProgramFiles% would be expanded to the C:\Program Files folder.
- It is important to note that the program specified by lpszProgramFile must be an executable file, not a script or batch file. If the program name does not contain a directory path, then the standard Windows pathing rules will be used when searching for an executable file that matches the given name. It is recommended that you always provide a full path to the executable file.
- The lpszParameters string is used to define optional command line parameters that will be included with the command. This string can contain placeholders that are replaced by additional parameters specified by the client when it sends the SITE EXEC command. First replacement parameter is %1, the second is %2 and so on.
- The executable program that is registered using this function must be a console application that writes to standard output. Programs that write directly to a console, or programs written to use a Windows user interface are not supported and will yield unpredictable results. In most cases, those programs that do not use standard input and output will be forcibly terminated by the server. If the program attempts to read from standard input, it will immediately encounter an end-of-file condition. Programs executed by the SITE EXEC command have no input; it is similar to a program that has its input redirected from the NUL: device. If the program must process a file on the server, the local file name should be passed as a command line parameter.
- The output from the program will be redirected back to the client control channel. The output should be textual, with each line of text terminated by a carriage return and linefeed (CRLF). Programs that write binary data to standard output, particular data with embedded nulls, will yield unpredictable results and are not supported. To ensure that the program output conforms to the protocol standard, any non-printable characters will be replaced with a space and each line of output will be prefixed by a single space. The server application can obtain a copy of the output from the last command by calling the FtpGetProgramOutput function.
- If the server is running on a system with User Account Control (UAC) enabled and does not have elevated privileges, do not register a program that requires elevated privileges or has a manifest that specifies the requestedExecutionLevel as requiring administrative privileges.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetProgramExitCode](#ftpgetprogramexitcode-function)
- [FtpGetProgramName](#ftpgetprogramname-function)
- [FtpGetProgramOutput](#ftpgetprogramoutput-function)

---

## FtpRenameServerLogFile Function

Rename or delete the current log file being updated by the server

### Prototype

```c
BOOL WINAPI FtpRenameServerLogFile(
    HSERVER hServer,
    LPCTSTR lpszFileName
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszFileName` | `LPCTSTR` | A pointer to a string that specifies the file name the current log file should be renamed to. If this parameter is NULL or an empty string, the current log file will be deleted. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle does not specify a valid server, the function will return zero. If logging is not currently enabled for the server, this function will return zero.

### Remarks

- The FtpRenameServerLogFile function is used to rename or delete the current log file. Note that this does not change the current log file name or disable logging by the server. It only changes the file name of the current log file, or removes the log file if the lpszFileName parameter is NULL. This can be useful if you want your server to perform log file rotation, archiving the current log file. By renaming the current log file, the server will automatically create a new log file with original file name.
- This function must be used to rename or delete the current log file while logging is active because the server holds an open handle on the file. The application should not use the FtpGetServerLogFile function to obtain the log file name and then use the MoveFileEx or DeleteFile functions with that file.
- To disable logging, use the FtpSetServerLogFile function and specify the logging format as FTP_LOGFILE_NONE.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetServerLogFile](#ftpgetserverlogfile-function)
- [FtpSetServerLogFile](#ftpsetserverlogfile-function)

---

## FtpSendResponse Function

Send a result code and optional message to the client in response to a command

### Prototype

```c
BOOL WINAPI FtpSendResponse(
    HSERVER hServer,
    UINT nClientId,
    UINT nResultCode,
    LPCTSTR lpszMessage
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `nResultCode` | `UINT` | An unsigned integer value which specifies the result code. |
| `lpszMessage` | `LPCTSTR` | A pointer to a string which specifies a message to be sent to the client. If this parameter is NULL or points to an empty string, a default message associated with the result code will be used. |

### Return Value

- **Type**: `BOOL`
- If the result code and message text was sent to the client, the return value is non-zero. If the server handle and client ID do not specify a valid client session, or the result code is invalid, this function will return zero.

### Remarks

- The FtpSendResponse function is used to respond to a command issued by the client. Command responses are normally handled by the server as a normal part of processing a command and this function is only used if the application has implemented custom commands or wishes to modify the standard responses sent by the server. The message may be a maximum of 2048 characters and may include embedded carriage-return and linefeed characters. If no message is specified, then a default message will be sent based on the result code.
- Result codes must be three digits (in the range of 100 through 999) and although this function will support the use of non-standard result codes, it is recommended that the client application use the standard codes defined in RFC 959 whenever possible. The use of non-standard result codes may cause problems with FTP clients that expect specific result codes in response to a particular command. For more information, refer to the FtpGetCommandResult function.
- This function should only be called once in response to a command sent by the client. If a result code has already been sent in response to a command and this function is called, it will fail and return a value of zero. This is necessary because sending multiple result codes in response to a single command may cause unpredictable behavior by the client.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetCommandResult](#ftpgetcommandresult-function)

---

## FtpServerAsyncNotify Function

Enable or disable asynchronous notification of changes in server status

### Prototype

```c
BOOL WINAPI FtpServerAsyncNotify(
    HSERVER hServer,
    HWND hWnd,
    UINT uMsg
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `hWnd` | `HWND` | A handle to the window whose window procedure will receive the notification message. |
| `uMsg` | `UINT` | The user-defined message that will be sent to the notification window. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call the FtpGetServerError function.

### Remarks

- The FtpServerAsyncNotify function is used by an application to enable or disable asynchronous notifications. The message window is typically the main UI window and these notifications are used signal to the application that it should update the user interface. If the hWnd parameter is not NULL, it must specify a valid window handle and the user-defined message must have a value of WM_USER or higher. The application cannot specify a notification message that is reserved by the operating system. The pseudo-handle HWND_BROADCAST cannot be specified as the notification window. If the hWnd parameter is NULL, notifications for the specified server will be disabled.
- When asynchronous notifications are enabled for a server, the server will post the user-defined message to the window whenever there is a change in status or after a client has connected or disconnected from the server. The wParam message parameter will contain the notification message and the lParam message parameter will contain the handle to the server or the client ID. The following notification messages are defined:
- If asynchronous notifications are enabled, you should never use those notifications as a replacement for an event handler. When an event occurs, the callback function that handles the event is invoked in the context of the thread that manages the client session. The application should exchange data with the client within that event handler and not in response to a notification message. These notification messages should only be used to update the application UI in response to changes in the status of the server.
- The FTP_NOTIFY_CONNECT and FTP_NOTIFY_DISCONNECT notifications are different from the other server notifications because the lParam message parameter does not specify the server handle, but rather the unique client ID associated with the session that connected to or disconnected from the server. Use the FtpGetClientServer function to obtain a handle to the server that created the client session. Note that at the time the application processes the FTP_NOTIFY_DISCONNECT notification message, the client session will have already terminated.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h.`
- Library: `csftsv11.lib`

### See Also

- [FtpGetClientServer](#ftpgetclientserver-function)
- [FtpServerStart](#ftpserverstart-function)

---

## FtpServerDisableTrace Function

Disable logging of network function calls

### Prototype

```c
BOOL WINAPI FtpServerDisableTrace();
```

### Parameters

| Name | Type | Description |
|------|------|-------------|

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetServerError.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpServerEnableTrace](#ftpserverenabletrace-function)

---

## FtpServerEnableTrace Function

Enable logging of network function calls to a file

### Prototype

```c
BOOL WINAPI FtpServerEnableTrace(
    LPCTSTR lpszTraceFile,
    DWORD dwTraceFlags
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszTraceFile` | `LPCTSTR` | A pointer to a string that specifies the name of the log file. If this parameter is NULL or points to an empty string, a log file is created in the temporary directory for the current user. |
| `dwTraceFlags` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |

### Options

- **dwTraceFlags** Parameter

    - `TRACE_DEFAULT`: All function calls are written to the trace file. This is the default value.
    - `TRACE_ERROR`: Only those function calls which fail are recorded in the trace file.
    - `TRACE_WARNING`: Only those function calls which fail, or return values which indicate a warning, are recorded in the trace file.
    - `TRACE_HEXDUMP`: All functions calls are written to the trace file, plus all the data that is sent or received is displayed, in both ASCII and hexadecimal format.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetServerError.

### Remarks

- When trace logging is enabled, the log file is opened, appended to and closed for each socket function call. Using the same file name, you can do the same in your application to add additional information to the file if needed. This can provide an application-level context for the entries made by the library. Make sure that the file is closed after the data has been written. If a file name is not specified by the caller, a file named cstrace.log will be created in the temporary directory for the current user.
- The TRACE_HEXDUMP option can produce very large files, since all data that is being sent and received by the application is logged. To reduce the size of the file, you can enable and disable logging around limited sections of code that you wish to analyze.
- To redistribute an application that includes this debug logging functionality, the cstrcv11.dll library must be included as part of the installation package. This library provides the trace logging features, and if it is not available the FtpServerEnableTrace function will fail. Note that this is a standard Windows DLL and does not need to be registered, it only needs to be redistributed with your application.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpServerDisableTrace](#ftpserverdisabletrace-function)

---

## FtpServerInitialize Function

Initialize the library and validate the specified license key at runtime

### Prototype

```c
BOOL WINAPI FtpServerInitialize(
    LPCTSTR lpszLicenseKey,
    LPINITDATA lpData
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszLicenseKey` | `LPCTSTR` | Pointer to a string that specifies the runtime license key to be validated. If this parameter is NULL, the library will validate the development license installed on the local system. |
| `lpData` | `LPINITDATA` | Pointer to an INITDATA data structure. This parameter may be NULL if the initialization data for the library is not required. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetServerError. All other functions will fail until a license key has been successfully validated.

### Remarks

- This must be the first function that an application calls before using any of the other functions in the library. When a NULL license key is specified, the library will only function on the development system. Before redistributing the application to an end-user, you must insure that this function is called with a valid license key.
- If the lpData argument is specified, it must point to an INITDATA structure which has been initialized by setting the dwSize member to the size of the structure. All other structure members should be set to zero. If the function is successful, then the INITDATA structure will be filled with identifying information about the library.
- Although it is only required that FtpServerInitialize be called once for the current process, it may be called multiple times; however, each call must be matched by a corresponding call to FtpServerUninitialize.
- This function dynamically loads other system libraries and allocates thread local storage. If you are calling the functions in this library from within another DLL, it is important that you do not call the FtpServerInitialize or FtpServerUninitialize functions from the DllMain function because it can result in deadlocks or access violation errors. If the DLL is linked with the C runtime library (CRT), it will automatically call the constructors and destructors for static and global C++ objects and has the same restrictions.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpServerStart](#ftpserverstart-function)
- [FtpServerStop](#ftpserverstop-function)
- [FtpServerUninitialize](#ftpserveruninitialize-function)
- [INITDATA](#initdata-function)

---

## FtpServerProc Function

Callback function used to process server events

### Prototype

```c
VOID __cdecl FtpServerProc(
    HSERVER hServer,
    UINT nClientId,
    UINT nEventId,
    DWORD dwError,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client that has issued a request to the server. |
| `nEventId` | `UINT` | An unsigned integer which specifies which event occurred. For a list of events, see Server Event Constants. |
| `dwError` | `DWORD` | An unsigned integer which specifies any error that occurred. If no error occurred, then this parameter will be zero. The FtpGetServerError function can be used to obtain additional information about the error code. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value which was specified when the server was started. This value is guaranteed to be large enough to store a pointer or handle value on both 32-bit and 64-bit platforms. |

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- The FTP_CLIENT_COMMAND event can be used to filter commands issued by the client. If the command performs an operation on a file or directory, the FtpGetCommandFile function can be used to obtain the file name on the server that the client specified. It is possible for the application to change the file name using the FtpSetCommandFile function to direct the server to use a different file than the one specified by the client. If the file name is changed and the event handler returns a value of zero, the server will perform the default action for the command using the new file name.
- The FTP_CLIENT_TIMEOUT event will only occur for authenticated client sessions. The server has a second, internal timer that is maintained for unauthenticated sessions that requires the client to successfully authenticate itself within a fixed period of time. If a client does not authenticate within the allowed time period, the server will automatically close the control channel. For more information, refer to the documentation for the nAuthTime member of the FTPSERVERCONFIG structure.
- The callback function will be called in the context of the thread that is currently managing the client session. You must ensure that any access to global or static variables are synchronized, otherwise the results may be unpredictable. It is recommended that you do not declare any static variables within the callback function itself.
- If the application has a graphical user interface, you should never attempt to directly modify a UI control from within an event handler. Controls should only be modified by the same UI thread that created their window. To change the user interface in response to a server event, use the FtpServerAsyncNotify function to enable asynchronous notifications and update the UI in response to the notification message.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpServerAsyncNotify](#ftpserverasyncnotify-function)
- [FtpServerStart](#ftpserverstart-function)

---

## FtpServerRestart Function

Restart the server, terminating all active client sessions

### Prototype

```c
HSERVER WINAPI FtpServerRestart(
    HSERVER hServer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |

### Return Value

- **Type**: `HSERVER`
- If the function succeeds, the return value is the new handle for the specified server. If the function fails, the return value is INVALID_SERVER. To get extended error information, call FtpGetServerError.

### Remarks

- The FtpServerRestart function will restart the specified server, terminating all active client sessions. The server handle that is returned by the function is the handle for the new server instance, and the old handle value is no longer valid. If the function is unable to restart the server for any reason, the server thread is terminated. The server retains all of the configuration parameters from the previous instance, however the statistical information (such as the number of clients, files transferred, etc.) will be reset.
- If an application calls this function from within an event handler, the active client session (the client for which the event handler was invoked) may not get a disconnect notification. It is recommended that this function only be called by the same thread that created the server using the FtpServerStart function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpServerStart](#ftpserverstart-function)
- [FtpServerStop](#ftpserverstop-function)

---

## FtpServerResume Function

Resume accepting client connections on the specified server

### Prototype

```c
BOOL WINAPI FtpServerResume(
    HSERVER hServer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | Handle to the server. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetServerError.

### Remarks

- The FtpServerResume function instructs the server to resume accepting new client connections after the FtpServerSuspend function has been called.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpServerRestart](#ftpserverrestart-function)
- [FtpServerStart](#ftpserverstart-function)
- [FtpServerStop](#ftpserverstop-function)
- [FtpServerSuspend](#ftpserversuspend-function)
- [FtpServerThrottle](#ftpserverthrottle-function)

---

## FtpServerStart Function

Start the server and begin accepting client connections

### Prototype

```c
HSERVER WINAPI FtpServerStart(
    LPCTSTR lpszLocalHost,
    UINT nLocalPort,
    DWORD dwOptions,
    LPFTPSERVERCONFIG lpServerConfig,
    FTPSERVPROC lpServerProc,
    DWORD_PTR dwServerParam,
    LPSECURITYCREDENTIALS lpCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszLocalHost` | `LPCTSTR` | A pointer to a string which specifies the local hostname or IP address address that the server should be bound to. If this parameter is NULL or an empty string, then an appropriate address will automatically be used. If a specific address is used, the server will only accept client connections on the network interface that is bound to that address. |
| `nLocalPort` | `UINT` | The port number the server should use to listen for client connections. If a value of zero is specified, the server will use the standard port number 21 to listen for connections, or port 990 if the server is configured to use implicit TLS. The port number used by the application must be unique and multiple instances of a server cannot use the same port number. It is recommended that a port number greater than 5000 be used for private, application-specific implementations. |
| `dwOptions` | `DWORD` | An unsigned integer value that specifies the options used when creating an instance of the server. For a list of options, see Server Option Constants. |
| `lpServerConfig` | `LPFTPSERVERCONFIG` | A pointer to an FTPSERVERCONFIG structure that specifies the configuration options for the server. If this parameter is NULL, then default configuration parameters will be used that starts the server in a restrictive mode. |
| `lpServerProc` | `FTPSERVPROC` | Specifies the address of the application defined callback function. For more information about the callback function, see the description of the FtpServerProc callback function. If this parameter is NULL, a default internal handler is used to process client commands. |
| `dwServerParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. If the lpServerProc parameter is NULL, this value should be zero. This value is guaranteed to be large enough to store a pointer or handle value on both 32-bit and 64-bit platforms. |
| `lpCredentials` | `LPSECURITYCREDENTIALS` | Pointer to a SECURITYCREDENTIALS structure. If this parameter is NULL, the default security credentials for the server host name will be used. If security is enabled for the server, it is recommended that you provide a pointer to this structure with specific information about the server certificate that should be used. If the security options are not specified in the server configuration, this parameter is ignored. |

### Return Value

- **Type**: `HSERVER`
- If the function succeeds, the return value is a handle to a server session. If the function fails, the return value is INVALID_SERVER. To get extended error information, call FtpGetServerError.

### Remarks

- In most cases, the lpszLocalHost parameter should be a NULL pointer or an empty string. On a multihomed system, this will enable the server to accept connections on any appropriately configured network adapter. Specifying a hostname or IP address will limit client connections to that particular address. Note that the hostname or address must be one that is assigned to the local system, otherwise an error will occur.
- If an IPv6 address is specified as the local address, the system must have an IPv6 stack installed and configured, otherwise the function will fail.
- To listen for connections on any suitable IPv4 interface, specify the special dotted-quad address "0.0.0.0". You can accept connections from clients using either IPv4 or IPv6 on the same socket by specifying the special IPv6 address "::0", however this is only supported on Windows 7 and Windows Server 2008 R2 or later platforms. If no local address is specified, then the server will only listen for connections from clients using IPv4. This behavior is by design for backwards compatibility with systems that do not have an IPv6 TCP/IP stack installed.
- The handle returned by this function references the listening socket that was created when the server was started. The service is managed in another thread, and all interaction with the server and active client connections are performed inside the event handler. To disconnect all active connections, close the listening socket and terminate the server thread, call the FtpServerStop function.
- The host UUID that is defined as part of the server configuration should be generated using the uuidgen utility that is included with the Windows SDK. You should not use the UUID that is provided in the example code, it is for demonstration purposes only. If no host UUID is specified in the server configuration, an ephemeral UUID will be generated automatically when the server is started.
- If the server is started with security enabled, the lpCredentials parameter should be used to provide the server certificate information in a SECURITYCREDENTIALS structure. If the pointer is NULL, this function will search for a certificate that matches the hostname provided as part of the server configuration. This requires that the server certificate be installed in the personal certificate store of the current process user, and it must have a private key associated with it. To use a certificate with a different name, or one that is stored in a PFX file, a SECURITYCREDENTIALS structure must be defined and passed to this function.

### Example

```cpp
HSERVER hServer;
FTPSERVERCONFIG ftpConfig;

// Initialize the server configuration
ZeroMemory(&ftpConfig, sizeof(FTPSERVERCONFIG));
ftpConfig.dwSize = sizeof(ftpConfig);
ftpConfig.nMaxClients = 20;
ftpConfig.nMaxGuests = 5;
ftpConfig.nLogFormat = FTP_LOGFILE_EXTENDED;
ftpConfig.nAuthTime = 30;
ftpConfig.nIdleTime = 120;
ftpConfig.lpszIdentity = _T("MyProgram");
ftpConfig.lpszHostName = _T("server.company.com");
ftpConfig.lpszHostUuid = _T("10000000-1000-1000-1000-100000000000");
ftpConfig.lpszDirectory = _T("%ProgramData%\\MyProgram\\Files");
ftpConfig.lpszLogFile = _T("%ProgramData%\\MyProgram\\Server.log");

// Start the server
hServer = FtpServerStart(lpszLocalHost,
						FTP_PORT_DEFAULT,
						FTP_SERVER_LOCALUSER | FTP_SERVER_UNIXMODE,
						&ftpConfig,
						lpEventHandler,
						0,
						NULL);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpEnumServerClients](#ftpenumserverclients-function)
- [FtpServerProc](#ftpserverproc-function)
- [FtpServerRestart](#ftpserverrestart-function)
- [FtpServerStop](#ftpserverstop-function)
- [FTPSERVERCONFIG](#ftpserverconfig-function)
- [SECURITYCREDENTIALS](#securitycredentials-function)

---

## FtpServerStop Function

Stop the server and terminate all active client connections

### Prototype

```c
BOOL WINAPI FtpServerStop(
    HSERVER hServer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle is invalid, the function will return a value of zero.

### Remarks

- The FtpServerStop function instructs the server to stop accepting client connections, disconnects all active client connections and terminates the thread that is managing the server session. The handle is no longer valid after the server has been stopped and should no longer be used. Note that it is possible that the actual handle value may be re-used at a later point when a new server is started. An application should always consider the server handle to be opaque and never depend on it being a specific value.
- If an application calls this function from within an event handler, the active client session (the client for which the event handler was invoked) may not get a disconnect notification. It is recommended that this function only be called by the same thread that created the server using the FtpServerStart function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpServerRestart](#ftpserverrestart-function)
- [FtpServerStart](#ftpserverstart-function)

---

## FtpServerSuspend Function

Suspend accepting client connections on the specified server

### Prototype

```c
BOOL WINAPI FtpServerSuspend(
    HSERVER hServer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | Handle to the server. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetServerError.

### Remarks

- The FtpServerSuspend function instructs the server to suspend accepting new client connections. Any incoming client connections will be rejected with an error message indicating that the server is currently unavailable. To resume accepting client connections, call the FtpServerResume function. Suspending the server will have no effect on clients that have already established a connection with the server.
- It is recommended that you only suspend a server if absolutely necessary, and only for brief periods of time. If you want to limit the number of active client connections or control the connection rate for clients, use the FtpServerThrottle function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpServerRestart](#ftpserverrestart-function)
- [FtpServerResume](#ftpserverresume-function)
- [FtpServerStart](#ftpserverstart-function)
- [FtpServerStop](#ftpserverstop-function)
- [FtpServerThrottle](#ftpserverthrottle-function)

---

## FtpServerThrottle Function

Limit the number of active client connections, connections per address and connection rate

### Prototype

```c
BOOL WINAPI FtpServerThrottle(
    HSERVER hServer,
    UINT nMaxClients,
    UINT nMaxClientsPerAddress,
    UINT nMaxGuests,
    DWORD dwConnectionRate
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | Handle to the server. |
| `nMaxClients` | `UINT` | An integer value which specifies the maximum number of clients that may connect to the server. A value of zero specifies that there is no fixed limit to the number of client connections. A value of -1 specifies that the maximum number of clients should not be changed. |
| `nMaxClientsPerAddress` | `UINT` | An integer value which specifies the maximum number of clients that may connect to the server from the same IP address. A value of zero specifies that there is no fixed limit to the number of client connections per address. By default, there is a limit of four client connections per address. A value of -1 specifies that the maximum number of clients should not be changed. |
| `nMaxGuests` | `UINT` | An integer value which specifies the maximum number of guest users that may login to the server. A value of zero disables guest logins and requires that all clients authenticate with a valid username and password. A value of -1 specifies that the maximum number of guest users should not be changed. |
| `dwConnectionRate` | `DWORD` | A value which specifies a restriction on the rate of client connections, limiting the number of connections that will be accepted within that period of time. A value of zero specifies that there is no restriction on the rate of client connections. The higher this value, the fewer the number of connections that will be accepted within a specific period of time. By default, there is no limit on the client connection rate. A value of -1 specifies that the connection rate should not be changed. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetServerError.

### Remarks

- The FtpServerThrottle function is used to limit the number of connections and the connection rate to minimize the potential impact of a large number of client connections over a short period of time. This can be used to protect the server from a client application that is malfunctioning or a deliberate denial-of-service attack in which the attacker attempts to flood the server with connection attempts.
- If the maximum number of client connections or maximum number of connections per address is exceeded, the server will reject subsequent connection attempts until the number of active client sessions drops below the specified threshold. Note that adjusting these values lower than the current connection limits will not affect clients that have already connected to the server. For example, if the FtpServerStart function is called with the maximum number of clients set to 100, and then FtpServerThrottle is called lowering that value to 75, no existing client connections will be affected by the change. However, the server will not accept any new connections until the number of active clients drops below 75.
- Increasing the connection rate value will force the server to slow down the rate at which it will accept incoming client connection requests. For example, setting this parameter to a value of 1000 would limit the server to accepting one client connection every second, while a value of 250 would allow the server to accept four client connections per second. Note that significantly increasing the amount of time the server must wait to accept client connections can exceed the connection backlog queue, resulting in client connections being rejected.
- It is recommended that you always specify conservative connection limits for your server application based on expected usage. Allowing an unlimited number of client connections can potentially expose the system to denial-of-service attacks and should never be done for servers that are accessible over the Internet.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpServerRestart](#ftpserverrestart-function)
- [FtpServerResume](#ftpserverresume-function)
- [FtpServerStart](#ftpserverstart-function)
- [FtpServerSuspend](#ftpserversuspend-function)

---

## FtpServerUninitialize Function

Terminate use of the library by the application

### Prototype

```c
VOID WINAPI FtpServerUninitialize();
```

### Parameters

| Name | Type | Description |
|------|------|-------------|

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- An application is required to perform a successful FtpServerInitialize call before it can call any of the other library functions. When it has completed the use of library, the application must call FtpServerUninitialize to allow the library to free any resources allocated on behalf of the process. Any pending blocking or asynchronous calls in this process are canceled without posting any notification messages, and all sockets that were opened by the process are closed.
- There must be a call to FtpServerUninitialize for every successful call to FtpServerInitialize made by a process. Operations for all threads in the server are terminated.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpServerInitialize](#ftpserverinitialize-function)
- [FtpServerStart](#ftpserverstart-function)
- [FtpServerStop](#ftpserverstop-function)

---

## FtpSetClientAccess Function

Change the access rights associated with the specified client session

### Prototype

```c
BOOL WINAPI FtpSetClientAccess(
    HSERVER hServer,
    UINT nClientId,
    DWORD dwUserAccess
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `dwUserAccess` | `DWORD` | An unsigned integer which specifies one or more user access rights. For a list of user access rights that can be granted to the client, see User Access Constants. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero. This function can only be used with authenticated clients. If the client session has not been authenticated, the return value will be zero.

### Remarks

- The FtpSetClientAccess function can change the access rights for an authenticated client session. This function can only be used after the FtpAuthenticateClient function has been used to grant the initial set of access rights to the client. The FtpEnableClientAccess function can be used to grant or revoke a specific permission for the client session.
- The dwUserAccess parameter has a value of FTP_ACCESS_DEFAULT, then default permissions will be granted to the client session. A normal client cannot be changed to a restricted or anonymous client using this function. If the FTP_ACCESS_RESTRICTED or FTP_ACCESS_ANONYMOUS access flags are specified, this function will fail.
- This function cannot be used to change the access rights for a restricted or anonymous user. Those rights are granted when the client session is authenticated and will persist until the client disconnects from the server. This restriction is designed to prevent the inadvertent granting of rights to an untrusted client that could compromise the security of the server.

### Example

```cpp
DWORD dwUserAccess = 0;

// Allow the client to execute programs using SITE EXEC
if (FtpGetClientAccess(hServer, nClientId, &dwUserAccess))
{
	if (! (dwUserAccess & FTP_ACCESS_ANONYMOUS))
		FtpSetClientAccess(hServer, nClientId, dwUserAccess | FTP_ACCESS_EXECUTE);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpAuthenticateClient](#ftpauthenticateclient-function)
- [FtpEnableClientAccess](#ftpenableclientaccess-function)
- [FtpGetClientAccess](#ftpgetclientaccess-function)

---

## FtpSetClientFileType Function

Change the current file type used for transfers by the specified client

### Prototype

```c
BOOL WINAPI FtpSetClientFileType(
    HSERVER hServer,
    UINT nClientId,
    UINT nFileType
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `nFileType` | `UINT` | Specifies the type of file that will be uploaded or downloaded. This parameter determines whether subsequent file transfers require any data conversion and may be one of the following values. |

### Options

- **nFileType** Parameter

    - `FILE_TYPE_ASCII`: The file is a text file using the ASCII character set. For those clients which use a different end-of-line character sequence, the text file has been converted to the local format which uses the carriage return (CR) and linefeed (LF) characters.
    - `FILE_TYPE_IMAGE`: The file is a binary file and no data conversion of any type has been performed on the file. This is the default file type for most data files and executable programs. If the client specified this file type when appending to a text file, the file will contain the end-of-line sequences used by its native operating system.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- The FtpSetClientFileType function will change the default file type that is used for subsequent transfers by the client. If the file type is set to FILE_TYPE_ASCII then the server will automatically convert any end-of-line character sequences to match the format used by the local system. For example, if the client is connecting from a UNIX based system, the server will convert a single linefeed character to a carriage return (CR) and linefeed (LF) sequence. If the file type is set to FILE_TYPE_IMAGE, then no conversion is performed.
- This function can be used to override the file type specified by filtering the TYPE command issued by the client. For example, it could be used to force file transfers to use a specific type based on the file extension, regardless of the type specified by the client. To determine the current file type set by the client, use the FtpGetClientFileType function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpGetClientFileType](#ftpgetclientfiletype-function)

---

## FtpSetClientIdentity Function

Change the identity string associated with the specified client session

### Prototype

```c
BOOL WINAPI FtpSetClientIdentity(
    HSERVER hServer,
    UINT nClientId,
    LPCTSTR lpszIdentity
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszIdentity` | `LPCTSTR` | A pointer to a string that identifies the client. If this parameter is NULL or specifies an empty string, the current identity for the client is cleared. The maximum length of the identity string is 64 characters, including the terminating null character. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle or client ID is invalid, the function will return a value of zero.

### Remarks

- The FtpSetClientIdentity function associates a string value with the client that can be used to identify the session. The identity string does not have any standard format and is used for informational purposes only. Typically it is used to identify the client application that was used to establish the connection. Changing the client identity has no effect on the operation of the server. To obtain the identity string currently associated with the client, use the FtpGetClientIdentity function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetClientIdentity](#ftpgetclientidentity-function)
- [FtpGetServerIdentity](#ftpgetserveridentity-function)
- [FtpSetServerIdentity](#ftpsetserveridentity-function)

---

## FtpSetClientIdleTime Function

Change the idle timeout period for the specified client session

### Prototype

```c
UINT WINAPI FtpSetClientIdleTime(
    HSERVER hServer,
    UINT nClientId,
    UINT nTimeout
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `nTimeout` | `UINT` | An unsigned integer value that specifies the number of seconds that the client may remain idle. If this value is zero, the default idle timeout period for the server will be used. |

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is the previous client idle timeout period in seconds. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- The FtpSetClientIdleTime function is will change the number of seconds that the client may remain idle before being automatically disconnected by the server. The minimum timeout period for a client is 60 seconds, the maximum is 7200 seconds (2 hours). The idle time of a client session is based on the last time a command was issued to the server or when a data transfer completed.
- If the value INFINITE is specified as the timeout period, the client activity timer will be refreshed, extending the idle timeout period for the session. This is typically done inside an event handler to prevent the client from being disconnected due to inactivity.
- To obtain the current idle timeout period for a client, along with the amount of time the client has been idle, use the FtpGetClientIdleTime function.
- This timeout period only affects authenticated clients. Unauthenticated clients use a different internal timer that limits the amount of time they can remain connected to the server and that value cannot be changed for individual client sessions.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpGetClientIdleTime](#ftpgetclientidletime-function)

---

## FtpSetCommandFile Function

Change the name of the local file or directory that is the target of the current command

### Prototype

```c
BOOL WINAPI FtpSetCommandFile(
    HSERVER hServer,
    UINT nClientId,
    LPCTSTR lpszFileName
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszFileName` | `LPCTSTR` | A pointer to a string that specifies the new file name. This parameter may be NULL to specify that the original file or directory name should be used. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- The FtpSetCommandFile function is used by the application to change the target file or directory name for the current command from within an FTP_EVENT_COMMAND event handler. This can be used to effectively redirect the client to use a different file than the one that was actually requested. For example, if the client issues the RETR command to download a file from the server, this function can be used to redirect the command to use a different file name. To obtain the full path to the file or directory that is the target of the current command, use the FtpGetCommandFile function.
- The lpszFileName parameter specifies the path to the new file or directory name. If the path is absolute, then it will be used as-is . If the path is relative, it will be relative to the current working directory for the client session. The full path to this file is not limited to the server root directory or its subdirectory, it can specify a file anywhere on the local system. If this parameter is a NULL pointer, or points to an empty string, then the server will revert to using the actual file or directory name specified by the command. This enables the application to effectively undo a previous call to this function to change the target file name.
- Typically this function would be used to redirect a client to a file or directory that it may not normally have access to. Exercise caution when using this function to provide access to data that is stored outside of the server root directory. Incorrect use of this function could expose the server to security risks or cause unpredictable behavior by client applications.
- This function should only be called within the context of the FTP_EVENT_COMMAND event, and only for those commands that perform an action on a file or directory. If the current command does not target a file or directory, this function will return zero and the last error code will be set to ST_ERROR_INVALID_COMMAND. To obtain the name of the current command issued by the client, use the FtpGetCommandName function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetCommandFile](#ftpgetcommandfile-function)
- [FtpGetCommandLine](#ftpgetcommandline-function)
- [FtpGetCommandName](#ftpgetcommandname-function)

---

## FtpSetServerAddress Function

Change the IP address that the server will use with passive data connections

### Prototype

```c
BOOL WINAPI FtpSetServerAddress(
    HSERVER hServer,
    LPCTSTR lpszAddress
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszAddress` | `LPCTSTR` | A pointer to a string that specifies the IP address that the server should use for passive mode data transfers. This parameter cannot be NULL. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If either the server handle or the IP address is invalid the function will return a value of zero.

### Remarks

- The FtpSetServerAddress function changes the IP address that the server will use when a client transfers a file using a passive mode data connection. In passive mode, the server will create a second passive (listening) socket that will accept an incoming connection from the client. The server sends the IP address and port number allocated for that socket to the client, and the client establishes the data connection to the server using that address. The IP address that the server sends to the client is normally the same as the IP address that the client used to establish the control connection, however if the server is located behind a router that performs Network Address Translation (NAT), the IP address reported to the client may not be usable.
- This function enables your application to set the external IP address for the server to a specific value, rather than the server attempting to automatically discover its own external address. If you wish to set the external address for the server manually, call the FtpServerStart function without the FTP_SERVER_EXTERNAL option and then call this function to set the external IP address to the desired value.
- This function will not change the IP address the server is using to listen for client connections. The only way to change the listening IP address is to stop and restart the server using the new address. This function only changes the IP address that is reported to clients when a passive data connection is used. Incorrect use of this function can prevent the client from establishing a data connection to the server. The address must be in the same address family as the local address that the server was started with. For example, if the server was started using an IPv4 address, the IP address passed to this function cannot be an IPv6 address.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetServerAddress](#ftpgetserveraddress-function)
- [FtpGetServerName](#ftpgetservername-function)

---

## FtpSetServerError Function

Set the last error code for the specified server session

### Prototype

```c
VOID WINAPI FtpSetServerError(
    HSERVER hServer,
    DWORD dwError
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `dwError` | `DWORD` | An unsigned integer that specifies an error code. |

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- Error codes are unsigned 32-bit values which are private to each server session. Most functions will set the last error code value when they fail; a few functions set it when they succeed. Function failure is typically indicated by a return value such as FALSE, NULL, INVALID_SERVER or FTP_ERROR.
- If the hServer parameter is specified as INVALID_SERVER, this function will set the last error code for the current thread, but will not change the error code associated with any server session. This should only be done if the application does not have access to a valid server handle.
- If the dwError parameter is specified with a value of zero, this effectively clears the error code for the last function that failed. Those functions which clear the last error code when they succeed are noted on the function reference page.
- Applications can retrieve the value saved by this function by using the FtpGetServerError function to determine the specific reason for a function failure.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpGetCommandResult](#ftpgetcommandresult-function)
- [FtpGetServerError](#ftpgetservererror-function)
- [FtpSendResponse](#ftpsendresponse-function)

---

## FtpSetServerIdentity Function

Change the identity and version information for the specified server

### Prototype

```c
BOOL WINAPI FtpSetServerIdentity(
    HSERVER hServer,
    LPCTSTR lpszIdentity
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszIdentity` | `LPCTSTR` | A pointer to a string that identifies the server. If this parameter is NULL or specifies an empty string, the current identity for the server is reset to a default value. The maximum length of the identity string is 64 characters, including the terminating null character. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle is invalid, the function will return a value of zero.

### Remarks

- The FtpSetClientIdentity function changes a string value used by the server to identify itself to clients. The identity string does not have any standard format and is used for informational purposes only. Typically it consists of the application name and a version number. Changing the server identity has no effect on the operation of the server. To obtain the identity string currently associated with the server, use the FtpGetServerIdentity function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetClientIdentity](#ftpgetclientidentity-function)
- [FtpSetClientIdentity](#ftpsetclientidentity-function)
- [FtpGetServerIdentity](#ftpgetserveridentity-function)

---

## FtpSetServerLogFile Function

Change the current log format, level of detail and file name

### Prototype

```c
BOOL WINAPI FtpSetServerLogFile(
    HSERVER hServer,
    UINT nLogFormat,
    UINT nLogLevel,
    LPCTSTR lpszFileName
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nLogFormat` | `UINT` | An integer value that specifies the format used when creating or updating the server log file. The following formats are supported: |
| `nLogLevel` | `UINT` | An integer value that specifies the level of detail that should generated in the log file. The minimum value is 1 and the maximum value is 10. If this parameter is zero, it is the same as specifying a log file format of FTP_LOGFILE_NONE and will disable logging by the server. |
| `lpszFileName` | `LPCTSTR` | A pointer to a string that specifies the name of the log file that should be created or appended to. If the server was configured with logging enabled and this parameter is NULL or an empty string, the current log file name will not be changed. If the log file does not exist, it will be created. If it does exist, the contents of the log file will be appended to. |

### Options

- **nLogFormat** Parameter

    - `FTP_LOGFILE_NONE`: This value specifies that the server should not create or update a log file.
    - `FTP_LOGFILE_COMMON`: This value specifies that the log file should use the common log format that records a subset of information in a fixed format. This log format usually only provides information about file transfers.
    - `FTP_LOGFILE_EXTENDED`: This value specifies that the log file should use the standard W3C extended log file format. This is an extensible format that can provide additional information about the client session.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle does not specify a valid server, the function will return zero.

### Remarks

- The FtpSetServerLogFile function can be used to change the current log file name, the format of the log file or the level of detail recorded in the log file. In some situations it may be desirable to delete the current log file contents when changing the format or ensure that a new log file is created. To do this, combine the nLogFormat parameter with the constant FTP_LOGFILE_DELETE.
- The higher the value of the nLogLevel parameter, the greater the level of detail that is recorded by the server. A log level of 1 instructs the server to only record file transfers, while a level of 10 instructs the server to record all commands processed by the server. Because a higher level of logging detail can negatively impact the performance of the server, it is recommended that you do not exceed a level of 5 for most applications. A log level of 10 should only be used for debugging purposes.

### Example

```cpp
UINT nLogFormat = FTP_LOGFILE_NONE;
UINT nLogLevel = 0;
UINT nNewLevel = 5;
BOOL bChanged = FALSE;

// Change the level of detail for the current log file if logging
// has been enabled and the current level is a lower value

if (FtpGetServerLogFile(hServer, &nLogFormat, &nLogLevel, NULL, 0))
{
	if (nLogFormat != FTP_LOGFILE_NONE && nLogLevel < nNewLevel)
		bChanged = FtpSetServerLogFile(hServer, nLogFormat, nNewLevel, NULL);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetServerLogFile](#ftpgetserverlogfile-function)
- [FtpRenameServerLogFile](#ftprenameserverlogfile-function)

---

## FtpSetServerName Function

Change the hostname assigned to the specified server or client session

### Prototype

```c
BOOL WINAPI FtpSetServerName(
    HSERVER hServer,
    UINT nClientId,
    LPCTSTR lpszHostName
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. This value may be zero. |
| `lpszHostName` | `LPCTSTR` | A pointer to a string that specifies the new host name assigned to the server or client session. If this value is NULL or points to an empty string, the current host name will be changed to use the default host name. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If either the server handle or the client ID is invalid, or the buffer is not large enough to store the complete hostname, the function will return a value of zero.

### Remarks

- This function will change the host name assigned to the specified client session. If the nClientId parameter has a value of zero, the function will change default host name that was assigned to the server as part of the server configuration. If the nClientId parameter specifies a valid client session and the lpszHostName parameter is NULL, the host name associated with the client session will be changed to the current host name assigned to the server.
- When a client connects to the server, it can specify the host name that it used to establish the connection by sending the HOST command. This is typically used with virtual hosting, where one server may accept client connections for multiple domains. The FtpGetServerName function will return the host name specified by the client, and FtpSetServerName can be used by the application to either explicitly assign a different host name to the client session, or override the host name provided by the client.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetServerAddress](#ftpgetserveraddress-function)
- [FtpGetServerName](#ftpgetservername-function)

---

## FtpSetServerPriority Function

Change the priority assigned to the specified server

### Prototype

```c
INT WINAPI FtpSetServerPriority(
    HSERVER hServer,
    INT nPriority
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nPriority` | `INT` | An integer value which specifies the new priority for the server. It may be one of the following values: |

### Options

- **nPriority** Parameter

    - `FTP_PRIORITY_BACKGROUND`: This priority significantly reduces the memory, processor and network resource utilization for the server. It is typically used with lightweight services running in the background that are designed for few client connections. The server thread will be assigned a lower scheduling priority and will be frequently forced to yield execution to other threads.
    - `FTP_PRIORITY_LOW`: This priority lowers the overall resource utilization for the server and meters the processor utilization for the server thread. The server thread will be assigned a lower scheduling priority and will occasionally be forced to yield execution to other threads.
    - `FTP_PRIORITY_NORMAL`: The default priority which balances resource and processor utilization. This is the priority that is initially assigned to the server when it is started, and it is recommended that most applications use this priority.
    - `FTP_PRIORITY_HIGH`: This priority increases the overall resource utilization for the server and the thread will be given higher scheduling priority. It is not recommended that this priority be used on a system with a single processor.
    - `FTP_PRIORITY_CRITICAL`: This priority can significantly increase processor, memory and network utilization. The server thread will be given higher scheduling priority and will be more responsive to client connection requests. It is not recommended that this priority be used on a system with a single processor.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the previous priority assigned to the server. If the function fails, the return value is FTP_PRIORITY_INVALID. To get extended error information, call FtpGetServerError.

### Remarks

- The FtpSetServerPriority function can be used to change the current priority assigned to the specified server. Client connections that are accepted after this function is called will inherit the new priority as their default priority. Previously existing client connections will not be affected by this function.
- Higher priority values increase the thread priority and processor utilization for each client session. You should only change the server priority if you understand the impact it will have on the system and have thoroughly tested your application. Configuring the server to run with a higher priority can have a negative effect on the performance of other programs running on the system.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h.`
- Library: `csftsv11.lib`

### See Also

- [FtpGetServerPriority](#ftpgetserverpriority-function)
- [FtpServerStart](#ftpserverstart-function)

---

## FtpSetServerStackSize Function

Change the initial size of the stack allocated for threads created by the server

### Prototype

```c
BOOL WINAPI FtpSetServerStackSize(
    SOCKET hServer,
    DWORD dwStackSize
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `SOCKET` | Handle to the server socket. |
| `dwStackSize` | `DWORD` | The amount of memory that will be committed to the stack for each thread created by the server. If this value is zero, a default stack size will be used. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetServerError.

### Remarks

- The FtpSetServerStackSize function changes the initial amount of memory that is committed to the stack for each thread created by the server. By default, the stack size for each thread is set to 256K for 32-bit processes and 512K for 64-bit processes. Increasing or decreasing the stack size will only affect new threads that are created by the server, it will not affect those threads that have already been created to manage active client sessions. It is recommended that most applications use the default stack size.
- You should not change the stack size unless you understand the impact that it will have on your system and have thoroughly tested your application. Increasing the initial commit size of the stack will remove pages from the total system commit limit, and every page of memory that is reserved for stack cannot be used for any other purpose.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftsv11.lib`

### See Also

- [FtpGetServerMemoryUsage](#ftpgetservermemoryusage-function)
- [FtpGetServerStackSize](#ftpgetserverstacksize-function)
- [FtpServerStart](#ftpserverstart-function)

---

## FTPCLIENTCREDENTIALS Structure

The FTPCLIENTCREDENTIALS structure defines the credentials used to authenticate a specific user.

### Definition

```c
typedef struct _FTPCLIENTCREDENTIALS
{
    DWORD dwSize;
    DWORD dwFlags;
} FTPCLIENTCREDENTIALS, *LPFTPCLIENTCREDENTIALS;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | An unsigned integer value that specifies the size of the structure. |
| `dwFlags` | `DWORD` | An unsigned integer value reserved for future use. This member will always be initialized to a value of zero. |

### Remarks

- When an instance of this structure is passed to the FtpGetClientCredentials function, this member must be initialized to the size of the structure and all other members must be initialized with a value of zero.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

### See Also

- [FtpGetClientCredentials](#ftpgetclientcredentials-structure)

---

## FTPSERVERCONFIG Structure

The FTPSERVERCONFIG structure provides the configuration information used to create an instance of an FTP server.

### Definition

```c
typedef struct _FTPSERVERCONFIG
{
    DWORD dwSize;
    UINT nMaxClients;
    UINT nMaxClientsPerAddress;
    UINT nMaxGuests;
    UINT nLogFormat;
    UINT nLogLevel;
    UINT nMinPort;
    UINT nMaxPort;
    UINT nAuthFail;
    UINT nAuthTime;
    UINT nIdleTime;
    UINT nExecTime;
    LPCTSTR lpszIdentity;
    LPCTSTR lpszHostUuid;
    LPCTSTR lpszHostName;
    LPCTSTR lpszRootPath;
    LPCTSTR lpszTempPath;
    LPCTSTR lpszLogFile;
} FTPSERVERCONFIG, *LPFTPSERVERCONFIG;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | An unsigned integer value that specifies the size of the structure. |
| `nMaxClients` | `UINT` | An integer value that specifies the maximum number of active client connections that will be accepted by the server. If the maximum number of clients is reached, any further connections are rejected by the server until one or more clients close their connection to the server or are disconnected. A value of zero specifies the default configuration value of 100 connections should be used. |
| `nMaxClientsPerAddress` | `UINT` | An integer value that specifies the maximum number of active client connections per IP address that will be accepted by the server. If the maximum number of clients from the same IP address is reached, any further connections are rejected until one of the clients closes its connection to the server. A value of zero specifies the default configuration value of 4 connections per address should be used. |
| `nMaxGuests` | `UINT` | An integer value that specifies the maximum number of anonymous client connections. If the server does not permit anonymous connections, this value is ignored. It is recommended that this value always be less than the value of the nMaxClients member. A value of zero specifies that the default configuration limit of 20 anonymous connections should be used. |
| `nLogFormat` | `UINT` | An integer value that specifies the format used when creating or updating the server log file. The following formats are supported: |
| `nLogLevel` | `UINT` | An integer value that specifies the level of detail that should generated in the log file. The minimum value is 1 and the maximum value is 10. If the nLogFormat member specifies a valid log file format and this value is zero, a default level of detail will be selected based on the format. The common log file format generally contains less information by default, only logging the data transfers between the client and server. The W3C extended log file format defaults to a higher level of detail that includes additional information about the client session. The higher the level of detail, the larger the log file will be. |
| `nMinPort` | `UINT` | An integer value that specifies the minimum range of port numbers that will be used with passive data connections. A value of zero specifies that the default value of 30000 should be used. The minimum value of this member is 5000 and the maximum value is 65535. If the value is non-zero, it must be less than the value of the nMaxPort structure member. |
| `nMaxPort` | `UINT` | An integer value that specifies the maximum range of port numbers that will be used with passive data connections. A value of zero specifies the default value of 65535 should be used. The minimum value of this member is 5000 and the maximum value is 65535. If the value is non-zero, it must be greater than the value of the nMinPort structure member. |
| `nAuthFail` | `UINT` | An integer value that specifies the maximum number of user authentication attempts that are permitted until the server terminates the client connection. A value of zero specifies that the default configuration limit of 3 authentication attempts per login should be allowed. The maximum number of authentication attempts is 10. |
| `nAuthTime` | `UINT` | An integer value that specifies the maximum number of user authentication attempts that are permitted until the server terminates the client connection. A value of zero specifies the default value of 60 seconds. If the value is non-zero, the minimum value is 20 seconds and the maximum value is 300 seconds (5 minutes). This value is used to ensure that a client has successfully authenticated itself within a limited period of time. This prevents a potential denial-of-service attack against the server where clients establish connections and hold them open without authentication. In conjunction with the nAuthFail member, this also limits the ability of a client to attempt to probe the server for valid username and password combinations. |
| `nIdleTime` | `UINT` | An integer value that specifies the maximum number of seconds that a client session may be idle before the server closes the control connection to the client. A value of zero specifies the default value of 900 seconds (15 minutes). If the value is non-zero, the minimum value is 60 seconds and the maximum value is 7200 seconds (2 hours). This value is used to initialize the default idle timeout period for each client session. A client may request that the server change the idle timeout period for its session by sending the SITE IDLE command. The server determines if a client is idle based on the time the last command was issued and whether or not a file transfer is in progress. |
| `nExecTime` | `UINT` | An unsigned integer value that specifies the maximum number of seconds that an external program is permitted to run on the server. External programs are registered using the FtpRegisterProgram function, and are executed by the client sending the SITE EXEC command to the server. If this value is zero, the default timeout period of 5 seconds will be used. The minimum execution time is 1 second and the maximum time limit is 30 seconds. |
| `lpszIdentity` | `LPCTSTR` | A pointer to a string that identifies the server. It is used for informational purposes only and has no effect on the operation of the server. If this member is not initialized to a value, then a default identity will be used. The server identity is provided when a client establishes the initial connection and when the client sends the STAT or CSID commands. If this member is defined, it is recommended that you only use printable ASCII characters. |
| `lpszHostUuid` | `LPCTSTR` | A pointer to a string that specifies a Universally Unique Identifier (UUID) that is used to uniquely identify the server. This value can be used when storing information about the server, and should be generated using a utility such as uuidgen which is included with Visual Studio. This structure member may be initialized to an empty string, in which case a temporary UUID will be randomly generated. |
| `lpszHostName` | `LPCTSTR` | A pointer to a string that specifies the fully-qualified host name for the server. If this structure member is initialized with an empty string, the local host name assigned to the Windows system will be used. This value does not need to correspond to the actual host name associated with the server's IP address. This value is used for informational purposes only and has no effect on the operation of the server. |
| `lpszRootPath` | `LPCTSTR` | A pointer to a string that specifies the path to the root directory for the server. If this structure member is initialized with an empty string, the current working directory for the process will be used as the root directory. It is recommended that you provide a full path to an existing directory and do not specify the root of a local or network drive. If the path does not exist at the time the server is started, it will be automatically created. |
| `lpszTempPath` | `LPCTSTR` | A pointer to a string that specifies the path to the temporary directory for the server. If this structure member is initialized with an empty string, the current temporary directory for the process will be used. The temporary directory cannot be the same as the root directory, and it is strongly recommended that you do not specify the root of a local or network drive. If the path does not exist at the time the server is started, it will be automatically created. |
| `lpszLogFile` | `LPCTSTR` | A pointer to a string that specifies the name of the server log file to create, if a logging format has been specified. If logging is enabled and this member is an empty string, then a default log file name will be created. If the file name does not include a path, then the file is created in the server log directory. If the file name includes a path, the log file will be created using that specific name. If the server is in multi-user mode, then the default location for log files will be the Logs subdirectory in the server root directory. If the server is not in multi-user mode, the default location for log files will be the temporary directory for the server process. |

### Remarks

- When an instance of this structure is passed to the FtpServerStart function, the dwSize member must be initialized to the size of the structure, otherwise the function will fail with an error indicating that the configuration is invalid.
- The nMaxClients member limits the total number of client connections and the nMaxGuests member limits the total number of guest connections. The server will notify the client if either number of connections has been exceeded and will automatically close the connection. However, one difference is that a new client that exceeds the maximum number of connections will not generate any events; a client that exceeds the maximum number of guest connections will generate events. The reason for the difference is that the check for the number of active clients is made immediately after the client connects to the server, prior to session context being created for that client. The check for the number of anonymous clients is made later, after the client has sent the USER and PASS commands to the server. For more control over how the server accepts client connections, use the FtpServerThrottle function.
- If the server is running on a system that is behind a firewall that restricts the range of port numbers for inbound connections, the nMinPort and nMaxPort members can be used to limit the ports which the server will use to listen for passive data connections from clients. By default, the server will use data port numbers that range from 30000 to 65535, which is typical for many firewall configurations. If you provide your own port range, the minimum number of ports available must be at least 1000. Specifying a port range that is too small will cause the FtpServerStart function to fail with an error indicating that the server configuration is invalid.
- When specifying the root directory for the server configuration, it is important to consider that a client's access to files on the system will be limited to these directories and any subdirectories. If a root directory is not specified, then one will be created using the current working directory for the process. The root directory path may include environment variables surrounded by % symbols and these will be expanded.
- If you have configured the server to permit clients to upload files, you must ensure that your application has permission to create files in the directory that you specify. A recommended location for the server root directory would be a subdirectory of the %ALLUSERSPROFILE% directory. Using the environment variable ensures that your server will work correctly on different versions of Windows. If the root directory does not exist at the time that the server is started, it will be created.
- For servers that are publicly accessible, or where you want files to be a accessible across multiple server sessions, you should always populate the szHostUuid member with a valid UUID string, and the szDirectory member should specify an absolute path to an existing directory.
- If the FTP_SERVER_MULTIUSER option is specified, the server will start in multi-user mode, with each user assigned to their own home directory based on their username. This option will cause the server to create a directory structure in the root directory that includes three subdirectories: Public, Users and Logs. The Public directory is the home directory for anonymous users, and they are isolated to that directory. The Users directory is where the user home directories are created. The Logs directory is where log files are created by default. If this option is not specified, then no subdirectories are created and all users will share the server root directory by default.
- If the FTP_SERVER_LOCALUSER option is specified, the server will never attempt to authenticate the local Administrator or Guest accounts. This is done to prevent clients from attempting to probe for the administrator account password. However, the application can override this behavior by implementing a handler for the FTP_CLIENT_LOGIN event.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpServerStart](#ftpserverstart-structure)
- [FtpServerStop](#ftpserverstop-structure)
- [FtpServerThrottle](#ftpserverthrottle-structure)

---

## FTPSERVERTRANSFER Structure

typedef struct _FTPSERVERTRANSFER { DWORD dwSize; DWORD dwReserved; DWORD dwFileAccess; DWORD dwTimeElapsed; ULARGE_INTEGER uiBytesCopied; TCHAR szFileName[MAX_PATH]; } FTPSERVERTRANSFER, *LPFTPSERVERTRANSFER; Members dwSize An unsigned integer value that specifies the size of the structure. dwReserved An unsigned integer value that is reserved for future use. This value will always be zero. dwFileAccess An unsigned integer value that specifies the how the local file was accessed. It can be one of the following values: Value Description FTP_FILE_READ The file was opened for reading. This mode indicates that the client issued the RETR command to download the contents of a file from the server to the client system. The szFileName member specifies the name of the local file on the server that was downloaded by the client. FTP_FILE_WRITE The file was opened for writing. This mode indicates that the client issued the STOR or STOU command to upload the contents of a file from the client system to server. The szFileName member specifies the name of the local file on the server that was created by the client. If a file already existed with the name name, it was replaced. FTP_FILE_APPEND The file was opened for writing. This mode indicates the client issued the APPE command to upload the contents of a file from the client system and append the data to a file on the server. If the file did not exist, then it was created. The szFileName member specifies the name of the local file that was appended to or created by the client. dwTimeElapsed The amount of time that it took for the file transfer to complete in milliseconds. This value is limited to the resolution of the system timer, which is typically in the range of 10 to 16 milliseconds. This value may be zero if the transfer occurred over a local network or on the same host using a loopback address. uiBytesCopied A 64-bit integer value that specifies the total number of bytes copied during the file transfer. This value is represented by a ULARGE_INTEGER union which provides support for those programming languages that do not have intrinsic support for 64-bit integers. For more information, refer to the Windows SDK documentation. The application should not make the assumption that this is the actual size of the file. If the client specified a restart offset using the REST command, this value would only represent the number of bytes transferred from that byte offset, not the total file size. szFileName A pointer to a string value that will contain the full path to the local file that was transferred. The dwFileAccess member determines whether the file name represents a file that was downloaded by the client, or uploaded from the client and stored on the server. Remarks When an instance of this structure is passed to the FtpGetServerTransferInfo function, the dwSize member must be initialized to the size of the structure, otherwise the function will fail with an error indicating that the parameter is invalid. All other members should be initialized to a value of zero. Requirements Minimum Desktop Platform: Windows 7 Service Pack 1 Minimum Server Platform: Windows Server 2008 R2 Service Pack 1 Header File: cstools11.h Unicode: Implemented as Unicode and ANSI versions See Also FtpGetServerTransferInfo

### Definition

```c
typedef struct _FTPSERVERTRANSFER
{
    DWORD dwSize;
    DWORD dwReserved;
    DWORD dwFileAccess;
    DWORD dwTimeElapsed;
    ULARGE_INTEGER uiBytesCopied;
} FTPSERVERTRANSFER, *LPFTPSERVERTRANSFER;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | An unsigned integer value that specifies the size of the structure. |
| `dwReserved` | `DWORD` | An unsigned integer value that is reserved for future use. This value will always be zero. |
| `dwFileAccess` | `DWORD` | An unsigned integer value that specifies the how the local file was accessed. It can be one of the following values: |
| `dwTimeElapsed` | `DWORD` | The amount of time that it took for the file transfer to complete in milliseconds. This value is limited to the resolution of the system timer, which is typically in the range of 10 to 16 milliseconds. This value may be zero if the transfer occurred over a local network or on the same host using a loopback address. |
| `uiBytesCopied` | `ULARGE_INTEGER` | A 64-bit integer value that specifies the total number of bytes copied during the file transfer. This value is represented by a ULARGE_INTEGER union which provides support for those programming languages that do not have intrinsic support for 64-bit integers. For more information, refer to the Windows SDK documentation. The application should not make the assumption that this is the actual size of the file. If the client specified a restart offset using the REST command, this value would only represent the number of bytes transferred from that byte offset, not the total file size. |

### Remarks

- When an instance of this structure is passed to the FtpGetServerTransferInfo function, the dwSize member must be initialized to the size of the structure, otherwise the function will fail with an error indicating that the parameter is invalid. All other members should be initialized to a value of zero.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

### See Also

- [FtpGetServerTransferInfo](#ftpgetservertransferinfo-structure)

---

## INITDATA Structure

This structure contains information about the SocketTools library when the initialization function returns.

### Definition

```c
typedef struct _INITDATA
{
    DWORD dwSize;
    DWORD dwVersionMajor;
    DWORD dwVersionMinor;
    DWORD dwVersionBuild;
    DWORD dwOptions;
    DWORD_PTR dwReserved1;
    DWORD_PTR dwReserved2;
    TCHAR szDescription;
} INITDATA, *LPINITDATA;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | Size of this structure. This structure member must be set to the size of the structure prior to calling the initialization function. Failure to do so will cause the function to fail. |
| `dwVersionMajor` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. When the function returns, it will contain the major version number for the library. |
| `dwVersionMinor` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. When the function returns, it will contain the minor version number for the library. |
| `dwVersionBuild` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. When the function returns, it will contain the build number for the library. |
| `dwOptions` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. This member is reserved for future use. |
| `dwReserved1` | `DWORD_PTR` | This member must be initialized to a value of zero prior to calling the initialization function. This member is reserved for future use. |
| `dwReserved2` | `DWORD_PTR` | This member must be initialized to a value of zero prior to calling the initialization function. This member is reserved for future use. |
| `szDescription` | `TCHAR` | A null terminated string which describes the library. |

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

---

## SECURITYCREDENTIALS Structure

The SECURITYCREDENTIALS structure specifies the information needed by the library to specify the security protocol and server certificate when accepting a secure connection.

### Definition

```c
typedef struct _SECURITYCREDENTIALS
{
    DWORD dwSize;
    DWORD dwProtocol;
    DWORD dwOptions;
    DWORD dwReserved;
    LPCTSTR lpszHostName;
    LPCTSTR lpszUserName;
    LPCTSTR lpszPassword;
    LPCTSTR lpszCertStore;
    LPCTSTR lpszCertName;
    LPCTSTR lpszKeyFile;
} SECURITYCREDENTIALS, *LPSECURITYCREDENTIALS;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | Size of this structure. If the structure is being allocated dynamically, this member must be set to the size of the structure and all other unused structure members must be initialized to a value of zero or NULL. |
| `dwProtocol` | `DWORD` | A bitmask of supported security protocols. The value of this structure member is constructed by using a bitwise operator with any of the following values: |
| `dwOptions` | `DWORD` | A value which specifies one or options. This member is constructed by using a bitwise operator with any of the following values: |
| `dwReserved` | `DWORD` | This structure member is reserved for future use and should always be initialized to zero. |
| `lpszHostName` | `LPCTSTR` | A pointer to a null terminated string which specifies the hostname that will be used when validating the server certificate. If this member is NULL, then the server certificate will be validated against the hostname used to establish the connection. |
| `lpszUserName` | `LPCTSTR` | A pointer to a null terminated string which identifies the owner of client certificate. Currently this member is not used by the library and should always be initialized as a NULL pointer. |
| `lpszPassword` | `LPCTSTR` | A pointer to a null terminated string which specifies the password needed to access the certificate. Currently this member is only used if the CREDENTIAL_STORE_FILENAME option has been specified. If there is no password associated with the certificate, then this member should be initialized as a NULL pointer. |
| `lpszCertStore` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the certificate store to open. A certificate store is a collection of certificates and their private keys, typically organized by how they are used. If this value is NULL or points to an empty string, the default certificate store "MY" will be used. |
| `lpszCertName` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the certificate to use. The library will first search the certificate store for a certificate with a matching "friendly name"; this is a name for the certificate that is assigned by the user. Note that the name must match completely, but the comparison is not case sensitive. If no matching certificate is found, the library will then attempt to find a certificate that has a matching common name (also called the certificate subject). This comparison is less stringent, and the first partial match will be returned. If this second search fails, the library will return an error indicating that the certificate could not be found. If the SECURITY_PROTOCOL_SSH protocol has been specified, this member should be NULL. |
| `lpszKeyFile` | `LPCTSTR` | This member is not used and should always be NULL. The private key cannot be specified separately and must be associated with the certificate. |

### Remarks

- A client application only needs to create this structure if the server requires that the client provide a certificate as part of the process of negotiating the secure session. If a certificate is required, note that it must have a private key associated with it. Attempting to use a certificate that does not have a private key will result in an error during the connection process indicating that the client credentials could not be established.
- If you are using a local certificate store, with the certificate and private key stored in the registry, you can explicitly specify whether the certificate store for the current user or the local machine (all users) should be used. This is done by prefixing the certificate store name with "HKCU:" for the current user, or "HKLM:" for the local machine. For example, a certificate store name of "HKLM:MY" would specify the personal certificate store for the local machine, rather than the current user. If neither prefix is specified, then it will default to the certificate store for the current user. You can manage these certificates using the CertMgr.msc Microsoft Management Console (MMC) snap-in.
- It is possible to load the certificate from a file rather than from current user's certificate store. The dwOptions member should be set to CREDENTIAL_STORE_FILENAME and the lpszCertStore member should specify the name of the file that contains the certificate and its private key. The file must be in Private Information Exchange (PFX) format, also known as PKCS #12. These certificate files typically have an extension of .pfx or .p12. Note that if a password was specified when the certificate file was created, it must be provided in the lpszPassword member or the library will be unable to access the certificate.
- Note that the lpszUserName and lpszPassword members are values which are used to access the certificate store or private key file. They are not the credentials which are used when establishing the connection with the remote host or authenticating the client session.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

