# Network News Transfer Protocol

## Functions

- [NntpAsyncConnect](#nntpasyncconnect-function)
- [NntpAttachThread](#nntpattachthread-function)
- [NntpAuthenticate](#nntpauthenticate-function)
- [NntpCancel](#nntpcancel-function)
- [NntpCloseArticle](#nntpclosearticle-function)
- [NntpCommand](#nntpcommand-function)
- [NntpConnect](#nntpconnect-function)
- [NntpCreateArticle](#nntpcreatearticle-function)
- [NntpCreateSecurityCredentials](#nntpcreatesecuritycredentials-function)
- [NntpDeleteSecurityCredentials](#nntpdeletesecuritycredentials-function)
- [NntpDisableEvents](#nntpdisableevents-function)
- [NntpDisableTrace](#nntpdisabletrace-function)
- [NntpDisconnect](#nntpdisconnect-function)
- [NntpEnableEvents](#nntpenableevents-function)
- [NntpEnableTrace](#nntpenabletrace-function)
- [NntpEventProc](#nntpeventproc-function)
- [NntpFreezeEvents](#nntpfreezeevents-function)
- [NntpGetArticle](#nntpgetarticle-function)
- [NntpGetArticleByMessageId](#nntpgetarticlebymessageid-function)
- [NntpGetArticleEx](#nntpgetarticleex-function)
- [NntpGetArticleHeaders](#nntpgetarticleheaders-function)
- [NntpGetArticleHeadersEx](#nntpgetarticleheadersex-function)
- [NntpGetArticleMessageId](#nntpgetarticlemessageid-function)
- [NntpGetArticleMessageIdEx](#nntpgetarticlemessageidex-function)
- [NntpGetArticleRange](#nntpgetarticlerange-function)
- [NntpGetArticleRangeEx](#nntpgetarticlerangeex-function)
- [NntpGetArticleSize](#nntpgetarticlesize-function)
- [NntpGetArticleSizeEx](#nntpgetarticlesizeex-function)
- [NntpGetCurrentArticle](#nntpgetcurrentarticle-function)
- [NntpGetCurrentArticleEx](#nntpgetcurrentarticleex-function)
- [NntpGetCurrentDate](#nntpgetcurrentdate-function)
- [NntpGetErrorString](#nntpgeterrorstring-function)
- [NntpGetFirstArticle](#nntpgetfirstarticle-function)
- [NntpGetFirstArticleEx](#nntpgetfirstarticleex-function)
- [NntpGetFirstGroup](#nntpgetfirstgroup-function)
- [NntpGetFirstGroupEx](#nntpgetfirstgroupex-function)
- [NntpGetGroupName](#nntpgetgroupname-function)
- [NntpGetGroupTitle](#nntpgetgrouptitle-function)
- [NntpGetLastError](#nntpgetlasterror-function)
- [NntpGetMessageIdArticle](#nntpgetmessageidarticle-function)
- [NntpGetMessageIdArticleEx](#nntpgetmessageidarticleex-function)
- [NntpGetMultiLine](#nntpgetmultiline-function)
- [NntpGetNextArticle](#nntpgetnextarticle-function)
- [NntpGetNextArticleEx](#nntpgetnextarticleex-function)
- [NntpGetNextGroup](#nntpgetnextgroup-function)
- [NntpGetNextGroupEx](#nntpgetnextgroupex-function)
- [NntpGetResultCode](#nntpgetresultcode-function)
- [NntpGetResultString](#nntpgetresultstring-function)
- [NntpGetSecurityInformation](#nntpgetsecurityinformation-function)
- [NntpGetStatus](#nntpgetstatus-function)
- [NntpGetTimeout](#nntpgettimeout-function)
- [NntpGetTransferStatus](#nntpgettransferstatus-function)
- [NntpGetTransferStatusEx](#nntpgettransferstatusex-function)
- [NntpInitialize](#nntpinitialize-function)
- [NntpIsBlocking](#nntpisblocking-function)
- [NntpIsConnected](#nntpisconnected-function)
- [NntpIsReadable](#nntpisreadable-function)
- [NntpIsWritable](#nntpiswritable-function)
- [NntpListArticles](#nntplistarticles-function)
- [NntpListArticlesEx](#nntplistarticlesex-function)
- [NntpListGroups](#nntplistgroups-function)
- [NntpListNewGroups](#nntplistnewgroups-function)
- [NntpOpenArticle](#nntpopenarticle-function)
- [NntpOpenArticleByMessageId](#nntpopenarticlebymessageid-function)
- [NntpOpenArticleEx](#nntpopenarticleex-function)
- [NntpOpenNextArticle](#nntpopennextarticle-function)
- [NntpOpenPreviousArticle](#nntpopenpreviousarticle-function)
- [NntpPostArticle](#nntppostarticle-function)
- [NntpRead](#nntpread-function)
- [NntpRegisterEvent](#nntpregisterevent-function)
- [NntpReset](#nntpreset-function)
- [NntpSelectGroup](#nntpselectgroup-function)
- [NntpSetLastError](#nntpsetlasterror-function)
- [NntpSetMultiLine](#nntpsetmultiline-function)
- [NntpSetTimeout](#nntpsettimeout-function)
- [NntpStoreArticle](#nntpstorearticle-function)
- [NntpStoreArticleEx](#nntpstorearticleex-function)
- [NntpUninitialize](#nntpuninitialize-function)
- [NntpWrite](#nntpwrite-function)
## Structures

- [INITDATA](#initdata-structure)
- [NEWSARTICLE](#newsarticle-structure)
- [NEWSARTICLEEX](#newsarticleex-structure)
- [NEWSGROUP](#newsgroup-structure)
- [NEWSGROUPEX](#newsgroupex-structure)
- [NNTPTRANSFERSTATUS](#nntptransferstatus-structure)
- [NNTPTRANSFERSTATUSEX](#nntptransferstatusex-structure)
- [SECURITYCREDENTIALS](#securitycredentials-structure)
- [SECURITYINFO](#securityinfo-structure)

---

## NntpAsyncConnect Function

Establish an asynchronous connection to the specified server

### Prototype

```c
HCLIENT WINAPI NntpAsyncConnect(
    LPCTSTR lpszRemoteHost,
    UINT nRemotePort,
    UINT nTimeout,
    DWORD dwOptions,
    LPSECURITYCREDENTIALS lpCredentials,
    HWND hEventWnd,
    UINT uEventMsg
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszRemoteHost` | `LPCTSTR` | A pointer to the name of the server to connect to; this may be a fully-qualified domain name or an IP address. |
| `nRemotePort` | `UINT` | The port number the server is listening on; a value of zero specifies that the default port number should be used. |
| `nTimeout` | `UINT` | The number of seconds that the client will wait for a response from the server before failing the current operation. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `lpCredentials` | `LPSECURITYCREDENTIALS` | Pointer to credentials structure SECURITYCREDENTIALS. This parameter is only used if the NNTP_OPTION_SECURE option is specified for the connection. This parameter may be NULL, in which case no client credentials will be provided to the server. If client credentials are required, the fields dwSize, lpszCertStore, and lpszCertName must be defined, while other fields may be left undefined. Set dwSize to the size of the SECURITYCREDENTIALS structure. |
| `hEventWnd` | `HWND` | The handle to the event notification window. This window receives messages which notify the client of various asynchronous socket events that occur. |
| `uEventMsg` | `UINT` | The message identifier that is used when an asynchronous socket event occurs. This value should be greater than WM_USER as defined in the Windows header files. |

### Options

- **dwOptions** Parameter

    - `NNTP_OPTION_NONE`: No connection options specified. A standard connection to the server will be established using the specified host name and port number.
    - `NNTP_OPTION_TUNNEL`: This option specifies that a tunneled TCP connection and/or port-forwarding is being used to establish the connection to the server. This changes the behavior of the client with regards to internal checks of the destination IP address and remote port number, default capability selection and how the connection is established.
    - `NNTP_OPTION_TRUSTEDSITE`: This option specifies the server is trusted. The server certificate will not be validated and the connection will always be permitted. This option only affects connections using the TLS protocol.
    - `NNTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. Note that the server must support secure connections using the TLS protocol.
    - `NNTP_OPTION_SECURE_FALLBACK`: This option specifies the client should permit the use of less secure cipher suites for compatibility with legacy servers. If this option is specified, the client will allow connections using TLS 1.0 and cipher suites that use RC4, MD5 and SHA1.
    - `NNTP_OPTION_PREFER_IPV6`: This option specifies the client should prefer the use of IPv6 if the server hostname can be resolved to both an IPv6 and IPv4 address. This option is ignored if the local system does not have IPv6 enabled, or when the hostname can only be resolved to an IPv4 address. If the server hostname can only be resolved to an IPv6 address, the client will attempt to establish a connection using IPv6 regardless if this option has been specified.
    - `NNTP_OPTION_FREETHREAD`: This option specifies the handle returned by this function may be used by any thread, and is not limited to the thread which created it. The application is responsible for ensuring that access to the handle is synchronized across multiple threads.

### Return Value

- **Type**: `HCLIENT`
- If the function succeeds, the return value is a handle to a client session. If the function fails, the return value is INVALID_CLIENT. To get extended error information, call NntpGetLastError.

### Remarks

- The dwOptions argument can be used to specify the threading model that is used by the library when a connection is established. By default, the handle is initially attached to the thread that created it. From that point on, until the it is released, only the owner may call functions using that handle. The ownership of the handle may be transferred from one thread to another using the NntpAttachThread function.
- Specifying the NNTP_OPTION_FREETHREAD option enables any thread to call any function using the handle, regardless of which thread created it. It is important to note that this option disables certain internal safety checks which are performed by the library and may result in unexpected behavior unless access to the handle is synchronized. If one thread calls a function in the library, it must ensure that no other thread will call another function at the same time using the same handle.
- When a message is posted to the notification window, the low word of the lParam parameter contains the event identifier. The high word of lParam contains the low word of the error code, if an error has occurred. The wParam parameter contains the client handle. One or more of the following event identifiers may be sent:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpAuthenticate](#nntpauthenticate-function)
- [NntpConnect](#nntpconnect-function)
- [NntpCreateSecurityCredentials](#nntpcreatesecuritycredentials-function)
- [NntpDeleteSecurityCredentials](#nntpdeletesecuritycredentials-function)
- [NntpDisconnect](#nntpdisconnect-function)
- [NntpInitialize](#nntpinitialize-function)
- [NntpUninitialize](#nntpuninitialize-function)

---

## NntpAttachThread Function

Attach the specified client handle to another thread

### Prototype

```c
DWORD WINAPI NntpAttachThread(
    HCLIENT hClient,
    DWORD dwThreadId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `dwThreadId` | `DWORD` | The ID of the thread that will become the new owner of the handle. A value of zero specifies that the current thread should become the owner of the client handle. |

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is the thread ID of the previous owner. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- When a client handle is created, it is associated with the current thread that created it. Normally, if another thread attempts to perform an operation using that handle, an error is returned since it does not own the handle. This is used to ensure that other threads cannot interfere with an operation being performed by the owner thread. In some cases, it may be desirable for one thread in a client application to create the client handle, and then pass that handle to another worker thread. The NntpAttachThread function can be used to change the ownership of the handle to the new worker thread. By preserving the return value from the function, the original owner of the handle can be restored before the worker thread terminates.
- This function should be called by the new thread immediately after it has been created, and if the new thread does not release the handle itself, the ownership of the handle should be restored to the parent thread before it terminates. Under no circumstances should NntpAttachThread be used to forcibly release a handle allocated by another thread while a blocking operation is in progress. To cancel an operation, use the NntpCancel function and then release the handle after the blocking function exits and control is returned to the current thread.
- Note that the dwThreadId parameter is presumed to be a valid thread ID and no checks are performed to ensure that the thread actually exists. Specifying an invalid thread ID will orphan the handle until the NntpUninitialize function is called.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpConnect](#nntpconnect-function)
- [NntpDisconnect](#nntpdisconnect-function)
- [NntpUninitialize](#nntpuninitialize-function)

---

## NntpAuthenticate Function

Authenticate the specified user on the news server

### Prototype

```c
INT WINAPI NntpAuthenticate(
    HCLIENT hClient,
    LPCTSTR lpszUserName,
    LPCTSTR lpszPassword
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszUserName` | `LPCTSTR` | Pointer to a string which specifies the user name required for authentication on the news server. |
| `lpszPassword` | `LPCTSTR` | Pointer to a string which specifies the password required for authentication on the news server. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- This function should only be called if the server requires authentication. Two authentication methods, "original" and "simple" authentication, are recognized by the library.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpConnect](#nntpconnect-function)
- [NntpListArticles](#nntplistarticles-function)
- [NntpListGroups](#nntplistgroups-function)

---

## NntpCancel Function

Cancel the current blocking operation

### Prototype

```c
INT WINAPI NntpCancel(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- When the NntpCancel function is called, the blocking function will not immediately fail. An internal flag is set which causes the blocking operation to exit with an error. This means that the application cannot cancel an operation and immediately perform some other operation. Instead it must allow the calling stack to unwind, returning back to the blocking operation before making any further function calls.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpIsBlocking](#nntpisblocking-function)
- [NntpRead](#nntpread-function)
- [NntpReset](#nntpreset-function)
- [NntpWrite](#nntpwrite-function)

---

## NntpCloseArticle Function

Close the article being posted to the current newsgroup

### Prototype

```c
INT WINAPI NntpCloseArticle(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- If an article is being created, this function actually submits the article to the server. Note that the client application is responsible for generating the message headers as well as the body of the message. News articles conform to the same general characteristics of an email message.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpCreateArticle](#nntpcreatearticle-function)
- [NntpOpenArticle](#nntpopenarticle-function)
- [NntpOpenArticleByMessageId](#nntpopenarticlebymessageid-function)
- [NntpWrite](#nntpwrite-function)

---

## NntpCommand Function

Send a command to the server

### Prototype

```c
INT WINAPI NntpCommand(
    HCLIENT hClient,
    LPCTSTR lpszCommand,
    LPCTSTR lpszParameter
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszCommand` | `LPCTSTR` | The command which will be executed by the server. |
| `lpszParameter` | `LPCTSTR` | An optional command parameter. If the command requires more than one parameter, then they should be combined into a single string, with a space separating each parameter. If the command does not accept any parameters, this value may be NULL. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the result code returned by the server. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- A list of valid commands can be found in the technical specification for the protocol. Many servers will list supported commands when the HELP command is used.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetMultiLine](#nntpgetmultiline-function)
- [NntpGetResultCode](#nntpgetresultcode-function)
- [NntpGetResultString](#nntpgetresultstring-function)
- [NntpSetMultiLine](#nntpsetmultiline-function)

---

## NntpConnect Function

Connect to the specified server

### Prototype

```c
HCLIENT WINAPI NntpConnect(
    LPCTSTR lpszRemoteHost,
    UINT nRemotePort,
    UINT nTimeout,
    DWORD dwOptions,
    LPSECURITYCREDENTIALS lpCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszRemoteHost` | `LPCTSTR` | A pointer to the name of the server to connect to; this may be a fully-qualified domain name or an IP address. |
| `nRemotePort` | `UINT` | The port number the server is listening on; a value of zero specifies that the default port number should be used. |
| `nTimeout` | `UINT` | The number of seconds that the client will wait for a response from the server before failing the current operation. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `lpCredentials` | `LPSECURITYCREDENTIALS` | Pointer to credentials structure SECURITYCREDENTIALS. This parameter is only used if the NNTP_OPTION_SECURE option is specified for the connection. This parameter may be NULL, in which case no client credentials will be provided to the server. If client credentials are required, the fields dwSize, lpszCertStore, and lpszCertName must be defined, while other fields may be left undefined. Set dwSize to the size of the SECURITYCREDENTIALS structure. |

### Options

- **dwOptions** Parameter

    - `NNTP_OPTION_NONE`: No connection options specified. A standard connection to the server will be established using the specified host name and port number.
    - `NNTP_OPTION_TUNNEL`: This option specifies that a tunneled TCP connection and/or port-forwarding is being used to establish the connection to the server. This changes the behavior of the client with regards to internal checks of the destination IP address and remote port number, default capability selection and how the connection is established.
    - `NNTP_OPTION_TRUSTEDSITE`: This option specifies the server is trusted. The server certificate will not be validated and the connection will always be permitted. This option only affects connections using the TLS protocol.
    - `NNTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. Note that the server must support secure connections using the TLS protocol.
    - `NNTP_OPTION_SECURE_FALLBACK`: This option specifies the client should permit the use of less secure cipher suites for compatibility with legacy servers. If this option is specified, the client will allow connections using TLS 1.0 and cipher suites that use RC4, MD5 and SHA1.
    - `NNTP_OPTION_PREFER_IPV6`: This option specifies the client should prefer the use of IPv6 if the server hostname can be resolved to both an IPv6 and IPv4 address. This option is ignored if the local system does not have IPv6 enabled, or when the hostname can only be resolved to an IPv4 address. If the server hostname can only be resolved to an IPv6 address, the client will attempt to establish a connection using IPv6 regardless if this option has been specified.
    - `NNTP_OPTION_FREETHREAD`: This option specifies the handle returned by this function may be used by any thread, and is not limited to the thread which created it. The application is responsible for ensuring that access to the handle is synchronized across multiple threads.

### Return Value

- **Type**: `HCLIENT`
- If the function succeeds, the return value is a handle to a client session. If the function fails, the return value is INVALID_CLIENT. To get extended error information, call NntpGetLastError.

### Remarks

- This function will block the current thread until a connection has been established or the timeout period has elapsed. To prevent it from blocking the main user interface thread, the application should create a background worker thread and establish a connection by calling NntpConnect in that thread. If the application requires multiple simultaneous connections, it is recommended you create a worker thread for each connection.
- The dwOptions argument can be used to specify the threading model that is used by the library when a connection is established. By default, the handle is initially attached to the thread that created it. From that point on, until the it is released, only the owner may call functions using that handle. The ownership of the handle may be transferred from one thread to another using the NntpAttachThread function.
- Specifying the NNTP_OPTION_FREETHREAD option enables any thread to call any function using the handle, regardless of which thread created it. It is important to note that this option disables certain internal safety checks which are performed by the library and may result in unexpected behavior unless access to the handle is synchronized. If one thread calls a function in the library, it must ensure that no other thread will call another function at the same time using the same handle.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpAuthenticate](#nntpauthenticate-function)
- [NntpCreateSecurityCredentials](#nntpcreatesecuritycredentials-function)
- [NntpDeleteSecurityCredentials](#nntpdeletesecuritycredentials-function)
- [NntpDisconnect](#nntpdisconnect-function)
- [NntpInitialize](#nntpinitialize-function)
- [NntpUninitialize](#nntpuninitialize-function)

---

## NntpCreateArticle Function

Create a new article in the current newsgroup

### Prototype

```c
INT WINAPI NntpCreateArticle(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- This function sends the POST command to the news server. Not all servers permit clients to post articles. The client application is responsible for generating the message headers as well as the body of the message. News articles conform to the same general characteristics of an email message.
- The NntpCloseArticle function must be called once the contents of the article has been written to the server.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpCloseArticle](#nntpclosearticle-function)
- [NntpGetCurrentDate](#nntpgetcurrentdate-function)
- [NntpListArticles](#nntplistarticles-function)
- [NntpOpenArticle](#nntpopenarticle-function)
- [NntpOpenArticleByMessageId](#nntpopenarticlebymessageid-function)
- [NntpOpenNextArticle](#nntpopennextarticle-function)
- [NntpOpenPreviousArticle](#nntpopenpreviousarticle-function)
- [NntpWrite](#nntpwrite-function)

---

## NntpCreateSecurityCredentials Function

Create a new security credentials structure

### Prototype

```c
BOOL WINAPI NntpCreateSecurityCredentials(
    DWORD dwProtocol,
    DWORD dwOptions,
    LPCTSTR lpszUserName,
    LPCTSTR lpszPassword,
    LPCTSTR lpszCertStore,
    LPCTSTR lpszCertName,
    LPVOID lpvReserved,
    LPSECURITYCREDENTIALS lppCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `dwProtocol` | `DWORD` | A bitmask of supported security protocols. This parameter is constructed by using a bitwise operator with any of the following values: |
| `dwOptions` | `DWORD` | A value which specifies one or more options. This member is constructed by using a bitwise operator with any of the following values: |
| `lpszUserName` | `LPCTSTR` | A pointer to a string which specifies the certificate owner's username. A value of NULL specifies that no username is required. Currently this parameter is not used and any value specified will be ignored. |
| `lpszPassword` | `LPCTSTR` | A pointer to a string which specifies the certificate owner's password. A value of NULL specifies that no password is required. This parameter is only used if a PKCS #12 (PFX) certificate file is specified and that certificate has been secured with a password. This value will be ignored the current user or local machine certificate store is specified. |
| `lpszCertStore` | `LPCTSTR` | A pointer to a string which specifies the name of the certificate store to open. A certificate store is a collection of certificates and their private keys, typically organized by how they are used. If this value is NULL or points to an empty string, the default certificate store "MY" will be used. |
| `lpszCertName` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the certificate to use. The function will first search the certificate store for a certificate with a matching "friendly name"; this is a name for the certificate that is assigned by the user. Note that the name must match completely, but the comparison is not case sensitive. If no matching certificate is found, the function will then attempt to find a certificate that has a matching common name (also called the certificate subject). This comparison is less stringent, and the first partial match will be returned. If this second search fails, the function will return an error indicating that the certificate could not be found. |
| `lpvReserved` | `LPVOID` | Pointer reserved for future use. Set it to NULL when using this function. |
| `lppCredentials` | `LPSECURITYCREDENTIALS` | Pointer to an LPSECURITYCREDENTIALS pointer. The memory for the credentials structure will be allocated by this function and must be released by calling the NntpDeleteSecurityCredentials function when it is no longer needed. The pointer value must be set to NULL before the function is called. It is important to note that this is a pointer to a pointer variable, not a pointer to the SECURITYCREDENTIALS structure itself. |

### Options

- **dwProtocol** Parameter

    - `SECURITY_PROTOCOL_DEFAULT`: The default security protocol will be used when establishing a connection. This option will always request the latest version of the preferred security protocol and is the recommended value. Currently the default security protocol is TLS 1.2.
    - `SECURITY_PROTOCOL_TLS`: Either the TLS 1.2 or 1.3 protocol should be used when establishing a secure connection. The correct protocol is automatically selected, based on what version of the protocol is supported by the server. If this is the only protocol specified, SSL will be excluded from the list of supported protocols. This may be necessary for some servers which reject any attempt to use the older SSL protocol and require that only TLS be used.
    - `SECURITY_PROTOCOL_TLS10`: The TLS 1.0 protocol should be used when establishing a secure connection. This version is supported on all Windows platforms, however some servers may reject connections using version 1.0 in favor of using version 1.2. This version should only be used for backwards compatibility with older servers that have not been updated to use the current version of TLS.
    - `SECURITY_PROTOCOL_TLS11`: The TLS 1.1 protocol should be used when establishing a secure connection. This version is supported on Windows 7 and later desktop platforms, and Windows Server 2008 R2 and later server platforms. Some servers may reject connections using version 1.1 in favor of using version 1.2. This version should only be used for backwards compatibility with older servers that have not been updated to use the current version of TLS.
    - `SECURITY_PROTOCOL_TLS12`: The TLS 1.2 protocol should be used when establishing a secure connection. This version is supported on Windows 7 and later desktop platforms, and Windows Server 2008 R2 and later server platforms. This version of TLS offers the broadest compatibility with most servers.
    - `SECURITY_PROTOCOL_TLS13`: The TLS 1.3 protocol should be used when establishing a secure connection. This is the newest version of the protocol and is only supported on Windows 11, Windows Server 2022 and later versions of Windows. If this version is not supported by the operating system, TLS 1.2 will be used instead.
- **dwOptions** Parameter

    - `CREDENTIAL_STORE_CURRENT_USER`: The library will attempt to open a store for the current user using the certificate store name provided in this structure. If no options are specified, then this is the default behavior.
    - `CREDENTIAL_STORE_LOCAL_MACHINE`: The library will attempt to open a local machine store using the certificate store name provided in this structure. If this option is specified, the library will always search for a local machine store before searching for the store by that name for the current user.
    - `CREDENTIAL_STORE_FILENAME`: The certificate store name is a file that contains the certificate and private key that will be used.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call the NntpGetLastError function.

### Remarks

- The structure that is created by this function may be used as client credentials when establishing a secure connection. This is particularly useful for programming languages other than C/C++ which may not support C structures or pointers. The pointer to the SECURITYCREDENTIALS structure can be declared as an unsigned integer variable which is passed by reference to this function, and then passed by value to the NntpConnect function.
- A client application only needs to call this function if the server requires that the client provide a certificate as part of the process of negotiating the secure session. If a certificate is required, note that it must have a private key associated with it. Attempting to use a certificate that does not have a private key will result in an error during the connection process indicating that the client credentials could not be established.
- If you are using a local certificate store, with the certificate and private key stored in the registry, you can explicitly specify whether the certificate store for the current user or the local machine (all users) should be used. This is done by prefixing the certificate store name with "HKCU:" for the current user, or "HKLM:" for the local machine. For example, a certificate store name of "HKLM:MY" would specify the personal certificate store for the local machine, rather than the current user. If neither prefix is specified, then it will default to the certificate store for the current user. You can manage these certificates using the CertMgr.msc Microsoft Management Console (MMC) snap-in.
- It is possible to load the certificate from a file rather than from current user's certificate store. The dwOptions parameter should be set to CREDENTIAL_STORE_FILENAME and the lpszCertStore parameter should specify the name of the file that contains the certificate and its private key. The file must be in Private Information Exchange (PFX) format, also known as PKCS #12.These certificate files typically have an extension of .pfx or .p12. If a password was specified when the certificate was created, it must be provided in the lpszPassword parameter or the library will be unable to access the certificate.
- Note that the lpszUserName and lpszPassword parameters are values which are used to access the certificate store or client certificate. They are not the credentials which are used when establishing the connection with the remote host or authenticating the client session. In most cases, these parameters will be NULL.

### Example

```cpp
LPSECURITYCREDENTIALS lpSecCred = NULL;
NntpCreateSecurityCredentials(SECURITY_PROTOCOL_DEFAULT,
							0,
							NULL,
							NULL,
							lpszCertStore,
							lpszCertName,
							NULL,
							&lpSecCred);

hClient = NntpConnect(lpszHostName,
					NNTP_PORT_SECURE,
					NNTP_TIMEOUT,
					NNTP_OPTION_SECURE,
					lpSecCred);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpConnect](#nntpconnect-function)
- [NntpDeleteSecurityCredentials](#nntpdeletesecuritycredentials-function)
- [NntpGetSecurityInformation](#nntpgetsecurityinformation-function)
- [SECURITYCREDENTIALS](#securitycredentials-function)

---

## NntpDeleteSecurityCredentials Function

Delete a previously created security credentials structure

### Prototype

```c
VOID WINAPI NntpDeleteSecurityCredentials(
    LPSECURITYCREDENTIALS lppCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lppCredentials` | `LPSECURITYCREDENTIALS` | Pointer to an LPSECURITYCREDENTIALS pointer. On exit from the function, the pointer will be NULL. |

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- This function can be used to release the memory allocated to the client or server credentials after a secure connection has been terminated.

### Example

```cpp
if (lpSecCred)
	NntpDeleteSecurityCredentials(&lpSecCred);

NntpUninitialize();
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpCreateSecurityCredentials](#nntpcreatesecuritycredentials-function)
- [NntpUninitialize](#nntpuninitialize-function)

---

## NntpDisableEvents Function

Disable asynchronous event notification

### Prototype

```c
INT WINAPI NntpDisableEvents(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- This function affects both event notification and event callbacks. Any outstanding events in the message queue should be ignored by the client application.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpEnableEvents](#nntpenableevents-function)
- [NntpFreezeEvents](#nntpfreezeevents-function)
- [NntpRegisterEvent](#nntpregisterevent-function)

---

## NntpDisableTrace Function

Disable logging of network function calls to the trace log

### Prototype

```c
BOOL WINAPI NntpDisableTrace();
```

### Parameters

| Name | Type | Description |
|------|------|-------------|

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpEnableTrace](#nntpenabletrace-function)

---

## NntpDisconnect Function

Disconnect from the current server

### Prototype

```c
INT WINAPI NntpDisconnect(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpConnect](#nntpconnect-function)
- [NntpUninitialize](#nntpuninitialize-function)

---

## NntpEnableEvents Function

Enable asynchronous event notification

### Prototype

```c
INT WINAPI NntpEnableEvents(
    HCLIENT hClient,
    HWND hEventWnd,
    UINT uEventMsg
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `hEventWnd` | `HWND` | Handle to the event notification window. This window receives a user-defined message which specifies the event that has occurred. If this value is NULL, event notification is disabled. |
| `uEventMsg` | `UINT` | An unsigned integer which specifies the user-defined message that is sent when an event occurs. This parameter's value must be greater than the value of WM_USER. If the hEventWnd parameter is NULL, this value must be specified as WM_NULL. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- When a message is posted to the notification window, the low word of the lParam parameter contains the event identifier. The high word of lParam contains the low word of the error code, if an error has occurred. The wParam parameter contains the client handle. One or more of the following event identifiers may be sent:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpDisableEvents](#nntpdisableevents-function)
- [NntpFreezeEvents](#nntpfreezeevents-function)
- [NntpRegisterEvent](#nntpregisterevent-function)

---

## NntpEnableTrace Function

Enable logging of network function calls to a file

### Prototype

```c
BOOL WINAPI NntpEnableTrace(
    LPCTSTR lpszTraceFile,
    DWORD dwTraceFlags
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszTraceFile` | `LPCTSTR` | A pointer to a string which specifies the name of the trace log file. If this parameter is NULL or an empty string, the default file name cstrace.log is used. The file is stored in the directory specified by the TEMP environment variable, if it is defined; otherwise, the current working directory is used. |
| `dwTraceFlags` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |

### Options

- **dwTraceFlags** Parameter

    - `TRACE_INFO`: All function calls are written to the trace file. This is the default value.
    - `TRACE_ERROR`: Only those function calls which fail are recorded in the trace file.
    - `TRACE_WARNING`: Only those function calls which fail or return values which indicate a warning are recorded in the trace file.
    - `TRACE_HEXDUMP`: All functions calls are written to the trace file, plus all the data that is sent or received is displayed, in both ASCII and hexadecimal format.
    - `TRACE_PROCESS`: All function calls in the current process are logged, rather than only those functions in the current thread. This option is useful for multithreaded applications that are using worker threads.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. A return value of zero indicates an error. Failure typically indicates that the tracing library cstrcv11.dll cannot be loaded on the local system.

### Remarks

- When trace logging is enabled, the file is opened, appended to and closed for each socket function call. This makes it possible for an application to append its own logging information, however care should be taken to ensure that the file is closed before the next network operation is performed. To limit the size of the log files, enable and disable logging only around those sections of code that you wish to trace.
- Note that the TRACE_HEXDUMP trace level generates very large log files since it includes all of the data exchanged between your application and the server.
- Trace function logging is managed on a per-thread basis, not for each client handle. This means that all SocketTools libraries and components share the same settings in the current thread. If you are using multiple SocketTools libraries or components in your application, you only need to enable logging once.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpDisableTrace](#nntpdisabletrace-function)

---

## NntpEventProc Function

Callback function that processes events generated by the client

### Prototype

```c
VOID __cdecl NntpEventProc(
    HCLIENT hClient,
    UINT nEvent,
    DWORD dwError,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nEvent` | `UINT` | An unsigned integer which specifies which event occurred. For a complete list of events, refer to the NntpRegisterEvent function. |
| `dwError` | `DWORD` | An unsigned integer which specifies any error that occurred. If no error occurred, then this parameter will be zero. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value which was specified when the event callback was registered. |

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- An application must register this callback function by passing its address to the NntpRegisterEvent function. The NntpEventProc function is a placeholder for the application-defined function name.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpDisableEvents](#nntpdisableevents-function)
- [NntpEnableEvents](#nntpenableevents-function)
- [NntpFreezeEvents](#nntpfreezeevents-function)
- [NntpRegisterEvent](#nntpregisterevent-function)

---

## NntpFreezeEvents Function

Suspend asynchronous event processing

### Prototype

```c
INT WINAPI NntpFreezeEvents(
    HCLIENT hClient,
    BOOL bFreeze
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `bFreeze` | `BOOL` | A non-zero value specifies that event handling should be suspended by the client. A zero value specifies that event handling should be resumed. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- This function should be used when the application does not want to process events, such as when a modal dialog is being displayed. When events are suspended, all client events are queued. If events are re-enabled at a later point, those queued events will be sent to the application for processing. Note that only one of each event will be generated. For example, if the client has suspended event handling, and four read events occur, once event handling is resumed only one of those read events will be posted to the client. This prevents the application from being flooded by a potentially large number of queued events.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpDisableEvents](#nntpdisableevents-function)
- [NntpEnableEvents](#nntpenableevents-function)
- [NntpRegisterEvent](#nntpregisterevent-function)

---

## NntpGetArticle Function

Retrieve an article from the server and store the contents in a local buffer

### Prototype

```c
INT WINAPI NntpGetArticle(
    HCLIENT hClient,
    LONG nArticleId,
    LPVOID lpvBuffer,
    LPDWORD lpdwLength,
    DWORD dwReserved
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nArticleId` | `LONG` | Number of article to retrieve from the server. This value must be greater than zero. |
| `lpvBuffer` | `LPVOID` | A pointer to a byte buffer which will contain the data transferred from the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpdwLength` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvBuffer parameter. If the lpvBuffer parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the actual length of the file that was downloaded. |
| `dwReserved` | `DWORD` | A reserved parameter. This value should always be zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetArticle function is used to retrieve an article from the server and copy it into a local buffer. The function may be used in one of two ways, depending on the needs of the application. The first method is to pre-allocate a buffer large enough to store the contents of the article. In this case, the lpvBuffer parameter will point to the buffer that was allocated, the value that the lpdwLength parameter points to should be initialized to the size of that buffer.
- The second method that can be used is have the lpvBuffer parameter point to a global memory handle which will contain the article data when the function returns. In this case, the value that the lpdwLength parameter points to must be initialized to zero. It is important to note that the memory handle returned by the function must be freed by the application, otherwise a memory leak will occur. See the example code below.
- This function will cause the current thread to block until the complete article has been retrieved, a timeout occurs or the operation is canceled. During the transfer, the NNTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling NntpEnableEvents, or by registering a callback function using the NntpRegisterEvent function.
- To determine the current status of a transfer while it is in progress, use the NntpGetTransferStatus function. If you need to retrieve an article based on its message ID rather than the article number, use the NntpGetArticleByMessageId function.
- Your application should use the NntpGetArticleEx function if the server uses 64-bit article IDs.

### Example

```cpp
HGLOBAL hgblBuffer = (HGLOBAL)NULL;
LPBYTE lpBuffer = (LPBYTE)NULL;
DWORD cbBuffer = 0;

// Return the article into block of global memory allocated by
// the GlobalAlloc function; the handle to this memory will be
// returned in the hgblBuffer parameter
nResult = NntpGetArticle(hClient,
						nArticleId,
						&hgblBuffer,
						&cbBuffer,
						0);

if (nResult != NNTP_ERROR)
{
	// Lock the global memory handle, returning a pointer to the
	// article text
	lpBuffer = (LPBYTE)GlobalLock(hgblBuffer);
	
	// After the data has been used, the handle must be unlocked
	// and freed, otherwise a memory leak will occur
	GlobalUnlock(hgblBuffer);
	GlobalFree(hgblBuffer);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpCreateArticle](#nntpcreatearticle-function)
- [NntpEnableEvents](#nntpenableevents-function)
- [NntpGetArticleEx](#nntpgetarticleex-function)
- [NntpGetArticleByMessageId](#nntpgetarticlebymessageid-function)
- [NntpGetArticleHeaders](#nntpgetarticleheaders-function)
- [NntpGetTransferStatus](#nntpgettransferstatus-function)
- [NntpRegisterEvent](#nntpregisterevent-function)

---

## NntpGetArticleByMessageId Function

Retrieve an article from the server using a message ID and store the contents in a local buffer

### Prototype

```c
INT WINAPI NntpGetArticleByMessageId(
    HCLIENT hClient,
    LPCTSTR lpszMessageId,
    LPVOID lpvBuffer,
    LPDWORD lpdwLength,
    DWORD dwReserved
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszMessageId` | `LPCTSTR` | A pointer to a string which specifies the message ID of the article that you want to retrieve. If this parameter is a NULL pointer or specifies a zero-length string, an error will be returned. |
| `lpvBuffer` | `LPVOID` | A pointer to a byte buffer which will contain the data transferred from the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpdwLength` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvBuffer parameter. If the lpvBuffer parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the actual length of the file that was downloaded. |
| `dwReserved` | `DWORD` | A reserved parameter. This value should always be zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetArticleByMessageId function is used to retrieve an article from the server and copy it into a local buffer. This function is identical to the NntpGetArticle function except that a message ID string is used to identify the article, rather than an article number. The function may be used in one of two ways, depending on the needs of the application. The first method is to pre-allocate a buffer large enough to store the contents of the article. In this case, the lpvBuffer parameter will point to the buffer that was allocated, the value that the lpdwLength parameter points to should be initialized to the size of that buffer.
- The second method that can be used is have the lpvBuffer parameter point to a global memory handle which will contain the article data when the function returns. In this case, the value that the lpdwLength parameter points to must be initialized to zero. It is important to note that the memory handle returned by the function must be freed by the application, otherwise a memory leak will occur. See the example code below.
- This function will cause the current thread to block until the complete article has been retrieved, a timeout occurs or the operation is canceled. During the transfer, the NNTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling NntpEnableEvents, or by registering a callback function using the NntpRegisterEvent function.
- To determine the current status of a transfer while it is in progress, use the NntpGetTransferStatus function.

### Example

```cpp
HGLOBAL hgblBuffer = (HGLOBAL)NULL;
LPBYTE lpBuffer = (LPBYTE)NULL;
DWORD cbBuffer = 0;

// Return the article into block of global memory allocated by
// the GlobalAlloc function; the handle to this memory will be
// returned in the hgblBuffer parameter
nResult = NntpGetArticleByMessageId(hClient,
									lpszMessageId,
									&hgblBuffer,
									&cbBuffer,
									0);

if (nResult != NNTP_ERROR)
{
	// Lock the global memory handle, returning a pointer to the
	// article text
	lpBuffer = (LPBYTE)GlobalLock(hgblBuffer);
	
	// After the data has been used, the handle must be unlocked
	// and freed, otherwise a memory leak will occur
	GlobalUnlock(hgblBuffer);
	GlobalFree(hgblBuffer);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpCreateArticle](#nntpcreatearticle-function)
- [NntpEnableEvents](#nntpenableevents-function)
- [NntpGetArticle](#nntpgetarticle-function)
- [NntpGetArticleHeaders](#nntpgetarticleheaders-function)
- [NntpGetTransferStatus](#nntpgettransferstatus-function)
- [NntpRegisterEvent](#nntpregisterevent-function)

---

## NntpGetArticleEx Function

Retrieve an article from the server with support for large article IDs

### Prototype

```c
INT WINAPI NntpGetArticleEx(
    HCLIENT hClient,
    ULONGLONG nArticleId,
    LPVOID lpvBuffer,
    LPDWORD lpdwLength,
    DWORD dwReserved
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nArticleId` | `ULONGLONG` | Number of article to retrieve from the server. |
| `lpvBuffer` | `LPVOID` | A pointer to a byte buffer which will contain the data transferred from the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpdwLength` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvBuffer parameter. If the lpvBuffer parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the actual length of the file that was downloaded. |
| `dwReserved` | `DWORD` | A reserved parameter. This value should always be zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetArticlEx function is used to retrieve an article from the server and copy it into a local buffer. This version of the function provides support for servers which use 64-bit article IDs. The function may be used in one of two ways, depending on the needs of the application. The first method is to pre-allocate a buffer large enough to store the contents of the article. In this case, the lpvBuffer parameter will point to the buffer that was allocated, the value that the lpdwLength parameter points to should be initialized to the size of that buffer.
- The second method that can be used is have the lpvBuffer parameter point to a global memory handle which will contain the article data when the function returns. In this case, the value that the lpdwLength parameter points to must be initialized to zero. It is important to note that the memory handle returned by the function must be freed by the application, otherwise a memory leak will occur. See the example code below.
- This function will cause the current thread to block until the complete article has been retrieved, a timeout occurs or the operation is canceled. During the transfer, the NNTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling NntpEnableEvents, or by registering a callback function using the NntpRegisterEvent function.
- To determine the current status of a transfer while it is in progress, use the NntpGetTransferStatusEx function. If you need to retrieve an article based on its message ID rather than the article number, use the NntpGetArticleByMessageId function.

### Example

```cpp
HGLOBAL hgblBuffer = (HGLOBAL)NULL;
LPBYTE lpBuffer = (LPBYTE)NULL;
DWORD cbBuffer = 0;

// Return the article into block of global memory allocated by
// the GlobalAlloc function; the handle to this memory will be
// returned in the hgblBuffer parameter
nResult = NntpGetArticleEx(hClient,
						nArticleId,
						&hgblBuffer,
						&cbBuffer,
						0);

if (nResult != NNTP_ERROR)
{
	// Lock the global memory handle, returning a pointer to the
	// article text
	lpBuffer = (LPBYTE)GlobalLock(hgblBuffer);
	
	// After the data has been used, the handle must be unlocked
	// and freed, otherwise a memory leak will occur
	GlobalUnlock(hgblBuffer);
	GlobalFree(hgblBuffer);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpCreateArticle](#nntpcreatearticle-function)
- [NntpEnableEvents](#nntpenableevents-function)
- [NntpGetArticleByMessageId](#nntpgetarticlebymessageid-function)
- [NntpGetArticleHeadersEx](#nntpgetarticleheadersex-function)
- [NntpGetTransferStatusEx](#nntpgettransferstatusex-function)
- [NntpRegisterEvent](#nntpregisterevent-function)

---

## NntpGetArticleHeaders Function

Return the contents of the specified article header

### Prototype

```c
INT WINAPI NntpGetArticleHeaders(
    HCLIENT hClient,
    LONG nArticleId,
    LPVOID lpvHeaders,
    LPDWORD lpdwLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nArticleId` | `LONG` | Number of article to retrieve from the server. This value must be greater than zero. |
| `lpvHeaders` | `LPVOID` | A pointer to a byte buffer which will contain the data transferred from the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpdwLength` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvHeaders parameter. If the lpvHeaders parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the actual length of the message that was downloaded. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetArticleHeaders function is used to retrieve an article header block from the server and copy it into a local buffer. The function may be used in one of two ways, depending on the needs of the application. The first method is to pre-allocate a buffer large enough to store the contents of the file. In this case, the lpvHeaders parameter will point to the buffer that was allocated, the value that the lpdwLength parameter points to should be initialized to the size of that buffer.
- The second method that can be used is have the lpvHeaders parameter point to a global memory handle which will contain the message headers when the function returns. In this case, the value that the lpdwLength parameter points to must be initialized to zero. It is important to note that the memory handle returned by the function must be freed by the application, otherwise a memory leak will occur.
- This function will cause the current thread to block until the transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the NNTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling NntpEnableEvents, or by registering a callback function using the NntpRegisterEvent function.
- Your application should use the NntpGetArticleHeadersEx function if the server uses 64-bit article IDs.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpGetArticle](#nntpgetarticle-function)
- [NntpGetArticleHeadersEx](#nntpgetarticleheadersex-function)
- [NntpGetArticleRange](#nntpgetarticlerange-function)
- [NntpListArticles](#nntplistarticles-function)
- [NntpPostArticle](#nntppostarticle-function)

---

## NntpGetArticleHeadersEx Function

Return the contents of the specified article header with support for large article IDs

### Prototype

```c
INT WINAPI NntpGetArticleHeadersEx(
    HCLIENT hClient,
    ULONGLONG nArticleId,
    LPVOID lpvHeaders,
    LPDWORD lpdwLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nArticleId` | `ULONGLONG` | Number of article to retrieve from the server. |
| `lpvHeaders` | `LPVOID` | A pointer to a byte buffer which will contain the data transferred from the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpdwLength` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvHeaders parameter. If the lpvHeaders parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the actual length of the message that was downloaded. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetArticleHeadersEx function is used to retrieve an article header block from the server and copy it into a local buffer. This function provides support for servers which use 64-bit article IDs. The function may be used in one of two ways, depending on the needs of the application. The first method is to pre-allocate a buffer large enough to store the contents of the file. In this case, the lpvHeaders parameter will point to the buffer that was allocated, the value that the lpdwLength parameter points to should be initialized to the size of that buffer.
- The second method that can be used is have the lpvHeaders parameter point to a global memory handle which will contain the message headers when the function returns. In this case, the value that the lpdwLength parameter points to must be initialized to zero. It is important to note that the memory handle returned by the function must be freed by the application, otherwise a memory leak will occur.
- This function will cause the current thread to block until the transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the NNTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling NntpEnableEvents, or by registering a callback function using the NntpRegisterEvent function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpGetArticle](#nntpgetarticle-function)
- [NntpGetArticleRangeEx](#nntpgetarticlerangeex-function)
- [NntpListArticlesEx](#nntplistarticlesex-function)
- [NntpPostArticle](#nntppostarticle-function)

---

## NntpGetArticleMessageId Function

Return the message identifier for the specified article

### Prototype

```c
INT WINAPI NntpGetArticleMessageId(
    HCLIENT hClient,
    LONG nArticleId,
    LPTSTR lpszMessageId,
    INT cbMessageId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nArticleId` | `LONG` | Article number to retrieve the message identifier for. The value may be zero, in which case the current article number is used. |
| `lpszMessageId` | `LPTSTR` | Pointer to a string buffer which will contain the message identifier for the specified article. |
| `cbMessageId` | `INT` | Maximum number of characters that may be copied into the buffer, including the terminating null character. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the message identifier string. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The message identifier is a string which can uniquely identify the message on the news server. This value may be used to retrieve the contents of the article. Your application should use the NntpGetArticleMessageIdEx function if the server uses 64-bit article IDs.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetArticleMessageIdEx](#nntpgetarticlemessageidex-function)
- [NntpGetMessageIdArticle](#nntpgetmessageidarticle-function)
- [NntpListArticles](#nntplistarticles-function)

---

## NntpGetArticleMessageIdEx Function

Return the message identifier for the specified article with support for large article IDs

### Prototype

```c
INT WINAPI NntpGetArticleMessageIdEx(
    HCLIENT hClient,
    ULONGLONG nArticleId,
    LPTSTR lpszMessageId,
    INT cbMessageId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nArticleId` | `ULONGLONG` | Article number to retrieve the message identifier for. The value may be zero, in which case the current article number is used. |
| `lpszMessageId` | `LPTSTR` | Pointer to a string buffer which will contain the message identifier for the specified article. |
| `cbMessageId` | `INT` | Maximum number of characters that may be copied into the buffer, including the terminating null character. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the message identifier string. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The message identifier is a string which can uniquely identify the message on the news server. This value may be used to retrieve the contents of the article. This function provides support for servers which use 64-bit article IDs.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetMessageIdArticleEx](#nntpgetmessageidarticleex-function)
- [NntpListArticlesEx](#nntplistarticlesex-function)

---

## NntpGetArticleRange Function

Return the first and last article number for the current group

### Prototype

```c
LONG WINAPI NntpGetArticleRange(
    HCLIENT hClient,
    LPLONG lpnFirstArticle,
    LPLONG lpnLastArticle
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpnFirstArticle` | `LPLONG` | Pointer to a long integer that will contain the first article number in the currently selected newsgroup. If this parameter is NULL, it will be ignored. |
| `lpnLastArticle` | `LPLONG` | Pointer to a long integer that will contain the last article number in the currently selected newsgroup. If this parameter is NULL, it will be ignored. |

### Return Value

- **Type**: `LONG`
- If the function succeeds, the return value is number of articles in the selected newsgroup. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- It is possible that there will be gaps in the articles within the range of the first and last articles in the newsgroup. This may be due to a message being canceled or expired. If the server uses 64-bit article IDs, your application should use the NntpGetArticleRangeEx function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpGetArticleRangeEx](#nntpgetarticlerangeex-function)
- [NntpOpenArticle](#nntpopenarticle-function)
- [NntpOpenArticleByMessageId](#nntpopenarticlebymessageid-function)
- [NntpListArticles](#nntplistarticles-function)

---

## NntpGetArticleRangeEx Function

Return the first and last article number for the current group with support for large article IDs

### Prototype

```c
BOOL WINAPI NntpGetArticleRangeEx(
    HCLIENT hClient,
    ULONGLONG lpnFirstArticle,
    ULONGLONG lpnLastArticle,
    ULONGLONG lpnArticleCount
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpnFirstArticle` | `ULONGLONG` | Pointer to an unsigned 64-bit integer that will contain the first article number in the currently selected newsgroup. If this parameter is NULL, it will be ignored. |
| `lpnLastArticle` | `ULONGLONG` | Pointer to an unsigned 64-bit integer that will contain the last article number in the currently selected newsgroup. If this parameter is NULL, it will be ignored. |
| `lpnArticleCount` | `ULONGLONG` | Pointer to an unsigned 64-bit integer that will contain the total number of articles in the selected newsgroup. If this parameter is NULL, it will be ignored. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value will be non-zero. If the function fails, the return value is zero. To get extended error information, call NntpGetLastError.

### Remarks

- It is possible that there will be gaps in the articles within the range of the first and last articles in the newsgroup. This may be due to a message being canceled or expired. This function provides support for servers which use 64-bit article IDs.
- The NntpGetArticleRangeEx function returns a BOOL (a signed 32-bit integer) to indicate success or failure, and the article count is returned in a variable that is passed by reference to the function. If you are updating your code to use this function, make sure you also change how you check the return value.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpOpenArticleEx](#nntpopenarticleex-function)
- [NntpOpenArticleByMessageId](#nntpopenarticlebymessageid-function)
- [NntpListArticlesEx](#nntplistarticlesex-function)

---

## NntpGetArticleSize Function

Return the size of the specified news article in bytes

### Prototype

```c
DWORD WINAPI NntpGetArticleSize(
    HCLIENT hClient,
    LONG nArticleId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nArticleId` | `LONG` | An integer value that identifies the article. The value may be zero, in which case the current article number is used. |

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is the size of the article in bytes. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetArticleSize function sends the XOVER command to the server to request the size of the specified article. If the server uses 64-bit article IDs, your application should use the NntpGetArticleSizeEx function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpGetArticleSizeEx](#nntpgetarticlesizeex-function)
- [NntpOpenArticle](#nntpopenarticle-function)
- [NntpOpenArticleByMessageId](#nntpopenarticlebymessageid-function)
- [NntpListArticles](#nntplistarticles-function)

---

## NntpGetArticleSizeEx Function

Return the size of the specified article with support for large article IDs

### Prototype

```c
DWORD WINAPI NntpGetArticleSizeEx(
    HCLIENT hClient,
    ULONGLONG nArticleId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nArticleId` | `ULONGLONG` | An unsigned 64-bit integer value that identifies the article. The value may be zero, in which case the current article number is used. |

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is the size of the article in bytes. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetArticleSizeEx function sends the XOVER command to the server to request the size of the specified article. This function provides support for servers which use 64-bit article IDs.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpOpenArticleEx](#nntpopenarticleex-function)
- [NntpOpenArticleByMessageId](#nntpopenarticlebymessageid-function)
- [NntpListArticlesEx](#nntplistarticlesex-function)

---

## NntpGetCurrentArticle Function

Return the current article number for the selected group

### Prototype

```c
LONG WINAPI NntpGetCurrentArticle(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `LONG`
- If the function succeeds, the return value is the current article number. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpOpenArticle](#nntpopenarticle-function)
- [NntpOpenArticleByMessageId](#nntpopenarticlebymessageid-function)
- [NntpGetArticleRange](#nntpgetarticlerange-function)
- [NntpGetFirstArticle](#nntpgetfirstarticle-function)
- [NntpGetNextArticle](#nntpgetnextarticle-function)
- [NntpListArticles](#nntplistarticles-function)

---

## NntpGetCurrentArticleEx Function

Return the current article number for the selected group with support for large article IDs

### Prototype

```c
BOOL WINAPI NntpGetCurrentArticleEx(
    HCLIENT hClient,
    ULONGLONG lpnArticleId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpnArticleId` | `ULONGLONG` | Pointer to an unsigned 64-bit integer that will contain the current article number in the selected newsgroup. This parameter cannot be NULL. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetCurrentArticleEx function returns a BOOL (a signed 32-bit integer) to indicate success or failure, and the article ID is returned in a variable that is passed by reference to the function. This function provides support for servers which use 64-bit article IDs. If you are updating your code to use this function, make sure you also change how you check the return value.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpOpenArticleEx](#nntpopenarticleex-function)
- [NntpOpenArticleByMessageId](#nntpopenarticlebymessageid-function)
- [NntpGetArticleRangeEx](#nntpgetarticlerangeex-function)
- [NntpGetFirstArticleEx](#nntpgetfirstarticleex-function)
- [NntpGetNextArticleEx](#nntpgetnextarticleex-function)
- [NntpListArticlesEx](#nntplistarticlesex-function)

---

## NntpGetCurrentDate Function

Return the current date and time

### Prototype

```c
INT WINAPI NntpGetCurrentDate(
    LPTSTR lpszDate,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszDate` | `LPTSTR` | Pointer to a string buffer that will contain the current date and time when the function returns. |
| `nMaxLength` | `INT` | The maximum number of characters that can be copied into the string buffer. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the buffer, not including the null-terminator. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The date value that is returned is adjusted for the local timezone.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpCreateArticle](#nntpcreatearticle-function)

---

## NntpGetErrorString Function

Return a description for the specified error code

### Prototype

```c
INT WINAPI NntpGetErrorString(
    DWORD dwErrorCode,
    LPTSTR lpszDescription,
    INT cbDescription
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `dwErrorCode` | `DWORD` | The error code for which a description is returned. |
| `lpszDescription` | `LPTSTR` | A pointer to the buffer that will contain a description of the specified error code. This buffer should be at least 128 characters in length. |
| `cbDescription` | `INT` | The maximum number of characters that may be copied into the description buffer. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the description string. If the function fails, the return value is zero, meaning that no description exists for the specified error code. Typically this indicates that the error code passed to the function is invalid.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetLastError](#nntpgetlasterror-function)
- [NntpSetLastError](#nntpsetlasterror-function)

---

## NntpGetFirstArticle Function

Return the first available article in the currently selected newsgroup

### Prototype

```c
BOOL WINAPI NntpGetFirstArticle(
    HCLIENT hClient,
    LPNEWSARTICLE lpArticle
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpArticle` | `LPNEWSARTICLE` | A pointer to a NEWSARTICLE structure which will contain information about the first article in the currently selected directory. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If there are no articles in the current newsgroup, or the function fails, the return value is zero. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetFirstArticle function returns information about the first article in the currently selected newsgroup. This function is used in conjunction with the NntpGetNextArticle function to enumerate all of the articles in the newsgroup. Typically this is used to provide the user with a list of articles to access.
- While the articles in the newsgroup are being listed, the client cannot retrieve the contents of a specific article. For example, the NntpGetArticle function cannot be called while inside a loop calling NntpGetNextArticle. The client should store those articles which it wants to retrieve in an array, and then once all of the articles have been listed, it can begin calling NttpGetArticle for each article number to retrieve the article text.
- The date and time that the article was posted is returned in the stPosted member of the NEWSARTICLE structure. This value is returned in Universal Coordinated Time (UTC) and can be converted to local time using the SystemTimeToTzSpecificLocalTime function.
- If the server uses 64-bit article IDs, your application should use the NntpGetFirstArticleEx and NntpGetNextArticleEx functions.

### Example

```cpp
NEWSARTICLE newsArticle;
BOOL bResult;
INT nResult;

// List all articles in the current group
nResult = NntpListArticles(hClient, -1L, -1L);

if (nResult == NNTP_ERROR)
{
	TCHAR szError[ASTRING];
	DWORD dwError = NntpGetLastError();

	NntpGetErrorString(dwError, szError, ASTRING);
	_ftprintf(stderr, _T("Error %08x: %s\n"), dwError, szError);
	return;
}

// Get each article in the current newsgroup, printing the article
// number and the subject of the article
bResult = NntpGetFirstArticle(hClient, &newsArticle);

while (bResult)
{
	_tprintf(_T("%ld %s\n"), newsArticle.nArticleId, newsArticle.szSubject);
	bResult = NntpGetNextArticle(hClient, &newsArticle);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetArticle](#nntpgetarticle-function)
- [NntpGetFirstArticleEx](#nntpgetfirstarticleex-function)
- [NntpGetFirstGroup](#nntpgetfirstgroup-function)
- [NntpGetNextArticle](#nntpgetnextarticle-function)
- [NntpGetNextGroup](#nntpgetnextgroup-function)
- [NntpGetNextGroupEx](#nntpgetnextgroupex-function)
- [NntpListArticles](#nntplistarticles-function)
- [NntpListGroups](#nntplistgroups-function)
- [NntpListNewGroups](#nntplistnewgroups-function)
- [NntpSelectGroup](#nntpselectgroup-function)
- [NEWSARTICLE](#newsarticle-function)
- [NEWSGROUP](#newsgroup-function)

---

## NntpGetFirstArticleEx Function

Return the first available article in the currently selected newsgroup with support for large article IDs

### Prototype

```c
BOOL WINAPI NntpGetFirstArticleEx(
    HCLIENT hClient,
    LPNEWSARTICLEEX lpArticleEx
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpArticleEx` | `LPNEWSARTICLEEX` | A pointer to a NEWSARTICLEEX structure which will contain information about the first article in the currently selected directory. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If there are no articles in the current newsgroup, or the function fails, the return value is zero. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetFirstArticleEx function returns information about the first article in the currently selected newsgroup. This function is used in conjunction with the NntpGetNextArticleEx function to enumerate all of the articles in the newsgroup. Typically this is used to provide the user with a list of articles to access. This function provides support for servers which use 64-bit article IDs.
- While the articles in the newsgroup are being listed, the client cannot retrieve the contents of a specific article. For example, the NntpGetArticleEx function cannot be called while inside a loop calling NntpGetNextArticleEx. The client should store those articles which it wants to retrieve in an array, and then once all of the articles have been listed, it can begin calling NttpGetArticleEx for each article number to retrieve the article text.
- The date and time that the article was posted is returned in the stPosted member of the NEWSARTICLE structure. This value is returned in Universal Coordinated Time (UTC) and can be converted to local time using the SystemTimeToTzSpecificLocalTime function.

### Example

```cpp
NEWSARTICLEEX newsArticle;
BOOL bResult;
INT nResult;

// List all articles in the current group
nResult = NntpListArticlesEx(hClient, (ULONGLONG)-1, (ULONGLONG)-1);

if (nResult == NNTP_ERROR)
{
	TCHAR szError[ASTRING];
	DWORD dwError = NntpGetLastError();

	NntpGetErrorString(dwError, szError, ASTRING);
	_ftprintf(stderr, _T("Error %08x: %s\n"), dwError, szError);
	return;
}

// Get each article in the current newsgroup, printing the article
// number and the subject of the article
bResult = NntpGetFirstArticleEx(hClient, &newsArticle);

while (bResult)
{
	_tprintf(_T("%I64u %s\n"), newsArticle.nArticleId, newsArticle.szSubject);
	bResult = NntpGetNextArticleEx(hClient, &newsArticle);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetArticleEx](#nntpgetarticleex-function)
- [NntpGetFirstGroupEx](#nntpgetfirstgroupex-function)
- [NntpGetNextArticleEx](#nntpgetnextarticleex-function)
- [NntpGetNextGroupEx](#nntpgetnextgroupex-function)
- [NntpListArticlesEx](#nntplistarticlesex-function)
- [NntpListGroups](#nntplistgroups-function)
- [NntpListNewGroups](#nntplistnewgroups-function)
- [NntpSelectGroup](#nntpselectgroup-function)
- [NEWSARTICLEEX](#newsarticleex-function)
- [NEWSGROUPEX](#newsgroupex-function)

---

## NntpGetFirstGroup Function

Return the first available newsgroup from the server

### Prototype

```c
BOOL WINAPI NntpGetFirstGroup(
    HCLIENT hClient,
    LPNEWSGROUP lpGroup
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpGroup` | `LPNEWSGROUP` | A pointer to a NEWSGROUP structure which will contain information about the first available newsgroup. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If there are no newsgroups available, or the function fails, the return value is zero. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetFirstGroup function returns information about the first newsgroup on the server. This function is used in conjunction with the NntpGetNextGroup function to enumerate all of the available newsgroups. Typically this is used to provide the user with a list of newsgroups to select.
- While the the newsgroups are being listed, the client cannot select a newsgroup or retrieve the contents of a specific article. The client should store those newsgroups which it wants to retrieve articles from, and then once all of the newsgroups have been listed, it can then select each newsgroup and retrieve the available articles from that group.
- Note that if no newsgroups are returned by the server, it may indicate that it requires the client to authenticate itself prior to requesting a list of groups or articles.
- If the server uses 64-bit article IDs, your application should use the NntpGetFirstGroupEx and NntpGetNextGroupEx functions.

### Example

```cpp
NEWSGROUP newsGroup;
BOOL bResult;
INT nResult;

// List all available newsgroups
nResult = NntpListGroups(hClient);

if (nResult == NNTP_ERROR)
{
	TCHAR szError[ASTRING];
	DWORD dwError = NntpGetLastError();

	NntpGetErrorString(dwError, szError, ASTRING);
	_ftprintf(stderr, _T("Error %08x: %s\n"), dwError, szError);
	return;
}

// Get each newsgroup, printing the article range and
// the name of the group
bResult = NntpGetFirstGroup(hClient, &newsGroup);

while (bResult)
{
	_tprintf(_T("%ld %ld %s\n"), newsGroup.nFirstArticle,
								newsGroup.nLastArticle,
								newsGroup.szName);

	bResult = NntpGetNextGroup(hClient, &newsGroup);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetFirstArticle](#nntpgetfirstarticle-function)
- [NntpGetFirstGroupEx](#nntpgetfirstgroupex-function)
- [NntpGetNextArticle](#nntpgetnextarticle-function)
- [NntpGetNextGroup](#nntpgetnextgroup-function)
- [NntpGetNextGroupEx](#nntpgetnextgroupex-function)
- [NntpListArticles](#nntplistarticles-function)
- [NntpListGroups](#nntplistgroups-function)
- [NntpListNewGroups](#nntplistnewgroups-function)
- [NntpSelectGroup](#nntpselectgroup-function)
- [NEWSARTICLE](#newsarticle-function)
- [NEWSGROUP](#newsgroup-function)

---

## NntpGetFirstGroupEx Function

Return the first available newsgroup from the server with support for large article IDs

### Prototype

```c
BOOL WINAPI NntpGetFirstGroupEx(
    HCLIENT hClient,
    LPNEWSGROUPEX lpGroupEx
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpGroupEx` | `LPNEWSGROUPEX` | A pointer to a NEWSGROUPEX structure which will contain information about the first available newsgroup. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If there are no newsgroups available, or the function fails, the return value is zero. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetFirstGroupEx function returns information about the first newsgroup on the server. This function is used in conjunction with the NntpGetNextGroupEx function to enumerate all of the available newsgroups. Typically this is used to provide the user with a list of newsgroups to select. This function provides support for servers which use 64-bit article IDs.
- While the the newsgroups are being listed, the client cannot select a newsgroup or retrieve the contents of a specific article. The client should store those newsgroups which it wants to retrieve articles from, and then once all of the newsgroups have been listed, it can then select each newsgroup and retrieve the available articles from that group.
- Note that if no newsgroups are returned by the server, it may indicate that it requires the client to authenticate itself prior to requesting a list of groups or articles.

### Example

```cpp
NEWSGROUPEX newsGroup;
BOOL bResult;
INT nResult;

// List all available newsgroups
nResult = NntpListGroups(hClient);

if (nResult == NNTP_ERROR)
{
	TCHAR szError[ASTRING];
	DWORD dwError = NntpGetLastError();
	NntpGetErrorString(dwError, szError, ASTRING);
	fprintf(stderr, "Error %08x: %s\n", dwError, szError);
	return;
}

// Get each newsgroup, printing the article range and
// the name of the group
bResult = NntpGetFirstGroupEx(hClient, &newsGroup);
while (bResult)
{
	printf("%I64u %I64u %s\n", newsGroup.nFirstArticle,
							newsGroup.nLastArticle,
							newsGroup.szName);

	bResult = NntpGetNextGroupEx(hClient, &newsGroup);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetFirstArticleEx](#nntpgetfirstarticleex-function)
- [NntpGetNextArticleEx](#nntpgetnextarticleex-function)
- [NntpGetNextGroupEx](#nntpgetnextgroupex-function)
- [NntpListArticlesEx](#nntplistarticlesex-function)
- [NntpListGroups](#nntplistgroups-function)
- [NntpListNewGroups](#nntplistnewgroups-function)
- [NntpSelectGroup](#nntpselectgroup-function)
- [NEWSARTICLEEX](#newsarticleex-function)
- [NEWSGROUPEX](#newsgroupex-function)

---

## NntpGetGroupName Function

Return the name of the currently selected newsgroup

### Prototype

```c
INT WINAPI NntpGetGroupName(
    HCLIENT hClient,
    LPTSTR lpszGroupName,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszGroupName` | `LPTSTR` | Pointer to a string buffer that will contain the name of the currently selected newsgroup. |
| `nMaxLength` | `INT` | The maximum number of characters that may be copied into the buffer, including the terminating null character. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the newsgroup name. If no newsgroup has been selected, the function will return a value of zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetGroupTitle](#nntpgetgrouptitle-function)
- [NntpListGroups](#nntplistgroups-function)
- [NntpListNewGroups](#nntplistnewgroups-function)
- [NntpSelectGroup](#nntpselectgroup-function)

---

## NntpGetGroupTitle Function

Return a description of the currently selected newsgroup

### Prototype

```c
INT WINAPI NntpGetGroupTitle(
    HCLIENT hClient,
    LPTSTR lpszGroupTitle,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszGroupTitle` | `LPTSTR` | Pointer to a string buffer that will contain a description of the currently selected newsgroup. |
| `nMaxLength` | `INT` | The maximum number of characters that may be copied into the buffer, including the terminating null character. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the description. If no newsgroup has been selected, the function will return a value of zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The news server must support the XGTITLE command so that the group description can be obtained when the newsgroup is selected. If this command is not recognized, then no description will be returned.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetGroupName](#nntpgetgroupname-function)
- [NntpListGroups](#nntplistgroups-function)
- [NntpListNewGroups](#nntplistnewgroups-function)
- [NntpSelectGroup](#nntpselectgroup-function)

---

## NntpGetLastError Function

Return the last error code

### Prototype

```c
DWORD WINAPI NntpGetLastError();
```

### Parameters

| Name | Type | Description |
|------|------|-------------|

### Return Value

- **Type**: `DWORD`
- The return value is the last error code value for the current thread. Functions set this value by calling the NntpSetLastError function. The Return Value section of each reference page notes the conditions under which the function sets the last error code.

### Remarks

- Error codes are unsigned 32-bit values which are private to each calling thread. You should call the NntpGetLastError function immediately when a function's return value indicates that an error has occurred. That is because some functions call NntpSetLastError(0) when they succeed, clearing the error code set by the most recently failed function.
- Most functions will set the last error code value when they fail; a few functions set it when they succeed. Function failure is typically indicated by a return value such as FALSE, NULL, INVALID_CLIENT or NNTP_ERROR. Those functions which call NntpSetLastError when they succeed are noted on the function reference page.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpGetErrorString](#nntpgeterrorstring-function)
- [NntpSetLastError](#nntpsetlasterror-function)

---

## NntpGetMessageIdArticle Function

Return the article number for the specified message identifier

### Prototype

```c
LONG WINAPI NntpGetMessageIdArticle(
    HCLIENT hClient,
    LPCTSTR lpszMessageId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszMessageId` | `LPCTSTR` | A pointer to a message identifier string. |

### Return Value

- **Type**: `LONG`
- If the function succeeds, the return value is the article number. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- If the server uses 64-bit article IDs, your application should use the NntpGetMessageIdArticleEx function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetMessageIdArticleEx](#nntpgetmessageidarticleex-function)
- [NntpGetArticleMessageId](#nntpgetarticlemessageid-function)
- [NntpListArticles](#nntplistarticles-function)

---

## NntpGetMessageIdArticleEx Function

Return the article number for the specified message with support for large article IDs

### Prototype

```c
BOOL WINAPI NntpGetMessageIdArticleEx(
    HCLIENT hClient,
    LPCTSTR lpszMessageId,
    ULONGLONG lpnArticleId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszMessageId` | `LPCTSTR` | A pointer to a message identifier string. |
| `lpnArticleId` | `ULONGLONG` | A pointer to an unsigned 64-bit integer which will contain the article ID. This parameter cannot be NULL. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value non-zero. If the function fails, the return value is zero. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetMessageIdArticleEx function returns a BOOL (a signed 32-bit integer) to indicate success or failure, and the article count is returned in a variable that is passed by reference to the function. If you are updating your code to use this function, make sure you also change how you check the return value.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetArticleMessageIdEx](#nntpgetarticlemessageidex-function)
- [NntpListArticlesEx](#nntplistarticlesex-function)

---

## NntpGetMultiLine Function

Return the client multi-line output flag

### Prototype

```c
INT WINAPI NntpGetMultiLine(
    HCLIENT hClient,
    LPBOOL lpbMultiLine
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpbMultiLine` | `LPBOOL` | A pointer to a boolean variable. This variable will be set to the current value of the client's internal multi-line flag. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The multi-line flag is used by the library to determine if multiple lines of data will be returned by the server as the result of a command. Unlike a single line response, which consists of a result code and result string, a multi-line response consists of one or more lines of text, terminated by a special end-of-data marker.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpCommand](#nntpcommand-function)
- [NntpGetResultCode](#nntpgetresultcode-function)
- [NntpGetResultString](#nntpgetresultstring-function)
- [NntpSetMultiLine](#nntpsetmultiline-function)

---

## NntpGetNextArticle Function

Return the next available article from the current newsgroup

### Prototype

```c
BOOL WINAPI NntpGetNextArticle(
    HCLIENT hClient,
    LPNEWSARTICLE lpArticle
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpArticle` | `LPNEWSARTICLE` | A pointer to a NEWSARTICLE structure which will contain information about the next available article in the currently selected directory. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If there are no more articles in the current newsgroup, or the function fails, the return value is zero. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetNextArticle function returns information about the next available article in the currently selected newsgroup. This function is used in conjunction with the NntpGetFirstArticle function to enumerate all of the articles in the newsgroup. Typically this is used to provide the user with a list of articles to access.
- While the articles in the newsgroup are being listed, the client cannot retrieve the contents of a specific article. For example, the NntpGetArticle function cannot be called while inside a loop calling NntpGetNextArticle. The client should store those articles which it wants to retrieve in an array, and then once all of the articles have been listed, it can begin calling NttpGetArticle for each article number to retrieve the article text.
- If the server uses 64-bit article IDs, your application should use the NntpGetFirstArticleEx and NntpGetNextArticleEx functions.

### Example

```cpp
NEWSARTICLE newsArticle;
BOOL bResult;
INT nResult;

// List all articles in the current group
nResult = NntpListArticles(hClient, -1L, -1L);

if (nResult == NNTP_ERROR)
{
	TCHAR szError[ASTRING];
	DWORD dwError = NntpGetLastError();

	NntpGetErrorString(dwError, szError, ASTRING);
	_ftprintf(stderr, _T("Error %08x: %s\n"), dwError, szError);
	return;
}

// Get each article in the current newsgroup, printing the article
// number and the subject of the article
bResult = NntpGetNextArticle(hClient, &newsArticle);

while (bResult)
{
	_tprintf(_T("%ld %s\n"), newsArticle.nArticleId, newsArticle.szSubject);
	bResult = NntpGetNextArticle(hClient, &newsArticle);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetArticle](#nntpgetarticle-function)
- [NntpGetFirstArticle](#nntpgetfirstarticle-function)
- [NntpGetFirstArticleEx](#nntpgetfirstarticleex-function)
- [NntpGetFirstGroup](#nntpgetfirstgroup-function)
- [NntpGetNextArticleEx](#nntpgetnextarticleex-function)
- [NntpGetNextGroup](#nntpgetnextgroup-function)
- [NntpListArticles](#nntplistarticles-function)
- [NntpListGroups](#nntplistgroups-function)
- [NntpListNewGroups](#nntplistnewgroups-function)
- [NntpSelectGroup](#nntpselectgroup-function)
- [NEWSARTICLE](#newsarticle-function)
- [NEWSGROUP](#newsgroup-function)

---

## NntpGetNextArticleEx Function

Return the next available article from the current newsgroup with support for large article IDs

### Prototype

```c
BOOL WINAPI NntpGetNextArticleEx(
    HCLIENT hClient,
    LPNEWSARTICLEEX lpArticle
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpArticle` | `LPNEWSARTICLEEX` | A pointer to a NEWSARTICLEEX structure which will contain information about the next available article in the currently selected directory. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If there are no more articles in the current newsgroup, or the function fails, the return value is zero. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetNextArticleEx function returns information about the next available article in the currently selected newsgroup. This function is used in conjunction with the NntpGetFirstArticleEx function to enumerate all of the articles in the newsgroup. Typically this is used to provide the user with a list of articles to access. This function provides support for servers which use 64-bit article IDs.
- While the articles in the newsgroup are being listed, the client cannot retrieve the contents of a specific article. For example, the NntpGetArticleEx function cannot be called while inside a loop calling NntpGetNextArticleEx. The client should store those articles which it wants to retrieve in an array, and then once all of the articles have been listed, it can begin calling NttpGetArticleEx for each article number to retrieve the article text.

### Example

```cpp
NEWSARTICLEEX newsArticle;
BOOL bResult;
INT nResult;

// List all articles in the current group
nResult = NntpListArticlesEx(hClient, (ULONGLONG)-1, (ULONGLONG)-1);

if (nResult == NNTP_ERROR)
{
	TCHAR szError[ASTRING];
	DWORD dwError = NntpGetLastError();

	NntpGetErrorString(dwError, szError, ASTRING);
	_ftprintf(stderr, _T("Error %08x: %s\n"), dwError, szError);
	return;
}

// Get each article in the current newsgroup, printing the article
// number and the subject of the article
bResult = NntpGetNextArticleEx(hClient, &newsArticle);

while (bResult)
{
	_tprintf(_T("%I64u %s\n"), newsArticle.nArticleId, newsArticle.szSubject);
	bResult = NntpGetNextArticleEx(hClient, &newsArticle);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetArticleEx](#nntpgetarticleex-function)
- [NntpGetFirstArticleEx](#nntpgetfirstarticleex-function)
- [NntpGetFirstGroupEx](#nntpgetfirstgroupex-function)
- [NntpGetNextGroupEx](#nntpgetnextgroupex-function)
- [NntpListArticlesEx](#nntplistarticlesex-function)
- [NntpListGroups](#nntplistgroups-function)
- [NntpListNewGroups](#nntplistnewgroups-function)
- [NntpSelectGroup](#nntpselectgroup-function)
- [NEWSARTICLEEX](#newsarticleex-function)
- [NEWSGROUPEX](#newsgroupex-function)

---

## NntpGetNextGroup Function

Return the next available newsgroup from the server

### Prototype

```c
BOOL WINAPI NntpGetNextGroup(
    HCLIENT hClient,
    LPNEWSGROUP lpGroup
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpGroup` | `LPNEWSGROUP` | A pointer to a NEWSGROUP structure which will contain information about the next available newsgroup. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If there are no more newsgroups available, or the function fails, the return value is zero. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetNextGroup function returns information about the next newsgroup on the server. This function is used in conjunction with the NntpGetFirstGroup function to enumerate all of the available newsgroups. Typically this is used to provide the user with a list of newsgroups to select.
- While the the newsgroups are being listed, the client cannot select a newsgroup or retrieve the contents of a specific article. The client should store those newsgroups which it wants to retrieve articles from, and then once all of the newsgroups have been listed, it can then select each newsgroup and retrieve the available articles from that group.
- If the server uses 64-bit article IDs, your application should use the NntpGetFirstGroupEx and NntpGetNextGroupEx functions.

### Example

```cpp
NEWSGROUP newsGroup;
BOOL bResult;
INT nResult;

// List all available newsgroups
nResult = NntpListGroups(hClient);

if (nResult == NNTP_ERROR)
{
	TCHAR szError[ASTRING];
	DWORD dwError = NntpGetLastError();

	NntpGetErrorString(dwError, szError, ASTRING);
	_ftprintf(stderr, _T("Error %08x: %s\n"), dwError, szError);
	return;
}

// Get each newsgroup, printing the article range and
// the name of the group
bResult = NntpGetFirstGroup(hClient, &newsGroup);

while (bResult)
{
	_tprintf(_T("%ld %ld %s\n"), newsGroup.nFirstArticle,
								newsGroup.nLastArticle,
								newsGroup.szName);

	bResult = NntpGetNextGroup(hClient, &newsGroup);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetFirstArticle](#nntpgetfirstarticle-function)
- [NntpGetFirstGroup](#nntpgetfirstgroup-function)
- [NntpGetFirstGroupEx](#nntpgetfirstgroupex-function)
- [NntpGetNextArticle](#nntpgetnextarticle-function)
- [NntpGetNextGroupEx](#nntpgetnextgroupex-function)
- [NntpListArticles](#nntplistarticles-function)
- [NntpListGroups](#nntplistgroups-function)
- [NntpListNewGroups](#nntplistnewgroups-function)
- [NntpSelectGroup](#nntpselectgroup-function)
- [NEWSARTICLE](#newsarticle-function)
- [NEWSGROUP](#newsgroup-function)

---

## NntpGetNextGroupEx Function

Return the next available newsgroup from the server with support for large article IDs

### Prototype

```c
BOOL WINAPI NntpGetNextGroupEx(
    HCLIENT hClient,
    LPNEWSGROUPEX lpGroup
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpGroup` | `LPNEWSGROUPEX` | A pointer to a NEWSGROUPEX structure which will contain information about the next available newsgroup. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If there are no more newsgroups available, or the function fails, the return value is zero. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetNextGroupEx function returns information about the next newsgroup on the server. This function is used in conjunction with the NntpGetFirstGroupEx function to enumerate all of the available newsgroups. Typically this is used to provide the user with a list of newsgroups to select. This function provides support for servers which use 64-bit article IDs.
- While the the newsgroups are being listed, the client cannot select a newsgroup or retrieve the contents of a specific article. The client should store those newsgroups which it wants to retrieve articles from, and then once all of the newsgroups have been listed, it can then select each newsgroup and retrieve the available articles from that group.

### Example

```cpp
NEWSGROUPEX newsGroup;
BOOL bResult;
INT nResult;

// List all available newsgroups
nResult = NntpListGroups(hClient);

if (nResult == NNTP_ERROR)
{
	TCHAR szError[ASTRING];
	DWORD dwError = NntpGetLastError();

	NntpGetErrorString(dwError, szError, ASTRING);
	_ftprintf(stderr, _T("Error %08x: %s\n"), dwError, szError);
	return;
}

// Get each newsgroup, printing the article range and
// the name of the group
bResult = NntpGetFirstGroupEx(hClient, &newsGroup);

while (bResult)
{
	_tprintf(_T("%I64u %I64u %s\n"), newsGroup.nFirstArticle,
									newsGroup.nLastArticle,
									newsGroup.szName);

	bResult = NntpGetNextGroup(hClient, &newsGroup);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetFirstArticle](#nntpgetfirstarticle-function)
- [NntpGetFirstGroup](#nntpgetfirstgroup-function)
- [NntpGetNextArticle](#nntpgetnextarticle-function)
- [NntpListArticles](#nntplistarticles-function)
- [NntpListGroups](#nntplistgroups-function)
- [NntpListNewGroups](#nntplistnewgroups-function)
- [NntpSelectGroup](#nntpselectgroup-function)
- [NEWSARTICLE](#newsarticle-function)
- [NEWSGROUP](#newsgroup-function)

---

## NntpGetResultCode Function

Return the result code from the previous command

### Prototype

```c
INT WINAPI NntpGetResultCode(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the result code. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- Result codes are three-digit numeric values returned by the server. They may be broken down into the following ranges:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpCommand](#nntpcommand-function)
- [NntpGetMultiLine](#nntpgetmultiline-function)
- [NntpGetResultString](#nntpgetresultstring-function)
- [NntpSetMultiLine](#nntpsetmultiline-function)

---

## NntpGetResultString Function

Return the result string from the previous command

### Prototype

```c
INT WINAPI NntpGetResultString(
    HCLIENT hClient,
    LPTSTR lpszResult,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResult` | `LPTSTR` | A pointer to the buffer that will contain the result string returned by the server. |
| `nMaxLength` | `INT` | The maximum number of characters that may be copied into the result string buffer, including the terminating null character. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the result string. If a value of zero is returned, this means that no result string was sent by the server. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetResultString function is most useful when an error occurs because the server will typically include a brief description of the cause of the error. This can then be parsed by the application or displayed to the user. The result string is updated each time the client sends a command to the server and then calls NntpGetResultCode to obtain the result code for the operation.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpCommand](#nntpcommand-function)
- [NntpGetMultiLine](#nntpgetmultiline-function)
- [NntpGetResultCode](#nntpgetresultcode-function)
- [NntpSetMultiLine](#nntpsetmultiline-function)

---

## NntpGetSecurityInformation Function

Return security information about the current client connection

### Prototype

```c
BOOL WINAPI NntpGetSecurityInformation(
    HCLIENT hClient,
    LPSECURITYINFO lpSecurityInfo
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpSecurityInfo` | `LPSECURITYINFO` | A pointer to a SECURITYINFO structure which contains information about the current client connection. The dwSize member of this structure must be initialized to the size of the structure before passing the address of the structure to this function. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call NntpGetLastError.

### Remarks

- This function is used to obtain security related information about the current client connection to the server. It can be used to determine if a secure connection has been established, what security protocol was selected, and information about the server certificate. Note that a secure connection has not been established, the dwProtocol structure member will contain the value SECURITY_PROTOCOL_NONE.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpConnect](#nntpconnect-function)
- [NntpDisconnect](#nntpdisconnect-function)
- [SECURITYINFO](#securityinfo-function)

---

## NntpGetStatus Function

Return the current client status

### Prototype

```c
INT WINAPI NntpGetStatus(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the client status code. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetStatus function returns a numeric code which identifies the current state of the client session. The following values may be returned:
- In a multithreaded application, any thread in the current process may call this function to obtain status information for the specified client session.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpIsBlocking](#nntpisblocking-function)
- [NntpIsConnected](#nntpisconnected-function)
- [NntpIsReadable](#nntpisreadable-function)
- [NntpIsWritable](#nntpiswritable-function)

---

## NntpGetTimeout Function

Return the number of seconds until an operation times out

### Prototype

```c
INT WINAPI NntpGetTimeout(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the timeout period in seconds. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The timeout value is only used with blocking client connections. A value of zero indicates that the default timeout period of 20 seconds should be used.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpSetTimeout](#nntpsettimeout-function)

---

## NntpGetTransferStatus Function

Return data transfer statistics

### Prototype

```c
INT WINAPI NntpGetTransferStatus(
    HCLIENT hClient,
    LPNNTPTRANSFERSTATUS lpStatus
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpStatus` | `LPNNTPTRANSFERSTATUS` | A pointer to an NNTPTRANSFERSTATUS structure which contains information about the status of the current article transfer. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetTransferStatus function returns information about the current data transfer, including the average number of bytes transferred per second and the estimated amount of time until the transfer completes. If no article is currently being retrieved or submitted to the server, this function will return the status of the last successful data transfer made by the client.
- In a multithreaded application, any thread in the current process may call this function to obtain status information for the specified client session.
- If the server uses 64-bit article IDs, your application should use the NntpGetTransferStatusEx function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpEnableEvents](#nntpenableevents-function)
- [NntpGetTransferStatusEx](#nntpgettransferstatusex-function)
- [NntpRegisterEvent](#nntpregisterevent-function)
- [NNTPTRANSFERSTATUS](#nntptransferstatus-function)

---

## NntpGetTransferStatusEx Function

Return data transfer statistics with support for large article IDs

### Prototype

```c
INT WINAPI NntpGetTransferStatusEx(
    HCLIENT hClient,
    LPNNTPTRANSFERSTATUSEX lpStatus
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpStatus` | `LPNNTPTRANSFERSTATUSEX` | A pointer to an NNTPTRANSFERSTATUSEX structure which contains information about the status of the current article transfer. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpGetTransferStatusEx function returns information about the current data transfer, including the average number of bytes transferred per second and the estimated amount of time until the transfer completes. This function provides support for servers which use 64-bit article IDs. If no article is currently being retrieved or submitted to the server, this function will return the status of the last successful data transfer made by the client.
- In a multithreaded application, any thread in the current process may call this function to obtain status information for the specified client session.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpEnableEvents](#nntpenableevents-function)
- [NntpRegisterEvent](#nntpregisterevent-function)
- [NNTPTRANSFERSTATUSEX](#nntptransferstatusex-function)

---

## NntpInitialize Function

Initialize the library and validate the specified license key at runtime

### Prototype

```c
BOOL WINAPI NntpInitialize(
    LPCTSTR lpszLicenseKey,
    LPINITDATA lpData
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszLicenseKey` | `LPCTSTR` | Pointer to a string that specifies the runtime license key to be validated. If this parameter is NULL, the library will validate the development license installed on the local system. |
| `lpData` | `LPINITDATA` | Pointer to an INITDATA data structure. This parameter may be NULL if the initialization data for the library is not required. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call NntpGetLastError. All other client functions will fail until a license key has been successfully validated.

### Remarks

- This must be the first function that an application calls before using any of the other functions in the library. When a NULL license key is specified, the library will only function on the development system. Before redistributing the application to an end-user, you must insure that this function is called with a valid license key.
- If the lpData argument is specified, it must point to an INITDATA structure which has been initialized by setting the dwSize member to the size of the structure. All other structure members should be set to zero. If the function is successful, then the INITDATA structure will be filled with identifying information about the library.
- Although it is only required that NntpInitialize be called once for the current process, it may be called multiple times; however, each call must be matched by a corresponding call to NntpUninitialize.
- This function dynamically loads other system libraries and allocates thread local storage. If you are calling the functions in this library from within another DLL, it is important that you do not call the NntpInitialize or NntpUninitialize functions from the DllMain function because it can result in deadlocks or access violation errors. If the DLL is linked with the C runtime library (CRT), it will automatically call the constructors and destructors for static and global C++ objects and has the same restrictions.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpConnect](#nntpconnect-function)
- [NntpDisconnect](#nntpdisconnect-function)
- [NntpUninitialize](#nntpuninitialize-function)

---

## NntpIsBlocking Function

Determine if the client is blocked, waiting for information

### Prototype

```c
BOOL WINAPI NntpIsBlocking(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `BOOL`
- If the client is performing a blocking operation, the function returns a non-zero value. If the client is not performing a blocking operation, or the client handle is invalid, the function returns zero.

### Remarks

- Because a blocking operation can allow the application to be re-entered (for example, by pressing a button while the operation is being performed), it is possible that another blocking function may be called while it is in progress. Since only one thread of execution may perform a blocking operation at any one time, an error would occur. The NntpIsBlocking function can be used to determine if the client is already blocked, and if so, take some other action (such as warning the user that they must wait for the operation to complete).

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpCancel](#nntpcancel-function)
- [NntpCommand](#nntpcommand-function)
- [NntpIsConnected](#nntpisconnected-function)
- [NntpIsReadable](#nntpisreadable-function)
- [NntpIsWritable](#nntpiswritable-function)

---

## NntpIsConnected Function

Determine if the client is connected to the server

### Prototype

```c
BOOL WINAPI NntpIsConnected(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `BOOL`
- If the client is connected to a server, the function returns a non-zero value. If the client is not connected, or the client handle is invalid, the function returns zero.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpIsBlocking](#nntpisblocking-function)
- [NntpIsReadable](#nntpisreadable-function)
- [NntpIsWritable](#nntpiswritable-function)

---

## NntpIsReadable Function

Determine if data can be read from the server

### Prototype

```c
BOOL WINAPI NntpIsReadable(
    HCLIENT hClient,
    INT nTimeout,
    LPDWORD lpdwAvail
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nTimeout` | `INT` | Timeout for server response, in seconds. A value of zero specifies that the connection should be polled without blocking the current thread. |
| `lpdwAvail` | `LPDWORD` | A pointer to an unsigned integer which will contain the number of bytes available to read. This parameter may be NULL if this information is not required. |

### Return Value

- **Type**: `BOOL`
- If the client can read data from the server within the specified timeout period, the function returns a non-zero value. If the client cannot read any data, the function returns zero.

### Remarks

- On some platforms, this value will not exceed the size of the receive buffer (typically 64K bytes). Because of differences between TCP/IP stack implementations, it is not recommended that your application exclusively depend on this value to determine the exact number of bytes available. Instead, it should be used as a general indicator that there is data available to be read.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpGetStatus](#nntpgetstatus-function)
- [NntpIsBlocking](#nntpisblocking-function)
- [NntpIsConnected](#nntpisconnected-function)
- [NntpIsWritable](#nntpiswritable-function)
- [NntpRead](#nntpread-function)

---

## NntpIsWritable Function

Determine if data can be written to the server

### Prototype

```c
BOOL WINAPI NntpIsWritable(
    HCLIENT hClient,
    INT nTimeout
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nTimeout` | `INT` | Timeout for server response, in seconds. A value of zero specifies that the connection should be polled without blocking the current thread. |

### Return Value

- **Type**: `BOOL`
- If the client can write data to the server within the specified timeout period, the function returns a non-zero value. If the client cannot write any data, the function returns zero.

### Remarks

- Although this function can be used to determine if some amount of data can be sent to the remote process it does not indicate the amount of data that can be written without blocking the client. In most cases, it is recommended that large amounts of data be broken into smaller logical blocks, typically some multiple of 512 bytes in length.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpGetStatus](#nntpgetstatus-function)
- [NntpIsBlocking](#nntpisblocking-function)
- [NntpIsConnected](#nntpisconnected-function)
- [NntpIsReadable](#nntpisreadable-function)
- [NntpWrite](#nntpwrite-function)

---

## NntpListArticles Function

Return a list of articles in the currently selected newsgroup

### Prototype

```c
INT WINAPI NntpListArticles(
    HCLIENT hClient,
    LONG nFirstArticle,
    LONG nLastArticle
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nFirstArticle` | `LONG` | The first newsgroup article to be returned in the list. If this value is -1, the list will begin with the first available article in the newsgroup. |
| `nLastArticle` | `LONG` | The last newsgroup article to be returned in the list. If the value is -1, the list will end with the last available article in the newsgroup. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- It is possible that there will be gaps in the articles within the range of the first and last articles in the newsgroup. This may be due to a message being canceled or expired. Use the NntpGetFirstArticle and NntpGetNextArticle functions to read the list of articles returned by the server.
- If the server uses 64-bit article IDs, your application should use the NntpListArticlesEx function.

### Example

```cpp
NEWSARTICLE newsArticle;
BOOL bResult;
INT nResult;

// List all articles in the current group
nResult = NntpListArticles(hClient, -1L, -1L);

if (nResult == NNTP_ERROR)
{
	TCHAR szError[ASTRING];
	DWORD dwError = NntpGetLastError();

	NntpGetErrorString(dwError, szError, ASTRING);
	_ftprintf(stderr, _T("Error %08x: %s\n"), dwError, szError);
	return;
}

// Get each article in the current newsgroup, printing the article
// number and the subject of the article
bResult = NntpGetNextArticle(hClient, &newsArticle);
while (bResult)
{
	_tprintf(_T("%ld %s\n"), newsArticle.nArticleId, newsArticle.szSubject);
	bResult = NntpGetNextArticle(hClient, &newsArticle);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpGetArticleRange](#nntpgetarticlerange-function)
- [NntpGetCurrentArticle](#nntpgetcurrentarticle-function)
- [NntpGetFirstArticle](#nntpgetfirstarticle-function)
- [NntpGetNextArticle](#nntpgetnextarticle-function)
- [NntpListGroups](#nntplistgroups-function)
- [NntpListArticlesEx](#nntplistarticlesex-function)
- [NntpListNewGroups](#nntplistnewgroups-function)

---

## NntpListArticlesEx Function

Return a list of articles in the currently selected newsgroup with support for large article IDs

### Prototype

```c
INT WINAPI NntpListArticlesEx(
    HCLIENT hClient,
    ULONGLONG nFirstArticle,
    ULONGLONG nLastArticle
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nFirstArticle` | `ULONGLONG` | The first newsgroup article to be returned in the list. If this value is -1, the list will begin with the first available article in the newsgroup. |
| `nLastArticle` | `ULONGLONG` | The last newsgroup article to be returned in the list. If the value is -1, the list will end with the last available article in the newsgroup. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- It is possible that there will be gaps in the articles within the range of the first and last articles in the newsgroup. This may be due to a message being canceled or expired. This function provides support for servers which use 64-bit article IDs. Use the NntpGetFirstArticleEx and NntpGetNextArticleEx functions to read the list of articles returned by the server.

### Example

```cpp
NEWSARTICLEEX newsArticle;
BOOL bResult;
INT nResult;

// List all articles in the current group
nResult = NntpListArticlesEx(hClient, (ULONGLONG)-1, (ULONGLONG)-1);

if (nResult == NNTP_ERROR)
{
	TCHAR szError[ASTRING];
	DWORD dwError = NntpGetLastError();

	NntpGetErrorString(dwError, szError, ASTRING);
	_ftprintf(stderr, _T("Error %08x: %s\n"), dwError, szError);
	return;
}

// Get each article in the current newsgroup, printing the article
// number and the subject of the article
bResult = NntpGetNextArticle(hClient, &newsArticle);

while (bResult)
{
	_tprintf(_T("%I64u %s\n"), newsArticle.nArticleId, newsArticle.szSubject);
	bResult = NntpGetNextArticleEx(hClient, &newsArticle);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpGetArticleRangeEx](#nntpgetarticlerangeex-function)
- [NntpGetCurrentArticleEx](#nntpgetcurrentarticleex-function)
- [NntpGetFirstArticleEx](#nntpgetfirstarticleex-function)
- [NntpGetNextArticleEx](#nntpgetnextarticleex-function)
- [NntpListGroups](#nntplistgroups-function)
- [NntpListNewGroups](#nntplistnewgroups-function)

---

## NntpListGroups Function

Return a list of newsgroups maintained by the server

### Prototype

```c
INT WINAPI NntpListGroups(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpListGroups function is used in conjunction with the NntpGetFirstGroup and NntpGetNextGroup functions to enumerate all of the available newsgroups. Typically this is used to provide the user with a list of newsgroups to select. To list only those newsgroups which have been added since a certain date, use the NntpListNewGroups function.
- While the newsgroups are being listed, the client cannot select a newsgroup or retrieve the contents of a specific article. The client should store those newsgroups which it wants to retrieve articles from, and then once all of the newsgroups have been listed, it can then select each newsgroup and retrieve the available articles from that group.

### Example

```cpp
NEWSGROUP newsGroup;
BOOL bResult;
INT nResult;

// List all available newsgroups
nResult = NntpListGroups(hClient);

if (nResult == NNTP_ERROR)
{
	TCHAR szError[ASTRING];
	DWORD dwError = NntpGetLastError();
	NntpGetErrorString(dwError, szError, ASTRING);
	fprintf(stderr, "Error %08x: %s\n", dwError, szError);
	return;
}

// Get each newsgroup, printing the article range and
// the name of the group
bResult = NntpGetFirstGroup(hClient, &newsGroup);
while (bResult)
{
	printf("%ld %ld %s\n", newsGroup.nFirstArticle,
						newsGroup.nLastArticle,
						newsGroup.szName);
	bResult = NntpGetNextGroup(hClient, &newsGroup);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpGetArticleRange](#nntpgetarticlerange-function)
- [NntpGetFirstGroup](#nntpgetfirstgroup-function)
- [NntpGetNextGroup](#nntpgetnextgroup-function)
- [NntpListNewGroups](#nntplistnewgroups-function)
- [NntpSelectGroup](#nntpselectgroup-function)

---

## NntpListNewGroups Function

Return a list of newsgroups created since a specified date

### Prototype

```c
INT WINAPI NntpListNewGroups(
    HCLIENT hClient,
    LPCTSTR lpszLastUpdated,
    BOOL bLocalTime
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLastUpdated` | `LPCTSTR` | Pointer to a string which specifies the date and time that the list of newsgroups were last retrieved from the server. This parameter may be NULL or an empty string, in which case all available newsgroups will be listed by the server. |
| `bLocalTime` | `BOOL` | A boolean value which indicates if the time specified in the lpszLastUpdated parameter is for the current timezone. If the value is non-zero, the time is assumed to be in the local timezone. If the value is zero, the time is assumed to be in Coordinated Universal Time (UTC). |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpListNewGroups function is used in conjunction with the NntpGetFirstGroup and NntpGetNextGroup functions to enumerate all of the newsgroups that were added to the server since a specific date and time. Typically this is used to provide the user with a list of updated newsgroups to select. To list all of the newsgroups available on the server, use the NntpListGroups function.
- While the newsgroups are being listed, the client cannot select a newsgroup or retrieve the contents of a specific article. The client should store those newsgroups which it wants to retrieve articles from, and then once all of the newsgroups have been listed, it can then select each newsgroup and retrieve the available articles from that group.

### Example

```cpp
NEWSGROUP newsGroup;
LPCTSTR lpszUpdated = _T("1/1/2004 12:00 AM");
BOOL bResult;
INT nResult;

// List all newsgroups that were added after a
// specific date
nResult = NntpListNewGroups(hClient, lpszUpdated, TRUE);

if (nResult == NNTP_ERROR)
{
	TCHAR szError[ASTRING];
	DWORD dwError = NntpGetLastError();
	NntpGetErrorString(dwError, szError, ASTRING);
	fprintf(stderr, "Error %08x: %s\n", dwError, szError);
	return;
}

// Get each newsgroup, printing the article range and
// the name of the group
bResult = NntpGetFirstGroup(hClient, &newsGroup);
while (bResult)
{
	printf("%ld %ld %s\n", newsGroup.nFirstArticle,
						newsGroup.nLastArticle,
						newsGroup.szName);
	bResult = NntpGetNextGroup(hClient, &newsGroup);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetArticleRange](#nntpgetarticlerange-function)
- [NntpGetFirstGroup](#nntpgetfirstgroup-function)
- [NntpGetNextGroup](#nntpgetnextgroup-function)
- [NntpListGroups](#nntplistgroups-function)
- [NntpSelectGroup](#nntpselectgroup-function)

---

## NntpOpenArticle Function

Open the specified article in the current newsgroup

### Prototype

```c
INT WINAPI NntpOpenArticle(
    HCLIENT hClient,
    LONG nArticleId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nArticleId` | `LONG` | An integer value that specifies which article in the current newsgroup to retrieve. This value may be zero, which specifies that the current article should be opened. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpOpenArticle function sends a request to begin returning the contents of the specified article. The NntpRead function is used to read the article contents after it has been opened. When the complete article has been read, the NntpCloseArticle function must be called to close the article and complete the request.
- It is recommended most applications use the NntpGetArticle function, which will retrieve the complete article in a single function call. This function is typically only used if the application needs to modify the contents of the article as it is being read. If you wish to download an article and store it in a file on the local system, use the NntpStoreArticle function.
- If the server uses 64-bit article IDs, your application should use the NntpOpenArticleEx function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpCloseArticle](#nntpclosearticle-function)
- [NntpGetArticle](#nntpgetarticle-function)
- [NntpGetArticleRange](#nntpgetarticlerange-function)
- [NntpGetCurrentArticle](#nntpgetcurrentarticle-function)
- [NntpListArticles](#nntplistarticles-function)
- [NntpOpenArticleByMessageId](#nntpopenarticlebymessageid-function)
- [NntpOpenNextArticle](#nntpopennextarticle-function)
- [NntpOpenPreviousArticle](#nntpopenpreviousarticle-function)
- [NntpRead](#nntpread-function)
- [NntpStoreArticle](#nntpstorearticle-function)

---

## NntpOpenArticleByMessageId Function

Open the specified article by message ID in the current newsgroup

### Prototype

```c
INT WINAPI NntpOpenArticleByMessageId(
    HCLIENT hClient,
    LPCTSTR lpszMessageId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszMessageId` | `LPCTSTR` | Pointer to a string which contains the message identifier for the article in the current newsgroup. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpCloseArticle](#nntpclosearticle-function)
- [NntpGetArticle](#nntpgetarticle-function)
- [NntpGetArticleRange](#nntpgetarticlerange-function)
- [NntpGetCurrentArticle](#nntpgetcurrentarticle-function)
- [NntpListArticles](#nntplistarticles-function)
- [NntpOpenArticle](#nntpopenarticle-function)
- [NntpOpenNextArticle](#nntpopennextarticle-function)
- [NntpOpenPreviousArticle](#nntpopenpreviousarticle-function)
- [NntpRead](#nntpread-function)

---

## NntpOpenArticleEx Function

Open the specified article in the current newsgroup with support for large article IDs

### Prototype

```c
INT WINAPI NntpOpenArticleEx(
    HCLIENT hClient,
    ULONGLONG nArticleId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nArticleId` | `ULONGLONG` | An unsigned 64-bit integer that specifies which article in the current newsgroup to retrieve. This value may be zero, which specifies that the current article should be opened. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpOpenArticleEx function sends a request to begin returning the contents of the specified article. This function provides support for servers which use 64-bit article IDs. The NntpRead function is used to read the article contents after it has been opened. When the complete article has been read, the NntpCloseArticle function must be called to close the article and complete the request.
- It is recommended most applications use the NntpGetArticleEx function, which will retrieve the complete article in a single function call. This function is typically only used if the application needs to modify the contents of the article as it is being read. If you wish to download an article and store it in a file on the local system, use the NntpStoreArticleEx function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpCloseArticle](#nntpclosearticle-function)
- [NntpGetArticleEx](#nntpgetarticleex-function)
- [NntpGetArticleRangeEx](#nntpgetarticlerangeex-function)
- [NntpGetCurrentArticleEx](#nntpgetcurrentarticleex-function)
- [NntpListArticlesEx](#nntplistarticlesex-function)
- [NntpOpenArticleByMessageId](#nntpopenarticlebymessageid-function)
- [NntpOpenNextArticle](#nntpopennextarticle-function)
- [NntpOpenPreviousArticle](#nntpopenpreviousarticle-function)
- [NntpRead](#nntpread-function)
- [NntpStoreArticleEx](#nntpstorearticleex-function)

---

## NntpOpenNextArticle Function

Open the next available article

### Prototype

```c
INT WINAPI NntpOpenNextArticle(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpCloseArticle](#nntpclosearticle-function)
- [NntpGetArticle](#nntpgetarticle-function)
- [NntpGetArticleRange](#nntpgetarticlerange-function)
- [NntpGetCurrentArticle](#nntpgetcurrentarticle-function)
- [NntpListArticles](#nntplistarticles-function)
- [NntpOpenArticleByMessageId](#nntpopenarticlebymessageid-function)
- [NntpOpenPreviousArticle](#nntpopenpreviousarticle-function)
- [NntpRead](#nntpread-function)

---

## NntpOpenPreviousArticle Function

Open the previous article

### Prototype

```c
INT WINAPI NntpOpenPreviousArticle(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpCloseArticle](#nntpclosearticle-function)
- [NntpGetArticle](#nntpgetarticle-function)
- [NntpGetArticleRange](#nntpgetarticlerange-function)
- [NntpGetCurrentArticle](#nntpgetcurrentarticle-function)
- [NntpListArticles](#nntplistarticles-function)
- [NntpOpenArticleByMessageId](#nntpopenarticlebymessageid-function)
- [NntpOpenNextArticle](#nntpopennextarticle-function)
- [NntpRead](#nntpread-function)

---

## NntpPostArticle Function

Post a new article to the news server

### Prototype

```c
INT WINAPI NntpPostArticle(
    HCLIENT hClient,
    LPCTSTR lpBuffer,
    DWORD dwLength,
    DWORD dwReserved
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpBuffer` | `LPCTSTR` | A pointer to a character buffer which contains the article to be posted to the currently selected newsgroup. |
| `dwLength` | `DWORD` | Specifies the length of the string which contains the article. If this parameter is -1, the actual length of the string is calculated by searching the buffer for a terminating null byte. |
| `dwReserved` | `DWORD` | Reserved parameter. This value should always be zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpPostArticle function is used to post the contents of the specified buffer to the server as a new article in the current newsgroup. Not all newsgroups permit new articles to be posted, and some newsgroups may require that you email the article to a moderator for approval instead of posting directly to the group. It may be required that the client authenticate itself using the NntpAuthenticate function prior to posting the article.
- A news article is similar to an email message in that it contains one or more header fields, followed by an empty line, followed by the body of the article. Each line of text should be terminated by a carriage return/linefeed sequence of characters. The Mail Message library can be used to compose a message if needed. Note that the article header must contain a header field named "Newsgroups" with a value that specifies the newsgroup or newsgroups the article is being posted to. If this header field is missing, the news server will reject the article.
- This function will cause the current thread to block until the transfer has completed, a timeout occurs or the transfer is canceled. During the transfer, the HTTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling NntpEnableEvents, or by registering a callback function using the NntpRegisterEvent function.
- To determine the current status of a transfer while it is in progress, use the NntpGetTransferStatus function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetTransferStatus](#nntpgettransferstatus-function)
- [NntpIsBlocking](#nntpisblocking-function)
- [NntpIsWritable](#nntpiswritable-function)
- [NntpRead](#nntpread-function)
- [NntpReset](#nntpreset-function)
- [NntpWrite](#nntpwrite-function)

---

## NntpRead Function

Read data returned by the news server

### Prototype

```c
INT WINAPI NntpRead(
    HCLIENT hClient,
    LPBYTE lpBuffer,
    INT cbBuffer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpBuffer` | `LPBYTE` | Pointer to the buffer in which the data will be copied. |
| `cbBuffer` | `INT` | The maximum number of bytes to read and copy into the specified buffer. This value must be greater than zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of bytes actually read. A return value of zero indicates that the server has closed the connection and there is no more data available to be read. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- When NntpRead is called and the client is in non-blocking mode, it is possible that the function will fail because there is no available data to read at that time. This should not be considered a fatal error. Instead, the application should simply wait to receive the next asynchronous notification that data is available.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpCloseArticle](#nntpclosearticle-function)
- [NntpIsBlocking](#nntpisblocking-function)
- [NntpIsConnected](#nntpisconnected-function)
- [NntpIsReadable](#nntpisreadable-function)
- [NntpOpenArticle](#nntpopenarticle-function)
- [NntpWrite](#nntpwrite-function)

---

## NntpRegisterEvent Function

Register an event callback function

### Prototype

```c
INT WINAPI NntpRegisterEvent(
    HCLIENT hClient,
    UINT nEvent,
    NNTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nEvent` | `UINT` | An unsigned integer which specifies which event should be registered with the specified callback function. One of the following values may be used: |
| `lpEventProc` | `NNTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the NntpEventProc callback function. If this parameter is NULL, the callback for the specified event is disabled. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. If the application targets the x86 (32-bit) platform, this parameter must be a 32-bit unsigned integer. If the application targets the x64 (64-bit) platform, this parameter must be a 64-bit unsigned integer. |

### Options

- **nEvent** Parameter

    - `NNTP_EVENT_CONNECT`: The connection to the server has completed.
    - `NNTP_EVENT_DISCONNECT`: The server has closed the connection to the client. The client should read any remaining data and disconnect.
    - `NNTP_EVENT_READ`: Data is available to read by the calling process. No additional messages will be posted until the client has read at least some of the data. This event is only generated if the client is in asynchronous mode.
    - `NNTP_EVENT_WRITE`: The client can now write data. This notification is sent after a connection has been established, or after a previous attempt to write data has failed because it would result in a blocking operation. This event is only generated if the client is in asynchronous mode.
    - `NNTP_EVENT_TIMEOUT`: The network operation has exceeded the specified timeout period. The client application may attempt to retry the operation, or may disconnect from the server and report an error to the user.
    - `NNTP_EVENT_CANCEL`: The current operation has been canceled. Under most circumstances the client should disconnect from the server and re-connect if needed. After an operation has been canceled, the server may abort the connection or refuse to accept further commands from the client.
    - `NNTP_EVENT_COMMAND`: A command has been issued by the client and the server response has been received and processed. This event can be used to log the result codes and messages returned by the server in response to actions taken by the client.
    - `NNTP_EVENT_LISTARTICLE`: The client is retrieving a list of articles from the server and information about another article has been processed. The client should use this event to retrieve the next available article from the server.
    - `NNTP_EVENT_LASTARTICLE`: The client is retrieving a list of articles from the server and all of the available articles have been processed. This event is generated when there are no further articles.
    - `NNTP_EVENT_LISTGROUP`: The client is retrieving a list of newsgroups from the server and information about another group has been processed. The client should use this event to retrieve the next available newsgroup from the server.
    - `NNTP_EVENT_LASTGROUP`: The client is retrieving a list of newsgroups from the server and all of the available groups have been processed. This event is generated when there are no further newsgroups.
    - `NNTP_EVENT_PROGRESS`: The client is in the process of sending or receiving data from the server. This event is called periodically during a transfer so that the client can update any user interface components such as a status control or progress bar.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpRegisterEvent function associates a callback function with a specific event. The event handler is an NntpEventProc function that is invoked when the event occurs. Arguments are passed to the function to identify the client session, the event type and the user-defined value specified when the event handler is registered. If the event occurs because of an error condition, the error code will be provided to the handler.
- This function is typically used to register an event handler that is invoked while a news article is being uploaded or downloaded. The NNTP_EVENT_PROGRESS event will only be generated periodically during the transfer to ensure the application is not flooded with event notifications. It is guaranteed that at least one NNTP_EVENT_PROGRESS notification will occur at the beginning of the transfer, and one at the end of the transfer when it has completed.
- The callback function specified by the lpEventProc parameter must be declared using the __stdcall calling convention. This ensures the arguments passed to the event handler are pushed on to the stack in the correct order. Failure to use the correct calling convention will corrupt the stack and cause the application to terminate abnormally.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpDisableEvents](#nntpdisableevents-function)
- [NntpEnableEvents](#nntpenableevents-function)
- [NntpEventProc](#nntpeventproc-function)
- [NntpFreezeEvents](#nntpfreezeevents-function)

---

## NntpReset Function

Reset the client

### Prototype

```c
INT WINAPI NntpReset(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The client cannot be reset while it is in a blocked state.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpCancel](#nntpcancel-function)
- [NntpIsBlocking](#nntpisblocking-function)

---

## NntpSelectGroup Function

Select the specified newsgroup to retrieve articles from

### Prototype

```c
INT WINAPI NntpSelectGroup(
    HCLIENT hClient,
    LPCTSTR lpszGroupName
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszGroupName` | `LPCTSTR` | Pointer to a string which specifies the newsgroup to be selected. This value may be NULL, in which case the current newsgroup is unchanged, but the article count is updated. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- This function selects the newsgroup and obtains a description and the first and last article numbers for that group.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetGroupName](#nntpgetgroupname-function)
- [NntpGetGroupTitle](#nntpgetgrouptitle-function)
- [NntpListGroups](#nntplistgroups-function)
- [NntpListNewGroups](#nntplistnewgroups-function)

---

## NntpSetLastError Function

Set the last error code

### Prototype

```c
VOID WINAPI NntpSetLastError(
    DWORD dwErrorCode
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `dwErrorCode` | `DWORD` | Specifies the last error code for the current thread. |

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- Error codes are unsigned 32-bit values which are private to each calling thread. Most functions will set the last error code value when they fail; a few functions set it when they succeed. Function failure is typically indicated by a return value such as FALSE, NULL, INVALID_CLIENT or NNTP_ERROR. Those functions which call NntpSetLastError when they succeed are noted on the function reference page.
- Applications can retrieve the value saved by this function by using the NntpGetLastError function. The use of NntpGetLastError is optional; an application can call the function to determine the specific reason for a function failure.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpGetErrorString](#nntpgeterrorstring-function)
- [NntpGetLastError](#nntpgetlasterror-function)

---

## NntpSetMultiLine Function

Set the client multi-line output flag

### Prototype

```c
INT WINAPI NntpSetMultiLine(
    HCLIENT hClient,
    BOOL bMultiLine
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `bMultiLine` | `BOOL` | A boolean flag which determines if the client is processing multiple lines of data as the result of a command. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The multi-line flag is used by the library to determine if multiple lines of data will be returned by the server as the result of a command. Unlike a single line response, which consists of a result code and result string, a multi-line response consists of one or more lines of text, terminated by a special end-of-data marker.
- The NntpSetMultiLine function should only be used in conjunction with the NntpCommand function. If a command is issued which would result in multiple lines of output, the multi-line flag must be set TRUE. The multi-line flag must be set after each command, since it is reset to FALSE with each command that is sent to the server.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpCommand](#nntpcommand-function)
- [NntpGetMultiLine](#nntpgetmultiline-function)
- [NntpGetResultCode](#nntpgetresultcode-function)
- [NntpGetResultString](#nntpgetresultstring-function)

---

## NntpSetTimeout Function

Set the number of seconds until an operation times out

### Prototype

```c
INT WINAPI NntpSetTimeout(
    HCLIENT hClient,
    INT nTimeout
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nTimeout` | `INT` | The number of seconds to wait for a blocking operation to complete. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpConnect](#nntpconnect-function)
- [NntpGetTimeout](#nntpgettimeout-function)

---

## NntpStoreArticle Function

Retrieve an article and store the contents in a local file

### Prototype

```c
INT WINAPI NntpStoreArticle(
    HCLIENT hClient,
    LONG nArticleId,
    LPCTSTR lpszFileName
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nArticleId` | `LONG` | An integer value that specifies the article to be downloaded. |
| `lpszFileName` | `LPCTSTR` | Pointer to a string which specifies the file that the article will be stored in. If the file does not exist, it will be created. If the file does exist, it will be overwritten with the contents of the article. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpStoreArticle function provides a method of retrieving and storing an article on the local system. The contents of the article is stored as a text file, using the specified file name. This function always causes the caller to block until the entire message has been retrieved, even if the client has been put in asynchronous mode. If you wish to download the article to memory rather than a file, use the NntpGetArticle function.
- If event handling is enabled, the NNTP_EVENT_PROGRESS event will fire periodically during the transfer of the article to the local system. An application can determine how much of the article has been retrieved by calling the NntpGetTransferStatus function.
- If the server uses 64-bit article IDs, your application should use the NntpStoreArticleEx function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetArticle](#nntpgetarticle-function)
- [NntpGetArticleHeaders](#nntpgetarticleheaders-function)
- [NntpGetTransferStatus](#nntpgettransferstatus-function)
- [NntpStoreArticleEx](#nntpstorearticleex-function)

---

## NntpStoreArticleEx Function

Retrieve an article and store the contents in a local file with support for large article IDs

### Prototype

```c
INT WINAPI NntpStoreArticleEx(
    HCLIENT hClient,
    ULONGLONG nArticleId,
    LPCTSTR lpszFileName,
    DWORD dwReserved
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nArticleId` | `ULONGLONG` | An unsigned 64-integer value which specifies the article to be downloaded. |
| `lpszFileName` | `LPCTSTR` | Pointer to a string which specifies the file that the article will be stored in. If the file does not exist, it will be created. If the file does exist, it will be overwritten with the contents of the article. |
| `dwReserved` | `DWORD` | Number of the article to retrieve. This value must be greater than zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The NntpStoreArticleEx function provides a method of retrieving and storing an article on the local system. This function provides support for servers which use 64-bit article IDs.
- The contents of the article is stored as a text file, using the specified file name. This function always causes the caller to block until the entire message has been retrieved, even if the client has been put in asynchronous mode. If you wish to download the article to memory rather than a file, use the NntpGetArticle function.
- If event handling is enabled, the NNTP_EVENT_PROGRESS event will fire periodically during the transfer of the article to the local system. An application can determine how much of the article has been retrieved by calling the NntpGetTransferStatusEx function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [NntpGetArticleEx](#nntpgetarticleex-function)
- [NntpGetArticleHeadersEx](#nntpgetarticleheadersex-function)
- [NntpGetTransferStatusEx](#nntpgettransferstatusex-function)

---

## NntpUninitialize Function

Terminate use of the library by the application

### Prototype

```c
VOID WINAPI NntpUninitialize();
```

### Parameters

| Name | Type | Description |
|------|------|-------------|

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- An application is required to perform a successful NntpInitialize call before it can call any of the other library functions. When it has completed the use of library, the application must call NntpUninitialize to allow the library to free any resources allocated on behalf of the process. Any pending blocking or asynchronous calls in this process are canceled without posting any notification messages, and all sockets that were opened by the process are closed.
- There must be a call to NntpUninitialize for every successful call to NntpInitialize made by a process. In a multithreaded environment, operations for all threads in the client are terminated.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpDisconnect](#nntpdisconnect-function)
- [NntpInitialize](#nntpinitialize-function)

---

## NntpWrite Function

Write data to the news server

### Prototype

```c
INT WINAPI NntpWrite(
    HCLIENT hClient,
    LPBYTE lpBuffer,
    INT cbBuffer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpBuffer` | `LPBYTE` | The pointer to the buffer which contains the data that is to be sent to the server. |
| `cbBuffer` | `INT` | The number of bytes to send from the specified buffer. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of bytes actually written. If the function fails, the return value is NNTP_ERROR. To get extended error information, call NntpGetLastError.

### Remarks

- The return value may be less than the number of bytes specified by the cbBuffer parameter. In this case, the data has been partially written and it is the responsibility of the client application to send the remaining data at some later point. For non-blocking clients, the client must wait for the NNTP_EVENT_WRITE asynchronous notification message before it resumes sending data.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csnwsv11.lib`

### See Also

- [NntpCreateArticle](#nntpcreatearticle-function)
- [NntpIsBlocking](#nntpisblocking-function)
- [NntpRead](#nntpread-function)

---

## INITDATA Structure

This structure contains information about the SocketTools library when the initialization function returns.

### Definition

```c
typedef struct _INITDATA
{
    DWORD dwSize;
    DWORD dwVersionMajor;
    DWORD dwVersionMinor;
    DWORD dwVersionBuild;
    DWORD dwOptions;
    DWORD_PTR dwReserved1;
    DWORD_PTR dwReserved2;
    TCHAR szDescription;
} INITDATA, *LPINITDATA;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | Size of this structure. This structure member must be set to the size of the structure prior to calling the initialization function. Failure to do so will cause the function to fail. |
| `dwVersionMajor` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. When the function returns, it will contain the major version number for the library. |
| `dwVersionMinor` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. When the function returns, it will contain the minor version number for the library. |
| `dwVersionBuild` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. When the function returns, it will contain the build number for the library. |
| `dwOptions` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. This member is reserved for future use. |
| `dwReserved1` | `DWORD_PTR` | This member must be initialized to a value of zero prior to calling the initialization function. This member is reserved for future use. |
| `dwReserved2` | `DWORD_PTR` | This member must be initialized to a value of zero prior to calling the initialization function. This member is reserved for future use. |
| `szDescription` | `TCHAR` | A null terminated string which describes the library. |

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

---

## NEWSARTICLE Structure

This structure is used by the NntpGetFirstArticle and NntpGetNextArticle functions to return information about news articles.

### Definition

```c
typedef struct _NEWSARTICLE
{
    LONG nArticleId;
    LONG nBytes;
    LONG nLines;
    SYSTEMTIME stPosted;
} NEWSARTICLE, *LPNEWSARTICLE;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `nArticleId` | `LONG` | A long integer which specifies the article number. |
| `nBytes` | `LONG` | The length of the news article in bytes. |
| `nLines` | `LONG` | The length of the news article specified as the number of lines of text. |
| `stPosted` | `SYSTEMTIME` | A SYSTEMTIME structure which specifies when the article was posted in Universal Coordinated Time (UTC). |

### Remarks

- If the server uses 64-bit article IDs your application should use the NEWSARTICLEEX structure and related functions.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

### See Also

- [NntpGetFirstArticle](#nntpgetfirstarticle-structure)
- [NntpGetNextArticle](#nntpgetnextarticle-structure)
- [NntpListArticles](#nntplistarticles-structure)
- [NEWSARTICLE](#newsarticle-structure)
- [NEWSGROUP](#newsgroup-structure)

---

## NEWSARTICLEEX Structure

This structure is used by the NntpGetFirstArticleEx and NntpGetNextArticleEx functions to return information about news articles.

### Definition

```c
typedef struct _NEWSARTICLEEX
{
    ULONGLONG nArticleId;
    ULONG nBytes;
    ULONG nLines;
    SYSTEMTIME stPosted;
} NEWSARTICLEEX, *LPNEWSARTICLEEX;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `nArticleId` | `ULONGLONG` | An unsigned 64-bit integer which specifies the article number. |
| `nBytes` | `ULONG` | The length of the news article in bytes. |
| `nLines` | `ULONG` | The length of the news article specified as the number of lines of text. |
| `stPosted` | `SYSTEMTIME` | A SYSTEMTIME structure which specifies when the article was posted in Universal Coordinated Time (UTC). |

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

### See Also

- [NntpGetFirstArticleEx](#nntpgetfirstarticleex-structure)
- [NntpGetNextArticleEx](#nntpgetnextarticleex-structure)
- [NntpListArticlesEx](#nntplistarticlesex-structure)
- [NEWSARTICLEEX](#newsarticleex-structure)
- [NEWSGROUPEX](#newsgroupex-structure)

---

## NEWSGROUP Structure

This structure is used by the NntpGetFirstGroup and NntpGetNextGroup functions to return information about the available newsgroups.

### Definition

```c
typedef struct _NEWSGROUP
{
    LONG nFirstArticle;
    LONG nLastArticle;
    DWORD dwAccess;
} NEWSGROUP, *LPNEWSGROUP;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `nFirstArticle` | `LONG` | A long integer which specifies the article number of the first available article in the newsgroup. |
| `nLastArticle` | `LONG` | A long integer which specifies the article number of the last available article in the newsgroup. Note that posted articles may not be contiguous in the range between the first and last article numbers. Some servers may assign numbers in a different order than the articles were posted, or there may be gaps where articles have been removed. |
| `dwAccess` | `DWORD` | An unsigned integer which specifies the access mode for the group. It may be one of the following values: |

### Remarks

- If the server uses 64-bit article IDs your application should use the NEWSGROUPEX structure and related functions.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

### See Also

- [NntpGetFirstGroup](#nntpgetfirstgroup-structure)
- [NntpGetNextGroup](#nntpgetnextgroup-structure)
- [NEWSARTICLE](#newsarticle-structure)
- [NEWSARTICLEEX](#newsarticleex-structure)
- [NEWSGROUPEX](#newsgroupex-structure)

---

## NEWSGROUPEX Structure

This structure is used by the NntpGetFirstGroupEx and NntpGetNextGroupEx functions to return information about the available newsgroups.

### Definition

```c
typedef struct _NEWSGROUPEX
{
    ULONGLONG nFirstArticle;
    ULONGLONG nLastArticle;
    DWORD dwAccess;
} NEWSGROUPEX, *LPNEWSGROUPEX;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `nFirstArticle` | `ULONGLONG` | An unsigned 64-bit integer which specifies the article number of the first available article in the newsgroup. |
| `nLastArticle` | `ULONGLONG` | An unsigned 64-bit integer which specifies the article number of the last available article in the newsgroup. Note that posted articles may not be contiguous in the range between the first and last article numbers. Some servers may assign numbers in a different order than the articles were posted, or there may be gaps where articles have been removed. |
| `dwAccess` | `DWORD` | An unsigned integer which specifies the access mode for the group. It may be one of the following values: |

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

### See Also

- [NntpGetFirstGroupEx](#nntpgetfirstgroupex-structure)
- [NntpGetNextGroupEx](#nntpgetnextgroupex-structure)
- [NEWSARTICLE](#newsarticle-structure)
- [NEWSARTICLEEX](#newsarticleex-structure)
- [NEWSGROUP](#newsgroup-structure)

---

## NNTPTRANSFERSTATUS Structure

This structure is used by the NntpGetTransferStatus function to return information about an article transfer in progress. If the server uses 64-bit article IDs your application should use the NNTPTRANSFERSTATUSEX structure and related functions.

### Definition

```c
typedef struct _NNTPTRANSFERSTATUS
{
    LONG nArticleId;
    DWORD dwBytesTotal;
    DWORD dwBytesCopied;
    DWORD dwBytesPerSecond;
    DWORD dwTimeElapsed;
    DWORD dwTimeEstimated;
} NNTPTRANSFERSTATUS, *LPNNTPTRANSFERSTATUS;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `nArticleId` | `LONG` | A signed integer that specifies the article ID of the current article that is being transferred. If an article is being posted, this value will be zero. |
| `dwBytesTotal` | `DWORD` | An unsigned integer that specifies the total number of bytes that will be transferred. If the article is being copied from the server to the local host, this is the size of the article on the server. If the article is being posted to the server, it is the size of article on the local system. If the article size cannot be determined, this value will be zero. |
| `dwBytesCopied` | `DWORD` | An unsigned integer that specifies the total number of bytes that have been copied. |
| `dwBytesPerSecond` | `DWORD` | An unsigned integer that specifies the average number of bytes that have been copied per second. |
| `dwTimeElapsed` | `DWORD` | An unsigned integer that specifies the number of seconds that have elapsed since the transfer started. |
| `dwTimeEstimated` | `DWORD` | An unsigned integer that specifies the estimated number of seconds until the transfer is completed. This is based on the average number of bytes transferred per second. |

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

### See Also

- [NntpEnableEvents](#nntpenableevents-structure)
- [NntpGetTransferStatus](#nntpgettransferstatus-structure)
- [NntpRegisterEvent](#nntpregisterevent-structure)
- [NNTPTRANSFERSTATUS](#nntptransferstatus-structure)
- [NNTPTRANSFERSTATUSEX](#nntptransferstatusex-structure)

---

## NNTPTRANSFERSTATUSEX Structure

This structure is used by the NntpGetTransferStatusEx function to return information about an article transfer in progress. This structure is intended for use with servers that return 64-bit article IDs.

### Definition

```c
typedef struct _NNTPTRANSFERSTATUSEX
{
    ULONGLONG nArticleId;
    DWORD dwBytesTotal;
    DWORD dwBytesCopied;
    DWORD dwBytesPerSecond;
    DWORD dwTimeElapsed;
    DWORD dwTimeEstimated;
} NNTPTRANSFERSTATUSEX, *LPNNTPTRANSFERSTATUSEX;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `nArticleId` | `ULONGLONG` | An unsigned 64-bit integer that specifies the article ID of the current article that is being transferred. If an article is being posted, this value will be zero. |
| `dwBytesTotal` | `DWORD` | An unsigned integer that specifies the total number of bytes that will be transferred. If the article is being copied from the server to the local host, this is the size of the article on the server. If the article is being posted to the server, it is the size of article on the local system. If the article size cannot be determined, this value will be zero. |
| `dwBytesCopied` | `DWORD` | An unsigned integer that specifies the total number of bytes that have been copied. |
| `dwBytesPerSecond` | `DWORD` | An unsigned integer that specifies the average number of bytes that have been copied per second. |
| `dwTimeElapsed` | `DWORD` | An unsigned integer that specifies the number of seconds that have elapsed since the transfer started. |
| `dwTimeEstimated` | `DWORD` | An unsigned integer that specifies the estimated number of seconds until the transfer is completed. This is based on the average number of bytes transferred per second. |

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

### See Also

- [NntpEnableEvents](#nntpenableevents-structure)
- [NntpGetTransferStatusEx](#nntpgettransferstatusex-structure)
- [NntpRegisterEvent](#nntpregisterevent-structure)

---

## SECURITYCREDENTIALS Structure

The SECURITYCREDENTIALS structure specifies the information needed by the library to specify additional security credentials, such as a client certificate, when establishing a secure connection.

### Definition

```c
typedef struct _SECURITYCREDENTIALS
{
    DWORD dwSize;
    DWORD dwProtocol;
    DWORD dwOptions;
    DWORD dwReserved;
    LPCTSTR lpszHostName;
    LPCTSTR lpszUserName;
    LPCTSTR lpszPassword;
    LPCTSTR lpszCertStore;
    LPCTSTR lpszCertName;
    LPCTSTR lpszKeyFile;
} SECURITYCREDENTIALS, *LPSECURITYCREDENTIALS;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | Size of this structure. If the structure is being allocated dynamically, this member must be set to the size of the structure and all other unused structure members must be initialized to a value of zero or NULL. |
| `dwProtocol` | `DWORD` | A bitmask of supported security protocols. The value of this structure member is constructed by using a bitwise operator with any of the following values: |
| `dwOptions` | `DWORD` | A value which specifies one or options. This member is constructed by using a bitwise operator with any of the following values: |
| `dwReserved` | `DWORD` | This structure member is reserved for future use and should always be initialized to zero. |
| `lpszHostName` | `LPCTSTR` | A pointer to a null terminated string which specifies the hostname that will be used when validating the server certificate. If this member is NULL, then the server certificate will be validated against the hostname used to establish the connection. |
| `lpszUserName` | `LPCTSTR` | A pointer to a null terminated string which identifies the owner of client certificate. Currently this member is not used by the library and should always be initialized as a NULL pointer. |
| `lpszPassword` | `LPCTSTR` | A pointer to a null terminated string which specifies the password needed to access the certificate. Currently this member is only used if the CREDENTIAL_STORE_FILENAME option has been specified. If there is no password associated with the certificate, then this member should be initialized as a NULL pointer. |
| `lpszCertStore` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the certificate store to open. A certificate store is a collection of certificates and their private keys, typically organized by how they are used. If this value is NULL or points to an empty string, the default certificate store "MY" will be used. |
| `lpszCertName` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the certificate to use. The library will first search the certificate store for a certificate with a matching "friendly name"; this is a name for the certificate that is assigned by the user. Note that the name must match completely, but the comparison is not case sensitive. If no matching certificate is found, the library will then attempt to find a certificate that has a matching common name (also called the certificate subject). This comparison is less stringent, and the first partial match will be returned. If this second search fails, the library will return an error indicating that the certificate could not be found. If the SECURITY_PROTOCOL_SSH protocol has been specified, this member should be NULL. |
| `lpszKeyFile` | `LPCTSTR` | This member is not used and should always be NULL. The private key cannot be specified separately and must be associated with the certificate. |

### Remarks

- An application only needs to create this structure if the server requires the client to provide a certificate as part of the process of negotiating the secure session. If a certificate is required, note that it must have a private key associated with it. Attempting to use a certificate that does not have a private key will result in an error during the connection process indicating that the client credentials could not be established.
- If you are using a local certificate store, with the certificate and private key stored in the registry, you can explicitly specify whether the certificate store for the current user or the local machine (all users) should be used. This is done by prefixing the certificate store name with "HKCU:" for the current user, or "HKLM:" for the local machine. For example, a certificate store name of "HKLM:MY" would specify the personal certificate store for the local machine, rather than the current user. If neither prefix is specified, then it will default to the certificate store for the current user. You can manage these certificates using the CertMgr.msc Microsoft Management Console (MMC) snap-in.
- It is possible to load the certificate from a file rather than from current user's certificate store. The dwOptions member should be set to CREDENTIAL_STORE_FILENAME and the lpszCertStore member should specify the name of the file that contains the certificate and its private key. The file must be in Private Information Exchange (PFX) format, also known as PKCS #12. These certificate files typically have an extension of .pfx or .p12. Note that if a password was specified when the certificate file was created, it must be provided in the lpszPassword member or the library will be unable to access the certificate.
- Note that the lpszUserName and lpszPassword members are values which are used to access the certificate store or private key file. They are not the credentials which are used when establishing the connection with the remote host or authenticating the client session.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

---

## SECURITYINFO Structure

The SECURITYINFO structure contains security related information about the connection, including the protocol, cipher suite and certificate.

### Definition

```c
typedef struct _SECURITYINFO
{
    DWORD dwSize;
    DWORD dwProtocol;
    DWORD dwCipher;
    DWORD dwCipherStrength;
    DWORD dwHash;
    DWORD dwHashStrength;
    DWORD dwKeyExchange;
    DWORD dwCertStatus;
    SYSTEMTIME stCertIssued;
    SYSTEMTIME stCertExpires;
    LPCTSTR lpszCertIssuer;
    LPCTSTR lpszCertSubject;
    LPCTSTR lpszFingerprint;
} SECURITYINFO, *LPSECURITYINFO;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | Specifies the size of the data structure. This member must always be initialized to the size of the structure in bytes prior to passing the address of this structure to the function. If this this member is not initialized, an error will be returned indicating that an invalid parameter has been passed to the function. |
| `dwProtocol` | `DWORD` | A numeric value which specifies the security protocol selected when establishing the connection. |
| `dwCipher` | `DWORD` | A numeric value which specifies the cipher that was selected when establishing the secure connection. |
| `dwCipherStrength` | `DWORD` | A numeric value which specifies the strength (the length of the cipher key in bits) of the cipher that was selected. Typically this value will be 128 or 256. 40-bit and 56-bit key lengths are considered weak encryption, and subject to brute force attacks. 128-bit and 256-bit key lengths are considered to be secure, and are the recommended key length for secure communications. |
| `dwHash` | `DWORD` | A numeric value which specifies the hash algorithm which was selected. |
| `dwHashStrength` | `DWORD` | A numeric value which specifies the strength (the length in bits) of the message digest that was selected. |
| `dwKeyExchange` | `DWORD` | A numeric value which specifies the key exchange algorithm which was selected. |
| `dwCertStatus` | `DWORD` | A numeric value which specifies the status of the certificate returned by the secure server. |
| `stCertIssued` | `SYSTEMTIME` | A structure which contains the date and time that the certificate was issued by the certificate authority. If the issue date cannot be determined for the certificate, the SYSTEMTIME structure members will have zero values. |
| `stCertExpires` | `SYSTEMTIME` | A structure which contains the date and time that the certificate expires. If the expiration date cannot be determined for the certificate, the SYSTEMTIME structure members will have zero values. |
| `lpszCertIssuer` | `LPCTSTR` | A pointer to a string which contains information about the organization that issued the certificate. This string consists of one or more comma-separated tokens. Each token consists of an identifier, followed by an equal sign and a value. If the certificate issuer could not be determined, this member may be NULL. |
| `lpszCertSubject` | `LPCTSTR` | A pointer to a string which contains information about the organization that the certificate was issued to. This string consists of one or more comma-separated tokens. Each token consists of an identifier, followed by an equal sign and a value. If the certificate subject could not be determined, this member may be NULL. |
| `lpszFingerprint` | `LPCTSTR` | A pointer to a string which contains a sequence of hexadecimal values that uniquely identify the server. This member may be NULL. |

### Remarks

- The size of this structure is typically determined using the sizeof operator in C/C++ and most other languages have a similar method for obtaining the size of a data structure or user-defined type. It is important to note the size of this structure will be different on 32-bit and 64-bit platforms due to the difference in the length of the structure members which are pointers.
- When evaluating structure members which are string pointers, such as lpszCertIssuer and lpszCertSubject, you should always check to ensure their values are not NULL (zero) before attempting to dereference them. If those values are undefined, it is not guaranteed they will point to zero-length strings.
- There are additional protocols and ciphers defined which are not listed above because they are considered insecure and are no longer supported. It is important to note that most servers will reject attempts to use unsupported protocols such as SSL 3.0 and will either abort the connection or issue an error message and then immediately disconnect.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

