# File Transfer Protocol Client

## Functions

- [FtpAddQueuedFile](#ftpaddqueuedfile-function)
- [FtpAddQueuedFileEx](#ftpaddqueuedfileex-function)
- [FtpAllocate](#ftpallocate-function)
- [FtpAsyncConnect](#ftpasyncconnect-function)
- [FtpAsyncFileList](#ftpasyncfilelist-function)
- [FtpAsyncGetData](#ftpasyncgetdata-function)
- [FtpAsyncGetFile](#ftpasyncgetfile-function)
- [FtpAsyncGetFileEx](#ftpasyncgetfileex-function)
- [FtpAsyncProxyConnect](#ftpasyncproxyconnect-function)
- [FtpAsyncPutData](#ftpasyncputdata-function)
- [FtpAsyncPutFile](#ftpasyncputfile-function)
- [FtpAsyncPutFileEx](#ftpasyncputfileex-function)
- [FtpAttachThread](#ftpattachthread-function)
- [FtpCancel](#ftpcancel-function)
- [FtpCancelQueuedFile](#ftpcancelqueuedfile-function)
- [FtpChangeDirectory](#ftpchangedirectory-function)
- [FtpChangeDirectoryUp](#ftpchangedirectoryup-function)
- [FtpClearQueue](#ftpclearqueue-function)
- [FtpCloseDirectory](#ftpclosedirectory-function)
- [FtpCloseFile](#ftpclosefile-function)
- [FtpCommand](#ftpcommand-function)
- [FtpConnect](#ftpconnect-function)
- [FtpConnectUrl](#ftpconnecturl-function)
- [FtpCreateDirectory](#ftpcreatedirectory-function)
- [FtpCreateQueue](#ftpcreatequeue-function)
- [FtpCreateSecurityCredentials](#ftpcreatesecuritycredentials-function)
- [FtpDeleteFile](#ftpdeletefile-function)
- [FtpDeleteQueue](#ftpdeletequeue-function)
- [FtpDeleteSecurityCredentials](#ftpdeletesecuritycredentials-function)
- [FtpDisableEvents](#ftpdisableevents-function)
- [FtpDisableTrace](#ftpdisabletrace-function)
- [FtpDisconnect](#ftpdisconnect-function)
- [FtpDownloadFile](#ftpdownloadfile-function)
- [FtpEnableEvents](#ftpenableevents-function)
- [FtpEnableFeature](#ftpenablefeature-function)
- [FtpEnableTrace](#ftpenabletrace-function)
- [FtpEndOfFile](#ftpendoffile-function)
- [FtpEnumFiles](#ftpenumfiles-function)
- [FtpEnumFilesEx](#ftpenumfilesex-function)
- [FtpEnumQueuedFiles](#ftpenumqueuedfiles-function)
- [FtpEnumTasks](#ftpenumtasks-function)
- [FtpEventProc](#ftpeventproc-function)
- [FtpFindQueuedFile](#ftpfindqueuedfile-function)
- [FtpFreezeEvents](#ftpfreezeevents-function)
- [FtpGetActivePorts](#ftpgetactiveports-function)
- [FtpGetAutoFileType](#ftpgetautofiletype-function)
- [FtpGetBufferSize](#ftpgetbuffersize-function)
- [FtpGetChannelMode](#ftpgetchannelmode-function)
- [FtpGetClientQuota](#ftpgetclientquota-function)
- [FtpGetData](#ftpgetdata-function)
- [FtpGetDirectory](#ftpgetdirectory-function)
- [FtpGetDirectoryFormat](#ftpgetdirectoryformat-function)
- [FtpGetErrorString](#ftpgeterrorstring-function)
- [FtpGetFeatures](#ftpgetfeatures-function)
- [FtpGetFile](#ftpgetfile-function)
- [FtpGetFileEx](#ftpgetfileex-function)
- [FtpGetFileList](#ftpgetfilelist-function)
- [FtpGetFileNameEncoding](#ftpgetfilenameencoding-function)
- [FtpGetFilePermissions](#ftpgetfilepermissions-function)
- [FtpGetFileSize](#ftpgetfilesize-function)
- [FtpGetFileStatus](#ftpgetfilestatus-function)
- [FtpGetFileStatusEx](#ftpgetfilestatusex-function)
- [FtpGetFileTime](#ftpgetfiletime-function)
- [FtpGetFileType](#ftpgetfiletype-function)
- [FtpGetFirstFile](#ftpgetfirstfile-function)
- [FtpGetFirstFileEx](#ftpgetfirstfileex-function)
- [FtpGetFirstQueuedFile](#ftpgetfirstqueuedfile-function)
- [FtpGetLastError](#ftpgetlasterror-function)
- [FtpGetMultipleFiles](#ftpgetmultiplefiles-function)
- [FtpGetNextFile](#ftpgetnextfile-function)
- [FtpGetNextFileEx](#ftpgetnextfileex-function)
- [FtpGetNextQueuedFile](#ftpgetnextqueuedfile-function)
- [FtpGetPriority](#ftpgetpriority-function)
- [FtpGetProxyType](#ftpgetproxytype-function)
- [FtpGetQueueClient](#ftpgetqueueclient-function)
- [FtpGetQueuedFile](#ftpgetqueuedfile-function)
- [FtpGetQueueStatus](#ftpgetqueuestatus-function)
- [FtpGetQueueThread](#ftpgetqueuethread-function)
- [FtpGetResultCode](#ftpgetresultcode-function)
- [FtpGetResultString](#ftpgetresultstring-function)
- [FtpGetSecurityInformation](#ftpgetsecurityinformation-function)
- [FtpGetServerInformation](#ftpgetserverinformation-function)
- [FtpGetServerStatus](#ftpgetserverstatus-function)
- [FtpGetServerTimeZone](#ftpgetservertimezone-function)
- [FtpGetServerType](#ftpgetservertype-function)
- [FtpGetStatus](#ftpgetstatus-function)
- [FtpGetTaskError](#ftpgettaskerror-function)
- [FtpGetTaskId](#ftpgettaskid-function)
- [FtpGetText](#ftpgettext-function)
- [FtpGetThreadQueue](#ftpgetthreadqueue-function)
- [FtpGetTimeout](#ftpgettimeout-function)
- [FtpGetTransferStatus](#ftpgettransferstatus-function)
- [FtpGetTransferStatusEx](#ftpgettransferstatusex-function)
- [FtpInitialize](#ftpinitialize-function)
- [FtpIsBlocking](#ftpisblocking-function)
- [FtpIsConnected](#ftpisconnected-function)
- [FtpIsReadable](#ftpisreadable-function)
- [FtpIsWritable](#ftpiswritable-function)
- [FtpLogin](#ftplogin-function)
- [FtpLogout](#ftplogout-function)
- [FtpMountStructure](#ftpmountstructure-function)
- [FtpOpenDirectory](#ftpopendirectory-function)
- [FtpOpenFile](#ftpopenfile-function)
- [FtpProxyConnect](#ftpproxyconnect-function)
- [FtpPutData](#ftpputdata-function)
- [FtpPutFile](#ftpputfile-function)
- [FtpPutFileEx](#ftpputfileex-function)
- [FtpPutMultipleFiles](#ftpputmultiplefiles-function)
- [FtpPutText](#ftpputtext-function)
- [FtpRead](#ftpread-function)
- [FtpRegisterEvent](#ftpregisterevent-function)
- [FtpRegisterFileType](#ftpregisterfiletype-function)
- [FtpRemoveDirectory](#ftpremovedirectory-function)
- [FtpRemoveQueuedFile](#ftpremovequeuedfile-function)
- [FtpRenameFile](#ftprenamefile-function)
- [FtpReset](#ftpreset-function)
- [FtpResetQueue](#ftpresetqueue-function)
- [FtpResumeQueue](#ftpresumequeue-function)
- [FtpSetActivePorts](#ftpsetactiveports-function)
- [FtpSetBufferSize](#ftpsetbuffersize-function)
- [FtpSetChannelMode](#ftpsetchannelmode-function)
- [FtpSetDirectoryFormat](#ftpsetdirectoryformat-function)
- [FtpSetFeatures](#ftpsetfeatures-function)
- [FtpSetFileMode](#ftpsetfilemode-function)
- [FtpSetFileNameEncoding](#ftpsetfilenameencoding-function)
- [FtpSetFilePermissions](#ftpsetfilepermissions-function)
- [FtpSetFileStructure](#ftpsetfilestructure-function)
- [FtpSetFileTime](#ftpsetfiletime-function)
- [FtpSetFileType](#ftpsetfiletype-function)
- [FtpSetLastError](#ftpsetlasterror-function)
- [FtpSetPassiveMode](#ftpsetpassivemode-function)
- [FtpSetPriority](#ftpsetpriority-function)
- [FtpSetTimeout](#ftpsettimeout-function)
- [FtpStartQueue](#ftpstartqueue-function)
- [FtpStopQueue](#ftpstopqueue-function)
- [FtpSuspendQueue](#ftpsuspendqueue-function)
- [FtpTaskAbort](#ftptaskabort-function)
- [FtpTaskDone](#ftptaskdone-function)
- [FtpTaskResume](#ftptaskresume-function)
- [FtpTaskSuspend](#ftptasksuspend-function)
- [FtpTaskWait](#ftptaskwait-function)
- [FtpUninitialize](#ftpuninitialize-function)
- [FtpUploadFile](#ftpuploadfile-function)
- [FtpValidateHostName](#ftpvalidatehostname-function)
- [FtpValidateUrl](#ftpvalidateurl-function)
- [FtpVerifyFile](#ftpverifyfile-function)
- [FtpWaitForQueue](#ftpwaitforqueue-function)
- [FtpWrite](#ftpwrite-function)
## Structures

- [FTPCLIENTQUOTA](#ftpclientquota-structure)
- [FTPFILESTATUS](#ftpfilestatus-structure)
- [FTPFILESTATUSEX](#ftpfilestatusex-structure)
- [FTPQUEUEDFILE](#ftpqueuedfile-structure)
- [FTPQUEUESTATUS](#ftpqueuestatus-structure)
- [FTPTRANSFERSTATUS](#ftptransferstatus-structure)
- [FTPTRANSFERSTATUSEX](#ftptransferstatusex-structure)
- [INITDATA](#initdata-structure)
- [SECURITYCREDENTIALS](#securitycredentials-structure)
- [SECURITYINFO](#securityinfo-structure)

---

## FtpAddQueuedFile Function

Add a new file to the queue to be uploaded or downloaded

### Prototype

```c
DWORD WINAPI FtpAddQueuedFile(
    HQUEUE hQueue,
    DWORD dwQueueMode,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    UINT nFileType,
    UINT nTimeout
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `dwQueueMode` | `DWORD` | An integer value which specifies if the file should be downloaded from the server or uploaded to the server. This parameter must be one of the following options and cannot have a value of zero. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the local file to be queued for transfer. This parameter cannot be NULL or point to an empty string. If the file is being queued for an upload, the file must exist on the local system or the function will fail. If the file is being downloaded, it will be created or replaced on the local system. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a null terminated string which specifies the URL to the location of the file on the server. The URL must follow the conventions for the File Transfer Protocol and may specify either a standard or secure connection, alternate port number, username, password and optional working directory. |
| `dwOptions` | `DWORD` | An unsigned integer value which specifies one or more options. This parameter is constructed by using a bitwise operator and can be any of the options used with the FtpConnect function. If this value is zero, the default options for the queue will be used. The most common options are: |
| `nFileType` | `UINT` | An integer value which specifies the type of file being transferred. It can be one of the following values: |
| `nTimeout` | `UINT` | The number of seconds to wait for a response from the server before failing the file transfer. If this value is zero, the default timeout period for the queue will be used. |

### Options

- **dwQueueMode** Parameter

    - `FTP_QUEUE_DOWNLOAD`: The file should be queued for downloading from the server to the local system.
    - `FTP_QUEUE_UPLOAD`: The file should be queued for uploading from the local system to the server.
- **dwOptions** Parameter

    - `FTP_OPTION_PASSIVE`: This option specifies the file transfer should attempt to establish the data connection with the server. If the local system is behind a firewall or a NAT router, the server may not be able to establish a data connection back to the client and the transfer will fail. This option forces the client to establish an outbound data connection with the server. It is recommended that applications use passive mode whenever possible.
    - `FTP_OPTION_FIREWALL`: This option specifies the file transfer should always use the host IP address to establish the data connection with the server, not the address returned by the server in response to the PASV command. This option may be necessary if the server is behind a router that performs Network Address Translation (NAT) and it returns an unreachable IP address for the data connection. If this option is specified, it will also enable passive mode data transfers.
    - `FTP_OPTION_SECURE`: This option specifies the file transfer should attempt to establish a secure connection with the server by default. This option is the same as specifying FTP_OPTION_SECURE_IMPLICIT which immediately performs the TLS protocol negotiation when the connection is established.
    - `FTP_OPTION_SECURE_IMPLICIT`: This option specifies the file transfer should attempt to immediately establish secure TLS connection with the server by default. This option is typically used when connecting to a server on port 990, which is the default port number used for FTPS.
    - `FTP_OPTION_SECURE_EXPLICIT`: This option specifies the file transfer should establish a standard connection to the server and then use the AUTH command to negotiate an explicit secure connection. This option is typically used when connecting to the server on ports other than 990.
    - `FTP_OPTION_SECURE_SHELL`: This option specifies the file transfer should use the Secure Shell (SSH) protocol to establish the connection by default. This option will automatically be selected if the connection is established using port 22, the default port for SSH.
- **nFileType** Parameter

    - `FILE_TYPE_AUTO`: The file type should be automatically determined based on the file name extension. If the file extension is unknown, the file type should be determined based on the contents of the file. The library has an internal list of common text file extensions, and additional file extensions can be registered using the FtpRegisterFileType function.
    - `FILE_TYPE_ASCII`: The file is a text file using the ASCII character set. For those servers which mark the end of a line with characters other than a carriage return and linefeed, it will be converted to the native client format. This is the file type used for directory listings.
    - `FILE_TYPE_EBCDIC`: The file is a text file using the EBCDIC character set. Local files will be converted to EBCDIC when sent to the server. Remote files will be converted to the native ASCII character set when retrieved from the server. Not all servers support this file type. It is recommended that you only specify this type if you know that it is required by the server to transfer data correctly.
    - `FILE_TYPE_IMAGE`: The file is a binary file and no data conversion of any type is performed on the file. This is the default file type for most data files and executable programs. If the type of file cannot be automatically determined, it will always be considered a binary file. If this file type is specified when uploading or downloading text files, the native end-of-line character sequences will be preserved.
    - `FILE_TYPE_LOCAL`: The file is a binary file that uses the local byte size for the server platform. On most servers, this file type is considered to be the same as FILE_TYPE_IMAGE. Not all servers support this file type. It is recommended that you only specify this type if you know that it is required by the server to transfer data correctly.

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is a unique identifier which corresponds to the queued file. If the function fails, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- This function will add a file to the current transfer queue. If successful, the value returned is a unique integer which identifies that file in the queue. To obtain information about the queued file, you can call the FtpGetQueuedFile function and provide this return value as the dwFileId parameter. To remove a file from the queue, use the FtpRemoveQueuedFile function.
- Files can only be added to the queue when in an idle or paused state. If you attempt to add a file to the queue while the queue manager is transferring files, the function will fail. To determine the current state of the queue, call the FtpGetQueueStatus function
- There are no fixed limits to the number of files which can be queued for transfer. To release the memory allocated for the queue, call the FtpClearQueue function. To determine the current status of the queue, including how many file transfers have been queued and how many are pending completion, call the FtpGetQueueStatus function.
- If the local file name includes environment variables enclosed in percentage (%) symbols, those values will automatically be expanded based on the environment variables defined for the current user using the ExpandEnvironmentStrings function in the Windows API. Note that environment variable names are not case-sensitive.
- This function will not immediately begin the process of uploading or downloading the file. It will only add the transfer request to the current queue. The file transfers are managed by a background worker thread which is created when the FtpStartQueue function is called.
- The FtpAddQueuedFileEx function is an extended version of this function with additional parameters to specify a hostname, port number, user name and password. Because most file uploads require authentication, using the extended function may be preferred to composing a URL which includes the account credentials.

### Example

```cpp
// Create a new queue
HQUEUE hQueue = FtpCreateQueue(INFINITE, FTP_TIMEOUT, FTP_OPTION_DEFAULT);

if (hQueue == INVALID_QUEUE)
	return;

// Add a file to the queue
DWORD dwFileId = FtpAddQueuedFile(
					hQueue,
					lpszLocalFile,
					lpszRemoteFile,
					FTP_OPTION_DEFAULT,
					FILE_TYPE_AUTO,
					FTP_TIMEOUT);

// Display information about the queued file
if (dwFileId != 0)
{
	FTPQUEUEDFILE queuedFile;

	if (FtpGetQueuedFile(hQueue, dwFileId, &queuedFile))
	{
		switch (queuedFile.dwMode)
		{
		case FTP_QUEUE_DOWNLOAD:
			_tprintf(_T("%u: Download \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szRemoteFile,
						queuedFile.szLocalFile);
				break;

		case FTP_QUEUE_UPLOAD:
			_tprintf(_T("%u: Upload \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szLocalFile,
						queuedFile.szRemoteFile);
				break;
		}
	}
}

// Start the queued file transfers and wait for it to complete
if (FtpStartQueue(hQueue, FTP_QUEUE_ALL, 0, NULL, 0))
{
	FtpWaitForQueue(hQueue, INFINITE, &dwElapsed, &dwError);
	FtpStopQueue(hQueue);
}

// Remove all files from the queue
FtpDeleteQueue(hQueue);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAddQueuedFileEx](#ftpaddqueuedfileex-function)
- [FtpCreateQueue](#ftpcreatequeue-function)
- [FtpDeleteQueue](#ftpdeletequeue-function)
- [FtpFindQueuedFile](#ftpfindqueuedfile-function)
- [FtpGetFirstQueuedFile](#ftpgetfirstqueuedfile-function)
- [FtpGetNextQueuedFile](#ftpgetnextqueuedfile-function)
- [FtpGetQueuedFile](#ftpgetqueuedfile-function)
- [FtpRemoveQueuedFile](#ftpremovequeuedfile-function)

---

## FtpAddQueuedFileEx Function

Add a new file to the queue with additional transfer options

### Prototype

```c
DWORD WINAPI FtpAddQueuedFileEx(
    HQUEUE hQueue,
    DWORD dwQueueMode,
    LPCTSTR lpszHostName,
    UINT nHostPort,
    LPCTSTR lpszUserName,
    LPCTSTR lpszPassword,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    UINT nFileType,
    UINT nTimeout,
    LPVOID lpvReserved
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `dwQueueMode` | `DWORD` | An integer value which specifies if the file should be downloaded from the server or uploaded to the server. This parameter must be one of the following options and cannot have a value of zero. |
| `lpszHostName` | `LPCTSTR` | A pointer to the name of the server to establish a connection with. This may be a fully-qualified domain name or an IP address. If this parameter is NULL or points to an empty string, the lpszRemoteFile parameter must specify a complete URL which identifies the server as well as the path to the remote file. |
| `nHostPort` | `UINT` | The port number which should be used when establishing the connection. A value of zero specifies that the default port number should be used. For standard connections, the default port number is 21. For secure connections, the default port number is 990. If this parameter is zero and a URL is specified with the lpszRemoteFile parameter, the port number included in the URL will be used as the default value. |
| `lpszUserName` | `LPCTSTR` | Points to a null terminated string which specifies the user name to be used to authenticate the connection. If this parameter is NULL or an empty string, then the login is considered to be anonymous. Note that anonymous logins are not supported for secure connections using the SSH protocol. |
| `lpszPassword` | `LPCTSTR` | Points to a null terminated string which specifies the password to be used to authenticate the current client session. This parameter may be NULL or an empty string if no password is required for the specified user, or if no username has been specified. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the local file to be queued for transfer. This parameter cannot be NULL or point to an empty string. If the file is being queued for an upload, the file must exist on the local system or the function will fail. If the file is being downloaded, it will be created or replaced on the local system. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the file on the server. If the file is being downloaded, the file must exist on the server or the transfer will fail. If the file is being uploaded, the file will be created or replaced on the server. This parameter may specify a complete URL. Note that any values you specify as arguments to this function will override the values specified in the URL. If you want to use a URL as the remote file name, the lpszHostName parameter should be NULL and the nHostPort parameter should be zero. |
| `dwOptions` | `DWORD` | An unsigned integer value which specifies one or more options. This parameter is constructed by using a bitwise operator and can be any of the options used with the FtpConnect function. If this value is zero, the default options for the queue will be used. The most common options are: |
| `nFileType` | `UINT` | An integer value which specifies the type of file being transferred. It can be one of the following values: |
| `nTimeout` | `UINT` | The number of seconds to wait for a response from the server before failing the file transfer. If this value is zero, the default timeout period for the queue will be used. |
| `lpvReserved` | `LPVOID` | A reserved parameter which should always be NULL. |

### Options

- **dwQueueMode** Parameter

    - `FTP_QUEUE_DOWNLOAD`: The file should be queued for downloading from the server to the local system.
    - `FTP_QUEUE_UPLOAD`: The file should be queued for uploading from the local system to the server.
- **dwOptions** Parameter

    - `FTP_OPTION_PASSIVE`: This option specifies the file transfer should attempt to establish the data connection with the server. If the local system is behind a firewall or a NAT router, the server may not be able to establish a data connection back to the client and the transfer will fail. This option forces the client to establish an outbound data connection with the server. It is recommended that applications use passive mode whenever possible.
    - `FTP_OPTION_FIREWALL`: This option specifies the file transfer should always use the host IP address to establish the data connection with the server, not the address returned by the server in response to the PASV command. This option may be necessary if the server is behind a router that performs Network Address Translation (NAT) and it returns an unreachable IP address for the data connection. If this option is specified, it will also enable passive mode data transfers.
    - `FTP_OPTION_SECURE`: This option specifies the file transfer should attempt to establish a secure connection with the server by default. This option is the same as specifying FTP_OPTION_SECURE_IMPLICIT which immediately performs the TLS protocol negotiation when the connection is established.
    - `FTP_OPTION_SECURE_IMPLICIT`: This option specifies the file transfer should attempt to immediately establish secure TLS connection with the server by default. This option is typically used when connecting to a server on port 990, which is the default port number used for FTPS.
    - `FTP_OPTION_SECURE_EXPLICIT`: This option specifies the file transfer should establish a standard connection to the server and then use the AUTH command to negotiate an explicit secure connection. This option is typically used when connecting to the server on ports other than 990.
    - `FTP_OPTION_SECURE_SHELL`: This option specifies the file transfer should use the Secure Shell (SSH) protocol to establish the connection by default. This option will automatically be selected if the connection is established using port 22, the default port for SSH.
- **nFileType** Parameter

    - `FILE_TYPE_AUTO`: The file type should be automatically determined based on the file name extension. If the file extension is unknown, the file type should be determined based on the contents of the file. The library has an internal list of common text file extensions, and additional file extensions can be registered using the FtpRegisterFileType function.
    - `FILE_TYPE_ASCII`: The file is a text file using the ASCII character set. For those servers which mark the end of a line with characters other than a carriage return and linefeed, it will be converted to the native client format. This is the file type used for directory listings.
    - `FILE_TYPE_EBCDIC`: The file is a text file using the EBCDIC character set. Local files will be converted to EBCDIC when sent to the server. Remote files will be converted to the native ASCII character set when retrieved from the server. Not all servers support this file type. It is recommended that you only specify this type if you know that it is required by the server to transfer data correctly.
    - `FILE_TYPE_IMAGE`: The file is a binary file and no data conversion of any type is performed on the file. This is the default file type for most data files and executable programs. If the type of file cannot be automatically determined, it will always be considered a binary file. If this file type is specified when uploading or downloading text files, the native end-of-line character sequences will be preserved.
    - `FILE_TYPE_LOCAL`: The file is a binary file that uses the local byte size for the server platform. On most servers, this file type is considered to be the same as FILE_TYPE_IMAGE. Not all servers support this file type. It is recommended that you only specify this type if you know that it is required by the server to transfer data correctly.

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is a unique identifier which corresponds to the queued file. If the function fails, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- This function will add a file to the current transfer queue. If successful, the value returned is a unique integer which identifies that file in the queue. To obtain information about the queued file, you can call the FtpGetQueuedFile function and provide this return value as the dwFileId parameter. To remove a file from the queue, use the FtpRemoveQueuedFile function.
- Files can only be added to the queue when in an idle or paused state. If you attempt to add a file to the queue while the queue manager is transferring files, the function will fail. To determine the current state of the queue, call the FtpGetQueueStatus function
- There are no fixed limits to the number of files which can be queued for transfer. To release the memory allocated for the queue, call the FtpClearQueue function. To determine the current status of the queue, including how many file transfers have been queued and how many are pending completion, call the FtpGetQueueStatus function.
- If the local file name includes environment variables enclosed in percentage (%) symbols, those values will automatically be expanded based on the environment variables defined for the current user using the ExpandEnvironmentStrings function in the Windows API. Note that environment variable names are not case-sensitive.
- This function will not immediately begin the process of uploading or downloading the file. It will only add the transfer request to the current queue. The file transfers are managed by a background worker thread which is created when the FtpStartQueue function is called.

### Example

```cpp
// Create a new queue
HQUEUE hQueue = FtpCreateQueue(INFINITE, FTP_TIMEOUT, FTP_OPTION_DEFAULT);

if (hQueue == INVALID_QUEUE)
	return;

// Add a file to the queue
DWORD dwFileId = FtpAddQueuedFileEx(
					hQueue,
					FTP_QUEUE_DOWNLOAD,
					lpszHostName,
					FTP_PORT_DEFAULT,
					lpszUserName,
					lpszPassword,
					lpszLocalFile,
					lpszRemoteFile,
					FTP_OPTION_DEFAULT,
					FILE_TYPE_AUTO,
					FTP_TIMEOUT,
					NULL);

// Display information about the queued file
if (dwFileId != 0)
{
	FTPQUEUEDFILE queuedFile;

	if (FtpGetQueuedFile(hQueue, dwFileId, &queuedFile))
	{
		switch (queuedFile.dwMode)
		{
		case FTP_QUEUE_DOWNLOAD:
			_tprintf(_T("%u: Download \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szRemoteFile,
						queuedFile.szLocalFile);
				break;

		case FTP_QUEUE_UPLOAD:
			_tprintf(_T("%u: Upload \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szLocalFile,
						queuedFile.szRemoteFile);
				break;
		}
	}
}

// Start the queued file transfers and wait for it to complete
if (FtpStartQueue(hQueue, FTP_QUEUE_ALL, 0, NULL, 0))
{
	FtpWaitForQueue(hQueue, INFINITE, &dwElapsed, &dwError);
	FtpStopQueue(hQueue);
}

// Remove all files from the queue
FtpDeleteQueue(hQueue);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAddQueuedFile](#ftpaddqueuedfile-function)
- [FtpCreateQueue](#ftpcreatequeue-function)
- [FtpDeleteQueue](#ftpdeletequeue-function)
- [FtpFindQueuedFile](#ftpfindqueuedfile-function)
- [FtpGetFirstQueuedFile](#ftpgetfirstqueuedfile-function)
- [FtpGetNextQueuedFile](#ftpgetnextqueuedfile-function)
- [FtpGetQueuedFile](#ftpgetqueuedfile-function)
- [FtpRemoveQueuedFile](#ftpremovequeuedfile-function)

---

## FtpAllocate Function

Allocate the specified number of bytes on the server

### Prototype

```c
INT WINAPI FtpAllocate(
    HCLIENT hClient,
    DWORD dwFileLength,
    DWORD dwRecSize
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `dwFileLength` | `DWORD` | The number of bytes to allocate storage for on the server. |
| `dwRecSize` | `DWORD` | The maximum record or page size for the file. A value of zero indicates that the file does not have a record or page structure, and the parameter is ignored. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function should be called immediately before the FtpOpenFile function.
- This function is ignored by those servers which do not require that the maximum size of the file be declared beforehand. The most common FTP servers running under UNIX and Windows do not require that file space be pre-allocated.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpOpenFile](#ftpopenfile-function)
- [FtpSetFileMode](#ftpsetfilemode-function)
- [FtpSetFileStructure](#ftpsetfilestructure-function)
- [FtpSetFileType](#ftpsetfiletype-function)

---

## FtpAsyncConnect Function

Connect asynchronously to the specified server

### Prototype

```c
HCLIENT WINAPI FtpAsyncConnect(
    LPCTSTR lpszRemoteHost,
    UINT nRemotePort,
    LPCTSTR lpszUserName,
    LPCTSTR lpszPassword,
    UINT nTimeout,
    DWORD dwOptions,
    LPSECURITYCREDENTIALS lpCredentials,
    HWND hEventWnd,
    UINT uEventMsg
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszRemoteHost` | `LPCTSTR` | A pointer to the name of the server to connect to; this may be a fully-qualified domain name or an IP address. |
| `nRemotePort` | `UINT` | The port number the server is listening on. A value of zero specifies that the default port number should be used. For standard connections, the default port number is 21. For secure connections, the default port number is 990. If the secure port number is specified, an implicit TLS connection will be established by default. |
| `lpszUserName` | `LPCTSTR` | Points to a string that specifies the user name to be used to authenticate the current client session. If this parameter is NULL or an empty string, then the login is considered to be anonymous. Note that anonymous logins are not supported for secure connections using the SSH protocol. |
| `lpszPassword` | `LPCTSTR` | Points to a string that specifies the password to be used to authenticate the current client session. This parameter may be NULL or an empty string if no password is required for the specified user, or if no username has been specified. |
| `nTimeout` | `UINT` | The number of seconds that the client will wait for a response from the server before failing the current operation. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `lpCredentials` | `LPSECURITYCREDENTIALS` | A pointer to a SECURITYCREDENTIALS structure. This parameter should be NULL if the connection is not secure or when client credentials are not required. Most servers do not require a client certificate to establish a secure connection. However, if the server does require a client certificate, the structure members dwSize, lpszCertStore and lpszCertName must be defined. Undefined structure members must be initialized to a value of zero or NULL and the dwSize member must be initialized to the size of the SECURITYCREDENTIALS structure. |
| `hEventWnd` | `HWND` | The handle to the event notification window. This window receives messages which notify the client of various asynchronous network events that occur. |
| `uEventMsg` | `UINT` | The message identifier that is used when an asynchronous network event occurs. This value should be greater than WM_USER as defined in the Windows header files. |

### Options

- **dwOptions** Parameter

    - `FTP_OPTION_DEFAULT`: Default options should be used for file transfers. This is the same as specifying that all file transfers should use passive mode when establishing a data connection with the server. It is recommended most applications use passive mode to prevent potential compatibility issues with certain types of firewalls and routers which use Network Address Translation (NAT).
    - `FTP_OPTION_PASSIVE`: This option specifies file transfers should attempt to establish the data connection with the server. If the local system is behind a firewall or a NAT router, the server may not be able to establish a data connection back to the client and the transfer will fail. This option forces the client to establish an outbound data connection with the server. It is recommended that applications use passive mode whenever possible.
    - `FTP_OPTION_FIREWALL`: This option specifies the client should always use the host IP address to establish the data connection with the server, not the address returned by the server in response to the PASV command. This option may be necessary if the server is behind a router that performs Network Address Translation (NAT) and it returns an unreachable IP address for the data connection. If this option is specified, it will also enable passive mode data transfers.
    - `FTP_OPTION_NOAUTH`: This option specifies the server does not require authentication, or that it requires an alternate authentication method. When this option is used, the client connection is flagged as authenticated as soon as the connection to the server has been established. Note that using this option to bypass authentication may result in subsequent errors when attempting to retrieve a directory listing or transfer a file. It is recommended that you consult the technical reference documentation for the server to determine its specific authentication requirements.
    - `FTP_OPTION_KEEPALIVE`: This option specifies the client should attempt to keep the connection with the server active for an extended period of time. It is important to note that regardless of this option, the server may still choose to disconnect client sessions that are holding the command channel open but are not performing file transfers.
    - `FTP_OPTION_NOAUTHRSA`: This option specifies that RSA authentication should not be used with SSH-1 connections. This option is ignored with SSH-2 connections and should only be specified if required by the server. This option has no effect on standard or secure connections using TLS.
    - `FTP_OPTION_NOPWDNUL`: This option specifies the user password cannot be terminated with a null character. This option is ignored with SSH-2 connections and should only be specified if required by the server. This option has no effect on standard or secure connections using TLS.
    - `FTP_OPTION_NOREKEY`: This option specifies the client should never attempt a repeat key exchange with the server. Some SSH servers do not support rekeying the session, and this can cause the client to become non-responsive or abort the connection after being connected for an hour. This option has no effect on standard or secure connections using TLS.
    - `FTP_OPTION_COMPATSID`: This compatibility option changes how the session ID is handled during public key authentication with older SSH servers. This option should only be specified when connecting to servers that use OpenSSH 2.2.0 or earlier versions. This option has no effect on standard or secure connections using SSL.
    - `FTP_OPTION_COMPATHMAC`: This compatibility option changes how the HMAC authentication codes are generated. This option should only be specified when connecting to servers that use OpenSSH 2.2.0 or earlier versions. This option has no effect on standard or secure connections using TLS.
    - `FTP_OPTION_VIRTUALHOST`: This option specifies the server supports virtual hosting, where multiple domains are hosted by a server using the same external IP address. If this option is enabled, the client will send the HOST command to the server upon establishing a connection.
    - `FTP_OPTION_VERIFY`: This option specifies that file transfers should be automatically verified after the transfer has completed. If the server supports the XMD5 command, the transfer will be verified by calculating an MD5 hash of the file contents. If the server does not support the XMD5 command, but does support the XCRC command, the transfer will be verified by calculating a CRC32 checksum of the file contents. If neither the XMD5 or XCRC commands are supported, the transfer is verified by comparing the size of the file. Automatic file verification is only performed for binary mode transfers because of the end-of-line conversion that may occur when text files are uploaded or downloaded.
    - `FTP_OPTION_TRUSTEDSITE`: This option specifies the server is trusted. The server certificate will not be validated and the connection will always be permitted. This option only affects connections using the TLS protocol.
    - `FTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. This option is the same as specifying FTP_OPTION_SECURE_IMPLICIT which immediately performs the TLS protocol negotiation when the connection is established.
    - `FTP_OPTION_SECURE_IMPLICIT`: This option specifies the client should attempt to immediately establish secure TLS connection with the server. This option is typically used when connecting to a server on port 990, which is the default port number used for FTPS.
    - `FTP_OPTION_SECURE_EXPLICIT`: This option specifies the client should establish a standard connection to the server and then use the AUTH command to negotiate an explicit secure connection. This option is typically used when connecting to the server on ports other than 990.
    - `FTP_OPTION_SECURE_SHELL`: This option specifies the client should use the Secure Shell (SSH) protocol to establish the connection. This option will automatically be selected if the connection is established using port 22, the default port for SSH.
    - `FTP_OPTION_SECURE_FALLBACK`: This option specifies the client should permit the use of less secure cipher suites for compatibility with legacy servers. If this option is specified, the client will allow connections using TLS 1.0 and cipher suites that use RC4, MD5 and SHA1.
    - `FTP_OPTION_TUNNEL`: This option specifies that a tunneled TCP connection and/or port-forwarding is being used to establish the connection to the server. This changes the behavior of the client with regards to internal checks of the destination IP address and remote port number, default capability selection and how the connection is established. This option also forces all connections to be outbound and enables the firewall compatibility features in the client.
    - `FTP_OPTION_KEEPALIVE_DATA`: This option specifies the client should attempt to keep the control connection active during a file transfer. Normally, when a data transfer is in progress, no additional commands are issued on the control channel until the transfer completes. Specifying this option automatically enables the FTP_OPTION_KEEPALIVE option and forces the client to continue to issue NOOP commands during the file transfer. This option only applies to FTP and FTPS connections and has no effect on connections using SFTP (SSH).
    - `FTP_OPTION_PREFER_IPV6`: This option specifies the client should prefer the use of IPv6 if the server hostname can be resolved to both an IPv6 and IPv4 address. This option is ignored if the local system does not have IPv6 enabled, or when the hostname can only be resolved to an IPv4 address. If the server hostname can only be resolved to an IPv6 address, the client will attempt to establish a connection using IPv6 regardless if this option has been specified.
    - `FTP_OPTION_FREETHREAD`: This option specifies the handle returned by this function may be used by any thread, and is not limited to the thread which created it. The application is responsible for ensuring that access to the handle is synchronized across multiple threads.
    - `FTP_OPTION_HIRES_TIMER`: This option specifies the elapsed time for data transfers should be returned in milliseconds instead of seconds. This will return more accurate transfer times for smaller files being uploaded or downloaded using fast network connections.
    - `FTP_OPTION_TLS_REUSE`: This option specifies that TLS session reuse should be enabled for secure connections. This option is only supported on Windows 8.1 or Windows Server 2012 R2 and later platforms, and it should only be used when explicitly required by the server. This option is not compatible with servers built using OpenSSL 1.0.2 and earlier versions which do not provide Extended Master Secret (EMS) support as outlined in RFC7627.

### Return Value

- **Type**: `HCLIENT`
- If the function succeeds, the return value is a handle to a client session. If the function fails, the return value is INVALID_CLIENT. To get extended error information, call FtpGetLastError.

### Remarks

- When a message is posted to the notification window, the low word of the lParam parameter contains the event identifier. The high word of lParam contains the low word of the error code, if an error has occurred. The wParam parameter contains the client handle. One or more of the following event identifiers may be sent:

### Example

```cpp
// The Ipswitch WS_FTP server accepts the AUTH command to establish
// an explicit TLS session on the default FTP port     
hClient = FtpAsyncConnect(lpszRemoteHost,
						FTP_PORT_DEFAULT,
						FTP_TIMEOUT,
						FTP_OPTION_SECURE_EXPLICIT,
						NULL,
						hEventWnd,
						uEventMsg);      

// When the GlobalSCAPE Secure FTP server is configured in implicit
// authorization mode, it negotiates a secure session as soon as the
// connection is established and does not require a command      
hClient = FtpAsyncConnect(lpszRemoteHost,
						FTP_PORT_SECURE,
						FTP_TIMEOUT,
						FTP_OPTION_SECURE_IMPLICIT,
						NULL,
						hEventWnd,
						uEventMsg);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAsyncProxyConnect](#ftpasyncproxyconnect-function)
- [FtpConnect](#ftpconnect-function)
- [FtpCreateSecurityCredentials](#ftpcreatesecuritycredentials-function)
- [FtpDeleteSecurityCredentials](#ftpdeletesecuritycredentials-function)
- [FtpDisconnect](#ftpdisconnect-function)
- [FtpGetSecurityInformation](#ftpgetsecurityinformation-function)
- [FtpInitialize](#ftpinitialize-function)
- [FtpProxyConnect](#ftpproxyconnect-function)
- [FtpSetChannelMode](#ftpsetchannelmode-function)

---

## FtpAsyncFileList Function

Return an unparsed list of files in the specified directory

### Prototype

```c
UINT WINAPI FtpAsyncFileList(
    HCLIENT hClient,
    LPCTSTR lpszDirectory,
    DWORD dwOptions,
    LPTSTR lpszBuffer,
    INT nMaxLength,
    FTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszDirectory` | `LPCTSTR` | A pointer to a string that specifies the name of a directory and/or a wildcard file mask. The format of the directory name must match the file naming conventions of the server. If this parameter is NULL or points to an empty string, the current working directory will be used. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter may be any one of the following values: |
| `lpszBuffer` | `LPTSTR` | A pointer to a string buffer that will contain the list of files when the function returns. This buffer should be large enough to store the complete file listing and a terminating null character. If the buffer is smaller than the total amount of data returned by the server, the data will be truncated. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. |
| `lpEventProc` | `FTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the FtpEventProc callback function. This parameter may be NULL if you do not wish to implement an event handler. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. This parameter is ignored if the lpEventProc parameter is NULL. |

### Options

- **dwOptions** Parameter

    - `FTP_LIST_DEFAULT`: This option specifies the server should return a complete listing of files in the specified directory with as much detail as possible. This typically means that the file size, date, ownership and access rights will be returned to the client. Information about the files are returned in lines of text, with each line terminated by carriage return and linefeed (CRLF) characters. The exact format of the data returned is specific to the server operating system.
    - `FTP_LIST_NAMEONLY`: This option specifies the server should only return a list of file names, with no additional information about the file. Each file name is terminated by carriage return and linefeed (CRLF) characters.

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the function fails, the return value is zero. To get extended error information, call the FtpGetLastError function.

### Remarks

- The FtpAsyncFileList function returns a list of files in the specified directory, copying the data to a string buffer. This function is similar to the FtpGetFileList function, however it retrieves the list of files asynchronously using a background worker thread and does not block the current working thread. This enables the application to continue to perform other operations while the file listing is being returned by the server.
- Because this function works asynchronously, it is important that the memory allocated for the buffer is not released before the asynchronous task completes. If you provide a buffer that is allocated on the stack, such as with the example listed below, then you must ensure that your code does not return from the function while the directory listing is being retrieved. In the example, this is achieved by calling the FtpTaskWait function. You can also perform other operation and poll the status of the task by calling the FtpTaskDone function. If you wish to return from the calling function immediately, then you must dynamically allocate memory for the lpszBuffer parameter on the heap and free that memory after the task has completed and the data is no longer needed.
- If the address of an event handler is provided to this function, it is guaranteed that the handler will be invoked with the FTP_EVENT_CONNECT event after the connection has been established, and the FTP_EVENT_DISCONNECT event after the directory listing has completed. This enables your application to know when the directory listing is about to begin, and immediately before the worker thread is terminated. The worker thread creates a secondary connection to the server with its own session handle. This ensures that the asynchronous operation will not interfere with the current client session. Your application can interact with this background worker thread using the client handle that is passed to the event handler.
- This function can be particularly useful when the client is connected to a server that returns file listings in a format that is not recognized by the library. The application can retrieve the unparsed file listing from the server and parse the contents. Note that if you specify the FTP_LIST_NAMEONLY option, the data will only contain a list of file names and there will be no way for the application to know if they represent a regular file or a subdirectory.
- This function is supported for both FTP and SFTP (SSH) connections, however the format of the data may differ depending on which protocol is used. Most UNIX based FTP servers will not list files and subdirectories that begin with a period, however most SFTP servers will return a list of all files, even those that begin with a period.

### Example

```cpp
TCHAR szFileList[MAXFILELISTSIZE];
UINT nTaskId;

nTaskId = FtpAsyncFileList(hClient,
						NULL,
						FTP_LIST_DEFAULT,
						szFileList,
						MAXFILELISTSIZE,
						NULL, 0);

if (nTaskId == 0)
{
	_tprintf(_T("Unable to list files (error 0x%08lx)\n"), FtpGetLastError());
	return;
}
else
{
	DWORD dwError = NO_ERROR;
	DWORD dwElapsed = 0;

	FtpTaskWait(nTaskId, INFINTE, &dwElapsed, &dwError);
	_tprintf(_T("Asynchronous file listing returned in %lu milliseconds\n"), dwElapsed);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpEventProc](#ftpeventproc-function)
- [FtpGetFileList](#ftpgetfilelist-function)
- [FtpTaskWait](#ftptaskwait-function)

---

## FtpAsyncGetData Function

Copy the contents of a remote file to a local buffer

### Prototype

```c
UINT WINAPI FtpAsyncGetData(
    HCLIENT hClient,
    LPCTSTR lpszRemoteFile,
    LPVOID lpvBuffer,
    LPDWORD lpdwLength,
    DWORD dwReserved,
    FTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be transferred to the local system. The file naming conventions must be that of the host operating system. |
| `lpvBuffer` | `LPVOID` | A pointer to a byte buffer which will contain the data transferred from the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpdwLength` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvBuffer parameter. If the lpvBuffer parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the actual length of the file that was downloaded. |
| `dwReserved` | `DWORD` | A reserved parameter. This value should always be zero. |
| `lpEventProc` | `FTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the FtpEventProc callback function. This parameter may be NULL if you do not wish to implement an event handler. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. This parameter is ignored if the lpEventProc parameter is NULL. |

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the function fails, the return value is zero. To get extended error information, call the FtpGetLastError function. The application should treat the task ID as an opaque value and never make an assumption about the sequence in which IDs are assigned to a background task.

### Remarks

- The FtpAsyncGetData function is used to download the contents of a remote file into a local buffer. This function is similar to the FtpGetData function, however it retrieves the contents of the file using a background worker thread and does not block the current working thread. This enables the application to continue to perform other operations while the file is being copied to the local system.
- Because this function works asynchronously, it is important that the memory allocated for the buffer is not released before the asynchronous task completes. If you provide a buffer that is allocated on the stack, such as with the example listed below, then you must ensure that your code does not return from the function while the data is being downloaded. In the example, this is achieved by calling the FtpTaskWait function. You can also perform other operation and poll the status of the task by calling the FtpTaskDone function. If you wish to return from the calling function immediately, then you must dynamically allocate memory for the lpvBuffer and lpdwLength parameters on the heap and free that memory after the task has completed and the data is no longer needed.
- If the address of an event handler is provided to this function, it is guaranteed that the handler will be invoked with the FTP_EVENT_CONNECT event after the connection has been established, and the FTP_EVENT_DISCONNECT event after the transfer has completed. This enables your application to know when the data transfer is about to begin, and immediately before the worker thread is terminated. The worker thread creates a secondary connection to the server with its own session handle. This ensures that the asynchronous operation will not interfere with the current client session. Your application can interact with this background worker thread using the client handle that is passed to the event handler.
- The lpBuffer parameter may be specified in one of two ways, depending on the needs of the application. It can either be a pre-allocated buffer large enough to store the contents of the file or it can specify the address of a global memory handle that will contain the data. If it points to a pre-allocated buffer, the lpdwLength parameter must be initialized to the maximum number of bytes that can be copied into the buffer. If specifies the address of a global memory handle, then lpdwLength must be initialized to a value of zero. See the example code below.

### Example

```cpp
HGLOBAL hgblBuffer = NULL;
DWORD dwLength = 0;
UINT nTaskId;

// Return the file data into block of global memory allocated by
// the GlobalAlloc function; the handle to this memory will be
// returned in the hgblBuffer parameter

nTaskId = FtpAsyncGetData(hClient,
						lpszFileName,
						&hgblBuffer,
						&dwLength, 
						0, NULL, 0);

if (nTaskId != 0)
{
	DWORD dwError = NO_ERROR;
	DWORD dwElapsed = 0;

	// Wait for the transfer to complete
	FtpTaskWait(nTaskId, INFINTE, &dwElapsed, &dwError);

	// Lock the global memory handle, returning a pointer to the
	// contents of the file data
	lpBuffer = (LPBYTE)GlobalLock(hgblBuffer);
	
	// After the data has been used, the handle must be unlocked
	// and freed, otherwise a memory leak will occur
	GlobalUnlock(hgblBuffer);
	GlobalFree(hgblBuffer);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAsyncGetFile](#ftpasyncgetfile-function)
- [FtpAsyncPutData](#ftpasyncputdata-function)
- [FtpAsyncPutFile](#ftpasyncputfile-function)
- [FtpEventProc](#ftpeventproc-function)
- [FtpGetFile](#ftpgetfile-function)
- [FtpTaskWait](#ftptaskwait-function)

---

## FtpAsyncGetFile Function

Copy a file from the server to the local system

### Prototype

```c
UINT WINAPI FtpAsyncGetFile(
    HCLIENT hClient,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    DWORD dwOffset,
    FTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file on the local system that will be created, overwritten or appended to. The file pathing and name conventions must be that of the local host. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be transferred to the local system. The file naming conventions must be that of the host operating system. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter may be any one of the following values: |
| `dwOffset` | `DWORD` | A byte offset which specifies where the file transfer should begin. The default value of zero specifies that the file transfer should start at the beginning of the file. A value greater than zero is typically used to restart a transfer that has not completed successfully. Note that specifying a non-zero offset requires that the server support the REST command to restart transfers. |
| `lpEventProc` | `FTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the FtpEventProc callback function. This parameter may be NULL if you do not wish to implement an event handler. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. This parameter is ignored if the lpEventProc parameter is NULL. |

### Options

- **dwOptions** Parameter

    - `FTP_TRANSFER_DEFAULT`: This option specifies the default transfer mode should be used. If the local file exists, it will be overwritten with the contents of the downloaded file.
    - `FTP_TRANSFER_APPEND`: This option specifies that if the local file exists, the contents of file on the server is appended to the local file. If the local file does not exist, it is created.

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the function fails, the return value is zero. To get extended error information, call the FtpGetLastError function. The application should treat the task ID as an opaque value and never make an assumption about the sequence in which IDs are assigned to a background task.

### Remarks

- The FtpAsyncGetFile function is used to download the contents of a remote file to a file on the local system. This function is similar to the FtpGetFile function, however it retrieves the file using a background worker thread and does not block the current working thread. This enables the application to continue to perform other operations while the file is being transferred to the local system.
- If the address of an event handler is provided to this function, it is guaranteed that the handler will be invoked with the FTP_EVENT_CONNECT event after the connection has been established, and the FTP_EVENT_DISCONNECT event after the transfer has completed. This enables your application to know when the file transfer is about to begin, and immediately before the worker thread is terminated. During the file transfer, the callback function will be invoked periodically with the FTP_EVENT_PROGRESS event. The client session handle is passed to the event handler, allowing you to call functions such as FtpGetTransferStatus to determine the amount of data that has been copied.
- To determine when the transfer has completed without implementing an event handler, periodically call the FtpTaskDone function. If you wish to block the current thread and wait for the transfer to complete, call the FtpTaskWait function. To stop a background file transfer that is in progress, call the FtpTaskAbort function. This will signal the background worker thread to cancel the transfer and terminate the session.
- This function can be called multiple times to download multiple files in the background; however, most servers limit the number of simultaneous connections that can originate from a single IP address. It is recommended that you only perform two simultaneous background transfers from the same server at any one time. The application should not make any assumptions about the order in which multiple background transfers may complete or how they are sequenced. For example, it should never be assumed that a background task with a lower task ID will complete before a task with a higher ID value.

### Example

```cpp
UINT nTaskId;

// Begin a file transfer in the background

nTaskId = FtpAsyncGetFile(hClient,
						lpszLocalFile,
						lpszRemoteFile,
						FTP_TRANSFER_DEFAULT,
						0,
						NULL,
						0);

if (nTaskId != 0)
{
	DWORD dwError = NO_ERROR;
	DWORD dwElapsed = 0;

	// Wait for the transfer to complete
	FtpTaskWait(nTaskId, INFINTE, &dwElapsed, &dwError);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAsyncGetData](#ftpasyncgetdata-function)
- [FtpAsyncPutData](#ftpasyncputdata-function)
- [FtpAsyncPutFile](#ftpasyncputfile-function)
- [FtpEventProc](#ftpeventproc-function)
- [FtpGetFile](#ftpgetfile-function)
- [FtpTaskDone](#ftptaskdone-function)
- [FtpTaskWait](#ftptaskwait-function)

---

## FtpAsyncGetFileEx Function

Copy a file from the server to the local system, supporting files larger than 4GB

### Prototype

```c
UINT WINAPI FtpAsyncGetFileEx(
    HCLIENT hClient,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    ULARGE_INTEGER uiOffset,
    FTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file on the local system that will be created, overwritten or appended to. The file pathing and name conventions must be that of the local host. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be transferred to the local system. The file naming conventions must be that of the host operating system. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter may be any one of the following values: |
| `uiOffset` | `ULARGE_INTEGER` | A byte offset which specifies where the file transfer should begin. The default value of zero specifies that the file transfer should start at the beginning of the file. A value greater than zero is typically used to restart a transfer that has not completed successfully. Note that specifying a non-zero offset requires that the server support the REST command to restart transfers. |
| `lpEventProc` | `FTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the FtpEventProc callback function. This parameter may be NULL if you do not wish to implement an event handler. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. This parameter is ignored if the lpEventProc parameter is NULL. |

### Options

- **dwOptions** Parameter

    - `FTP_TRANSFER_DEFAULT`: This option specifies the default transfer mode should be used. If the local file exists, it will be overwritten with the contents of the downloaded file.
    - `FTP_TRANSFER_APPEND`: This option specifies that if the local file exists, the contents of file on the server is appended to the local file. If the local file does not exist, it is created.

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the function fails, the return value is zero. To get extended error information, call the FtpGetLastError function. The application should treat the task ID as an opaque value and never make an assumption about the sequence in which IDs are assigned to a background task.

### Remarks

- The FtpAsyncGetFileEx function is used to download the contents of a remote file to a file on the local system. This function is similar to the FtpGetFileEx function, however it retrieves the file using a background worker thread and does not block the current working thread. This enables the application to continue to perform other operations while the file is being transferred to the local system.
- If the address of an event handler is provided to this function, it is guaranteed that the handler will be invoked with the FTP_EVENT_CONNECT event after the connection has been established, and the FTP_EVENT_DISCONNECT event after the transfer has completed. This enables your application to know when the file transfer is about to begin, and immediately before the worker thread is terminated. During the file transfer, the callback function will be invoked periodically with the FTP_EVENT_PROGRESS event. The client session handle is passed to the event handler, allowing you to call functions such as FtpGetTransferStatusEx to determine the amount of data that has been copied.
- To determine when the transfer has completed without implementing an event handler, periodically call the FtpTaskDone function. If you wish to block the current thread and wait for the transfer to complete, call the FtpTaskWait function. To stop a background file transfer that is in progress, call the FtpTaskAbort function. This will signal the background worker thread to cancel the transfer and terminate the session.
- This function can be called multiple times to download multiple files in the background; however, most servers limit the number of simultaneous connections that can originate from a single IP address. It is recommended that you only perform two simultaneous background transfers from the same server at any one time. The application should not make any assumptions about the order in which multiple background transfers may complete or how they are sequenced. For example, it should never be assumed that a background task with a lower task ID will complete before a task with a higher ID value.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAsyncPutFileEx](#ftpasyncputfileex-function)
- [FtpEventProc](#ftpeventproc-function)
- [FtpGetFileEx](#ftpgetfileex-function)
- [FtpPutFileEx](#ftpputfileex-function)
- [FtpTaskDone](#ftptaskdone-function)
- [FtpTaskWait](#ftptaskwait-function)

---

## FtpAsyncProxyConnect Function

Connect asynchronously to the specified proxy server

### Prototype

```c
HCLIENT WINAPI FtpAsyncProxyConnect(
    UINT nProxyType,
    LPCTSTR lpszProxyHost,
    UINT nProxyPort,
    LPCTSTR lpszProxyUser,
    LPCTSTR lpszProxyPassword,
    LPCTSTR lpszRemoteHost,
    UINT nRemotePort,
    UINT nTimeout,
    DWORD dwOptions,
    LPSECURITYCREDENTIALS lpCredentials,
    HWND hEventWnd,
    UINT uEventMsg
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nProxyType` | `UINT` | An identifier which specifies the type of proxy server that is being connected to. This value must be defined as one of the following values: |
| `lpszProxyHost` | `LPCTSTR` | A pointer to the name of the proxy server to connect through; this may be a fully-qualified domain name or an IP address. |
| `nProxyPort` | `UINT` | The port number the proxy server is listening on; a value of zero specifies that the default port number should be used. |
| `lpszProxyUser` | `LPCTSTR` | A pointer to the user name used to authenticate the client on the proxy server. Not all proxy servers require this information; it is recommended that you consult the proxy server documentation to determine if a username is required. |
| `lpszProxyPassword` | `LPCTSTR` | A pointer to the password used to authenticate the client on the proxy server. Not all proxy servers require this information; it is recommended that you consult the proxy server documentation to determine if a password is required. |
| `lpszRemoteHost` | `LPCTSTR` | A pointer to the name of the server to connect to; this may be a fully-qualified domain name or an IP address. |
| `nRemotePort` | `UINT` | The port number the server is listening on; a value of zero specifies that the default port number should be used. For standard connections, the default port number is 21. For secure connections, the default port number is 990. If the secure port number is specified, an implicit TLS connection will be established by default. |
| `nTimeout` | `UINT` | The number of seconds that the client will wait for a response from the server before failing the current operation. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `lpCredentials` | `LPSECURITYCREDENTIALS` | A pointer to a SECURITYCREDENTIALS structure. This parameter should be NULL if the connection is not secure or when client credentials are not required. Most servers do not require a client certificate to establish a secure connection. However, if the server does require a client certificate, the structure members dwSize, lpszCertStore and lpszCertName must be defined. Undefined structure members must be initialized to a value of zero or NULL and the dwSize member must be initialized to the size of the SECURITYCREDENTIALS structure. |
| `hEventWnd` | `HWND` | The handle to the event notification window. This window receives messages which notify the client of various asynchronous network events that occur. |
| `uEventMsg` | `UINT` | The message identifier that is used when an asynchronous network event occurs. This value should be greater than WM_USER as defined in the Windows header files. |

### Options

- **nProxyType** Parameter

    - `FTP_PROXY_NONE`: This value specifies that no proxy server is being used. In this case, the FtpConnect function is called directly, ignoring the proxy parameters.
    - `FTP_PROXY_USER`: This value specifies that the client is not logged into the proxy server. The USER command is sent in the format username@ftpsite followed by the password. This is the format used with the Gauntlet proxy server.
    - `FTP_PROXY_LOGIN`: This value specifies that the client is logged into the proxy server. The USER command is then sent in the format username@ftpsite followed by the password. This is the format used by the InterLock proxy server.
    - `FTP_PROXY_OPEN`: This value specifies that the client is not logged into the proxy server. The OPEN command is sent specifying the host name, followed by the username and password.
    - `FTP_PROXY_SITE`: This value specifies that the client is logged into the server. The SITE command is sent, specifying the host name, followed by the username and the password.
    - `FTP_PROXY_OTHER`: This special proxy type specifies that another, undefined proxy server is being used. The client connects to the proxy host, but does not attempt to authenticate the client. The application is responsible for negotiating with the proxy server, typically using the FtpCommand function to send specific command sequences.
- **dwOptions** Parameter

    - `FTP_OPTION_DEFAULT`: Default options should be used for file transfers. This is the same as specifying that all file transfers should use passive mode when establishing a data connection with the server. It is recommended most applications use passive mode to prevent potential compatibility issues with certain types of firewalls and routers which use Network Address Translation (NAT).
    - `FTP_OPTION_PASSIVE`: This option specifies file transfers should attempt to establish the data connection with the server. If the local system is behind a firewall or a NAT router, the server may not be able to establish a data connection back to the client and the transfer will fail. This option forces the client to establish an outbound data connection with the server. It is recommended that applications use passive mode whenever possible.
    - `FTP_OPTION_FIREWALL`: This option specifies the client should always use the host IP address to establish the data connection with the server, not the address returned by the server in response to the PASV command. This option may be necessary if the server is behind a router that performs Network Address Translation (NAT) and it returns an unreachable IP address for the data connection. If this option is specified, it will also enable passive mode data transfers.
    - `FTP_OPTION_NOAUTH`: This option specifies the server does not require authentication, or that it requires an alternate authentication method. When this option is used, the client connection is flagged as authenticated as soon as the connection to the server has been established. Note that using this option to bypass authentication may result in subsequent errors when attempting to retrieve a directory listing or transfer a file. It is recommended that you consult the technical reference documentation for the server to determine its specific authentication requirements.
    - `FTP_OPTION_KEEPALIVE`: This option specifies the client should attempt to keep the connection with the server active for an extended period of time. It is important to note that regardless of this option, the server may still choose to disconnect client sessions that are holding the command channel open but are not performing file transfers.
    - `FTP_OPTION_VIRTUALHOST`: This option specifies the server supports virtual hosting, where multiple domains are hosted by a server using the same external IP address. If this option is enabled, the client will send the HOST command to the server upon establishing a connection.
    - `FTP_OPTION_VERIFY`: This option specifies that file transfers should be automatically verified after the transfer has completed. If the server supports the XMD5 command, the transfer will be verified by calculating an MD5 hash of the file contents. If the server does not support the XMD5 command, but does support the XCRC command, the transfer will be verified by calculating a CRC32 checksum of the file contents. If neither the XMD5 or XCRC commands are supported, the transfer is verified by comparing the size of the file. Automatic file verification is only performed for binary mode transfers because of the end-of-line conversion that may occur when text files are uploaded or downloaded.
    - `FTP_OPTION_TRUSTEDSITE`: This option specifies the server is trusted. The server certificate will not be validated and the connection will always be permitted. This option only affects connections using the TLS protocol.
    - `FTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. This option is the same as specifying FTP_OPTION_SECURE_IMPLICIT which immediately performs the TLS protocol negotiation when the connection is established.
    - `FTP_OPTION_SECURE_IMPLICIT`: This option specifies the client should attempt to immediately establish secure TLS connection with the server. This option is typically used when connecting to a server on port 990, which is the default port number used for FTPS.
    - `FTP_OPTION_SECURE_EXPLICIT`: This option specifies the client should establish a standard connection to the server and then use the AUTH command to negotiate an explicit secure connection. This option is typically used when connecting to the server on ports other than 990.
    - `FTP_OPTION_SECURE_FALLBACK`: This option specifies the client should permit the use of less secure cipher suites for compatibility with legacy servers. If this option is specified, the client will allow connections using TLS 1.0 and cipher suites that use RC4, MD5 and SHA1.
    - `FTP_OPTION_TUNNEL`: This option specifies that a tunneled TCP connection and/or port-forwarding is being used to establish the connection to the server. This changes the behavior of the client with regards to internal checks of the destination IP address and remote port number, default capability selection and how the connection is established. This option also forces all connections to be outbound and enables the firewall compatibility features in the client.
    - `FTP_OPTION_KEEPALIVE_DATA`: This option specifies the client should attempt to keep the control connection active during a file transfer. Normally, when a data transfer is in progress, no additional commands are issued on the control channel until the transfer completes. Specifying this option automatically enables the FTP_OPTION_KEEPALIVE option and forces the client to continue to issue NOOP commands during the file transfer. This option only applies to FTP and FTPS connections and has no effect on connections using SFTP (SSH).
    - `FTP_OPTION_PREFER_IPV6`: This option specifies the client should prefer the use of IPv6 if the server hostname can be resolved to both an IPv6 and IPv4 address. This option is ignored if the local system does not have IPv6 enabled, or when the hostname can only be resolved to an IPv4 address. If the server hostname can only be resolved to an IPv6 address, the client will attempt to establish a connection using IPv6 regardless if this option has been specified.
    - `FTP_OPTION_FREETHREAD`: This option specifies the handle returned by this function may be used by any thread, and is not limited to the thread which created it. The application is responsible for ensuring that access to the handle is synchronized across multiple threads.
    - `FTP_OPTION_HIRES_TIMER`: This option specifies the elapsed time for data transfers should be returned in milliseconds instead of seconds. This will return more accurate transfer times for smaller files being uploaded or downloaded using fast network connections.
    - `FTP_OPTION_TLS_REUSE`: This option specifies that TLS session reuse should be enabled for secure connections. This option is only supported on Windows 8.1 or Windows Server 2012 R2 and later platforms, and it should only be used when explicitly required by the server. This option is not compatible with servers built using OpenSSL 1.0.2 and earlier versions which do not provide Extended Master Secret (EMS) support as outlined in RFC7627.

### Return Value

- **Type**: `HCLIENT`
- If the function succeeds, the return value is a handle to a client session. If the function fails, the return value is INVALID_CLIENT. To get extended error information, call FtpGetLastError.

### Remarks

- The username and password that is used to authenticate the client with the proxy server are not the same as those used to login to the target server. Once a connection has been established with the proxy server, the client must call the FtpLogin function to actually login to the server and begin a file transfer.
- When a message is posted to the notification window, the low word of the lParam parameter contains the event identifier. The high word of lParam contains the low word of the error code, if an error has occurred. The wParam parameter contains the client handle. One or more of the following event identifiers may be sent:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAsyncConnect](#ftpasyncconnect-function)
- [FtpConnect](#ftpconnect-function)
- [FtpCreateSecurityCredentials](#ftpcreatesecuritycredentials-function)
- [FtpDeleteSecurityCredentials](#ftpdeletesecuritycredentials-function)
- [FtpDisconnect](#ftpdisconnect-function)
- [FtpGetSecurityInformation](#ftpgetsecurityinformation-function)
- [FtpInitialize](#ftpinitialize-function)
- [FtpLogin](#ftplogin-function)
- [FtpProxyConnect](#ftpproxyconnect-function)
- [FtpSetChannelMode](#ftpsetchannelmode-function)

---

## FtpAsyncPutData Function

Create a file on the server using the contents of a local buffer

### Prototype

```c
UINT WINAPI FtpAsyncPutData(
    HCLIENT hClient,
    LPCTSTR lpszFileName,
    LPVOID lpvBuffer,
    DWORD dwLength,
    DWORD dwReserved,
    FTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileName` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be created, overwritten or appended to. The file naming conventions must be that of the host operating system. |
| `lpvBuffer` | `LPVOID` | A pointer to the data that will be copied to the server and stored in the specified file. |
| `dwLength` | `DWORD` | The number of bytes to copy from the buffer. |
| `dwReserved` | `DWORD` | A reserved parameter. This value should always be zero. |
| `lpEventProc` | `FTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the FtpEventProc callback function. This parameter may be NULL if you do not wish to implement an event handler. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. This parameter is ignored if the lpEventProc parameter is NULL. |

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the function fails, the return value is zero. To get extended error information, call the FtpGetLastError function. The application should treat the task ID as an opaque value and never make an assumption about the sequence in which IDs are assigned to a background task.

### Remarks

- The FtpAsyncPutData function is used to upload the contents of a local buffer to the server. This function is similar to the FtpPutData function, however it uses a background worker thread and does not block the current working thread. This enables the application to continue to perform other operations while the data is being sent to the server.
- Because this function works asynchronously, it is important that the memory allocated for the buffer is not released before the asynchronous task completes. If you provide a buffer that is allocated on the stack, ensure that your code does not return from the function while the data is being uploaded. This can be achieved by calling the FtpTaskWait function or periodically calling the FtpTaskDone function to determine if the transfer has completed. If you wish to return from the calling function immediately, then you must dynamically allocate memory for the lpvBuffer parameter on the heap and free that memory after the task has completed and the data is no longer needed.
- If the address of an event handler is provided to this function, it is guaranteed that the handler will be invoked with the FTP_EVENT_CONNECT event after the connection has been established, and the FTP_EVENT_DISCONNECT event after the transfer has completed. This enables your application to know when the data transfer is about to begin, and immediately before the worker thread is terminated. The worker thread creates a secondary connection to the server with its own session handle. This ensures that the asynchronous operation will not interfere with the current client session. Your application can interact with this background worker thread using the client handle that is passed to the event handler.
- If the lpvBuffer parameter is pointing to a Unicode string, it is important to note that the value of the dwLength parameter should specify the number of bytes, not the number of characters. When using UTF-16, each character is two bytes long and therefore the length of the buffer is effectively double the length of the string. Because Unicode strings can contain null characters, you must also set the current file type to FILE_TYPE_IMAGE prior to calling this function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAsyncGetData](#ftpasyncgetdata-function)
- [FtpAsyncGetFile](#ftpasyncgetfile-function)
- [FtpAsyncPutFile](#ftpasyncputfile-function)
- [FtpEventProc](#ftpeventproc-function)
- [FtpPutData](#ftpputdata-function)
- [FtpTaskWait](#ftptaskwait-function)

---

## FtpAsyncPutFile Function

Copy a file from the local system to the server

### Prototype

```c
UINT WINAPI FtpAsyncPutFile(
    HCLIENT hClient,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    DWORD dwOffset,
    FTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file that will be transferred from the local system. The file pathing and name conventions must be that of the local host. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be created, overwritten or appended to. The file naming conventions must be that of the host operating system. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter may be any one of the following values: |
| `dwOffset` | `DWORD` | A byte offset which specifies where the file transfer should begin. The default value of zero specifies that the file transfer should start at the beginning of the file. A value greater than zero is typically used to restart a transfer that has not completed successfully. Note that specifying a non-zero offset requires that the server support the REST command to restart transfers. |
| `lpEventProc` | `FTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the FtpEventProc callback function. This parameter may be NULL if you do not wish to implement an event handler. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. This parameter is ignored if the lpEventProc parameter is NULL. |

### Options

- **dwOptions** Parameter

    - `FTP_TRANSFER_DEFAULT`: This option specifies the default transfer mode should be used. If the remote file exists, it will be overwritten with the contents of the uploaded file.
    - `FTP_TRANSFER_APPEND`: This option specifies that if the remote file exists, the contents of the local file is appended to the remote file. If the remote file does not exist, it is created.

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the function fails, the return value is zero. To get extended error information, call the FtpGetLastError function. The application should treat the task ID as an opaque value and never make an assumption about the sequence in which IDs are assigned to a background task.

### Remarks

- The FtpAsyncPutFile function is used to upload the contents of a local file to the server. This function is similar to the FtpPutFile function, however it uploads the file using a background worker thread and does not block the current working thread. This enables the application to continue to perform other operations while the file is being transferred to the server.
- If the address of an event handler is provided to this function, it is guaranteed that the handler will be invoked with the FTP_EVENT_CONNECT event after the connection has been established, and the FTP_EVENT_DISCONNECT event after the transfer has completed. This enables your application to know when the file transfer is about to begin, and immediately before the worker thread is terminated. During the file transfer, the callback function will be invoked periodically with the FTP_EVENT_PROGRESS event. The client session handle is passed to the event handler, allowing you to call functions such as FtpGetTransferStatus to determine the amount of data that has been copied.
- To determine when the transfer has completed without implementing an event handler, periodically call the FtpTaskDone function. If you wish to block the current thread and wait for the transfer to complete, call the FtpTaskWait function. To stop a background file transfer that is in progress, call the FtpTaskAbort function. This will signal the background worker thread to cancel the transfer and terminate the session.
- This function can be called multiple times to upload multiple files in the background; however, most servers limit the number of simultaneous connections that can originate from a single IP address. It is recommended that you only perform two simultaneous background transfers from the same server at any one time. The application should not make any assumptions about the order in which multiple background transfers may complete or how they are sequenced. For example, it should never be assumed that a background task with a lower task ID will complete before a task with a higher ID value.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAsyncGetData](#ftpasyncgetdata-function)
- [FtpAsyncGetFile](#ftpasyncgetfile-function)
- [FtpAsyncPutData](#ftpasyncputdata-function)
- [FtpEventProc](#ftpeventproc-function)
- [FtpPutFile](#ftpputfile-function)
- [FtpTaskDone](#ftptaskdone-function)
- [FtpTaskWait](#ftptaskwait-function)

---

## FtpAsyncPutFileEx Function

Copy a file from the local system to the server, supporting files larger than 4GB

### Prototype

```c
UINT WINAPI FtpAsyncPutFileEx(
    HCLIENT hClient,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    ULARGE_INTEGER uiOffset,
    FTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file that will be transferred from the local system. The file pathing and name conventions must be that of the local host. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be created, overwritten or appended to. The file naming conventions must be that of the host operating system. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter may be any one of the following values: |
| `uiOffset` | `ULARGE_INTEGER` | A byte offset which specifies where the file transfer should begin. The default value of zero specifies that the file transfer should start at the beginning of the file. A value greater than zero is typically used to restart a transfer that has not completed successfully. Note that specifying a non-zero offset requires that the server support the REST command to restart transfers. |
| `lpEventProc` | `FTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the FtpEventProc callback function. This parameter may be NULL if you do not wish to implement an event handler. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. This parameter is ignored if the lpEventProc parameter is NULL. |

### Options

- **dwOptions** Parameter

    - `FTP_TRANSFER_DEFAULT`: This option specifies the default transfer mode should be used. If the remote file exists, it will be overwritten with the contents of the uploaded file.
    - `FTP_TRANSFER_APPEND`: This option specifies that if the remote file exists, the contents of the local file is appended to the remote file. If the remote file does not exist, it is created.

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the function fails, the return value is zero. To get extended error information, call the FtpGetLastError function. The application should treat the task ID as an opaque value and never make an assumption about the sequence in which IDs are assigned to a background task.

### Remarks

- The FtpAsyncPutFileEx function is used to upload the contents of a local file to the server. This function is similar to the FtpPutFileEx function, however it uploads the file using a background worker thread and does not block the current working thread. This enables the application to continue to perform other operations while the file is being transferred to the server.
- If the address of an event handler is provided to this function, it is guaranteed that the handler will be invoked with the FTP_EVENT_CONNECT event after the connection has been established, and the FTP_EVENT_DISCONNECT event after the transfer has completed. This enables your application to know when the file transfer is about to begin, and immediately before the worker thread is terminated. During the file transfer, the callback function will be invoked periodically with the FTP_EVENT_PROGRESS event. The client session handle is passed to the event handler, allowing you to call functions such as FtpGetTransferStatusEx to determine the amount of data that has been copied.
- To determine when the transfer has completed without implementing an event handler, periodically call the FtpTaskDone function. If you wish to block the current thread and wait for the transfer to complete, call the FtpTaskWait function. To stop a background file transfer that is in progress, call the FtpTaskAbort function. This will signal the background worker thread to cancel the transfer and terminate the session.
- This function can be called multiple times to upload multiple files in the background; however, most servers limit the number of simultaneous connections that can originate from a single IP address. It is recommended that you only perform two simultaneous background transfers from the same server at any one time. The application should not make any assumptions about the order in which multiple background transfers may complete or how they are sequenced. For example, it should never be assumed that a background task with a lower task ID will complete before a task with a higher ID value.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAsyncGetFileEx](#ftpasyncgetfileex-function)
- [FtpEventProc](#ftpeventproc-function)
- [FtpGetFileEx](#ftpgetfileex-function)
- [FtpPutFileEx](#ftpputfileex-function)
- [FtpTaskDone](#ftptaskdone-function)
- [FtpTaskWait](#ftptaskwait-function)

---

## FtpAttachThread Function

Attach the specified client handle to another thread

### Prototype

```c
DWORD WINAPI FtpAttachThread(
    HCLIENT hClient,
    DWORD dwThreadId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `dwThreadId` | `DWORD` | The ID of the thread that will become the new owner of the handle. A value of zero specifies that the current thread should become the owner of the client handle. |

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is the thread ID of the previous owner. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- When a client handle is created, it is associated with the current thread that created it. Normally, if another thread attempts to perform an operation using that handle, an error is returned since it does not own the handle. This is used to ensure that other threads cannot interfere with an operation being performed by the owner thread. In some cases, it may be desirable for one thread in a client application to create the client handle, and then pass that handle to another worker thread. The FtpAttachThread function can be used to change the ownership of the handle to the new worker thread. By preserving the return value from the function, the original owner of the handle can be restored before the worker thread terminates.
- This function should be called by the new thread immediately after it has been created, and if the new thread does not release the handle itself, the ownership of the handle should be restored to the parent thread before it terminates. Under no circumstances should FtpAttachThread be used to forcibly release a handle allocated by another thread while a blocking operation is in progress. To cancel an operation, use the FtpCancel function and then release the handle after the blocking function exits and control is returned to the current thread.
- Note that the dwThreadId parameter is presumed to be a valid thread ID and no checks are performed to ensure that the thread actually exists. Specifying an invalid thread ID will orphan the handle until the FtpUninitialize function is called.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpConnect](#ftpconnect-function)
- [FtpDisconnect](#ftpdisconnect-function)
- [FtpUninitialize](#ftpuninitialize-function)

---

## FtpCancel Function

Cancel the current blocking operation

### Prototype

```c
INT WINAPI FtpCancel(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- When the FtpCancel function is called, the blocking function will not immediately fail. An internal flag is set which causes the blocking operation to exit with an error. This means that the application cannot cancel an operation and immediately perform some other operation. Instead it must allow the calling stack to unwind, returning back to the blocking operation before making any further function calls.
- This function may be called during a blocking file transfer.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpIsBlocking](#ftpisblocking-function)

---

## FtpCancelQueuedFile Function

Cancel the queued file transfer

### Prototype

```c
BOOL WINAPI FtpCancelQueuedFile(
    HQUEUE hQueue,
    DWORD dwFileId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `dwFileId` | `DWORD` | An unsigned integer value which uniquely identifies the file in the queue. If this value is zero, the function will cancel the current file transfer in progress. If queue transfers have been suspended, this parameter cannot be zero. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, it will return zero. To get extended error information, call FtpGetLastError.

### Remarks

- When this function is called, the queued file transfer may not immediately stop. An internal flag is set which causes the file transfer to exit with an error and the queue manager will begin processing the next file in the queue. If the queue is in an idle state, this function will fail.
- It is permitted to call FtpCancelQueuedFile from within a queue event handler to cancel the current file transfer. In this case, the dwFileId parameter should be zero. If you specify a file which has not been transferred, it will be flagged as canceled and skipped by the queue manager when processing the queue. If you specify a file which has already been processed, this function will fail.
- A canceled file transfer is also considered a failed transfer. When you call FtpGetQueueStatus after a queued file transfer is canceled, the dwFailedFiles member of the FTPQUEUESTATUS structure will be incremented to reflect this change. You can determine the status of an individual file transfer by calling the FtpGetQueuedFile function and checking the value of the dwQueueFlags member of the FTPQUEUEDFILE structure.
- The FtpResetQueue function can be used to reset the state of previously canceled transfers.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpCancel](#ftpcancel-function)
- [FtpGetQueuedFile](#ftpgetqueuedfile-function)
- [FtpGetQueueStatus](#ftpgetqueuestatus-function)
- [FtpResetQueue](#ftpresetqueue-function)
- [FtpResumeQueue](#ftpresumequeue-function)
- [FtpStartQueue](#ftpstartqueue-function)
- [FtpSuspendQueue](#ftpsuspendqueue-function)
- [FtpStopQueue](#ftpstopqueue-function)

---

## FtpChangeDirectory Function

Change the current working directory on the server

### Prototype

```c
INT WINAPI FtpChangeDirectory(
    HCLIENT hClient,
    LPCTSTR lpszDirectory
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszDirectory` | `LPCTSTR` | Points to a string that specifies the name of the directory. The file pathing and name conventions must be that of the server. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function uses the CWD command to change the current working directory. The user must have the appropriate permission to access the specified directory.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpChangeDirectoryUp](#ftpchangedirectoryup-function)
- [FtpCloseDirectory](#ftpclosedirectory-function)
- [FtpCommand](#ftpcommand-function)
- [FtpGetDirectory](#ftpgetdirectory-function)
- [FtpGetFirstFile](#ftpgetfirstfile-function)
- [FtpGetNextFile](#ftpgetnextfile-function)
- [FtpGetResultCode](#ftpgetresultcode-function)
- [FtpGetResultString](#ftpgetresultstring-function)
- [FtpOpenDirectory](#ftpopendirectory-function)

---

## FtpChangeDirectoryUp Function

Change the current working directory on the server

### Prototype

```c
INT WINAPI FtpChangeDirectoryUp(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function sends the CDUP command to the server. This command is a special case of the CWD command, and is included to simplify transferring between directory trees on those operating systems which have different syntaxes for naming the parent directory. The current user must have the appropriate permission to access the specified directory.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpChangeDirectory](#ftpchangedirectory-function)
- [FtpCommand](#ftpcommand-function)
- [FtpGetDirectory](#ftpgetdirectory-function)
- [FtpGetResultCode](#ftpgetresultcode-function)
- [FtpGetResultString](#ftpgetresultstring-function)

---

## FtpClearQueue Function

Remove all files from the current transfer queue

### Prototype

```c
BOOL WINAPI FtpClearQueue(
    HQUEUE hQueue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, it will return zero. To get extended error information, call FtpGetLastError.

### Remarks

- This function can only be called when the queue is in an idle state. An error will be returned if the function is called while the queue manager is paused or actively transferring files in the queue. To determine the current state of the queue, call the FtpGetQueueStatus function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpCancelQueuedFile](#ftpcancelqueuedfile-function)
- [FtpGetQueueStatus](#ftpgetqueuestatus-function)
- [FtpResetQueue](#ftpresetqueue-function)
- [FtpResumeQueue](#ftpresumequeue-function)
- [FtpStartQueue](#ftpstartqueue-function)
- [FtpStopQueue](#ftpstopqueue-function)
- [FtpSuspendQueue](#ftpsuspendqueue-function)

---

## FtpCloseDirectory Function

Close the open directory on the server

### Prototype

```c
INT WINAPI FtpCloseDirectory(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function must be called after all of the file information from the server has been returned. Because directory information is returned on the data channel, no file transfers can take place while a directory is being read.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetDirectoryFormat](#ftpgetdirectoryformat-function)
- [FtpGetFileStatus](#ftpgetfilestatus-function)
- [FtpGetFirstFile](#ftpgetfirstfile-function)
- [FtpGetNextFile](#ftpgetnextfile-function)
- [FtpOpenDirectory](#ftpopendirectory-function)
- [FtpSetDirectoryFormat](#ftpsetdirectoryformat-function)

---

## FtpCloseFile Function

Close the current file on the server

### Prototype

```c
INT WINAPI FtpCloseFile(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- If the file is opened for writing, all buffered data is written to the server before the socket is closed. This may cause the client to block until all of the data can be written. The client application should not perform any other action until the function returns.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpOpenFile](#ftpopenfile-function)
- [FtpRead](#ftpread-function)
- [FtpWrite](#ftpwrite-function)

---

## FtpCommand Function

Send a command to the server

### Prototype

```c
INT WINAPI FtpCommand(
    HCLIENT hClient,
    LPCTSTR lpszCommand,
    LPCTSTR lpszParameter
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszCommand` | `LPCTSTR` | The command which will be executed by the server. |
| `lpszParameter` | `LPCTSTR` | An optional command parameter. If the command requires more than one parameter, then they should be combined into a single string, with a space separating each parameter. If the command does not accept any parameters, this value may be NULL. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the result code returned by the server. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function should only be used when the application needs to send a custom, site-specific command or send a command that is not directly supported by this API. This function should never be used to issue a command that opens a data channel. If the application needs to transform data as it is being sent or received, and cannot use the FtpGetFile or FtpPutFile functions, then use the FtpOpenFile function to open a data channel with the server.
- By default, file names which are sent to the server using the FtpCommand function are sent as ANSI characters. If the Unicode version of the function is used, the file name will be converted from Unicode to ANSI using the current codepage. If the server supports UTF-8 encoded file names, the FtpSetFileNameEncoding function can be used to specify that file names with non-ASCII characters should be sent as UTF-8 encoded values. It is important to note that this option is only available if the server advertises support for UTF-8 and permits that encoding type.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetFile](#ftpgetfile-function)
- [FtpGetFileNameEncoding](#ftpgetfilenameencoding-function)
- [FtpGetResultCode](#ftpgetresultcode-function)
- [FtpGetResultString](#ftpgetresultstring-function)
- [FtpOpenFile](#ftpopenfile-function)
- [FtpPutFile](#ftpputfile-function)
- [FtpSetFileNameEncoding](#ftpsetfilenameencoding-function)

---

## FtpConnect Function

Establish a client connection with a server

### Prototype

```c
HCLIENT WINAPI FtpConnect(
    LPCTSTR lpszRemoteHost,
    UINT nRemotePort,
    LPCTSTR lpszUserName,
    LPCTSTR lpszPassword,
    UINT nTimeout,
    DWORD dwOptions,
    LPSECURITYCREDENTIALS lpCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszRemoteHost` | `LPCTSTR` | A pointer to the name of the server to connect to; this may be a fully-qualified domain name or an IP address. |
| `nRemotePort` | `UINT` | The port number the server is listening on; a value of zero specifies that the default port number should be used. For standard connections, the default port number is 21. For secure connections, the default port number is 990. |
| `lpszUserName` | `LPCTSTR` | Points to a string that specifies the user name to be used to authenticate the current client session. If this parameter is NULL or an empty string, then the login is considered to be anonymous. Note that anonymous logins are not supported for secure connections using the SSH protocol. |
| `lpszPassword` | `LPCTSTR` | Points to a string that specifies the password to be used to authenticate the current client session. This parameter may be NULL or an empty string if no password is required for the specified user, or if no username has been specified. |
| `nTimeout` | `UINT` | The number of seconds that the client will wait for a response from the server before failing the current operation. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `lpCredentials` | `LPSECURITYCREDENTIALS` | A pointer to a SECURITYCREDENTIALS structure. This parameter should be NULL if the connection is not secure or when client credentials are not required. Most servers do not require a client certificate to establish a secure connection. However, if the server does require a client certificate, the structure members dwSize, lpszCertStore and lpszCertName must be defined. Undefined structure members must be initialized to a value of zero or NULL and the dwSize member must be initialized to the size of the SECURITYCREDENTIALS structure. |

### Options

- **dwOptions** Parameter

    - `FTP_OPTION_DEFAULT`: Default options should be used for file transfers. This is the same as specifying that all file transfers should use passive mode when establishing a data connection with the server. It is recommended most applications use passive mode to prevent potential compatibility issues with certain types of firewalls and routers which use Network Address Translation (NAT).
    - `FTP_OPTION_PASSIVE`: This option specifies file transfers should attempt to establish the data connection with the server. If the local system is behind a firewall or a NAT router, the server may not be able to establish a data connection back to the client and the transfer will fail. This option forces the client to establish an outbound data connection with the server. It is recommended that applications use passive mode whenever possible.
    - `FTP_OPTION_FIREWALL`: This option specifies the client should always use the host IP address to establish the data connection with the server, not the address returned by the server in response to the PASV command. This option may be necessary if the server is behind a router that performs Network Address Translation (NAT) and it returns an unreachable IP address for the data connection. If this option is specified, it will also enable passive mode data transfers.
    - `FTP_OPTION_NOAUTH`: This option specifies the server does not require authentication, or that it requires an alternate authentication method. When this option is used, the client connection is flagged as authenticated as soon as the connection to the server has been established. Note that using this option to bypass authentication may result in subsequent errors when attempting to retrieve a directory listing or transfer a file. It is recommended that you consult the technical reference documentation for the server to determine its specific authentication requirements.
    - `FTP_OPTION_KEEPALIVE`: This option specifies the client should attempt to keep the connection with the server active for an extended period of time. It is important to note that regardless of this option, the server may still choose to disconnect client sessions that are holding the command channel open but are not performing file transfers.
    - `FTP_OPTION_NOAUTHRSA`: This option specifies that RSA authentication should not be used with SSH-1 connections. This option is ignored with SSH-2 connections and should only be specified if required by the server. This option has no effect on standard or secure connections using TLS.
    - `FTP_OPTION_NOPWDNUL`: This option specifies the user password cannot be terminated with a null character. This option is ignored with SSH-2 connections and should only be specified if required by the server. This option has no effect on standard or secure connections using TLS.
    - `FTP_OPTION_NOREKEY`: This option specifies the client should never attempt a repeat key exchange with the server. Some SSH servers do not support rekeying the session, and this can cause the client to become non-responsive or abort the connection after being connected for an hour. This option has no effect on standard or secure connections using TLS.
    - `FTP_OPTION_COMPATSID`: This compatibility option changes how the session ID is handled during public key authentication with older SSH servers. This option should only be specified when connecting to servers that use OpenSSH 2.2.0 or earlier versions. This option has no effect on standard or secure connections using SSL.
    - `FTP_OPTION_COMPATHMAC`: This compatibility option changes how the HMAC authentication codes are generated. This option should only be specified when connecting to servers that use OpenSSH 2.2.0 or earlier versions. This option has no effect on standard or secure connections using TLS.
    - `FTP_OPTION_VIRTUALHOST`: This option specifies the server supports virtual hosting, where multiple domains are hosted by a server using the same external IP address. If this option is enabled, the client will send the HOST command to the server upon establishing a connection.
    - `FTP_OPTION_VERIFY`: This option specifies that file transfers should be automatically verified after the transfer has completed. If the server supports the XMD5 command, the transfer will be verified by calculating an MD5 hash of the file contents. If the server does not support the XMD5 command, but does support the XCRC command, the transfer will be verified by calculating a CRC32 checksum of the file contents. If neither the XMD5 or XCRC commands are supported, the transfer is verified by comparing the size of the file. Automatic file verification is only performed for binary mode transfers because of the end-of-line conversion that may occur when text files are uploaded or downloaded.
    - `FTP_OPTION_TRUSTEDSITE`: This option specifies the server is trusted. The server certificate will not be validated and the connection will always be permitted. This option only affects connections using the TLS protocol.
    - `FTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. This option is the same as specifying FTP_OPTION_SECURE_IMPLICIT which immediately performs the TLS protocol negotiation when the connection is established.
    - `FTP_OPTION_SECURE_IMPLICIT`: This option specifies the client should attempt to immediately establish secure TLS connection with the server. This option is typically used when connecting to a server on port 990, which is the default port number used for FTPS.
    - `FTP_OPTION_SECURE_EXPLICIT`: This option specifies the client should establish a standard connection to the server and then use the AUTH command to negotiate an explicit secure connection. This option is typically used when connecting to the server on ports other than 990.
    - `FTP_OPTION_SECURE_SHELL`: This option specifies the client should use the Secure Shell (SSH) protocol to establish the connection. This option will automatically be selected if the connection is established using port 22, the default port for SSH.
    - `FTP_OPTION_SECURE_FALLBACK`: This option specifies the client should permit the use of less secure cipher suites for compatibility with legacy servers. If this option is specified, the client will allow connections using TLS 1.0 and cipher suites that use RC4, MD5 and SHA1.
    - `FTP_OPTION_TUNNEL`: This option specifies that a tunneled TCP connection and/or port-forwarding is being used to establish the connection to the server. This changes the behavior of the client with regards to internal checks of the destination IP address and remote port number, default capability selection and how the connection is established. This option also forces all connections to be outbound and enables the firewall compatibility features in the client.
    - `FTP_OPTION_KEEPALIVE_DATA`: This option specifies the client should attempt to keep the control connection active during a file transfer. Normally, when a data transfer is in progress, no additional commands are issued on the control channel until the transfer completes. Specifying this option automatically enables the FTP_OPTION_KEEPALIVE option and forces the client to continue to issue NOOP commands during the file transfer. This option only applies to FTP and FTPS connections and has no effect on connections using SFTP (SSH).
    - `FTP_OPTION_PREFER_IPV6`: This option specifies the client should prefer the use of IPv6 if the server hostname can be resolved to both an IPv6 and IPv4 address. This option is ignored if the local system does not have IPv6 enabled, or when the hostname can only be resolved to an IPv4 address. If the server hostname can only be resolved to an IPv6 address, the client will attempt to establish a connection using IPv6 regardless if this option has been specified.
    - `FTP_OPTION_FREETHREAD`: This option specifies the handle returned by this function may be used by any thread, and is not limited to the thread which created it. The application is responsible for ensuring that access to the handle is synchronized across multiple threads.
    - `FTP_OPTION_HIRES_TIMER`: This option specifies the elapsed time for data transfers should be returned in milliseconds instead of seconds. This will return more accurate transfer times for smaller files being uploaded or downloaded using fast network connections.
    - `FTP_OPTION_TLS_REUSE`: This option specifies that TLS session reuse should be enabled for secure connections. This option is only supported on Windows 8.1 or Windows Server 2012 R2 and later platforms, and it should only be used when explicitly required by the server. This option is not compatible with servers built using OpenSSL 1.0.2 and earlier versions which do not provide Extended Master Secret (EMS) support as outlined in RFC7627.

### Return Value

- **Type**: `HCLIENT`
- If the function succeeds, the return value is a handle to a client session. If the function fails, the return value is INVALID_CLIENT. To get extended error information, call FtpGetLastError.

### Remarks

- This function will block the current thread until a connection has been established or the timeout period has elapsed. To prevent it from blocking the main user interface thread, the application should create a background worker thread and establish a connection by calling FtpConnect in that thread. If the application requires multiple simultaneous connections, it is recommended you create a worker thread for each connection.
- If the FTP_OPTION_KEEPALIVE option is specified, a background worker thread will be created to monitor the command channel and periodically send NOOP commands to the server if no commands have been sent recently. This can prevent the server from terminating the client connection during idle periods where no commands are being issued. However, it is important to keep in mind that many servers can be configured to also limit the total amount of time a client can be connected to the server, as well as the amount of time permitted between file transfers. If the server does not respond to the NOOP command, this option will be automatically disabled for the remainder of the client session.
- If the FTP_OPTION_SECURE_EXPLICIT option is specified, the client will establish a standard connection to the server and send the AUTH TLS command to the server. If the server does not accept this command, it will then send the AUTH SSL command. If both commands are rejected by the server, an explicit TLS session cannot be established. By default, both the command and data channels will be encrypted when a secure connection is established. To change this, use the FtpSetChannelMode function.
- The dwOptions argument can be used to specify the threading model that is used by the library when a connection is established. By default, the handle is initially attached to the thread that created it. From that point on, until the it is released, only the owner may call functions using that handle. The ownership of the handle may be transferred from one thread to another using the FtpAttachThread function.
- Specifying the FTP_OPTION_FREETHREAD option enables any thread to call any function using the handle, regardless of which thread created it. It is important to note that this option disables certain internal safety checks which are performed by the library and may result in unexpected behavior unless access to the handle is synchronized. If one thread calls a function in the library, it must ensure that no other thread will call another function at the same time using the same handle.

### Example

```cpp
// Connect to a server using a standard (non-secure) connection on
// the default port. The username and password are not encrypted.

hClient = FtpConnect(lpszRemoteHost,
					FTP_PORT_DEFAULT,
					lpszUserName,
					lpszPassword,
					FTP_TIMEOUT,
					FTP_OPTION_DEFAULT,
					NULL);      

// Connect to a server using the default port and then initiate a
// secure connection using the AUTH TLS command

hClient = FtpConnect(lpszRemoteHost,
					FTP_PORT_DEFAULT,
					lpszUserName,
					lpszPassword,
					FTP_TIMEOUT,
					FTP_OPTION_PASSIVE | FTP_OPTION_SECURE_EXPLICIT,
					NULL);      

// Connect to a server on port 990 and immediately initiate a
// secure connection as soon as the connection is established

hClient = FtpConnect(lpszRemoteHost,
					FTP_PORT_SECURE,
					lpszUserName,
					lpszPassword,
					FTP_TIMEOUT,
					FTP_OPTION_PASSIVE | FTP_OPTION_SECURE_IMPLICIT,
					NULL);

// Connect to a server on port 22 using the Secure Shell (SFTP)
// protocol to transfer files

hClient = FtpConnect(lpszRemoteHost,
					FTP_PORT_SSH,
					lpszUserName,
					lpszPassword,
					FTP_TIMEOUT,
					FTP_OPTION_SECURE_SHELL,
					NULL);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpCreateSecurityCredentials](#ftpcreatesecuritycredentials-function)
- [FtpDeleteSecurityCredentials](#ftpdeletesecuritycredentials-function)
- [FtpDisconnect](#ftpdisconnect-function)
- [FtpGetSecurityInformation](#ftpgetsecurityinformation-function)
- [FtpInitialize](#ftpinitialize-function)
- [FtpProxyConnect](#ftpproxyconnect-function)
- [FtpSetChannelMode](#ftpsetchannelmode-function)

---

## FtpConnectUrl Function

Establish a client connection using the specified URL

### Prototype

```c
HCLIENT WINAPI FtpConnectUrl(
    LPCTSTR lpszUrl,
    UINT nTimeout,
    DWORD dwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszUrl` | `LPCTSTR` | A pointer to a string which specifies the URL for the server. The URL must follow the conventions for the File Transfer Protocol and may specify either a standard or secure connection, alternate port number, username, password and optional working directory. |
| `nTimeout` | `UINT` | The number of seconds that the client will wait for a response from the server before failing the current operation. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |

### Options

- **dwOptions** Parameter

    - `FTP_OPTION_DEFAULT`: Default options should be used for file transfers. This is the same as specifying that all file transfers should use passive mode when establishing a data connection with the server. It is recommended most applications use passive mode to prevent potential compatibility issues with certain types of firewalls and routers which use Network Address Translation (NAT).
    - `FTP_OPTION_PASSIVE`: This option specifies file transfers should attempt to establish the data connection with the server. If the local system is behind a firewall or a NAT router, the server may not be able to establish a data connection back to the client and the transfer will fail. This option forces the client to establish an outbound data connection with the server. It is recommended that applications use passive mode whenever possible.
    - `FTP_OPTION_FIREWALL`: This option specifies the client should always use the host IP address to establish the data connection with the server, not the address returned by the server in response to the PASV command. This option may be necessary if the server is behind a router that performs Network Address Translation (NAT) and it returns an unreachable IP address for the data connection. If this option is specified, it will also enable passive mode data transfers.
    - `FTP_OPTION_NOAUTH`: This option specifies the server does not require authentication, or that it requires an alternate authentication method. When this option is used, the client connection is flagged as authenticated as soon as the connection to the server has been established. Note that using this option to bypass authentication may result in subsequent errors when attempting to retrieve a directory listing or transfer a file. It is recommended that you consult the technical reference documentation for the server to determine its specific authentication requirements.
    - `FTP_OPTION_KEEPALIVE`: This option specifies the client should attempt to keep the connection with the server active for an extended period of time. It is important to note that regardless of this option, the server may still choose to disconnect client sessions that are holding the command channel open but are not performing file transfers.
    - `FTP_OPTION_NOAUTHRSA`: This option specifies that RSA authentication should not be used with SSH-1 connections. This option is ignored with SSH-2 connections and should only be specified if required by the server. This option has no effect on standard or secure connections using TLS.
    - `FTP_OPTION_NOPWDNUL`: This option specifies the user password cannot be terminated with a null character. This option is ignored with SSH-2 connections and should only be specified if required by the server. This option has no effect on standard or secure connections using TLS.
    - `FTP_OPTION_NOREKEY`: This option specifies the client should never attempt a repeat key exchange with the server. Some SSH servers do not support rekeying the session, and this can cause the client to become non-responsive or abort the connection after being connected for an hour. This option has no effect on standard or secure connections using TLS.
    - `FTP_OPTION_COMPATSID`: This compatibility option changes how the session ID is handled during public key authentication with older SSH servers. This option should only be specified when connecting to servers that use OpenSSH 2.2.0 or earlier versions. This option has no effect on standard or secure connections using SSL.
    - `FTP_OPTION_COMPATHMAC`: This compatibility option changes how the HMAC authentication codes are generated. This option should only be specified when connecting to servers that use OpenSSH 2.2.0 or earlier versions. This option has no effect on standard or secure connections using TLS.
    - `FTP_OPTION_VIRTUALHOST`: This option specifies the server supports virtual hosting, where multiple domains are hosted by a server using the same external IP address. If this option is enabled, the client will send the HOST command to the server upon establishing a connection.
    - `FTP_OPTION_VERIFY`: This option specifies that file transfers should be automatically verified after the transfer has completed. If the server supports the XMD5 command, the transfer will be verified by calculating an MD5 hash of the file contents. If the server does not support the XMD5 command, but does support the XCRC command, the transfer will be verified by calculating a CRC32 checksum of the file contents. If neither the XMD5 or XCRC commands are supported, the transfer is verified by comparing the size of the file. Automatic file verification is only performed for binary mode transfers because of the end-of-line conversion that may occur when text files are uploaded or downloaded.
    - `FTP_OPTION_TRUSTEDSITE`: This option specifies the server is trusted. The server certificate will not be validated and the connection will always be permitted. This option only affects connections using the TLS protocol.
    - `FTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. This option is the same as specifying FTP_OPTION_SECURE_IMPLICIT which immediately performs the TLS protocol negotiation when the connection is established.
    - `FTP_OPTION_SECURE_IMPLICIT`: This option specifies the client should attempt to immediately establish secure TLS connection with the server. This option is typically used when connecting to a server on port 990, which is the default port number used for FTPS.
    - `FTP_OPTION_SECURE_EXPLICIT`: This option specifies the client should establish a standard connection to the server and then use the AUTH command to negotiate an explicit secure connection. This option is typically used when connecting to the server on ports other than 990.
    - `FTP_OPTION_SECURE_SHELL`: This option specifies the client should use the Secure Shell (SSH) protocol to establish the connection. This option will automatically be selected if the connection is established using port 22, the default port for SSH.
    - `FTP_OPTION_SECURE_FALLBACK`: This option specifies the client should permit the use of less secure cipher suites for compatibility with legacy servers. If this option is specified, the client will allow connections using TLS 1.0 and cipher suites that use RC4, MD5 and SHA1.
    - `FTP_OPTION_TUNNEL`: This option specifies that a tunneled TCP connection and/or port-forwarding is being used to establish the connection to the server. This changes the behavior of the client with regards to internal checks of the destination IP address and remote port number, default capability selection and how the connection is established. This option also forces all connections to be outbound and enables the firewall compatibility features in the client.
    - `FTP_OPTION_KEEPALIVE_DATA`: This option specifies the client should attempt to keep the control connection active during a file transfer. Normally, when a data transfer is in progress, no additional commands are issued on the control channel until the transfer completes. Specifying this option automatically enables the FTP_OPTION_KEEPALIVE option and forces the client to continue to issue NOOP commands during the file transfer. This option only applies to FTP and FTPS connections and has no effect on connections using SFTP (SSH).
    - `FTP_OPTION_PREFER_IPV6`: This option specifies the client should prefer the use of IPv6 if the server hostname can be resolved to both an IPv6 and IPv4 address. This option is ignored if the local system does not have IPv6 enabled, or when the hostname can only be resolved to an IPv4 address. If the server hostname can only be resolved to an IPv6 address, the client will attempt to establish a connection using IPv6 regardless if this option has been specified.
    - `FTP_OPTION_FREETHREAD`: This option specifies the handle returned by this function may be used by any thread, and is not limited to the thread which created it. The application is responsible for ensuring that access to the handle is synchronized across multiple threads.
    - `FTP_OPTION_HIRES_TIMER`: This option specifies the elapsed time for data transfers should be returned in milliseconds instead of seconds. This will return more accurate transfer times for smaller files being uploaded or downloaded using fast network connections.
    - `FTP_OPTION_TLS_REUSE`: This option specifies that TLS session reuse should be enabled for secure connections. This option is only supported on Windows 8.1 or Windows Server 2012 R2 and later platforms, and it should only be used when explicitly required by the server. This option is not compatible with servers built using OpenSSL 1.0.2 and earlier versions which do not provide Extended Master Secret (EMS) support as outlined in RFC7627.

### Return Value

- **Type**: `HCLIENT`
- If the function succeeds, the return value is a handle to a client session. If the function fails, the return value is INVALID_CLIENT. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpConnectUrl function is a high-level function that uses an FTP URL to establish a connection with a server. Unlike the other connection related functions such as FtpConnect, this function does more than simply connect to the server. It will also authenticate the client session, change the current working directory and set the default file transfer mode. By default, this function will always place the client in passive mode, ensuring the broadest compatibility with most servers.
- The URL must be complete, and specify either a standard or secure FTP scheme:
- If no user name and password is provided, then the client session will be authenticated as an anonymous user. If a path is specified as part of the URL, the function will attempt to change the current working directory. The paths in an FTP URL are relative to the home directory of the user account and are not absolute paths starting at the root directory on the server. If a file name is also specified in the URL, it will be ignored and only the file path will be used. The URL scheme will always determine if the connection is secure, not the option. In other words, if the "ftp" scheme is used and the FTP_OPTION_SECURE option is specified, that option will be ignored. To establish a secure connection, either the "ftps" or "sftp" scheme must be specified.
- The FtpConnectUrl function is designed to provide a simpler, more convenient interface to establishing a connection with a server. However, complex connections such as those using a proxy server or a secure connection which uses a client certificate will require the program to use the lower-level connection functions. If you only need to upload or download a file using a URL, then refer to the FtpUploadFile and FtpDownloadFile functions.
- This function will block the current thread until a connection has been established or the timeout period has elapsed. To prevent it from blocking the main user interface thread, the application should create a background worker thread and establish a connection by calling FtpConnectUrl in that thread. If the application requires multiple simultaneous connections, it is recommended you create a worker thread for each connection.
- The dwOptions argument can be used to specify the threading model that is used by the library when a connection is established. By default, the handle is initially attached to the thread that created it. From that point on, until the it is released, only the owner may call functions using that handle. The ownership of the handle may be transferred from one thread to another using the FtpAttachThread function.
- Specifying the FTP_OPTION_FREETHREAD option enables any thread to call any function using the handle, regardless of which thread created it. It is important to note that this option disables certain internal safety checks which are performed by the library and may result in unexpected behavior unless access to the handle is synchronized. If one thread calls a function in the library, it must ensure that no other thread will call another function at the same time using the same handle.

### Example

```cpp
HCLIENT hClient;
LPCTSTR lpszUrl = _T("ftp://ftp.sockettools.com/");

// Connect to the site specified by the URL
hClient = FtpConnectUrl(lpszUrl, FTP_TIMEOUT, FTP_OPTION_DEFAULT);

if (hClient == INVALID_CLIENT)
{
	TCHAR szError[128];

	// Display a message box that describes the error
	FtpGetErrorString(FtpGetLastError(), szError, 128);
	MessageBox(NULL, szError, NULL, MB_ICONEXCLAMATION|MB_TASKMODAL);
	return;
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpConnect](#ftpconnect-function)
- [FtpDisconnect](#ftpdisconnect-function)
- [FtpDownloadFile](#ftpdownloadfile-function)
- [FtpUploadFile](#ftpuploadfile-function)
- [FtpValidateUrl](#ftpvalidateurl-function)

---

## FtpCreateDirectory Function

Create the specified directory on the server

### Prototype

```c
INT WINAPI FtpCreateDirectory(
    HCLIENT hClient,
    LPCTSTR lpszDirectory
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszDirectory` | `LPCTSTR` | Points to a string that specifies the name of the directory. The file pathing and name conventions must be that of the server. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function uses the MKD command to create the directory. The user must have the appropriate permission to create the specified directory.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpChangeDirectory](#ftpchangedirectory-function)
- [FtpGetDirectory](#ftpgetdirectory-function)
- [FtpRemoveDirectory](#ftpremovedirectory-function)

---

## FtpCreateQueue Function

Create a new file transfer queue

### Prototype

```c
HQUEUE WINAPI FtpCreateQueue(
    UINT nMaxFiles,
    UINT nTimeout,
    DWORD dwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nMaxFiles` | `UINT` | An unsigned integer which specifies the maximum number of files which can be added to the queue. The constant INFINITE can be used to specify that there is no fixed limit to the number of files in the queue. |
| `nTimeout` | `UINT` | An unsigned integer which specifies the default timeout for all queued file transfers. If this value is zero, a reasonable default timeout period will be used. This timeout period is used when a file is added to the queue without providing a timeout period for that specific file transfer. If a timeout period is specified for a particular file, it will override this value. |
| `dwOptions` | `DWORD` | An unsigned integer value which specifies one or more default options for all queued files. This parameter is constructed by using a bitwise operator and can be any of the options used with the FtpConnect function. If transfer options are specified for a particular file, it will override this value. The most common options are: |

### Options

- **dwOptions** Parameter

    - `FTP_OPTION_DEFAULT`: Default options should be used for queued file transfers. This is the same as specifying that all file transfers should use passive mode when establishing a data connection with the server. It is recommended most applications use passive mode to prevent potential compatibility issues with certain types of firewalls and routers which use Network Address Translation (NAT).
    - `FTP_OPTION_PASSIVE`: This option specifies queued transfers should attempt to establish the data connection with the server. If the local system is behind a firewall or a NAT router, the server may not be able to establish a data connection back to the client and the transfer will fail. This option forces the client to establish an outbound data connection with the server. It is recommended that applications use passive mode whenever possible.
    - `FTP_OPTION_FIREWALL`: This option specifies queued transfers should always use the host IP address to establish the data connection with the server, not the address returned by the server in response to the PASV command. This option may be necessary if the server is behind a router that performs Network Address Translation (NAT) and it returns an unreachable IP address for the data connection. If this option is specified, it will also enable passive mode data transfers.
    - `FTP_OPTION_SECURE`: This option specifies queued file transfers should attempt to establish a secure connection with the server by default. This option is the same as specifying FTP_OPTION_SECURE_IMPLICIT which immediately performs the TLS protocol negotiation when the connection is established.
    - `FTP_OPTION_SECURE_IMPLICIT`: This option specifies queued file transfers should attempt to immediately establish secure TLS connection with the server by default. This option is typically used when connecting to a server on port 990, which is the default port number used for FTPS.
    - `FTP_OPTION_SECURE_EXPLICIT`: This option specifies queued file transfers should establish a standard connection to the server and then use the AUTH command to negotiate an explicit secure connection. This option is typically used when connecting to the server on ports other than 990.
    - `FTP_OPTION_SECURE_SHELL`: This option specifies queued file transfers should use the Secure Shell (SSH) protocol to establish the connection by default. This option will automatically be selected if the connection is established using port 22, the default port for SSH.

### Return Value

- **Type**: `HQUEUE`
- If the function succeeds, the return value is a handle to the queue which can be used with subsequent function calls. If the function fails, the return value is INVALID_QUEUE. To get extended error information, call FtpGetLastError.

### Remarks

- If the nMaxFiles parameter is INFINITE, memory will be dynamically allocated on the process heap with no limit to the number of files which can be queued. If there is a logic error which causes the application to recursively add files to the queue, or repeatedly queue the same file, this can result in virtual memory being exhausted for the process. You can avoid this by specifying a reasonable maximum queue size, which will cause the FtpAddQueuedFile function to fail if that limit is exceeded.
- The memory allocated for the queue will be released when the FtpDeleteQueue function is called.

### Example

```cpp
// Create a new queue
HQUEUE hQueue = FtpCreateQueue(INFINITE, FTP_TIMEOUT, FTP_OPTION_DEFAULT);

if (hQueue == INVALID_QUEUE)
	return;

// Add a file to the queue
DWORD dwFileId = FtpAddQueuedFile(
					hQueue,
					lpszLocalFile,
					lpszRemoteFile,
					FTP_OPTION_DEFAULT,
					FILE_TYPE_AUTO,
					FTP_TIMEOUT);

// Display information about the queued file
if (dwFileId != 0)
{
	FTPQUEUEDFILE queuedFile;

	if (FtpGetQueuedFile(hQueue, dwFileId, &queuedFile))
	{
		switch (queuedFile.dwMode)
		{
		case FTP_QUEUE_DOWNLOAD:
			_tprintf(_T("%u: Download \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szRemoteFile,
						queuedFile.szLocalFile);
				break;

		case FTP_QUEUE_UPLOAD:
			_tprintf(_T("%u: Upload \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szLocalFile,
						queuedFile.szRemoteFile);
				break;
		}
	}
}

// Start the queued file transfers and wait for it to complete
if (FtpStartQueue(hQueue, FTP_QUEUE_ALL, 0, NULL, 0))
{
	FtpWaitForQueue(hQueue, INFINITE, &dwElapsed, &dwError);
	FtpStopQueue(hQueue);
}

// Remove all files from the queue
FtpDeleteQueue(hQueue);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpAddQueuedFile](#ftpaddqueuedfile-function)
- [FtpDeleteQueue](#ftpdeletequeue-function)
- [FtpClearQueue](#ftpclearqueue-function)
- [FtpStartQueue](#ftpstartqueue-function)
- [FtpStopQueue](#ftpstopqueue-function)
- [FtpWaitForQueue](#ftpwaitforqueue-function)

---

## FtpCreateSecurityCredentials Function

Create a new security credentials structure

### Prototype

```c
BOOL WINAPI FtpCreateSecurityCredentials(
    DWORD dwProtocol,
    DWORD dwOptions,
    LPCTSTR lpszUserName,
    LPCTSTR lpszPassword,
    LPCTSTR lpszCertStore,
    LPCTSTR lpszCertName,
    LPVOID lpvReserved,
    LPSECURITYCREDENTIALS lppCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `dwProtocol` | `DWORD` | A bitmask of supported security protocols. This parameter is constructed by using a bitwise operator with any of the following values: |
| `dwOptions` | `DWORD` | A value which specifies one or more options. This value should always be zero for connections using SSH. This member is constructed by using a bitwise operator with any of the following values: |
| `lpszUserName` | `LPCTSTR` | A pointer to a string which specifies the certificate owner's username. A value of NULL specifies that no username is required. Currently this parameter is not used and any value specified will be ignored. |
| `lpszPassword` | `LPCTSTR` | A pointer to a string which specifies the certificate owner's password. A value of NULL specifies that no password is required. This parameter is only used if a PKCS #12 (PFX) certificate file is specified and that certificate has been secured with a password. This value will be ignored the current user or local machine certificate store is specified. |
| `lpszCertStore` | `LPCTSTR` | A pointer to a string which specifies the name of the certificate store to open. A certificate store is a collection of certificates and their private keys, typically organized by how they are used. If this value is NULL or points to an empty string, the default certificate store "MY" will be used. |
| `lpszCertName` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the certificate to use. The function will first search the certificate store for a certificate with a matching "friendly name"; this is a name for the certificate that is assigned by the user. Note that the name must match completely, but the comparison is not case sensitive. If no matching certificate is found, the function will then attempt to find a certificate that has a matching common name (also called the certificate subject). This comparison is less stringent, and the first partial match will be returned. If this second search fails, the function will return an error indicating that the certificate could not be found. |
| `lpvReserved` | `LPVOID` | Pointer reserved for future use. Set it to NULL when using this function. |
| `lppCredentials` | `LPSECURITYCREDENTIALS` | Pointer to an LPSECURITYCREDENTIALS pointer. The memory for the credentials structure will be allocated by this function and must be released by calling the FtpDeleteSecurityCredentials function when it is no longer needed. The pointer value must be set to NULL before the function is called. It is important to note that this is a pointer to a pointer variable, not a pointer to the SECURITYCREDENTIALS structure itself. |

### Options

- **dwProtocol** Parameter

    - `SECURITY_PROTOCOL_DEFAULT`: The default security protocol will be used when establishing a connection. This option will always request the latest version of the preferred security protocol and is the recommended value. Currently the default security protocol is TLS 1.2.
    - `SECURITY_PROTOCOL_TLS`: Either the TLS 1.2 or 1.3 protocol should be used when establishing a secure connection. The correct protocol is automatically selected, based on what version of the protocol is supported by the server. If this is the only protocol specified, SSL will be excluded from the list of supported protocols. This may be necessary for some servers which reject any attempt to use the older SSL protocol and require that only TLS be used.
    - `SECURITY_PROTOCOL_TLS10`: The TLS 1.0 protocol should be used when establishing a secure connection. This version is supported on all Windows platforms, however some servers may reject connections using version 1.0 in favor of using version 1.2. This version should only be used for backwards compatibility with older servers that have not been updated to use the current version of TLS.
    - `SECURITY_PROTOCOL_TLS11`: The TLS 1.1 protocol should be used when establishing a secure connection. This version is supported on Windows 7 and later desktop platforms, and Windows Server 2008 R2 and later server platforms. Some servers may reject connections using version 1.1 in favor of using version 1.2. This version should only be used for backwards compatibility with older servers that have not been updated to use the current version of TLS.
    - `SECURITY_PROTOCOL_TLS12`: The TLS 1.2 protocol should be used when establishing a secure connection. This version is supported on Windows 7 and later desktop platforms, and Windows Server 2008 R2 and later server platforms. This version of TLS offers the broadest compatibility with most servers.
    - `SECURITY_PROTOCOL_TLS13`: The TLS 1.3 protocol should be used when establishing a secure connection. This is the newest version of the protocol and is only supported on Windows 11, Windows Server 2022 and later versions of Windows. If this version is not supported by the operating system, TLS 1.2 will be used instead.
    - `SECURITY_PROTOCOL_SSH2`: The Secure Shell 2.0 protocol should be used when establishing the connection. This is the default version of the protocol that is supported by most SSH servers.
- **dwOptions** Parameter

    - `CREDENTIAL_STORE_CURRENT_USER`: The library will attempt to open a store for the current user using the certificate store name provided in this structure. If no options are specified, then this is the default behavior.
    - `CREDENTIAL_STORE_LOCAL_MACHINE`: The library will attempt to open a local machine store using the certificate store name provided in this structure. If this option is specified, the library will always search for a local machine store before searching for the store by that name for the current user.
    - `CREDENTIAL_STORE_FILENAME`: The certificate store name is a file that contains the certificate and private key that will be used.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call the FtpGetLastError function.

### Remarks

- The structure that is created by this function may be used as client credentials when establishing a secure connection. This is particularly useful for programming languages other than C/C++ which may not support C structures or pointers. The pointer to the SECURITYCREDENTIALS structure can be declared as an unsigned integer variable which is passed by reference to this function, and then passed by value to the FtpConnect function.
- A client application only needs to call this function if the server requires that the client provide a certificate as part of the process of negotiating the secure session. If a certificate is required, note that it must have a private key associated with it. Attempting to use a certificate that does not have a private key will result in an error during the connection process indicating that the client credentials could not be established.
- If you are using a local certificate store, with the certificate and private key stored in the registry, you can explicitly specify whether the certificate store for the current user or the local machine (all users) should be used. This is done by prefixing the certificate store name with "HKCU:" for the current user, or "HKLM:" for the local machine. For example, a certificate store name of "HKLM:MY" would specify the personal certificate store for the local machine, rather than the current user. If neither prefix is specified, then it will default to the certificate store for the current user. You can manage these certificates using the CertMgr.msc Microsoft Management Console (MMC) snap-in.
- It is possible to load the certificate from a file rather than from current user's certificate store. The dwOptions parameter should be set to CREDENTIAL_STORE_FILENAME and the lpszCertStore parameter should specify the name of the file that contains the certificate and its private key. The file must be in Private Information Exchange (PFX) format, also known as PKCS #12.These certificate files typically have an extension of .pfx or .p12. If a password was specified when the certificate was created, it must be provided in the lpszPassword parameter or the library will be unable to access the certificate.
- Note that the lpszUserName and lpszPassword parameters are values which are used to access the certificate store or client certificate. They are not the credentials which are used when establishing the connection with the remote host or authenticating the client session. In most cases, these parameters will be NULL.

### Example

```cpp
LPCTSTR lpszCertStore = _T("HKCU:MY");   // The current user's personal certificate store
LPCTSTR lpszCertName = _T("ClientCert"); // The client certificate name
LPSECURITYCREDENTIALS lpSecCred = NULL;

FtpCreateSecurityCredentials(SECURITY_PROTOCOL_DEFAULT,
							CREDENTIAL_STORE_CURRENT_USER,
							NULL,
							NULL,
							lpszCertStore,
							lpszCertName,
							NULL,
							&lpSecCred);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cswskv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpConnect](#ftpconnect-function)
- [FtpDeleteSecurityCredentials](#ftpdeletesecuritycredentials-function)

---

## FtpDeleteFile Function

Delete a file from the server

### Prototype

```c
INT WINAPI FtpDeleteFile(
    HCLIENT hClient,
    LPCTSTR lpszFileName
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileName` | `LPCTSTR` | Points to a string that specifies the name of the remote file to delete. The file pathing and name conventions must be that of the server. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The current user must have the appropriate permission to delete the file, or an error will be returned by the server.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetFile](#ftpgetfile-function)
- [FtpPutFile](#ftpputfile-function)
- [FtpRenameFile](#ftprenamefile-function)

---

## FtpDeleteQueue Function

Delete a previously created file transfer queue

### Prototype

```c
BOOL WINAPI FtpDeleteQueue(
    HQUEUE hQueue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- This function can only be called when the queue is in an idle state. If the queue manager is in the process of uploading or downloading files, the function will fail and return a value of zero. You can determine the current state of the queue by calling the FtpGetQueueStatus function. It is not necessary to explicitly clear the queue prior to calling this function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpCreateQueue](#ftpcreatequeue-function)
- [FtpGetQueueStatus](#ftpgetqueuestatus-function)
- [FtpCancelQueuedFile](#ftpcancelqueuedfile-function)
- [FtpClearQueue](#ftpclearqueue-function)
- [FtpStartQueue](#ftpstartqueue-function)
- [FtpStopQueue](#ftpstopqueue-function)
- [FtpWaitForQueue](#ftpwaitforqueue-function)

---

## FtpDeleteSecurityCredentials Function

Delete a previously created security credentials structure

### Prototype

```c
VOID WINAPI FtpDeleteSecurityCredentials(
    LPSECURITYCREDENTIALS lppCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lppCredentials` | `LPSECURITYCREDENTIALS` | Pointer to an LPSECURITYCREDENTIALS pointer. On exit from the function, the pointer will be NULL. |

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- This function can be used to release the memory allocated to the client or server credentials after a secure connection has been terminated.

### Example

```cpp
if (lpSecCred != NULL)
	FtpDeleteSecurityCredentials(&lpSecCred);

FtpUninitialize();
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpCreateSecurityCredentials](#ftpcreatesecuritycredentials-function)
- [FtpUninitialize](#ftpuninitialize-function)

---

## FtpDisableEvents Function

Disable event notification

### Prototype

```c
INT WINAPI FtpDisableEvents(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpDisableEvents function is used to disable event message posting for the specified client session. Although this will immediately prevent any new events from being generated, it is possible that messages could be waiting in the message queue. Therefore, an application must be prepared to handle client event messages after this function has been called.
- This function is automatically called if the client has event notification enabled, and the FtpDisconnect function is called. The same issues regarding outstanding event messages also applies in this situation, requiring that the application handle event messages that may reference a client handle that is no longer valid.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpAsyncConnect](#ftpasyncconnect-function)
- [FtpAsyncProxyConnect](#ftpasyncproxyconnect-function)
- [FtpEnableEvents](#ftpenableevents-function)
- [FtpRegisterEvent](#ftpregisterevent-function)

---

## FtpDisableTrace Function

Disable logging of network function calls to the trace log

### Prototype

```c
BOOL WINAPI FtpDisableTrace();
```

### Parameters

| Name | Type | Description |
|------|------|-------------|

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, a value of zero is returned.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpEnableTrace](#ftpenabletrace-function)

---

## FtpDisconnect Function

Disconnect the client session from the server

### Prototype

```c
INT WINAPI FtpDisconnect(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpConnect](#ftpconnect-function)
- [FtpProxyConnect](#ftpproxyconnect-function)
- [FtpUninitialize](#ftpuninitialize-function)

---

## FtpDownloadFile Function

Download a file from the server to the local system

### Prototype

```c
BOOL WINAPI FtpDownloadFile(
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    UINT nTimeout,
    DWORD dwOptions,
    LPFTPTRANSFERSTATUS lpStatus,
    FTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file on the local system that will be created, overwritten or appended to. The file pathing and name conventions must be that of the local host. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the complete URL of the file to be downloaded. The URL must follow the conventions for the File Transfer Protocol and may specify either a standard or secure connection, alternate port number, username, password and optional working directory. |
| `nTimeout` | `UINT` | The number of seconds that the client will wait for a response before failing the operation. A value of zero specifies that the default timeout period of sixty seconds will be used. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `lpStatus` | `LPFTPTRANSFERSTATUS` | A pointer to an FTPTRANSFERSTATUS structure which contains information about the status of the current file transfer. If this information is not required, a NULL pointer may be specified as the parameter. |
| `lpEventProc` | `FTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the FtpEventProc callback function. If this parameter is NULL, the callback for the specified event is disabled. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. |

### Options

- **dwOptions** Parameter

    - `FTP_OPTION_DEFAULT`: Default options should be used for file transfers. This is the same as specifying that all file transfers should use passive mode when establishing a data connection with the server. It is recommended most applications use passive mode to prevent potential compatibility issues with certain types of firewalls and routers which use Network Address Translation (NAT).
    - `FTP_OPTION_PASSIVE`: This option specifies file transfers should attempt to establish the data connection with the server. If the local system is behind a firewall or a NAT router, the server may not be able to establish a data connection back to the client and the transfer will fail. This option forces the client to establish an outbound data connection with the server. It is recommended that applications use passive mode whenever possible.
    - `FTP_OPTION_FIREWALL`: This option specifies the client should always use the host IP address to establish the data connection with the server, not the address returned by the server in response to the PASV command. This option may be necessary if the server is behind a router that performs Network Address Translation (NAT) and it returns an unreachable IP address for the data connection. If this option is specified, it will also enable passive mode data transfers.
    - `FTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. Note that the server must support secure connections using the TLS protocol.
    - `FTP_OPTION_SECURE_EXPLICIT`: This option specifies the client should use the AUTH command to negotiate an explicit secure connection. Some servers may only require this when connecting to the server on ports other than 990.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpDownloadFile function provides a convenient way for an application to download a file in a single function call. Based on the connection information specified in the URL, it will connect to the server, authenticate the session, change the current working directory if necessary and then download the file to the local system. The URL must be complete, and specify either a standard or secure FTP scheme:
- If no user name and password is provided, then the client session will be authenticated as an anonymous user. If a path is specified as part of the URL, the function will attempt to change the current working directory. Note that the path in an FTP URL is relative to the home directory of the user account and is not an absolute path starting at the root directory on the server. The URL scheme will always determine if the connection is secure, not the option. In other words, if the "ftp" scheme is used and the FTP_OPTION_SECURE option is specified, that option will be ignored. To establish a secure connection, either the "ftps" or "sftp" scheme must be specified.
- The optional "type" value at the end of the file name determines if the file should be downloaded as a text or binary file. A value of "a" specifies that the file should be downloaded as a text file. A value of "i" specifies that the file should be downloaded as a binary file. If the type is not explicitly specified, the file will be downloaded as a binary file.
- The lpStatus parameter can be used by the application to determine the final status of the transfer, including the total number of bytes copied, the amount of time elapsed and other information related to the transfer process. If this information isn't needed, then this parameter may be specified as NULL.
- The lpEventProc parameter specifies a pointer to a function which will be periodically called during the file transfer process. This can be used to check the status of the transfer by calling FtpGetTransferStatus and then update the program's user interface. For example, the callback function could calculate the percentage for how much of the file has been transferred and then update a progress bar control. The dwParam parameter is used in conjunction with the event handler and specifies a user-defined value that is passed to the callback function. One common use in a C++ program is to pass the this pointer as the value, and then cast it back to an object pointer inside the callback function. If no event handler is required, then a NULL pointer can be specified as the value for lpEventProc and the dwParam parameter will be ignored.
- The FtpDownloadFile function is designed to provide a simpler interface for downloading a file. However, complex connections such as those using a proxy server or a secure connection which uses a client certificate will require the program to establish the connection using FtpConnect and then use FtpGetFile to download the file.

### Example

```cpp
FTPTRANSFERSTATUS ftpStatus;
LPCTSTR lpszLocalFile = _T("c:\\temp\\database.mdb");
LPCTSTR lpszRemoteFile = _T("ftp://ftp.example.com/updates/database.mdb");
BOOL bResult;

// Download the file using the specified URL
bResult = FtpDownloadFile(lpszLocalFile,
						lpszRemoteFile,
						FTP_OPTION_PASSIVE,
						&ftpStatus,
						NULL, 0);

if (!bResult)
{
	TCHAR szError[128];

	// Display a message box that describes the error
	FtpGetErrorString(FtpGetLastError(), szError, 128);
	MessageBox(NULL, szError, NULL, MB_ICONEXCLAMATION|MB_TASKMODAL);
	return;
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpEventProc](#ftpeventproc-function)
- [FtpGetFile](#ftpgetfile-function)
- [FtpGetTransferStatus](#ftpgettransferstatus-function)
- [FtpUploadFile](#ftpuploadfile-function)
- [FTPTRANSFERSTATUS](#ftptransferstatus-function)

---

## FtpEnableEvents Function

Enable event notification

### Prototype

```c
INT WINAPI FtpEnableEvents(
    HCLIENT hClient,
    HWND hEventWnd,
    UINT uEventMsg
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `hEventWnd` | `HWND` | Handle to the window which will receive the client notification messages. This parameter must specify a valid window handle. If a NULL handle is specified, event notification will be disabled. |
| `uEventMsg` | `UINT` | The message that is received when a client event occurs. This value must be greater than 1024. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpEnableEvents function is used to request that notification messages be posted to the specified window whenever a client event occurs. This allows an application to monitor the status of different client operations, such as a file transfer.
- The wParam argument will contain the client handle, the low word of the lParam argument will contain the event ID, and the high word will contain any error code. If no error has occurred, the high word will always have a value of zero. The following events may be generated:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpDisableEvents](#ftpdisableevents-function)
- [FtpRegisterEvent](#ftpregisterevent-function)

---

## FtpEnableFeature Function

Enable the specified feature in the client

### Prototype

```c
BOOL WINAPI FtpEnableFeature(
    HCLIENT hClient,
    DWORD dwFeature,
    BOOL bEnable
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `dwFeature` | `DWORD` | An unsigned integer which specifies the feature to be enabled to disabled for the current client session. Refer to the documentation for the FtpGetFeatures function for a list of available features. |
| `bEnable` | `BOOL` | A boolean flag which specifies if the feature should be enabled or disabled. If the value is non-zero, the library will attempt to use that feature on the server. If the value is zero, the feature is disabled. If an application calls a function which requires a specific feature and that feature is disabled, the function will fail with an error indicating the feature is not supported. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, it will return a value of zero. To get extended error information, call the FtpGetLastError function.

### Remarks

- The FtpEnableFeature function is used to enable or disable a specific feature for the current session. When a client connection is first established, features are enabled based on the server type and the server's response to the FEAT command. However, as the client issues commands to the server, if the server reports that the command is unrecognized that feature will automatically be disabled in the client. An application can use the FtpEnableFeature function to control what commands will be sent to the server, or re-enable a command that was previously disabled.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetFeatures](#ftpgetfeatures-function)
- [FtpSetFeatures](#ftpsetfeatures-function)

---

## FtpEnableTrace Function

Enable logging of network function calls to a file

### Prototype

```c
BOOL WINAPI FtpEnableTrace(
    LPCTSTR lpszTraceFile,
    DWORD dwTraceFlags
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszTraceFile` | `LPCTSTR` | A pointer to a string which specifies the name of the trace log file. If this parameter is NULL or an empty string, the default file name cstrace.log is used. The file is stored in the directory specified by the TEMP environment variable, if it is defined; otherwise, the current working directory is used. |
| `dwTraceFlags` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |

### Options

- **dwTraceFlags** Parameter

    - `TRACE_INFO`: All function calls are written to the trace file. This is the default value.
    - `TRACE_ERROR`: Only those function calls which fail are recorded in the trace file.
    - `TRACE_WARNING`: Only those function calls which fail or return values which indicate a warning are recorded in the trace file.
    - `TRACE_HEXDUMP`: All functions calls are written to the trace file, plus all the data that is sent or received is displayed, in both ASCII and hexadecimal format.
    - `TRACE_PROCESS`: All function calls in the current process are logged, rather than only those functions in the current thread. This option is useful for multithreaded applications that are using worker threads.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. A return value of zero indicates an error. Failure typically indicates that the tracing library cstrcv11.dll cannot be loaded on the local system.

### Remarks

- When trace logging is enabled, the file is opened, appended to and closed for each socket function call. This makes it possible for an application to append its own logging information, however care should be taken to ensure that the file is closed before the next network operation is performed. To limit the size of the log files, enable and disable logging only around those sections of code that you wish to trace.
- Note that the TRACE_HEXDUMP trace level generates very large log files since it includes all of the data exchanged between your application and the server.
- Trace function logging is managed on a per-thread basis, not for each client handle. This means that all SocketTools libraries and components share the same settings in the current thread. If you are using multiple SocketTools libraries or components in your application, you only need to enable logging once.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpDisableTrace](#ftpdisabletrace-function)

---

## FtpEndOfFile Function

Determine if the end-of-file has been reached

### Prototype

```c
BOOL WINAPI FtpEndOfFile(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `BOOL`
- If the end-of-file has been reached, the function returns a non-zero value. If the client handle is invalid, or the end-of-file has not been reached, the function returns zero.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpCloseFile](#ftpclosefile-function)
- [FtpOpenFile](#ftpopenfile-function)
- [FtpRead](#ftpread-function)

---

## FtpEnumFiles Function

Return a list of files in a directory on the server

### Prototype

```c
INT WINAPI FtpEnumFiles(
    HCLIENT hClient,
    LPCTSTR lpszDirectory,
    LPCTSTR lpszFileMask,
    DWORD dwOptions,
    LPFTPFILESTATUS lpFileList,
    INT nMaxFiles
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszDirectory` | `LPCTSTR` | A pointer to a string that specifies the name of a directory on the server. If this parameter is NULL or points to an empty string, the function will return the files in the current working directory. This string cannot contain wildcard characters and must specify a valid directory name that exists on the server. |
| `lpszFileMask` | `LPCTSTR` | A pointer to a string that specifies a wildcard file mask that is used to return a subset of files in the directory. If this parameter is NULL or an empty string then all of the files in the directory will be returned. |
| `dwOptions` | `DWORD` | An unsigned integer value that specifies one or more options. This parameter can be a combination of one or more of the following values: |
| `lpFileList` | `LPFTPFILESTATUS` | A pointer to an array of FTPFILESTATUS structures which contains information about each of the files in the specified directory. This parameter cannot be NULL, and the array must be large enough to store the number of files specified by the nMaxFiles parameter. |
| `nMaxFiles` | `INT` | An integer value that specifies the maximum number of files that should be returned. This value must be greater than zero and the lpFileList parameter must provide an array that is large enough to store information about each file. |

### Options

- **dwOptions** Parameter

    - `FTP_ENUM_DEFAULT`: The function will return both regular files and subdirectories.
    - `FTP_ENUM_FILE`: The function will return only regular files.
    - `FTP_ENUM_DIRECTORY`: The function will return only subdirectories.
    - `FTP_ENUM_FULLPATH`: The function will return the full path of the file or subdirectory.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of files returned by the function. If the directory is empty or there are no files that match the specified wildcard file mask, the function will return zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpEnumFiles function provides a high-level interface for obtaining a list of available files in a directory on the server in a single function call. This is an alternative to opening a directory and returning information about each file by calling the FtpGetNextFile function in a loop.
- This function temporarily changes the current working directory to the directory specified by the lpszDirectory parameter. The current working directory will be restored to its original value when the function returns. The user must have the appropriate permissions to access the directory or this function will fail.
- To obtain information on a subset of files in the directory, you can specify a wildcard file mask. For FTP and FTPS (TLS) sessions, this value is passed as a parameter to the LIST command and the server performs the wildcard matching. For SFTP (SSH) sessions the wildcard matching is performed by the library, and the standard conventions for Windows file wildcards are used.
- By default, the szFileName member for each FTPFILESTATUS structure will contain the base file name. If the FTP_ENUM_FULLPATH option is specified, the function will return the full path name to the file. The library must be able to automatically determine the path delimiter that is used by the server. This is done by examining how the server identifies itself, the current directory format and the path the server returns for the current working directory. For example, UNIX based servers use the forward slash as a path delimiter. If the function cannot determine what the appropriate path delimiter is, it will ignore this option and return only the base file name.
- This function will cause the current thread to block until the file listing completes, a timeout occurs or the operation is canceled. If the directory contains files that are larger than 4GB, the FtpEnumFilesEx function should be used to obtain the correct file size.

### Example

```cpp
LPFTPFILESTATUS lpFileList = new FTPFILESTATUS[MAXFILECOUNT];

// Return all of the regular files in the current working directory
INT nResult = FtpEnumFiles(hClient, NULL, NULL, FTP_ENUM_FILE,
						lpFileList, MAXFILECOUNT);

if (nResult == FTP_ERROR)
{
	DWORD dwError = FtpGetLastError();
	_tprintf(_T("FtpEnumFiles failed, error 0x%08lx\n"), dwError);
	return;
}

_tprintf(_T("FtpEnumFiles returned %d files\n"), nResult);
for (INT nIndex = 0; nIndex < nResult; nIndex++)
{
	_tprintf(_T("file=\"%s\" size=%lu\n"), lpFileList[nIndex].szFileName,
										lpFileList[nIndex].dwFileSize);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpEnumFilesEx](#ftpenumfilesex-function)
- [FtpGetFileStatus](#ftpgetfilestatus-function)
- [FtpGetFirstFile](#ftpgetfirstfile-function)
- [FtpGetNextFile](#ftpgetnextfile-function)
- [FtpOpenDirectory](#ftpopendirectory-function)

---

## FtpEnumFilesEx Function

Return a list of files in a directory on the server, supporting files larger than 4GB

### Prototype

```c
INT WINAPI FtpEnumFilesEx(
    HCLIENT hClient,
    LPCTSTR lpszDirectory,
    LPCTSTR lpszFileMask,
    DWORD dwOptions,
    LPFTPFILESTATUSEX lpFileList,
    INT nMaxFiles
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszDirectory` | `LPCTSTR` | A pointer to a string that specifies the name of a directory on the server. If this parameter is NULL or points to an empty string, the function will return the files in the current working directory. This string cannot contain wildcard characters and must specify a valid directory name that exists on the server. |
| `lpszFileMask` | `LPCTSTR` | A pointer to a string that specifies a wildcard file mask that is used to return a subset of files in the directory. If this parameter is NULL or an empty string then all of the files in the directory will be returned. |
| `dwOptions` | `DWORD` | An unsigned integer value that specifies one or more options. This parameter can be a combination of one or more of the following values: |
| `lpFileList` | `LPFTPFILESTATUSEX` | A pointer to an array of FTPFILESTATUSEX structures which contains information about each of the files in the specified directory. This parameter cannot be NULL, and the array must be large enough to store the number of files specified by the nMaxFiles parameter. |
| `nMaxFiles` | `INT` | An integer value that specifies the maximum number of files that should be returned. This value must be greater than zero and the lpFileList parameter must provide an array that is large enough to store information about each file. |

### Options

- **dwOptions** Parameter

    - `FTP_ENUM_DEFAULT`: The function will return both regular files and subdirectories.
    - `FTP_ENUM_FILE`: The function will return only regular files.
    - `FTP_ENUM_DIRECTORY`: The function will return only subdirectories.
    - `FTP_ENUM_FULLPATH`: The function will return the full path of the file or subdirectory.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of files returned by the function. If the directory is empty or there are no files that match the specified wildcard file mask, the function will return zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpEnumFilesEx function provides a high-level interface for obtaining a list of available files in a directory on the server in a single function call. This is an alternative to opening a directory and returning information about each file by calling the FtpGetNextFileEx function in a loop.
- This function temporarily changes the current working directory to the directory specified by the lpszDirectory parameter. The current working directory will be restored to its original value when the function returns. The user must have the appropriate permissions to access the directory or this function will fail.
- To obtain information on a subset of files in the directory, you can specify a wildcard file mask. For FTP and FTPS (TLS) sessions, this value is passed as a parameter to the LIST command and the server performs the wildcard matching. For SFTP (SSH) sessions the wildcard matching is performed by the library, and the standard conventions for Windows file wildcards are used.
- By default, the szFileName member for each FTPFILESTATUSEX structure will contain the base file name. If the FTP_ENUM_FULLPATH option is specified, the function will return the full path name to the file. The library must be able to automatically determine the path delimiter that is used by the server. This is done by examining how the server identifies itself, the current directory format and the path the server returns for the current working directory. For example, UNIX based servers use the forward slash as a path delimiter. If the function cannot determine what the appropriate path delimiter is, it will ignore this option and return only the base file name.
- This function will cause the current thread to block until the file listing completes, a timeout occurs or the operation is canceled.

### Example

```cpp
LPFTPFILESTATUSEX lpFileList = new FTPFILESTATUSEX[MAXFILECOUNT];

// Return all of the regular files in the current working directory
INT nResult = FtpEnumFilesEx(hClient, NULL, NULL, FTP_ENUM_FILE,
							lpFileList, MAXFILECOUNT);

if (nResult == FTP_ERROR)
{
	DWORD dwError = FtpGetLastError();
	_tprintf(_T("FtpEnumFilesEx failed, error 0x%08lx\n"), dwError);
	return;
}

_tprintf(_T("FtpEnumFilesEx returned %d files\n"), nResult);
for (INT nIndex = 0; nIndex < nResult; nIndex++)
{
	_tprintf(_T("file=\"%s\" size=%I64d\n"), lpFileList[nIndex].szFileName,
											lpFileList[nIndex].uiFileSize);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpEnumFiles](#ftpenumfiles-function)
- [FtpGetFileStatusEx](#ftpgetfilestatusex-function)
- [FtpGetFirstFileEx](#ftpgetfirstfileex-function)
- [FtpGetNextFileEx](#ftpgetnextfileex-function)
- [FtpOpenDirectory](#ftpopendirectory-function)

---

## FtpEnumQueuedFiles Function

Return a list of files in the transfer queue

### Prototype

```c
LONG WINAPI FtpEnumQueuedFiles(
    HQUEUE hQueue,
    LPCTSTR lpszFileMask,
    DWORD dwQueueMode,
    DWORD dwExcludeFiles,
    LPDWORD lpFileList,
    LONG nMaxFiles
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `lpszFileMask` | `LPCTSTR` | A pointer to a null terminated string which specifies a file name which can include wildcards. Only those files which match this value will be enumerated. The character '?' will match against any single character, and '*' will match any number of characters. If this parameter is NULL or points to an empty string, all eligible files in the queue will be matched. |
| `dwQueueMode` | `DWORD` | An unsigned integer value which specifies if the file name should be matched against downloaded files, uploaded files or all files in the queue. Only those files which match the queue mode will be enumerated. This is a bitmask which may be one or more of the following values: |
| `dwExcludeFiles` | `DWORD` | An unsigned integer value which specifies which files to exclude from the enumeration. If this value is zero, no files will be excluded; otherwise, this value is constructed by using a bitwise operator with any of the following values: |
| `lpFileList` | `LPDWORD` | A pointer to an array of unsigned integer values which will contain the unique file identifiers for each matching file in the queue. This parameter must specify an array large enough to store all of the file identifiers, otherwise the function will fail with a ST_ERROR_BUFFER_TOO_SMALL error. If this parameter is NULL, the function will return the number of matching files. |
| `nMaxFiles` | `LONG` | An integer value which specifies the maximum number of file identifiers which can be copied into the lpFileList array. If the lpFileList parameter is not NULL, this value must be greater than zero. |

### Options

- **dwQueueMode** Parameter

    - `FTP_QUEUE_ALL`: Match the file name to all files in the queue.
    - `FTP_QUEUE_DOWNLOAD`: Match file names which are queued for download.
    - `FTP_QUEUE_UPLOAD`: Match file names which are queued for upload.
    - `FTP_QUEUE_LOCAL`: Match against the local file name instead of the remote file name.
- **dwExcludeFiles** Parameter

    - `FTP_QUEUE_FLAG_NONE`: No files should be excluded.
    - `FTP_QUEUE_FLAG_COMPLETED`: Exclude files which have been transferred. This flag is set after a queued file has been uploaded or downloaded successfully.
    - `FTP_QUEUE_FLAG_FAILED`: Exclude files which where not successfully uploaded or downloaded. This flag is set when an error occurs, either when establishing a connection with the server or during the file transfer.
    - `FTP_QUEUE_FLAG_CANCELED`: Exclude files which were canceled during the file transfer. This flag is only set when the FtpCancelQueuedFile function has been called and a queued file is in the process of being uploaded or downloaded.

### Return Value

- **Type**: `LONG`
- If the function succeeds, the return value is the number of matching files. If the queue is empty or there are no matching files, this function will return zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function populates an array of unique file identifiers which can be used to obtain information about the files in the current queue. The values returned in the lpFileList array can be used in conjunction with the FtpGetQueuedFile function. This provides an alternative to using the FtpGetFirstQueuedFile and FtpGetNextQueuedFile functions.
- The application should not make any assumptions about the value of the file identifiers returned by this function. They should be considered opaque values which are only guaranteed to uniquely identify a file in the transfer queue. In particular, there is no guarantee that the file identifiers will be sequential and they should not be used as index values into an array.

### Example

```cpp
// Get the total number of files in the queue
LONG nFiles = FtpEnumQueuedFiles(hQueue, NULL, FTP_QUEUE_ALL, FTP_QUEUE_FLAG_NONE, NULL, 0)

// Display information about the queued files
if (nFiles > 0)
{
	DWORD *pdwFileList = new DWORD[nFiles];

	nFiles = FtpEnumQueuedFiles(hQueue, NULL, FTP_QUEUE_ALL, FTP_QUEUE_FLAG_NONE, pdwFileList, nFiles);

	for (LONG nIndex = 0; nIndex < nFiles; nIndex++)
	{
		FTPQUEUEDFILE queuedFile;

		if (FtpGetQueuedFile(hQueue, pdwFileList[nIndex], &queuedFile) == FALSE)
			break;
			
		switch (queuedFile.dwMode)
		{
		case FTP_QUEUE_DOWNLOAD:
			_tprintf(_T("%u: Download \"%s\" to \"%s\"\n"),
						queuedFile.dwFileId,
						queuedFile.szRemoteFile,
						queuedFile.szLocalFile);
				break;

		case FTP_QUEUE_UPLOAD:
			_tprintf(_T("%u: Upload \"%s\" to \"%s\"\n"),
						queuedFile.dwFileId,
						queuedFile.szLocalFile,
						queuedFile.szRemoteFile);
				break;
		}
	}
	
	delete pdwFileList;
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAddQueuedFile](#ftpaddqueuedfile-function)
- [FtpFindQueuedFile](#ftpfindqueuedfile-function)
- [FtpGetFirstQueuedFile](#ftpgetfirstqueuedfile-function)
- [FtpGetNextQueuedFile](#ftpgetnextqueuedfile-function)
- [FtpGetQueuedFile](#ftpgetqueuedfile-function)
- [FtpRemoveQueuedFile](#ftpremovequeuedfile-function)

---

## FtpEnumTasks Function

Return a list of asynchronous tasks

### Prototype

```c
INT WINAPI FtpEnumTasks(
    UINT lpTasks,
    INT nMaxTasks,
    DWORD dwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpTasks` | `UINT` | A pointer to an array of unsigned integer values that will contain unique task identifiers when the function returns. If this parameter is NULL, the function will return the number of tasks. |
| `nMaxTasks` | `INT` | An integer value that specifies the maximum number of task identifiers that may be copied into the lpTasks array. If the lpTasks parameter is NULL, this value must be zero. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies the type of asynchronous tasks that may be returned by this function. It may be a combination of the following values: |

### Options

- **dwOptions** Parameter

    - `FTP_TASK_DEFAULT`: The list of asynchronous task IDs should include both active and suspended tasks. This option is the same as specifying both the FTP_TASK_ACTIVE and FTP_TASK_SUSPENDED options.
    - `FTP_TASK_ACTIVE`: The list of asynchronous task IDs should include those tasks which are currently active. An active task represents a background connection to a server that is in the process of performing the requested action, such as uploading or downloading a file.
    - `FTP_TASK_SUSPENDED`: The list of asynchronous task IDs should include those tasks which have been suspended. A suspended task represents a background connection that has been established, but the worker thread is not scheduled for execution.
    - `FTP_TASK_FINISHED`: The list of asynchronous task IDs should include those tasks which have completed recently.

### Return Value

- **Type**: `INT`
- If the function is successful, the return value is the number of task identifiers copied into the provided array. If there are no tasks which match the requested criteria, the return value is zero. A return value of FTP_ERROR indicates an error has occurred. To get extended error information, call the FtpGetLastError function.

### Remarks

- The FtpEnumTasks function can be used to obtain a list of numeric identifiers that represent the asynchronous tasks that have been started or those that have completed. These task IDs are used by other functions to reference the background worker thread that has been created and obtain status information for the task. For example, the FtpTaskDone function can be used to determine if a particular task has completed, and the FtpTaskWait function can be used to wait for a task to complete and return an error status code if the background operation failed.
- There is an internal limit of 128 asynchronous tasks per process that may be active at any one time. When a task completes, the status information about that task is maintained for period of time after the task has completed.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpTaskDone](#ftptaskdone-function)
- [FtpTaskResume](#ftptaskresume-function)
- [FtpTaskSuspend](#ftptasksuspend-function)
- [FtpTaskWait](#ftptaskwait-function)

---

## FtpEventProc Function

Callback function that processes events generated by the client

### Prototype

```c
VOID __cdecl FtpEventProc(
    HCLIENT hClient,
    UINT nEventId,
    DWORD dwError,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nEventId` | `UINT` | An unsigned integer which specifies which event occurred. For a complete list of events, refer to the FtpRegisterEvent function. |
| `dwError` | `DWORD` | An unsigned integer which specifies any error that occurred. If no error occurred, then this parameter will be zero. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value which was specified when the event callback was registered. |

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- An application must register this callback function by passing its address to the FtpRegisterEvent function. This callback function is also used by asynchronous tasks to notify the application when the task has started and completed. The FtpEventProc function is a placeholder for the application-defined function name. Other functions, such as FtpStartQueue can also use event callbacks.
- If the callback function is invoked by an asynchronous task, it will execute in the context of the worker thread that is managing the client session. You must ensure that any access to global or static variables are synchronized, otherwise the results may be unpredictable. It is recommended that you do not declare any static variables within the callback function itself, and you should avoid calling any functions which could cause the thread to block. For example, you should not attempt to establish other network connections from within the event handler.
- If your application has a graphical user interface, you should never attempt to directly modify a UI control from within the callback function for an asynchronous task. Controls should only be modified by the same UI thread that created their window. One common approach to resolve this issue is to post a user-defined message to the main window to signal that the user interface needs to be updated. The message handler would then process the user-defined message and update the user interface as needed.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpDisableEvents](#ftpdisableevents-function)
- [FtpEnableEvents](#ftpenableevents-function)
- [FtpFreezeEvents](#ftpfreezeevents-function)
- [FtpRegisterEvent](#ftpregisterevent-function)
- [FtpStartQueue](#ftpstartqueue-function)

---

## FtpFindQueuedFile Function

Find a file in the transfer queue which matches the search criteria

### Prototype

```c
DWORD WINAPI FtpFindQueuedFile(
    HQUEUE hQueue,
    LPCTSTR lpszFileName,
    DWORD dwQueueMode,
    DWORD dwExcludeFiles
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `lpszFileName` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the file to search for. The string may contain the wildcard character '?' to match against any single character, and '*' will match any number of characters. This parameter cannot be NULL or point to an empty string. |
| `dwQueueMode` | `DWORD` | An unsigned integer value which specifies if the file name should be matched against downloaded files, uploaded files or all files in the queue. This is a bitmask which may be one or more of the following values: |
| `dwExcludeFiles` | `DWORD` | An unsigned integer value which specifies which files to exclude from the search. If this value is zero, no files will be excluded from the search; otherwise, this value is constructed by using a bitwise operator with any of the following values: |

### Options

- **dwQueueMode** Parameter

    - `FTP_QUEUE_ALL`: Match the file name to all files in the queue.
    - `FTP_QUEUE_DOWNLOAD`: Match file names which are queued for download.
    - `FTP_QUEUE_UPLOAD`: Match file names which are queued for upload.
    - `FTP_QUEUE_LOCAL`: Match against the local file name instead of the remote file name.
- **dwExcludeFiles** Parameter

    - `FTP_QUEUE_FLAG_NONE`: No files should be excluded from the search.
    - `FTP_QUEUE_FLAG_COMPLETED`: Exclude files which have been transferred. This flag is set after a queued file has been uploaded or downloaded successfully.
    - `FTP_QUEUE_FLAG_FAILED`: Exclude files which where not successfully uploaded or downloaded. This flag is set when an error occurs, either when establishing a connection with the server or during the file transfer.
    - `FTP_QUEUE_FLAG_CANCELED`: Exclude files which were canceled during the file transfer. This flag is only set when the FtpCancelQueuedFile function has been called and a queued file is in the process of being uploaded or downloaded.

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is a unique identifier for the file. To obtain information about the file, call the FtpGetQueuedFile function. If the function fails, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- This function returns a unique file identifier for the first file which matches the specified file name in the queue. If the lpszFileName parameter includes wildcard characters, this function will return the first file in the queue which matches the name. File name matches are not case-sensitive, even when matching against remote file names on servers which use case-sensitive naming, such as UNIX based servers.
- To perform more complex searches based on the file name, or to find multiple files, you can use the FtpGetFirstQueuedFile and FtpGetNextQueuedFile functions to iterate through all queued files.

### Example

```cpp
// Find a local file in the download queue
DWORD dwFileId = FtpFindQueuedFile(
					hQueue,
					lpszFileName,
					FTP_QUEUE_DOWNLOAD | FTP_QUEUE_LOCAL,
					FTP_QUEUE_FLAG_NONE);

// Display information about the queued file
if (dwFileId != 0)
{
	FTPQUEUEDFILE queuedFile;

	if (FtpGetQueuedFile(hQueue, dwFileId, &queuedFile))
	{
		switch (queuedFile.dwMode)
		{
		case FTP_QUEUE_DOWNLOAD:
			_tprintf(_T("%u: Download \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szRemoteFile,
						queuedFile.szLocalFile);
				break;

		case FTP_QUEUE_UPLOAD:
			_tprintf(_T("%u: Upload \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szLocalFile,
						queuedFile.szRemoteFile);
				break;
		}
	}
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAddQueuedFile](#ftpaddqueuedfile-function)
- [FtpEnumQueuedFiles](#ftpenumqueuedfiles-function)
- [FtpGetFirstQueuedFile](#ftpgetfirstqueuedfile-function)
- [FtpGetNextQueuedFile](#ftpgetnextqueuedfile-function)
- [FtpGetQueuedFile](#ftpgetqueuedfile-function)
- [FtpRemoveQueuedFile](#ftpremovequeuedfile-function)

---

## FtpFreezeEvents Function

Suspend and resume event handling by the client

### Prototype

```c
INT WINAPI FtpFreezeEvents(
    HCLIENT hClient,
    BOOL bFreeze
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `bFreeze` | `BOOL` | A non-zero value specifies that event handling should be suspended by the client. A zero value specifies that event handling should be resumed. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function should be used when the application does not want to process events, such as when a modal dialog is being displayed. When events are suspended, all client events are queued. If events are re-enabled at a later point, those queued events will be sent to the application for processing. Note that only one of each event will be generated. For example, if the client has suspended event handling, and four read events occur, once event handling is resumed only one of those read events will be posted to the client. This prevents the application from being flooded by a potentially large number of queued events.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpDisableEvents](#ftpdisableevents-function)
- [FtpEnableEvents](#ftpenableevents-function)
- [FtpRegisterEvent](#ftpregisterevent-function)

---

## FtpGetActivePorts Function

Return the range of local port numbers used for active transfers

### Prototype

```c
INT WINAPI FtpGetActivePorts(
    HCLIENT hClient,
    UINT lpnLowPort,
    UINT lpnHighPort
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpnLowPort` | `UINT` | Points to an unsigned integer that will contain the low port number when the function returns. |
| `lpnHighPort` | `UINT` | Points to an unsigned integer that will contain the high port number when the function returns. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function is used to determine the default port numbers being used for active mode file transfers. When using active mode, the client listens for an inbound connection from the server rather than establishing an outbound connection for the data transfer. In most cases, passive mode transfers are preferred because they mitigate potential compatibility issues with firewalls and NAT routers.
- If active mode transfers are required, the default port range used when listening for the server connection is between 1024 and 5000. This is the standard range of ephemeral ports used by the Windows operating system. However, under some circumstances that range of ports may be too small, or a firewall may be configured to deny inbound connections on ephemeral ports. In that case, the FtpSetActivePorts function can be used to specify a different range of port numbers.
- While it is technically permissible to assign the low and high port numbers to the same value, effectively specifying a single active port number, this is not recommended as it can cause the transfer to fail unexpectedly if multiple file transfers are performed. A minimum range of at least 1000 ports is recommended. For example, if you specify a low port value of 40000 then it is recommended that the high port value be at least 41000. The maximum port value is 65535.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpSetActivePorts](#ftpsetactiveports-function)
- [FtpSetPassiveMode](#ftpsetpassivemode-function)

---

## FtpGetAutoFileType Function

Return the file transfer type based on the file extension or content

### Prototype

```c
UINT WINAPI FtpGetAutoFileType(
    HCLIENT hClient,
    LPCTSTR lpszFileName,
    BOOL bScanFile
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. If this parameter is INVALID_CLIENT the function will only check against the global list of default text file extensions. If the handle is valid, it will also check for any application defined file extensions. |
| `lpszFileName` | `LPCTSTR` | A pointer to a null-terminated string which specifies the local path to the file. This parameter cannot be NULL and cannot specify a local device name or directory. |
| `bScanFile` | `BOOL` | Specifies if the contents of the file should be scanned. A value of zero indicates that only the file extension should be used to determine the file type, while a non-zero value specifies the contents of the file should be examined if the file type cannot be determined based on its extension. |

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is the file transfer type. If the function fails, the return value is INVALID_FILE_TYPE. To get extended error information, call FtpGetLastError.

### Remarks

- This function is used to determine the file transfer type to be used when uploading or downloading files. This function is called internally when FILE_TYPE_AUTO is specified as the default file type. The return value may be one of the following:
- If the file extension or contents are not recognized, the default file transfer type for the client session will be returned. This will usually be FILE_TYPE_IMAGE, however this can be changed by calling the FtpRegisterFileType function. The file type for the current client session can be explicitly set using the FtpSetFileType function.
- If the bScanFile parameter is non-zero, the local file will be opened in a shared reading mode and up to 4,096 bytes will be examined to determine if it contains binary data. If the file is currently locked or has been opened exclusively by another process, the file type associated with the file extension will be returned instead. Text files which contain UTF-16 text will always return a file type of FILE_TYPE_IMAGE because they can contain non-ASCII characters and/or embedded null characters.
- If the bScanFile parameter is non-zero and the file type cannot be determined based on the file name extension, the file specified by lpszFileName must exist and be a regular file. If the file does not exist, an error will be returned and the last error code will be set to ST_ERROR_FILE_NOT_FOUND. If the bScanFile parameter is zero, no errors will be returned if the file does not exist, the function will only check the file name extension to determine the file type. When downloading a file, the bScanFile parameter should normally be zero because the local file may not exist yet.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetFileType](#ftpgetfiletype-function)
- [FtpRegisterFileType](#ftpregisterfiletype-function)
- [FtpSetFileMode](#ftpsetfilemode-function)
- [FtpSetFileStructure](#ftpsetfilestructure-function)
- [FtpSetFileType](#ftpsetfiletype-function)

---

## FtpGetBufferSize Function

Return the size of an internal buffer used during data transfers

### Prototype

```c
INT WINAPI FtpGetBufferSize(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the size of the internal buffer that will be used in data transfers. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The speed of data transfers, particularly on uploads, may be sensitive to network type and configuration, and the size of the internal buffer used for data transfers. The default size of this buffer will result in good performance for a wide range of network characteristics. A larger buffer will not necessarily result in better performance. For example, a value of 1460, which is the typical Maximum Transmission Unit (MTU), may be optimal in many situations.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpSetBufferSize](#ftpsetbuffersize-function)

---

## FtpGetChannelMode Function

Return the mode for the specified communication channel

### Prototype

```c
INT WINAPI FtpGetChannelMode(
    HCLIENT hClient,
    INT nChannel
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nChannel` | `INT` | An integer value which specifies which channel to return information for. It may be one of the following values: |

### Options

- **nChannel** Parameter

    - `FTP_CHANNEL_COMMAND`: Return information about the command channel. This is the communication channel used to send commands to the server and receive command result and status information from the server.
    - `FTP_CHANNEL_DATA`: Return information about the data channel. This is the communication channel used to send or receive data during a file transfer.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the mode for the specified channel. If the function fails, it will return FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpGetChannelMode function returns a integer which may be one of the following values:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpSetChannelMode](#ftpsetchannelmode-function)

---

## FtpGetClientQuota Function

Return quota information for the current client session

### Prototype

```c
INT WINAPI FtpGetClientQuota(
    HCLIENT hClient,
    LPFTPCLIENTQUOTA lpClientQuota
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpClientQuota` | `LPFTPCLIENTQUOTA` | A pointer to an FTPCLIENTQUOTA structure which contains the quota information returned by the server. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call GetLastError.

### Remarks

- This method uses the XQUOTA command to obtain information for the current client session. If the server does not support this command, the function will fail.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetServerInformation](#ftpgetserverinformation-function)
- [FtpGetServerType](#ftpgetservertype-function)

---

## FtpGetData Function

Copy the contents of a remote file to a local buffer

### Prototype

```c
INT WINAPI FtpGetData(
    HCLIENT hClient,
    LPCTSTR lpszRemoteFile,
    LPVOID lpvBuffer,
    LPDWORD lpdwLength,
    DWORD dwReserved
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be transferred to the local system. The file naming conventions must be that of the host operating system. |
| `lpvBuffer` | `LPVOID` | A pointer to a byte buffer which will contain the data transferred from the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpdwLength` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvBuffer parameter. If the lpvBuffer parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the actual length of the file that was downloaded. |
| `dwReserved` | `DWORD` | A reserved parameter. This value should always be zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpGetData function is used to download the contents of a remote file into a local buffer. The function may be used in one of two ways, depending on the needs of the application. The first method is to pre-allocate a buffer large enough to store the contents of the file. In this case, the lpvBuffer parameter will point to the buffer that was allocated, the value that the lpdwLength parameter points to should be initialized to the size of that buffer.
- The second method that can be used is have the lpvBuffer parameter point to a global memory handle which will contain the file data when the function returns. In this case, the value that the lpdwLength parameter points to must be initialized to zero. It is important to note that the memory handle returned by the function must be freed by the application, otherwise a memory leak will occur. See the example code below.
- It is important for your application to initialize the value of the lpdwLength parameter correctly. This parameter must be passed by reference and if it is not initialized properly it can cause unexpected behavior or corrupt the process heap. If an error occurs when downloading the file, the variable passed to this function may have a value of zero when the function returns, indicating no data has been returned to the caller.
- The FtpGetText function can be used to download a text file and store the contents in a string.
- This function will cause the current thread to block until the file transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the FTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling FtpEnableEvents, or by registering a callback function using the FtpRegisterEvent function.
- To determine the current status of a file transfer while it is in progress, use the FtpGetTransferStatus function.

### Example

```cpp
HGLOBAL hgblBuffer = (HGLOBAL)NULL;
LPBYTE lpBuffer = (LPBYTE)NULL;
DWORD cbBuffer = 0;

// Return the file data into block of global memory allocated by
// the GlobalAlloc function; the handle to this memory will be
// returned in the hgblBuffer parameter
nResult = FtpGetData(hClient,
					lpszRemoteFile,
					&hgblBuffer,
					&cbBuffer,
					0);

if (nResult != FTP_ERROR)
{
	// Lock the global memory handle, returning a pointer to the
	// contents of the file data
	lpBuffer = (LPBYTE)GlobalLock(hgblBuffer);
	
	// After the data has been used, the handle must be unlocked
	// and freed, otherwise a memory leak will occur
	GlobalUnlock(hgblBuffer);
	GlobalFree(hgblBuffer);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpChangeDirectory](#ftpchangedirectory-function)
- [FtpEnableEvents](#ftpenableevents-function)
- [FtpGetFile](#ftpgetfile-function)
- [FtpGetText](#ftpgettext-function)
- [FtpGetTransferStatus](#ftpgettransferstatus-function)
- [FtpPutData](#ftpputdata-function)
- [FtpPutFile](#ftpputfile-function)
- [FtpRegisterEvent](#ftpregisterevent-function)
- [FtpSetBufferSize](#ftpsetbuffersize-function)

---

## FtpGetDirectory Function

Get the current working directory on the server

### Prototype

```c
INT WINAPI FtpGetDirectory(
    HCLIENT hClient,
    LPTSTR lpszDirectory,
    INT cbDirectory
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszDirectory` | `LPTSTR` | Points to a buffer that will contain the name of the current working directory on the server. The file pathing and name conventions must be that of the server. |
| `cbDirectory` | `INT` | The maximum number of characters that may be copied into the buffer, including the terminating null-character. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function sends the PWD command to the server.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpChangeDirectory](#ftpchangedirectory-function)
- [FtpCreateDirectory](#ftpcreatedirectory-function)
- [FtpRemoveDirectory](#ftpremovedirectory-function)

---

## FtpGetDirectoryFormat Function

Get the format which is used by the server to list files

### Prototype

```c
INT WINAPI FtpGetDirectoryFormat(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the currently selected directory format. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- Refer to the FtpSetDirectoryFormat function for a list of directory format types that are supported by the library. This function can be used to determine which format was selected by the library after a file listing has been retrieved.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpCloseDirectory](#ftpclosedirectory-function)
- [FtpGetFileStatus](#ftpgetfilestatus-function)
- [FtpGetFirstFile](#ftpgetfirstfile-function)
- [FtpGetNextFile](#ftpgetnextfile-function)
- [FtpOpenDirectory](#ftpopendirectory-function)
- [FtpSetDirectoryFormat](#ftpsetdirectoryformat-function)

---

## FtpGetErrorString Function

Return a description for the specified error code

### Prototype

```c
INT WINAPI FtpGetErrorString(
    DWORD dwErrorCode,
    LPTSTR lpszDescription,
    INT cbDescription
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `dwErrorCode` | `DWORD` | The error code for which a description is returned. |
| `lpszDescription` | `LPTSTR` | A pointer to the buffer that will contain a description of the specified error code. This buffer should be at least 128 characters in length. |
| `cbDescription` | `INT` | The maximum number of characters that may be copied into the description buffer. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the description string. If the function fails, the return value is zero, meaning that no description exists for the specified error code. Typically this indicates that the error code passed to the function is invalid.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetLastError](#ftpgetlasterror-function)
- [FtpSetLastError](#ftpsetlasterror-function)

---

## FtpGetFeatures Function

Return the features available to the client

### Prototype

```c
DWORD WINAPI FtpGetFeatures(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is one or more bit flags which specify the features that are available to the client. If the function fails, it will return zero. Because it is possible that no features would be enabled, a return value of zero does not always indicate an error. An application should call FtpGetLastError to determine if an error code has been set.

### Remarks

- The FtpGetFeatures function returns a value which may be a combination of one or more of the following bit flags:
- When a client connection is first established, features are enabled based on the server type and the server's response to the FEAT command. However, as the client issues commands to the server, if the server reports that the command is unrecognized that feature will automatically be disabled in the client.
- For example, the first time an application calls the FtpGetFileSize function to determine the size of a file, the library will try to use the SIZE command. If the server reports that the SIZE command is not available, that feature will be disabled and the library will not use the command again during the session unless it is explicitly re-enabled. This is designed to prevent the library from repeatedly sending invalid commands to a server, which may result in the server aborting the connection.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpEnableFeature](#ftpenablefeature-function)
- [FtpSetFeatures](#ftpsetfeatures-function)

---

## FtpGetFile Function

Copy a file from the server to the local system

### Prototype

```c
INT WINAPI FtpGetFile(
    HCLIENT hClient,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    DWORD dwOffset
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file on the local system that will be created, overwritten or appended to. The file pathing and name conventions must be that of the local host. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be transferred to the local system. The file naming conventions must be that of the host operating system. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter may be any one of the following values: |
| `dwOffset` | `DWORD` | A byte offset which specifies where the file transfer should begin. The default value of zero specifies that the file transfer should start at the beginning of the file. A value greater than zero is typically used to restart a transfer that has not completed successfully. Note that specifying a non-zero offset requires that the server support the REST command to restart transfers. |

### Options

- **dwOptions** Parameter

    - `FTP_TRANSFER_DEFAULT`: This option specifies the default transfer mode should be used. If the local file exists, it will be overwritten with the contents of the downloaded file.
    - `FTP_TRANSFER_APPEND`: This option specifies that if the local file exists, the contents of file on the server is appended to the local file. If the local file does not exist, it is created.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function will cause the current thread to block until the file transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the FTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling FtpEnableEvents, or by registering a callback function using the FtpRegisterEvent function.
- To determine the current status of a file transfer while it is in progress, use the FtpGetTransferStatus function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpChangeDirectory](#ftpchangedirectory-function)
- [FtpEnableEvents](#ftpenableevents-function)
- [FtpGetMultipleFiles](#ftpgetmultiplefiles-function)
- [FtpGetTransferStatus](#ftpgettransferstatus-function)
- [FtpPutFile](#ftpputfile-function)
- [FtpPutMultipleFiles](#ftpputmultiplefiles-function)
- [FtpRegisterEvent](#ftpregisterevent-function)
- [FtpSetBufferSize](#ftpsetbuffersize-function)
- [FtpVerifyFile](#ftpverifyfile-function)

---

## FtpGetFileEx Function

Copy a file from the server to the local system, supporting files larger than 4GiB

### Prototype

```c
INT WINAPI FtpGetFileEx(
    HCLIENT hClient,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    ULARGE_INTEGER uiOffset
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file on the local system that will be created, overwritten or appended to. The file pathing and name conventions must be that of the local host. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be transferred to the local system. The file naming conventions must be that of the host operating system. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter may be any one of the following values: |
| `uiOffset` | `ULARGE_INTEGER` | A byte offset which specifies where the file transfer should begin. The default value of zero specifies that the file transfer should start at the beginning of the file. A value greater than zero is typically used to restart a transfer that has not completed successfully. Note that specifying a non-zero offset requires that the server support the REST command to restart transfers. |

### Options

- **dwOptions** Parameter

    - `FTP_TRANSFER_DEFAULT`: This option specifies the default transfer mode should be used. If the local file exists, it will be overwritten with the contents of the downloaded file.
    - `FTP_TRANSFER_APPEND`: This option specifies that if the local file exists, the contents of file on the server is appended to the local file. If the local file does not exist, it is created.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function will cause the current thread to block until the file transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the FTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling FtpEnableEvents, or by registering a callback function using the FtpRegisterEvent function.
- To determine the current status of a file transfer while it is in progress, use the FtpGetTransferStatusEx function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpChangeDirectory](#ftpchangedirectory-function)
- [FtpEnableEvents](#ftpenableevents-function)
- [FtpGetMultipleFiles](#ftpgetmultiplefiles-function)
- [FtpGetTransferStatusEx](#ftpgettransferstatusex-function)
- [FtpPutFile](#ftpputfile-function)
- [FtpPutMultipleFiles](#ftpputmultiplefiles-function)
- [FtpRegisterEvent](#ftpregisterevent-function)
- [FtpSetBufferSize](#ftpsetbuffersize-function)
- [FtpVerifyFile](#ftpverifyfile-function)

---

## FtpGetFileList Function

Return an unparsed list of files in the specified directory

### Prototype

```c
INT WINAPI FtpGetFileList(
    HCLIENT hClient,
    LPCTSTR lpszDirectory,
    DWORD dwOptions,
    LPTSTR lpszBuffer,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszDirectory` | `LPCTSTR` | A pointer to a string that specifies the name of a directory and/or a wildcard file mask. The format of the directory name must match the file naming conventions of the server. If this parameter is NULL or points to an empty string, the current working directory will be used. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter may be any one of the following values: |
| `lpszBuffer` | `LPTSTR` | A pointer to a string buffer that will contain the list of files when the function returns. This buffer should be large enough to store the complete file listing and a terminating null character. If the buffer is smaller than the total amount of data returned by the server, the data will be truncated. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. |

### Options

- **dwOptions** Parameter

    - `FTP_LIST_DEFAULT`: This option specifies the server should return a complete listing of files in the specified directory with as much detail as possible. This typically means that the file size, date, ownership and access rights will be returned to the client. Information about the files are returned in lines of text, with each line terminated by carriage return and linefeed (CRLF) characters. The exact format of the data returned is specific to the server operating system.
    - `FTP_LIST_NAMEONLY`: This option specifies the server should only return a list of file names, with no additional information about the file. Each file name is terminated by carriage return and linefeed (CRLF) characters.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of bytes copied into the string buffer, not including the terminating null character. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpGetFileList function returns a list of files in the specified directory, copying the data to a string buffer. Unlike the other functions like FtpEnumFiles that parse a directory listing and return information in an FTPFILESTATUS structure, this function returns the unparsed file list data. The actual format of the data that is returned depends on the operating system and how the server implements file listings. For example, UNIX servers typically return the output from the /bin/ls command.
- Some servers may not support file listings for any directory other than the current working directory. If an error is returned when specifying a directory name, try changing the current working directory using the FtpChangeDirectory function and then call this function again, passing NULL or an empty string as the lpszDirectory parameter.
- This function can be particularly useful when the client is connected to a server that returns file listings in a format that is not recognized by the library. The application can retrieve the unparsed file listing from the server and parse the contents. Note that if you specify the FTP_LIST_NAMEONLY option, the data will only contain a list of file names and there will be no way for the application to know if they represent a regular file or a subdirectory.
- This function is supported for both FTP and SFTP (SSH) connections, however the format of the data may differ depending on which protocol is used. Most UNIX based FTP servers will not list files and subdirectories that begin with a period, however most SFTP servers will return a list of all files, even those that begin with a period.
- This function will cause the current thread to block until the file listing completes, a timeout occurs or the operation is canceled.

### Example

```cpp
TCHAR szFileList[MAXFILELISTSIZE];

nResult = FtpGetFileList(hClient, NULL, FTP_LIST_NAMEONLY,
						szFileList, MAXFILELISTSIZE);

if (nResult != FTP_ERROR)
	_tprintf(_T("%s\n"), szFileList);
else
{
	DWORD dwError = FtpGetLastError();
	_tprintf(_T("Unable to list files (error 0x%08lx)\n"), dwError);
	return;
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpCloseDirectory](#ftpclosedirectory-function)
- [FtpEnumFiles](#ftpenumfiles-function)
- [FtpGetDirectoryFormat](#ftpgetdirectoryformat-function)
- [FtpGetFirstFile](#ftpgetfirstfile-function)
- [FtpOpenDirectory](#ftpopendirectory-function)
- [FtpGetNextFile](#ftpgetnextfile-function)

---

## FtpGetFileNameEncoding Function

Return the character encoding used when sending a file name to the server

### Prototype

```c
INT WINAPI FtpGetFileNameEncoding(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the type of encoding that is used. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- Refer to the FtpSetFileNameEncoding function for a list of encoding types that are supported by the library.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpCommand](#ftpcommand-function)
- [FtpEnableFeature](#ftpenablefeature-function)
- [FtpGetFeatures](#ftpgetfeatures-function)
- [FtpSetFileNameEncoding](#ftpsetfilenameencoding-function)
- [FtpSetFeatures](#ftpsetfeatures-function)

---

## FtpGetFilePermissions Function

Return the access permissions for the specified file

### Prototype

```c
INT WINAPI FtpGetFilePermissions(
    HCLIENT hClient,
    LPCTSTR lpszFileName,
    LPDWORD lpdwPermissions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileName` | `LPCTSTR` | A pointer to a string which contains the name of the file that the access permissions are to be returned for. The filename cannot contain any wildcard characters. |
| `lpdwPermissions` | `LPDWORD` | A pointer to an unsigned integer which will contain the access permissions for the file when the function returns. The file permissions are represented as bit flags, and may be one or more of the following values: |

### Options

- **lpdwPermissions** Parameter

    - `FILE_OWNER_READ`: The owner has permission to open the file for reading. If the current user is the owner of the file, this grants the user the right to download the file to the local system.
    - `FILE_OWNER_WRITE`: The owner has permission to open the file for writing. If the current user is the owner of the file, this grants the user the right to replace the file. If this permission is set for a directory, this grants the user the right to create and delete files.
    - `FILE_OWNER_EXECUTE`: The owner has permission to execute the contents of the file. The file is typically either a binary executable, script or batch file. If this permission is set for a directory, this may also grant the user the right to open that directory and search for files in that directory.
    - `FILE_GROUP_READ`: Users in the specified group have permission to open the file for reading. If the current user is in the same group as the file owner, this grants the user the right to download the file.
    - `FILE_GROUP_WRITE`: Users in the specified group have permission to open the file for writing. On some platforms, this may also imply permission to delete the file. If the current user is in the same group as the file owner, this grants the user the right to replace the file. If this permission is set for a directory, this grants the user the right to create and delete files.
    - `FILE_GROUP_EXECUTE`: Users in the specified group have permission to execute the contents of the file. If this permission is set for a directory, this may also grant the user the right to open that directory and search for files in that directory.
    - `FILE_WORLD_READ`: All users have permission to open the file for reading. This permission grants any user the right to download the file to the local system.
    - `FILE_WORLD_WRITE`: All users have permission to open the file for writing. This permission grants any user the right to replace the file. If this permission is set for a directory, this grants any user the right to create and delete files.
    - `FILE_WORLD_EXECUTE`: All users have permission to execute the contents of the file. If this permission is set for a directory, this may also grant all users the right to open that directory and search for files in that directory.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is a result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function uses the STAT command to retrieve information about the specified file. On some systems, the STAT command will not return information on files that contain spaces or tabs in the filename. In this case, the function will fail and value pointed to by the lpdwPermissions parameter will be zero.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetFileStatus](#ftpgetfilestatus-function)
- [FtpSetFilePermissions](#ftpsetfilepermissions-function)

---

## FtpGetFileSize Function

Return the size of a file on the server

### Prototype

```c
INT WINAPI FtpGetFileSize(
    HCLIENT hClient,
    LPCTSTR lpszFileName,
    LPDWORD lpdwFileSize
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileName` | `LPCTSTR` | Points to a string that specifies the name of the remote file. |
| `lpdwFileSize` | `LPDWORD` | Points to an unsigned integer that will contain the size of the specified file in bytes. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function uses the SIZE command to determine the length of the specified file. Not all servers implement this command, in which case the function call will fail, and the lpdwFileSize parameter will be set to zero.
- Note that if the file on the server is a text file, it is possible that the value returned by this method will not match the size of the file when it is downloaded to the local system. This is because different operating systems use different sequences of characters to mark the end of a line of text, and when a file is transferred in text mode, the end of line character sequence is automatically converted to a carriage return-linefeed, which is the convention used by the Windows platform.
- Some FTP servers will refuse to return the size of a file if the current file type is set to FILE_TYPE_ASCII because the size of a text file on the server may not accurately reflect what the size of the file will be on the local system.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetFileStatus](#ftpgetfilestatus-function)
- [FtpOpenDirectory](#ftpopendirectory-function)

---

## FtpGetFileStatus Function

Return file status information from the server

### Prototype

```c
BOOL WINAPI FtpGetFileStatus(
    HCLIENT hClient,
    LPCTSTR lpszFileName,
    LPFTPFILESTATUS lpFileStatus
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileName` | `LPCTSTR` | A pointer to a string which contains the name of the file that status information will be returned on. The file name cannot contain any wildcard characters. |
| `lpFileStatus` | `LPFTPFILESTATUS` | A pointer to an FTPFILESTATUS structure which contains information about the file returned by the server. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- This function uses the STAT command to retrieve information about the specified file. Unlike the FtpGetFirstFile and FtpGetNextFile functions, which read through a file list returned on the data channel, this function reads the result of a command string. For applications that need information about a specific file, using this function can be considerably faster than iterating through all of the files in a given directory. Note that not all servers support using the command in this way.
- On some systems, the STAT command will not return information on files that contain spaces or tabs in the filename. In this case, the FTPFILESTATUS structure members will be empty strings and zero values.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpCloseDirectory](#ftpclosedirectory-function)
- [FtpGetDirectoryFormat](#ftpgetdirectoryformat-function)
- [FtpGetFirstFile](#ftpgetfirstfile-function)
- [FtpGetNextFile](#ftpgetnextfile-function)
- [FtpGetTransferStatus](#ftpgettransferstatus-function)
- [FtpOpenDirectory](#ftpopendirectory-function)
- [FtpSetDirectoryFormat](#ftpsetdirectoryformat-function)

---

## FtpGetFileStatusEx Function

Return file status information from the server, supporting files larger than 4GiB

### Prototype

```c
BOOL WINAPI FtpGetFileStatusEx(
    HCLIENT hClient,
    LPCTSTR lpszFileName,
    LPFTPFILESTATUSEX lpFileStatus
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileName` | `LPCTSTR` | A pointer to a string which contains the name of the file that status information will be returned on. The file name cannot contain any wildcard characters. |
| `lpFileStatus` | `LPFTPFILESTATUSEX` | A pointer to an FTPFILESTATUSEX structure which contains information about the file returned by the server. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- This function uses the STAT command to retrieve information about the specified file. Unlike the FtpGetFirstFileEx and FtpGetNextFileEx functions, which read through a file list returned on the data channel, this function reads the result of a command string. For applications that need information about a specific file, using this function can be considerably faster than iterating through all of the files in a given directory. Note that not all servers support using the command in this way.
- On some systems, the STAT command will not return information on files that contain spaces or tabs in the filename. In this case, the FTPFILESTATUSEX structure members will be empty strings and zero values.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpCloseDirectory](#ftpclosedirectory-function)
- [FtpGetDirectoryFormat](#ftpgetdirectoryformat-function)
- [FtpGetFirstFileEx](#ftpgetfirstfileex-function)
- [FtpGetNextFileEx](#ftpgetnextfileex-function)
- [FtpGetTransferStatusEx](#ftpgettransferstatusex-function)
- [FtpOpenDirectory](#ftpopendirectory-function)
- [FtpSetDirectoryFormat](#ftpsetdirectoryformat-function)

---

## FtpGetFileTime Function

Return the modification time for the specified file on the server

### Prototype

```c
INT WINAPI FtpGetFileTime(
    HCLIENT hClient,
    LPCTSTR lpszFileName,
    LPSYSTEMTIME lpFileTime,
    BOOL bLocalize
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileName` | `LPCTSTR` | Points to a string that specifies the name of the remote file. |
| `lpFileTime` | `LPSYSTEMTIME` | Points to a SYSTEMTIME structure that will be set to the current modification time for the remote file. |
| `bLocalize` | `BOOL` | A boolean flag which specifies if the file time is localized to the current timezone. If this value is non-zero, then the file time is adjusted to that the time is local to the current system. If this value is zero, the file time is returned in UTC time. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpGetFileTime function can be used to determine the date and time that a file was last modified on the server. The time may either be localized to the current system, or it may be returned as UTC time. If you plan on changing the values returned in the SYSTEMTIME structure and then calling FtpSetFileTime function to modify the file time on the server, you should do not localize the time.
- This function uses the MDTM command to determine the modification time of the specified file. If the server does not support this command, the function will attempt to use the STAT command to determine the file modification time.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetFileStatus](#ftpgetfilestatus-function)
- [FtpOpenDirectory](#ftpopendirectory-function)
- [FtpSetFileTime](#ftpsetfiletime-function)

---

## FtpGetFileType Function

Return the default file type for the current session

### Prototype

```c
INT WINAPI FtpGetFileType(
    HCLIENT hClient,
    UINT lpnFileType
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpnFileType` | `UINT` | A pointer to an unsigned integer that will identify the current file type. This parameter cannot be NULL. When the function returns it will contain one of the following values: |

### Options

- **lpnFileType** Parameter

    - `FILE_TYPE_AUTO`: The file type should be automatically determined based on the file name extension. If the file extension is unknown, the file type should be determined based on the contents of the file. The library has an internal list of common text file extensions, and additional file extensions can be registered using the FtpRegisterFileType function.
    - `FILE_TYPE_ASCII`: The file is a text file using the ASCII character set. For those servers which mark the end of a line with characters other than a carriage return and linefeed, it will be converted to the native client format. This is the file type used for directory listings.
    - `FILE_TYPE_EBCDIC`: The file is a text file using the EBCDIC character set. Local files will be converted to EBCDIC when sent to the server. Remote files will be converted to the native ASCII character set when retrieved from the server.
    - `FILE_TYPE_IMAGE`: The file is a binary file and no data conversion of any type is performed on the file. This is the default file type for most data files and executables. If the type of file cannot be automatically determined, it will always be considered a binary file.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- If this function is called when connected to an SFTP (SSH) server, the default file type will always be FILE_TYPE_IMAGE because SFTP does not differentiate between text files and binary files.
- The FtpSetFileType function can be used to change the default file type. To determine the automatic file type for a specific file based on its extension or contents, use the FtpGetAutoFileType function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetAutoFileType](#ftpgetautofiletype-function)
- [FtpOpenFile](#ftpopenfile-function)
- [FtpRegisterFileType](#ftpregisterfiletype-function)
- [FtpSetFileMode](#ftpsetfilemode-function)
- [FtpSetFileStructure](#ftpsetfilestructure-function)
- [FtpSetFileType](#ftpsetfiletype-function)
- [FtpSetPassiveMode](#ftpsetpassivemode-function)

---

## FtpGetFirstFile Function

Return the first file from the file list returned by the server

### Prototype

```c
BOOL WINAPI FtpGetFirstFile(
    HCLIENT hClient,
    LPFTPFILESTATUS lpFileStatus
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpFileStatus` | `LPFTPFILESTATUS` | A pointer to an FTPFILESTATUS structure which contains information about the file returned by the server. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- This file list information returned by the server is cached by the library, allowing you to use this function to reposition back to the beginning of the file list.

### Example

```cpp
if (FtpOpenDirectory(hClient, _T("")) != FTP_ERROR)
{
	FTPFILESTATUS ftpFile;
	BOOL bResult;

	bResult = FtpGetFirstFile(hClient, &ftpFile);
	while (bResult)
	{
		// The ftpFile structure contains information about the file
		bResult = FtpGetNextFile(hClient, &ftpFile);
	}

	FtpCloseDirectory(hClient);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpCloseDirectory](#ftpclosedirectory-function)
- [FtpGetDirectoryFormat](#ftpgetdirectoryformat-function)
- [FtpGetFileStatus](#ftpgetfilestatus-function)
- [FtpGetNextFile](#ftpgetnextfile-function)
- [FtpOpenDirectory](#ftpopendirectory-function)
- [FtpSetDirectoryFormat](#ftpsetdirectoryformat-function)

---

## FtpGetFirstFileEx Function

Return the first file from the file list returned by the server, supporting files larger than 4GiB

### Prototype

```c
BOOL WINAPI FtpGetFirstFileEx(
    HCLIENT hClient,
    LPFTPFILESTATUSEX lpFileStatus
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpFileStatus` | `LPFTPFILESTATUSEX` | A pointer to an FTPFILESTATUSEX structure which contains information about the file returned by the server. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- This file list information returned by the server is cached by the library, allowing you to use this function to reposition back to the beginning of the file list.

### Example

```cpp
if (FtpOpenDirectory(hClient, _T("")) != FTP_ERROR)
{
	FTPFILESTATUSEX ftpFile;
	BOOL bResult;

	bResult = FtpGetFirstFileEx(hClient, &ftpFile);
	while (bResult)
	{
		// The ftpFile structure contains information about the file
		bResult = FtpGetNextFileEx(hClient, &ftpFile);
	}

	FtpCloseDirectory(hClient);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpCloseDirectory](#ftpclosedirectory-function)
- [FtpGetDirectoryFormat](#ftpgetdirectoryformat-function)
- [FtpGetFileStatusEx](#ftpgetfilestatusex-function)
- [FtpGetNextFileEx](#ftpgetnextfileex-function)
- [FtpOpenDirectory](#ftpopendirectory-function)
- [FtpSetDirectoryFormat](#ftpsetdirectoryformat-function)

---

## FtpGetFirstQueuedFile Function

Return information about the first file in the transfer queue

### Prototype

```c
DWORD WINAPI FtpGetFirstQueuedFile(
    HQUEUE hQueue,
    DWORD dwQueueMode,
    DWORD dwExcludeFiles,
    LPFTPQUEUEDFILE lpFileInfo
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `dwQueueMode` | `DWORD` | An unsigned integer value which specifies if the file name should be matched against downloaded files, uploaded files or all files in the queue. It may be one of the following values: |
| `dwExcludeFiles` | `DWORD` | An unsigned integer value which specifies which files to exclude from the search. If this value is zero, no files will be excluded from the search; otherwise, this value is constructed by using a bitwise operator with any of the following values: |
| `lpFileInfo` | `LPFTPQUEUEDFILE` | A pointer to a FTPQUEUEDFILE structure which will contain information about the file. This parameter cannot be NULL. |

### Options

- **dwQueueMode** Parameter

    - `FTP_QUEUE_ALL`: Return information about all files in the queue.
    - `FTP_QUEUE_DOWNLOAD`: Return information for files which are queued for download.
    - `FTP_QUEUE_UPLOAD`: Return information for files which are queued for upload.
- **dwExcludeFiles** Parameter

    - `FTP_QUEUE_FLAG_NONE`: No files should be excluded.
    - `FTP_QUEUE_FLAG_COMPLETED`: Exclude files which have been transferred. This flag is set after a queued file has been uploaded or downloaded successfully.
    - `FTP_QUEUE_FLAG_FAILED`: Exclude files which where not successfully uploaded or downloaded. This flag is set when an error occurs, either when establishing a connection with the server or during the file transfer.
    - `FTP_QUEUE_FLAG_CANCELED`: Exclude files which were canceled during the file transfer. This flag is only set when the FtpCancelQueuedFile function has been called and a queued file is in the process of being uploaded or downloaded.

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is an unsigned integer with a non-zero value which uniquely identifies the file in the queue. If there are no queued files which match the specified parameters, or the function fails, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- This function returns information about the first file in the current transfer queue. It is used in conjunction with the FtpGetNextQueuedFile function to obtain information about all queued files.

### Example

```cpp
// List all files in a file transfer queue
FTPQUEUEDFILE queuedFile;
DWORD dwFileId;

dwFileId = FtpGetFirstQueuedFile(hQueue, FTP_QUEUE_ALL, FTP_QUEUE_FLAG_NONE, &queuedFile);

while (dwFileId != 0)
{
	switch (queuedFile.dwQueueMode)
	{
	case FTP_QUEUE_DOWNLOAD:
		_tprintf(_T("%u: download \"%s\" to \"%s\"\n"),
				queuedFile.dwFileId,
				queuedFile.szRemoteFile,
				queuedFile.szLocalFile);
		break;

	case FTP_QUEUE_UPLOAD:
		_tprintf(_T("%u: upload \"%s\" to \"%s\"\n"),
				queuedFile.dwFileId,
				queuedFile.szRemoteFile,
				queuedFile.szLocalFile);
		break;
	}

	dwFileId = FtpGetNextQueuedFile(hQueue, &queuedFile);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAddQueuedFile](#ftpaddqueuedfile-function)
- [FtpEnumQueuedFiles](#ftpenumqueuedfiles-function)
- [FtpFindQueuedFile](#ftpfindqueuedfile-function)
- [FtpGetNextQueuedFile](#ftpgetnextqueuedfile-function)
- [FtpGetQueuedFile](#ftpgetqueuedfile-function)

---

## FtpGetLastError Function

Return the last error code

### Prototype

```c
DWORD WINAPI FtpGetLastError();
```

### Parameters

| Name | Type | Description |
|------|------|-------------|

### Return Value

- **Type**: `DWORD`
- The return value is the last error code value for the current thread. Functions set this value by calling the FtpSetLastError function. The Return Value section of each reference page notes the conditions under which the function sets the last error code.

### Remarks

- Error codes are unsigned 32-bit values which are private to each calling thread. You should call the FtpGetLastError function immediately when a function's return value indicates that an error has occurred. That is because some functions call FtpSetLastError(0) when they succeed, clearing the error code set by the most recently failed function.
- Most functions will set the last error code value when they fail; a few functions set it when they succeed. Function failure is typically indicated by a return value such as FALSE, NULL, INVALID_CLIENT or FTP_ERROR. Those functions which call FtpSetLastError when they succeed are noted on the function reference page.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetErrorString](#ftpgeterrorstring-function)
- [FtpSetLastError](#ftpsetlasterror-function)

---

## FtpGetMultipleFiles Function

Copy multiple files from the server to the local system

### Prototype

```c
INT WINAPI FtpGetMultipleFiles(
    HCLIENT hClient,
    LPCTSTR lpszLocalDirectory,
    LPCTSTR lpszRemoteDirectory,
    LPCTSTR lpszFileMask,
    DWORD dwReserved
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalDirectory` | `LPCTSTR` | Pointer to a string which specifies the local directory where the files will be copied to. A NULL pointer or empty string specifies that files should be copied to the current working directory. |
| `lpszRemoteDirectory` | `LPCTSTR` | Pointer to a string which specifies the remote directory where the files will be copied from. A NULL pointer or empty string specifies that the files should be copied from the current working directory on the server. |
| `lpszFileMask` | `LPCTSTR` | Pointer to a string which specifies the files that are to be copied from the server to the local system. The file mask should follow the native conventions used for wildcard file matches on the server. |
| `dwReserved` | `DWORD` | A reserved parameter. This value should always be zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpGetMultipleFiles function is used to transfer files from the server to the local host which match a specified wildcard file mask. This function requires that the client be able to automatically list and parse directory listings from the server, otherwise an error will be returned. All files will be transferred using the current file type as specified by the FtpSetFileType function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpChangeDirectory](#ftpchangedirectory-function)
- [FtpGetFile](#ftpgetfile-function)
- [FtpPutFile](#ftpputfile-function)
- [FtpPutMultipleFiles](#ftpputmultiplefiles-function)
- [FtpSetFileType](#ftpsetfiletype-function)

---

## FtpGetNextFile Function

Return the next file from the file list returned by the server

### Prototype

```c
BOOL WINAPI FtpGetNextFile(
    HCLIENT hClient,
    LPFTPFILESTATUS lpFileStatus
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpFileStatus` | `LPFTPFILESTATUS` | A pointer to an FTPFILESTATUS structure which contains information about the file returned by the server. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpGetNextFile function returns the next file in the directory listing. If the last file has been returned, the function will return zero and the client should call the FtpCloseDirectory function to close the directory.

### Example

```cpp
if (FtpOpenDirectory(hClient, _T("")) != FTP_ERROR)
{
	FTPFILESTATUS ftpFile;
	BOOL bResult;

	bResult = FtpGetFirstFile(hClient, &ftpFile);
	while (bResult)
	{
		// The ftpFile structure contains information about the file
		bResult = FtpGetNextFile(hClient, &ftpFile);
	}

	FtpCloseDirectory(hClient);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpCloseDirectory](#ftpclosedirectory-function)
- [FtpGetDirectoryFormat](#ftpgetdirectoryformat-function)
- [FtpGetFileStatus](#ftpgetfilestatus-function)
- [FtpGetFirstFile](#ftpgetfirstfile-function)
- [FtpOpenDirectory](#ftpopendirectory-function)
- [FtpSetDirectoryFormat](#ftpsetdirectoryformat-function)

---

## FtpGetNextFileEx Function

Return the next file from the file list returned by the server, supporting files larger than 4GiB

### Prototype

```c
BOOL WINAPI FtpGetNextFileEx(
    HCLIENT hClient,
    LPFTPFILESTATUSEX lpFileStatus
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpFileStatus` | `LPFTPFILESTATUSEX` | A pointer to an FTPFILESTATUSEX structure which contains information about the file returned by the server. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpGetNextFileEx function returns the next file in the directory listing. If the last file has been returned, the function will return zero and the client should call the FtpCloseDirectory function to close the directory.

### Example

```cpp
if (FtpOpenDirectory(hClient, _T("")) != FTP_ERROR)
{
	FTPFILESTATUSEX ftpFile;
	BOOL bResult;

	bResult = FtpGetFirstFileEx(hClient, &ftpFile);
	while (bResult)
	{
		// The ftpFile structure contains information about the file
		bResult = FtpGetNextFileEx(hClient, &ftpFile);
	}

	FtpCloseDirectory(hClient);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpCloseDirectory](#ftpclosedirectory-function)
- [FtpGetDirectoryFormat](#ftpgetdirectoryformat-function)
- [FtpGetFileStatusEx](#ftpgetfilestatusex-function)
- [FtpGetFirstFileEx](#ftpgetfirstfileex-function)
- [FtpOpenDirectory](#ftpopendirectory-function)
- [FtpSetDirectoryFormat](#ftpsetdirectoryformat-function)

---

## FtpGetNextQueuedFile Function

Return information about the next file in the transfer queue

### Prototype

```c
DWORD WINAPI FtpGetNextQueuedFile(
    HQUEUE hQueue,
    LPFTPQUEUEDFILE lpFileInfo
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `lpFileInfo` | `LPFTPQUEUEDFILE` | A pointer to a FTPQUEUEDFILE structure which will contain information about the file. This parameter cannot be NULL. |

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is an unsigned integer with a non-zero value which uniquely identifies the file in the queue. If there are no additional queued files which match the exclusion criteria specified with the call to FtpGetFirstQueuedFile, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- This function returns information about the next file in the current transfer queue after an initial call to FtpGetFirstQueuedFile. To obtain a list of all matching files in the queue, call this function repeatedly until it returns a value of zero. When information about the last file in the queue has been returned, the last error code will be set to ST_ERROR_END_OF_QUEUE.

### Example

```cpp
// List all files in a file transfer queue
FTPQUEUEDFILE queuedFile;
DWORD dwFileId;

dwFileId = FtpGetFirstQueuedFile(hQueue, FTP_QUEUE_ALL, FTP_QUEUE_FLAG_NONE, &queuedFile);

while (dwFileId != 0)
{
	switch (queuedFile.dwQueueMode)
	{
	case FTP_QUEUE_DOWNLOAD:
		_tprintf(_T("%u: download \"%s\" to \"%s\"\n"),
				queuedFile.dwFileId,
				queuedFile.szRemoteFile,
				queuedFile.szLocalFile);
		break;

	case FTP_QUEUE_UPLOAD:
		_tprintf(_T("%u: upload \"%s\" to \"%s\"\n"),
				queuedFile.dwFileId,
				queuedFile.szRemoteFile,
				queuedFile.szLocalFile);
		break;
	}

	dwFileId = FtpGetNextQueuedFile(hQueue, &queuedFile);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAddQueuedFile](#ftpaddqueuedfile-function)
- [FtpEnumQueuedFiles](#ftpenumqueuedfiles-function)
- [FtpFindQueuedFile](#ftpfindqueuedfile-function)
- [FtpGetFirstQueuedFile](#ftpgetfirstqueuedfile-function)
- [FtpGetQueuedFile](#ftpgetqueuedfile-function)

---

## FtpGetPriority Function

Return the current priority for file transfers

### Prototype

```c
INT WINAPI FtpGetPriority(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the current file transfer priority. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpGetPriority function can be used to determine the current priority assigned to file transfers performed by the client. It may be one of the following values:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpSetPriority](#ftpsetpriority-function)

---

## FtpGetProxyType Function

Return the proxy type selected by the client

### Prototype

```c
INT WINAPI FtpGetProxyType(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value identifies the type of proxy that the client is connected to. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpConnect](#ftpconnect-function)
- [FtpProxyConnect](#ftpproxyconnect-function)

---

## FtpGetQueueClient Function

Return the handle to the current client session

### Prototype

```c
HCLIENT WINAPI FtpGetQueueClient(
    HQUEUE hQueue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |

### Return Value

- **Type**: `HCLIENT`
- If the function succeeds, the return value a handle to a client session. If the function fails, it will return INVALID_CLIENT. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpGetQueueClient function returns the handle to a client session which may be used with other functions, such as FtpGetTransferStatus. A valid handle will only be returned if the queue manager is currently uploading or downloading a file. If the queue is active but there are no file transfers in progress at the time this function is called, it will fail and set the last error code to ST_ERROR_NO_QUEUED_TRANSFER.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetTransferStatus](#ftpgettransferstatus-function)
- [FtpGetTransferStatusEx](#ftpgettransferstatusex-function)
- [FtpGetQueueStatus](#ftpgetqueuestatus-function)
- [FtpGetThreadQueue](#ftpgetthreadqueue-function)
- [FtpStartQueue](#ftpstartqueue-function)
- [FtpStopQueue](#ftpstopqueue-function)

---

## FtpGetQueuedFile Function

Return information about a file queued for transfer

### Prototype

```c
BOOL WINAPI FtpGetQueuedFile(
    HQUEUE hQueue,
    DWORD dwFileId,
    LPFTPQUEUEDFILE lpFileInfo
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `dwFileId` | `DWORD` | An unsigned integer value which uniquely identifies the file in the queue. This value cannot be zero. |
| `lpFileInfo` | `LPFTPQUEUEDFILE` | A pointer to a FTPQUEUEDFILE structure which will contain information about the file. This parameter cannot be NULL. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the file identifier is not valid or the file has been removed from the queue, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- The file identifier can be obtained by several different functions, including FtpEnumQueuedFiles and FtpGetQueueStatus, which provides information about the current file being processed in the queue. Do not make any assumptions about the value of the identifier. Although the value is guaranteed to be unique for the specified queue, it is not guaranteed that file identifiers will be assigned in sequential order.

### Example

```cpp
// Get the number of files in the queue
LONG nFiles = FtpEnumQueuedFiles(hQueue, NULL, 0)

// Display information about the queued files
if (nFiles > 0)
{
	DWORD *pdwFileList = new DWORD[nFiles];

	nFiles = FtpEnumQueuedFiles(hQueue, pdwFileList, nFiles);

	for (LONG nIndex = 0; nIndex < nFiles; nIndex++)
	{
		FTPQUEUEDFILE queuedFile;

		if (FtpGetQueuedFile(hQueue, pdwFileList[nIndex], &queuedFile) == FALSE)
			break;
			
		switch (queuedFile.dwMode)
		{
		case FTP_QUEUE_DOWNLOAD:
			_tprintf(_T("%u: Download \"%s\" to \"%s\"\n"),
						queuedFile.dwFileId,
						queuedFile.szRemoteFile,
						queuedFile.szLocalFile);
				break;

		case FTP_QUEUE_UPLOAD:
			_tprintf(_T("%u: Upload \"%s\" to \"%s\"\n"),
						queuedFile.dwFileId,
						queuedFile.szLocalFile,
						queuedFile.szRemoteFile);
				break;
		}
	}
	
	delete pdwFileList;
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpAddQueuedFile](#ftpaddqueuedfile-function)
- [FtpEnumQueuedFiles](#ftpenumqueuedfiles-function)
- [FtpFindQueuedFile](#ftpfindqueuedfile-function)
- [FtpGetFirstQueuedFile](#ftpgetfirstqueuedfile-function)
- [FtpGetNextQueuedFile](#ftpgetnextqueuedfile-function)
- [FtpGetQueueStatus](#ftpgetqueuestatus-function)

---

## FtpGetQueueStatus Function

Return the status of the current file transfer queue

### Prototype

```c
INT WINAPI FtpGetQueueStatus(
    HQUEUE hQueue,
    LPFTPQUEUESTATUS lpQueueStatus
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `lpQueueStatus` | `LPFTPQUEUESTATUS` | A pointer to a FTPQUEUESTATUS structure which will contain information about the current state of the file transfer queue. If this parameter is NULL, the function will ignore the parameter and only return the current status of the queue. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the current queue status. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError. The following status values may be returned:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpCancelQueuedFile](#ftpcancelqueuedfile-function)
- [FtpResetQueue](#ftpresetqueue-function)
- [FtpResumeQueue](#ftpresumequeue-function)
- [FtpStartQueue](#ftpstartqueue-function)
- [FtpSuspendQueue](#ftpsuspendqueue-function)
- [FtpStopQueue](#ftpstopqueue-function)

---

## FtpGetQueueThread Function

Return a value which uniquely identifies the queue manager thread

### Prototype

```c
DWORD WINAPI FtpGetQueueThread(
    HQUEUE hQueue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is non-zero and specifies a unique identifier for the queue manager thread. If the function fails, it will return zero. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpGetQueueThread function can be used to obtain a unique identifier for the queue manager thread which is responsible for performing the file transfers. If the function returns zero, this indicates that either the queue handle is no longer valid, or the queue is idle and no files are currently being processed. To obtain the handle to a queue associated with a particular thread, call the FtpGetThreadQueue function.
- You should not store the thread ID or consider it a persistent value, even during the lifetime of the process. It is only valid while the queue manager is actively processing files in the queue. The thread ID value will change every time the FtpStartQueue function is called.
- Never use the thread ID to obtain a handle to the thread and call Windows API functions such as SuspendThread or TerminateThread. This can result inconsistency within the internal state of the queue manager and may result in incomplete or corrupted file transfers.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetQueueStatus](#ftpgetqueuestatus-function)
- [FtpGetThreadQueue](#ftpgetthreadqueue-function)
- [FtpStartQueue](#ftpstartqueue-function)
- [FtpStopQueue](#ftpstopqueue-function)

---

## FtpGetResultCode Function

Return the result code from the previous command

### Prototype

```c
INT WINAPI FtpGetResultCode(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- Result codes are three-digit numeric values returned by the server. They may be broken down into the following ranges:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpCommand](#ftpcommand-function)
- [FtpGetResultString](#ftpgetresultstring-function)

---

## FtpGetResultString Function

Return the result string from the previous command

### Prototype

```c
INT WINAPI FtpGetResultString(
    HCLIENT hClient,
    LPTSTR lpszResult,
    INT cbResult
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResult` | `LPTSTR` | A pointer to the buffer that will contain the result string returned by the server. |
| `cbResult` | `INT` | The maximum number of characters that may be copied into the result string buffer, including the terminating null character. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the result string. If a value of zero is returned, this means that no result string was sent by the server.

### Remarks

- The FtpGetResultString function is most useful when an error occurs because the server will typically include a brief description of the cause of the error. This can then be parsed by the application or displayed to the user. The result string is updated each time the client sends a command to the server and then calls FtpGetResultCode to obtain the result code for the operation.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpCommand](#ftpcommand-function)
- [FtpGetResultCode](#ftpgetresultcode-function)

---

## FtpGetSecurityInformation Function

Return security information about the current client connection

### Prototype

```c
BOOL WINAPI FtpGetSecurityInformation(
    HCLIENT hClient,
    LPSECURITYINFO lpSecurityInfo
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpSecurityInfo` | `LPSECURITYINFO` | A pointer to a SECURITYINFO structure which contains information about the current client connection. The dwSize member of this structure must be initialized to the size of the structure before passing the address of the structure to this function. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- This function is used to obtain security related information about the current client connection to the server. It can be used to determine if a secure connection has been established, what security protocol was selected, and information about the server certificate. Note that a secure connection has not been established, the dwProtocol structure member will contain the value SECURITY_PROTOCOL_NONE.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpConnect](#ftpconnect-function)
- [FtpCreateSecurityCredentials](#ftpcreatesecuritycredentials-function)
- [FtpDeleteSecurityCredentials](#ftpdeletesecuritycredentials-function)
- [FtpDisconnect](#ftpdisconnect-function)
- [FtpProxyConnect](#ftpproxyconnect-function)
- [SECURITYINFO](#securityinfo-function)

---

## FtpGetServerInformation Function

Get system information about the server

### Prototype

```c
INT WINAPI FtpGetServerInformation(
    HCLIENT hClient,
    LPTSTR lpszSystemInfo,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszSystemInfo` | `LPTSTR` | A pointer to the buffer that will contain the system information returned by the server. |
| `nMaxLength` | `INT` | The maximum number of characters that can be copied into the buffer, including the terminating null character. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function sends the SYST command to the server. The first word will identify the type of operating system. The format for the remaining information depends on the server type. Typically it is a description of the operating system version and hardware platform. For example, here are some strings commonly returned by various FTP servers:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpConnect](#ftpconnect-function)
- [FtpGetDirectoryFormat](#ftpgetdirectoryformat-function)
- [FtpGetClientQuota](#ftpgetclientquota-function)
- [FtpGetServerStatus](#ftpgetserverstatus-function)
- [FtpGetServerTimeZone](#ftpgetservertimezone-function)
- [FtpGetServerType](#ftpgetservertype-function)

---

## FtpGetServerStatus Function

Return system status of server

### Prototype

```c
INT WINAPI FtpGetServerStatus(
    HCLIENT hClient,
    LPTSTR lpszStatus,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszStatus` | `LPTSTR` | A pointer to the buffer that will contain the system status returned by the server. |
| `nMaxLength` | `INT` | The maximum number of characters that can be copied into the buffer, including the terminating null character. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function sends the STAT command to the server. The format for the information returned depends on the server type. Typically it is a description of the server platform, version, current user and file transfer options.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetServerInformation](#ftpgetserverinformation-function)
- [FtpGetServerType](#ftpgetservertype-function)

---

## FtpGetServerTimeZone Function

Return the timezone offset in seconds for the current server

### Prototype

```c
INT WINAPI FtpGetServerTimeZone(
    HCLIENT hClient,
    LPLONG lpnTimeZone
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpnTimeZone` | `LPLONG` | A pointer to a signed long integer which will contain the timezone offset in seconds. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function sends the SITE ZONE command to the server to determine its timezone. The value returned is expressed as the number of seconds offset from Coordinated Universal Time (UTC). A positive value specifies a time west of UTC, while a negative value specifies a time east of UTC. For example, a value of 28800 would specify an offset of 8 hours west of UTC, which is the Pacific timezone.
- The SIZE ZONE command is an extension that is not supported by all servers. If the server timezone cannot be determined, the function will fail and the value pointed to by the lpnTimeZone parameter will be zero.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetClientQuota](#ftpgetclientquota-function)
- [FtpGetServerInformation](#ftpgetserverinformation-function)
- [FtpGetServerStatus](#ftpgetserverstatus-function)

---

## FtpGetServerType Function

Return the type of operating system the server is running on

### Prototype

```c
INT WINAPI FtpGetServerType(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is a numeric value which indicates the server type. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function sends the SYST command to the server to determine the server type. The following server types are recognized by the library:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetClientQuota](#ftpgetclientquota-function)
- [FtpGetServerInformation](#ftpgetserverinformation-function)
- [FtpGetServerStatus](#ftpgetserverstatus-function)
- [FtpSetDirectoryFormat](#ftpsetdirectoryformat-function)

---

## FtpGetStatus Function

Return the current client status

### Prototype

```c
INT WINAPI FtpGetStatus(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the client status code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpGetStatus function returns a numeric code which identifies the current state of the client session. The following values may be returned:
- In a multithreaded application, any thread in the current process may call this function to obtain status information for the specified client session. To obtain status information about a file transfer, use the FtpGetTransferStatus function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpIsBlocking](#ftpisblocking-function)
- [FtpIsReadable](#ftpisreadable-function)
- [FtpIsWritable](#ftpiswritable-function)
- [FtpGetTransferStatus](#ftpgettransferstatus-function)

---

## FtpGetTaskError Function

Return the last error code for the specified asynchronous task

### Prototype

```c
DWORD WINAPI FtpGetTaskError(
    UINT nTaskId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nTaskId` | `UINT` | The task identifier. |

### Return Value

- **Type**: `DWORD`
- If the asynchronous task has completed successfully, this function returns a value of zero. A non-zero return value indicates an error has occurred.

### Remarks

- The FtpGetTaskError function returns the last error code associated with the specified asynchronous task. If the task completed successfully, the return value will be zero. If the task is still active, the function will return the error ST_ERROR_TASK_ACTIVE. If the task has been suspended, the function will return ST_ERROR_TASK_SUSPENDED. Any other value indicates that the task completed, but the operation has failed and the error code will specify the cause of the failure.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpTaskAbort](#ftptaskabort-function)
- [FtpTaskResume](#ftptaskresume-function)
- [FtpTaskSuspend](#ftptasksuspend-function)
- [FtpTaskWait](#ftptaskwait-function)

---

## FtpGetTaskId Function

Return the unique task identifier associated with the specified client session

### Prototype

```c
UINT WINAPI FtpGetTaskId(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the client handle is not associated with an asynchronous task, the function will return a value of zero.

### Remarks

- The FtpGetTaskId function will return the task ID that is associated with a client session. This is a unique unsigned integer value that references the worker thread that was created to manage the asynchronous client session. This function should only be called within an event handler that is invoked by a background task that has been started using a function such as FtpAsyncGetFile.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpTaskAbort](#ftptaskabort-function)
- [FtpTaskDone](#ftptaskdone-function)
- [FtpTaskResume](#ftptaskresume-function)
- [FtpTaskSuspend](#ftptasksuspend-function)
- [FtpTaskWait](#ftptaskwait-function)

---

## FtpGetText Function

Download the contents of a text file to a string buffer

### Prototype

```c
INT WINAPI FtpGetText(
    HCLIENT hClient,
    LPCTSTR lpszRemoteFile,
    LPTSTR lpszBuffer,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies a text file on the server. The file pathing and naming conventions must be that of the host operating system. |
| `lpszBuffer` | `LPTSTR` | A pointer to a string buffer which will contain the contents of the text file when the function returns. This buffer should be large enough to store the contents of the file, including a terminating null character. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer. This value must be larger than zero. If this value is smaller than the actual size of the text file, the data returned will be truncated. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpGetText function is used to download a text file and store the contents in a string buffer. This function will always set the file type to FILE_TYPE_ASCII before downloading the file, and will restore the default file type before the method returns. Because binary files can include embedded null characters, this function should only be used with known text files.
- This function has been included as a convenience for applications that need to retrieve relatively small text files and manipulate the contents as a string. If the Unicode version of this function is called, the contents of the text file is automatically converted to a Unicode string. If the size of the file is unknown or the text file is very large, it is recommended that you use the FtpGetData or FtpGetFile functions.
- If you use the FtpGetFileSize function to determine how large the string buffer should be prior to calling this function, it is important to be aware that the actual number of characters may differ based on the end-of-line conventions used by the host operating system. For example, if you call FtpGetFileSize to obtain the size of a text file on a UNIX system, the value will not be large enough to store the complete file because UNIX uses a single linefeed (LF) character to indicate the end-of-line, while a Windows system will use a carriage-return and linefeed (CRLF) pair. To accommodate this difference, you should always allocate extra memory for the string buffer to store the additional end-of-line characters.
- FTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling FtpEnableEvents, or by registering a callback function using the FtpRegisterEvent function.
- To determine the current status of a file transfer while it is in progress, use the FtpGetTransferStatus function.

### Example

```cpp
LPTSTR lpszBuffer = (LPTSTR)calloc(MAXFILESIZE, sizeof(TCHAR));

if (lpszBuffer == NULL)
	return;

nResult = FtpGetText(hClient, lpszRemoteFile, lpszBuffer, MAXFILESIZE);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpChangeDirectory](#ftpchangedirectory-function)
- [FtpEnableEvents](#ftpenableevents-function)
- [FtpGetData](#ftpgetdata-function)
- [FtpGetFile](#ftpgetfile-function)
- [FtpGetTransferStatus](#ftpgettransferstatus-function)
- [FtpPutData](#ftpputdata-function)
- [FtpPutFile](#ftpputfile-function)
- [FtpRegisterEvent](#ftpregisterevent-function)
- [FtpSetBufferSize](#ftpsetbuffersize-function)

---

## FtpGetThreadQueue Function

Return the handle to a queue associated with the specified thread

### Prototype

```c
HQUEUE WINAPI FtpGetThreadQueue(
    DWORD dwThreadId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `dwThreadId` | `DWORD` | An unsigned integer value which specifies a unique identifier for the queue manager thread. If this value is zero, it will return the handle associated with the current thread. |

### Return Value

- **Type**: `HQUEUE`
- If the function succeeds, the return value is the handle to the queue. If the function fails, it will return INVAID_QUEUE. To get extended error information, call FtpGetLastError.

### Remarks

- All queued file transfers are handled by a queue manager which executes asynchronously in a background worker thread. This worker thread is created when the FtpStartQueue function is called and terminates when all files in the queue have been processed, or when the FtpStopQueue function is called. This function will return the queue handle associated with that worker thread.
- The most common use of this function would be to obtain the handle for the queue from within a queue event handler. The application would pass in a value of zero as the thread ID and the function will return the handle to the queue which invoked the event notification.
- If you call this function outside of an event handler and the dwThreadId parameter is zero, or if the queue is idle and not transferring files, this function will return INVALID_QUEUE. The thread ID is only valid while the queue manager is actively processing files in the queue.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetQueueStatus](#ftpgetqueuestatus-function)
- [FtpGetQueueThread](#ftpgetqueuethread-function)
- [FtpStartQueue](#ftpstartqueue-function)
- [FtpStopQueue](#ftpstopqueue-function)

---

## FtpGetTimeout Function

Return the number of seconds until an operation times out

### Prototype

```c
INT WINAPI FtpGetTimeout(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the timeout period in seconds. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The timeout value is only used with blocking client connections. A value of zero indicates that the default timeout period of 20 seconds should be used.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpConnect](#ftpconnect-function)
- [FtpIsReadable](#ftpisreadable-function)
- [FtpIsWritable](#ftpiswritable-function)
- [FtpProxyConnect](#ftpproxyconnect-function)
- [FtpRead](#ftpread-function)
- [FtpSetTimeout](#ftpsettimeout-function)
- [FtpWrite](#ftpwrite-function)

---

## FtpGetTransferStatus Function

Return current file transfer statistics

### Prototype

```c
INT WINAPI FtpGetTransferStatus(
    HCLIENT hClient,
    LPFTPTRANSFERSTATUS lpStatus
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpStatus` | `LPFTPTRANSFERSTATUS` | A pointer to an FTPTRANSFERSTATUS structure which contains information about the status of the current file transfer. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpGetTransferStatus function returns information about the current file transfer, including the average number of bytes transferred per second and the estimated amount of time until the transfer completes. If there is no file currently being transferred, this function will return the status of the last successful transfer made by the client.
- In a multithreaded application, any thread in the current process may call this function to obtain status information for the specified client session.
- If the option FTP_OPTION_HIRES_TIMER has been specified when connecting to the server, the values of the dwTimeElapsed and dwTimeEstimated members of the FTPTRANSFERSTATUS structure will be in milliseconds instead of seconds. You can use this option to obtain more accurate elapsed times when uploading or downloading small files over a fast network connection.
- If you are uploading or downloading large files which exceed 4GB, you should use the FtpGetTransferStatusEx function which returns the size as a 64-bit value.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpEnableEvents](#ftpenableevents-function)
- [FtpGetFileStatus](#ftpgetfilestatus-function)
- [FtpGetTransferStatusEx](#ftpgettransferstatusex-function)
- [FtpRegisterEvent](#ftpregisterevent-function)
- [FTPTRANSFERSTATUS](#ftptransferstatus-function)
- [FTPTRANSFERSTATUSEX](#ftptransferstatusex-function)

---

## FtpGetTransferStatusEx Function

Return current file transfer statistics, supporting files larger than 4GB

### Prototype

```c
INT WINAPI FtpGetTransferStatusEx(
    HCLIENT hClient,
    LPFTPTRANSFERSTATUS lpStatus
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpStatus` | `LPFTPTRANSFERSTATUS` | A pointer to an FTPTRANSFERSTATUSEX structure which contains information about the status of the current file transfer. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpGetTransferStatusEx function returns information about the current file transfer, including the average number of bytes transferred per second and the estimated amount of time until the transfer completes. If there is no file currently being transferred, this function will return the status of the last successful transfer made by the client.
- In a multithreaded application, any thread in the current process may call this function to obtain status information for the specified client session.
- If the option FTP_OPTION_HIRES_TIMER has been specified when connecting to the server, the values of the dwTimeElapsed and dwTimeEstimated members of the FTPTRANSFERSTATUSEX structure will be in milliseconds instead of seconds. You can use this option to obtain more accurate elapsed times when uploading or downloading small files over a fast network connection.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpEnableEvents](#ftpenableevents-function)
- [FtpGetFileStatus](#ftpgetfilestatus-function)
- [FtpGetTransferStatus](#ftpgettransferstatus-function)
- [FtpRegisterEvent](#ftpregisterevent-function)
- [FTPTRANSFERSTATUS](#ftptransferstatus-function)
- [FTPTRANSFERSTATUSEX](#ftptransferstatusex-function)

---

## FtpInitialize Function

Initialize the library and validate the specified runtime license key

### Prototype

```c
BOOL WINAPI FtpInitialize(
    LPCTSTR lpszLicenseKey,
    LPINITDATA lpData
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszLicenseKey` | `LPCTSTR` | Pointer to a string that specifies the runtime license key to be validated. If this parameter is NULL, the library will validate the development license installed on the local system. |
| `lpData` | `LPINITDATA` | Pointer to an INITDATA data structure. This parameter may be NULL if the initialization data for the library is not required. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetLastError. All other client functions will fail until a license key has been successfully validated.

### Remarks

- This must be the first function that an application calls before using any of the other functions in the library. When a NULL license key is specified, the library will only function on the development system. Before redistributing the application to an end-user, you must insure that this function is called with a valid license key.
- If the lpData argument is specified, it must point to an INITDATA structure which has been initialized by setting the dwSize member to the size of the structure. All other structure members should be set to zero. If the function is successful, then the INITDATA structure will be filled with identifying information about the library.
- Although it is only required that FtpInitialize be called once for the current process, it may be called multiple times; however, each call must be matched by a corresponding call to FtpUninitialize.
- This function dynamically loads other system libraries and allocates thread local storage. If you are calling the functions in this library from within another DLL, it is important that you do not call the FtpInitialize or FtpUninitialize functions from the DllMain function because it can result in deadlocks or access violation errors. If the DLL is linked with the C runtime library (CRT), it will automatically call the constructors and destructors for static and global C++ objects and has the same restrictions.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpConnect](#ftpconnect-function)
- [FtpDisconnect](#ftpdisconnect-function)
- [FtpUninitialize](#ftpuninitialize-function)

---

## FtpIsBlocking Function

Determine if the current operation is blocked

### Prototype

```c
BOOL WINAPI FtpIsBlocking(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `BOOL`
- If the client is performing a blocking operation, the function returns a non-zero value. If the client is not performing a blocking operation, or the client handle is invalid, the function returns zero.

### Remarks

- Because a blocking operation can allow the application to be re-entered (for example, by pressing a button while the operation is being performed), it is possible that another blocking function may be called while it is in progress. Since only one thread of execution may perform a blocking operation at any one time, an error would occur. The FtpIsBlocking function can be used to determine if the client is already blocked, and if so, take some other action (such as warning the user that they must wait for the operation to complete).

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpCancel](#ftpcancel-function)
- [FtpGetStatus](#ftpgetstatus-function)
- [FtpIsConnected](#ftpisconnected-function)
- [FtpIsReadable](#ftpisreadable-function)
- [FtpIsWritable](#ftpiswritable-function)
- [FtpRead](#ftpread-function)
- [FtpWrite](#ftpwrite-function)

---

## FtpIsConnected Function

Determine if the client is connected to the server

### Prototype

```c
BOOL WINAPI FtpIsConnected(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `BOOL`
- If the client is connected to a server, the function returns a non-zero value. If the client is not connected, or the client handle is invalid, the function returns zero.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetStatus](#ftpgetstatus-function)
- [FtpIsBlocking](#ftpisblocking-function)
- [FtpIsReadable](#ftpisreadable-function)
- [FtpIsWritable](#ftpiswritable-function)

---

## FtpIsReadable Function

Determine if the client can read data from the data channel

### Prototype

```c
BOOL WINAPI FtpIsReadable(
    HCLIENT hClient,
    INT nTimeout,
    LPDWORD lpdwAvail
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nTimeout` | `INT` | Timeout for server response, in seconds. A value of zero specifies that the connection should be polled without blocking the current thread. |
| `lpdwAvail` | `LPDWORD` | A pointer to an unsigned integer which will contain the number of bytes available to read. This parameter may be NULL if this information is not required. |

### Return Value

- **Type**: `BOOL`
- If the client can read data from the server within the specified timeout period, the function returns a non-zero value. If the client cannot read any data, the function returns zero.

### Remarks

- On some platforms, this value will not exceed the size of the receive buffer (typically 64K bytes). Because of differences between TCP/IP stack implementations, it is not recommended that your application exclusively depend on this value to determine the exact number of bytes available. Instead, it should be used as a general indicator that there is data available to be read.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetStatus](#ftpgetstatus-function)
- [FtpIsBlocking](#ftpisblocking-function)
- [FtpIsConnected](#ftpisconnected-function)
- [FtpIsWritable](#ftpiswritable-function)
- [FtpRead](#ftpread-function)

---

## FtpIsWritable Function

Determine if the client can write data to the data channel

### Prototype

```c
BOOL WINAPI FtpIsWritable(
    HCLIENT hClient,
    INT nTimeout
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nTimeout` | `INT` | Timeout for server response, in seconds. A value of zero specifies that the connection should be polled without blocking the current thread. |

### Return Value

- **Type**: `BOOL`
- If the client can write data to the server within the specified timeout period, the function returns a non-zero value. If the client cannot write any data, the function returns zero.

### Remarks

- Although this function can be used to determine if some amount of data can be sent to the remote process it does not indicate the amount of data that can be written without blocking the client. In most cases, it is recommended that large amounts of data be broken into smaller logical blocks, typically some multiple of 512 bytes in length.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetStatus](#ftpgetstatus-function)
- [FtpIsBlocking](#ftpisblocking-function)
- [FtpIsConnected](#ftpisconnected-function)
- [FtpIsReadable](#ftpisreadable-function)
- [FtpWrite](#ftpwrite-function)

---

## FtpLogin Function

Login to the server

### Prototype

```c
INT WINAPI FtpLogin(
    HCLIENT hClient,
    LPCTSTR lpszUserName,
    LPCTSTR lpszPassword,
    LPCTSTR lpszAccount
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszUserName` | `LPCTSTR` | Points to a string that specifies the user name to be used to authenticate the current client session. If this parameter is NULL or an empty string, then the login is considered to be anonymous. |
| `lpszPassword` | `LPCTSTR` | Points to a string that specifies the password to be used to authenticate the current client session. This parameter may be NULL or an empty string if no password is required for the specified user, or if no username has been specified. |
| `lpszAccount` | `LPCTSTR` | Points to a string that specifies the account name to be used to authenticate the current client session. This parameter may be NULL or an empty string if no account name is required for the specified user. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- Some public FTP servers support anonymous logins, where a username and password are not required to access the server. In this case, both the lpszUserName and lpszPassword parameters can be NULL or specify empty strings. In most cases, access to the server using an anonymous login is restricted, with clients only having permission to download files. Servers may also restrict the maximum number of anonymous sessions that may be logged in at one time.
- This function should only be used after calling the FtpLogout function, enabling you to log in as another user during the same session. Not all servers will permit a client to change user credentials during the same session. In most cases, it is preferable to disconnect from the server and re-connect using the new credentials rather than using this function.
- This function is not supported with secure connections using the SSH protocol.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpConnect](#ftpconnect-function)
- [FtpLogout](#ftplogout-function)
- [FtpProxyConnect](#ftpproxyconnect-function)

---

## FtpLogout Function

Logout from the server

### Prototype

```c
INT WINAPI FtpLogout(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpLogout function is used when the client wants to re-authenticate using a new username and password. Before any further action may be taken, other than disconnecting from the server, the FtpLogin function must be called to re-authenticate the client.
- It is not necessary to call this function prior to disconnecting from the server because the user current user is automatically logged out when the FtpDisconnect function is called.
- This function is not supported with secure connections using the SSH protocol.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpConnect](#ftpconnect-function)
- [FtpDisconnect](#ftpdisconnect-function)
- [FtpLogin](#ftplogin-function)

---

## FtpMountStructure Function

Mount a structure (filesystem) on the server

### Prototype

```c
INT WINAPI FtpMountStructure(
    HCLIENT hClient,
    LPCTSTR lpszFileSystem
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileSystem` | `LPCTSTR` | A pointer to a string which specifies the file system to mount on the server. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function sends the SMNT command to the server, which may not be supported on some platforms. Use of this command typically requires that the user have administrator privileges on the server.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpCreateDirectory](#ftpcreatedirectory-function)
- [FtpRemoveDirectory](#ftpremovedirectory-function)

---

## FtpOpenDirectory Function

Open the specified directory for reading

### Prototype

```c
INT WINAPI FtpOpenDirectory(
    HCLIENT hClient,
    LPCTSTR lpszDirectory
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszDirectory` | `LPCTSTR` | Pointer to the name of the directory that will be opened. The format of the directory name must match the filename conventions used by the server. If a NULL pointer or an empty string is specified, then the current working directory is opened. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpOpenDirectory function opens the specified directory on the server using the LIST command. The contents of the directory can be read using the FtpGetFirstFile and FtpGetNextFile functions. The directory listing is returned on the data channel in one of several different formats. The library can recognize listing formats generated by UNIX, VMS and Windows servers, as well as those of other servers which emulate one of those common formats. Once the complete directory listing has been read, the directory must be closed by calling the FtpCloseDirectory function.
- Because the directory listing is returned on the data channel, a file transfer cannot be performed while the directory is in the process of being read by the client. Applications which need to collect a list of files to download should first open the directory, read the contents and store the file names in an array. After the directory has been closed, the application can then start transferring the files to the local system.
- Some servers may not support file listings for any directory other than the current working directory. If an error is returned when specifying a directory name, try changing the current working directory using the FtpChangeDirectory function and then call this function again, passing NULL or an empty string as the lpszDirectory parameter.
- To obtain a list of all files in a directory using a single function call, use the FtpEnumFiles function. If the server lists files in a format that is not recognized by the library, the FtpGetFileList function can be used to obtain an unparsed file listing from the server.

### Example

```cpp
if (FtpOpenDirectory(hClient, NULL) != FTP_ERROR)
{
	FTPFILESTATUS ftpFile;
	BOOL bResult;

	bResult = FtpGetFirstFile(hClient, &ftpFile);
	while (bResult)
	{
		// The ftpFile structure contains information about the file
		bResult = FtpGetNextFile(hClient, &ftpFile);
	}

	FtpCloseDirectory(hClient);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpChangeDirectory](#ftpchangedirectory-function)
- [FtpCloseDirectory](#ftpclosedirectory-function)
- [FtpEnumFiles](#ftpenumfiles-function)
- [FtpGetDirectoryFormat](#ftpgetdirectoryformat-function)
- [FtpGetFileList](#ftpgetfilelist-function)
- [FtpGetFileStatus](#ftpgetfilestatus-function)
- [FtpGetFirstFile](#ftpgetfirstfile-function)
- [FtpGetNextFile](#ftpgetnextfile-function)
- [FtpSetDirectoryFormat](#ftpsetdirectoryformat-function)

---

## FtpOpenFile Function

Open the specified file for reading or writing

### Prototype

```c
INT WINAPI FtpOpenFile(
    HCLIENT hClient,
    LPCTSTR lpszFileName,
    DWORD dwOpenMode,
    DWORD dwOffset
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileName` | `LPCTSTR` | Points to a string that specifies the name of the remote file to create or open. The file pathing and name conventions must be that of the server. |
| `dwOpenMode` | `DWORD` | Specifies the type of access to the file. An application can open a file for reading, create a new file or append data to an existing file. This parameter should be one of the following values. |
| `dwOffset` | `DWORD` | A byte offset which specifies where the file transfer should begin. The default value of zero specifies that the file transfer should start at the beginning of the file. A value greater than zero is typically used to restart a transfer that has not completed successfully. Note that specifying a non-zero offset using FTP requires that the server support the REST command to restart transfers. |

### Options

- **dwOpenMode** Parameter

    - `FTP_FILE_READ`: The file is opened for reading on the server. A data channel is created and the contents of the file are returned to the client.
    - `FTP_FILE_WRITE`: The file is opened for writing on the server. If the file does not exist, it will be created. If it does exist, it will be overwritten.
    - `FTP_FILE_APPEND`: The file is opened for writing on the server. All data will be appended to the end of the file.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- Only one file may be opened at a time for each client session. Attempting to perform an action such as uploading or downloading another file while a file is currently open will result in an error. Typically this indicates that the application failed to call the FtpCloseFile function.
- It is strongly recommended that most applications use the FtpGetFile or FtpPutFile functions to perform file transfers. These functions are easier to use, and have internal optimizations that improves the overall data transfer rate when compared to implementing the file transfer code in your own application.
- When a file is created on the server, the file ownership and access rights are determined by the server. Some servers may provide a method to change these attributes through site-specific commands. Refer to the server's operating system documentation for more information about what commands may be available.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpCloseFile](#ftpclosefile-function)
- [FtpGetFile](#ftpgetfile-function)
- [FtpGetFileSize](#ftpgetfilesize-function)
- [FtpGetFileTime](#ftpgetfiletime-function)
- [FtpPutFile](#ftpputfile-function)
- [FtpSetFileTime](#ftpsetfiletime-function)

---

## FtpProxyConnect Function

Establish a connection with a proxy server

### Prototype

```c
HCLIENT WINAPI FtpProxyConnect(
    UINT nProxyType,
    LPCTSTR lpszProxyHost,
    UINT nProxyPort,
    LPCTSTR lpszProxyUser,
    LPCTSTR lpszProxyPassword,
    LPCTSTR lpszRemoteHost,
    UINT nTimeout,
    DWORD dwOptions,
    LPSECURITYCREDENTIALS lpCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nProxyType` | `UINT` | An identifier which specifies the type of proxy server that is being connected to. This value must be defined as one of the following values: |
| `lpszProxyHost` | `LPCTSTR` | A pointer to the name of the proxy server to connect through; this may be a fully-qualified domain name or an IP address. |
| `nProxyPort` | `UINT` | The port number the proxy server is listening on; a value of zero specifies that the default port number should be used. |
| `lpszProxyUser` | `LPCTSTR` | A pointer to the user name used to authenticate the client on the proxy server. Not all proxy servers require this information; it is recommended that you consult the proxy server documentation to determine if a username is required. |
| `lpszProxyPassword` | `LPCTSTR` | A pointer to the password used to authenticate the client on the proxy server. Not all proxy servers require this information; it is recommended that you consult the proxy server documentation to determine if a password is required. |
| `lpszRemoteHost` | `LPCTSTR` | A pointer to the name of the server that you want to connect to, through the proxy server. |
| `nTimeout` | `UINT` | The number of seconds that the client will wait for a response from the server before failing the current operation. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `lpCredentials` | `LPSECURITYCREDENTIALS` | A pointer to a SECURITYCREDENTIALS structure. This parameter should be NULL if the connection is not secure or when client credentials are not required. Most servers do not require a client certificate to establish a secure connection. However, if the server does require a client certificate, the structure members dwSize, lpszCertStore and lpszCertName must be defined. Undefined structure members must be initialized to a value of zero or NULL and the dwSize member must be initialized to the size of the SECURITYCREDENTIALS structure. |

### Options

- **nProxyType** Parameter

    - `FTP_PROXY_NONE`: This value specifies that no proxy server is being used. In this case, the FtpConnect function is called directly, ignoring the proxy parameters.
    - `FTP_PROXY_USER`: This value specifies that the client is not logged into the proxy server. The USER command is sent in the format username@ftpsite followed by the password. This is the format used with the Gauntlet proxy server.
    - `FTP_PROXY_LOGIN`: This value specifies that the client is logged into the proxy server. The USER command is then sent in the format username@ftpsite followed by the password. This is the format used by the InterLock proxy server.
    - `FTP_PROXY_OPEN`: This value specifies that the client is not logged into the proxy server. The OPEN command is sent specifying the host name, followed by the username and password.
    - `FTP_PROXY_SITE`: This value specifies that the client is logged into the server. The SITE command is sent, specifying the host name, followed by the username and the password.
    - `FTP_PROXY_OTHER`: This special proxy type specifies that another, undefined proxy server is being used. The client connects to the proxy host, but does not attempt to authenticate the client. The application is responsible for negotiating with the proxy server, typically using the FtpCommand function to send specific command sequences.
- **dwOptions** Parameter

    - `FTP_OPTION_DEFAULT`: Default options should be used for file transfers. This is the same as specifying that all file transfers should use passive mode when establishing a data connection with the server. It is recommended most applications use passive mode to prevent potential compatibility issues with certain types of firewalls and routers which use Network Address Translation (NAT).
    - `FTP_OPTION_PASSIVE`: This option specifies file transfers should attempt to establish the data connection with the server. If the local system is behind a firewall or a NAT router, the server may not be able to establish a data connection back to the client and the transfer will fail. This option forces the client to establish an outbound data connection with the server. It is recommended that applications use passive mode whenever possible.
    - `FTP_OPTION_FIREWALL`: This option specifies the client should always use the host IP address to establish the data connection with the server, not the address returned by the server in response to the PASV command. This option may be necessary if the server is behind a router that performs Network Address Translation (NAT) and it returns an unreachable IP address for the data connection. If this option is specified, it will also enable passive mode data transfers.
    - `FTP_OPTION_NOAUTH`: This option specifies the server does not require authentication, or that it requires an alternate authentication method. When this option is used, the client connection is flagged as authenticated as soon as the connection to the server has been established. Note that using this option to bypass authentication may result in subsequent errors when attempting to retrieve a directory listing or transfer a file. It is recommended that you consult the technical reference documentation for the server to determine its specific authentication requirements.
    - `FTP_OPTION_KEEPALIVE`: This option specifies the client should attempt to keep the connection with the server active for an extended period of time. It is important to note that regardless of this option, the server may still choose to disconnect client sessions that are holding the command channel open but are not performing file transfers.
    - `FTP_OPTION_VIRTUALHOST`: This option specifies the server supports virtual hosting, where multiple domains are hosted by a server using the same external IP address. If this option is enabled, the client will send the HOST command to the server upon establishing a connection.
    - `FTP_OPTION_VERIFY`: This option specifies that file transfers should be automatically verified after the transfer has completed. If the server supports the XMD5 command, the transfer will be verified by calculating an MD5 hash of the file contents. If the server does not support the XMD5 command, but does support the XCRC command, the transfer will be verified by calculating a CRC32 checksum of the file contents. If neither the XMD5 or XCRC commands are supported, the transfer is verified by comparing the size of the file. Automatic file verification is only performed for binary mode transfers because of the end-of-line conversion that may occur when text files are uploaded or downloaded.
    - `FTP_OPTION_TRUSTEDSITE`: This option specifies the server is trusted. The server certificate will not be validated and the connection will always be permitted. This option only affects connections using the TLS protocol.
    - `FTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. This option is the same as specifying FTP_OPTION_SECURE_IMPLICIT which immediately performs the TLS protocol negotiation when the connection is established.
    - `FTP_OPTION_SECURE_IMPLICIT`: This option specifies the client should attempt to immediately establish secure TLS connection with the server. This option is typically used when connecting to a server on port 990, which is the default port number used for FTPS.
    - `FTP_OPTION_SECURE_EXPLICIT`: This option specifies the client should establish a standard connection to the server and then use the AUTH command to negotiate an explicit secure connection. This option is typically used when connecting to the server on ports other than 990.
    - `FTP_OPTION_SECURE_FALLBACK`: This option specifies the client should permit the use of less secure cipher suites for compatibility with legacy servers. If this option is specified, the client will allow connections using TLS 1.0 and cipher suites that use RC4, MD5 and SHA1.
    - `FTP_OPTION_TUNNEL`: This option specifies that a tunneled TCP connection and/or port-forwarding is being used to establish the connection to the server. This changes the behavior of the client with regards to internal checks of the destination IP address and remote port number, default capability selection and how the connection is established. This option also forces all connections to be outbound and enables the firewall compatibility features in the client.
    - `FTP_OPTION_KEEPALIVE_DATA`: This option specifies the client should attempt to keep the control connection active during a file transfer. Normally, when a data transfer is in progress, no additional commands are issued on the control channel until the transfer completes. Specifying this option automatically enables the FTP_OPTION_KEEPALIVE option and forces the client to continue to issue NOOP commands during the file transfer. This option only applies to FTP and FTPS connections and has no effect on connections using SFTP (SSH).
    - `FTP_OPTION_PREFER_IPV6`: This option specifies the client should prefer the use of IPv6 if the server hostname can be resolved to both an IPv6 and IPv4 address. This option is ignored if the local system does not have IPv6 enabled, or when the hostname can only be resolved to an IPv4 address. If the server hostname can only be resolved to an IPv6 address, the client will attempt to establish a connection using IPv6 regardless if this option has been specified.
    - `FTP_OPTION_FREETHREAD`: This option specifies the handle returned by this function may be used by any thread, and is not limited to the thread which created it. The application is responsible for ensuring that access to the handle is synchronized across multiple threads.
    - `FTP_OPTION_HIRES_TIMER`: This option specifies the elapsed time for data transfers should be returned in milliseconds instead of seconds. This will return more accurate transfer times for smaller files being uploaded or downloaded using fast network connections.
    - `FTP_OPTION_TLS_REUSE`: This option specifies that TLS session reuse should be enabled for secure connections. This option is only supported on Windows 8.1 or Windows Server 2012 R2 and later platforms, and it should only be used when explicitly required by the server. This option is not compatible with servers built using OpenSSL 1.0.2 and earlier versions which do not provide Extended Master Secret (EMS) support as outlined in RFC7627.

### Return Value

- **Type**: `HCLIENT`
- If the function succeeds, the return value is a handle to a client session. If the function fails, the return value is INVALID_CLIENT. To get extended error information, call FtpGetLastError.

### Remarks

- This function will block the current thread until a connection has been established or the timeout period has elapsed. To prevent it from blocking the main user interface thread, the application should create a background worker thread and establish a connection by calling FtpProxyConnect in that thread. If the application requires multiple simultaneous connections, it is recommended you create a worker thread for each connection.
- The username and password that is used to authenticate the client with the proxy server are not the same as those used to login to the target server. Once a connection has been established with the proxy server, the client must call the FtpLogin function to actually login to the server and begin a file transfer.
- If the FTP_OPTION_KEEPALIVE option is specified, a background worker thread will be created to monitor the command channel and periodically send NOOP commands to the server if no commands have been sent recently. This can prevent the server from terminating the client connection during idle periods where no commands are being issued. However, it is important to keep in mind that many servers can be configured to also limit the total amount of time a client can be connected to the server, as well as the amount of time permitted between file transfers. If the server does not respond to the NOOP command, this option will be automatically disabled for the remainder of the client session.
- If the FTP_OPTION_SECURE_EXPLICIT option is specified, the client will establish a standard connection to the server and send the AUTH TLS command to the server. If the server does not accept this command, it will then send the AUTH SSL command. If both commands are rejected by the server, an explicit TLS session cannot be established. By default, both the command and data channels will be encrypted when a secure connection is established. To change this, use the FtpSetChannelMode function.
- The dwOptions argument can be used to specify the threading model that is used by the library when a connection is established. By default, the handle is initially attached to the thread that created it. From that point on, until the it is released, only the owner may call functions using that handle. The ownership of the handle may be transferred from one thread to another using the FtpAttachThread function.
- Specifying the FTP_OPTION_FREETHREAD option enables any thread to call any function using the handle, regardless of which thread created it. It is important to note that this option disables certain internal safety checks which are performed by the library and may result in unexpected behavior unless access to the handle is synchronized. If one thread calls a function in the library, it must ensure that no other thread will call another function at the same time using the same handle.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpConnect](#ftpconnect-function)
- [FtpCreateSecurityCredentials](#ftpcreatesecuritycredentials-function)
- [FtpDeleteSecurityCredentials](#ftpdeletesecuritycredentials-function)
- [FtpDisconnect](#ftpdisconnect-function)
- [FtpGetSecurityInformation](#ftpgetsecurityinformation-function)
- [FtpInitialize](#ftpinitialize-function)
- [FtpLogin](#ftplogin-function)
- [FtpSetChannelMode](#ftpsetchannelmode-function)

---

## FtpPutData Function

Create a file on the server using the contents of a local buffer

### Prototype

```c
INT WINAPI FtpPutData(
    HCLIENT hClient,
    LPCTSTR lpszFileName,
    LPVOID lpvBuffer,
    DWORD dwLength,
    DWORD dwReserved
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileName` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be created, overwritten or appended to. The file naming conventions must be that of the host operating system. |
| `lpvBuffer` | `LPVOID` | A pointer to the data that will be copied to the server and stored in the specified file. |
| `dwLength` | `DWORD` | The number of bytes to copy from the buffer. |
| `dwReserved` | `DWORD` | A reserved parameter. This value should always be zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- If the lpvBuffer parameter is pointing to a Unicode string, it is important to note that the value of the dwLength parameter should specify the number of bytes, not the number of characters. When using UTF-16, each character is two bytes long and therefore the length of the buffer is effectively double the length of the string. Because Unicode strings can contain null characters, you must also set the current file type to FILE_TYPE_IMAGE prior to calling this function.
- The FtpPutText function can be used to create a text file from the contents of a string.
- This function will cause the current thread to block until the file transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the FTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling FtpEnableEvents, or by registering a callback function using the FtpRegisterEvent function.
- To determine the current status of a file transfer while it is in progress, use the FtpGetTransferStatus function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpChangeDirectory](#ftpchangedirectory-function)
- [FtpEnableEvents](#ftpenableevents-function)
- [FtpGetData](#ftpgetdata-function)
- [FtpGetFile](#ftpgetfile-function)
- [FtpGetTransferStatus](#ftpgettransferstatus-function)
- [FtpPutFile](#ftpputfile-function)
- [FtpRegisterEvent](#ftpregisterevent-function)
- [FtpSetBufferSize](#ftpsetbuffersize-function)

---

## FtpPutFile Function

Copy a file from the local system to the server

### Prototype

```c
INT WINAPI FtpPutFile(
    HCLIENT hClient,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    DWORD dwOffset
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file that will be transferred from the local system. The file pathing and name conventions must be that of the local host. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be created, overwritten or appended to. The file naming conventions must be that of the host operating system. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter may be any one of the following values: |
| `dwOffset` | `DWORD` | A byte offset which specifies where the file transfer should begin. The default value of zero specifies that the file transfer should start at the beginning of the file. A value greater than zero is typically used to restart a transfer that has not completed successfully. Note that specifying a non-zero offset requires that the server support the REST command to restart transfers. |

### Options

- **dwOptions** Parameter

    - `FTP_TRANSFER_DEFAULT`: This option specifies the default transfer mode should be used. If the remote file exists, it will be overwritten with the contents of the uploaded file.
    - `FTP_TRANSFER_APPEND`: This option specifies that if the remote file exists, the contents of the local file is appended to the remote file. If the remote file does not exist, it is created.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function will cause the current thread to block until the file transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the FTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling FtpEnableEvents, or by registering a callback function using the FtpRegisterEvent function.
- To determine the current status of a file transfer while it is in progress, use the FtpGetTransferStatus function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpChangeDirectory](#ftpchangedirectory-function)
- [FtpEnableEvents](#ftpenableevents-function)
- [FtpGetData](#ftpgetdata-function)
- [FtpGetFile](#ftpgetfile-function)
- [FtpGetMultipleFiles](#ftpgetmultiplefiles-function)
- [FtpGetTransferStatus](#ftpgettransferstatus-function)
- [FtpPutData](#ftpputdata-function)
- [FtpPutMultipleFiles](#ftpputmultiplefiles-function)
- [FtpRegisterEvent](#ftpregisterevent-function)
- [FtpSetBufferSize](#ftpsetbuffersize-function)
- [FtpVerifyFile](#ftpverifyfile-function)

---

## FtpPutFileEx Function

Copy a file from the local system to the server, supporting files larger than 4GiB

### Prototype

```c
INT WINAPI FtpPutFileEx(
    HCLIENT hClient,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    ULARGE_INTEGER uiOffset
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file that will be transferred from the local system. The file pathing and name conventions must be that of the local host. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be created, overwritten or appended to. The file naming conventions must be that of the host operating system. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter may be any one of the following values: |
| `uiOffset` | `ULARGE_INTEGER` | A byte offset which specifies where the file transfer should begin. The default value of zero specifies that the file transfer should start at the beginning of the file. A value greater than zero is typically used to restart a transfer that has not completed successfully. Note that specifying a non-zero offset requires that the server support the REST command to restart transfers. |

### Options

- **dwOptions** Parameter

    - `FTP_TRANSFER_DEFAULT`: This option specifies the default transfer mode should be used. If the remote file exists, it will be overwritten with the contents of the uploaded file.
    - `FTP_TRANSFER_APPEND`: This option specifies that if the remote file exists, the contents of the local file is appended to the remote file. If the remote file does not exist, it is created.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function will cause the current thread to block until the file transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the FTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling FtpEnableEvents, or by registering a callback function using the FtpRegisterEvent function.
- To determine the current status of a file transfer while it is in progress, use the FtpGetTransferStatusEx function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpChangeDirectory](#ftpchangedirectory-function)
- [FtpEnableEvents](#ftpenableevents-function)
- [FtpGetData](#ftpgetdata-function)
- [FtpGetFileEx](#ftpgetfileex-function)
- [FtpGetMultipleFiles](#ftpgetmultiplefiles-function)
- [FtpGetTransferStatusEx](#ftpgettransferstatusex-function)
- [FtpPutData](#ftpputdata-function)
- [FtpPutMultipleFiles](#ftpputmultiplefiles-function)
- [FtpRegisterEvent](#ftpregisterevent-function)
- [FtpSetBufferSize](#ftpsetbuffersize-function)
- [FtpVerifyFile](#ftpverifyfile-function)

---

## FtpPutMultipleFiles Function

Copy multiple files from the local system to the server

### Prototype

```c
INT WINAPI FtpPutMultipleFiles(
    HCLIENT hClient,
    LPCTSTR lpszLocalDirectory,
    LPCTSTR lpszRemoteDirectory,
    LPCTSTR lpszFileMask,
    DWORD dwReserved
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalDirectory` | `LPCTSTR` | Pointer to a string which specifies the local directory where the files will be copied from. A NULL pointer or empty string specifies that files should be copied from the current working directory. |
| `lpszRemoteDirectory` | `LPCTSTR` | Pointer to a string which specifies the remote directory where the files will be copied to. A NULL pointer or empty string specifies that the files should be copied to the current working directory on the server. |
| `lpszFileMask` | `LPCTSTR` | Pointer to a string which specifies the files that are to be copied from the local system to the server. The file mask should follow the Windows conventions used for wildcard file matches. |
| `dwReserved` | `DWORD` | A reserved parameter. This value should always be zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpPutMultipleFiles function is used to transfer files from the local host to the server which match a specified wildcard file mask. All files will be transferred using the current file type as specified by the FtpSetFileType function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpChangeDirectory](#ftpchangedirectory-function)
- [FtpGetFile](#ftpgetfile-function)
- [FtpGetMultipleFiles](#ftpgetmultiplefiles-function)
- [FtpPutFile](#ftpputfile-function)

---

## FtpPutText Function

Create a text file on the server from the contents of a string buffer

### Prototype

```c
INT WINAPI FtpPutText(
    HCLIENT hClient,
    LPCTSTR lpszRemoteFile,
    LPCTSTR lpszBuffer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the text file on the server that will be created or overwritten. The file pathing and name conventions must be that of the server. |
| `lpszBuffer` | `LPCTSTR` | A pointer to a string that contains the text that will be stored in the file. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpPutText function is used to create a text file on the server from the contents of a string. If the specified file already exists on the server, its contents will be overwritten. This function will always set the file type to FILE_TYPE_ASCII before creating the file, and will restore the default file type before the method returns.
- If the Unicode version of this function is called, the string will be converted to UTF-8 and then uploaded to the server. If you wish to store the contents of the string as UTF-16 Unicode on the server, you must set the current file type to FILE_TYPE_IMAGE and use the FtpPutData function. This function should never be used to upload binary data.
- This function will cause the current thread to block until the file transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the FTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling FtpEnableEvents, or by registering a callback function using the FtpRegisterEvent function.
- To determine the current status of a file transfer while it is in progress, use the FtpGetTransferStatus function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpChangeDirectory](#ftpchangedirectory-function)
- [FtpEnableEvents](#ftpenableevents-function)
- [FtpGetText](#ftpgettext-function)
- [FtpGetTransferStatus](#ftpgettransferstatus-function)
- [FtpPutData](#ftpputdata-function)
- [FtpPutFile](#ftpputfile-function)
- [FtpRegisterEvent](#ftpregisterevent-function)
- [FtpSetBufferSize](#ftpsetbuffersize-function)

---

## FtpRead Function

Read data from the server

### Prototype

```c
INT WINAPI FtpRead(
    HCLIENT hClient,
    LPBYTE lpBuffer,
    INT cbBuffer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpBuffer` | `LPBYTE` | Pointer to the buffer in which the data will be copied. |
| `cbBuffer` | `INT` | The maximum number of bytes to read and copy into the specified buffer. This value must be greater than zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of bytes actually read. A return value of zero indicates that the server has closed the connection and there is no more data available to be read. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- When FtpRead is called and the client is in non-blocking mode, it is possible that the function will fail because there is no available data to read at that time. This should not be considered a fatal error. Instead, the application should simply wait to receive the next asynchronous notification that data is available.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpEnableEvents](#ftpenableevents-function)
- [FtpGetData](#ftpgetdata-function)
- [FtpGetFile](#ftpgetfile-function)
- [FtpIsBlocking](#ftpisblocking-function)
- [FtpIsReadable](#ftpisreadable-function)
- [FtpIsWritable](#ftpiswritable-function)
- [FtpRegisterEvent](#ftpregisterevent-function)
- [FtpWrite](#ftpwrite-function)

---

## FtpRegisterEvent Function

Register an event handler for the specified event

### Prototype

```c
INT WINAPI FtpRegisterEvent(
    HCLIENT hClient,
    UINT nEventId,
    FTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nEventId` | `UINT` | An unsigned integer which specifies which event should be registered with the specified callback function. One of the following values may be used: |
| `lpEventProc` | `FTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the FtpEventProc callback function. If this parameter is NULL, the callback for the specified event is disabled. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. If the application targets the x86 (32-bit) platform, this parameter must be a 32-bit unsigned integer. If the application targets the x64 (64-bit) platform, this parameter must be a 64-bit unsigned integer. |

### Options

- **nEventId** Parameter

    - `FTP_EVENT_CONNECT`: The control connection to the server has completed.
    - `FTP_EVENT_DISCONNECT`: The server has closed the control connection to the client. The client should read any remaining data and disconnect.
    - `FTP_EVENT_OPENFILE`: The data connection to the server has completed.
    - `FTP_EVENT_CLOSEFILE`: The server has closed the data connection to the client. The client should read any remaining data and close the data channel.
    - `FTP_EVENT_READFILE`: Data is available to read by the calling process. No additional messages will be posted until the client has read at least some of the data. This event is only generated if the client is in asynchronous mode.
    - `FTP_EVENT_WRITEFILE`: The client can now write data. This notification is sent after a connection has been established, or after a previous attempt to write data has failed because it would result in a blocking operation. This event is only generated if the client is in asynchronous mode.
    - `FTP_EVENT_TIMEOUT`: The network operation has exceeded the specified timeout period. The client application may attempt to retry the operation, or may disconnect from the server and report an error to the user.
    - `FTP_EVENT_CANCEL`: The current operation has been canceled. Under most circumstances the client should disconnect from the server and re-connect if needed. After an operation has been canceled, the server may abort the connection or refuse to accept further commands from the client.
    - `FTP_EVENT_COMMAND`: A command has been issued by the client and the server response has been received and processed. This event can be used to log the result codes and messages returned by the server in response to actions taken by the client.
    - `FTP_EVENT_PROGRESS`: The client is in the process of sending or receiving a file on the data channel. This event is called periodically during a transfer so that the client can update any user interface components such as a status control or progress bar.
    - `FTP_EVENT_GETFILE`: This event is generated when a file download has completed. If multiple files are being downloaded, this event will be generated for each file.
    - `FTP_EVENT_PUTFILE`: This event is generated when a file upload has completed. If multiple files are being uploaded, this event will be generated for each file.
    - `FTP_EVENT_QUEUE`: This event is generated during a queued file transfer. It only occurs when a file is being transferred using the queue management APIs and the internal state of the queue has changed. The handle passed to this event will be a handle to the queue, not a client connection to the server.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpRegisterEvent function associates a callback function with a specific event. The event handler is an FtpEventProc function that is invoked when the event occurs. Arguments are passed to the function to identify the client session, the event type and the user-defined value specified when the event handler is registered. If the event occurs because of an error condition, the error code will be provided to the handler.
- This function is typically used to register an event handler that is invoked while a file is being uploaded or downloaded. The FTP_EVENT_PROGRESS event will only be generated periodically during the transfer to ensure the application is not flooded with event notifications. It is guaranteed that at least one FTP_EVENT_PROGRESS notification will occur at the beginning of the transfer, and one at the end of the transfer when it has completed.
- The callback function specified by the lpEventProc parameter must be declared using the __stdcall calling convention. This ensures the arguments passed to the event handler are pushed on to the stack in the correct order. Failure to use the correct calling convention will corrupt the stack and cause the application to terminate abnormally.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpDisableEvents](#ftpdisableevents-function)
- [FtpEnableEvents](#ftpenableevents-function)
- [FtpEventProc](#ftpeventproc-function)
- [FtpFreezeEvents](#ftpfreezeevents-function)

---

## FtpRegisterFileType Function

Associate a file name extension with a specific file type

### Prototype

```c
BOOL WINAPI FtpRegisterFileType(
    HCLIENT hClient,
    LPCTSTR lpszExtension,
    UINT nFileType
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. If this parameter is INVALID_CLIENT, the file type is registered for all client sessions in the current process. If the parameter specifies a valid client session, then the association is made only for that specific session. |
| `lpszExtension` | `LPCTSTR` | A pointer to a null terminated string which specifies the file name extension. If this parameter is NULL or points to an empty string, the default file type will be changed for the client session. |
| `nFileType` | `UINT` | Specifies the type of file associated with the file extension. This parameter can be one of the following values. |

### Options

- **nFileType** Parameter

    - `FILE_TYPE_ASCII`: The file is a text file using the ASCII character set. For those servers which mark the end of a line with characters other than a carriage return and linefeed, it will be converted to the native client format. This is the file type used for directory listings.
    - `FILE_TYPE_EBCDIC`: The file is a text file using the EBCDIC character set. Local files will be converted to EBCDIC when sent to the server. Remote files will be converted to the native ASCII character set when retrieved from the server.
    - `FILE_TYPE_IMAGE`: The file is a binary image and no data conversion of any type is performed on the file. This is typically the default file type for data file transfers. If the type of file that is being transferred is unknown, this file type should always be used.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpRegisterFileType function is used to associate specific file types with file name extensions. The library has an internal list of standard text file extensions which it automatically recognizes. This method can be used to extend or modify that list for the client session.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetAutoFileType](#ftpgetautofiletype-function)
- [FtpOpenFile](#ftpopenfile-function)
- [FtpRegisterFileType](#ftpregisterfiletype-function)
- [FtpSetFileMode](#ftpsetfilemode-function)
- [FtpSetFileStructure](#ftpsetfilestructure-function)
- [FtpSetFileType](#ftpsetfiletype-function)
- [FtpSetPassiveMode](#ftpsetpassivemode-function)

---

## FtpRemoveDirectory Function

Remove a directory from the server

### Prototype

```c
INT WINAPI FtpRemoveDirectory(
    HCLIENT hClient,
    LPCTSTR lpszDirectory
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszDirectory` | `LPCTSTR` | Points to a string that specifies the name of the directory. The file pathing and name conventions must be that of the server. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function uses the RMD command to create the directory. The user must have the appropriate permission to remove the specified directory. Most servers will not permit you to remove a directory if it contains one or more files.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpChangeDirectory](#ftpchangedirectory-function)
- [FtpCreateDirectory](#ftpcreatedirectory-function)
- [FtpDeleteFile](#ftpdeletefile-function)
- [FtpGetDirectory](#ftpgetdirectory-function)

---

## FtpRemoveQueuedFile Function

Remove a file from the transfer queue

### Prototype

```c
BOOL WINAPI FtpRemoveQueuedFile(
    HQUEUE hQueue,
    DWORD dwFileId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `dwFileId` | `DWORD` | An unsigned integer value which uniquely identifies the file in the queue. This value cannot be zero. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, it will return zero. To get extended error information, call FtpGetLastError.

### Remarks

- Files can only be removed from the queue when in an idle or paused state. If you attempt to remove a file while the queue manager is in the process of uploading or download files, the function will fail.
- The file identifier can be obtained by several different functions, including FtpEnumQueuedFiles and FtpGetQueueStatus, which provides information about the current file being processed in the queue. Do not make any assumptions about the value of the identifier. Although the value is guaranteed to be unique for the specified queue, it is not guaranteed that file identifiers will be assigned in sequential order.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpAddQueuedFile](#ftpaddqueuedfile-function)
- [FtpClearQueue](#ftpclearqueue-function)
- [FtpEnumQueuedFiles](#ftpenumqueuedfiles-function)
- [FtpGetQueuedFile](#ftpgetqueuedfile-function)
- [FtpGetQueueStatus](#ftpgetqueuestatus-function)
- [FtpSuspendQueue](#ftpsuspendqueue-function)
- [FtpResetQueue](#ftpresetqueue-function)

---

## FtpRenameFile Function

Rename a file on the server

### Prototype

```c
INT WINAPI FtpRenameFile(
    HCLIENT hClient,
    LPCTSTR lpszOldFileName,
    LPCTSTR lpszNewFileName
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszOldFileName` | `LPCTSTR` | A null-terminated string which specifies the name of the remote file to rename or move. This parameter cannot be NULL or a zero-length string and the file must exist on the server. The file path and name must match the conventions used on the server. |
| `lpszNewFileName` | `LPCTSTR` | A null-terminated string which specifies the new name for the file. This parameter cannot be NULL or a zero-length string. The file path and name must match the conventions used on the server. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- If the lpszNewFileName parameter specifies a file which already exists on the server, the contents of that file will be deleted and replaced by the contents of the file specified by lpszOldFileName. If you want to prevent this from occurring, your application can check if a file with the new name exists by calling the FtpGetFileStatus function. If successful, you can warn the user the rename operation would delete the contents of the new file as a consequence of renaming the original file.
- If the connection was established using the standard FTP or FTPS protocols, this function causes two separate commands to be sent to the server, RNFR and RNTO. If either command fails, the function will fail and return an error code. If the connection was established using SFTP (SSH) the client will request the server rename the file atomically by specifying the internal SSH_FXF_RENAME_ATOMIC option. If the server does not support this option and lpszNewFileName already exists on the server, this function will attempt to delete the file and retry the rename operation.
- This function can be used to move a file from one folder to another on the server, as long as the user has the appropriate permissions required to perform the operation. If the new file name includes a path, that path must already exist on the server or the function will fail.
- If the old and new file names specify folders instead of regular files, the server may or may not allow the operation, depending on the access rights for those folders and the server's configuration. Some servers may allow a simple rename operation within the same parent folder, but may not permit you to move the folder to another location in the filesystem.
- There is no guarantee the rename operation will be performed in an atomic fashion if multiple client sessions attempt to rename the same file at the same time. For example, it is possible that one client could attempt to rename a file while another client is already in the process of moving the file to a new folder. In this case, the server may respond with an error indicating the file cannot be found, an access denied error or a general failure error.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpDeleteFile](#ftpdeletefile-function)
- [FtpGetFile](#ftpgetfile-function)
- [FtpGetFileStatus](#ftpgetfilestatus-function)
- [FtpGetFileSize](#ftpgetfilesize-function)
- [FtpPutFile](#ftpputfile-function)

---

## FtpReset Function

Reset the client connection

### Prototype

```c
INT WINAPI FtpReset(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The client cannot be reset while a file transfer is in progress or if the client is in a blocked state. To abort a file transfer, use the FtpCancel function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpCancel](#ftpcancel-function)

---

## FtpResetQueue Function

Reset the internal state of file transfers in the specified queue

### Prototype

```c
BOOL WINAPI FtpResetQueue(
    HQUEUE hQueue,
    DWORD dwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `dwOptions` | `DWORD` | An unsigned integer value which specifies which files should be reset in the queue. It may be one of the following values: |

### Options

- **dwOptions** Parameter

    - `FTP_QUEUE_RESET_ALL`: All files in the queue should be reset to their initial state.
    - `FTP_QUEUE_RESET_COMPLETED`: All files in the queue which have been successfully transferred will be reset to their initial state.
    - `FTP_QUEUE_RESET_FAILED`: All files in the queue which were not transferred will be reset to their initial state.
    - `FTP_QUEUE_RESET_CANCELED`: All files in the queue which were canceled will be reset to their initial state.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, it will return zero. To get extended error information, call FtpGetLastError.

### Remarks

- When the FtpStartQueue function is called multiple times using the same queue handle, it will not attempt to transfer files which have already been successfully copied, and it will not attempt to re-transfer files if the previous transfer failed. This function resets queued files back to their initial state, prior to when the queue manager attempted to perform the transfer. The most common use would be to call the function with the FTP_QUEUE_RESET_FAILED mode and then call FtpStartQueue to retry failed or canceled file transfers.
- Because canceled file transfers are also considered failed transfers, specifying FTP_QUEUE_RESET_FAILED will reset queued files which either encountered an error during the transfer or were explicitly canceled by calling the FtpCancelQueuedFile function. The FTP_QUEUE_RESET_CANCELED option will only reset the state of queued file transfers which were canceled.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpCancelQueuedFile](#ftpcancelqueuedfile-function)
- [FtpGetQueuedFile](#ftpgetqueuedfile-function)
- [FtpResumeQueue](#ftpresumequeue-function)
- [FtpStartQueue](#ftpstartqueue-function)
- [FtpStopQueue](#ftpstopqueue-function)
- [FtpSuspendQueue](#ftpsuspendqueue-function)

---

## FtpResumeQueue Function

Resume the transfer of files after queue processing has been paused

### Prototype

```c
BOOL WINAPI FtpResumeQueue(
    HQUEUE hQueue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, it will return zero. To get extended error information, call FtpGetLastError.

### Remarks

- This function signals the queue manager to resume processing files in the transfer queue after the FtpSuspendQueue function has been called. This function will fail if the queue is in an idle (stopped) state, and will be ignored if the queue manager is already transferring files. The FtpGetQueueStatus function can be called to obtain the current status of the queue.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetQueueStatus](#ftpgetqueuestatus-function)
- [FtpResetQueue](#ftpresetqueue-function)
- [FtpStartQueue](#ftpstartqueue-function)
- [FtpStopQueue](#ftpstopqueue-function)
- [FtpSuspendQueue](#ftpsuspendqueue-function)

---

## FtpSetActivePorts Function

Set the range of local port numbers used for active transfers

### Prototype

```c
INT WINAPI FtpSetActivePorts(
    HCLIENT hClient,
    UINT nLowPort,
    UINT nHighPort
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nLowPort` | `UINT` | An unsigned integer that specifies the low port number. |
| `nHighPort` | `UINT` | An unsigned integer that specifies the high port number. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function is used to modify the range of local port numbers used for active mode file transfers. When using active mode, the client listens for an inbound connection from the server rather than establishing an outbound connection for the data transfer. In most cases, passive mode transfers are preferred because they mitigate potential compatibility issues with firewalls and NAT routers.
- If active mode transfers are required, the default port range used when listening for the server connection is between 1024 and 5000. This is the standard range of ephemeral ports used by the Windows operating system. However, under some circumstances that range of ports may be too small, or a firewall may be configured to deny inbound connections on ephemeral ports. In that case, the FtpSetActivePorts function can be used to specify a different range of port numbers.
- While it is technically permissible to assign the low and high port numbers to the same value, effectively specifying a single active port number, this is not recommended as it can cause the transfer to fail unexpectedly if multiple file transfers are performed. A minimum range of at least 1000 ports is recommended. For example, if you specify a low port value of 40000 then it is recommended that the high port value be at least 41000. The maximum port value is 65535.
- To determine the current range of active port numbers being used, call the FtpGetActivePorts function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetActivePorts](#ftpgetactiveports-function)
- [FtpSetPassiveMode](#ftpsetpassivemode-function)

---

## FtpSetBufferSize Function

Set the size of an internal buffer used during data transfers

### Prototype

```c
INT WINAPI FtpSetBufferSize(
    HCLIENT hClient,
    INT nBufferSize
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nBufferSize` | `INT` | The size of an internal buffer, in bytes. Any value greater than or equal to zero is acceptable. If nBufferSize is zero, then the default value of 4096 will be used. If nBufferSize is less than 256 bytes, the buffer size will be set to 256. The maximum value of nBufferSize is 1048576 (1Mb). |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the size of the internal buffer that will be used. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The speed of data transfers, particularly on uploads, may be sensitive to network type and configuration, and the size of the internal buffer used for data transfers. The default size of this buffer will result in good performance for a wide range of network characteristics. A larger buffer will not necessarily result in better performance. For example, a multiple of 1460, which is the typical Maximum Transmission Unit (MTU), may be optimal in many situations.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetBufferSize](#ftpgetbuffersize-function)
- [FtpGetData](#ftpgetdata-function)
- [FtpGetFile](#ftpgetfile-function)
- [FtpPutData](#ftpputdata-function)
- [FtpPutFile](#ftpputfile-function)

---

## FtpSetChannelMode Function

Change the security mode for the specified channel

### Prototype

```c
INT WINAPI FtpSetChannelMode(
    HCLIENT hClient,
    INT nChannel,
    INT nMode
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nChannel` | `INT` | An integer value which specifies which channel to return information for. It may be one of the following values: |
| `nMode` | `INT` | An integer value which specifies the new mode for the specified channel. It may be one of the following values: |

### Options

- **nChannel** Parameter

    - `FTP_CHANNEL_COMMAND`: Change information for the command channel. This is the communication channel used to send commands to the server and receive command result and status information from the server.
    - `FTP_CHANNEL_DATA`: Change information for the data channel. This is the communication channel used to send or receive data during a file transfer.
- **nMode** Parameter

    - `FTP_CHANNEL_CLEAR`: Data sent and received on this channel should not be encrypted.
    - `FTP_CHANNEL_SECURE`: Data sent and received on this channel should be encrypted. Specifying this option requires that a secure connection has already been established with the server.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the previous mode for the specified channel. If the function fails, it will return FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpSetChannelMode function is used to change the default mode for the specified channel, and is typically used to control whether or not data is encrypted during a file transfer. If a standard, non-secure connection has been established with the server, an error will be returned if you specify the FTP_CHANNEL_SECURE mode for either channel.
- If you have established a secure connection and then specify the FTP_CHANNEL_CLEAR mode for the command channel, the client will send the CCC command to the server to indicate that commands should no longer be encrypted. If the server does not support this command, an error will be returned and the channel mode will remain unchanged. Once the command channel has been changed to clear mode, it cannot be changed back to secure mode. You must disconnect and re-connect to the server if you want to resume sending commands over an encrypted channel.
- Changing the mode for the data channel requires that the server support the PROT command. If this command is not supported by the server, the function will fail and the channel mode will remain unchanged.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetChannelMode](#ftpgetchannelmode-function)

---

## FtpSetDirectoryFormat Function

Set the format which is used by the server to list files

### Prototype

```c
INT WINAPI FtpSetDirectoryFormat(
    HCLIENT hClient,
    INT nFormatId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nFormatId` | `INT` | An identifier used to specify the format of the file list returned by the server. The following values are recognized: |

### Options

- **nFormatId** Parameter

    - `FTP_DIRECTORY_AUTO`: This value specifies that the library should automatically determine the format of the file lists returned by the server. It is recommended that most applications use this value and allow the library to automatically determine the appropriate file listing format used by the server.
    - `FTP_DIRECTORY_UNIX`: This value specifies that the server returns file lists in the format commonly used by UNIX servers. Note that many servers can be configured to return file listings in this format, even if they are not actually a UNIX based platform. Consult the technical reference documentation for your server for more information.
    - `FTP_DIRECTORY_MSDOS`: This value specifies that the server returns file lists in the format commonly used by MS-DOS based systems. This includes Windows IIS servers. Long file names will be returned if supported by the underlying filesystem, such as NTFS or FAT32.
    - `FTP_DIRECTORY_VMS`: This value specifies that the server returns file lists in the format commonly used by VMS servers. Note that VMS servers can be configured to return a standard UNIX style listing in additional to the default VMS format.
    - `FTP_DIRECTORY_STERLING_1`: This value specifies that the server returns file listings in a proprietary format used by the Sterling server, which is used for EDI (Electronic Data Interchange) applications. This format uses a 13 byte status code.
    - `FTP_DIRECTORY_STERLING_2`: This value specifies that the server returns file listings in a proprietary format used by the Sterling server, which is used for EDI (Electronic Data Interchange) applications. This format uses a 10 byte status code.
    - `FTP_DIRECTORY_NETWARE`: This value specifies that the server returns file listings in a proprietary format used by NetWare servers. The format is similar to UNIX style listings except that file access and permissions are indicated by letter codes enclosed in brackets. This is the default format selected if the server identifies itself as a NetWare system.
    - `FTP_DIRECTORY_MLSD`: This value specifies that the server should return file listings in a machine-independent format as defined by RFC 3659. This format specifies file information as a sequence of name/value pairs, with the same format being used regardless of the operating system that the server is hosted on. Note that not all servers support this format, and some proxy servers may reject the command even if the remote server supports its use.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value identifies the file list format used by the server. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function should only be used when the library cannot automatically determine the directory format returned by the server. To determine the format used by a server after a file list has been retrieved, use the FtpGetDirectoryFormat function.
- The default directory format is determined both by the server's operating system and by analyzing the format of the data returned by the server. If the library is unable to automatically determine the format, it will attempt to parse the list of files as though it is a UNIX style listing.
- If the FTP_DIRECTORY_MLSD format is specified, the file information returned by the server may differ from the default output of the LIST command. For example, on a UNIX based FTP server, the output of the LIST command is typically the same format that is used by the /bin/ls command, where file names are sorted and hidden files are not listed. However, the MLSD command may return an unsorted list of files that includes hidden files and directories.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpCloseDirectory](#ftpclosedirectory-function)
- [FtpGetDirectoryFormat](#ftpgetdirectoryformat-function)
- [FtpGetFileStatus](#ftpgetfilestatus-function)
- [FtpGetFirstFile](#ftpgetfirstfile-function)
- [FtpGetNextFile](#ftpgetnextfile-function)
- [FtpOpenDirectory](#ftpopendirectory-function)

---

## FtpSetFeatures Function

Set the features which can be used by the client

### Prototype

```c
DWORD WINAPI FtpSetFeatures(
    HCLIENT hClient,
    DWORD dwFeatures
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `dwFeatures` | `DWORD` | An unsigned integer that specifies one or more features. Refer to the documentation for the FtpGetFeatures function for a list of available features. |

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value specifies the features that were previously enabled. If the function fails, it will return zero. Because it is possible that no features were enabled, a return value of zero does not always indicate an error. An application should call FtpGetLastError to determine if an error code has been set.

### Remarks

- The FtpSetFeatures function is used to enable a specific set of features for the current session. When a client connection is first established, features are enabled based on the server type and the server's response to the FEAT command. However, as the client issues commands to the server, if the server reports that the command is unrecognized that feature will automatically be disabled in the client. To enable or disable a specific feature, an application can use the FtpEnableFeature function.
- For example, the first time an application calls the FtpGetFileSize function to determine the size of a file, the library will try to use the SIZE command. If the server reports that the SIZE command is not available, that feature will be disabled and the library will not use the command again during the session unless it is explicitly re-enabled. This is designed to prevent the library from repeatedly sending invalid commands to a server, which may result in the server aborting the connection.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpEnableFeature](#ftpenablefeature-function)
- [FtpGetFeatures](#ftpgetfeatures-function)

---

## FtpSetFileMode Function

Set the current file mode

### Prototype

```c
INT WINAPI FtpSetFileMode(
    HCLIENT hClient,
    UINT nMode
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nMode` | `UINT` | Specifies the default type of data transfer mode for files being opened or created on the server. This parameter can be one of the following values. |

### Options

- **nMode** Parameter

    - `FILE_MODE_STREAM`: The data is transmitted as a stream of bytes. This is the default client transfer mode.
    - `FILE_MODE_BLOCK`: The data is transmitted as a series of data blocks preceded by one or more header bytes. This transfer mode is currently not supported.
    - `FILE_MODE_COMPRESSED`: The data is transmitted in compressed form. This transfer mode is currently not supported.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The file transfer mode should be set before a file is opened or created on the server. Once the transfer mode is set, it is in effect for all files that are subsequently opened or created.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpOpenFile](#ftpopenfile-function)
- [FtpSetFileStructure](#ftpsetfilestructure-function)
- [FtpSetFileType](#ftpsetfiletype-function)
- [FtpSetPassiveMode](#ftpsetpassivemode-function)

---

## FtpSetFileNameEncoding Function

Set the character encoding type used when sending a file name to the server

### Prototype

```c
INT WINAPI FtpSetFileNameEncoding(
    HCLIENT hClient,
    INT nEncoding
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nEncoding` | `INT` | An integer value which specifies the encoding type. It may be one of the following values: |

### Options

- **nEncoding** Parameter

    - `FTP_ENCODING_ANSI`: File names are sent as 8-bit characters using the default character encoding for the current codepage. If the Unicode version of the functions are used, file names are converted from Unicode to ANSI using the current codepage before being sent to the server. This is the default encoding type.
    - `FTP_ENCODING_UTF8`: File names that contain non-ASCII characters are sent using UTF-8 encoding. This encoding type is only available on servers that advertise support for UTF-8 encoding and permit that encoding type to be enabled by the client.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpSetFileNameEncoding function can be used to enable UTF-8 encoding of file names, which provides improved support for the use of international character sets. However, the server must provide support for UTF-8 encoding by advertising it in response to the FEAT command and it must support the OPTS command which is used to enable UTF-8 encoding. If the server does not advertise support for UTF-8, or the OPTS command fails with an error, then this function will fail with an error and the encoding type will not change.
- Although it is possible to use the FtpEnableFeature function to explicitly enable the FTP_FEATURE_UTF8 feature, this is not recommended. If the server has not advertised support for UTF-8 encoding in response to the FEAT command, that typically indicates that UTF-8 encoding is not supported. Attempting to force UTF-8 encoding can result in unpredictable behavior when file names contain non-ASCII characters.
- It is important to note that not all FTP servers support UTF-8 encoding, and in some cases servers which advertise support for UTF-8 encoding do not implement the feature correctly. For example, a server may allow a client to enable UTF-8 encoding, but once enabled will not permit the client to disable it. Some servers may advertise support for UTF-8 encoding, however if the underlying file system does not support UTF-8 encoded file names, any attempt to upload or download a file may fail with an error indicating that the file cannot be found or created.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpCommand](#ftpcommand-function)
- [FtpEnableFeature](#ftpenablefeature-function)
- [FtpGetFeatures](#ftpgetfeatures-function)
- [FtpGetFileNameEncoding](#ftpgetfilenameencoding-function)
- [FtpSetFeatures](#ftpsetfeatures-function)

---

## FtpSetFilePermissions Function

Set the access permissions for the specified file

### Prototype

```c
INT WINAPI FtpSetFilePermissions(
    HCLIENT hClient,
    LPCTSTR lpszFileName,
    DWORD dwPermissions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileName` | `LPCTSTR` | A pointer to a string which contains the name of the file to be updated. The filename cannot contain any wildcard characters. |
| `dwPermissions` | `DWORD` | An unsigned integer which will specify the new access permissions for the file. The file permissions are represented as bit flags, and may be one or more of the following values combined with a bitwise Or operator: |

### Options

- **dwPermissions** Parameter

    - `FILE_OWNER_READ`: The owner has permission to open the file for reading. If the current user is the owner of the file, this grants the user the right to download the file to the local system.
    - `FILE_OWNER_WRITE`: The owner has permission to open the file for writing. If the current user is the owner of the file, this grants the user the right to replace the file. If this permission is set for a directory, this grants the user the right to create and delete files.
    - `FILE_OWNER_EXECUTE`: The owner has permission to execute the contents of the file. The file is typically either a binary executable, script or batch file. If this permission is set for a directory, this may also grant the user the right to open that directory and search for files in that directory.
    - `FILE_GROUP_READ`: Users in the specified group have permission to open the file for reading. If the current user is in the same group as the file owner, this grants the user the right to download the file.
    - `FILE_GROUP_WRITE`: Users in the specified group have permission to open the file for writing. On some platforms, this may also imply permission to delete the file. If the current user is in the same group as the file owner, this grants the user the right to replace the file. If this permission is set for a directory, this grants the user the right to create and delete files.
    - `FILE_GROUP_EXECUTE`: Users in the specified group have permission to execute the contents of the file. If this permission is set for a directory, this may also grant the user the right to open that directory and search for files in that directory.
    - `FILE_WORLD_READ`: All users have permission to open the file for reading. This permission grants any user the right to download the file to the local system.
    - `FILE_WORLD_WRITE`: All users have permission to open the file for writing. This permission grants any user the right to replace the file. If this permission is set for a directory, this grants any user the right to create and delete files.
    - `FILE_WORLD_EXECUTE`: All users have permission to execute the contents of the file. If this permission is set for a directory, this may also grant all users the right to open that directory and search for files in that directory.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is a result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- This function uses the SITE CHMOD command to set the permissions for the file. This command is typically only supported on servers that are hosted on UNIX based systems. If the command is not supported, an error will be returned.
- Users who are familiar with the UNIX operating system will recognize the chmod command used to change the file permissions. However, it should be noted that the numeric value used as an argument to the command is in octal, not decimal. For example, issuing the command chmod 644 filename.txt on a UNIX based system will make the file readable and writable by the owner, and readable by other users in the owner's group as well as all other users. The value 644 is an octal value, which is equivalent to the decimal value 420. If you were to mistakenly specify 644 as the value for the dwPermissions parameter, rather than the decimal value of 420, the permissions on the file would be incorrect. It is strongly recommended that you use the pre-defined constants to prevent this sort of error.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetFilePermissions](#ftpgetfilepermissions-function)
- [FtpGetFileStatus](#ftpgetfilestatus-function)

---

## FtpSetFileStructure Function

Set the current file data structure

### Prototype

```c
INT WINAPI FtpSetFileStructure(
    HCLIENT hClient,
    UINT nType
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nType` | `UINT` | Specifies the default type of file structure being opened or created on the server. This parameter can be one of the following values. |

### Options

- **nType** Parameter

    - `FILE_STRUCT_NONE`: The file has no inherent structure and is considered to be a stream of bytes. This is the default structure for file transfers.
    - `FILE_STRUCT_RECORD`: The file uses a record structure. This file structure is currently not supported.
    - `FILE_STRUCT_PAGE`: The file uses a page structure. This file structure is currently not supported.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The file structure should be set before a file is opened or created on the server. Once the file type is set, it is in effect for all files that are subsequently opened or created.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpOpenFile](#ftpopenfile-function)
- [FtpSetFileMode](#ftpsetfilemode-function)
- [FtpSetFileType](#ftpsetfiletype-function)
- [FtpSetPassiveMode](#ftpsetpassivemode-function)

---

## FtpSetFileTime Function

Set the modification time for the specified file on the server

### Prototype

```c
INT WINAPI FtpSetFileTime(
    HCLIENT hClient,
    LPCTSTR lpszFileName,
    LPSYSTEMTIME lpFileTime
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileName` | `LPCTSTR` | Points to a string that specifies the name of the remote file. |
| `lpFileTime` | `LPSYSTEMTIME` | Points to a SYSTEMTIME structure that specifies the new modification time for the remote file. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpSetFileTime function will change the modification time of a file on the server. The values specified in the SYSTEMTIME structure are expected to represent UTC time, not time adjusted for the local system's timezone. If the values do represent the local time, it must be converted to UTC time prior to calling this function. To populate the SYSTEMTIME structure with the current time, use the GetSystemTime function.
- When connected to an FTP server, this function uses the MDTM command to set the modification time for the specified file. Not all servers implement this command, in which case the function call will fail. Note that some servers only support the MDTM command to return, but not change, the file modification time.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpGetFileStatus](#ftpgetfilestatus-function)
- [FtpGetFileTime](#ftpgetfiletime-function)
- [FtpOpenDirectory](#ftpopendirectory-function)

---

## FtpSetFileType Function

Set the default file type for the current session

### Prototype

```c
INT WINAPI FtpSetFileType(
    HCLIENT hClient,
    UINT nFileType
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nFileType` | `UINT` | Specifies the default type of file being opened or created on the server. This parameter can be one of the following values. |

### Options

- **nFileType** Parameter

    - `FILE_TYPE_AUTO`: The file type should be automatically determined based on the file name extension. If the file extension is unknown, the file type should be determined based on the contents of the file. The library has an internal list of common text file extensions, and additional file extensions can be registered using the FtpRegisterFileType function.
    - `FILE_TYPE_ASCII`: The file is a text file using the ASCII character set. For those servers which mark the end of a line with characters other than a carriage return and linefeed, it will be converted to the native client format. This is the file type used for directory listings.
    - `FILE_TYPE_EBCDIC`: The file is a text file using the EBCDIC character set. Local files will be converted to EBCDIC when sent to the server. Remote files will be converted to the native ASCII character set when retrieved from the server. Not all servers support this file type. It is recommended that you only specify this type if you know that it is required by the server to transfer data correctly.
    - `FILE_TYPE_IMAGE`: The file is a binary file and no data conversion of any type is performed on the file. This is the default file type for most data files and executable programs. If the type of file cannot be automatically determined, it will always be considered a binary file. If this file type is specified when uploading or downloading text files, the native end-of-line character sequences will be preserved.
    - `FILE_TYPE_LOCAL`: The file is a binary file that uses the local byte size for the server platform. On most servers, this file type is considered to be the same as FILE_TYPE_IMAGE. Not all servers support this file type. It is recommended that you only specify this type if you know that it is required by the server to transfer data correctly.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The file type should be set before a file is opened or created on the server. Once the file type is set, it is in effect for all files that are subsequently opened or created. Some functions, such as FtpOpenDirectory and FtpGetText, will temporarily change the default file type to FILE_TYPE_ASCII and then restore the current file type when they return.
- Calling this function has no practical effect when connected to an SFTP (SSH) server. They do not differentiate between text and binary files and the default file type will always be FILE_TYPE_IMAGE. If your application is uploading or downloading a text file, this difference between FTP and SFTP is important because the operating system that hosts the server may have different end-of-line character conventions than the client system. For example, if you download a text file from a UNIX system using SFTP, the end-of-line is indicated by a single linefeed (LF) character. However, on the Windows platform, the end-of-line is indicated by a carriage-return and linefeed sequence (CRLF).
- The FtpGetFileType function can be used to determine the current file type. To determine the transfer file type for a specific file, use the FtpGetAutoFileType function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetAutoFileType](#ftpgetautofiletype-function)
- [FtpGetFileType](#ftpgetfiletype-function)
- [FtpOpenFile](#ftpopenfile-function)
- [FtpRegisterFileType](#ftpregisterfiletype-function)
- [FtpSetFileMode](#ftpsetfilemode-function)
- [FtpSetFileStructure](#ftpsetfilestructure-function)
- [FtpSetPassiveMode](#ftpsetpassivemode-function)

---

## FtpSetLastError Function

Set the last error code

### Prototype

```c
VOID WINAPI FtpSetLastError(
    DWORD dwErrorCode
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `dwErrorCode` | `DWORD` | Specifies the last error code for the current thread. |

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- Error codes are unsigned 32-bit values which are private to each calling thread. Most functions will set the last error code value when they fail; a few functions set it when they succeed. Function failure is typically indicated by a return value such as FALSE, NULL, INVALID_CLIENT or FTP_ERROR. Those functions which call FtpSetLastError when they succeed are noted on the function reference page.
- Applications can retrieve the value saved by this function by using the FtpGetLastError function. The use of FtpGetLastError is optional; an application can call the function to determine the specific reason for a function failure.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetErrorString](#ftpgeterrorstring-function)
- [FtpGetLastError](#ftpgetlasterror-function)

---

## FtpSetPassiveMode Function

Set the server in passive mode

### Prototype

```c
INT WINAPI FtpSetPassiveMode(
    HCLIENT hClient,
    BOOL bPassiveMode
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `bPassiveMode` | `BOOL` | A boolean flag which specifies that the client should enter passive mode and establish all connections with the server to transfer data. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- By default, the File Transfer Protocol uses active mode transfers, whereby the data connection is established from the server back to the local client. However, this can introduce problems for a client application that is behind a proxy server, firewall or a router which uses Network Address Translation (NAT). Enabling passive mode transfers instructs the client to create an outbound connection from the local system to the server for the data connection, similarly to how the control connection is established.
- Not all servers may support passive mode, in which case an error will be returned to the client when this function is called.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpConnect](#ftpconnect-function)
- [FtpGetActivePorts](#ftpgetactiveports-function)
- [FtpGetData](#ftpgetdata-function)
- [FtpGetFile](#ftpgetfile-function)
- [FtpProxyConnect](#ftpproxyconnect-function)
- [FtpPutData](#ftpputdata-function)
- [FtpPutFile](#ftpputfile-function)
- [FtpSetActivePorts](#ftpsetactiveports-function)

---

## FtpSetPriority Function

Set the priority for file transfers

### Prototype

```c
INT WINAPI FtpSetPriority(
    HCLIENT hClient,
    INT nPriority
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nPriority` | `INT` | An integer value which specifies the new priority for file transfers. It may be one of the following values: |

### Options

- **nPriority** Parameter

    - `FTP_PRIORITY_NORMAL`: The default priority which balances resource utilization and transfer speed. It is recommended that most applications use this priority.
    - `FTP_PRIORITY_BACKGROUND`: This priority significantly reduces the memory, processor and network resource utilization for the transfer. It is typically used with worker threads running in the background when the amount of time required perform the transfer is not critical.
    - `FTP_PRIORITY_LOW`: This priority lowers the overall resource utilization for the transfer and meters the bandwidth allocated for the transfer. This priority will increase the average amount of time required to complete a file transfer.
    - `FTP_PRIORITY_HIGH`: This priority increases the overall resource utilization for the transfer, allocating more memory for internal buffering. It can be used when it is important to transfer the file quickly, and there are no other threads currently performing file transfers at the time.
    - `FTP_PRIORITY_CRITICAL`: This priority can significantly increase processor, memory and network utilization while attempting to transfer the file as quickly as possible. If the file transfer is being performed in the main UI thread, this priority can cause the application to appear to become non-responsive. No events will be generated during the transfer.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the previous file transfer priority. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpSetPriority function can be used to control the processor usage, memory and network bandwidth allocated for file transfers. The default priority balances resource utilization and transfer speed while ensuring that a single-threaded application remains responsive to the user. Lower priorities reduce the overall resource utilization at the expense of transfer speed. For example, if you create a worker thread to download a file in the background and want to ensure that it has a minimal impact on the process, the FTP_PRIORITY_BACKGROUND value can be used.
- Higher priority values increase the memory allocated for the transfers and increases processor utilization for the transfer. The FTP_PRIORITY_CRITICAL priority maximizes transfer speed at the expense of system resources. It is not recommended that you increase the file transfer priority unless you understand the implications of doing so and have thoroughly tested your application. If the file transfer is being performed in the main UI thread, increasing the priority may interfere with the normal processing of Windows messages and cause the application to appear to become non-responsive. It is also important to note that when the priority is set to FTP_PRIORITY_CRITICAL, normal progress events will not be generated during the transfer.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetPriority](#ftpgetpriority-function)

---

## FtpSetTimeout Function

Set the number of seconds until an operation times out

### Prototype

```c
INT WINAPI FtpSetTimeout(
    HCLIENT hClient,
    UINT nTimeout
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nTimeout` | `UINT` | The number of seconds to wait for a blocking operation to complete. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The timeout value is only used with blocking client connections.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpConnect](#ftpconnect-function)
- [FtpGetTimeout](#ftpgettimeout-function)
- [FtpIsReadable](#ftpisreadable-function)
- [FtpIsWritable](#ftpiswritable-function)
- [FtpProxyConnect](#ftpproxyconnect-function)
- [FtpRead](#ftpread-function)
- [FtpWrite](#ftpwrite-function)

---

## FtpStartQueue Function

Begin transferring the files in the specified queue

### Prototype

```c
BOOL WINAPI FtpStartQueue(
    HQUEUE hQueue,
    DWORD dwQueueMode,
    DWORD dwReserved,
    FTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `dwQueueMode` | `DWORD` | An unsigned integer which specifies which files in the queue should be transferred. It may be one of the following values: |
| `dwReserved` | `DWORD` | An unsigned integer reserved for internal use. This parameter value should always be zero. |
| `lpEventProc` | `FTPEVENTPROC` | Specifies the procedure-instance address of an application defined callback function. For more information about the callback function, see the description of the FtpEventProc callback function. If this parameter is NULL, there will be no callback notifications. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. If the application targets the x86 (32-bit) platform, this parameter must be a 32-bit unsigned integer. If the application targets the x64 (64-bit) platform, this parameter must be a 64-bit unsigned integer. |

### Options

- **dwQueueMode** Parameter

    - `FTP_QUEUE_ALL`: All files in the queue should be transferred.
    - `FTP_QUEUE_DOWNLOAD`: Transfer only those files which have been queued for download.
    - `FTP_QUEUE_UPLOAD`: Transfer only those files which have been queued for upload.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, it will return zero. To get extended error information, call FtpGetLastError.

### Remarks

- Queued file transfers are performed asynchronously using a background worker thread. If you provide the address to an event callback function, that function will always be invoked in the context of the queue manager thread. You must ensure that any access to global or static variables are synchronized, otherwise the results may be unpredictable. It is recommended that you do not declare any static variables within the callback function itself and you should avoid calling any functions which could cause the thread to block. For example, you should not attempt to establish other network connections from within the event handler.
- If your application has a graphical user interface, you should never attempt to directly modify a UI control from within the callback function. Controls should only be modified by the same UI thread that created their window. One common approach to address this issue is to post a user-defined message to the main window to signal that the user interface needs to be updated. The message handler would then process the user-defined message and update the user interface as needed.
- To obtain the handle to the queue from within an event handler, call the FtpGetThreadQueue function with the dwThreadId parameter set to a value of zero. This will return the handle for the current queue management session which invoked the callback function.
- If a callback function is provided, the FTP_QUEUE_EVENT event notification will be invoked whenever the internal state of the queue has changed. The handle value passed to the callback function will be a handle to the queue, not to a client connection. The FtpGetQueueStatus function can be called within the event handler to obtain the current state of the queue. This will event will always occur when the queue manager begins processing files in the queue and after it has stopped. This event will also occur whenever the queue is suspended and then resumed.
- The FtpWaitForQueue function can be used to wait for the queue manager to complete processing the transfer queue.

### Example

```cpp
// Create a new queue
HQUEUE hQueue = FtpCreateQueue(INFINITE, FTP_TIMEOUT, FTP_OPTION_DEFAULT);

if (hQueue == INVALID_QUEUE)
	return;

// Add a file to the queue
DWORD dwFileId = FtpAddQueuedFile(
					hQueue,
					lpszLocalFile,
					lpszRemoteFile,
					FTP_OPTION_DEFAULT,
					FILE_TYPE_AUTO,
					FTP_TIMEOUT);

// Display information about the queued file
if (dwFileId != 0)
{
	FTPQUEUEDFILE queuedFile;

	if (FtpGetQueuedFile(hQueue, dwFileId, &queuedFile))
	{
		switch (queuedFile.dwMode)
		{
		case FTP_QUEUE_DOWNLOAD:
			_tprintf(_T("%u: Download \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szRemoteFile,
						queuedFile.szLocalFile);
				break;

		case FTP_QUEUE_UPLOAD:
			_tprintf(_T("%u: Upload \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szLocalFile,
						queuedFile.szRemoteFile);
				break;
		}
	}
}

// Start the queued file transfers and wait for it to complete
if (FtpStartQueue(hQueue, FTP_QUEUE_ALL, 0, NULL, 0))
{
	FtpWaitForQueue(hQueue, INFINITE, &dwElapsed, &dwError);
	FtpStopQueue(hQueue);
}

// Remove all files from the queue
FtpDeleteQueue(hQueue);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpEventProc](#ftpeventproc-function)
- [FtpGetQueueStatus](#ftpgetqueuestatus-function)
- [FtpGetThreadQueue](#ftpgetthreadqueue-function)
- [FtpResumeQueue](#ftpresumequeue-function)
- [FtpStartQueue](#ftpstartqueue-function)
- [FtpStopQueue](#ftpstopqueue-function)
- [FtpSuspendQueue](#ftpsuspendqueue-function)
- [FtpWaitForQueue](#ftpwaitforqueue-function)

---

## FtpStopQueue Function

Stop transferring the files in the specified queue

### Prototype

```c
BOOL WINAPI FtpStopQueue(
    HQUEUE hQueue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, it will return zero. To get extended error information, call FtpGetLastError.

### Remarks

- When the FtpStopQueue function is called and there is a file transfer in progress, it will not immediately stop the upload or download of the file. Instead, the queue manager is signaled to stop processing additional files in the queue after the transfer has completed. To wait for the current transfer to complete, call the FtpWaitForQueue function.
- It is permitted to call FtpStopQueue from within a queue event handler. In this case, the current file transfer will complete and the queue manager will terminate.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpCancelQueuedFile](#ftpcancelqueuedfile-function)
- [FtpResetQueue](#ftpresetqueue-function)
- [FtpResumeQueue](#ftpresumequeue-function)
- [FtpStartQueue](#ftpstartqueue-function)
- [FtpSuspendQueue](#ftpsuspendqueue-function)
- [FtpWaitForQueue](#ftpwaitforqueue-function)

---

## FtpSuspendQueue Function

Pause the transfer of files in the specified queue

### Prototype

```c
BOOL WINAPI FtpSuspendQueue(
    HQUEUE hQueue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, it will return zero. To get extended error information, call FtpGetLastError.

### Remarks

- If there is a file transfer in progress when this function is called, the transfer will complete normally. The queue manager will enter a suspended state after the transfer has completed and before it begins processing the next file in the queue.
- It is permitted to call FtpSuspendQueue from within a queue event handler. In this case, the current file transfer will complete and the queue manager will stop processing additional files in the queue until it is resumed or stopped.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpCancelQueuedFile](#ftpcancelqueuedfile-function)
- [FtpGetQueueStatus](#ftpgetqueuestatus-function)
- [FtpResetQueue](#ftpresetqueue-function)
- [FtpResumeQueue](#ftpresumequeue-function)
- [FtpStartQueue](#ftpstartqueue-function)
- [FtpStopQueue](#ftpstopqueue-function)

---

## FtpTaskAbort Function

Abort the specified asynchronous task

### Prototype

```c
BOOL WINAPI FtpTaskAbort(
    UINT nTaskId,
    DWORD dwMilliseconds
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nTaskId` | `UINT` | The task identifier. |
| `dwMilliseconds` | `DWORD` | An unsigned integer that specifies the number of milliseconds to wait for the background task to abort. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds and the worker thread has terminated, the return value is non-zero. A return value of zero indicates that the worker thread is still running or an error has occurred. To get extended error information, call the FtpGetLastError function.

### Remarks

- The FtpTaskAbort function signals the background worker thread associated with the task ID to abort the current operation and terminate as soon as possible. If the dwMilliseconds parameter has a value of zero, the function returns immediately after the background thread has been signaled. If the dwMilliseconds parameter is non-zero, the function will wait that amount of time for the background thread to terminate.
- This function should never be called from within the event handler for an asynchronous task because it can cause the process to deadlock. To abort a file transfer within an event handler, use the FtpCancel function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpTaskDone](#ftptaskdone-function)
- [FtpTaskResume](#ftptaskresume-function)
- [FtpTaskSuspend](#ftptasksuspend-function)
- [FtpTaskWait](#ftptaskwait-function)

---

## FtpTaskDone Function

Determine if an asynchronous task has completed

### Prototype

```c
BOOL WINAPI FtpTaskDone(
    UINT nTaskId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nTaskId` | `UINT` | The task identifier. |

### Return Value

- **Type**: `BOOL`
- If the asynchronous task has completed, this function returns a non-zero value. A return value of zero indicates that the worker thread is still running or an error has occurred. To get extended error information, call the FtpGetLastError function.

### Remarks

- The FtpTaskDone function is used to determine if the specified asynchronous task has completed. If you use this function to poll the status of a background task from within the main UI thread, you must ensure that Windows messages are processed so that the application remains responsive to the end-user. To check if a background transfer has completed, it is recommended that you use a timer to periodically call this function rather than calling it repeatedly within a loop.
- To determine if the task completed successfully, the FtpGetTaskError function will return the last error code associated with the task. A return value of zero indicates success, while a non-zero return value specifies an error code that indicates the cause of the failure. The last error code for the task can also be retrieved using the FtpTaskWait function, which causes the application to wait for the asynchronous task to complete.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetTaskError](#ftpgettaskerror-function)
- [FtpTaskAbort](#ftptaskabort-function)
- [FtpTaskResume](#ftptaskresume-function)
- [FtpTaskSuspend](#ftptasksuspend-function)
- [FtpTaskWait](#ftptaskwait-function)

---

## FtpTaskResume Function

Resume execution of an asynchronous task

### Prototype

```c
BOOL WINAPI FtpTaskResume(
    UINT nTaskId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nTaskId` | `UINT` | The task identifier. |

### Return Value

- **Type**: `BOOL`
- If the asynchronous task has resumed, this function returns a non-zero value. A return value of zero indicates that an error has occurred. To get extended error information, call the FtpGetLastError function.

### Remarks

- The FtpTaskResume function resumes execution of the background worker thread that was previously suspended using the FtpTaskSuspend function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpTaskAbort](#ftptaskabort-function)
- [FtpTaskDone](#ftptaskdone-function)
- [FtpTaskSuspend](#ftptasksuspend-function)
- [FtpTaskWait](#ftptaskwait-function)

---

## FtpTaskSuspend Function

Suspend execution of an asynchronous task

### Prototype

```c
BOOL WINAPI FtpTaskSuspend(
    UINT nTaskId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nTaskId` | `UINT` | The task identifier. |

### Return Value

- **Type**: `BOOL`
- If the asynchronous task has resumed, this function returns a non-zero value. A return value of zero indicates that an error has occurred. To get extended error information, call the FtpGetLastError function.

### Remarks

- The FtpTaskSuspend function will suspend execution of the background worker thread associated with the task. Once the task has been suspended, it will no longer be scheduled for execution, however the client session will remain active and the task may be resumed using the FtpTaskResume function. Note that if a task is suspended for a long period of time, the background operation may fail because it has exceeded the timeout period imposed by the server.
- This function should never be called from within the event handler for an asynchronous task because it can cause the process to deadlock.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpTaskAbort](#ftptaskabort-function)
- [FtpTaskDone](#ftptaskdone-function)
- [FtpTaskResume](#ftptaskresume-function)
- [FtpTaskWait](#ftptaskwait-function)

---

## FtpTaskWait Function

Wait for an asynchronous task to complete

### Prototype

```c
BOOL WINAPI FtpTaskWait(
    UINT nTaskId,
    DWORD dwMilliseconds,
    DWORD dwReserved,
    LPDWORD lpdwElapsed,
    LPDWORD lpdwError
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nTaskId` | `UINT` | The task identifier. |
| `dwMilliseconds` | `DWORD` | An unsigned integer that specifies the number of milliseconds to wait for the background task to complete. |
| `dwReserved` | `DWORD` | An unsigned integer reserved for future use. This value should always be zero. |
| `lpdwElapsed` | `LPDWORD` | A pointer to an unsigned integer that will contain elapsed time in milliseconds when the function returns. If this information is not required, this parameter may be NULL. |
| `lpdwError` | `LPDWORD` | A pointer to an unsigned integer that will contain the error code associated with the completed task. If this information is not required, this parameter may be NULL. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds and the worker thread has terminated, the return value is non-zero. A return value of zero indicates that the worker thread is still running or an error has occurred. To get extended error information, call the FtpGetLastError function.

### Remarks

- The FtpTaskWait function waits for the specified task to complete. If the task is active and the dwMilliseconds parameter is non-zero, this function will cause the current working thread to block until the task completes or the amount of time exceeds the number of milliseconds specified by the caller. If the dwMilliseconds parameter is zero, then this function will poll the status of the task and return immediately to the caller.
- If the specified task has already completed at the time this function is called, the function will return immediately without causing the current thread to block. If the lpdwElapsed parameter is not NULL, it will contain the number of milliseconds that it took for the task to complete. If the lpdwError parameter is not NULL, it will contain the last error code value that was set by the worker thread before it terminated. If this value is zero, that means that the background operation was successful and no error occurred. A non-zero value will indicate that the background operation has failed.
- You should not call this function from the main UI thread with a long timeout period to wait for a background task to complete. Windows messages will not be processed while this function is blocked waiting for the background task to complete, and this can cause your application to appear non-responsive to the end-user. If you have a GUI application and you need to periodically check to see if a task has completed, create a timer to periodically call the FtpTaskDone function. When it returns a non-zero value (indicating that the task has completed), you can safely call FtpTaskWait to obtain the elapsed time and last error code without blocking the current thread.
- This function should never be called from within the event handler for an asynchronous task because it can cause the process to deadlock.

### Example

```cpp
UINT nTaskId;

// Begin a file transfer in the background

nTaskId = FtpAsyncGetFile(hClient,
						lpszLocalFile,
						lpszRemoteFile,
						FTP_TRANSFER_DEFAULT,
						0,
						NULL,
						0);

if (nTaskId != 0)
{
	DWORD dwError = NO_ERROR;
	DWORD dwElapsed = 0;

	// Wait for the transfer to complete
	FtpTaskWait(nTaskId, INFINTE, &dwElapsed, &dwError);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpTaskDone](#ftptaskdone-function)
- [FtpTaskResume](#ftptaskresume-function)
- [FtpTaskSuspend](#ftptasksuspend-function)
- [FtpTaskWait](#ftptaskwait-function)

---

## FtpUninitialize Function

Terminate use of the library by the calling process

### Prototype

```c
VOID WINAPI FtpUninitialize();
```

### Parameters

| Name | Type | Description |
|------|------|-------------|

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- An application is required to perform a successful FtpInitialize call before it can call any of the other library functions. When it has completed the use of library, the application must call FtpUninitialize to allow the library to free any resources allocated on behalf of the process. Any pending blocking or asynchronous calls in this process are canceled without posting any notification messages, and all sockets that were opened by the process are closed.
- There must be a call to FtpUninitialize for every successful call to FtpInitialize made by a process. In a multithreaded environment, operations for all threads in the client are terminated.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpConnect](#ftpconnect-function)
- [FtpDisconnect](#ftpdisconnect-function)
- [FtpInitialize](#ftpinitialize-function)
- [FtpProxyConnect](#ftpproxyconnect-function)
- [FtpReset](#ftpreset-function)

---

## FtpUploadFile Function

Upload a file from the local system to the server

### Prototype

```c
BOOL WINAPI FtpUploadFile(
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    UINT nTimeout,
    DWORD dwOptions,
    LPFTPTRANSFERSTATUS lpStatus,
    FTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file on the local system that will be uploaded to the server. The file pathing and name conventions must be that of the local host. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the complete URL of the file that will be created or overwritten on the server. The URL must follow the conventions for the File Transfer Protocol and may specify either a standard or secure connection, alternate port number, username, password and optional working directory. |
| `nTimeout` | `UINT` | The number of seconds that the client will wait for a response before failing the operation. A value of zero specifies that the default timeout period of sixty seconds will be used. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `lpStatus` | `LPFTPTRANSFERSTATUS` | A pointer to an FTPTRANSFERSTATUS structure which contains information about the status of the current file transfer. If this information is not required, a NULL pointer may be specified as the parameter. |
| `lpEventProc` | `FTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the FtpEventProc callback function. If this parameter is NULL, the callback for the specified event is disabled. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. |

### Options

- **dwOptions** Parameter

    - `FTP_OPTION_DEFAULT`: Default options should be used for file transfers. This is the same as specifying that all file transfers should use passive mode when establishing a data connection with the server. It is recommended most applications use passive mode to prevent potential compatibility issues with certain types of firewalls and routers which use Network Address Translation (NAT).
    - `FTP_OPTION_PASSIVE`: This option specifies file transfers should attempt to establish the data connection with the server. If the local system is behind a firewall or a NAT router, the server may not be able to establish a data connection back to the client and the transfer will fail. This option forces the client to establish an outbound data connection with the server. It is recommended that applications use passive mode whenever possible.
    - `FTP_OPTION_FIREWALL`: This option specifies the client should always use the host IP address to establish the data connection with the server, not the address returned by the server in response to the PASV command. This option may be necessary if the server is behind a router that performs Network Address Translation (NAT) and it returns an unreachable IP address for the data connection. If this option is specified, it will also enable passive mode data transfers.
    - `FTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. Note that the server must support secure connections using the TLS protocol.
    - `FTP_OPTION_SECURE_EXPLICIT`: This option specifies the client should use the AUTH command to negotiate an explicit secure connection. Some servers may only require this when connecting to the server on ports other than 990.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpUploadFile function provides a convenient way for an application to upload a file in a single function call. Based on the connection information specified in the URL, it will connect to the server, authenticate the session, change the current working directory if necessary and then upload the file to the server. The URL must be complete, and specify either a standard or secure FTP scheme:
- If no user name and password is provided, then the client session will be authenticated as an anonymous user. If a path is specified as part of the URL, the function will attempt to change the current working directory. Note that the path in an FTP URL is relative to the home directory of the user account and is not an absolute path starting at the root directory on the server. The URL scheme will always determine if the connection is secure, not the option. In other words, if the "ftp" scheme is used and the FTP_OPTION_SECURE option is specified, that option will be ignored. To establish a secure connection, either the "ftps" or "sftp" scheme must be specified.
- The optional "type" value at the end of the file name determines if the file should be uploaded as a text or binary file. A value of "a" specifies that the file should be uploaded as a text file. A value of "i" specifies that the file should be uploaded as a binary file. If the type is not explicitly specified, the file will be uploaded as a binary file.
- The lpStatus parameter can be used by the application to determine the final status of the transfer, including the total number of bytes copied, the amount of time elapsed and other information related to the transfer process. If this information isn't needed, then this parameter may be specified as NULL.
- The lpEventProc parameter specifies a pointer to a function which will be periodically called during the file transfer process. This can be used to check the status of the transfer by calling FtpGetTransferStatus and then update the program's user interface. For example, the callback function could calculate the percentage for how much of the file has been transferred and then update a progress bar control. The dwParam parameter is used in conjunction with the event handler and specifies a user-defined value that is passed to the callback function. One common use in a C++ program is to pass the this pointer as the value, and then cast it back to an object pointer inside the callback function. If no event handler is required, then a NULL pointer can be specified as the value for lpEventProc and the dwParam parameter will be ignored.
- The FtpUploadFile function is designed to provide a simpler interface for uploading a file. However, complex connections such as those using a proxy server or a secure connection which uses a client certificate will require the program to establish the connection using FtpConnect and then use FtpPutFile to upload the file.

### Example

```cpp
FTPTRANSFERSTATUS ftpStatus;
LPCTSTR lpszLocalFile = _T("c:\\temp\\database.mdb");
LPCTSTR lpszRemoteFile = _T("ftp://update:secret@ftp.example.com/updates/database.mdb");
BOOL bResult;

// Upload the file using the specified URL
bResult = FtpUploadFile(lpszLocalFile,
						lpszRemoteFile,
						FTP_OPTION_PASSIVE,
						&ftpStatus,
						NULL, 0);

if (!bResult)
{
	TCHAR szError[128];

	// Display a message box that describes the error
	FtpGetErrorString(FtpGetLastError(), szError, 128);
	MessageBox(NULL, szError, NULL, MB_ICONEXCLAMATION|MB_TASKMODAL);
	return;
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpEventProc](#ftpeventproc-function)
- [FtpDownloadFile](#ftpdownloadfile-function)
- [FtpGetTransferStatus](#ftpgettransferstatus-function)
- [FtpPutFile](#ftpputfile-function)
- [FTPTRANSFERSTATUS](#ftptransferstatus-function)

---

## FtpValidateHostName Function

Validate the specified host name and return the resolved IP address

### Prototype

```c
BOOL WINAPI FtpValidateHostName(
    LPCTSTR lpszHostName,
    LPTSTR lpszAddress,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszHostName` | `LPCTSTR` | A pointer to a null terminated string which specifies the host name. The function will fail If this parameter is NULL or an empty string. |
| `lpszAddress` | `LPTSTR` | A pointer to a string buffer which will contain the IP address of the host. If specified, this string must be large enough to store the complete IP address, including the terminating null character. If this parameter is NULL or the nMaxLength parameter is zero, it will be ignored and the IP address will not be returned. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters which can be copied into the lpszAddress string buffer. The buffer must be large enough to store the complete address. Because this function can return either an IPv4 or IPv6 address, it is recommended the minimum length for the buffer to be 46 characters. If this parameter is zero, the lpszAddress parameter will be ignored. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the host name is valid and the return value will be non-zero. If the function fails, the host name could not be resolved to an IP address and the return value will be zero. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpValidateHostName function provides a convenient way to determine if a host name is valid by attempting to resolve the name into an IP address. If the Unicode version of this function is used, any non-ASCII characters in the host name will be automatically encoded into a compatible format and then resolved to an IP address. If you are unsure if an internationalized domain name will be specified as the host name, it is recommended you use the Unicode version.
- If the lpszHostName parameter specifies a valid IPv4 or IPv6 address string instead of a host name, this function will return a copy of that IP address in the buffer provided by the caller. This allows the function to be used in cases where a user may input either a host name or IP address.
- If you wish to validate a complete FTP URL instead of a host name, use the FtpValidateUrl function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpConnectUrl](#ftpconnecturl-function)
- [FtpValidateUrl](#ftpvalidateurl-function)

---

## FtpValidateUrl Function

Check the contents of a string to ensure it represents a valid URL

### Prototype

```c
BOOL WINAPI FtpValidateUrl(
    LPCTSTR lpszUrl
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszUrl` | `LPCTSTR` | A pointer to a string that specifies the URL to validate. |

### Return Value

- **Type**: `BOOL`
- If the specified URL is valid and the host name can be resolved to an IP address, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpValidateUrl function will check the value of a string to ensure that it represents a complete, valid URL using either a standard or secure FTP scheme. This function will not establish a connection with the server to verify that it exists, it will only attempt to resolve the host name to an IP address. If the remote host is specified as an IP address, this function will check to make sure that the address is formatted correctly. Note that if you wish to specify an IPv6 address, you must enclose the address in brackets.
- To establish a connection with a server using a URL, use the FtpConnectUrl function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpConnectUrl](#ftpconnecturl-function)
- [FtpValidateHostName](#ftpvalidatehostname-function)

---

## FtpVerifyFile Function

Compare the contents of a local file against a file stored on the server

### Prototype

```c
BOOL WINAPI FtpVerifyFile(
    HCLIENT hClient,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the name of file on the local system. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the name of the file on the server. |
| `dwOptions` | `DWORD` | Specifies the options that may be used when comparing the files. This parameter may be one or more of the following values: |

### Options

- **dwOptions** Parameter

    - `FTP_VERIFY_DEFAULT`: File verification should use the best option available based on the available server features. If the server supports the XMD5 command, the library will calculate an MD5 hash of the local file contents and compare the value with the file on the server. If the server does not support the XMD5 command, but it does support the XCRC command, the library will calculate a CRC32 checksum of the local file contents and compare the value with the file on the server. If the server does not support either the XMD5 or XCRC commands, the library will compare the size of the local and remote files.
    - `FTP_VERIFY_SIZE`: Files are verified by comparing the number of bytes of data in the local and remote files. This is the least reliable method, and should only be used if the server does not support either the XMD5 or XCRC commands.
    - `FTP_VERIFY_CRC32`: Files are verified by calculating a CRC32 checksum of the local file contents and comparing it with the value returned by the server in response to the XCRC command. This method should only be used if the server does not support the XMD5 command.
    - `FTP_VERIFY_MD5`: Files are verified by calculating an MD5 hash of the local file contents and comparing it with the value returned by the server in response to the XMD5 command. This is the preferred method for performing file verification.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call FtpGetLastError.

### Remarks

- The FtpVerifyFile function will attempt to verify that the contents of the local and remote files are identical using one of several methods, based on the features that the server supports. Preference will be given to the most reliable method available, using either an MD5 hash, a CRC-32 checksum or comparing the size of the file, in that order.
- It is not recommended that you use this function with text files because of the different end-of-line conventions used by different operating systems. For example, a text file on a Windows system uses a carriage-return and linefeed pair to indicate the end of a line of text. However, on a UNIX system, a single linefeed is used to indicate the end of a line. This can cause the FtpVerifyFile function to indicate the files are not identical, even though the only difference is in the end-of-line characters that are used.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [FtpDeleteFile](#ftpdeletefile-function)
- [FtpGetFile](#ftpgetfile-function)
- [FtpPutFile](#ftpputfile-function)

---

## FtpWaitForQueue Function

Wait for the transfer of all queued files to complete

### Prototype

```c
BOOL WINAPI FtpWaitForQueue(
    HQUEUE hQueue,
    DWORD dwMilliseconds,
    LPDWORD lpdwElapsed,
    LPDWORD lpdwError
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `dwMilliseconds` | `DWORD` | An unsigned integer value which specifies the number of milliseconds to wait for the queue to complete processing. If this value is zero, the function will return immediately. If this value is INFINITE (0xFFFFFFFF), the function will block indefinitely until all files in the queue have been processed. |
| `lpdwElapsed` | `LPDWORD` | A pointer to an unsigned integer which will contain the number of milliseconds the queue manager has been active when the function returns. If this information is not needed, this parameter can be NULL. If this parameter is not NULL, it will always be initialized to a value of zero. |
| `lpdwError` | `LPDWORD` | A pointer to an unsigned integer which will contain the last error code set if a file transfer has failed or was canceled. If this information is not needed, this parameter can be NULL. If this parameter is not NULL, it will always be initialized to a value of zero. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero, which means the queue manager has completed transferring all queued files. If the function fails, or the timeout period elapses, it will return zero. To get extended error information, call FtpGetLastError.

### Remarks

- This function will cause the current thread to block until either the queue manager has completed processing all files in the queue, or until the specified number of milliseconds have elapsed. It is important to note that Windows messages will not be processed during this time. If you call this function within the main UI thread, it can potentially cause the application to become non-responsive. To determine the current state of the queue without blocking the current thread, call the FtpGetQueueStatus function.
- If the dwMilliseconds parameter is non-zero and file transfers have not completed within the specified amount of time, the function will return zero and the last error code will be set to ST_ERROR_OPERATION_TIMEOUT.
- If an event callback function has been specified when starting the queue, you should never call this function within the event handler. Attempting to do so can potentially create a situation which will cause the application to become non-responsive. The function will return zero if it determines it's being called within the context of the queue manager thread and will set the last error code to ST_ERROR_THREAD_DEADLOCK.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpGetQueueStatus](#ftpgetqueuestatus-function)
- [FtpResetQueue](#ftpresetqueue-function)
- [FtpResumeQueue](#ftpresumequeue-function)
- [FtpStartQueue](#ftpstartqueue-function)
- [FtpStopQueue](#ftpstopqueue-function)
- [FtpSuspendQueue](#ftpsuspendqueue-function)

---

## FtpWrite Function

Write data to the server

### Prototype

```c
INT WINAPI FtpWrite(
    HCLIENT hClient,
    LPBYTE lpBuffer,
    INT cbBuffer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpBuffer` | `LPBYTE` | The pointer to the buffer which contains the data that is to be sent to the server. |
| `cbBuffer` | `INT` | The number of bytes to send from the specified buffer. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of bytes actually written. If the function fails, the return value is FTP_ERROR. To get extended error information, call FtpGetLastError.

### Remarks

- The return value may be less than the number of bytes specified by the cbBuffer parameter. In this case, the data has been partially written and it is the responsibility of the client application to send the remaining data at some later point. For non-blocking clients, the client must wait for the next asynchronous notification message before it resumes sending data.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `csftpv11.lib`

### See Also

- [FtpEnableEvents](#ftpenableevents-function)
- [FtpIsBlocking](#ftpisblocking-function)
- [FtpIsReadable](#ftpisreadable-function)
- [FtpIsWritable](#ftpiswritable-function)
- [FtpPutData](#ftpputdata-function)
- [FtpPutFile](#ftpputfile-function)
- [FtpRead](#ftpread-function)
- [FtpRegisterEvent](#ftpregisterevent-function)

---

## FTPCLIENTQUOTA Structure

The FTPCLIENTQUOTA structure provides information about the file quota for the current client session.

### Definition

```c
typedef struct _FTPCLIENTQUOTA
{
    DWORD dwFileCount;
    DWORD dwFileLimit;
    DWORD dwDiskUsage;
    DWORD dwDiskLimit;
} FTPCLIENTQUOTA, *LPFTPCLIENTQUOTA;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwFileCount` | `DWORD` | An unsigned integer value which specifies the number of files that the user has created. If file quotas have not been enabled for the current user, this value will be zero. |
| `dwFileLimit` | `DWORD` | An unsigned integer value which specifies the maximum number of files that may be created by the user. If file quotas have not been enabled for the current user, this value will be zero. |
| `dwDiskUsage` | `DWORD` | An unsigned integer value which specifies the number of bytes of disk storage that has been allocated by the current user. If file quotas have not been enabled for the current user, this value will be zero. |
| `dwDiskLimit` | `DWORD` | An unsigned integer value which specifies the maximum number of bytes of disk storage that may be allocated by the current user. If file quotas have not been enabled for the current user, this value will be zero. |

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

---

## FTPFILESTATUS Structure

This structure is used by the FtpEnumFiles , FtpGetFirstFile and FtpGetNextFile functions to return information about files on the server.

### Definition

```c
typedef struct _FTPFILESTATUS
{
    BOOL bIsDirectory;
    DWORD dwFileSize;
    DWORD dwFileLinks;
    DWORD dwFileVersion;
    DWORD dwFilePerms;
    SYSTEMTIME stFileDate;
} FTPFILESTATUS, *LPFTPFILESTATUS;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `bIsDirectory` | `BOOL` | A boolean flag which specifies if the file is actually a subdirectory. |
| `dwFileSize` | `DWORD` | The size of the file in bytes on the server. Servers that return file information in an MS-DOS format will always set this value to zero if the file refers to a subdirectory. If the file is a text file, the file size on the server may be different than the size on the local host if different end-of-line character conventions are used. It should be noted that under VMS, the file size is reported in 512 byte blocks, so the size should be considered approximate on that platform. |
| `dwFileLinks` | `DWORD` | The number of links to the file. Note that not all server types support the concept of file links, in which case this value will be zero. |
| `dwFileVersion` | `DWORD` | The number of revisions made to the file. Note that not all server types support the concept of file versioning, in which case this value will be zero. Currently this value will only be non-zero for VMS platforms. |
| `dwFilePerms` | `DWORD` | The permissions associated with the file. This value is actually a combination of bits that specify the individual permissions for the file owner, group and world (all other users). For those familiar with UNIX, the file permissions are the same as those used by the chmod command. For the proprietary Sterling directory formats, a bit map representing the status codes and transfer protocol of the file is stored in this member. |
| `stFileDate` | `SYSTEMTIME` | A SYSTEMTIME structure which specifies the date that the file was created or last modified. |

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

---

## FTPFILESTATUSEX Structure

This structure is used by the FtpEnumFilesEx , FtpGetFirstFileEx and FtpGetNextFileEx functions to return information about files on the server. This structure is designed for use with extended functions that support files larger than 4GB.

### Definition

```c
typedef struct _FTPFILESTATUSEX
{
    BOOL bIsDirectory;
    ULARGE_INTEGER uiFileSize;
    DWORD dwFileLinks;
    DWORD dwFileVersion;
    DWORD dwFilePerms;
    DWORD dwFileFlags;
    SYSTEMTIME stFileDate;
} FTPFILESTATUSEX, *LPFTPFILESTATUSEX;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `bIsDirectory` | `BOOL` | A boolean flag which specifies if the file is actually a subdirectory. |
| `uiFileSize` | `ULARGE_INTEGER` | The size of the file in bytes on the server. Servers that return file information in an MS-DOS format will always set this value to zero if the file refers to a subdirectory. If the file is a text file, the file size on the server may be different than the size on the local host if different end-of-line character conventions are used. It should be noted that under VMS, the file size is reported in 512 byte blocks, so the size should be considered approximate on that platform. |
| `dwFileLinks` | `DWORD` | The number of links to the file. Note that not all server types support the concept of file links, in which case this value will be zero. |
| `dwFileVersion` | `DWORD` | The number of revisions made to the file. Note that not all server types support the concept of file versioning, in which case this value will be zero. Currently this value will only be non-zero for VMS platforms. |
| `dwFilePerms` | `DWORD` | The permissions associated with the file. This value is actually a combination of bits that specify the individual permissions for the file owner, group and world (all other users). For those familiar with UNIX, the file permissions are the same as those used by the chmod command. For the proprietary Sterling directory formats, a bit map representing the status codes and transfer protocol of the file is stored in this member. |
| `dwFileFlags` | `DWORD` | This structure member is reserved for future use. |
| `stFileDate` | `SYSTEMTIME` | A SYSTEMTIME structure which specifies the date that the file was created or last modified. |

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

---

## FTPQUEUEDFILE Structure

This structure is used by the FtpGetFirstQueuedFile , FtpGetNextQueuedFile and FtpGetQueuedFile functions to return information about a file in the transfer queue.

### Definition

```c
typedef struct _FTPQUEUEDFILE
{
    DWORD dwFileId;
    DWORD dwQueueMode;
    DWORD dwQueueFlags;
    DWORD dwTimeElapsed;
    DWORD dwLastError;
    ULARGE_INTEGER uiBytesCopied;
} FTPQUEUEDFILE, *LPFTPQUEUEDFILE;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwFileId` | `DWORD` | An unsigned integer which specifies a unique identifier for the queued file. The application should not make any assumptions about the value of the file identifiers. They should be considered opaque values which are only guaranteed to uniquely identify a file in the transfer queue. In particular, there is no guarantee that the file identifiers will be sequential and they should not be used as index values into an array. |
| `dwQueueMode` | `DWORD` | An unsigned integer value which specifies how the file was queued for transfer. It may be one of the following values: |
| `dwQueueFlags` | `DWORD` | An unsigned integer which specifies one or more bit flags which provides information about the status of the file transfer. It may be one or more of the following values: |
| `dwTimeElapsed` | `DWORD` | An unsigned integer which specifies the number of milliseconds required to complete the transfer. This value will be zero unless the file has been transferred successfully. |
| `dwLastError` | `DWORD` | An unsigned integer which specifies the last error code for a failed transfer. If the file was transferred successfully, this value will be zero. |
| `uiBytesCopied` | `ULARGE_INTEGER` | A value which specifies the number of bytes which were copied during the file transfer. The ULARGE_INTEGER type is a union of a structure and a 64-bit value which can be used on both 32-bit and 64-bit systems. For languages other than C/C++ you can define this structure member as an unsigned 64-bit integer type. |

### Remarks

- It is possible that the szLocalFile and szRemoteFile structure members will be different than the values passed to the FtpAddQueuedFile function. Those values are normalized, with any relative paths converted to absolute paths. Internationalized domain names will be encoded and the URL paths will be collapsed, removing any extraneous path information. For example, if the remote file name is specified as ftp://ftp.server.tld/folder1/../folder2/filename.txt it would be normalized as ftp://ftp.server.tld/folder2/filename.txt.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

### See Also

- [FtpAddQueuedFile](#ftpaddqueuedfile-structure)
- [FtpAddQueuedFileEx](#ftpaddqueuedfileex-structure)
- [FtpGetFirstQueuedFile](#ftpgetfirstqueuedfile-structure)
- [FtpGetNextQueuedFile](#ftpgetnextqueuedfile-structure)
- [FtpGetQueuedFile](#ftpgetqueuedfile-structure)

---

## FTPQUEUESTATUS Structure

This structure is used by the FtpGetQueueStatus function to return information about the current status of the file transfer queue.

### Definition

```c
typedef struct _FTPQUEUESTATUS
{
    DWORD dwStatus;
    DWORD dwThreadId;
    DWORD dwQueuedFiles;
    DWORD dwPendingFiles;
    DWORD dwCopiedFiles;
    DWORD dwFailedFiles;
    DWORD dwTimeElapsed;
    DWORD dwCurrentFile;
    DWORD dwLastError;
    ULARGE_INTEGER uiBytesCopied;
    ULARGE_INTEGER uiBytesTotal;
} FTPQUEUESTATUS, *LPFTPQUEUESTATUS;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwStatus` | `DWORD` | An unsigned integer which specifies the current status of the queue. It can be one of the following values: |
| `dwThreadId` | `DWORD` | An unsigned integer which specifies the thread ID for the queue manager which is performing the file transfers. All file transfers are performed asynchronously in a background worker thread. If this structure member is zero, the queue is idle and not performing file transfers. The application should not use the thread ID to obtain a handle to suspend or terminate the thread. This can potentially result in unexpected behavior or instability within the application. |
| `dwQueuedFiles` | `DWORD` | An unsigned integer which specifies the total number of queued files. This value includes pending and completed file transfers. |
| `dwPendingFiles` | `DWORD` | An unsigned integer which specifies the number of files which are queued to be transferred. |
| `dwCopiedFiles` | `DWORD` | An unsigned integer which specifies the number of files which have been successfully transferred. This value reflects the total number of files which have the FTP_QUEUE_FLAG_COMPLETED status. |
| `dwFailedFiles` | `DWORD` | An unsigned integer which specifies the number of files which have failed to transfer or the file transfer has been canceled. This value reflects the total number of files which have the FTP_QUEUE_FLAG_FAILED status. |
| `dwTimeElapsed` | `DWORD` | An unsigned integer which specifies the total amount of time, in milliseconds, the queue manager has been active performing a file transfer. If the queue is idle, this value will reflect the total run time for the previously active queue. A value of zero indicates the queue was never active or the queue state has been reset with a call to FtpResetQueue . |
| `dwCurrentFile` | `DWORD` | An unsigned integer which specifies the unique identifier for the current file being transferred. If no file transfer is in progress, this member will have a value of zero. If the value is non-zero, it can be passed to the FtpGetQueuedFile function to obtain information about the queued file. |
| `dwLastError` | `DWORD` | An unsigned integer which specifies the last error code for a failed file transfer. If there have been no errors, this value will be zero. |
| `uiBytesCopied` | `ULARGE_INTEGER` | A value which specifies the number of bytes which were copied during the current or last transfer. The ULARGE_INTEGER type is a union of a structure and a 64-bit value which can be used on both 32-bit and 64-bit systems. For languages other than C/C++ you can define this structure member as an unsigned 64-bit integer type. |
| `uiBytesTotal` | `ULARGE_INTEGER` | A value which specifies the total number of bytes which were copied during the current queue run. The ULARGE_INTEGER type is a union of a structure and a 64-bit value which can be used on both 32-bit and 64-bit systems. For languages other than C/C++ you can define this structure member as an unsigned 64-bit integer type. |

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

### See Also

- [FtpGetQueuedFile](#ftpgetqueuedfile-structure)
- [FtpGetQueueStatus](#ftpgetqueuestatus-structure)
- [FtpCancelQueuedFile](#ftpcancelqueuedfile-structure)
- [FtpResetQueue](#ftpresetqueue-structure)
- [FtpResumeQueue](#ftpresumequeue-structure)
- [FtpStartQueue](#ftpstartqueue-structure)
- [FtpStopQueue](#ftpstopqueue-structure)
- [FtpSuspendQueue](#ftpsuspendqueue-structure)

---

## FTPTRANSFERSTATUS Structure

This structure is used by the FtpGetTransferStatus function to return information about a file transfer in progress.

### Definition

```c
typedef struct _FTPTRANSFERSTATUS
{
    DWORD dwBytesTotal;
    DWORD dwBytesCopied;
    DWORD dwBytesPerSecond;
    DWORD dwTimeElapsed;
    DWORD dwTimeEstimated;
} FTPTRANSFERSTATUS, *LPFTPTRANSFERSTATUS;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwBytesTotal` | `DWORD` | The total number of bytes that will be transferred. If the file is being copied from the server to the local host, this is the size of the remote file. If the file is being copied from the local host to the server, it is the size of the local file. If the file size cannot be determined, this value will be zero. |
| `dwBytesCopied` | `DWORD` | The total number of bytes that have been copied. |
| `dwBytesPerSecond` | `DWORD` | The average number of bytes that have been copied per second. |
| `dwTimeElapsed` | `DWORD` | The number of seconds that have elapsed since the file transfer started. |
| `dwTimeEstimated` | `DWORD` | The estimated number of seconds until the file transfer is completed. This is based on the average number of bytes transferred per second. |

### Remarks

- If the option FTP_OPTION_HIRES_TIMER has been specified when connecting to the server, the values returned in the dwTimeElapsed and dwTimeEstimated members will be in milliseconds instead of seconds. You can use this option to obtain more accurate elapsed times when uploading or downloading small files over a fast network connection.
- If you are uploading or downloading large files which exceed 4GB, you should use the FTPTRANSFERSTATUSEX structure which uses 64-bit integers for the file size.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

### See Also

- [FtpGetTransferStatus](#ftpgettransferstatus-structure)
- [FtpGetTransferStatusEx](#ftpgettransferstatusex-structure)
- [FTPTRANSFERSTATUSEX](#ftptransferstatusex-structure)

---

## FTPTRANSFERSTATUSEX Structure

This structure is used by the FtpGetTransferStatusEx function to return information about a file transfer in progress. This structure is designed for use with extended functions that support files larger than 4GB.

### Definition

```c
typedef struct _FTPTRANSFERSTATUSEX
{
    ULARGE_INTEGER dwBytesTotal;
    ULARGE_INTEGER dwBytesCopied;
    DWORD dwBytesPerSecond;
    DWORD dwTimeElapsed;
    DWORD dwTimeEstimated;
    DWORD dwReserved;
} FTPTRANSFERSTATUSEX, *LPFTPTRANSFERSTATUSEX;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwBytesTotal` | `ULARGE_INTEGER` |  |
| `dwBytesCopied` | `ULARGE_INTEGER` |  |
| `dwBytesPerSecond` | `DWORD` | The average number of bytes that have been copied per second. |
| `dwTimeElapsed` | `DWORD` | The number of seconds that have elapsed since the file transfer started. |
| `dwTimeEstimated` | `DWORD` | The estimated number of seconds until the file transfer is completed. This is based on the average number of bytes transferred per second. |
| `dwReserved` | `DWORD` | This structure member is reserved for future use. |

### Remarks

- If the option FTP_OPTION_HIRES_TIMER has been specified when connecting to the server, the values returned in the dwTimeElapsed and dwTimeEstimated members will be in milliseconds instead of seconds. You can use this option to obtain more accurate elapsed times when uploading or downloading small files over a fast network connection.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

### See Also

- [FtpGetTransferStatus](#ftpgettransferstatus-structure)
- [FtpGetTransferStatusEx](#ftpgettransferstatusex-structure)
- [FTPTRANSFERSTATUS](#ftptransferstatus-structure)

---

## INITDATA Structure

This structure contains information about the SocketTools library when the initialization function returns.

### Definition

```c
typedef struct _INITDATA
{
    DWORD dwSize;
    DWORD dwVersionMajor;
    DWORD dwVersionMinor;
    DWORD dwVersionBuild;
    DWORD dwOptions;
    DWORD_PTR dwReserved1;
    DWORD_PTR dwReserved2;
    TCHAR szDescription;
} INITDATA, *LPINITDATA;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | Size of this structure. This structure member must be set to the size of the structure prior to calling the initialization function. Failure to do so will cause the function to fail. |
| `dwVersionMajor` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. When the function returns, it will contain the major version number for the library. |
| `dwVersionMinor` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. When the function returns, it will contain the minor version number for the library. |
| `dwVersionBuild` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. When the function returns, it will contain the build number for the library. |
| `dwOptions` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. This member is reserved for future use. |
| `dwReserved1` | `DWORD_PTR` | This member must be initialized to a value of zero prior to calling the initialization function. This member is reserved for future use. |
| `dwReserved2` | `DWORD_PTR` | This member must be initialized to a value of zero prior to calling the initialization function. This member is reserved for future use. |
| `szDescription` | `TCHAR` | A null terminated string which describes the library. |

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

---

## SECURITYCREDENTIALS Structure

The SECURITYCREDENTIALS structure specifies the information needed by the library to specify additional security credentials, such as a client certificate or private key, when establishing a secure connection.

### Definition

```c
typedef struct _SECURITYCREDENTIALS
{
    DWORD dwSize;
    DWORD dwProtocol;
    DWORD dwOptions;
    DWORD dwReserved;
    LPCTSTR lpszHostName;
    LPCTSTR lpszUserName;
    LPCTSTR lpszPassword;
    LPCTSTR lpszCertStore;
    LPCTSTR lpszCertName;
    LPCTSTR lpszKeyFile;
} SECURITYCREDENTIALS, *LPSECURITYCREDENTIALS;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | Size of this structure. If the structure is being allocated dynamically, this member must be set to the size of the structure and all other unused structure members must be initialized to a value of zero or NULL. |
| `dwProtocol` | `DWORD` | A bitmask of supported security protocols. The value of this structure member is constructed by using a bitwise operator with any of the following values: |
| `dwOptions` | `DWORD` | A value which specifies one or options. This value should always be zero for connections using SSH. This member is constructed by using a bitwise operator with any of the following values: |
| `dwReserved` | `DWORD` | This structure member is reserved for future use and should always be initialized to zero. |
| `lpszHostName` | `LPCTSTR` | A pointer to a null terminated string which specifies the hostname that will be used when validating the server certificate. If this member is NULL, then the server certificate will be validated against the hostname used to establish the connection. |
| `lpszUserName` | `LPCTSTR` | A pointer to a null terminated string which identifies the owner of client certificate. Currently this member is not used by the library and should always be initialized as a NULL pointer. |
| `lpszPassword` | `LPCTSTR` | A pointer to a null terminated string which specifies the password needed to access the certificate. Currently this member is only used if the CREDENTIAL_STORE_FILENAME option has been specified. If there is no password associated with the certificate, then this member should be initialized as a NULL pointer. |
| `lpszCertStore` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the certificate store to open. A certificate store is a collection of certificates and their private keys, typically organized by how they are used. If this value is NULL or points to an empty string, the default certificate store "MY" will be used. |
| `lpszCertName` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the certificate to use. The library will first search the certificate store for a certificate with a matching "friendly name"; this is a name for the certificate that is assigned by the user. Note that the name must match completely, but the comparison is not case sensitive. If no matching certificate is found, the library will then attempt to find a certificate that has a matching common name (also called the certificate subject). This comparison is less stringent, and the first partial match will be returned. If this second search fails, the library will return an error indicating that the certificate could not be found. If the SECURITY_PROTOCOL_SSH protocol has been specified, this member should be NULL. |
| `lpszKeyFile` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the file which contains the private key required to establish the connection. This member is only used for SFTP (SSH) connections and should always be NULL when establishing a secure connection using FTPS (FTP+TLS). If the member is NULL, then no private key is used. The private key file must be in the standard PEM format defined in RFC 1422. Both the standard RSA private key format and the proprietary OpenSSH format are supported. |

### Remarks

- A client application only needs to create this structure if the server requires that the client provide a certificate as part of the process of negotiating the secure session. If a certificate is required, note that it must have a private key associated with it. Attempting to use a certificate that does not have a private key will result in an error during the connection process indicating that the client credentials could not be established.
- If you are using a local certificate store, with the certificate and private key stored in the registry, you can explicitly specify whether the certificate store for the current user or the local machine (all users) should be used. This is done by prefixing the certificate store name with "HKCU:" for the current user, or "HKLM:" for the local machine. For example, a certificate store name of "HKLM:MY" would specify the personal certificate store for the local machine, rather than the current user. If neither prefix is specified, then it will default to the certificate store for the current user. You can manage these certificates using the CertMgr.msc Microsoft Management Console (MMC) snap-in.
- It is possible to load the certificate from a file rather than from current user's certificate store. The dwOptions member should be set to CREDENTIAL_STORE_FILENAME and the lpszCertStore member should specify the name of the file that contains the certificate and its private key. The file must be in Private Information Exchange (PFX) format, also known as PKCS #12. These certificate files typically have an extension of .pfx or .p12. Note that if a password was specified when the certificate file was created, it must be provided in the lpszPassword member or the library will be unable to access the certificate.
- Note that the lpszUserName and lpszPassword members are values which are used to access the certificate store or private key file. They are not the credentials which are used when establishing the connection with the remote host or authenticating the client session.
- The lpszKeyFile path can use environment variables enclosed in percent symbols, and the path to the private key file will be normalized. It is recommended you always use an absolute path to the private key file. If you do not include a path, it will use the current working directory for the process. This can produce inconsistent results with multithreaded applications because the current working directory for a process is a global value and it can be changed by any thread at any time.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

---

## SECURITYINFO Structure

The SECURITYINFO structure contains security related information about the connection, including the protocol, cipher suite and certificate.

### Definition

```c
typedef struct _SECURITYINFO
{
    DWORD dwSize;
    DWORD dwProtocol;
    DWORD dwCipher;
    DWORD dwCipherStrength;
    DWORD dwHash;
    DWORD dwHashStrength;
    DWORD dwKeyExchange;
    DWORD dwCertStatus;
    SYSTEMTIME stCertIssued;
    SYSTEMTIME stCertExpires;
    LPCTSTR lpszCertIssuer;
    LPCTSTR lpszCertSubject;
    LPCTSTR lpszFingerprint;
} SECURITYINFO, *LPSECURITYINFO;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | Specifies the size of the data structure. This member must always be initialized to the size of the structure in bytes prior to passing the address of this structure to the function. If this this member is not initialized, an error will be returned indicating that an invalid parameter has been passed to the function. |
| `dwProtocol` | `DWORD` | A numeric value which specifies the security protocol selected when establishing the connection. |
| `dwCipher` | `DWORD` | A numeric value which specifies the cipher that was selected when establishing the secure connection. |
| `dwCipherStrength` | `DWORD` | A numeric value which specifies the strength (the length of the cipher key in bits) of the cipher that was selected. Typically this value will be 128 or 256. 40-bit and 56-bit key lengths are considered weak encryption, and subject to brute force attacks. 128-bit and 256-bit key lengths are considered to be secure, and are the recommended key length for secure communications. |
| `dwHash` | `DWORD` | A numeric value which specifies the hash algorithm which was selected. |
| `dwHashStrength` | `DWORD` | A numeric value which specifies the strength (the length in bits) of the message digest that was selected. |
| `dwKeyExchange` | `DWORD` | A numeric value which specifies the key exchange algorithm which was selected. |
| `dwCertStatus` | `DWORD` | A numeric value which specifies the status of the certificate returned by the secure server. |
| `stCertIssued` | `SYSTEMTIME` | A structure which contains the date and time that the certificate was issued by the certificate authority. If the issue date cannot be determined for the certificate, the SYSTEMTIME structure members will have zero values. This member only has meaning for connections using the TLS protocol. |
| `stCertExpires` | `SYSTEMTIME` | A structure which contains the date and time that the certificate expires. If the expiration date cannot be determined for the certificate, the SYSTEMTIME structure members will have zero values. |
| `lpszCertIssuer` | `LPCTSTR` | A pointer to a string which contains information about the organization that issued the certificate. This string consists of one or more comma-separated tokens. Each token consists of an identifier, followed by an equal sign and a value. If the certificate issuer could not be determined, this member may be NULL. This member only has meaning for connections using the TLS protocol. |
| `lpszCertSubject` | `LPCTSTR` | A pointer to a string which contains information about the organization that the certificate was issued to. This string consists of one or more comma-separated tokens. Each token consists of an identifier, followed by an equal sign and a value. If the certificate subject could not be determined, this member may be NULL. This member only has meaning for connections using the TLS protocol. |
| `lpszFingerprint` | `LPCTSTR` | A pointer to a string which contains a sequence of hexadecimal values that uniquely identify the server. This member may be NULL. |

### Remarks

- The size of this structure is typically determined using the sizeof operator in C/C++ and most other languages have a similar method for obtaining the size of a data structure or user-defined type. It is important to note the size of this structure will be different on 32-bit and 64-bit platforms due to the difference in the length of the structure members which are pointers.
- When evaluating structure members which are string pointers, such as lpszCertIssuer and lpszCertSubject, you should always check to ensure their values are not NULL (zero) before attempting to dereference them. If those values are undefined, it is not guaranteed they will point to zero-length strings.
- There are additional protocols and ciphers defined which are not listed above because they are considered insecure and are no longer supported. It is important to note that most servers will reject attempts to use unsupported protocols such as SSL 3.0 and will either abort the connection or issue an error message and then immediately disconnect.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

