# Hypertext Transfer Protocol Client

## Functions

- [HttpAddFormField](#httpaddformfield-function)
- [HttpAddFormFile](#httpaddformfile-function)
- [HttpAddQueuedFile](#httpaddqueuedfile-function)
- [HttpAddQueuedFileEx](#httpaddqueuedfileex-function)
- [HttpAddRequestHeaders](#httpaddrequestheaders-function)
- [HttpAsyncConnect](#httpasyncconnect-function)
- [HttpAsyncGetData](#httpasyncgetdata-function)
- [HttpAsyncGetFile](#httpasyncgetfile-function)
- [HttpAsyncGetFileEx](#httpasyncgetfileex-function)
- [HttpAsyncPostData](#httpasyncpostdata-function)
- [HttpAsyncPostJson](#httpasyncpostjson-function)
- [HttpAsyncPostXml](#httpasyncpostxml-function)
- [HttpAsyncProxyConnect](#httpasyncproxyconnect-function)
- [HttpAsyncPutData](#httpasyncputdata-function)
- [HttpAsyncPutFile](#httpasyncputfile-function)
- [HttpAsyncPutFileEx](#httpasyncputfileex-function)
- [HttpAsyncSubmitForm](#httpasyncsubmitform-function)
- [HttpAttachThread](#httpattachthread-function)
- [HttpAuthenticate](#httpauthenticate-function)
- [HttpCancel](#httpcancel-function)
- [HttpCancelQueuedFile](#httpcancelqueuedfile-function)
- [HttpClearForm](#httpclearform-function)
- [HttpClearHeaders](#httpclearheaders-function)
- [HttpClearQueue](#httpclearqueue-function)
- [HttpCloseFile](#httpclosefile-function)
- [HttpCommand](#httpcommand-function)
- [HttpConnect](#httpconnect-function)
- [HttpConnectUrl](#httpconnecturl-function)
- [HttpCreateFile](#httpcreatefile-function)
- [HttpCreateForm](#httpcreateform-function)
- [HttpCreateQueue](#httpcreatequeue-function)
- [HttpCreateSecurityCredentials](#httpcreatesecuritycredentials-function)
- [HttpDeleteFile](#httpdeletefile-function)
- [HttpDeleteFormField](#httpdeleteformfield-function)
- [HttpDeleteHeaders](#httpdeleteheaders-function)
- [HttpDeleteQueue](#httpdeletequeue-function)
- [HttpDeleteSecurityCredentials](#httpdeletesecuritycredentials-function)
- [HttpDestroyForm](#httpdestroyform-function)
- [HttpDisableEvents](#httpdisableevents-function)
- [HttpDisableTrace](#httpdisabletrace-function)
- [HttpDisconnect](#httpdisconnect-function)
- [HttpDownloadFile](#httpdownloadfile-function)
- [HttpEnableCompression](#httpenablecompression-function)
- [HttpEnableEvents](#httpenableevents-function)
- [HttpEnableTrace](#httpenabletrace-function)
- [HttpEnumQueuedFiles](#httpenumqueuedfiles-function)
- [HttpEnumTasks](#httpenumtasks-function)
- [HttpEventProc](#httpeventproc-function)
- [HttpFindQueuedFile](#httpfindqueuedfile-function)
- [HttpFreezeEvents](#httpfreezeevents-function)
- [HttpGetBearerToken](#httpgetbearertoken-function)
- [HttpGetContentLength](#httpgetcontentlength-function)
- [HttpGetContentType](#httpgetcontenttype-function)
- [HttpGetCookie](#httpgetcookie-function)
- [HttpGetData](#httpgetdata-function)
- [HttpGetDefaultUserAgent](#httpgetdefaultuseragent-function)
- [HttpGetEncodingType](#httpgetencodingtype-function)
- [HttpGetErrorString](#httpgeterrorstring-function)
- [HttpGetFile](#httpgetfile-function)
- [HttpGetFileEx](#httpgetfileex-function)
- [HttpGetFileSize](#httpgetfilesize-function)
- [HttpGetFileSizeEx](#httpgetfilesizeex-function)
- [HttpGetFileTime](#httpgetfiletime-function)
- [HttpGetFirstCookie](#httpgetfirstcookie-function)
- [HttpGetFirstHeader](#httpgetfirstheader-function)
- [HttpGetFirstQueuedFile](#httpgetfirstqueuedfile-function)
- [HttpGetFormProperties](#httpgetformproperties-function)
- [HttpGetLastError](#httpgetlasterror-function)
- [HttpGetNextCookie](#httpgetnextcookie-function)
- [HttpGetNextHeader](#httpgetnextheader-function)
- [HttpGetNextQueuedFile](#httpgetnextqueuedfile-function)
- [HttpGetOption](#httpgetoption-function)
- [HttpGetPriority](#httpgetpriority-function)
- [HttpGetQueueClient](#httpgetqueueclient-function)
- [HttpGetQueuedFile](#httpgetqueuedfile-function)
- [HttpGetQueueStatus](#httpgetqueuestatus-function)
- [HttpGetQueueThread](#httpgetqueuethread-function)
- [HttpGetRedirectUrl](#httpgetredirecturl-function)
- [HttpGetRequestHeader](#httpgetrequestheader-function)
- [HttpGetResourceUrl](#httpgetresourceurl-function)
- [HttpGetResponseHeader](#httpgetresponseheader-function)
- [HttpGetResultCode](#httpgetresultcode-function)
- [HttpGetResultString](#httpgetresultstring-function)
- [HttpGetSecurityInformation](#httpgetsecurityinformation-function)
- [HttpGetStatus](#httpgetstatus-function)
- [HttpGetTaskError](#httpgettaskerror-function)
- [HttpGetTaskId](#httpgettaskid-function)
- [HttpGetText](#httpgettext-function)
- [HttpGetTextEx](#httpgettextex-function)
- [HttpGetThreadQueue](#httpgetthreadqueue-function)
- [HttpGetTimeout](#httpgettimeout-function)
- [HttpGetTransferStatus](#httpgettransferstatus-function)
- [HttpInitialize](#httpinitialize-function)
- [HttpIsBlocking](#httpisblocking-function)
- [HttpIsConnected](#httpisconnected-function)
- [HttpIsReadable](#httpisreadable-function)
- [HttpIsWritable](#httpiswritable-function)
- [HttpOpenFile](#httpopenfile-function)
- [HttpPatchData](#httppatchdata-function)
- [HttpPostData](#httppostdata-function)
- [HttpPostFile](#httppostfile-function)
- [HttpPostJson](#httppostjson-function)
- [HttpPostXml](#httppostxml-function)
- [HttpProxyConnect](#httpproxyconnect-function)
- [HttpPutData](#httpputdata-function)
- [HttpPutDataEx](#httpputdataex-function)
- [HttpPutFile](#httpputfile-function)
- [HttpPutFileEx](#httpputfileex-function)
- [HttpPutText](#httpputtext-function)
- [HttpPutTextEx](#httpputtextex-function)
- [HttpRead](#httpread-function)
- [HttpRegisterEvent](#httpregisterevent-function)
- [HttpRemoveQueuedFile](#httpremovequeuedfile-function)
- [HttpResetQueue](#httpresetqueue-function)
- [HttpResumeQueue](#httpresumequeue-function)
- [HttpSetBearerToken](#httpsetbearertoken-function)
- [HttpSetContentType](#httpsetcontenttype-function)
- [HttpSetCookie](#httpsetcookie-function)
- [HttpSetDefaultUserAgent](#httpsetdefaultuseragent-function)
- [HttpSetEncodingType](#httpsetencodingtype-function)
- [HttpSetFormProperties](#httpsetformproperties-function)
- [HttpSetLastError](#httpsetlasterror-function)
- [HttpSetOption](#httpsetoption-function)
- [HttpSetPriority](#httpsetpriority-function)
- [HttpSetRequestHeader](#httpsetrequestheader-function)
- [HttpSetTimeout](#httpsettimeout-function)
- [HttpStartQueue](#httpstartqueue-function)
- [HttpStopQueue](#httpstopqueue-function)
- [HttpSubmitForm](#httpsubmitform-function)
- [HttpSubmitRequest](#httpsubmitrequest-function)
- [HttpSuspendQueue](#httpsuspendqueue-function)
- [HttpTaskAbort](#httptaskabort-function)
- [HttpTaskDone](#httptaskdone-function)
- [HttpTaskResume](#httptaskresume-function)
- [HttpTaskSuspend](#httptasksuspend-function)
- [HttpTaskWait](#httptaskwait-function)
- [HttpUninitialize](#httpuninitialize-function)
- [HttpUploadFile](#httpuploadfile-function)
- [HttpValidateHostName](#httpvalidatehostname-function)
- [HttpValidateUrl](#httpvalidateurl-function)
- [HttpVerifyFile](#httpverifyfile-function)
- [HttpWaitForQueue](#httpwaitforqueue-function)
- [HttpWrite](#httpwrite-function)
## Structures

- [HTTPCONNECTION](#httpconnection-structure)
- [HTTPFORMPROPERTIES](#httpformproperties-structure)
- [HTTPQUEUEDFILE](#httpqueuedfile-structure)
- [HTTPQUEUESTATUS](#httpqueuestatus-structure)
- [HTTPTRANSFERSTATUS](#httptransferstatus-structure)
- [HTTPTRANSFERSTATUSEX](#httptransferstatusex-structure)
- [INITDATA](#initdata-structure)
- [SECURITYCREDENTIALS](#securitycredentials-structure)
- [SECURITYINFO](#securityinfo-structure)

---

## HttpAddFormField Function

Add the form field and its value to the specified form

### Prototype

```c
INT WINAPI HttpAddFormField(
    HFORM hForm,
    LPCTSTR lpszFieldName,
    LPVOID lpFieldData,
    DWORD cbFieldData,
    DWORD dwReserved
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hForm` | `HFORM` | Handle to the virtual form. |
| `lpszFieldName` | `LPCTSTR` | A pointer to a string which specifies the name of the field to add to the form. If this parameter is NULL or points to an empty string, then a default field name will be assigned. |
| `lpFieldData` | `LPVOID` | A pointer to the form field data. Typically this will either by a pointer to an array of bytes or a string which specifies the value for the form field. If no data is to be associated with the form field, then this argument may be NULL. |
| `cbFieldData` | `DWORD` | An unsigned integer value which specifies the number of bytes of data in the form field. If this value is 0xFFFFFFFF (-1) then it is assumed that the lpFieldData parameter is a pointer to a null-terminated string. If lpFieldData is NULL, this value must be zero. |
| `dwReserved` | `DWORD` | A reserved parameter. This value must be zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpAddFormField function is used to add a field and its associated value to a form created using the HttpCreateForm function. If the field name has already been added to the form, the previous value is deleted and replaced by the new value.

### Example

```cpp
HFORM hForm = INVALID_FORM;
HGLOBAL hgblResult = (HGLOBAL)NULL;
DWORD cbResult = 0;
INT nResult = 0;

hForm = HttpCreateForm(_T("/login.php"), HTTP_METHOD_POST, HTTP_FORM_ENCODED);

if (hForm == INVALID_FORM)
	return;

HttpAddFormField(hForm, _T("UserName"), lpszUserName, (DWORD)-1L, 0);
HttpAddFormField(hForm, _T("Password"), lpszPassword, (DWORD)-1L, 0);

nResult = HttpSubmitForm(hClient, hForm, &hgblResult, &cbResult, 0);
HttpDestroyForm(hForm);

if (hgblResult != NULL)
{
	LPBYTE lpBuffer = (LPBYTE)GlobalLock(hgblResult);

	// lpBuffer points to data returned by the server after the form
	// data was submitted

	GlobalUnlock(hgblResult);
	GlobalFree(hgblResult);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddFormFile](#httpaddformfile-function)
- [HttpClearForm](#httpclearform-function)
- [HttpCreateForm](#httpcreateform-function)
- [HttpDeleteFormField](#httpdeleteformfield-function)
- [HttpSubmitForm](#httpsubmitform-function)

---

## HttpAddFormFile Function

Add the contents of the file to the specified form

### Prototype

```c
INT WINAPI HttpAddFormFile(
    HFORM hForm,
    LPCTSTR lpszFieldName,
    LPCTSTR lpszFileName,
    DWORD dwReserved
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hForm` | `HFORM` | Handle to the virtual form. |
| `lpszFieldName` | `LPCTSTR` | A pointer to a string which specifies the name of the field to add to the form. If this parameter is NULL or points to an empty string, then a default field name will be assigned. |
| `lpszFileName` | `LPCTSTR` | A pointer to a string which specifies the name of the file. The contents of the file will be added to the form data that is submitted to the server. |
| `dwReserved` | `DWORD` | A reserved parameter. This value must be zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddFormField](#httpaddformfield-function)
- [HttpClearForm](#httpclearform-function)
- [HttpCreateForm](#httpcreateform-function)
- [HttpDeleteFormField](#httpdeleteformfield-function)
- [HttpPostFile](#httppostfile-function)
- [HttpSubmitForm](#httpsubmitform-function)

---

## HttpAddQueuedFile Function

Add a new file to the queue to be uploaded or downloaded

### Prototype

```c
DWORD WINAPI HttpAddQueuedFile(
    HQUEUE hQueue,
    DWORD dwQueueMode,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    UINT nTimeout
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `dwQueueMode` | `DWORD` | An integer value which specifies if the file should be downloaded from the server or uploaded to the server. This parameter must be one of the following options and cannot have a value of zero. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the local file to be queued for transfer. This parameter cannot be NULL or point to an empty string. If the file is being queued for an upload, the file must exist on the local system or the function will fail. If the file is being downloaded, it will be created or replaced on the local system. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a null terminated string which specifies the URL to the location of the file on the server. The URL must follow the conventions for the File Transfer Protocol and may specify either a standard or secure connection, alternate port number, username, password and optional working directory. |
| `dwOptions` | `DWORD` | An unsigned integer value which specifies one or more options. This parameter is constructed by using a bitwise operator and can be any of the options used with the HttpConnect function. If this value is zero, the default options for the queue will be used. The most common options are: |
| `nTimeout` | `UINT` | The number of seconds to wait for a response from the server before failing the file transfer. If this value is zero, the default timeout period for the queue will be used. |

### Options

- **dwQueueMode** Parameter

    - `HTTP_QUEUE_DOWNLOAD`: The file should be queued for downloading from the server to the local system.
    - `HTTP_QUEUE_UPLOAD`: The file should be queued for uploading from the local system to the server.
- **dwOptions** Parameter

    - `HTTP_OPTION_DEFAULT`: Default options should be used for the queued transfer. All standard headers will be included with the request and redirected resources will return an error, allowing the application to determine if it should request the resource from the new location or inform the user the resource location has changed.
    - `HTTP_OPTION_REDIRECT`: This option specifies the client should automatically handle resource redirection. If the server indicates that the requested resource has moved to a new location, the client will close the current connection and request the resource from the new location. Note that it is possible that the redirected resource will be located on a different server.
    - `HTTP_OPTION_PROXY`: This option specifies the client should use the default proxy configuration for the local system. If the system is configured to use a proxy server, then the connection will be automatically established through that proxy; otherwise, a direct connection to the server is established. The local proxy configuration can be changed in the system settings or control panel.
    - `HTTP_OPTION_HTTP2`: This option specifies the client should attempt a HTTP/2 connection with the server. If a connection cannot be established using HTTP/2 the client will attempt to connect using an earlier version of the protocol.
    - `HTTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. Note that the server must support secure connections using the TLS protocol. The client will default to using TLS 1.2 or later for secure connections.

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is a unique identifier which corresponds to the queued file. If the function fails, the return value is zero. To get extended error information, call HttpGetLastError.

### Remarks

- This function will add a file to the current transfer queue. If successful, the value returned is a unique integer which identifies that file in the queue. To obtain information about the queued file, you can call the HttpGetQueuedFile function and provide this return value as the dwFileId parameter. To remove a file from the queue, use the HttpRemoveQueuedFile function.
- Files can only be added to the queue when in an idle or paused state. If you attempt to add a file to the queue while the queue manager is transferring files, the function will fail. To determine the current state of the queue, call the HttpGetQueueStatus function
- There are no fixed limits to the number of files which can be queued for transfer. To release the memory allocated for the queue, call the HttpClearQueue function. To determine the current status of the queue, including how many file transfers have been queued and how many are pending completion, call the HttpGetQueueStatus function.
- If the local file name includes environment variables enclosed in percentage (%) symbols, those values will automatically be expanded based on the environment variables defined for the current user using the ExpandEnvironmentStrings function in the Windows API. Note that environment variable names are not case-sensitive.
- This function will not immediately begin the process of uploading or downloading the file. It will only add the transfer request to the current queue. The file transfers are managed by a background worker thread which is created when the HttpStartQueue function is called.
- The HttpAddQueuedFileEx function is an extended version of this function with additional parameters to specify a hostname, port number, user name and password. Because most file uploads require authentication, using the extended function may be preferred to composing a URL which includes the account credentials.

### Example

```cpp
// Create a new queue
HQUEUE hQueue = HttpCreateQueue(INFINITE, HTTP_TIMEOUT, HTTP_OPTION_DEFAULT);

if (hQueue == INVALID_QUEUE)
	return;

// Add a file to the queue
DWORD dwFileId = HttpAddQueuedFile(
					hQueue,
					lpszLocalFile,
					lpszRemoteFile,
					HTTP_OPTION_DEFAULT,
					HTTP_TIMEOUT);

// Display information about the queued file
if (dwFileId != 0)
{
	HTTPQUEUEDFILE queuedFile;

	if (HttpGetQueuedFile(hQueue, dwFileId, &queuedFile))
	{
		switch (queuedFile.dwMode)
		{
		case HTTP_QUEUE_DOWNLOAD:
			_tprintf(_T("%u: Download \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szRemoteFile,
						queuedFile.szLocalFile);
				break;

		case HTTP_QUEUE_UPLOAD:
			_tprintf(_T("%u: Upload \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szLocalFile,
						queuedFile.szRemoteFile);
				break;
		}
	}
}

// Start the queued file transfers and wait for it to complete
if (HttpStartQueue(hQueue, HTTP_QUEUE_ALL, 0, NULL, 0))
{
	HttpWaitForQueue(hQueue, INFINITE, &dwElapsed, &dwError);
	HttpStopQueue(hQueue);
}

// Remove all files from the queue
HttpDeleteQueue(hQueue);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddQueuedFileEx](#httpaddqueuedfileex-function)
- [HttpCreateQueue](#httpcreatequeue-function)
- [HttpDeleteQueue](#httpdeletequeue-function)
- [HttpFindQueuedFile](#httpfindqueuedfile-function)
- [HttpGetFirstQueuedFile](#httpgetfirstqueuedfile-function)
- [HttpGetNextQueuedFile](#httpgetnextqueuedfile-function)
- [HttpGetQueuedFile](#httpgetqueuedfile-function)
- [HttpRemoveQueuedFile](#httpremovequeuedfile-function)

---

## HttpAddQueuedFileEx Function

Add a new file to the queue with additional transfer options

### Prototype

```c
DWORD WINAPI HttpAddQueuedFileEx(
    HQUEUE hQueue,
    DWORD dwQueueMode,
    LPCTSTR lpszHostName,
    UINT nHostPort,
    UINT nAuthType,
    LPCTSTR lpszUserName,
    LPCTSTR lpszPassword,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    UINT nTimeout,
    LPVOID lpvReserved
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `dwQueueMode` | `DWORD` | An integer value which specifies if the file should be downloaded from the server or uploaded to the server. This parameter must be one of the following options and cannot have a value of zero. |
| `lpszHostName` | `LPCTSTR` | A pointer to the name of the server to establish a connection with. This may be a fully-qualified domain name or an IP address. If this parameter is NULL or points to an empty string, the lpszRemoteFile parameter must specify a complete URL which identifies the server as well as the path to the remote file. |
| `nHostPort` | `UINT` | The port number which should be used when establishing the connection. A value of zero specifies that the default port number should be used. For standard connections, the default port number is 80. For secure connections, the default port number is 443. If this parameter is zero and a URL is specified with the lpszRemoteFile parameter, the port number included in the URL will be used as the default value. |
| `nAuthType` | `UINT` | An unsigned integer value which specifies the method to be used when authenticating the client. The following values are supported: |
| `lpszUserName` | `LPCTSTR` | Points to a null terminated string which specifies the user name to be used to authenticate the connection. If this parameter is NULL or an empty string, no client credentials are provided. If the authentication type is HTTP_AUTH_BEARER, this parameter is ignored. |
| `lpszPassword` | `LPCTSTR` | Points to a null terminated string which specifies the password to be used to authenticate the current client session. This parameter may be NULL or an empty string if no password is required for the specified user, or if no username has been specified. If the authentication type is HTTP_AUTH_BEARER, this value must be the bearer token issued by the service provider. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the local file to be queued for transfer. This parameter cannot be NULL or point to an empty string. If the file is being queued for an upload, the file must exist on the local system or the function will fail. If the file is being downloaded, it will be created or replaced on the local system. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the file on the server. If the file is being downloaded, the file must exist on the server or the transfer will fail. If the file is being uploaded, the file will be created or replaced on the server. This parameter may specify a complete URL. Note that any values you specify as arguments to this function will override the values specified in the URL. If you want to use a URL as the remote file name, the lpszHostName parameter should be NULL and the nHostPort parameter should be zero. |
| `dwOptions` | `DWORD` | An unsigned integer value which specifies one or more options. This parameter is constructed by using a bitwise operator and can be any of the options used with the HttpConnect function. If this value is zero, the default options for the queue will be used. The most common options are: |
| `nTimeout` | `UINT` | The number of seconds to wait for a response from the server before failing the file transfer. If this value is zero, the default timeout period for the queue will be used. |
| `lpvReserved` | `LPVOID` | A reserved parameter which should always be NULL. |

### Options

- **dwQueueMode** Parameter

    - `HTTP_QUEUE_DOWNLOAD`: The file should be queued for downloading from the server to the local system.
    - `HTTP_QUEUE_UPLOAD`: The file should be queued for uploading from the local system to the server.
- **nAuthType** Parameter

    - `HTTP_AUTH_NONE`: No client authentication should be performed. The lpszUserName and lpszPassword parameters are ignored and current authentication settings are cleared.
    - `HTTP_AUTH_BASIC`: The Basic authentication scheme should be used. This option is supported by all servers that support at least version 1.0 of the protocol. The user credentials are not encrypted and Basic authentication should not be used over standard (non-secure) connections. Most web services which use Basic authentication require the connection to be secure.
    - `HTTP_AUTH_BEARER`: The Bearer authentication scheme should be used. This authentication method does not require a user name and the lpszPassword parameter must specify the OAuth 2.0 bearer token issued by the service provider. If the access token has expired, the request will fail with an authorization error.
- **dwOptions** Parameter

    - `HTTP_OPTION_DEFAULT`: Default options should be used for the queued transfer. All standard headers will be included with the request and redirected resources will return an error, allowing the application to determine if it should request the resource from the new location or inform the user the resource location has changed.
    - `HTTP_OPTION_REDIRECT`: This option specifies the client should automatically handle resource redirection. If the server indicates that the requested resource has moved to a new location, the client will close the current connection and request the resource from the new location. Note that it is possible that the redirected resource will be located on a different server.
    - `HTTP_OPTION_PROXY`: This option specifies the client should use the default proxy configuration for the local system. If the system is configured to use a proxy server, then the connection will be automatically established through that proxy; otherwise, a direct connection to the server is established. The local proxy configuration can be changed in the system settings or control panel.
    - `HTTP_OPTION_HTTP2`: This option specifies the client should attempt a HTTP/2 connection with the server. If a connection cannot be established using HTTP/2 the client will attempt to connect using an earlier version of the protocol.
    - `HTTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. Note that the server must support secure connections using the TLS protocol. The client will default to using TLS 1.2 or later for secure connections.

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is a unique identifier which corresponds to the queued file. If the function fails, the return value is zero. To get extended error information, call HttpGetLastError.

### Remarks

- This function will add a file to the current transfer queue. If successful, the value returned is a unique integer which identifies that file in the queue. To obtain information about the queued file, you can call the HttpGetQueuedFile function and provide this return value as the dwFileId parameter. To remove a file from the queue, use the HttpRemoveQueuedFile function.
- Files can only be added to the queue when in an idle or paused state. If you attempt to add a file to the queue while the queue manager is transferring files, the function will fail. To determine the current state of the queue, call the HttpGetQueueStatus function
- There are no fixed limits to the number of files which can be queued for transfer. To release the memory allocated for the queue, call the HttpClearQueue function. To determine the current status of the queue, including how many file transfers have been queued and how many are pending completion, call the HttpGetQueueStatus function.
- If the local file name includes environment variables enclosed in percentage (%) symbols, those values will automatically be expanded based on the environment variables defined for the current user using the ExpandEnvironmentStrings function in the Windows API. Note that environment variable names are not case-sensitive.
- This function will not immediately begin the process of uploading or downloading the file. It will only add the transfer request to the current queue. The file transfers are managed by a background worker thread which is created when the HttpStartQueue function is called.

### Example

```cpp
// Create a new queue
HQUEUE hQueue = HttpCreateQueue(INFINITE, HTTP_TIMEOUT, HTTP_OPTION_DEFAULT);

if (hQueue == INVALID_QUEUE)
	return;

// Add a file to the queue
DWORD dwFileId = HttpAddQueuedFileEx(
					hQueue,
					HTTP_QUEUE_DOWNLOAD,
					lpszHostName,
					HTTP_PORT_DEFAULT,
					HTTP_AUTH_DEFAULT,
					lpszUserName,
					lpszPassword,
					lpszLocalFile,
					lpszRemoteFile,
					HTTP_OPTION_DEFAULT,
					HTTP_TIMEOUT,
					NULL);

// Display information about the queued file
if (dwFileId != 0)
{
	HTTPQUEUEDFILE queuedFile;

	if (HttpGetQueuedFile(hQueue, dwFileId, &queuedFile))
	{
		switch (queuedFile.dwMode)
		{
		case HTTP_QUEUE_DOWNLOAD:
			_tprintf(_T("%u: Download \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szRemoteFile,
						queuedFile.szLocalFile);
				break;

		case HTTP_QUEUE_UPLOAD:
			_tprintf(_T("%u: Upload \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szLocalFile,
						queuedFile.szRemoteFile);
				break;
		}
	}
}

// Start the queued file transfers and wait for it to complete
if (HttpStartQueue(hQueue, HTTP_QUEUE_ALL, 0, NULL, 0))
{
	HttpWaitForQueue(hQueue, INFINITE, &dwElapsed, &dwError);
	HttpStopQueue(hQueue);
}

// Remove all files from the queue
HttpDeleteQueue(hQueue);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddQueuedFile](#httpaddqueuedfile-function)
- [HttpCreateQueue](#httpcreatequeue-function)
- [HttpDeleteQueue](#httpdeletequeue-function)
- [HttpFindQueuedFile](#httpfindqueuedfile-function)
- [HttpGetFirstQueuedFile](#httpgetfirstqueuedfile-function)
- [HttpGetNextQueuedFile](#httpgetnextqueuedfile-function)
- [HttpGetQueuedFile](#httpgetqueuedfile-function)
- [HttpRemoveQueuedFile](#httpremovequeuedfile-function)

---

## HttpAddRequestHeaders Function

Add one or more request headers for the current client session

### Prototype

```c
BOOL WINAPI HttpAddRequestHeaders(
    HCLIENT hClient,
    LPCTSTR lpszHeaderList
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszHeaderList` | `LPCTSTR` | Points to a null-terminated string which specifies one or more header values which should be set for the current client session. This parameter cannot be NULL. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the client handle is invalid, the function returns a value of zero. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpAddRequestHeaders function enables your application to set one or more header values by providing a list of name/value pairs separated by a colon. Multiple header values may be provided by separating them with a newline character. This function is similar to calling the HttpSetRequestHeader function for each value. When the list of header values is parsed, extraneous whitespace is ignored; however, if the header list contains invalid text (for example, a missing colon separating a header name from its value) the function will fail and an error will be returned.
- Exercise caution when providing a header list created directly from user input, such as a list of values input using a textbox control. Any header values which have been previously set by your application can be overridden by this function and may yield unpredictable results. If the service you are using requires a custom authorization header, such as an API token or other user credentials, allowing users to directly modify request header values this way can present a security risk.

### Example

```cpp
// Define a list of header values which should be included with the
// request submitted to the server
LPCTSTR lpszHeaderList = _T("X-API-Token: 99d2fe39-0246-4efa-98e0-4d775579fa5d\n") \
						_T("X-API-UserId: someuser@domain.tld\n") \
						_T("X-API-Version: 1.1\n")

if (!HttpAddRequestHeaders(hClient, lpszHeaderList))
{
	// Unable to add the headers for this client session
	return;
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetFirstHeader](#httpgetfirstheader-function)
- [HttpGetNextHeader](#httpgetnextheader-function)
- [HttpGetRequestHeader](#httpgetrequestheader-function)
- [HttpGetResponseHeader](#httpgetresponseheader-function)
- [HttpSetRequestHeader](#httpsetrequestheader-function)

---

## HttpAsyncConnect Function

Establish an asynchronous connection to the specified server

### Prototype

```c
HCLIENT WINAPI HttpAsyncConnect(
    LPCTSTR lpszRemoteHost,
    UINT nRemotePort,
    UINT nTimeout,
    DWORD dwOptions,
    DWORD dwVersion,
    LPSECURITYCREDENTIALS lpCredentials,
    HWND hEventWnd,
    UINT uEventMsg
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszRemoteHost` | `LPCTSTR` | A pointer to the name of the server to connect to. This may be a fully-qualified domain name or an IP address. |
| `nRemotePort` | `UINT` | The port number the server is listening on. A value of zero specifies that the default port number should be used. For standard connections, the default port number is 80. For secure connections, the default port number is 443. |
| `nTimeout` | `UINT` | The number of seconds that the client will wait for a response from the server before failing the current operation. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `dwVersion` | `DWORD` | The requested protocol version used when sending requests to the server. The high word should specify the major version, and the low word should specify the minor version number. The HTTPVERSION macro can be used to create a version value and the following values are defined: |
| `lpCredentials` | `LPSECURITYCREDENTIALS` | Pointer to credentials structure SECURITYCREDENTIALS. This parameter is only used if the HTTP_OPTION_SECURE option is specified for the connection. This parameter may be NULL, in which case no client credentials will be provided to the server. If client credentials are required, the fields dwSize, lpszCertStore, and lpszCertName must be defined, while other fields may be left undefined. Set dwSize to the size of the SECURITYCREDENTIALS structure. |
| `hEventWnd` | `HWND` | The handle to the event notification window. This window receives messages which notify the client of various asynchronous network events that occur. |
| `uEventMsg` | `UINT` | The message identifier that is used when an asynchronous network event occurs. This value should be greater than WM_USER as defined in the Windows header files. |

### Options

- **dwOptions** Parameter

    - `HTTP_OPTION_NOCACHE`: This instructs the server to not return a cached copy of the resource. When connected to an HTTP 1.0 or earlier server, this directive may be ignored.
    - `HTTP_OPTION_KEEPALIVE`: This instructs the server to maintain a persistent connection between requests. This can improve performance because it eliminates the need to establish a separate connection for each resource that is requested.
    - `HTTP_OPTION_REDIRECT`: This option specifies the client should automatically handle resource redirection. If the server indicates that the requested resource has moved to a new location, the client will close the current connection and request the resource from the new location. Note that it is possible that the redirected resource will be located on a different server.
    - `HTTP_OPTION_PROXY`: This option specifies the client should use the default proxy configuration for the local system. If the system is configured to use a proxy server, then the connection will be automatically established through that proxy; otherwise, a direct connection to the server is established. The local proxy configuration can be changed using the system Control Panel.
    - `HTTP_OPTION_ERRORDATA`: This option specifies the client should return the content of an error response from the server, rather than returning an error code. Note that this option will disable automatic resource redirection, and should not be used with HTTP_OPTION_REDIRECT.
    - `HTTP_OPTION_NOUSERAGENT`: This option specifies the client should not include a User-Agent header with any requests made during the session. The user agent is a string which is used to identify the client application to the server. An application can provide its own custom user agent value using the HttpSetRequestHeader function.
    - `HTTP_OPTION_HTTP2`: This option specifies the client should attempt a HTTP/2 connection with the server. If a connection cannot be established using HTTP/2 the client will attempt to connect using an earlier version of the protocol. The value of the dwVersion parameter will be ignored when this option is used.
    - `HTTP_OPTION_TUNNEL`: This option specifies that a tunneled TCP connection and/or port-forwarding is being used to establish the connection to the server. This changes the behavior of the client with regards to internal checks of the destination IP address and remote port number, default capability selection and how the connection is established.
    - `HTTP_OPTION_TRUSTEDSITE`: This option specifies the server is trusted. The server certificate will not be validated and the connection will always be permitted. This option only affects connections using the TLS protocol.
    - `HTTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. Note that the server must support secure connections using the TLS protocol. The client will default to using TLS 1.2 or later for secure connections.
    - `HTTP_OPTION_SECURE_FALLBACK`: This option specifies the client should permit the use of less secure cipher suites for compatibility with legacy servers. If this option is specified, the client will allow connections using TLS 1.0 and cipher suites that use RC4, MD5 and SHA1.
    - `HTTP_OPTION_PREFER_IPV6`: This option specifies the client should prefer the use of IPv6 if the server hostname can be resolved to both an IPv6 and IPv4 address. This option is ignored if the local system does not have IPv6 enabled, or when the hostname can only be resolved to an IPv4 address. If the server hostname can only be resolved to an IPv6 address, the client will attempt to establish a connection using IPv6 regardless if this option has been specified.
    - `HTTP_OPTION_FREETHREAD`: This option specifies the handle returned by this function may be used by any thread, and is not limited to the thread which created it. The application is responsible for ensuring that access to the handle is synchronized across multiple threads.
    - `HTTP_OPTION_HIRES_TIMER`: This option specifies the elapsed time for data transfers should be returned in milliseconds instead of seconds. This will return more accurate transfer times for smaller amounts of data over fast network connections.
- **dwVersion** Parameter

    - `HTTP_VERSION_DEFAULT`: The client should use the default protocol version for this session. This is the same as specifying HTTP_VERSION_11 and is recommended to ensure the broadest compatibility with most servers.
    - `HTTP_VERSION_09`: The client should use the original one-line protocol which includes no version number and no request header block. This version has been deprecated and should only be used with legacy servers which do not support the protocol standard. This version of the protocol does not support virtual hosts and is not supported by most modern web services.
    - `HTTP_VERSION_10`: The client should use the HTTP/1.0 protocol standard originally defined in RFC 1945. This version of the protocol supports the use of request header blocks, however it does not support persistent connections or chunked data and has limited cache control mechanisms.
    - `HTTP_VERSION_11`: The client should use the HTTP/1.1 protocol standard defined in RFC 2616 and RFC 7230. This is the most widely used version of the protocol and is the default for client connections. It is recommended most applications use this version.
    - `HTTP_VERSION_20`: The client should use the HTTP/2 protocol standard defined in RFC 7540. This protocol version is a significant change from previous versions and can provide improved performance with header compression and optimizing how requests are serviced. If the client or server does not support HTTP/2, the client will automatically attempt to use an earlier version of the protocol.

### Return Value

- **Type**: `HCLIENT`
- If the function succeeds, the return value is a handle to a client session. If the function fails, the return value is INVALID_CLIENT. To get extended error information, call HttpGetLastError.

### Remarks

- When a message is posted to the notification window, the low word of the lParam parameter contains the event identifier. The high word of lParam contains the low word of the error code, if an error has occurred. The wParam parameter contains the client handle. One or more of the following event identifiers may be sent:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAsyncProxyConnect](#httpasyncproxyconnect-function)
- [HttpConnect](#httpconnect-function)
- [HttpDisconnect](#httpdisconnect-function)
- [HttpInitialize](#httpinitialize-function)
- [HttpProxyConnect](#httpproxyconnect-function)

---

## HttpAsyncGetData Function

Copy the contents of a resource on the server to a local buffer

### Prototype

```c
UINT WINAPI HttpAsyncGetData(
    HCLIENT hClient,
    LPCTSTR lpszResource,
    LPVOID lpvBuffer,
    LPDWORD lpdwLength,
    DWORD dwOptions,
    HTTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResource` | `LPCTSTR` | A pointer to a string that specifies the resource on the server that will be transferred to the local system. |
| `lpvBuffer` | `LPVOID` | A pointer to a byte buffer which will contain the data transferred from the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpdwLength` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvBuffer parameter. If the lpvBuffer parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the actual length of the file that was downloaded. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `lpEventProc` | `HTTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the HttpEventProc callback function. This parameter may be NULL if you do not wish to implement an event handler. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. This parameter is ignored if the lpEventProc parameter is NULL. |

### Options

- **dwOptions** Parameter

    - `HTTP_TRANSFER_DEFAULT`: The default transfer mode. The resource data is copied to the local system exactly as it is stored on the server.
    - `HTTP_TRANSFER_CONVERT`: If the resource being downloaded from the server is textual, the data is automatically converted so that the end of line character sequence is compatible with the Windows platform. Individual carriage return or linefeed characters are converted to carriage return/linefeed character sequences.
    - `HTTP_TRANSFER_COMPRESS`: This option informs the server that the client is willing to accept compressed data. If the server supports compression for the specified resource, then the data will be automatically expanded before being returned to the caller. This option is selected by default if compression has been enabled using the HttpEnableCompression function.
    - `HTTP_TRANSFER_ERRORDATA`: This option causes the client to accept error data from the server if the request fails. If this option is specified, an error response from the server will not cause the function to fail. Instead, the response is returned to the client and the function will succeed.

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the function fails, the return value is zero. To get extended error information, call the HttpGetLastError function. The application should treat the task ID as an opaque value and never make an assumption about the sequence in which IDs are assigned to a background task.

### Remarks

- The HttpAsyncGetData function is used to download the contents of a server resource into a local buffer. This function is similar to the HttpGetData function, however it retrieves the contents of the file using a background worker thread and does not block the current working thread. This enables the application to continue to perform other operations while the file is being copied to the local system.
- Because this function works asynchronously, it is important that the memory allocated for the buffer is not released before the asynchronous task completes. If you provide a buffer that is allocated on the stack, such as with the example listed below, then you must ensure that your code does not return from the function while the data is being downloaded. In the example, this is achieved by calling the HttpTaskWait function. You can also perform other operation and poll the status of the task by calling the HttpTaskDone function. If you wish to return from the calling function immediately, then you must dynamically allocate memory for the lpvBuffer and lpdwLength parameters on the heap and free that memory after the task has completed and the data is no longer needed.
- If the address of an event handler is provided to this function, it is guaranteed that the handler will be invoked with the HTTP_EVENT_CONNECT event after the connection has been established, and the HTTP_EVENT_DISCONNECT event after the transfer has completed. This enables your application to know when the data transfer is about to begin, and immediately before the worker thread is terminated. The worker thread creates a secondary connection to the server with its own session handle. This ensures that the asynchronous operation will not interfere with the current client session. Your application can interact with this background worker thread using the client handle that is passed to the event handler.
- The lpvBuffer parameter may be specified in one of two ways, depending on the needs of the application. It can either be a pre-allocated buffer large enough to store the contents of the file or it can specify the address of a global memory handle that will contain the data. If it points to a pre-allocated buffer, the lpdwLength parameter must be initialized to the maximum number of bytes that can be copied into the buffer. If specifies the address of a global memory handle, then lpdwLength must be initialized to a value of zero. See the example code below.

### Example

```cpp
HGLOBAL hgblBuffer = NULL;
DWORD dwLength = 0;
UINT nTaskId;

// Copy the data into block of global memory allocated by
// the GlobalAlloc function; the handle to this memory will be
// returned in the hgblBuffer parameter

nTaskId = HttpAsyncGetData(hClient,
						lpszResource,
						&hgblBuffer,
						&dwLength,
						HTTP_TRANSFER_DEFAULT, 
						NULL, 0);

if (nTaskId != 0)
{
	DWORD dwError = NO_ERROR;
	DWORD dwElapsed = 0;

	// Wait for the transfer to complete
	HttpTaskWait(nTaskId, INFINTE, &dwElapsed, &dwError);

	// Lock the global memory handle, returning a pointer to the
	// contents of the file data
	lpBuffer = (LPBYTE)GlobalLock(hgblBuffer);
	
	// After the data has been used, the handle must be unlocked
	// and freed, otherwise a memory leak will occur
	GlobalUnlock(hgblBuffer);
	GlobalFree(hgblBuffer);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAsyncGetFile](#httpasyncgetfile-function)
- [HttpAsyncPutData](#httpasyncputdata-function)
- [HttpAsyncPutFile](#httpasyncputfile-function)
- [HttpEventProc](#httpeventproc-function)
- [HttpGetFile](#httpgetfile-function)
- [HttpTaskWait](#httptaskwait-function)

---

## HttpAsyncGetFile Function

Copy a file from the server to the local system

### Prototype

```c
UINT WINAPI HttpAsyncGetFile(
    HCLIENT hClient,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    DWORD dwOffset,
    HTTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file on the local system that will be created, overwritten or appended to. The file pathing and name conventions must be that of the local host. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be transferred to the local system. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter may be any one of the following values: |
| `dwOffset` | `DWORD` | A byte offset which specifies where the file transfer should begin. The default value of zero specifies that the file transfer should start at the beginning of the file. A value greater than zero is typically used to restart a transfer that has not completed successfully. Note that specifying a non-zero offset requires that the server support the REST command to restart transfers. |
| `lpEventProc` | `HTTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the HttpEventProc callback function. This parameter may be NULL if you do not wish to implement an event handler. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. This parameter is ignored if the lpEventProc parameter is NULL. |

### Options

- **dwOptions** Parameter

    - `HTTP_TRANSFER_DEFAULT`: The default transfer mode. The resource data is copied to the local system exactly as it is stored on the server.
    - `HTTP_TRANSFER_CONVERT`: If the resource being downloaded from the server is textual, the data is automatically converted so that the end of line character sequence is compatible with the Windows platform. Individual carriage return or linefeed characters are converted to carriage return/linefeed character sequences.
    - `HTTP_TRANSFER_COMPRESS`: This option informs the server that the client is willing to accept compressed data. If the server supports compression for the specified resource, then the data will be automatically expanded before being returned to the caller. This option is selected by default if compression has been enabled using the HttpEnableCompression function. This option is ignored if the dwOffset parameter is non-zero.

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the function fails, the return value is zero. To get extended error information, call the HttpGetLastError function. The application should treat the task ID as an opaque value and never make an assumption about the sequence in which IDs are assigned to a background task.

### Remarks

- The HttpAsyncGetFile function is used to download the contents of a remote file to a file on the local system. This function is similar to the HttpGetFile function, however it retrieves the file using a background worker thread and does not block the current working thread. This enables the application to continue to perform other operations while the file is being transferred to the local system.
- If the address of an event handler is provided to this function, it is guaranteed that the handler will be invoked with the HTTP_EVENT_CONNECT event after the connection has been established, and the HTTP_EVENT_DISCONNECT event after the transfer has completed. This enables your application to know when the file transfer is about to begin, and immediately before the worker thread is terminated. During the file transfer, the callback function will be invoked periodically with the HTTP_EVENT_PROGRESS event. The client session handle is passed to the event handler, allowing you to call functions such as HttpGetTransferStatus to determine the amount of data that has been copied.
- To determine when the transfer has completed without implementing an event handler, periodically call the HttpTaskDone function. If you wish to block the current thread and wait for the transfer to complete, call the HttpTaskWait function. To stop a background file transfer that is in progress, call the HttpTaskAbort function. This will signal the background worker thread to cancel the transfer and terminate the session.
- This function can be called multiple times to download multiple files in the background; however, most servers limit the number of simultaneous connections that can originate from a single IP address. It is recommended that you only perform two simultaneous background transfers from the same server at any one time. The application should not make any assumptions about the order in which multiple background transfers may complete or how they are sequenced. For example, it should never be assumed that a background task with a lower task ID will complete before a task with a higher ID value.

### Example

```cpp
UINT nTaskId;

// Begin a file transfer in the background

nTaskId = HttpAsyncGetFile(hClient,
						lpszLocalFile,
						lpszRemoteFile,
						HTTP_TRANSFER_DEFAULT,
						0, NULL, 0);

if (nTaskId != 0)
{
	DWORD dwError = NO_ERROR;
	DWORD dwElapsed = 0;

	// Wait for the transfer to complete
	HttpTaskWait(nTaskId, INFINTE, &dwElapsed, &dwError);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAsyncGetData](#httpasyncgetdata-function)
- [HttpAsyncPutData](#httpasyncputdata-function)
- [HttpAsyncPutFile](#httpasyncputfile-function)
- [HttpEventProc](#httpeventproc-function)
- [HttpGetFile](#httpgetfile-function)
- [HttpTaskDone](#httptaskdone-function)
- [HttpTaskWait](#httptaskwait-function)

---

## HttpAsyncGetFileEx Function

Copy a file from the server to the local system, use with files larger than 4GB

### Prototype

```c
UINT WINAPI HttpAsyncGetFileEx(
    HCLIENT hClient,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    ULARGE_INTEGER uiOffset,
    HTTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file on the local system that will be created, overwritten or appended to. The file pathing and name conventions must be that of the local host. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be transferred to the local system. The file naming conventions must be that of the host operating system. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter may be any one of the following values: |
| `uiOffset` | `ULARGE_INTEGER` | A byte offset which specifies where the file transfer should begin. The default value of zero specifies that the file transfer should start at the beginning of the file. A value greater than zero is typically used to restart a transfer that has not completed successfully. Note that specifying a non-zero offset requires that the server support the REST command to restart transfers. |
| `lpEventProc` | `HTTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the HttpEventProc callback function. This parameter may be NULL if you do not wish to implement an event handler. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. This parameter is ignored if the lpEventProc parameter is NULL. |

### Options

- **dwOptions** Parameter

    - `HTTP_TRANSFER_DEFAULT`: The default transfer mode. The resource data is copied to the local system exactly as it is stored on the server.
    - `HTTP_TRANSFER_CONVERT`: If the resource being downloaded from the server is textual, the data is automatically converted so that the end of line character sequence is compatible with the Windows platform. Individual carriage return or linefeed characters are converted to carriage return/linefeed character sequences.
    - `HTTP_TRANSFER_COMPRESS`: This option informs the server that the client is willing to accept compressed data. If the server supports compression for the specified resource, then the data will be automatically expanded before being returned to the caller. This option is selected by default if compression has been enabled using the HttpEnableCompression function. This option is ignored if the dwOffset parameter is non-zero.

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the function fails, the return value is zero. To get extended error information, call the HttpGetLastError function. The application should treat the task ID as an opaque value and never make an assumption about the sequence in which IDs are assigned to a background task.

### Remarks

- The HttpAsyncGetFileEx function is used to download the contents of a remote file to a file on the local system. This function is similar to the HttpGetFileEx function, however it retrieves the file using a background worker thread and does not block the current working thread. This enables the application to continue to perform other operations while the file is being transferred to the local system.
- If the address of an event handler is provided to this function, it is guaranteed that the handler will be invoked with the HTTP_EVENT_CONNECT event after the connection has been established, and the HTTP_EVENT_DISCONNECT event after the transfer has completed. This enables your application to know when the file transfer is about to begin, and immediately before the worker thread is terminated. During the file transfer, the callback function will be invoked periodically with the HTTP_EVENT_PROGRESS event. The client session handle is passed to the event handler, allowing you to call functions such as HttpGetTransferStatusEx to determine the amount of data that has been copied.
- To determine when the transfer has completed without implementing an event handler, periodically call the HttpTaskDone function. If you wish to block the current thread and wait for the transfer to complete, call the HttpTaskWait function. To stop a background file transfer that is in progress, call the HttpTaskAbort function. This will signal the background worker thread to cancel the transfer and terminate the session.
- This function can be called multiple times to download multiple files in the background; however, most servers limit the number of simultaneous connections that can originate from a single IP address. It is recommended that you only perform two simultaneous background transfers from the same server at any one time. The application should not make any assumptions about the order in which multiple background transfers may complete or how they are sequenced. For example, it should never be assumed that a background task with a lower task ID will complete before a task with a higher ID value.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAsyncPutFileEx](#httpasyncputfileex-function)
- [HttpEventProc](#httpeventproc-function)
- [HttpGetFileEx](#httpgetfileex-function)
- [HttpPutFileEx](#httpputfileex-function)
- [HttpTaskDone](#httptaskdone-function)
- [HttpTaskWait](#httptaskwait-function)

---

## HttpAsyncPostData Function

Post data from a local buffer to a script executed on the server

### Prototype

```c
UINT WINAPI HttpAsyncPostData(
    HCLIENT hClient,
    LPCTSTR lpszResource,
    LPVOID lpvBuffer,
    DWORD cbBuffer,
    LPVOID lpvResult,
    LPDWORD lpcbResult,
    DWORD dwOptions,
    HTTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResource` | `LPCTSTR` | A pointer to a string that specifies the resource that the data will be posted to on the server. Typically this is the name of a script that will be executed. This string may specify a valid URL for the current server that the client is connected to. |
| `lpvBuffer` | `LPVOID` | A pointer to the data that will be provided to the script. This parameter may be NULL if the script does not require any additional data from the client. |
| `cbBuffer` | `DWORD` | The number of bytes to copy from the buffer. If this lpvBuffer parameter is NULL, this value should be zero. |
| `lpvResult` | `LPVOID` | A pointer to a byte buffer which will contain the data returned by the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpcbResult` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvBuffer parameter. If the lpvResult parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the actual number of bytes of data that was returned. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `lpEventProc` | `HTTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the HttpEventProc callback function. This parameter may be NULL if you do not wish to implement an event handler. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. This parameter is ignored if the lpEventProc parameter is NULL. |

### Options

- **dwOptions** Parameter

    - `HTTP_POST_DEFAULT`: The default post mode. The contents of the buffer are encoded and sent as standard form data. The data returned by the server is copied to the result buffer exactly as it is returned from the server.
    - `HTTP_POST_CONVERT`: If the data being returned from the server is textual, it is automatically converted so that the end of line character sequence is compatible with the Windows platform. Individual carriage return or linefeed characters are converted to carriage return/linefeed character sequences. Note that this option does not have any effect on the form data being submitted to the server, only on the data returned by the server.
    - `HTTP_POST_MULTIPART`: The contents of the buffer being sent to the server consists of multipart form data and will be sent as-is without any encoding.
    - `HTTP_POST_ERRORDATA`: This option causes the client to accept error data from the server if the request fails. If this option is specified, an error response from the server will not cause the function to fail. Instead, the response is returned to the client and the function will succeed.

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the function fails, the return value is zero. To get extended error information, call the HttpGetLastError function. The application should treat the task ID as an opaque value and never make an assumption about the sequence in which IDs are assigned to a background task.

### Remarks

- The HttpAsyncPostData function is used to submit data to a script that executes on the server and then copy the output from that script into a local buffer. This function is similar to the HttpPostData function, however it submits the data using a background worker thread and does not block the current working thread. This enables the application to continue to perform other operations while the data is being sent and the response from the server is being returned to the caller.
- Because this function works asynchronously, it is important that the memory allocated for the lpvBuffer and lpvResult parameters will not be released before the asynchronous task completes. If you provide pointers to memory that is allocated on the stack, ensure that your code does not return from the function until the background task completes. This can be achieved by calling the HttpTaskWait function or periodically calling the HttpTaskDone function to determine if the operation has completed. If you wish to return from the calling function immediately, then you must dynamically allocate memory on the heap and free that memory after the task has completed and the data is no longer needed.
- If the address of an event handler is provided to this function, it is guaranteed that the handler will be invoked with the HTTP_EVENT_CONNECT event after the connection has been established, and the HTTP_EVENT_DISCONNECT event after the transfer has completed. This enables your application to know when the file transfer is about to begin, and immediately before the worker thread is terminated.
- The lpvResult parameter may be specified in one of two ways, depending on the needs of the application. It can either be a pre-allocated buffer large enough to store the contents of the server response or it can specify the address of a global memory handle that will contain the data. If it points to a pre-allocated buffer, the lpcbResult parameter must be initialized to the maximum number of bytes that can be copied into the buffer. If specifies the address of a global memory handle, then lpcbResult must be initialized to a value of zero. See the example code below.
- If you wish to submit XML formatted data to the server, it is recommended that you use the HttpAsyncPostXml function instead.

### Example

```cpp
HGLOBAL hgblBuffer = (HGLOBAL)NULL;
LPBYTE lpBuffer = (LPBYTE)NULL;
DWORD cbBuffer = 0;
UINT nTaskId;

// Store the script output into block of global memory allocated by
// the GlobalAlloc function; the handle to this memory will be
// returned in the hgblBuffer parameter. Since the output from the
// script is textual, the HTTP_POST_CONVERT option is used

nTaskId = HttpAsyncPostData(hClient,
							lpszResource,
							lpParameters,
							cbParameters,
							&hgblBuffer,
							&cbBuffer,
							HTTP_POST_CONVERT,
							NULL, 0);

if (nTaskId != 0)
{
	DWORD dwError = NO_ERROR;
	DWORD dwElapsed = 0;

	// Wait for the task to complete
	HttpTaskWait(nTaskId, INFINTE, &dwElapsed, &dwError);

	// Lock the global memory handle, returning a pointer to the
	// output data from the script
	lpBuffer = (LPBYTE)GlobalLock(hgblBuffer);
	
	// After the data has been used, the handle must be unlocked
	// and freed, otherwise a memory leak will occur
	GlobalUnlock(hgblBuffer);
	GlobalFree(hgblBuffer);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAsyncGetData](#httpasyncgetdata-function)
- [HttpAsyncPostJson](#httpasyncpostjson-function)
- [HttpAsyncPostXml](#httpasyncpostxml-function)
- [HttpEventProc](#httpeventproc-function)
- [HttpPostData](#httppostdata-function)
- [HttpTaskWait](#httptaskwait-function)

---

## HttpAsyncPostJson Function

Post JSON formatted data to a script executed on the server

### Prototype

```c
UINT WINAPI HttpAsyncPostJson(
    HCLIENT hClient,
    LPCTSTR lpszResource,
    LPCTSTR lpszJsonData,
    LPVOID lpvResult,
    LPDWORD lpcbResult,
    DWORD dwOptions,
    HTTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResource` | `LPCTSTR` | A pointer to a string that specifies the resource name that the JSON data will be submitted to. Typically this is the name of a script on the server. |
| `lpszJsonData` | `LPCTSTR` | A pointer to a string that specifies the JSON data that will be submitted to the server. |
| `lpvResult` | `LPVOID` | A pointer to a byte buffer which will contain the data returned by the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpcbResult` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvBuffer parameter. If the lpvResult parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the actual number of bytes of data that was returned. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `lpEventProc` | `HTTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the HttpEventProc callback function. This parameter may be NULL if you do not wish to implement an event handler. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. This parameter is ignored if the lpEventProc parameter is NULL. |

### Options

- **dwOptions** Parameter

    - `HTTP_POST_DEFAULT`: The default post mode. The contents of the buffer are encoded and sent as standard form data. The data returned by the server is copied to the result buffer exactly as it is returned from the server.
    - `HTTP_POST_CONVERT`: If the data being returned from the server is textual, it is automatically converted so that the end of line character sequence is compatible with the Windows platform. Individual carriage return or linefeed characters are converted to carriage return/linefeed character sequences. Note that this option does not have any effect on the form data being submitted to the server, only on the data returned by the server.
    - `HTTP_POST_ERRORDATA`: This option causes the client to accept error data from the server if the request fails. If this option is specified, an error response from the server will not cause the function to fail. Instead, the response is returned to the client and the function will succeed.

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the function fails, the return value is zero. To get extended error information, call the HttpGetLastError function. The application should treat the task ID as an opaque value and never make an assumption about the sequence in which IDs are assigned to a background task.

### Remarks

- The HttpAsyncPostJson function is used to submit JSON formatted data to a script that executes on the server and then copy the output from that script into a local buffer. It automatically sets the correct content type and encoding required for submitting JSON data to a server, however it does not parse the JSON data itself to ensure that it is well-formed. Your application is responsible for ensuring that the JSON data that is being submitted to the server is formatted correctly. This function is similar to the HttpPostJson function, however it submits the data using a background worker thread and does not block the current working thread.
- Because this function works asynchronously, it is important that the memory allocated for the lpszJsonData and lpvResult parameters will not be released before the asynchronous task completes. If you provide pointers to memory that is allocated on the stack, ensure that your code does not return from the function until the background task completes. This can be achieved by calling the HttpTaskWait function or periodically calling the HttpTaskDone function to determine if the operation has completed. If you wish to return from the calling function immediately, then you must dynamically allocate memory on the heap and free that memory after the task has completed and the data is no longer needed.
- If the address of an event handler is provided to this function, it is guaranteed that the handler will be invoked with the HTTP_EVENT_CONNECT event after the connection has been established, and the HTTP_EVENT_DISCONNECT event after the transfer has completed. This enables your application to know when the file transfer is about to begin, and immediately before the worker thread is terminated.
- The lpvResult parameter may be specified in one of two ways, depending on the needs of the application. It can either be a pre-allocated buffer large enough to store the contents of the server response or it can specify the address of a global memory handle that will contain the data. If it points to a pre-allocated buffer, the lpcbResult parameter must be initialized to the maximum number of bytes that can be copied into the buffer. If specifies the address of a global memory handle, then lpcbResult must be initialized to a value of zero. See the example code below.

### Example

```cpp
HGLOBAL hgblBuffer = (HGLOBAL)NULL;
LPBYTE lpBuffer = (LPBYTE)NULL;
DWORD cbBuffer = 0;
UINT nTaskId;

// Store the script output into block of global memory allocated by
// the GlobalAlloc function; the handle to this memory will be
// returned in the hgblBuffer parameter. Since the output from the
// script is textual, the HTTP_POST_CONVERT option is used

nTaskId = HttpAsyncPostJson(hClient,
						lpszResource,
						lpszJsonData,
						&hgblBuffer,
						&cbBuffer,
						HTTP_POST_CONVERT,
						NULL, 0);

if (nTaskId != 0)
{
	DWORD dwError = NO_ERROR;
	DWORD dwElapsed = 0;

	// Wait for the task to complete
	HttpTaskWait(nTaskId, INFINTE, &dwElapsed, &dwError);

	// Lock the global memory handle, returning a pointer to the
	// output data from the script
	lpBuffer = (LPBYTE)GlobalLock(hgblBuffer);
	
	// After the data has been used, the handle must be unlocked
	// and freed, otherwise a memory leak will occur
	GlobalUnlock(hgblBuffer);
	GlobalFree(hgblBuffer);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAsyncGetData](#httpasyncgetdata-function)
- [HttpAsyncPostData](#httpasyncpostdata-function)
- [HttpEventProc](#httpeventproc-function)
- [HttpPostJson](#httppostjson-function)
- [HttpTaskWait](#httptaskwait-function)

---

## HttpAsyncPostXml Function

Post XML formatted data to a script executed on the server

### Prototype

```c
UINT WINAPI HttpAsyncPostXml(
    HCLIENT hClient,
    LPCTSTR lpszResource,
    LPCTSTR lpszXmlData,
    LPVOID lpvResult,
    LPDWORD lpcbResult,
    DWORD dwOptions,
    HTTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResource` | `LPCTSTR` | A pointer to a string that specifies the resource name that the XML data will be submitted to. Typically this is the name of a script on the server. |
| `lpszXmlData` | `LPCTSTR` | A pointer to a string that specifies the XML data that will be submitted to the server. |
| `lpvResult` | `LPVOID` | A pointer to a byte buffer which will contain the data returned by the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpcbResult` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvBuffer parameter. If the lpvResult parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the actual number of bytes of data that was returned. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `lpEventProc` | `HTTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the HttpEventProc callback function. This parameter may be NULL if you do not wish to implement an event handler. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. This parameter is ignored if the lpEventProc parameter is NULL. |

### Options

- **dwOptions** Parameter

    - `HTTP_POST_DEFAULT`: The default post mode. The contents of the buffer are encoded and sent as standard form data. The data returned by the server is copied to the result buffer exactly as it is returned from the server.
    - `HTTP_POST_CONVERT`: If the data being returned from the server is textual, it is automatically converted so that the end of line character sequence is compatible with the Windows platform. Individual carriage return or linefeed characters are converted to carriage return/linefeed character sequences. Note that this option does not have any effect on the form data being submitted to the server, only on the data returned by the server.
    - `HTTP_POST_ERRORDATA`: This option causes the client to accept error data from the server if the request fails. If this option is specified, an error response from the server will not cause the function to fail. Instead, the response is returned to the client and the function will succeed.

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the function fails, the return value is zero. To get extended error information, call the HttpGetLastError function. The application should treat the task ID as an opaque value and never make an assumption about the sequence in which IDs are assigned to a background task.

### Remarks

- The HttpAsyncPostXml function is used to submit XML formatted data to a script that executes on the server and then copy the output from that script into a local buffer. It automatically sets the correct content type and encoding required for submitting XML data to a server, however it does not parse the XML data itself to ensure that it is well-formed. Your application is responsible for ensuring that the XML data that is being submitted to the server is formatted correctly. This function is similar to the HttpPostXml function, however it submits the data using a background worker thread and does not block the current working thread.
- Because this function works asynchronously, it is important that the memory allocated for the lpszXmlData and lpvResult parameters will not be released before the asynchronous task completes. If you provide pointers to memory that is allocated on the stack, ensure that your code does not return from the function until the background task completes. This can be achieved by calling the HttpTaskWait function or periodically calling the HttpTaskDone function to determine if the operation has completed. If you wish to return from the calling function immediately, then you must dynamically allocate memory on the heap and free that memory after the task has completed and the data is no longer needed.
- If the address of an event handler is provided to this function, it is guaranteed that the handler will be invoked with the HTTP_EVENT_CONNECT event after the connection has been established, and the HTTP_EVENT_DISCONNECT event after the transfer has completed. This enables your application to know when the file transfer is about to begin, and immediately before the worker thread is terminated.
- The lpvResult parameter may be specified in one of two ways, depending on the needs of the application. It can either be a pre-allocated buffer large enough to store the contents of the server response or it can specify the address of a global memory handle that will contain the data. If it points to a pre-allocated buffer, the lpcbResult parameter must be initialized to the maximum number of bytes that can be copied into the buffer. If specifies the address of a global memory handle, then lpcbResult must be initialized to a value of zero. See the example code below.

### Example

```cpp
HGLOBAL hgblBuffer = (HGLOBAL)NULL;
LPBYTE lpBuffer = (LPBYTE)NULL;
DWORD cbBuffer = 0;
UINT nTaskId;

// Store the script output into block of global memory allocated by
// the GlobalAlloc function; the handle to this memory will be
// returned in the hgblBuffer parameter. Since the output from the
// script is textual, the HTTP_POST_CONVERT option is used

nTaskId = HttpAsyncPostXml(hClient,
						lpszResource,
						lpszXmlData,
						&hgblBuffer,
						&cbBuffer,
						HTTP_POST_CONVERT,
						NULL, 0);

if (nTaskId != 0)
{
	DWORD dwError = NO_ERROR;
	DWORD dwElapsed = 0;

	// Wait for the task to complete
	HttpTaskWait(nTaskId, INFINTE, &dwElapsed, &dwError);

	// Lock the global memory handle, returning a pointer to the
	// output data from the script
	lpBuffer = (LPBYTE)GlobalLock(hgblBuffer);
	
	// After the data has been used, the handle must be unlocked
	// and freed, otherwise a memory leak will occur
	GlobalUnlock(hgblBuffer);
	GlobalFree(hgblBuffer);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAsyncGetData](#httpasyncgetdata-function)
- [HttpAsyncPostData](#httpasyncpostdata-function)
- [HttpEventProc](#httpeventproc-function)
- [HttpPostXml](#httppostxml-function)
- [HttpTaskWait](#httptaskwait-function)

---

## HttpAsyncProxyConnect Function

Establish an asynchronous connection to a proxy server

### Prototype

```c
HCLIENT WINAPI HttpAsyncProxyConnect(
    UINT nProxyType,
    LPCTSTR lpszProxyHost,
    UINT nProxyPort,
    LPCTSTR lpszProxyUser,
    LPCTSTR lpszProxyPassword,
    LPCTSTR lpszRemoteHost,
    UINT nRemotePort,
    UINT nTimeout,
    DWORD dwOptions,
    DWORD dwVersion,
    LPSECURITYCREDENTIALS lpCredentials,
    HWND hEventWnd,
    UINT uEventMsg
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nProxyType` | `UINT` | An unsigned integer which specifies the type of proxy that the client is connecting to. The supported proxy server types are as follows: |
| `lpszProxyHost` | `LPCTSTR` | A pointer to a string which specifies the proxy server host name or IP address. This argument is ignored if the proxy type is set to HTTP_PROXY_NONE or HTTP_PROXY_WINDOWS and no proxy configuration has been specified for the local system. |
| `nProxyPort` | `UINT` | The port number that the proxy server is listening for connections on. A value of zero specifies that the default port number 80 should be used. Note that in most cases, a proxy server is not configured to use the default port. This argument is ignored if the proxy type is set to HTTP_PROXY_NONE or HTTP_PROXY_WINDOWS and no proxy configuration has been specified for the local system. |
| `lpszProxyUser` | `LPCTSTR` | A pointer to a string which specifies the user name that will be used to authenticate the client session to the proxy server. If the server does not require user authentication, then a NULL pointer may be passed in this argument. |
| `lpszProxyPassword` | `LPCTSTR` | A pointer to a string which specifies the password that will be used to authenticate the client session to the proxy server. If the server does not require user authentication, then a NULL pointer may be passed in this argument. |
| `lpszRemoteHost` | `LPCTSTR` | A pointer to a string which specifies the name of the server to connect to through the proxy server. This may be a fully-qualified domain name or an IP address. |
| `nRemotePort` | `UINT` | The port number the server is listening on. A value of zero specifies that the default port number should be used. For standard connections, the default port number is 80. For secure connections, the default port number is 443. |
| `nTimeout` | `UINT` | The number of seconds that the client will wait for a response from the server before failing the current operation. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `dwVersion` | `DWORD` | The requested protocol version used when sending requests to the server. The high word should specify the major version, and the low word should specify the minor version number. The HTTPVERSION macro can be used to create a version value and the following values are defined: |
| `lpCredentials` | `LPSECURITYCREDENTIALS` | Pointer to credentials structure SECURITYCREDENTIALS. This parameter is only used if the HTTP_OPTION_SECURE option is specified for the connection. This parameter may be NULL, in which case no client credentials will be provided to the server. If client credentials are required, the fields dwSize, lpszCertStore, and lpszCertName must be defined, while other fields may be left undefined. Set dwSize to the size of the SECURITYCREDENTIALS structure. |
| `hEventWnd` | `HWND` | The handle to the event notification window. This window receives messages which notify the client of various asynchronous network events that occur. |
| `uEventMsg` | `UINT` | The message identifier that is used when an asynchronous network event occurs. This value should be greater than WM_USER as defined in the Windows header files. |

### Options

- **nProxyType** Parameter

    - `HTTP_PROXY_NONE`: A direct connection will be established with the server. When this value is specified the proxy parameters are ignored.
    - `HTTP_PROXY_STANDARD`: A standard connection is established through the specified proxy server, and all resource requests will be specified using a complete URL. This proxy type should be used with standard connections.
    - `HTTP_PROXY_SECURE`: A secure connection is established through the specified proxy server. This proxy type should be used with secure connections and the HTTP_OPTION_SECURE option should also be set via the dwOptions parameter.
    - `HTTP_PROXY_WINDOWS`: The configuration options for the current system should be used. If the system is configured to use a proxy server, then the connection will be automatically established through that proxy; otherwise, a direct connection to the server is established. These settings are the same proxy server settings configured in Windows.
- **dwOptions** Parameter

    - `HTTP_OPTION_NOCACHE`: This instructs the server to not return a cached copy of the resource. When connected to an HTTP 1.0 or earlier server, this directive may be ignored.
    - `HTTP_OPTION_KEEPALIVE`: This instructs the server to maintain a persistent connection between requests. This can improve performance because it eliminates the need to establish a separate connection for each resource that is requested.
    - `HTTP_OPTION_REDIRECT`: This option specifies the client should automatically handle resource redirection. If the server indicates that the requested resource has moved to a new location, the client will close the current connection and request the resource from the new location. Note that it is possible that the redirected resource will be located on a different server.
    - `HTTP_OPTION_ERRORDATA`: This option specifies the client should return the content of an error response from the server, rather than returning an error code. Note that this option will disable automatic resource redirection, and should not be used with HTTP_OPTION_REDIRECT.
    - `HTTP_OPTION_NOUSERAGENT`: This option specifies the client should not include a User-Agent header with any requests made during the session. The user agent is a string which is used to identify the client application to the server. An application can provide its own custom user agent value using the HttpSetRequestHeader function.
    - `HTTP_OPTION_HTTP2`: This option specifies the client should attempt a HTTP/2 connection with the server. If a connection cannot be established using HTTP/2 the client will attempt to connect using an earlier version of the protocol. The value of the dwVersion parameter will be ignored when this option is used.
    - `HTTP_OPTION_TUNNEL`: This option specifies that a tunneled TCP connection and/or port-forwarding is being used to establish the connection to the proxy server. This changes the behavior of the client with regards to internal checks of the destination IP address and remote port number, default capability selection and how the connection is established.
    - `HTTP_OPTION_TRUSTEDSITE`: This option specifies the server is trusted. The server certificate will not be validated and the connection will always be permitted. This option only affects connections using the TLS protocol.
    - `HTTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. Note that the server must support secure connections using the TLS protocol. The client will default to using TLS 1.2 or later for secure connections.
    - `HTTP_OPTION_SECURE_FALLBACK`: This option specifies the client should permit the use of less secure cipher suites for compatibility with legacy servers. If this option is specified, the client will allow connections using TLS 1.0 and cipher suites that use RC4, MD5 and SHA1.
    - `HTTP_OPTION_PREFER_IPV6`: This option specifies the client should prefer the use of IPv6 if the server hostname can be resolved to both an IPv6 and IPv4 address. This option is ignored if the local system does not have IPv6 enabled, or when the hostname can only be resolved to an IPv4 address. If the server hostname can only be resolved to an IPv6 address, the client will attempt to establish a connection using IPv6 regardless if this option has been specified.
    - `HTTP_OPTION_FREETHREAD`: This option specifies the handle returned by this function may be used by any thread, and is not limited to the thread which created it. The application is responsible for ensuring that access to the handle is synchronized across multiple threads.
    - `HTTP_OPTION_HIRES_TIMER`: This option specifies the elapsed time for data transfers should be returned in milliseconds instead of seconds. This will return more accurate transfer times for smaller amounts of data over fast network connections.
- **dwVersion** Parameter

    - `HTTP_VERSION_DEFAULT`: The client should use the default protocol version for this session. This is the same as specifying HTTP_VERSION_11 and is recommended to ensure the broadest compatibility with most servers.
    - `HTTP_VERSION_09`: The client should use the original one-line protocol which includes no version number and no request header block. This version has been deprecated and should only be used with legacy servers which do not support the protocol standard. This version of the protocol does not support virtual hosts and is not supported by most modern web services.
    - `HTTP_VERSION_10`: The client should use the HTTP/1.0 protocol standard originally defined in RFC 1945. This version of the protocol supports the use of request header blocks, however it does not support persistent connections or chunked data and has limited cache control mechanisms.
    - `HTTP_VERSION_11`: The client should use the HTTP/1.1 protocol standard defined in RFC 2616 and RFC 7230. This is the most widely used version of the protocol and is the default for client connections. It is recommended most applications use this version.
    - `HTTP_VERSION_20`: The client should use the HTTP/2 protocol standard defined in RFC 7540. This protocol version is a significant change from previous versions and can provide improved performance with header compression and optimizing how requests are serviced. If the client or server does not support HTTP/2, the client will automatically attempt to use an earlier version of the protocol.

### Return Value

- **Type**: `HCLIENT`
- If the function succeeds, the return value is a handle to a client session. If the function fails, the return value is INVALID_CLIENT. To get extended error information, call HttpGetLastError.

### Remarks

- If the HTTP_PROXY_WINDOWS proxy type is specified, then the proxy configuration for the local system is used. If no proxy server has been defined, then the proxy-related parameters will be ignored and the function will establish a connection directly to the server.
- When a message is posted to the notification window, the low word of the lParam parameter contains the event identifier. The high word of lParam contains the low word of the error code, if an error has occurred. The wParam parameter contains the client handle. One or more of the following event identifiers may be sent:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAsyncConnect](#httpasyncconnect-function)
- [HttpConnect](#httpconnect-function)
- [HttpDisconnect](#httpdisconnect-function)
- [HttpInitialize](#httpinitialize-function)
- [HttpProxyConnect](#httpproxyconnect-function)

---

## HttpAsyncPutData Function

Create a file on the server using the contents of a local buffer

### Prototype

```c
UINT WINAPI HttpAsyncPutData(
    HCLIENT hClient,
    LPCTSTR lpszFileName,
    LPVOID lpvBuffer,
    DWORD dwLength,
    DWORD dwReserved,
    HTTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileName` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be created, overwritten or appended to. The file naming conventions must be that of the host operating system. |
| `lpvBuffer` | `LPVOID` | A pointer to the data that will be copied to the server and stored in the specified file. |
| `dwLength` | `DWORD` | The number of bytes to copy from the buffer. |
| `dwReserved` | `DWORD` | A reserved parameter. This value should always be zero. |
| `lpEventProc` | `HTTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the HttpEventProc callback function. This parameter may be NULL if you do not wish to implement an event handler. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. This parameter is ignored if the lpEventProc parameter is NULL. |

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the function fails, the return value is zero. To get extended error information, call the HttpGetLastError function. The application should treat the task ID as an opaque value and never make an assumption about the sequence in which IDs are assigned to a background task.

### Remarks

- The HttpAsyncPutData function is used to upload the contents of a local buffer to the server. This function is similar to the HttpPutData function, however it uses a background worker thread and does not block the current working thread. This enables the application to continue to perform other operations while the data is being sent to the server.
- Because this function works asynchronously, it is important that the memory allocated for the buffer is not released before the asynchronous task completes. If you provide a buffer that is allocated on the stack, ensure that your code does not return from the function while the data is being uploaded. This can be achieved by calling the HttpTaskWait function or periodically calling the HttpTaskDone function to determine if the transfer has completed. If you wish to return from the calling function immediately, then you must dynamically allocate memory for the lpvBuffer parameter on the heap and free that memory after the task has completed and the data is no longer needed.
- If the address of an event handler is provided to this function, it is guaranteed that the handler will be invoked with the HTTP_EVENT_CONNECT event after the connection has been established, and the HTTP_EVENT_DISCONNECT event after the transfer has completed. This enables your application to know when the data transfer is about to begin, and immediately before the worker thread is terminated. The worker thread creates a secondary connection to the server with its own session handle. This ensures that the asynchronous operation will not interfere with the current client session. Your application can interact with this background worker thread using the client handle that is passed to the event handler.
- If the lpvBuffer parameter is pointing to a Unicode string, it is important to note that the value of the dwLength parameter should specify the number of bytes, not the number of characters. When using UTF-16, each character is two bytes long and therefore the length of the buffer is effectively double the length of the string. Because Unicode strings can contain null characters, you must also set the current file type to FILE_TYPE_IMAGE prior to calling this function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAsyncGetData](#httpasyncgetdata-function)
- [HttpAsyncGetFile](#httpasyncgetfile-function)
- [HttpAsyncPutFile](#httpasyncputfile-function)
- [HttpEventProc](#httpeventproc-function)
- [HttpPutData](#httpputdata-function)
- [HttpTaskWait](#httptaskwait-function)

---

## HttpAsyncPutFile Function

Copy a file from the local system to the server

### Prototype

```c
UINT WINAPI HttpAsyncPutFile(
    HCLIENT hClient,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    DWORD dwOffset,
    HTTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file that will be transferred from the local system. The file pathing and name conventions must be that of the local host. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be created, overwritten or appended to. The file naming conventions must be that of the host operating system. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter may be any one of the following values: |
| `dwOffset` | `DWORD` | A byte offset which specifies where the file transfer should begin. The default value of zero specifies that the file transfer should start at the beginning of the file. A value greater than zero is typically used to restart a transfer that has not completed successfully. Note that specifying a non-zero offset requires that the server support the REST command to restart transfers. |
| `lpEventProc` | `HTTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the HttpEventProc callback function. This parameter may be NULL if you do not wish to implement an event handler. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. This parameter is ignored if the lpEventProc parameter is NULL. |

### Options

- **dwOptions** Parameter

    - `HTTP_TRANSFER_DEFAULT`: This option specifies the default transfer mode should be used. If the remote file exists, it will be overwritten with the contents of the uploaded file.

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the function fails, the return value is zero. To get extended error information, call the HttpGetLastError function. The application should treat the task ID as an opaque value and never make an assumption about the sequence in which IDs are assigned to a background task.

### Remarks

- The HttpAsyncPutFile function is used to upload the contents of a local file to the server. This function is similar to the HttpPutFile function, however it uploads the file using a background worker thread and does not block the current working thread. This enables the application to continue to perform other operations while the file is being transferred to the server.
- If the address of an event handler is provided to this function, it is guaranteed that the handler will be invoked with the HTTP_EVENT_CONNECT event after the connection has been established, and the HTTP_EVENT_DISCONNECT event after the transfer has completed. This enables your application to know when the file transfer is about to begin, and immediately before the worker thread is terminated. During the file transfer, the callback function will be invoked periodically with the HTTP_EVENT_PROGRESS event. The client session handle is passed to the event handler, allowing you to call functions such as HttpGetTransferStatus to determine the amount of data that has been copied.
- To determine when the transfer has completed without implementing an event handler, periodically call the HttpTaskDone function. If you wish to block the current thread and wait for the transfer to complete, call the HttpTaskWait function. To stop a background file transfer that is in progress, call the HttpTaskAbort function. This will signal the background worker thread to cancel the transfer and terminate the session.
- This function can be called multiple times to upload multiple files in the background; however, most servers limit the number of simultaneous connections that can originate from a single IP address. It is recommended that you only perform two simultaneous background transfers from the same server at any one time. The application should not make any assumptions about the order in which multiple background transfers may complete or how they are sequenced. For example, it should never be assumed that a background task with a lower task ID will complete before a task with a higher ID value.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAsyncGetData](#httpasyncgetdata-function)
- [HttpAsyncGetFile](#httpasyncgetfile-function)
- [HttpAsyncPutData](#httpasyncputdata-function)
- [HttpEventProc](#httpeventproc-function)
- [HttpPutFile](#httpputfile-function)
- [HttpTaskDone](#httptaskdone-function)
- [HttpTaskWait](#httptaskwait-function)

---

## HttpAsyncPutFileEx Function

Copy a file from the local system to the server, use with files larger than 4GB

### Prototype

```c
UINT WINAPI HttpAsyncPutFileEx(
    HCLIENT hClient,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    ULARGE_INTEGER uiOffset,
    HTTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file that will be transferred from the local system. The file pathing and name conventions must be that of the local host. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be created, overwritten or appended to. The file naming conventions must be that of the host operating system. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter may be any one of the following values: |
| `uiOffset` | `ULARGE_INTEGER` | A byte offset which specifies where the file transfer should begin. The default value of zero specifies that the file transfer should start at the beginning of the file. A value greater than zero is typically used to restart a transfer that has not completed successfully. Note that specifying a non-zero offset requires that the server support the REST command to restart transfers. |
| `lpEventProc` | `HTTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the HttpEventProc callback function. This parameter may be NULL if you do not wish to implement an event handler. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. This parameter is ignored if the lpEventProc parameter is NULL. |

### Options

- **dwOptions** Parameter

    - `HTTP_TRANSFER_DEFAULT`: This option specifies the default transfer mode should be used. If the remote file exists, it will be overwritten with the contents of the uploaded file.

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the function fails, the return value is zero. To get extended error information, call the HttpGetLastError function. The application should treat the task ID as an opaque value and never make an assumption about the sequence in which IDs are assigned to a background task.

### Remarks

- The HttpAsyncPutFileEx function is used to upload the contents of a local file to the server. This function is similar to the HttpPutFileEx function, however it uploads the file using a background worker thread and does not block the current working thread. This enables the application to continue to perform other operations while the file is being transferred to the server.
- If the address of an event handler is provided to this function, it is guaranteed that the handler will be invoked with the HTTP_EVENT_CONNECT event after the connection has been established, and the HTTP_EVENT_DISCONNECT event after the transfer has completed. This enables your application to know when the file transfer is about to begin, and immediately before the worker thread is terminated. During the file transfer, the callback function will be invoked periodically with the HTTP_EVENT_PROGRESS event. The client session handle is passed to the event handler, allowing you to call functions such as HttpGetTransferStatusEx to determine the amount of data that has been copied.
- To determine when the transfer has completed without implementing an event handler, periodically call the HttpTaskDone function. If you wish to block the current thread and wait for the transfer to complete, call the HttpTaskWait function. To stop a background file transfer that is in progress, call the HttpTaskAbort function. This will signal the background worker thread to cancel the transfer and terminate the session.
- This function can be called multiple times to upload multiple files in the background; however, most servers limit the number of simultaneous connections that can originate from a single IP address. It is recommended that you only perform two simultaneous background transfers from the same server at any one time. The application should not make any assumptions about the order in which multiple background transfers may complete or how they are sequenced. For example, it should never be assumed that a background task with a lower task ID will complete before a task with a higher ID value.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAsyncGetFileEx](#httpasyncgetfileex-function)
- [HttpEventProc](#httpeventproc-function)
- [HttpGetFileEx](#httpgetfileex-function)
- [HttpPutFileEx](#httpputfileex-function)
- [HttpTaskDone](#httptaskdone-function)
- [HttpTaskWait](#httptaskwait-function)

---

## HttpAsyncSubmitForm Function

Submit the specified form to the server for processing

### Prototype

```c
UINT WINAPI HttpAsyncSubmitForm(
    HCLIENT hClient,
    HFORM hForm,
    LPVOID lpvResult,
    LPDWORD lpcbResult,
    DWORD dwOptions,
    HTTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `hForm` | `HFORM` | Handle to the virtual form which contains the data to be submitted to the server. |
| `lpvResult` | `LPVOID` | A pointer to a byte buffer which will contain the data returned by the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpcbResult` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvBuffer parameter. If the lpvResult parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the actual number of bytes of data that was returned. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `lpEventProc` | `HTTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the HttpEventProc callback function. This parameter may be NULL if you do not wish to implement an event handler. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. This parameter is ignored if the lpEventProc parameter is NULL. |

### Options

- **dwOptions** Parameter

    - `HTTP_SUBMIT_DEFAULT`: The default post mode. The contents of the buffer are encoded and sent as standard form data. The data returned by the server is copied to the result buffer exactly as it is returned from the server.
    - `HTTP_SUBMIT_CONVERT`: If the data being returned from the server is textual, it is automatically converted so that the end of line character sequence is compatible with the Windows platform. Individual carriage return or linefeed characters are converted to carriage return/linefeed character sequences. Note that this option does not have any effect on the form data being submitted to the server, only on the data returned by the server.

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the function fails, the return value is zero. To get extended error information, call the HttpGetLastError function. The application should treat the task ID as an opaque value and never make an assumption about the sequence in which IDs are assigned to a background task.

### Remarks

- The HttpAsyncSubmitForm function is used to submit form data to a script that executes on the server and then copy the output from that script into a local buffer. This function is similar to the HttpSubmitForm function, however it submits the data using a background worker thread and does not block the current working thread. This enables the application to continue to perform other operations while the data is being sent and the response from the server is being returned to the caller.
- Because this function works asynchronously, it is important that the memory allocated for the lpvResult parameter will not be released before the asynchronous task completes. If you provide a buffer that is allocated on the stack, ensure that your code does not return from the function until the background task completes. This can be achieved by calling the HttpTaskWait function or periodically calling the HttpTaskDone function to determine if the operation has completed. If you wish to return from the calling function immediately, then you must dynamically allocate the buffer on the heap and free that memory after the task has completed and the data is no longer needed.
- Do not call the HttpDestroyForm function to release the memory allocated for the virtual form until the background task completes. Doing so may result in unpredictable behavior and could cause your application to terminate abnormally.
- If the address of an event handler is provided to this function, it is guaranteed that the handler will be invoked with the HTTP_EVENT_CONNECT event after the connection has been established, and the HTTP_EVENT_DISCONNECT event after the transfer has completed. This enables your application to know when the file transfer is about to begin, and immediately before the worker thread is terminated.
- The lpvResult parameter may be specified in one of two ways, depending on the needs of the application. It can either be a pre-allocated buffer large enough to store the contents of the server response or it can specify the address of a global memory handle that will contain the data. If it points to a pre-allocated buffer, the lpcbResult parameter must be initialized to the maximum number of bytes that can be copied into the buffer. If specifies the address of a global memory handle, then lpcbResult must be initialized to a value of zero. See the example code below.

### Example

```cpp
HFORM hForm = INVALID_FORM;
HGLOBAL hgblResult = (HGLOBAL)NULL;
DWORD cbResult = 0;
INT nResult = 0;
UINT nTaskId;

hForm = HttpCreateForm(_T("/login.php"), HTTP_METHOD_POST, HTTP_FORM_ENCODED);

if (hForm == INVALID_FORM)
	return;

HttpAddFormField(hForm, _T("UserName"), lpszUserName, (DWORD)-1L, 0);
HttpAddFormField(hForm, _T("Password"), lpszPassword, (DWORD)-1L, 0);

nTaskId = HttpAsyncSubmitForm(hClient, hForm, &hgblResult, &cbResult, 0);

if (nTaskId != 0)
{
	DWORD dwError = NO_ERROR;
	DWORD dwElapsed = 0;

	// Wait for the task to complete
	HttpTaskWait(nTaskId, INFINTE, &dwElapsed, &dwError);

	// Get a pointer to the data returned by the server
	LPBYTE lpBuffer = (LPBYTE)GlobalLock(hgblResult);

	// lpBuffer now points to data returned by the server after
	// the form data was submitted

	// Release the memory allocated for the buffer
	GlobalUnlock(hgblResult);
	GlobalFree(hgblResult);
}

// Release the memory allocated for the virtual form
HttpDestroyForm(hForm);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddFormField](#httpaddformfield-function)
- [HttpAddFormFile](#httpaddformfile-function)
- [HttpClearForm](#httpclearform-function)
- [HttpCreateForm](#httpcreateform-function)
- [HttpDeleteFormField](#httpdeleteformfield-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpAttachThread Function

Attach the specified client handle to another thread

### Prototype

```c
DWORD WINAPI HttpAttachThread(
    HCLIENT hClient,
    DWORD dwThreadId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `dwThreadId` | `DWORD` | The ID of the thread that will become the new owner of the handle. A value of zero specifies that the current thread should become the owner of the client handle. |

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is the thread ID of the previous owner. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- When a client handle is created, it is associated with the current thread that created it. Normally, if another thread attempts to perform an operation using that handle, an error is returned since it does not own the handle. This is used to ensure that other threads cannot interfere with an operation being performed by the owner thread. In some cases, it may be desirable for one thread in a client application to create the client handle, and then pass that handle to another worker thread. The HttpAttachThread function can be used to change the ownership of the handle to the new worker thread. By preserving the return value from the function, the original owner of the handle can be restored before the worker thread terminates.
- This function should be called by the new thread immediately after it has been created, and if the new thread does not release the handle itself, the ownership of the handle should be restored to the parent thread before it terminates. Under no circumstances should HttpAttachThread be used to forcibly release a handle allocated by another thread while a blocking operation is in progress. To cancel an operation, use the HttpCancel function and then release the handle after the blocking function exits and control is returned to the current thread.
- Note that the dwThreadId parameter is presumed to be a valid thread ID and no checks are performed to ensure that the thread actually exists. Specifying an invalid thread ID will orphan the handle until the HttpUninitialize function is called.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpConnect](#httpconnect-function)
- [HttpDisconnect](#httpdisconnect-function)
- [HttpUninitialize](#httpuninitialize-function)

---

## HttpAuthenticate Function

Specify authentication information for restricted resources

### Prototype

```c
INT WINAPI HttpAuthenticate(
    HCLIENT hClient,
    UINT nAuthType,
    LPCTSTR lpszUserName,
    LPCTSTR lpszPassword
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nAuthType` | `UINT` | An unsigned integer value which specifies the method to be used when authenticating the client. The following values are supported: |
| `lpszUserName` | `LPCTSTR` | A null terminated string which specifies the user name used to authenticate the client session. This parameter may be NULL or an empty string if a user name is not required for the specified authentication type. If the authentication type is HTTP_AUTH_BEARER, this parameter is ignored. |
| `lpszPassword` | `LPCTSTR` | A pointer to a string that specifies the password used to authenticate the client session. If the authentication type is HTTP_AUTH_BEARER, this value must be the bearer token issued by the service provider. |

### Options

- **nAuthType** Parameter

    - `HTTP_AUTH_NONE`: No client authentication should be performed. The lpszUserName and lpszPassword parameters are ignored and current authentication settings are cleared.
    - `HTTP_AUTH_BASIC`: The Basic authentication scheme should be used. This option is supported by all servers that support at least version 1.0 of the protocol. The user credentials are not encrypted and Basic authentication should not be used over standard (non-secure) connections. Most web services which use Basic authentication require the connection to be secure.
    - `HTTP_AUTH_BEARER`: The Bearer authentication scheme should be used. This authentication method does not require a user name and the lpszPassword parameter must specify the OAuth 2.0 bearer token issued by the service provider. If the access token has expired, the request will fail with an authorization error. This function will not automatically refresh an expired token.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- This function will set the Authorization request header for the client session using the credentials provided by the caller. This function will always override any custom Authorization header value that may have been previously set using the HttpSetRequestHeader function.
- If both the lpszUserName and lpszPassword parameters are NULL pointers or specify zero length strings, the current authentication type will always be set to HTTP_AUTH_NONE regardless of the value of the nAuthType parameter. This effectively clears the current user credentials for the client session.
- If the web service requires OAuth 2.0 authentication, it is recommended you use the HttpSetBearerToken function to specify the access token.

### Requirements

- Minimum Desktop Platform: Windows 7 (Service Pack 1)
- Minimum Server Platform: Windows Server 2008 R2 (Service Pack 1)
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpConnect](#httpconnect-function)
- [HttpSetBearerToken](#httpsetbearertoken-function)
- [HttpSetRequestHeader](#httpsetrequestheader-function)

---

## HttpCancel Function

Cancel the current blocking operation

### Prototype

```c
INT WINAPI HttpCancel(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- When the HttpCancel function is called, the blocking function will not immediately fail. An internal flag is set which causes the blocking operation to exit with an error. This means that the application cannot cancel an operation and immediately perform some other operation. Instead it must allow the calling stack to unwind, returning back to the blocking operation before making any further function calls.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpIsBlocking](#httpisblocking-function)

---

## HttpCancelQueuedFile Function

Cancel the queued file transfer

### Prototype

```c
BOOL WINAPI HttpCancelQueuedFile(
    HQUEUE hQueue,
    DWORD dwFileId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `dwFileId` | `DWORD` | An unsigned integer value which uniquely identifies the file in the queue. If this value is zero, the function will cancel the current file transfer in progress. If queue transfers have been suspended, this parameter cannot be zero. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, it will return zero. To get extended error information, call HttpGetLastError.

### Remarks

- When this function is called, the queued file transfer may not immediately stop. An internal flag is set which causes the file transfer to exit with an error and the queue manager will begin processing the next file in the queue. If the queue is in an idle state, this function will fail.
- It is permitted to call HttpCancelQueuedFile from within a queue event handler to cancel the current file transfer. In this case, the dwFileId parameter should be zero. If you specify a file which has not been transferred, it will be flagged as canceled and skipped by the queue manager when processing the queue. If you specify a file which has already been processed, this function will fail.
- A canceled file transfer is also considered a failed transfer. When you call HttpGetQueueStatus after a queued file transfer is canceled, the dwFailedFiles member of the HTTPQUEUESTATUS structure will be incremented to reflect this change. You can determine the status of an individual file transfer by calling the HttpGetQueuedFile function and checking the value of the dwQueueFlags member of the HTTPQUEUEDFILE structure.
- The HttpResetQueue function can be used to reset the state of previously canceled transfers.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpCancel](#httpcancel-function)
- [HttpGetQueuedFile](#httpgetqueuedfile-function)
- [HttpGetQueueStatus](#httpgetqueuestatus-function)
- [HttpResetQueue](#httpresetqueue-function)
- [HttpResumeQueue](#httpresumequeue-function)
- [HttpStartQueue](#httpstartqueue-function)
- [HttpSuspendQueue](#httpsuspendqueue-function)
- [HttpStopQueue](#httpstopqueue-function)

---

## HttpClearForm Function

Remove all defined fields from the specified form

### Prototype

```c
INT WINAPI HttpClearForm(
    HFORM hForm
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hForm` | `HFORM` | Handle to the virtual form. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpAddFormField](#httpaddformfield-function)
- [HttpAddFormFile](#httpaddformfile-function)
- [HttpCreateForm](#httpcreateform-function)
- [HttpDeleteFormField](#httpdeleteformfield-function)
- [HttpDestroyForm](#httpdestroyform-function)
- [HttpSubmitForm](#httpsubmitform-function)

---

## HttpClearHeaders Function

Resets the the current request and response headers to their default values

### Prototype

```c
INT WINAPI HttpClearHeaders(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, it will return HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpClearHeaders function removes all custom header values for the current client session and clears the response headers for the previous request. This function is useful when using persistent connections and you want to ensure that any custom header values from the previous request will not be included with subsequent requests made during the same session. Because this function clears all of the request headers for the client session, this means it will also remove any cookies which have been set using the HttpSetCookie function.
- This function will clear any authentication credentials or tokens specified for the current client session. If the next request you make requires authentication, you must provide those credentials again using the HttpAuthenticate or HttpSetBearerToken function.
- It is not necessary to use this function if the HTTP_OPTION_KEEPALIVE option was not specified when the connection was established. The headers for the previous request are automatically cleared when a new connection is established.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpAuthenticate](#httpauthenticate-function)
- [HttpConnect](#httpconnect-function)
- [HttpGetCookie](#httpgetcookie-function)
- [HttpGetResponseHeader](#httpgetresponseheader-function)
- [HttpSetBearerToken](#httpsetbearertoken-function)
- [HttpSetCookie](#httpsetcookie-function)
- [HttpSetRequestHeader](#httpsetrequestheader-function)

---

## HttpClearQueue Function

Remove all files from the current transfer queue

### Prototype

```c
BOOL WINAPI HttpClearQueue(
    HQUEUE hQueue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, it will return zero. To get extended error information, call HttpGetLastError.

### Remarks

- This function can only be called when the queue is in an idle state. An error will be returned if the function is called while the queue manager is paused or actively transferring files in the queue. To determine the current state of the queue, call the HttpGetQueueStatus function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpCancelQueuedFile](#httpcancelqueuedfile-function)
- [HttpGetQueueStatus](#httpgetqueuestatus-function)
- [HttpResetQueue](#httpresetqueue-function)
- [HttpResumeQueue](#httpresumequeue-function)
- [HttpStartQueue](#httpstartqueue-function)
- [HttpStopQueue](#httpstopqueue-function)
- [HttpSuspendQueue](#httpsuspendqueue-function)

---

## HttpCloseFile Function

Close the file opened on the server

### Prototype

```c
INT WINAPI HttpCloseFile(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- If the file is opened for writing, all buffered data is written to the server before the file is closed. This may cause the client to block until all of the data can be written. The client application should not perform any other action until the function returns.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpCommand](#httpcommand-function)
- [HttpGetData](#httpgetdata-function)
- [HttpGetFile](#httpgetfile-function)
- [HttpOpenFile](#httpopenfile-function)
- [HttpPutData](#httpputdata-function)
- [HttpPutFile](#httpputfile-function)

---

## HttpCommand Function

Send a command to the server

### Prototype

```c
INT WINAPI HttpCommand(
    HCLIENT hClient,
    LPCTSTR lpszCommand,
    LPCTSTR lpszResource,
    LPBYTE lpParameter,
    DWORD cbParameter,
    DWORD dwReserved
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszCommand` | `LPCTSTR` | A pointer to a string which specifies the command to be executed by the server. The following table lists the standard commands recognized by most HTTP servers. Other commands may also be used, such as those extensions used by WebDAV to edit and manage files on a server. |
| `lpszResource` | `LPCTSTR` | A pointer to a string which specifies the resource to be used with the command. This can be the name of a file, an executable script or any other valid resource name recognized by the server. Resource names must be absolute and include the complete path to the resource. |
| `lpParameter` | `LPBYTE` | A pointer to a byte array which contains data that is to be passed to the command as one or more parameters. Typically this is used to pass additional information to a script that executes on the server. The data is encoded according to the encoding type specified for the client session. If the resource does not require any parameters, this value should be NULL. |
| `cbParameter` | `DWORD` | Specifies the number of bytes stored in the parameter buffer. If the resource does not require any parameters, this value should be zero. |
| `dwReserved` | `DWORD` | A reserved parameter. This value should always be zero. |

### Options

- **lpszCommand** Parameter

    - `GET`: Return the contents of the specified resource. This command is recognized by all servers.
    - `HEAD`: Return only header information for the specified resource. This command is recognized by servers that support at least version 1.0 of the protocol.
    - `POST`: Post data to the specified resource. This command is recognized by servers that support at least version 1.0 of the protocol.
    - `PUT`: Create or replace the specified resource on the server. This command is recognized by servers that support at least version 1.0 of the protocol. Not all servers support this command.
    - `DELETE`: Delete the specified resource from the server. This command is recognized by servers that support at least version 1.1 of the protocol. Not all servers support this command.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the result code returned by the server. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- Not all servers support all of the listed commands, and some commands may require specific changes to the server configuration. In particular, the PUT and DELETE commands typically require that configuration changes be made by the site administrator. All servers will support the use of the GET command, and all servers that support at least version 1.0 of the protocol will support the POST command.
- If the lpszResource parameter specifies a path that contains reserved or restricted characters, such as a space, it will automatically be URL encoded by the library.
- It is permissible to include a query string in the resource name specified by the lpszResource parameter. Query strings begin with a question mark, and then are followed by one or more name/value pairs separated by an equal sign. For example, the following resource includes a query string:
- /cgi-bin/test.cgi?field1=value1&field2=value2
- In this case, the query string is "?field1=value1&field2=value2". If the query string contains reserved or restricted characters, such as spaces, then it will be automatically URL encoded prior to being sent to the server. If additional resource data is specified in the lpParameter argument along with a query string in the resource name, the action taken by the library depends on the command being sent. If the command is a POST or PUT command, then query string is included with command request to the server and the parameter data is sent separately. For example, if the POST command was used, the script running on the server would see that both query data and form data has been provided to it. However, if any other command is specified, the parameter data is simply appended to the query string.
- The lpParameter argument is used to pass additional information to the server when a resource is requested. This is most commonly used to provide information to scripts, similar to how arguments are used when executing a program from the command line. Unless the POST command is being executed, the data in the buffer will automatically be encoded using the current encoding mechanism specified for the client. By default, the data is URL encoded, which means that any spaces and non-printable characters are converted to printable characters before submitted to the server. The type of encoding that is performed can be set by calling the HttpSetEncodingType function. Although the default encoding is appropriate for most applications, those that submit XML formatted data may need to change the encoding type.
- Only one request may be in progress at one time for each client session. Use the HttpCloseFile function to terminate the request after all of the data has been read from the server.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpCloseFile](#httpclosefile-function)
- [HttpCreateFile](#httpcreatefile-function)
- [HttpGetData](#httpgetdata-function)
- [HttpGetFile](#httpgetfile-function)
- [HttpGetResultCode](#httpgetresultcode-function)
- [HttpGetResultString](#httpgetresultstring-function)
- [HttpOpenFile](#httpopenfile-function)
- [HttpPostData](#httppostdata-function)
- [HttpPutData](#httpputdata-function)
- [HttpPutFile](#httpputfile-function)

---

## HttpConnect Function

Connect to the specified server

### Prototype

```c
HCLIENT WINAPI HttpConnect(
    LPCTSTR lpszRemoteHost,
    UINT nRemotePort,
    UINT nTimeout,
    DWORD dwOptions,
    DWORD dwVersion,
    LPSECURITYCREDENTIALS lpCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszRemoteHost` | `LPCTSTR` | A pointer to the name of the server to connect to; this may be a fully-qualified domain name or an IP address. |
| `nRemotePort` | `UINT` | The port number the server is listening on; a value of zero specifies that the default port number should be used. For standard connections, the default port number is 80. For secure connections, the default port number is 443. |
| `nTimeout` | `UINT` | The number of seconds that the client will wait for a response from the server before failing the current operation. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `dwVersion` | `DWORD` | The requested protocol version used when sending requests to the server. The high word should specify the major version, and the low word should specify the minor version number. The HTTPVERSION macro can be used to create a version value, or the following values can be used: |
| `lpCredentials` | `LPSECURITYCREDENTIALS` | Pointer to credentials structure SECURITYCREDENTIALS. This parameter is only used if the HTTP_OPTION_SECURE option is specified for the connection. This parameter may be NULL, in which case no client credentials will be provided to the server. If client credentials are required, the fields dwSize, lpszCertStore, and lpszCertName must be defined, while other fields may be left undefined. Set dwSize to the size of the SECURITYCREDENTIALS structure. |

### Options

- **dwOptions** Parameter

    - `HTTP_OPTION_NOCACHE`: This instructs the server to not return a cached copy of the resource. When connected to an HTTP 1.0 or earlier server, this directive may be ignored.
    - `HTTP_OPTION_KEEPALIVE`: This instructs the server to maintain a persistent connection between requests. This can improve performance because it eliminates the need to establish a separate connection for each resource that is requested.
    - `HTTP_OPTION_REDIRECT`: This option specifies the client should automatically handle resource redirection. If the server indicates that the requested resource has moved to a new location, the client will close the current connection and request the resource from the new location. Note that it is possible that the redirected resource will be located on a different server.
    - `HTTP_OPTION_PROXY`: This option specifies the client should use the default proxy configuration for the local system. If the system is configured to use a proxy server, then the connection will be automatically established through that proxy; otherwise, a direct connection to the server is established. The local proxy configuration can be changed in the system settings or control panel.
    - `HTTP_OPTION_ERRORDATA`: This option specifies the client should return the content of an error response from the server, rather than returning an error code. Note that this option will disable automatic resource redirection, and should not be used with HTTP_OPTION_REDIRECT.
    - `HTTP_OPTION_NOUSERAGENT`: This option specifies the client should not include a User-Agent header with any requests made during the session. The user agent is a string which is used to identify the client application to the server. An application can provide its own custom user agent value using the HttpSetRequestHeader function.
    - `HTTP_OPTION_HTTP2`: This option specifies the client should attempt a HTTP/2 connection with the server. If a connection cannot be established using HTTP/2 the client will attempt to connect using an earlier version of the protocol. The value of the dwVersion parameter will be ignored when this option is used.
    - `HTTP_OPTION_TUNNEL`: This option specifies that a tunneled TCP connection and/or port-forwarding is being used to establish the connection to the server. This changes the behavior of the client with regards to internal checks of the destination IP address and remote port number, default capability selection and how the connection is established.
    - `HTTP_OPTION_TRUSTEDSITE`: This option specifies the server is trusted. The server certificate will not be validated and the connection will always be permitted. This option only affects connections using the TLS protocol.
    - `HTTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. Note that the server must support secure connections using the TLS protocol. The client will default to using TLS 1.2 or later for secure connections.
    - `HTTP_OPTION_SECURE_FALLBACK`: This option specifies the client should permit the use of less secure cipher suites for compatibility with legacy servers. If this option is specified, the client will allow connections using TLS 1.0 and cipher suites that use RC4, MD5 and SHA1.
    - `HTTP_OPTION_PREFER_IPV6`: This option specifies the client should prefer the use of IPv6 if the server hostname can be resolved to both an IPv6 and IPv4 address. This option is ignored if the local system does not have IPv6 enabled, or when the hostname can only be resolved to an IPv4 address. If the server hostname can only be resolved to an IPv6 address, the client will attempt to establish a connection using IPv6 regardless if this option has been specified.
    - `HTTP_OPTION_FREETHREAD`: This option specifies the handle returned by this function may be used by any thread, and is not limited to the thread which created it. The application is responsible for ensuring that access to the handle is synchronized across multiple threads.
    - `HTTP_OPTION_HIRES_TIMER`: This option specifies the elapsed time for data transfers should be returned in milliseconds instead of seconds. This will return more accurate transfer times for smaller amounts of data over fast network connections.
- **dwVersion** Parameter

    - `HTTP_VERSION_DEFAULT`: The client should use the default protocol version for this session. This is the same as specifying HTTP_VERSION_11 and is recommended to ensure the broadest compatibility with most servers.
    - `HTTP_VERSION_09`: The client should use the original one-line protocol which includes no version number and no request header block. This version has been deprecated and should only be used with legacy servers which do not support the protocol standard. This version of the protocol does not support virtual hosts and is not supported by most modern web services.
    - `HTTP_VERSION_10`: The client should use the HTTP/1.0 protocol standard originally defined in RFC 1945. This version of the protocol supports the use of request header blocks, however it does not support persistent connections or chunked data and has limited cache control mechanisms.
    - `HTTP_VERSION_11`: The client should use the HTTP/1.1 protocol standard defined in RFC 2616 and RFC 7230. This is the most widely used version of the protocol and is the default for client connections. It is recommended most applications use this version.
    - `HTTP_VERSION_20`: The client should use the HTTP/2 protocol standard defined in RFC 7540. This protocol version is a significant change from previous versions and can provide improved performance with header compression and optimizing how requests are serviced. If the client or server does not support HTTP/2, the client will automatically attempt to use an earlier version of the protocol.

### Return Value

- **Type**: `HCLIENT`
- If the function succeeds, the return value is a handle to a client session. If the function fails, the return value is INVALID_CLIENT. To get extended error information, call HttpGetLastError.

### Remarks

- This function will block the current thread until a connection has been established or the timeout period has elapsed. To prevent it from blocking the main user interface thread, the application should create a background worker thread and establish a connection by calling HttpConnect in that thread. If the application requires multiple simultaneous connections, it is recommended you create a worker thread for each connection.
- The dwOptions argument can be used to specify the threading model that is used by the library when a connection is established. By default, the handle is initially attached to the thread that created it. From that point on, until the it is released, only the owner may call functions using that handle. The ownership of the handle may be transferred from one thread to another using the HttpAttachThread function.
- Specifying the HTTP_OPTION_FREETHREAD option enables any thread to call any function using the handle, regardless of which thread created it. It is important to note that this option disables certain internal safety checks which are performed by the library and may result in unexpected behavior unless access to the handle is synchronized. If one thread calls a function in the library, it must ensure that no other thread will call another function at the same time using the same handle.
- If the HTTP_OPTION_KEEPALIVE option is specified and the server does not support persistent connections, the client will automatically attempt to reconnect when each resource is requested. Although it will not provide any performance benefits, this allows the option to be used with all servers. This option is automatically enabled when using HTTP/2.
- Under some circumstances, a server may forcibly close or abort a connection if the request fails. For example, this can happen when a malformed request is submitted to the server or a server-side error occurs. When this happens, the application will need to disconnect from the server and establish a new connection, even if the keep-alive option has been specified.
- Applications should use HTTP_VERSION_DEFAULT as the value for the dwVersion parameter. This will default to an appropriate version for the Windows platform and ensures the broadest compatibility with most servers. If your application specifies HTTP_VERSION_20, a secure connection using TLS 1.2 or later will always be used. The minimum required platform for HTTP/2 support is Windows 10 (Build 1903) or Windows Server 2019. Earlier versions of the Schannel SSP do not support the features required for a secure HTTP/2 connection.
- If your application requests a HTTP/2 connection and the server only accepts earlier versions of the protocol, the client will attempt to automatically downgrade the request to HTTP/1.1. If a connection using an earlier version of the protocol cannot be established, the function will fail and return INVALID_CLIENT.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpConnectUrl](#httpconnecturl-function)
- [HttpDisconnect](#httpdisconnect-function)
- [HttpInitialize](#httpinitialize-function)
- [HttpProxyConnect](#httpproxyconnect-function)

---

## HttpConnectUrl Function

Establish a client connection using the specified URL

### Prototype

```c
HCLIENT WINAPI HttpConnectUrl(
    LPCTSTR lpszUrl,
    UINT nTimeout,
    DWORD dwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszUrl` | `LPCTSTR` | A pointer to a string which specifies the URL for the server. The URL must follow the conventions for the Hypertext Transfer Protocol and may specify either a standard or secure connection, alternate port number, username, password and optional working directory. |
| `nTimeout` | `UINT` | The number of seconds that the client will wait for a response from the server before failing the current operation. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |

### Options

- **dwOptions** Parameter

    - `HTTP_OPTION_NOCACHE`: This instructs the server to not return a cached copy of the resource. When connected to an HTTP 1.0 or earlier server, this directive may be ignored.
    - `HTTP_OPTION_KEEPALIVE`: This instructs the server to maintain a persistent connection between requests. This can improve performance because it eliminates the need to establish a separate connection for each resource that is requested.
    - `HTTP_OPTION_REDIRECT`: This option specifies the client should automatically handle resource redirection. If the server indicates that the requested resource has moved to a new location, the client will close the current connection and request the resource from the new location. Note that it is possible that the redirected resource will be located on a different server.
    - `HTTP_OPTION_PROXY`: This option specifies the client should use the default proxy configuration for the local system. If the system is configured to use a proxy server, then the connection will be automatically established through that proxy; otherwise, a direct connection to the server is established. The local proxy configuration can be changed in the system settings or control panel.
    - `HTTP_OPTION_ERRORDATA`: This option specifies the client should return the content of an error response from the server, rather than returning an error code. Note that this option will disable automatic resource redirection, and should not be used with HTTP_OPTION_REDIRECT.
    - `HTTP_OPTION_NOUSERAGENT`: This option specifies the client should not include a User-Agent header with any requests made during the session. The user agent is a string which is used to identify the client application to the server. An application can provide its own custom user agent value using the HttpSetRequestHeader function.
    - `HTTP_OPTION_HTTP2`: This option specifies the client should attempt a HTTP/2 connection with the server. If a connection cannot be established using HTTP/2 the client will attempt to connect using an earlier version of the protocol.
    - `HTTP_OPTION_TUNNEL`: This option specifies that a tunneled TCP connection and/or port-forwarding is being used to establish the connection to the server. This changes the behavior of the client with regards to internal checks of the destination IP address and remote port number, default capability selection and how the connection is established.
    - `HTTP_OPTION_TRUSTEDSITE`: This option specifies the server is trusted. The server certificate will not be validated and the connection will always be permitted. This option only affects connections using the TLS protocol.
    - `HTTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. Note that the server must support secure connections using the TLS protocol. The client will default to using TLS 1.2 or later for secure connections.
    - `HTTP_OPTION_SECURE_FALLBACK`: This option specifies the client should permit the use of less secure cipher suites for compatibility with legacy servers. If this option is specified, the client will allow connections using TLS 1.0 and cipher suites that use RC4, MD5 and SHA1.
    - `HTTP_OPTION_PREFER_IPV6`: This option specifies the client should prefer the use of IPv6 if the server hostname can be resolved to both an IPv6 and IPv4 address. This option is ignored if the local system does not have IPv6 enabled, or when the hostname can only be resolved to an IPv4 address. If the server hostname can only be resolved to an IPv6 address, the client will attempt to establish a connection using IPv6 regardless if this option has been specified.
    - `HTTP_OPTION_FREETHREAD`: This option specifies the handle returned by this function may be used by any thread, and is not limited to the thread which created it. The application is responsible for ensuring that access to the handle is synchronized across multiple threads.
    - `HTTP_OPTION_HIRES_TIMER`: This option specifies the elapsed time for data transfers should be returned in milliseconds instead of seconds. This will return more accurate transfer times for smaller amounts of data over fast network connections.

### Return Value

- **Type**: `HCLIENT`
- If the function succeeds, the return value is a handle to a client session. If the function fails, the return value is INVALID_CLIENT. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpConnectUrl function uses an HTTP URL to establish a connection with a server. The URL must be in the following format:
- If no user name and password is provided, then the client session will be authenticated as an anonymous user. The URL scheme will always determine if the connection is secure, not the option. In other words, if the "http" scheme is used and the HTTP_OPTION_SECURE option is specified, that option will be ignored. To establish a secure connection, the "https" scheme must be specified. The HttpValidateUrl function can be used to verify that a URL is valid prior to calling this function.
- The HttpConnectUrl function is designed to provide a simpler, more convenient interface to establishing a connection with a server. However, complex connections such as those using a proxy server or a secure connection which uses a client certificate will require the program to use the lower-level connection functions. If you only need to upload or download a file using a URL, then refer to the HttpUploadFile and HttpDownloadFile functions.
- This function will block the current thread until a connection has been established or the timeout period has elapsed. To prevent it from blocking the main user interface thread, the application should create a background worker thread and establish a connection by calling HttpConnectUrl in that thread. If the application requires multiple simultaneous connections, it is recommended you create a worker thread for each connection.
- The dwOptions argument can be used to specify the threading model that is used by the library when a connection is established. By default, the handle is initially attached to the thread that created it. From that point on, until the it is released, only the owner may call functions using that handle. The ownership of the handle may be transferred from one thread to another using the HttpAttachThread function.
- Specifying the HTTP_OPTION_FREETHREAD option enables any thread to call any function using the handle, regardless of which thread created it. It is important to note that this option disables certain internal safety checks which are performed by the library and may result in unexpected behavior unless access to the handle is synchronized. If one thread calls a function in the library, it must ensure that no other thread will call another function at the same time using the same handle.
- If the HTTP_OPTION_KEEPALIVE option is specified and the server does not support persistent connections, the client will automatically reconnect when each resource is requested. Although it will not provide any performance benefits, this allows the option to be used with all servers. This option is automatically enabled when using HTTP/2.
- If your application specifies the HTTP_OPTION_HTTP2 option, a secure connection using TLS 1.2 or later will always be used. The minimum required platform for HTTP/2 support is Windows 10 (Build 1903) or Windows Server 2019. Earlier versions of Windows do not support the features required for a secure HTTP/2 connection. If the server only accepts earlier versions of the protocol, the client will attempt to automatically downgrade the request to HTTP/1.1. If a connection using an earlier version of the protocol cannot be established, the function will fail and return INVALID_CLIENT.

### Example

```cpp
HCLIENT hClient;
LPCTSTR lpszUrl = _T("https://www.example.com/");

// Connect to the site specified by the URL
hClient = HttpConnectUrl(lpszUrl, HTTP_TIMEOUT, HTTP_OPTION_DEFAULT);

if (hClient == INVALID_CLIENT)
{
	TCHAR szError[128];

	// Display a message box that describes the error
	HttpGetErrorString(HttpGetLastError(), szError, 128);
	MessageBox(NULL, szError, NULL, MB_ICONEXCLAMATION|MB_TASKMODAL);
	return;
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpConnect](#httpconnect-function)
- [HttpDisconnect](#httpdisconnect-function)
- [HttpDownloadFile](#httpdownloadfile-function)
- [HttpUploadFile](#httpuploadfile-function)
- [HttpValidateUrl](#httpvalidateurl-function)

---

## HttpCreateFile Function

Create or replace a file on the server

### Prototype

```c
INT WINAPI HttpCreateFile(
    HCLIENT hClient,
    LPCTSTR lpszRemoteFile,
    DWORD dwLength,
    DWORD dwOffset
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszRemoteFile` | `LPCTSTR` | Points to a string that specifies the name of the file being created on the server. The client must have the appropriate access rights to create the file or an error will be returned. |
| `dwLength` | `DWORD` | Specifies the length of the file that will be created on the server. This value must be greater than zero. |
| `dwOffset` | `DWORD` | Specifies a byte offset in the file. If this value is greater than zero, the server must support the ability to specify a byte range with the request to create the file, otherwise this function will fail. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpCreateFile function uses the PUT command to create the file. The server must support this command and the user must have the appropriate permission to create the specified file. If this function is successful, the client should then use the HttpWrite function to send the contents of the file to the server. Once all of the data has been written, the HttpCloseFile function should be called to close the file and complete the operation. Note that this function is typically only accepted by servers that support version 1.1 of the protocol or later.
- When using HttpWrite to send the contents of the file to the server, it is recommended that the data be written in logical blocks that are no larger than 8,192 bytes in size. Attempting to write very large amounts of data in a single call can either cause the thread to block or, in the case of an asynchronous connection, return an error if the internal buffers cannot accommodate all of the data. To send the entire contents of a file in a single function call, use the HttpPutData function instead of calling HttpCreateFile.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpCloseFile](#httpclosefile-function)
- [HttpOpenFile](#httpopenfile-function)
- [HttpPutData](#httpputdata-function)
- [HttpPutFile](#httpputfile-function)
- [HttpWrite](#httpwrite-function)

---

## HttpCreateForm Function

Create a new form and return the form handle

### Prototype

```c
HFORM WINAPI HttpCreateForm(
    LPCTSTR lpszAction,
    UINT nFormMethod,
    UINT nFormType,
    DWORD dwReserved
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszAction` | `LPCTSTR` | A pointer to a string which specifies the name of the resource that the form data will be submitted to. Typically this is the name of a script that is executed on the server. |
| `nFormMethod` | `UINT` | An unsigned integer value which specifies how the form data will be submitted to the server. This parameter may be one of the following values: |
| `nFormType` | `UINT` | An unsigned integer value which specifies the type of form and how the data will be encoded when it is submitted to the server. This parameter may be one of the following values: |
| `dwReserved` | `DWORD` | A reserved parameter. This value must be zero. |

### Options

- **nFormMethod** Parameter

    - `HTTP_METHOD_DEFAULT`: The form data should be submitted using the default method, using the GET command.
    - `HTTP_METHOD_GET`: The form data should be submitted using the GET command. This method should be used when the amount of form data is relatively small. If the total amount of form data exceeds 2048 bytes, it is recommended that the POST method be used instead.
    - `HTTP_METHOD_POST`: The form data should be submitted using the POST command. This is the preferred method of submitting larger amounts of form data. If the total amount of form data exceeds 2048 bytes, it is recommended that the POST method be used.
- **nFormType** Parameter

    - `HTTP_FORM_DEFAULT`: The form data should be submitted using the default encoding method.
    - `HTTP_FORM_ENCODED`: The form data should be submitted as URL encoded values. This is typically used when the GET method is used to submit the data to the server.
    - `HTTP_FORM_MULTIPART`: The form data should be submitted as multipart form data. This is typically used when the POST method is used to submit a file to the server. Note that the script must understand how to process multipart form data if this form type is specified.

### Return Value

- **Type**: `HFORM`
- If the function succeeds, the return value is a handle to the virtual form. If the function fails, the return value is INVALID_FORM. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpCreateForm function is used to create a new form that will be populated with values and then submitted to the server for processing. When the form is no longer needed, it should be destroyed using the HttpDestroyForm function.

### Example

```cpp
HFORM hForm = INVALID_FORM;
HGLOBAL hgblResult = (HGLOBAL)NULL;
DWORD cbResult = 0;
INT nResult = 0;

hForm = HttpCreateForm(_T("/login.php"), HTTP_METHOD_POST, HTTP_FORM_ENCODED);

if (hForm == INVALID_FORM)
	return;

HttpAddFormField(hForm, _T("UserName"), lpszUserName, (DWORD)-1L, 0);
HttpAddFormField(hForm, _T("Password"), lpszPassword, (DWORD)-1L, 0);

nResult = HttpSubmitForm(hClient, hForm, &hgblResult, &cbResult, 0);
HttpDestroyForm(hForm);

if (hgblResult != NULL)
{
	LPBYTE lpBuffer = (LPBYTE)GlobalLock(hgblResult);

	// lpBuffer points to data returned by the server after the form
	// data was submitted

	GlobalUnlock(hgblResult);
	GlobalFree(hgblResult);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddFormField](#httpaddformfield-function)
- [HttpAddFormFile](#httpaddformfile-function)
- [HttpClearForm](#httpclearform-function)
- [HttpDeleteFormField](#httpdeleteformfield-function)
- [HttpDestroyForm](#httpdestroyform-function)
- [HttpSubmitForm](#httpsubmitform-function)

---

## HttpCreateQueue Function

Create a new file transfer queue

### Prototype

```c
HQUEUE WINAPI HttpCreateQueue(
    UINT nMaxFiles,
    UINT nTimeout,
    DWORD dwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nMaxFiles` | `UINT` | An unsigned integer which specifies the maximum number of files which can be added to the queue. The constant INFINITE can be used to specify that there is no fixed limit to the number of files in the queue. |
| `nTimeout` | `UINT` | An unsigned integer which specifies the default timeout for all queued file transfers. If this value is zero, a reasonable default timeout period will be used. This timeout period is used when a file is added to the queue without providing a timeout period for that specific file transfer. If a timeout period is specified for a particular file, it will override this value. |
| `dwOptions` | `DWORD` | An unsigned integer value which specifies one or more default options for all queued files. This parameter is constructed by using a bitwise operator and can be any of the options used with the HttpConnect function. If transfer options are specified for a particular file, it will override this value. The most common options are: |

### Options

- **dwOptions** Parameter

    - `HTTP_OPTION_DEFAULT`: Default options should be used for queued file transfers. All standard headers will be included with the request and redirected resources will return an error, allowing the application to determine if it should request the resource from the new location or inform the user the resource location has changed.
    - `HTTP_OPTION_REDIRECT`: This option specifies the client should automatically handle resource redirection. If the server indicates that the requested resource has moved to a new location, the client will close the current connection and request the resource from the new location. Note that it is possible that the redirected resource will be located on a different server.
    - `HTTP_OPTION_PROXY`: This option specifies the client should use the default proxy configuration for the local system. If the system is configured to use a proxy server, then the connection will be automatically established through that proxy; otherwise, a direct connection to the server is established. The local proxy configuration can be changed in the system settings or control panel.
    - `HTTP_OPTION_HTTP2`: This option specifies the client should attempt a HTTP/2 connection with the server. If a connection cannot be established using HTTP/2 the client will attempt to connect using an earlier version of the protocol.
    - `HTTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. Note that the server must support secure connections using the TLS protocol. The client will default to using TLS 1.2 or later for secure connections.

### Return Value

- **Type**: `HQUEUE`
- If the function succeeds, the return value is a handle to the queue which can be used with subsequent function calls. If the function fails, the return value is INVALID_QUEUE. To get extended error information, call HttpGetLastError.

### Remarks

- If the nMaxFiles parameter is INFINITE, memory will be dynamically allocated on the process heap with no limit to the number of files which can be queued. If there is a logic error which causes the application to recursively add files to the queue, or repeatedly queue the same file, this can result in virtual memory being exhausted for the process. You can avoid this by specifying a reasonable maximum queue size, which will cause the HttpAddQueuedFile function to fail if that limit is exceeded.
- The memory allocated for the queue will be released when the HttpDeleteQueue function is called.

### Example

```cpp
// Create a new queue
HQUEUE hQueue = HttpCreateQueue(INFINITE, HTTP_TIMEOUT, HTTP_OPTION_DEFAULT);

if (hQueue == INVALID_QUEUE)
	return;

// Add a file to the queue
DWORD dwFileId = HttpAddQueuedFile(
					hQueue,
					lpszLocalFile,
					lpszRemoteFile,
					HTTP_OPTION_DEFAULT,
					HTTP_TIMEOUT);

// Display information about the queued file
if (dwFileId != 0)
{
	HTTPQUEUEDFILE queuedFile;

	if (HttpGetQueuedFile(hQueue, dwFileId, &queuedFile))
	{
		switch (queuedFile.dwMode)
		{
		case HTTP_QUEUE_DOWNLOAD:
			_tprintf(_T("%u: Download \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szRemoteFile,
						queuedFile.szLocalFile);
				break;

		case HTTP_QUEUE_UPLOAD:
			_tprintf(_T("%u: Upload \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szLocalFile,
						queuedFile.szRemoteFile);
				break;
		}
	}
}

// Start the queued file transfers and wait for it to complete
if (HttpStartQueue(hQueue, HTTP_QUEUE_ALL, 0, NULL, 0))
{
	HttpWaitForQueue(hQueue, INFINITE, &dwElapsed, &dwError);
	HttpStopQueue(hQueue);
}

// Remove all files from the queue
HttpDeleteQueue(hQueue);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpAddQueuedFile](#httpaddqueuedfile-function)
- [HttpDeleteQueue](#httpdeletequeue-function)
- [HttpClearQueue](#httpclearqueue-function)
- [HttpStartQueue](#httpstartqueue-function)
- [HttpStopQueue](#httpstopqueue-function)
- [HttpWaitForQueue](#httpwaitforqueue-function)

---

## HttpCreateSecurityCredentials Function

Create a new security credentials structure

### Prototype

```c
BOOL WINAPI HttpCreateSecurityCredentials(
    DWORD dwProtocol,
    DWORD dwOptions,
    LPCTSTR lpszUserName,
    LPCTSTR lpszPassword,
    LPCTSTR lpszCertStore,
    LPCTSTR lpszCertName,
    LPVOID lpvReserved,
    LPSECURITYCREDENTIALS lppCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `dwProtocol` | `DWORD` | A bitmask of supported security protocols. This parameter is constructed by using a bitwise operator with any of the following values: |
| `dwOptions` | `DWORD` | A value which specifies one or more options. This member is constructed by using a bitwise operator with any of the following values: |
| `lpszUserName` | `LPCTSTR` | A pointer to a string which specifies the certificate owner's username. A value of NULL specifies that no username is required. Currently this parameter is not used and any value specified will be ignored. |
| `lpszPassword` | `LPCTSTR` | A pointer to a string which specifies the certificate owner's password. A value of NULL specifies that no password is required. This parameter is only used if a PKCS #12 (PFX) certificate file is specified and that certificate has been secured with a password. This value will be ignored the current user or local machine certificate store is specified. |
| `lpszCertStore` | `LPCTSTR` | A pointer to a string which specifies the name of the certificate store to open. A certificate store is a collection of certificates and their private keys, typically organized by how they are used. If this value is NULL or points to an empty string, the default certificate store "MY" will be used. |
| `lpszCertName` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the certificate to use. The function will first search the certificate store for a certificate with a matching "friendly name"; this is a name for the certificate that is assigned by the user. Note that the name must match completely, but the comparison is not case sensitive. If no matching certificate is found, the function will then attempt to find a certificate that has a matching common name (also called the certificate subject). This comparison is less stringent, and the first partial match will be returned. If this second search fails, the function will return an error indicating that the certificate could not be found. |
| `lpvReserved` | `LPVOID` | Pointer reserved for future use. Set it to NULL when using this function. |
| `lppCredentials` | `LPSECURITYCREDENTIALS` | Pointer to an LPSECURITYCREDENTIALS pointer. The memory for the credentials structure will be allocated by this function and must be released by calling the HttpDeleteSecurityCredentials function when it is no longer needed. The pointer value must be set to NULL before the function is called. It is important to note that this is a pointer to a pointer variable, not a pointer to the SECURITYCREDENTIALS structure itself. |

### Options

- **dwProtocol** Parameter

    - `SECURITY_PROTOCOL_DEFAULT`: The default security protocol will be used when establishing a connection. This option will always request the latest version of the preferred security protocol and is the recommended value. Currently the default security protocol is TLS 1.2.
    - `SECURITY_PROTOCOL_TLS`: Either the TLS 1.2 or 1.3 protocol should be used when establishing a secure connection. The correct protocol is automatically selected, based on what version of the protocol is supported by the server. If this is the only protocol specified, SSL will be excluded from the list of supported protocols. This may be necessary for some servers which reject any attempt to use the older SSL protocol and require that only TLS be used.
    - `SECURITY_PROTOCOL_TLS10`: The TLS 1.0 protocol should be used when establishing a secure connection. This version is supported on all Windows platforms, however some servers may reject connections using version 1.0 in favor of using version 1.2. This version should only be used for backwards compatibility with older servers that have not been updated to use the current version of TLS.
    - `SECURITY_PROTOCOL_TLS11`: The TLS 1.1 protocol should be used when establishing a secure connection. This version is supported on Windows 7 and later desktop platforms, and Windows Server 2008 R2 and later server platforms. Some servers may reject connections using version 1.1 in favor of using version 1.2. This version should only be used for backwards compatibility with older servers that have not been updated to use the current version of TLS.
    - `SECURITY_PROTOCOL_TLS12`: The TLS 1.2 protocol should be used when establishing a secure connection. This version is supported on Windows 7 and later desktop platforms, and Windows Server 2008 R2 and later server platforms. This version of TLS offers the broadest compatibility with most servers.
    - `SECURITY_PROTOCOL_TLS13`: The TLS 1.3 protocol should be used when establishing a secure connection. This is the newest version of the protocol and is only supported on Windows 11, Windows Server 2022 and later versions of Windows. If this version is not supported by the operating system, TLS 1.2 will be used instead.
- **dwOptions** Parameter

    - `CREDENTIAL_STORE_CURRENT_USER`: The library will attempt to open a store for the current user using the certificate store name provided in this structure. If no options are specified, then this is the default behavior.
    - `CREDENTIAL_STORE_LOCAL_MACHINE`: The library will attempt to open a local machine store using the certificate store name provided in this structure. If this option is specified, the library will always search for a local machine store before searching for the store by that name for the current user.
    - `CREDENTIAL_STORE_FILENAME`: The certificate store name is a file that contains the certificate and private key that will be used.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call the HttpGetLastError function.

### Remarks

- The structure that is created by this function may be used as client credentials when establishing a secure connection. This is particularly useful for programming languages other than C/C++ which may not support C structures or pointers. The pointer to the SECURITYCREDENTIALS structure can be declared as an unsigned integer variable which is passed by reference to this function, and then passed by value to the HttpConnect function.
- A client application only needs to call this function if the server requires that the client provide a certificate as part of the process of negotiating the secure session. If a certificate is required, note that it must have a private key associated with it. Attempting to use a certificate that does not have a private key will result in an error during the connection process indicating that the client credentials could not be established.
- If you are using a local certificate store, with the certificate and private key stored in the registry, you can explicitly specify whether the certificate store for the current user or the local machine (all users) should be used. This is done by prefixing the certificate store name with "HKCU:" for the current user, or "HKLM:" for the local machine. For example, a certificate store name of "HKLM:MY" would specify the personal certificate store for the local machine, rather than the current user. If neither prefix is specified, then it will default to the certificate store for the current user. You can manage these certificates using the CertMgr.msc Microsoft Management Console (MMC) snap-in.
- It is possible to load the certificate from a file rather than from current user's certificate store. The dwOptions parameter should be set to CREDENTIAL_STORE_FILENAME and the lpszCertStore parameter should specify the name of the file that contains the certificate and its private key. The file must be in Private Information Exchange (PFX) format, also known as PKCS #12.These certificate files typically have an extension of .pfx or .p12. If a password was specified when the certificate was created, it must be provided in the lpszPassword parameter or the library will be unable to access the certificate.
- Note that the lpszUserName and lpszPassword parameters are values which are used to access the certificate store or client certificate. They are not the credentials which are used when establishing the connection with the remote host or authenticating the client session. In most cases, these parameters will be NULL.

### Example

```cpp
LPSECURITYCREDENTIALS lpSecCred = NULL;
HttpCreateSecurityCredentials(SECURITY_PROTOCOL_DEFAULT,
							0,
							NULL,
							NULL,
							lpszCertStore,
							lpszCertName,
							NULL,
							&lpSecCred);

hClient = HttpConnect(lpszHostName,
					HTTP_PORT_SECURE,
					HTTP_TIMEOUT,
					HTTP_OPTION_SECURE | HTTP_OPTION_KEEPALIVE,
					HTTP_VERSION_11,
					lpSecCred);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpConnect](#httpconnect-function)
- [HttpDeleteSecurityCredentials](#httpdeletesecuritycredentials-function)
- [HttpGetSecurityInformation](#httpgetsecurityinformation-function)
- [HttpProxyConnect](#httpproxyconnect-function)
- [SECURITYCREDENTIALS](#securitycredentials-function)

---

## HttpDeleteFile Function

Remove a file from the server

### Prototype

```c
INT WINAPI HttpDeleteFile(
    HCLIENT hClient,
    LPCTSTR lpszFileName
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileName` | `LPCTSTR` | Points to a string that specifies the name of the remote file to delete. The file pathing and name conventions must be that of the server. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- This function uses the DELETE command to delete the specified file from the server. The server must be configured to support this command, and client must have the appropriate permission to delete the file, or an error will be returned.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetFile](#httpgetfile-function)
- [HttpPutFile](#httpputfile-function)

---

## HttpDeleteFormField Function

Delete the form field and its value from the specified form

### Prototype

```c
INT WINAPI HttpDeleteFormField(
    HFORM hForm,
    LPCTSTR lpszFieldName
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hForm` | `HFORM` | Handle to the virtual form. |
| `lpszFieldName` | `LPCTSTR` | Points to a string that specifies the name of the field to delete. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddFormField](#httpaddformfield-function)
- [HttpAddFormFile](#httpaddformfile-function)
- [HttpClearForm](#httpclearform-function)
- [HttpCreateForm](#httpcreateform-function)
- [HttpSubmitForm](#httpsubmitform-function)

---

## HttpDeleteHeaders Function

Delete all of the response or request headers for the current session

### Prototype

```c
BOOL WINAPI HttpDeleteHeaders(
    HCLIENT hClient,
    UINT nHeaderType
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nHeaderType` | `UINT` | Specifies the type of header to delete. It may be one of the following values: |

### Options

- **nHeaderType** Parameter

    - `HTTP_HEADERS_REQUEST`: Delete all of the request headers that have been set for the next request sent to the server. This will clear all of the header values that were set using the HttpSetRequestHeader function.
    - `HTTP_HEADERS_RESPONSE`: Delete all of the headers that were set in response to the previous request. A call to the HttpGetResponseHeader function to obtain a specific header value will fail after this function returns.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpDeleteHeaders function will release the memory allocated for the request or response headers for the current session. This function is typically used to clear all of the current request headers so that the application may create a new set of headers when a persistent connection is being used. The memory allocated for the request and response headers is normally released when the session handle is closed by calling the HttpDisconnect function.
- Whenever a request for a resource is sent to the server, the response headers from the previous request are automatically cleared. It is not necessary for an application to call the HttpDeleteHeaders function to delete the response headers prior to each request.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpGetFirstHeader](#httpgetfirstheader-function)
- [HttpGetNextHeader](#httpgetnextheader-function)
- [HttpGetResponseHeader](#httpgetresponseheader-function)
- [HttpSetRequestHeader](#httpsetrequestheader-function)

---

## HttpDeleteQueue Function

Delete a previously created file transfer queue

### Prototype

```c
BOOL WINAPI HttpDeleteQueue(
    HQUEUE hQueue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetLastError.

### Remarks

- This function can only be called when the queue is in an idle state. If the queue manager is in the process of uploading or downloading files, the function will fail and return a value of zero. You can determine the current state of the queue by calling the HttpGetQueueStatus function. It is not necessary to explicitly clear the queue prior to calling this function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpCreateQueue](#httpcreatequeue-function)
- [HttpGetQueueStatus](#httpgetqueuestatus-function)
- [HttpCancelQueuedFile](#httpcancelqueuedfile-function)
- [HttpClearQueue](#httpclearqueue-function)
- [HttpStartQueue](#httpstartqueue-function)
- [HttpStopQueue](#httpstopqueue-function)
- [HttpWaitForQueue](#httpwaitforqueue-function)

---

## HttpDeleteSecurityCredentials Function

Delete a previously created security credentials structure

### Prototype

```c
VOID WINAPI HttpDeleteSecurityCredentials(
    LPSECURITYCREDENTIALS lppCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lppCredentials` | `LPSECURITYCREDENTIALS` | Pointer to an LPSECURITYCREDENTIALS pointer. On exit from the function, the pointer will be NULL. |

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- This function can be used to release the memory allocated to the client or server credentials after a secure connection has been terminated.

### Example

```cpp
if (lpSecCred != NULL)
	HttpDeleteSecurityCredentials(&lpSecCred);

HttpUninitialize();
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpCreateSecurityCredentials](#httpcreatesecuritycredentials-function)
- [HttpUninitialize](#httpuninitialize-function)

---

## HttpDestroyForm Function

Destroy the specified form and free the memory allocated for it

### Prototype

```c
INT WINAPI HttpDestroyForm(
    HFORM hForm
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hForm` | `HFORM` | Handle to the form. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpAddFormField](#httpaddformfield-function)
- [HttpAddFormFile](#httpaddformfile-function)
- [HttpClearForm](#httpclearform-function)
- [HttpCreateForm](#httpcreateform-function)
- [HttpDeleteFormField](#httpdeleteformfield-function)
- [HttpSubmitForm](#httpsubmitform-function)

---

## HttpDisableEvents Function

Disable asynchronous event notification

### Prototype

```c
INT WINAPI HttpDisableEvents(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- This function affects both event notification and event callbacks. Any outstanding events in the message queue should be ignored by the client application.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpEnableEvents](#httpenableevents-function)
- [HttpFreezeEvents](#httpfreezeevents-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpDisableTrace Function

Disable logging of network function calls to the trace log

### Prototype

```c
BOOL WINAPI HttpDisableTrace();
```

### Parameters

| Name | Type | Description |
|------|------|-------------|

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpEnableTrace](#httpenabletrace-function)

---

## HttpDisconnect Function

Disconnect from the current server

### Prototype

```c
INT WINAPI HttpDisconnect(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpConnect](#httpconnect-function)
- [HttpUninitialize](#httpuninitialize-function)

---

## HttpDownloadFile Function

Download a file from the server to the local system

### Prototype

```c
BOOL WINAPI HttpDownloadFile(
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    UINT nTimeout,
    DWORD dwOptions,
    LPHTTPTRANSFERSTATUS lpStatus,
    HTTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file on the local system that will be created, overwritten or appended to. The file pathing and name conventions must be that of the local host. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the complete URL of the file to be downloaded. The URL must follow the conventions for the File Transfer Protocol and may specify either a standard or secure connection, alternate port number, username, password and optional working directory. |
| `nTimeout` | `UINT` | The number of seconds that the client will wait for a response before failing the operation. A value of zero specifies that the default timeout period of sixty seconds will be used. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `lpStatus` | `LPHTTPTRANSFERSTATUS` | A pointer to an HTTPTRANSFERSTATUS structure which contains information about the status of the current file transfer. If this information is not required, a NULL pointer may be specified as the parameter. |
| `lpEventProc` | `HTTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the HttpEventProc callback function. If this parameter is NULL, the callback for the specified event is disabled. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. |

### Options

- **dwOptions** Parameter

    - `HTTP_OPTION_NOCACHE`: This instructs the server to not return a cached copy of the resource. When connected to an HTTP 1.0 or earlier server, this directive may be ignored.
    - `HTTP_OPTION_REDIRECT`: This option specifies the client should automatically handle resource redirection. If the server indicates that the requested resource has moved to a new location, the client will close the current connection and request the resource from the new location. Note that it is possible that the redirected resource will be located on a different server.
    - `HTTP_OPTION_PROXY`: This option specifies the client should use the default proxy configuration for the local system. If the system is configured to use a proxy server, then the connection will be automatically established through that proxy; otherwise, a direct connection to the server is established. The local proxy configuration can be changed using the system Control Panel.
    - `HTTP_OPTION_NOUSERAGENT`: This option specifies the client should not include a User-Agent header with any requests made during the session. The user agent is a string which is used to identify the client application to the server. If this option is not specified, a default user agent string will be included with the request.
    - `HTTP_OPTION_HTTP2`: This option specifies the client should attempt a HTTP/2 connection with the server. If a connection cannot be established using HTTP/2 the client will attempt to connect using an earlier version of the protocol.
    - `HTTP_OPTION_TUNNEL`: This option specifies that a tunneled TCP connection and/or port-forwarding is being used to establish the connection to the server. This changes the behavior of the client with regards to internal checks of the destination IP address and remote port number, default capability selection and how the connection is established.
    - `HTTP_OPTION_TRUSTEDSITE`: This option specifies the server is trusted. The server certificate will not be validated and the connection will always be permitted. This option only affects connections using the TLS protocol.
    - `HTTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. Note that the server must support secure connections using the TLS protocol. The client will default to using TLS 1.2 or later for secure connections.
    - `HTTP_OPTION_SECURE_FALLBACK`: This option specifies the client should permit the use of less secure cipher suites for compatibility with legacy servers. If this option is specified, the client will allow connections using TLS 1.0 and cipher suites that use RC4, MD5 and SHA1.
    - `HTTP_OPTION_HIRES_TIMER`: This option specifies the elapsed time for data transfers should be returned in milliseconds instead of seconds. This will return more accurate transfer times for smaller amounts of data over fast network connections.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpDownloadFile function provides a convenient way for an application to download a file in a single function call. Based on the connection information specified in the URL, it will connect to the server, authenticate the session and then download the file to the local system. The URL must be complete, and specify either a standard or secure HTTP scheme:
- If no user name and password is provided, then the client session will be authenticated as an anonymous user. The URL scheme will always determine if the connection is secure, not the option. In other words, if the "http" scheme is used and the HTTP_OPTION_SECURE option is specified, that option will be ignored. To establish a secure connection, the "https" scheme must be specified.
- If your application requests a HTTP/2 connection and the server only accepts earlier versions of the protocol, the client will attempt to automatically downgrade the request to HTTP/1.1. If a connection using an earlier version of the protocol cannot be established, the function will fail and return a value of zero.
- The lpStatus parameter can be used by the application to determine the final status of the transfer, including the total number of bytes copied, the amount of time elapsed and other information related to the transfer process. If this information isn't needed, then this parameter may be specified as NULL.
- The lpEventProc parameter specifies a pointer to a function which will be periodically called during the file transfer process. This can be used to check the status of the transfer by calling HttpGetTransferStatus and then update the program's user interface. For example, the callback function could calculate the percentage for how much of the file has been transferred and then update a progress bar control. The dwParam parameter is used in conjunction with the event handler and specifies a user-defined value that is passed to the callback function. One common use in a C++ program is to pass the this pointer as the value, and then cast it back to an object pointer inside the callback function. If no event handler is required, then a NULL pointer can be specified as the value for lpEventProc and the dwParam parameter will be ignored.
- The HttpDownloadFile function is designed to provide a simpler interface for downloading a file. However, complex connections such as those using a specific proxy server or a secure connection which uses a client certificate will require the program to establish the connection using HttpConnect or HttpProxyConnect and then use HttpGetFile to download the file.

### Example

```cpp
HTTPTRANSFERSTATUS httpStatus;
LPCTSTR lpszLocalFile = _T("c:\\temp\\database.mdb");
LPCTSTR lpszRemoteFile = _T("http://www.example.com/updates/database.mdb");
BOOL bResult;

// Download the file using the specified URL
bResult = HttpDownloadFile(lpszLocalFile,
						lpszRemoteFile,
						HTTP_OPTION_DEFAULT,
						&httpStatus,
						NULL, 0);

if (!bResult)
{
	TCHAR szError[128];

	// Display a message box that describes the error
	HttpGetErrorString(HttpGetLastError(), szError, 128);
	MessageBox(NULL, szError, NULL, MB_ICONEXCLAMATION|MB_TASKMODAL);
	return;
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpEventProc](#httpeventproc-function)
- [HttpGetFile](#httpgetfile-function)
- [HttpGetTransferStatus](#httpgettransferstatus-function)
- [HttpSubmitRequest](#httpsubmitrequest-function)
- [HttpUploadFile](#httpuploadfile-function)
- [HTTPTRANSFERSTATUS](#httptransferstatus-function)

---

## HttpEnableCompression Function

Enable or disable support for data compression

### Prototype

```c
INT WINAPI HttpEnableCompression(
    HCLIENT hClient,
    BOOL bEnable
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `bEnable` | `BOOL` | A boolean value which specifies if data compression should be enabled or disabled. A non-zero value enables compression, while a value of zero will disable compression. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpEnableCompression function is used to indicate to the server whether or not it is acceptable to compress the data that is returned to the client. If compression is enabled, the client will advertise that it will accept compressed data by setting the Accept-Encoding request header. The server will decide whether a resource being requested can be compressed. If the data is compressed, the library will automatically expand the data before returning it to the caller.
- Enabling compression does not guarantee that the data returned by the server will actually be compressed, it only informs the server that the client is willing to accept compressed data. Whether or not a particular resource is compressed depends on the server configuration, and the server may decide to only compress certain types of resources, such as text files. Disabling compression informs the server that the client is not willing to accept compressed data; this is the default.
- If the HttpSetRequestHeader function is used to explicitly set the Accept-Encoding header to request compressed data and compression is not enabled, the library will not attempt to automatically expand the data returned by the server. In this case, the raw compressed data will be returned to the caller and the application is responsible for processing it. This behavior is by design to maintain backwards compatibility with previous versions of the library that did not have internal support for compression.
- To determine if the server compressed the data returned to the client, use the HttpGetResponseHeader function to get the value of the Content-Encoding header. If the header is defined, the value specifies the compression method used, otherwise the data was not compressed.
- Enabling compression is only meaningful when downloading files from a server that supports file compression. It has no effect on file uploads.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpGetData](#httpgetdata-function)
- [HttpGetFile](#httpgetfile-function)
- [HttpGetFileEx](#httpgetfileex-function)
- [HttpGetResponseHeader](#httpgetresponseheader-function)
- [HttpGetText](#httpgettext-function)
- [HttpSetRequestHeader](#httpsetrequestheader-function)

---

## HttpEnableEvents Function

Enable asynchronous event notification

### Prototype

```c
INT WINAPI HttpEnableEvents(
    HCLIENT hClient,
    HWND hEventWnd,
    UINT uEventMsg
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `hEventWnd` | `HWND` | Handle to the event notification window. This window receives a user-defined message which specifies the event that has occurred. If this value is NULL, event notification is disabled. |
| `uEventMsg` | `UINT` | An unsigned integer which specifies the user-defined message that is sent when an event occurs. This parameter's value must be greater than the value of WM_USER. If the hEventWnd parameter is NULL, this value must be specified as WM_NULL. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- When a message is posted to the notification window, the low word of the lParam parameter contains the event identifier. The high word of lParam contains the low word of the error code, if an error has occurred. The wParam parameter contains the client handle. One or more of the following event identifiers may be sent:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpDisableEvents](#httpdisableevents-function)
- [HttpFreezeEvents](#httpfreezeevents-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpEnableTrace Function

Enable logging of network function calls to a file

### Prototype

```c
BOOL WINAPI HttpEnableTrace(
    LPCTSTR lpszTraceFile,
    DWORD dwTraceFlags
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszTraceFile` | `LPCTSTR` | A pointer to a string which specifies the name of the trace log file. If this parameter is NULL or an empty string, the default file name cstrace.log is used. The file is stored in the directory specified by the TEMP environment variable, if it is defined; otherwise, the current working directory is used. |
| `dwTraceFlags` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |

### Options

- **dwTraceFlags** Parameter

    - `TRACE_INFO`: All function calls are written to the trace file. This is the default value.
    - `TRACE_ERROR`: Only those function calls which fail are recorded in the trace file.
    - `TRACE_WARNING`: Only those function calls which fail or return values which indicate a warning are recorded in the trace file.
    - `TRACE_HEXDUMP`: All functions calls are written to the trace file, plus all the data that is sent or received is displayed, in both ASCII and hexadecimal format.
    - `TRACE_PROCESS`: All function calls in the current process are logged, rather than only those functions in the current thread. This option is useful for multithreaded applications that are using worker threads.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. A return value of zero indicates an error. Failure typically indicates that the tracing library cstrcv11.dll cannot be loaded on the local system.

### Remarks

- When trace logging is enabled, the file is opened, appended to and closed for each socket function call. This makes it possible for an application to append its own logging information, however care should be taken to ensure that the file is closed before the next network operation is performed. To limit the size of the log files, enable and disable logging only around those sections of code that you wish to trace.
- Note that the TRACE_HEXDUMP trace level generates very large log files since it includes all of the data exchanged between your application and the server.
- Logging is managed on a per-thread basis, not for each client handle. This means that all SocketTools libraries and components share the same settings in the current thread. If you are using multiple SocketTools libraries or components in your application, you only need to enable logging once.
- When logging is enabled for HTTP/2 client sessions, it is normal to see HTTP/1.1 in the request and server response. HTTP/2 is a binary protocol and the request and response header blocks emulate a standard HTTP/1.1 text response for backwards compatibility. Applications running on the server should work in the same way regardless of which protocol version is selected, however it is possible to check the server environment to determine which version of HTTP was used with the request.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpDisableTrace](#httpdisabletrace-function)

---

## HttpEnumQueuedFiles Function

Return a list of files in the transfer queue

### Prototype

```c
LONG WINAPI HttpEnumQueuedFiles(
    HQUEUE hQueue,
    LPCTSTR lpszFileMask,
    DWORD dwQueueMode,
    DWORD dwExcludeFiles,
    LPDWORD lpFileList,
    LONG nMaxFiles
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `lpszFileMask` | `LPCTSTR` | A pointer to a null terminated string which specifies a file name which can include wildcards. Only those files which match this value will be enumerated. The character '?' will match against any single character, and '*' will match any number of characters. If this parameter is NULL or points to an empty string, all eligible files in the queue will be matched. |
| `dwQueueMode` | `DWORD` | An unsigned integer value which specifies if the file name should be matched against downloaded files, uploaded files or all files in the queue. Only those files which match the queue mode will be enumerated. This is a bitmask which may be one or more of the following values: |
| `dwExcludeFiles` | `DWORD` | An unsigned integer value which specifies which files to exclude from the enumeration. If this value is zero, no files will be excluded; otherwise, this value is constructed by using a bitwise operator with any of the following values: |
| `lpFileList` | `LPDWORD` | A pointer to an array of unsigned integer values which will contain the unique file identifiers for each matching file in the queue. This parameter must specify an array large enough to store all of the file identifiers, otherwise the function will fail with a ST_ERROR_BUFFER_TOO_SMALL error. If this parameter is NULL, the function will return the number of matching files. |
| `nMaxFiles` | `LONG` | An integer value which specifies the maximum number of file identifiers which can be copied into the lpFileList array. If the lpFileList parameter is not NULL, this value must be greater than zero. |

### Options

- **dwQueueMode** Parameter

    - `HTTP_QUEUE_ALL`: Match the file name to all files in the queue.
    - `HTTP_QUEUE_DOWNLOAD`: Match file names which are queued for download.
    - `HTTP_QUEUE_UPLOAD`: Match file names which are queued for upload.
    - `HTTP_QUEUE_LOCAL`: Match against the local file name instead of the remote file name.
- **dwExcludeFiles** Parameter

    - `HTTP_QUEUE_FLAG_NONE`: No files should be excluded.
    - `HTTP_QUEUE_FLAG_COMPLETED`: Exclude files which have been transferred. This flag is set after a queued file has been uploaded or downloaded successfully.
    - `HTTP_QUEUE_FLAG_FAILED`: Exclude files which where not successfully uploaded or downloaded. This flag is set when an error occurs, either when establishing a connection with the server or during the file transfer.
    - `HTTP_QUEUE_FLAG_CANCELED`: Exclude files which were canceled during the file transfer. This flag is only set when the HttpCancelQueuedFile function has been called and a queued file is in the process of being uploaded or downloaded.

### Return Value

- **Type**: `LONG`
- If the function succeeds, the return value is the number of matching files. If the queue is empty or there are no matching files, this function will return zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- This function populates an array of unique file identifiers which can be used to obtain information about the files in the current queue. The values returned in the lpFileList array can be used in conjunction with the HttpGetQueuedFile function. This provides an alternative to using the HttpGetFirstQueuedFile and HttpGetNextQueuedFile functions.
- The application should not make any assumptions about the value of the file identifiers returned by this function. They should be considered opaque values which are only guaranteed to uniquely identify a file in the transfer queue. In particular, there is no guarantee that the file identifiers will be sequential and they should not be used as index values into an array.

### Example

```cpp
// Get the total number of files in the queue
LONG nFiles = HttpEnumQueuedFiles(hQueue, NULL, HTTP_QUEUE_ALL, HTTP_QUEUE_FLAG_NONE, NULL, 0)

// Display information about the queued files
if (nFiles > 0)
{
	DWORD *pdwFileList = new DWORD[nFiles];

	nFiles = HttpEnumQueuedFiles(hQueue, NULL, HTTP_QUEUE_ALL, HTTP_QUEUE_FLAG_NONE, pdwFileList, nFiles);

	for (LONG nIndex = 0; nIndex < nFiles; nIndex++)
	{
		HTTPQUEUEDFILE queuedFile;

		if (HttpGetQueuedFile(hQueue, pdwFileList[nIndex], &queuedFile) == FALSE)
			break;
			
		switch (queuedFile.dwMode)
		{
		case HTTP_QUEUE_DOWNLOAD:
			_tprintf(_T("%u: Download \"%s\" to \"%s\"\n"),
						queuedFile.dwFileId,
						queuedFile.szRemoteFile,
						queuedFile.szLocalFile);
				break;

		case HTTP_QUEUE_UPLOAD:
			_tprintf(_T("%u: Upload \"%s\" to \"%s\"\n"),
						queuedFile.dwFileId,
						queuedFile.szLocalFile,
						queuedFile.szRemoteFile);
				break;
		}
	}
	
	delete pdwFileList;
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddQueuedFile](#httpaddqueuedfile-function)
- [HttpFindQueuedFile](#httpfindqueuedfile-function)
- [HttpGetFirstQueuedFile](#httpgetfirstqueuedfile-function)
- [HttpGetNextQueuedFile](#httpgetnextqueuedfile-function)
- [HttpGetQueuedFile](#httpgetqueuedfile-function)
- [HttpRemoveQueuedFile](#httpremovequeuedfile-function)

---

## HttpEnumTasks Function

Return a list of asynchronous tasks

### Prototype

```c
INT WINAPI HttpEnumTasks(
    UINT lpTasks,
    INT nMaxTasks,
    DWORD dwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpTasks` | `UINT` | A pointer to an array of unsigned integer values that will contain unique task identifiers when the function returns. If this parameter is NULL, the function will return the number of tasks. |
| `nMaxTasks` | `INT` | An integer value that specifies the maximum number of task identifiers that may be copied into the lpTasks array. If the lpTasks parameter is NULL, this value must be zero. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies the type of asynchronous tasks that may be returned by this function. It may be a combination of the following values: |

### Options

- **dwOptions** Parameter

    - `HTTP_TASK_DEFAULT`: The list of asynchronous task IDs should include both active and suspended tasks. This option is the same as specifying both the HTTP_TASK_ACTIVE and HTTP_TASK_SUSPENDED options.
    - `HTTP_TASK_ACTIVE`: The list of asynchronous task IDs should include those tasks which are currently active. An active task represents a background connection to a server that is in the process of performing the requested action, such as uploading or downloading a file.
    - `HTTP_TASK_SUSPENDED`: The list of asynchronous task IDs should include those tasks which have been suspended. A suspended task represents a background connection that has been established, but the worker thread is not scheduled for execution.
    - `HTTP_TASK_FINISHED`: The list of asynchronous task IDs should include those tasks which have completed recently.

### Return Value

- **Type**: `INT`
- If the function is successful, the return value is the number of task identifiers copied into the provided array. If there are no tasks which match the requested criteria, the return value is zero. A return value of HTTP_ERROR indicates an error has occurred. To get extended error information, call the HttpGetLastError function.

### Remarks

- The HttpEnumTasks function can be used to obtain a list of numeric identifiers that represent the asynchronous tasks that have been started or those that have completed. These task IDs are used by other functions to reference the background worker thread that has been created and obtain status information for the task. For example, the HttpTaskDone function can be used to determine if a particular task has completed, and the HttpTaskWait function can be used to wait for a task to complete and return an error status code if the background operation failed.
- There is an internal limit of 128 asynchronous tasks per process that may be active at any one time. When a task completes, the status information about that task is maintained for period of time after the task has completed.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpTaskDone](#httptaskdone-function)
- [HttpTaskResume](#httptaskresume-function)
- [HttpTaskSuspend](#httptasksuspend-function)
- [HttpTaskWait](#httptaskwait-function)

---

## HttpEventProc Function

Callback function that processes events generated by the client

### Prototype

```c
VOID __cdecl HttpEventProc(
    HCLIENT hClient,
    UINT nEvent,
    DWORD dwError,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nEvent` | `UINT` | An unsigned integer which specifies which event occurred. For a complete list of events, refer to the HttpRegisterEvent function. |
| `dwError` | `DWORD` | An unsigned integer which specifies any error that occurred. If no error occurred, then this parameter will be zero. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value which was specified when the event callback was registered. |

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- An application must register this callback function by passing its address to the HttpRegisterEvent function. This callback function is also used by asynchronous tasks to notify the application when the task has started and completed. The HttpEventProc function is a placeholder for the application-defined function name.
- If the callback function is invoked by an asynchronous task, it will execute in the context of the worker thread that is managing the client session. You must ensure that any access to global or static variables are synchronized, otherwise the results may be unpredictable. It is recommended that you do not declare any static variables within the callback function itself.
- If the application has a graphical user interface, you should never attempt to directly modify a UI control from within the callback function for an asynchronous task. Controls should only be modified by the same UI thread that created their window. One common approach to resolve this issue is to post a user-defined message to the main window to signal that the user interface needs to be updated. The message handler would then process the user-defined message and update the user interface as needed.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpDisableEvents](#httpdisableevents-function)
- [HttpEnableEvents](#httpenableevents-function)
- [HttpFreezeEvents](#httpfreezeevents-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpFindQueuedFile Function

Find a file in the transfer queue which matches the search criteria

### Prototype

```c
DWORD WINAPI HttpFindQueuedFile(
    HQUEUE hQueue,
    LPCTSTR lpszFileName,
    DWORD dwQueueMode,
    DWORD dwExcludeFiles
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `lpszFileName` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the file to search for. The string may contain the wildcard character '?' to match against any single character, and '*' will match any number of characters. This parameter cannot be NULL or point to an empty string. |
| `dwQueueMode` | `DWORD` | An unsigned integer value which specifies if the file name should be matched against downloaded files, uploaded files or all files in the queue. This is a bitmask which may be one or more of the following values: |
| `dwExcludeFiles` | `DWORD` | An unsigned integer value which specifies which files to exclude from the search. If this value is zero, no files will be excluded from the search; otherwise, this value is constructed by using a bitwise operator with any of the following values: |

### Options

- **dwQueueMode** Parameter

    - `HTTP_QUEUE_ALL`: Match the file name to all files in the queue.
    - `HTTP_QUEUE_DOWNLOAD`: Match file names which are queued for download.
    - `HTTP_QUEUE_UPLOAD`: Match file names which are queued for upload.
    - `HTTP_QUEUE_LOCAL`: Match against the local file name instead of the remote file name.
- **dwExcludeFiles** Parameter

    - `HTTP_QUEUE_FLAG_NONE`: No files should be excluded from the search.
    - `HTTP_QUEUE_FLAG_COMPLETED`: Exclude files which have been transferred. This flag is set after a queued file has been uploaded or downloaded successfully.
    - `HTTP_QUEUE_FLAG_FAILED`: Exclude files which where not successfully uploaded or downloaded. This flag is set when an error occurs, either when establishing a connection with the server or during the file transfer.
    - `HTTP_QUEUE_FLAG_CANCELED`: Exclude files which were canceled during the file transfer. This flag is only set when the HttpCancelQueuedFile function has been called and a queued file is in the process of being uploaded or downloaded.

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is a unique identifier for the file. To obtain information about the file, call the HttpGetQueuedFile function. If the function fails, the return value is zero. To get extended error information, call HttpGetLastError.

### Remarks

- This function returns a unique file identifier for the first file which matches the specified file name in the queue. If the lpszFileName parameter includes wildcard characters, this function will return the first file in the queue which matches the name. File name matches are not case-sensitive, even when matching against remote file names on servers which use case-sensitive naming, such as UNIX based servers.
- To perform more complex searches based on the file name, or to find multiple files, you can use the HttpGetFirstQueuedFile and HttpGetNextQueuedFile functions to iterate through all queued files.

### Example

```cpp
// Find a local file in the download queue
DWORD dwFileId = HttpFindQueuedFile(
					hQueue,
					lpszFileName,
					HTTP_QUEUE_DOWNLOAD | HTTP_QUEUE_LOCAL,
					HTTP_QUEUE_FLAG_NONE);

// Display information about the queued file
if (dwFileId != 0)
{
	HTTPQUEUEDFILE queuedFile;

	if (HttpGetQueuedFile(hQueue, dwFileId, &queuedFile))
	{
		switch (queuedFile.dwMode)
		{
		case HTTP_QUEUE_DOWNLOAD:
			_tprintf(_T("%u: Download \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szRemoteFile,
						queuedFile.szLocalFile);
				break;

		case HTTP_QUEUE_UPLOAD:
			_tprintf(_T("%u: Upload \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szLocalFile,
						queuedFile.szRemoteFile);
				break;
		}
	}
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddQueuedFile](#httpaddqueuedfile-function)
- [HttpEnumQueuedFiles](#httpenumqueuedfiles-function)
- [HttpGetFirstQueuedFile](#httpgetfirstqueuedfile-function)
- [HttpGetNextQueuedFile](#httpgetnextqueuedfile-function)
- [HttpGetQueuedFile](#httpgetqueuedfile-function)
- [HttpRemoveQueuedFile](#httpremovequeuedfile-function)

---

## HttpFreezeEvents Function

Suspend asynchronous event processing

### Prototype

```c
INT WINAPI HttpFreezeEvents(
    HCLIENT hClient,
    BOOL bFreeze
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `bFreeze` | `BOOL` | A non-zero value specifies that event handling should be suspended by the client. A zero value specifies that event handling should be resumed. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- This function should be used when the application does not want to process events, such as when a modal dialog is being displayed. When events are suspended, all client events are queued. If events are re-enabled at a later point, those queued events will be sent to the application for processing. Note that only one of each event will be generated. For example, if the client has suspended event handling, and four read events occur, once event handling is resumed only one of those read events will be posted to the client. This prevents the application from being flooded by a potentially large number of queued events.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpDisableEvents](#httpdisableevents-function)
- [HttpEnableEvents](#httpenableevents-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpGetBearerToken Function

Return the current OAuth 2.0 bearer token for the client session

### Prototype

```c
INT WINAPI HttpGetBearerToken(
    HCLIENT hClient,
    LPTSTR lpszBearerToken,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszBearerToken` | `LPTSTR` | A pointer to a string buffer which will contain the bearer token when the function returns. The string will be null terminated and the the buffer must be large enough to accommodate the entire bearer token or the function will fail. This parameter cannot be a NULL pointer. |
| `nMaxLength` | `INT` | The maximum number of characters that may be copied into the string buffer. This value must be greater than zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the bearer token string. A return value of zero indicates that no bearer token has been specified. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- This function returns the bearer token which was previously set by a call to HttpSetBearerToken. Bearer tokens can be very long strings and do not contain any human readable information. For Google services, these tokens are usually about 180 characters in length. For Microsoft services, their bearer tokens are typically 1,200 characters in length. It is recommended that you provide a buffer size of at least 2,000 characters.
- Your application should not store the bearer tokens provided by a web service. These tokens are short-lived and typically only valid for about an hour. If the token has expired, the authorization to access the resource will fail and it must be refreshed. The refresh tokens used to acquire a new bearer token should be stored and they are typically valid for a period of months.

### Requirements

- Minimum Desktop Platform: Windows 7 (Service Pack 1)
- Minimum Server Platform: Windows Server 2008 R2 (Service Pack 1)
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAuthenticate](#httpauthenticate-function)
- [HttpSetBearerToken](#httpsetbearertoken-function)

---

## HttpGetContentLength Function

Return the size of the current resource in bytes

### Prototype

```c
BOOL WINAPI HttpGetContentLength(
    HCLIENT hClient,
    LPDWORD lpdwLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpdwLength` | `LPDWORD` | A pointer to a unsigned integer which will contain the content length for the current resource. This value will be initialized to zero and updated with the length when the function returns. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetLastError.

### Remarks

- When this function is called after a GET or POST request has completed, the lpdwLength parameter will contain the total number of bytes returned by the server. If this function is called while a request is being processed (for example, from within an event handler), it will return the value of the Content-Length response header provided by the server. If it's possible the server will return more than 4GiB of data to the client, the HttpGetContentLengthEx function should be used. That version of the function accepts an unsigned 64-bit integer and will prevent the content length from being truncated to a 32-bit value.
- Most servers will only include a Content-Length header in the response for static resources like documents or image files. For other types of resources where the response payload is generated dynamically, such as server-side scripts, servers typically use "chunked" output and there is no Content-Length header. The server may also not provide a file size for HTML documents which use server side includes (SSI) because that content is also dynamically created by the server. In this case, the content length can only be determined after the request has completed.
- This function should only be used after a request has completed and will not return a value for dynamic resources as they are being retrieved from the server. To obtain the current number of bytes copied from within an event handler, use the HttpGetTransferStatus function.
- If the content type for the current resource is textual, the content length reported by the server may be different than what is stored on the local system due to different end-of-line character conventions. For example, on Windows the end of a line of text is indicated by a carriage-return and linefeed pair, while on Linux the end-of-line is indicated by a single linefeed. Depending on the options specified when the request is made, text returned by the server may be normalized for the Windows platform.
- This function does not use the HEAD command to request the size of a document on the server. It will only return the content length of a resource which has already been requested, typically after using functions such as HttpGetText or HttpPostXml. To ask the server for the size of document without downloading the contents of that document, use the HttpGetFileSize function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpGetContentLengthEx](#httpgetcontentlengthex-function)
- [HttpGetContentType](#httpgetcontenttype-function)
- [HttpGetFileSize](#httpgetfilesize-function)
- [HttpGetResponseHeader](#httpgetresponseheader-function)
- [HttpGetTransferStatus](#httpgettransferstatus-function)
- [HttpSetContentType](#httpsetcontenttype-function)

---

## HttpGetContentType Function

Return the content type for the current resource

### Prototype

```c
INT WINAPI HttpGetContentType(
    HCLIENT hClient,
    LPTSTR lpszContentType,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszContentType` | `LPTSTR` | A pointer to a buffer which will contain the MIME content type of the resource returned by the web server. The buffer must be large enough to contain the entire content type string including the terminating null character. This parameter is optional and may be NULL if the information is not required. |
| `nMaxLength` | `INT` | An integer value which specifies the maximum number of characters which can be copied into the buffer. If the lpszContentType parameter is NULL, this value must be zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the value indicates the type of resource returned by the server. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- This function does not examine the contents of the payload returned by the server and only returns a value based on the Content-Type response header. If the web server does not recognize the data format of the resource it is returning, it should identify it as application/octet-stream and the content type would be returned as HTTP_CONTENT_BINARY. However, some servers incorrectly return unrecognized formats as text/plain, causing the payload to be identified as human-readable text rather than binary data.
- Some servers will return a content type of text/plain for JSON responses and others will use the IANA standard type of application/json. To ensure consistency with these two content types, this function will always return MIME_CONTENT_TEXT for JSON responses.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetContentLength](#httpgetcontentlength-function)
- [HttpGetResponseHeader](#httpgetresponseheader-function)
- [HttpSetContentType](#httpsetcontenttype-function)

---

## HttpGetCookie Function

Return information about the specified cookie

### Prototype

```c
BOOL WINAPI HttpGetCookie(
    HCLIENT hClient,
    LPCTSTR lpszCookieName,
    LPTSTR lpszCookieValue,
    INT nCookieValue,
    LPTSTR lpszCookiePath,
    INT nCookiePath,
    LPTSTR lpszCookieDomain,
    INT nCookieDomain,
    LPSYSTEMTIME lpCookieExpires,
    LPDWORD lpdwCookieFlags
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszCookieName` | `LPCTSTR` | A pointer to a string which specifies the name of the cookie to return information about. |
| `lpszCookieValue` | `LPTSTR` | A pointer to a string buffer that will contain the value of the cookie. If this information is not required, a NULL pointer may be specified. |
| `nCookieValue` | `INT` | The maximum number of characters that may be copied into the buffer specified by the lpszCookieValue parameter, including the terminating null character. |
| `lpszCookiePath` | `LPTSTR` | A pointer to a string buffer that will contain the cookie path. If this information is not required, a NULL pointer may be specified. |
| `nCookiePath` | `INT` | The maximum number of characters that may be copied into the buffer specified by the lpszCookiePath parameter, including the terminating null character. |
| `lpszCookieDomain` | `LPTSTR` | A pointer to a string buffer that will contain the cookie domain. If this information is not required, a NULL pointer may be specified. |
| `nCookieDomain` | `INT` | The maximum number of characters that may be copied into the buffer specified by the lpszCookieDomain parameter, including the terminating null character. |
| `lpCookieExpires` | `LPSYSTEMTIME` | A pointer to a SYSTEMTIME structure which specifies the date and time that the cookie expires. If this information is not required, a NULL pointer may be specified. |
| `lpdwCookieFlags` | `LPDWORD` | One or more bit flags which specify status information about the cookie. A value of zero indicates that there are no special status flags for the cookie. This parameter may be NULL if the information is not required. The following values are currently defined: |

### Options

- **lpdwCookieFlags** Parameter

    - `HTTP_COOKIE_SECURE`: This flag specifies that the cookie should only be provided to the server if the connection is secure.
    - `HTTP_COOKIE_SESSION`: This flag specifies that the cookie should only be used for the current application session and should not be stored permanently on the local system.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the specified cookie does not exist or function fails, the return value is zero. To get extended error information, call HttpGetLastError.

### Remarks

- The Hypertext Transfer Protocol uses special tokens called "cookies" to maintain persistent state information between requests for a resource. These cookies are exchanged between the client and server by setting specific header fields. When a server wants the client to use a cookie, it will include a header field named Set-Cookie in the response header when the client requests a resource. The client can then take this cookie and store it, either temporarily in memory or permanently in a file on the local system. The next time that the client requests a resource from that server, it can send the cookie back to the server by setting the Cookie header field. The HttpGetCookie function searches for a cookie set by the server in the Set-Cookie header field. The HttpSetCookie function creates or modifies the Cookie header field for the next resource requested by the client.
- There are two general types of cookies that are used by servers. Session cookies exist only for the duration of the client session; they are stored in memory and not saved in any kind of permanent storage. When the client application terminates, session cookies are deleted and no longer used. Persistent cookies are stored on the local system and are used by the client until their expiration time. It is the responsibility of the client application to store persistent cookies; applications may use a flat text file, a database or any other storage method available.
- In addition to the cookie name and value, the server may return additional information about the cookie which the client should use to determine if it should send the cookie back to the server:
- The cookie path specifies a path for the resources where the cookie should be used. For example, a path of "/" indicates that the cookie should be provided for all resources requested from the server. A path of "/data" would mean that the cookie should be included if the resource is found in the /data folder or a sub-folder, such as /data/projections.asp. However, the cookie would not be provided if the resource /info/status.asp was requested, since it is not in the /data path.
- The cookie domain specifies the domain for which the cookie should be used. Matches are made by comparing the name of the server against the domain name specified in the cookie. If the domain is example.com, then any server in the example.com domain would match; for example, both shipping.example.com and orders.example.com would match the domain value. However, if the cookie domain was orders.example.com, then the cookie would only be sent if the resource was requested from orders.example.com, not if the resource was located on shipping.example.com or www.example.com.
- The cookie expiration specifies the date and time that the cookie should be deleted and no longer sent when a resource is requested from the server. This is only valid for persistent cookies, since session cookies are automatically deleted when the client application terminates. The time is always expressed as Coordinated Universal Time.
- The cookie flags provide additional information about the cookie. In some cases, a cookie should only be submitted to the server if the resource is requested using a secure connection. In this case, the bit flag HTTP_COOKIE_SECURE will be set.
- It is the responsibility of the client application to determine if a cookie meets the criteria required to be submitted to the server. If the application wishes to send the cookie, it can use the HttpSetCookie function and specify the cookie name and value.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpClearHeaders](#httpclearheaders-function)
- [HttpGetFirstCookie](#httpgetfirstcookie-function)
- [HttpGetNextCookie](#httpgetnextcookie-function)
- [HttpGetResponseHeader](#httpgetresponseheader-function)
- [HttpSetCookie](#httpsetcookie-function)
- [HttpSetRequestHeader](#httpsetrequestheader-function)

---

## HttpGetData Function

Copy the specified resource to a local buffer

### Prototype

```c
INT WINAPI HttpGetData(
    HCLIENT hClient,
    LPCTSTR lpszResource,
    LPVOID lpvBuffer,
    LPDWORD lpdwLength,
    DWORD dwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResource` | `LPCTSTR` | A pointer to a string that specifies the resource on the server. This may be the name of a file on the server, or it may specify the name of a script that will be executed and the output returned to the caller. This string may specify a valid URL for the current server that the client is connected to. |
| `lpvBuffer` | `LPVOID` | A pointer to a byte buffer which will contain the data transferred from the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpdwLength` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvBuffer parameter. If the lpvBuffer parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the number of bytes of data returned by the server. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |

### Options

- **dwOptions** Parameter

    - `HTTP_TRANSFER_DEFAULT`: The default transfer mode. The resource data is downloaded to the local system exactly as it is stored on the server. If you are requesting a text-based resource, the data may use a different end-of-line character sequence. For example, the end-of-line character may be a single linefeed character instead of a carriage return and linefeed pair.
    - `HTTP_TRANSFER_CONVERT`: If the resource being downloaded from the server is textual, the data is automatically converted so that the end of line character sequence is compatible with the Windows platform. Individual carriage return or linefeed characters are converted to carriage return/linefeed character sequences.
    - `HTTP_TRANSFER_COMPRESS`: This option informs the server that the client is willing to accept compressed data. If the server supports compression for the specified resource, then the data will be automatically expanded before being returned to the caller. This option is selected by default if compression has been enabled using the HttpEnableCompression function.
    - `HTTP_TRANSFER_ERRORDATA`: This option causes the client to accept error data from the server if the request fails. If this option is specified, an error response from the server will not cause the function to fail. Instead, the response is returned to the client and the function will succeed.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpGetData function is used to retrieve a resource from the server and copy it into a local buffer. The function may be used in one of two ways, depending on the needs of the application. The first method is to pre-allocate a buffer large enough to store the contents of the file. In this case, the lpvBuffer parameter will point to the buffer that was allocated and the value that the lpdwLength parameter points to should be initialized to the size of that buffer.
- The second method that can be used is have the lpvBuffer parameter point to a global memory handle which will contain the file data when the function returns. In this case, the value that the lpdwLength parameter points to must be initialized to zero. It is important to note that the memory handle returned by the function must be freed by the application, otherwise a memory leak will occur. See the example code below.
- It is important for your application to initialize the value of the lpdwLength parameter correctly. This parameter must be passed by reference and if it is not initialized properly it can cause unexpected behavior or corrupt the process heap. If an error occurs when issuing the GET request to the server, the variable passed to this function may have a value of zero when the function returns, indicating no data has been returned to the caller.
- When encountering a server error during a request, the HttpGetData function normally returns HTTP_ERROR, and no data is copied into the caller-provided buffer. The last error code for the current thread is updated to reflect the general cause of the failure, allowing the application to handle this error condition appropriately. Additionally, servers may provide further details about the failure, such as XML or JSON formatted data containing specific error codes or diagnostic messages.
- To capture this error information, you can utilize the HTTP_TRANSFER_ERRORDATA option. When this option is enabled, the behavior of HttpGetData changes; it does not return HTTP_ERROR for server error statuses. Instead, any error data provided in the server's response, regardless of its format, is copied into the buffer provided by the caller.
- If compression has been enabled and the server returns compressed data, it will be automatically expanded before being returned to the caller. This will result in a difference between the value returned in the lpdwLength parameter, which contains the actual number of bytes copied into the buffer, and the values reported by HttpGetTransferStatus. For example, if the server returns 5,000 bytes of compressed data that expands into 15,000 bytes, this function will return 15,000 as the number of bytes copied into the buffer. However, the HttpGetTransferStatus function will return the content length as the original 5,000 bytes of compressed data. For this reason, you should always use the value returned in the lpdwLength parameter to determine the amount of data that has been copied into the buffer.
- This function will cause the current thread to block until the file transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the HTTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling HttpEnableEvents, or by registering a callback function using the HttpRegisterEvent function.
- To determine the current status of a file transfer while it is in progress, use the HttpGetTransferStatus function.

### Example

```cpp
HGLOBAL hgblBuffer = (HGLOBAL)NULL;
LPBYTE lpBuffer = (LPBYTE)NULL;
DWORD cbBuffer = 0;

// Store the response in a block of global memory allocated by
// the GlobalAlloc function; the handle to this memory will be
// returned in the hgblBuffer parameter
nResult = HttpGetData(hClient,
					lpszResource,
					&hgblBuffer,
					&cbBuffer,
					HTTP_TRANSFER_DEFAULT);

if (nResult != HTTP_ERROR)
{
	// Lock the global memory handle, returning a pointer to the
	// resource data
	lpBuffer = (LPBYTE)GlobalLock(hgblBuffer);
	
	// After the data has been used, the handle must be unlocked
	// and freed, otherwise a memory leak will occur
	GlobalUnlock(hgblBuffer);
	GlobalFree(hgblBuffer);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpEnableCompression](#httpenablecompression-function)
- [HttpEnableEvents](#httpenableevents-function)
- [HttpGetFile](#httpgetfile-function)
- [HttpGetTransferStatus](#httpgettransferstatus-function)
- [HttpPostData](#httppostdata-function)
- [HttpPutData](#httpputdata-function)
- [HttpPutFile](#httpputfile-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpGetDefaultUserAgent Function

Return the default user agent string included with requests

### Prototype

```c
INT WINAPI HttpGetDefaultUserAgent(
    LPTSTR lpszUserAgent,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszUserAgent` | `LPTSTR` | A pointer to a buffer which will contain the default user agent string when the function returns. The buffer must be large enough to contain the entire user agent string including the terminating null character. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value which specifies the maximum number of characters which can be copied into the buffer. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- When you submit a request to the server, a header named User-Agent is automatically defined which identifies your application. It typically uses a format where you have a product name and version number separated by a slash. There can be multiple products listed in the user agent string, with additional optional information enclosed in parenthesis.
- A server uses the user agent to determine what type of client has issued the request, including what operating system and browser version was used. The HttpGetDefaultUserAgent function returns a copy of that default value. The value of the user agent string depends on which version of Windows the client is running on and whether the process is 32-bit or 64-bit. For example, a 64-bit application will typically return a value like this:
- Mozilla/5.0 (Windows NT 6.2; Win64; x64) Chrome/74.0.3729.169 Safari/537.36 SocketTools/11.0
- Some web services check the value of the user agent string to determine if a compatible client is being used to issue the request. The default value is designed to emulate a common browser, but some services may require you change the user agent to use a specific value or include certain product names and versions.
- You can change the value of the user agent string in one of two ways. You can use HttpSetRequestHeader to set the User-Agent header to a specific value for a client session, or you can use HttpSetDefaultUserAgent to set the default user agent string for all requests. If you use HttpSetRequestHeader to change the user agent string for a client session, it will always override the default value.
- To prevent any user agent string from being included with a request, include the HTTP_OPTION_NOUSERAGENT option when connecting to the server or use HttpSetOption to enable that option after a connection has been established.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpSetDefaultUserAgent](#httpsetdefaultuseragent-function)
- [HttpSetOption](#httpsetoption-function)
- [HttpSetRequestHeader](#httpsetrequestheader-function)

---

## HttpGetEncodingType Function

Determines which content encoding option is enabled

### Prototype

```c
INT WINAPI HttpGetEncodingType(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is one of the following values:

### Remarks

- The default encoding type is HTTP_ENCODING_URL which is used for submitting data to services which expect HTML form data using the HttpPostData or HttpSubmitForm functions.
- When submitting a JSON or XML request to a service using a REST API, your application should use HTTP_ENCODING_NONE and set the appropriate content type for the request payload. The HTTP_ENCODING_XML encoding type should only be used if the server expects URL encoded form data. The HttpPostJson and HttpPostXml functions will automatically set the correct encoding and content type for those requests.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpGetContentType](#httpgetcontenttype-function)
- [HttpPostData](#httppostdata-function)
- [HttpPostJson](#httppostjson-function)
- [HttpPostXml](#httppostxml-function)
- [HttpSetEncodingType](#httpsetencodingtype-function)
- [HttpSubmitForm](#httpsubmitform-function)

---

## HttpGetErrorString Function

Return a description for the specified error code

### Prototype

```c
INT WINAPI HttpGetErrorString(
    DWORD dwErrorCode,
    LPTSTR lpszDescription,
    INT cbDescription
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `dwErrorCode` | `DWORD` | The error code for which a description is returned. |
| `lpszDescription` | `LPTSTR` | A pointer to the buffer that will contain a description of the specified error code. This buffer should be at least 128 characters in length. |
| `cbDescription` | `INT` | The maximum number of characters that may be copied into the description buffer. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the description string. If the function fails, the return value is zero, meaning that no description exists for the specified error code. Typically this indicates that the error code passed to the function is invalid.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetLastError](#httpgetlasterror-function)
- [HttpSetLastError](#httpsetlasterror-function)

---

## HttpGetFile Function

Copy a file from the server to the local system

### Prototype

```c
INT WINAPI HttpGetFile(
    HCLIENT hClient,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    DWORD dwOffset
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file on the local system that will be created, overwritten or appended to. The file pathing and name conventions must be that of the local system. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the resource on the server. This may be the name of a file on the server, or it may specify the name of a script that will be executed and the output returned to the caller. This string may specify a valid URL for the current server that the client is connected to. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `dwOffset` | `DWORD` | Specifies a byte offset into the file. If this value is greater than zero, the server must support the ability to specify a byte range with the request to download the file, otherwise this function will fail. |

### Options

- **dwOptions** Parameter

    - `HTTP_TRANSFER_DEFAULT`: The default transfer mode. The resource data is downloaded to the local system exactly as it is stored on the server. If you are requesting a text-based resource, the data may use a different end-of-line character sequence. For example, the end-of-line character may be a single linefeed character instead of a carriage return and linefeed pair.
    - `HTTP_TRANSFER_CONVERT`: If the resource being downloaded from the server is textual, the data is automatically converted so that the end of line character sequence is compatible with the Windows platform. Individual carriage return or linefeed characters are converted to carriage return/linefeed character sequences.
    - `HTTP_TRANSFER_COMPRESS`: This option informs the server that the client is willing to accept compressed data. If the server supports compression for the specified resource, then the data will be automatically expanded before being returned to the caller. This option is selected by default if compression has been enabled using the HttpEnableCompression function. This option is ignored if the dwOffset parameter is non-zero.
    - `HTTP_TRANSFER_ERRORDATA`: This option causes the client to accept error data from the server if the request fails. If this option is specified, an error response from the server will not cause the function to fail. Instead, the response is returned to the client and the function will succeed. If this option is used, your application should call HttpGetResultCode to obtain the HTTP status code returned by the server. This will enable you to determine if the operation was successful.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- Enabling compression does not guarantee that the data returned by the server will actually be compressed, it only informs the server that the client is willing to accept compressed data. Whether or not a particular resource is compressed depends on the server configuration, and the server may decide to only compress certain types of resources, such as text files. To determine if the server compressed the data returned to the client, use the HttpGetResponseHeader function to get the value of the Content-Encoding header after this function returns. If the header is defined, the value specifies the compression method used, otherwise the data was not compressed.
- To download large files that are over 4GB, use the HttpGetFileEx function.
- This function will cause the current thread to block until the file transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the HTTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling HttpEnableEvents, or by registering a callback function using the HttpRegisterEvent function.
- To determine the current status of a file transfer while it is in progress, use the HttpGetTransferStatus function.

### Example

```cpp
LPCTSTR lpszLocalFile = _T("index.html");
LPCTSTR lpszRemoteFile = _T("http://sockettools.com/");

if (HttpGetFile(hClient, lpszLocalFile, lpszRemoteFile) == HTTP_ERROR)
{
	dwError = HttpGetLastError();
	_tprintf(stderr, "Unable to download %s, error 0x%lx\n", lpszRemoteFile, dwError);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpEnableEvents](#httpenableevents-function)
- [HttpGetData](#httpgetdata-function)
- [HttpGetFileEx](#httpgetfileex-function)
- [HttpGetText](#httpgettext-function)
- [HttpGetTransferStatus](#httpgettransferstatus-function)
- [HttpPutFile](#httpputfile-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpGetFileEx Function

Copy a file from the server to the local system, use with large files over 4GiB

### Prototype

```c
INT WINAPI HttpGetFileEx(
    HCLIENT hClient,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    ULARGE_INTEGER uiOffset
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file on the local system that will be created, overwritten or appended to. The file pathing and name conventions must be that of the local host. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the resource on the server. This may be the name of a file on the server, or it may specify the name of a script that will be executed and the output returned to the caller. This string may specify a valid URL for the current server that the client is connected to. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `uiOffset` | `ULARGE_INTEGER` | Specifies a byte offset into the file. If this value is greater than zero, the server must support the ability to specify a byte range with the request to download the file, otherwise this function will fail. |

### Options

- **dwOptions** Parameter

    - `HTTP_TRANSFER_DEFAULT`: The default transfer mode. The resource data is downloaded to the local system exactly as it is stored on the server. If you are requesting a text-based resource, the data may use a different end-of-line character sequence. For example, the end-of-line character may be a single linefeed character instead of a carriage return and linefeed pair.
    - `HTTP_TRANSFER_CONVERT`: If the resource being downloaded from the server is textual, the data is automatically converted so that the end of line character sequence is compatible with the Windows platform. Individual carriage return or linefeed characters are converted to carriage return/linefeed character sequences.
    - `HTTP_TRANSFER_COMPRESS`: This option informs the server that the client is willing to accept compressed data. If the server supports compression for the specified resource, then the data will be automatically expanded before being returned to the caller. This option is selected by default if compression has been enabled using the HttpEnableCompression function. This option is ignored if the uiOffset parameter is non-zero.
    - `HTTP_TRANSFER_ERRORDATA`: This option causes the client to accept error data from the server if the request fails. If this option is specified, an error response from the server will not cause the function to fail. Instead, the response is returned to the client and the function will succeed. If this option is used, your application should call HttpGetResultCode to obtain the HTTP status code returned by the server. This will enable you to determine if the operation was successful.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- Enabling compression does not guarantee that the data returned by the server will actually be compressed, it only informs the server that the client is willing to accept compressed data. Whether or not a particular resource is compressed depends on the server configuration, and the server may decide to only compress certain types of resources, such as text files. To determine if the server compressed the data returned to the client, use the HttpGetResponseHeader function to get the value of the Content-Encoding header after this function returns. If the header is defined, the value specifies the compression method used, otherwise the data was not compressed.
- This function will cause the current thread to block until the file transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the HTTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling HttpEnableEvents, or by registering a callback function using the HttpRegisterEvent function.
- To determine the current status of a file transfer while it is in progress, use the HttpGetTransferStatusEx function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpEnableEvents](#httpenableevents-function)
- [HttpGetData](#httpgetdata-function)
- [HttpGetText](#httpgettext-function)
- [HttpGetTransferStatusEx](#httpgettransferstatusex-function)
- [HttpPutFileEx](#httpputfileex-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpGetFileSize Function

Return the size of a file on the server

### Prototype

```c
INT WINAPI HttpGetFileSize(
    HCLIENT hClient,
    LPCTSTR lpszFileName,
    LPDWORD lpdwFileSize
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileName` | `LPCTSTR` | Points to a string that specifies the name of the remote file. |
| `lpdwFileSize` | `LPDWORD` | Points to an unsigned integer that will contain the size of the specified file in bytes. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- This function uses the HEAD command to retrieve header information about the file without downloading the contents of the file itself. If the file does not exist or the client does not have permission to access the file, this method will fail and the lpdwFileSize parameter will be set to zero.
- The server may not return a file size for some resources. This is typically the case with scripts that generate dynamic content because the server has no way of determining the size of the output generated by the script without actually executing it. The server may also not provide a file size for HTML documents which use server side includes (SSI) because that content is also dynamically created by the server. If the request to the server was successful and the file exists, but the server does not return a file size, the function will succeed but the file size returned to the caller will be zero.
- When a request is made to the server for information about the file, the library will attempt to keep the connection alive, even if the HTTP_OPTION_KEEPALIVE option has not been specified for the session. This allows an application to request the file size and then download the file without having to write additional code to re-establish the connection. However, it is possible that the attempt to keep the connection open will fail. In that case, an error will be returned and the client handle will no longer be valid. If this happens, the lpdwFileSize parameter may still contain a valid value. If the library was able to determine the file size, but was not able to maintain the connection to the server, the returned file size will be greater than zero even if the function returns an error.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpCommand](#httpcommand-function)
- [HttpGetContentLength](#httpgetcontentlength-function)
- [HttpGetContentType](#httpgetcontenttype-function)
- [HttpGetFileTime](#httpgetfiletime-function)
- [HttpVerifyFile](#httpverifyfile-function)

---

## HttpGetFileSizeEx Function

Return the size of a file on the server, supports large files over 4GiB

### Prototype

```c
INT WINAPI HttpGetFileSizeEx(
    HCLIENT hClient,
    LPCTSTR lpszFileName,
    ULARGE_INTEGER lpFileSize
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileName` | `LPCTSTR` | Points to a string that specifies the name of the remote file. |
| `lpFileSize` | `ULARGE_INTEGER` | Points to an unsigned 64-bit integer that will contain the size of the specified file in bytes. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- This function uses the HEAD command to retrieve header information about the file without downloading the contents of the file itself. If the file does not exist or the client does not have permission to access the file, this method will fail and the lpFileSize parameter will be set to zero.
- The server may not return a file size for some resources. This is typically the case with scripts that generate dynamic content because the server has no way of determining the size of the output generated by the script without actually executing it. The server may also not provide a file size for HTML documents which use server side includes (SSI) because that content is also dynamically created by the server. If the request to the server was successful and the file exists, but the server does not return a file size, the function will succeed but the file size returned to the caller will be zero.
- When a request is made to the server for information about the file, the library will attempt to keep the connection alive, even if the HTTP_OPTION_KEEPALIVE option has not been specified for the session. This allows an application to request the file size and then download the file without having to write additional code to re-establish the connection. However, it is possible that the attempt to keep the connection open will fail. In that case, an error will be returned and the client handle will no longer be valid. If this happens, the lpFileSize parameter may still contain a valid value. If the library was able to determine the file size, but was not able to maintain the connection to the server, the returned file size will be greater than zero even if the function returns an error.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpCommand](#httpcommand-function)
- [HttpGetFileTime](#httpgetfiletime-function)
- [HttpVerifyFile](#httpverifyfile-function)

---

## HttpGetFileTime Function

Return the date and time a file on the server was last modified

### Prototype

```c
INT WINAPI HttpGetFileTime(
    HCLIENT hClient,
    LPCTSTR lpszFileName,
    LPSYSTEMTIME lpFileTime,
    BOOL bLocalize
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileName` | `LPCTSTR` | Points to a string that specifies the name of the remote file. |
| `lpFileTime` | `LPSYSTEMTIME` | Points to a SYSTEMTIME structure that will be set to the current modification time for the remote file. |
| `bLocalize` | `BOOL` | A boolean flag which specifies if the file time is localized to the current timezone. If this value is non-zero, then the file time is adjusted to that the time is local to the current system. If this value is zero, the file time is returned in UTC time. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpGetFileTime function can be used to determine the date and time that a file was last modified on the server. The time may either be localized to the current system, or it may be returned as UTC time.
- This function uses the HEAD command to retrieve header information about the file without downloading the contents of the file itself. This requires that the server support at least version 1.0 of the protocol standard, or an error will be returned.
- The server may not return a modification time for some resources. If the request to the server was successful and the file exists, but the server does not return a modification time, the function will succeed but all of the members of the SYSTEMTIME structure will be zero.
- When a request is made to the server for information about the file, the library will attempt to keep the connection alive, even if the HTTP_OPTION_KEEPALIVE option has not been specified for the session. This allows an application to request the modification time and then download the file without having to write additional code to re-establish the connection. However, it is possible that the attempt to keep the connection open will fail. In that case, an error will be returned and the client handle will no longer be valid. If this happens, the SYSTEMTIME structure may still contain a valid value. If the library was able to determine the modification time, but was not able to maintain the connection to the server, the members of the SYSTEMTIME structure will specify a valid date and time.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpCommand](#httpcommand-function)
- [HttpGetFileSize](#httpgetfilesize-function)

---

## HttpGetFirstCookie Function

Return the first cookie set by the server

### Prototype

```c
DWORD_PTR WINAPI HttpGetFirstCookie(
    HCLIENT hClient,
    LPTSTR lpszCookieName,
    LPINT lpnNameLen,
    LPTSTR lpszCookieValue,
    LPINT lpnValueLen
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszCookieName` | `LPTSTR` | A pointer to a string buffer which will contain the name of the first cookie set by the server. |
| `lpnNameLen` | `LPINT` | A pointer to an integer which specifies the maximum number of characters which may be copied into the buffer, including the terminating null character. When the function returns, this value is updated to specify the actual length of the cookie name string. |
| `lpszCookieValue` | `LPTSTR` | A pointer to a string buffer which will contain the name of the first cookie value set by the server. If the cookie value is not required, this parameter may be NULL. |
| `lpnValueLen` | `LPINT` | A pointer to an integer which specifies the maximum number of characters which may be copied into the buffer, including the terminating null character. When the function returns, this value is updated to specify the actual length of the cookie value string. If the lpszCookieValue parameter is NULL, this parameter should also be NULL. |

### Return Value

- **Type**: `DWORD_PTR`
- If the function succeeds, the return value is an opaque token which will be passed to the HttpGetNextCookie function to retrieve the next cookie. If there are no cookies or the function fails, the return value is zero. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpGetFirstCookie function is used to enumerate the cookies set by the server after a resource has been requested. The return value is an unsigned integer where the size depends on whether the application targets 32-bit or 64-bit platforms. This value should always be treated as an opaque integer which is only valid during the enumeration of the session cookies and should never be stored by the application.
- To get information about a specific cookie, use the HttpGetCookie function.

### Example

```cpp
TCHAR szCookieName[MAXCOOKIENAME];
TCHAR szCookieValue[MAXCOOKIEVALUE];
INT nNameLen, nValueLen;
DWORD_PTR dwCookie;

// Initialize the nNameLen and nValueLen variables to
// the maximum number of characters that can be copied
// into the string buffers
nNameLen = MAXCOOKIENAME;
nValueLen = MAXCOOKIEVALUE;

// Get the first cookie set by the server
dwCookie = HttpGetFirstCookie(hClient,
							szCookieName,
							&nNameLen,
							szCookieValue,
							&nValueLen);

while (dwCookie != 0)
{
	// The szCookieName and szCookieValue strings contain the
	// the name and value for a cookie set by the server

	// Re-initialize the nNameLen and nValueLen variables
	// to the maximum length of the strings
	nNameLen = MAXCOOKIENAME;
	nValueLen = MAXCOOKIEVALUE;

	// Get the next cookie set by the server
	dwCookie = HttpGetNextCookie(hClient,
								dwCookie,
								szCookieName,
								&nNameLen,
								szCookieValue,
								&nValueLen);
};
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetCookie](#httpgetcookie-function)
- [HttpGetNextCookie](#httpgetnextcookie-function)
- [HttpGetResponseHeader](#httpgetresponseheader-function)
- [HttpSetCookie](#httpsetcookie-function)
- [HttpSetRequestHeader](#httpsetrequestheader-function)

---

## HttpGetFirstHeader Function

Return the name and value of the first request or response header field

### Prototype

```c
BOOL WINAPI HttpGetFirstHeader(
    HCLIENT hClient,
    UINT nHeaderType,
    LPTSTR lpszHeader,
    LPINT lpcchHeader,
    LPTSTR lpszValue,
    LPINT lpcchValue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nHeaderType` | `UINT` | Specifies the type of header to return. It may be one of the following values: |
| `lpszHeader` | `LPTSTR` | A pointer to a string buffer that will contain the name of the header field when the function returns. |
| `lpcchHeader` | `LPINT` | A pointer to an integer which specifies the maximum number of characters which may be copied into the buffer, including the terminating null character. When the function returns, this value is updated to specify the actual length of the header name string. |
| `lpszValue` | `LPTSTR` | A pointer to a string buffer that will contain the name of the header value when the function returns. |
| `lpcchValue` | `LPINT` | A pointer to an integer which specifies the maximum number of characters which may be copied into the buffer, including the terminating null character. When the function returns, this value is updated to specify the actual length of the header value string. |

### Options

- **nHeaderType** Parameter

    - `HTTP_HEADERS_REQUEST`: Return the first header set by the client before a resource has been requested. Request headers typically specify information that the server needs to complete the request, such as the name of the host that has the resource, or what types of resources are acceptable to the client.
    - `HTTP_HEADERS_RESPONSE`: Return the first header set by the server after a request has been submitted to the server. The response headers typically contain information about the resource, such as its size, the content type and the date it was last modified.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the header field does not exist or the client handle is invalid, the function returns a value of zero. To get extended error information, call HttpGetLastError.

### Remarks

- Use this function together with HttpGetNextHeader to enumerate all request or response headers.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetResponseHeader](#httpgetresponseheader-function)
- [HttpSetRequestHeader](#httpsetrequestheader-function)
- [HttpGetNextHeader](#httpgetnextheader-function)

---

## HttpGetFirstQueuedFile Function

Return information about the first file in the transfer queue

### Prototype

```c
DWORD WINAPI HttpGetFirstQueuedFile(
    HQUEUE hQueue,
    DWORD dwQueueMode,
    DWORD dwExcludeFiles,
    LPHTTPQUEUEDFILE lpFileInfo
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `dwQueueMode` | `DWORD` | An unsigned integer value which specifies if the file name should be matched against downloaded files, uploaded files or all files in the queue. It may be one of the following values: |
| `dwExcludeFiles` | `DWORD` | An unsigned integer value which specifies which files to exclude from the search. If this value is zero, no files will be excluded from the search; otherwise, this value is constructed by using a bitwise operator with any of the following values: |
| `lpFileInfo` | `LPHTTPQUEUEDFILE` | A pointer to a HTTPQUEUEDFILE structure which will contain information about the file. This parameter cannot be NULL. |

### Options

- **dwQueueMode** Parameter

    - `HTTP_QUEUE_ALL`: Return information about all files in the queue.
    - `HTTP_QUEUE_DOWNLOAD`: Return information for files which are queued for download.
    - `HTTP_QUEUE_UPLOAD`: Return information for files which are queued for upload.
- **dwExcludeFiles** Parameter

    - `HTTP_QUEUE_FLAG_NONE`: No files should be excluded.
    - `HTTP_QUEUE_FLAG_COMPLETED`: Exclude files which have been transferred. This flag is set after a queued file has been uploaded or downloaded successfully.
    - `HTTP_QUEUE_FLAG_FAILED`: Exclude files which where not successfully uploaded or downloaded. This flag is set when an error occurs, either when establishing a connection with the server or during the file transfer.
    - `HTTP_QUEUE_FLAG_CANCELED`: Exclude files which were canceled during the file transfer. This flag is only set when the HttpCancelQueuedFile function has been called and a queued file is in the process of being uploaded or downloaded.

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is an unsigned integer with a non-zero value which uniquely identifies the file in the queue. If there are no queued files which match the specified parameters, or the function fails, the return value is zero. To get extended error information, call HttpGetLastError.

### Remarks

- This function returns information about the first file in the current transfer queue. It is used in conjunction with the HttpGetNextQueuedFile function to obtain information about all queued files.

### Example

```cpp
// List all files in a file transfer queue
HTTPQUEUEDFILE queuedFile;
DWORD dwFileId;

dwFileId = HttpGetFirstQueuedFile(hQueue, HTTP_QUEUE_ALL, HTTP_QUEUE_FLAG_NONE, &queuedFile);

while (dwFileId != 0)
{
	switch (queuedFile.dwQueueMode)
	{
	case HTTP_QUEUE_DOWNLOAD:
		_tprintf(_T("%u: download \"%s\" to \"%s\"\n"),
				queuedFile.dwFileId,
				queuedFile.szRemoteFile,
				queuedFile.szLocalFile);
		break;

	case HTTP_QUEUE_UPLOAD:
		_tprintf(_T("%u: upload \"%s\" to \"%s\"\n"),
				queuedFile.dwFileId,
				queuedFile.szRemoteFile,
				queuedFile.szLocalFile);
		break;
	}

	dwFileId = HttpGetNextQueuedFile(hQueue, &queuedFile);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddQueuedFile](#httpaddqueuedfile-function)
- [HttpEnumQueuedFiles](#httpenumqueuedfiles-function)
- [HttpFindQueuedFile](#httpfindqueuedfile-function)
- [HttpGetNextQueuedFile](#httpgetnextqueuedfile-function)
- [HttpGetQueuedFile](#httpgetqueuedfile-function)

---

## HttpGetFormProperties Function

Return the properties of the specified form

### Prototype

```c
INT WINAPI HttpGetFormProperties(
    HFORM hForm,
    LPHTTPFORMPROPERTIES lpFormProp
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hForm` | `HFORM` | Handle to the virtual form. |
| `lpFormProp` | `LPHTTPFORMPROPERTIES` | Points to a HTTPFORMPROPERTIES structure which will contain information about the specified form. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpCreateForm](#httpcreateform-function)
- [HttpSetFormProperties](#httpsetformproperties-function)
- [HttpSubmitForm](#httpsubmitform-function)
- [HTTPFORMPROPERTIES](#httpformproperties-function)

---

## HttpGetLastError Function

Return the last error code

### Prototype

```c
DWORD WINAPI HttpGetLastError();
```

### Parameters

| Name | Type | Description |
|------|------|-------------|

### Return Value

- **Type**: `DWORD`
- The return value is the last error code value for the current thread. Functions set this value by calling the HttpSetLastError function. The Return Value section of each reference page notes the conditions under which the function sets the last error code.

### Remarks

- Error codes are unsigned 32-bit values which are private to each calling thread. You should call the HttpGetLastError function immediately when a function's return value indicates that an error has occurred. That is because some functions call HttpSetLastError(0) when they succeed, clearing the error code set by the most recently failed function.
- Most functions will set the last error code value when they fail; a few functions set it when they succeed. Function failure is typically indicated by a return value such as FALSE, NULL, INVALID_CLIENT or HTTP_ERROR. Those functions which call HttpSetLastError when they succeed are noted on the function reference page.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpGetErrorString](#httpgeterrorstring-function)
- [HttpSetLastError](#httpsetlasterror-function)

---

## HttpGetNextCookie Function

Return the next cookie set by the server

### Prototype

```c
DWORD_PTR WINAPI HttpGetNextCookie(
    HCLIENT hClient,
    DWORD_PTR dwCookie,
    LPTSTR lpszCookieName,
    LPINT lpnNameLen,
    LPTSTR lpszCookieValue,
    LPINT lpnValueLen
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `dwCookie` | `DWORD_PTR` | An unsigned integer value which specifies a cookie token returned by a previous call to either HttpGetFirstCookie or HttpGetNextCookie. |
| `lpszCookieName` | `LPTSTR` | A pointer to a string buffer which will contain the name of the first cookie set by the server. |
| `lpnNameLen` | `LPINT` | A pointer to an integer which specifies the maximum number of characters which may be copied into the buffer, including the terminating null character. When the function returns, this value is updated to specify the actual length of the cookie name string. |
| `lpszCookieValue` | `LPTSTR` | A pointer to a string buffer which will contain the name of the first cookie value set by the server. If the cookie value is not required, this parameter may be NULL. |
| `lpnValueLen` | `LPINT` | A pointer to an integer which specifies the maximum number of characters which may be copied into the buffer, including the terminating null character. When the function returns, this value is updated to specify the actual length of the cookie value string. If the lpszCookieValue parameter is NULL, this parameter should also be NULL. |

### Return Value

- **Type**: `DWORD_PTR`
- If the function succeeds, the return value is an opaque token which will be passed to the HttpGetNextCookie function to retrieve the next cookie. If there are no more cookies or the function fails, the return value is zero. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpGetNextCookie function is used to enumerate the cookies set by the server after a resource has been requested. The return value is an unsigned integer where the size depends on whether the application targets 32-bit or 64-bit platforms. This value should always be treated as an opaque integer which is only valid during the enumeration of the session cookies and should never be stored by the application.
- To get information about a specific cookie, use the HttpGetCookie function.

### Example

```cpp
TCHAR szCookieName[MAXCOOKIENAME];
TCHAR szCookieValue[MAXCOOKIEVALUE];
INT nNameLen, nValueLen;
DWORD_PTR dwCookie;

// Initialize the nNameLen and nValueLen variables to
// the maximum number of characters that can be copied
// into the string buffers
nNameLen = MAXCOOKIENAME;
nValueLen = MAXCOOKIEVALUE;

// Get the first cookie set by the server
dwCookie = HttpGetFirstCookie(hClient,
							szCookieName,
							&nNameLen,
							szCookieValue,
							&nValueLen);

while (dwCookie != 0)
{
	// The szCookieName and szCookieValue strings contain the
	// the name and value for a cookie set by the server

	// Re-initialize the nNameLen and nValueLen variables
	// to the maximum length of the strings
	nNameLen = MAXCOOKIENAME;
	nValueLen = MAXCOOKIEVALUE;

	// Get the next cookie set by the server
	dwCookie = HttpGetNextCookie(hClient,
								dwCookie,
								szCookieName,
								&nNameLen,
								szCookieValue,
								&nValueLen);
};
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetCookie](#httpgetcookie-function)
- [HttpGetFirstCookie](#httpgetfirstcookie-function)
- [HttpGetResponseHeader](#httpgetresponseheader-function)
- [HttpSetCookie](#httpsetcookie-function)
- [HttpSetRequestHeader](#httpsetrequestheader-function)

---

## HttpGetNextHeader Function

Return the name and value of the next request or response header field

### Prototype

```c
BOOL WINAPI HttpGetNextHeader(
    HCLIENT hClient,
    UINT nHeaderType,
    LPTSTR lpszHeader,
    LPINT lpcchHeader,
    LPTSTR lpszValue,
    LPINT lpcchValue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nHeaderType` | `UINT` | Specifies the type of header to return. It may be one of the following values: |
| `lpszHeader` | `LPTSTR` | A pointer to a string buffer that will contain the name of the header field when the function returns. |
| `lpcchHeader` | `LPINT` | A pointer to an integer which specifies the maximum number of characters which may be copied into the buffer, including the terminating null character. When the function returns, this value is updated to specify the actual length of the header name string. |
| `lpszValue` | `LPTSTR` | A pointer to a string buffer that will contain the name of the header value when the function returns. |
| `lpcchValue` | `LPINT` | A pointer to an integer which specifies the maximum number of characters which may be copied into the buffer, including the terminating null character. When the function returns, this value is updated to specify the actual length of the header value string. |

### Options

- **nHeaderType** Parameter

    - `HTTP_HEADERS_REQUEST`: Return the first header set by the client before a resource has been requested. Request headers typically specify information that the server needs to complete the request, such as the name of the host that has the resource, or what types of resources are acceptable to the client.
    - `HTTP_HEADERS_RESPONSE`: Return the first header set by the server after a request has been submitted to the server. The response headers typically contain information about the resource, such as its size, the content type and the date it was last modified.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the header field does not exist or the client handle is invalid, the function returns a value of zero. To get extended error information, call HttpGetLastError.

### Remarks

- Use this function iteratively after HttpGetFirstHeader to enumerate all request or response headers.
- Unlike the HttpGetResponseHeader function, which returns a single header name and value, the HttpGetFirstHeader and HttpGetNextHeader functions will return multiple headers that have the same common name.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetResponseHeader](#httpgetresponseheader-function)
- [HttpSetRequestHeader](#httpsetrequestheader-function)
- [HttpGetFirstHeader](#httpgetfirstheader-function)

---

## HttpGetNextQueuedFile Function

Return information about the next file in the transfer queue

### Prototype

```c
DWORD WINAPI HttpGetNextQueuedFile(
    HQUEUE hQueue,
    LPHTTPQUEUEDFILE lpFileInfo
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `lpFileInfo` | `LPHTTPQUEUEDFILE` | A pointer to a HTTPQUEUEDFILE structure which will contain information about the file. This parameter cannot be NULL. |

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is an unsigned integer with a non-zero value which uniquely identifies the file in the queue. If there are no additional queued files which match the exclusion criteria specified with the call to HttpGetFirstQueuedFile, the return value is zero. To get extended error information, call HttpGetLastError.

### Remarks

- This function returns information about the next file in the current transfer queue after an initial call to HttpGetFirstQueuedFile. To obtain a list of all matching files in the queue, call this function repeatedly until it returns a value of zero. When information about the last file in the queue has been returned, the last error code will be set to ST_ERROR_END_OF_QUEUE.

### Example

```cpp
// List all files in a file transfer queue
HTTPQUEUEDFILE queuedFile;
DWORD dwFileId;

dwFileId = HttpGetFirstQueuedFile(hQueue, HTTP_QUEUE_ALL, HTTP_QUEUE_FLAG_NONE, &queuedFile);

while (dwFileId != 0)
{
	switch (queuedFile.dwQueueMode)
	{
	case HTTP_QUEUE_DOWNLOAD:
		_tprintf(_T("%u: download \"%s\" to \"%s\"\n"),
				queuedFile.dwFileId,
				queuedFile.szRemoteFile,
				queuedFile.szLocalFile);
		break;

	case HTTP_QUEUE_UPLOAD:
		_tprintf(_T("%u: upload \"%s\" to \"%s\"\n"),
				queuedFile.dwFileId,
				queuedFile.szRemoteFile,
				queuedFile.szLocalFile);
		break;
	}

	dwFileId = HttpGetNextQueuedFile(hQueue, &queuedFile);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddQueuedFile](#httpaddqueuedfile-function)
- [HttpEnumQueuedFiles](#httpenumqueuedfiles-function)
- [HttpFindQueuedFile](#httpfindqueuedfile-function)
- [HttpGetFirstQueuedFile](#httpgetfirstqueuedfile-function)
- [HttpGetQueuedFile](#httpgetqueuedfile-function)

---

## HttpGetOption Function

Return the enabled/disabled state of a specified option

### Prototype

```c
INT WINAPI HttpGetOption(
    HCLIENT hClient,
    DWORD dwOption,
    LPBOOL lpbEnabled
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `dwOption` | `DWORD` | An unsigned integer which specifies the option that is to be checked. It may be one of the following values: |
| `lpbEnabled` | `LPBOOL` | A pointer to an integer which will be set to a non-zero value when the function returns if the specified option has been enabled. If the option has not been enabled, a zero value will be returned in the variable. |

### Options

- **dwOption** Parameter

    - `HTTP_OPTION_NOCACHE`: This instructs the server to not return a cached copy of the resource. When connected to an HTTP 1.0 or earlier server, this directive may be ignored.
    - `HTTP_OPTION_KEEPALIVE`: This instructs the server to maintain a persistent connection between requests. This can improve performance because it eliminates the need to establish a separate connection for each resource that is requested.
    - `HTTP_OPTION_REDIRECT`: This option specifies the client should automatically handle resource redirection. If the server indicates that the requested resource has moved to a new location, the client will close the current connection and request the resource from the new location. Note that it is possible that the redirected resource will be located on a different server.
    - `HTTP_OPTION_ERRORDATA`: This option specifies the client should return the content of an error response from the server, rather than returning an error code. Note that this option will disable automatic resource redirection, and should not be used with HTTP_OPTION_REDIRECT.
    - `HTTP_OPTION_NOUSERAGENT`: This option specifies the client should not include a User-Agent header with any requests made during the session. The user agent is a string which is used to identify the client application to the server.
    - `HTTP_OPTION_TUNNEL`: This option specifies that a tunneled TCP connection and/or port-forwarding is being used to establish the connection to the server. This changes the behavior of the client with regards to internal checks of the destination IP address and remote port number, default capability selection and how the connection is established.
    - `HTTP_OPTION_TRUSTEDSITE`: This option specifies the server is trusted. The server certificate will not be validated and the connection will always be permitted. This option only affects connections using the TLS protocol.
    - `HTTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. Note that the server must support secure connections using the TLS protocol. The client will default to using TLS 1.2 or later for secure connections.
    - `HTTP_OPTION_SECURE_FALLBACK`: This option specifies the client should permit the use of less secure cipher suites for compatibility with legacy servers. If this option is specified, the client will allow connections using TLS 1.0 and cipher suites that use RC4, MD5 and SHA1.
    - `HTTP_OPTION_PREFER_IPV6`: This option specifies the client should prefer the use of IPv6 if the server hostname can be resolved to both an IPv6 and IPv4 address. This option is ignored if the local system does not have IPv6 enabled, or when the hostname can only be resolved to an IPv4 address. If the server hostname can only be resolved to an IPv6 address, the client will attempt to establish a connection using IPv6 regardless if this option has been specified.
    - `HTTP_OPTION_FREETHREAD`: This option specifies the handle returned by this function may be used by any thread, and is not limited to the thread which created it. The application is responsible for ensuring that access to the handle is synchronized across multiple threads.
    - `HTTP_OPTION_HIRES_TIMER`: This option specifies the elapsed time for data transfers should be returned in milliseconds instead of seconds. This will return more accurate transfer times for smaller amounts of data over fast network connections.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError. Note that the value returned in the lpbEnabled parameter is only valid if the function succeeds.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpConnect](#httpconnect-function)
- [HttpSetOption](#httpsetoption-function)

---

## HttpGetPriority Function

Return the current priority for file transfers

### Prototype

```c
INT WINAPI HttpGetPriority(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the current file transfer priority. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpGetPriority function can be used to determine the current priority assigned to file transfers performed by the client. It may be one of the following values:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpSetPriority](#httpsetpriority-function)

---

## HttpGetQueueClient Function

Return the handle to the current client session

### Prototype

```c
HCLIENT WINAPI HttpGetQueueClient(
    HQUEUE hQueue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |

### Return Value

- **Type**: `HCLIENT`
- If the function succeeds, the return value a handle to a client session. If the function fails, it will return INVALID_CLIENT. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpGetQueueClient function returns the handle to a client session which may be used with other functions, such as HttpGetTransferStatus. A valid handle will only be returned if the queue manager is currently uploading or downloading a file. If the queue is active but there are no file transfers in progress at the time this function is called, it will fail and set the last error code to ST_ERROR_NO_QUEUED_TRANSFER.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpGetTransferStatus](#httpgettransferstatus-function)
- [HttpGetTransferStatusEx](#httpgettransferstatusex-function)
- [HttpGetQueueStatus](#httpgetqueuestatus-function)
- [HttpGetThreadQueue](#httpgetthreadqueue-function)
- [HttpStartQueue](#httpstartqueue-function)
- [HttpStopQueue](#httpstopqueue-function)

---

## HttpGetQueuedFile Function

Return information about a file queued for transfer

### Prototype

```c
BOOL WINAPI HttpGetQueuedFile(
    HQUEUE hQueue,
    DWORD dwFileId,
    LPHTTPQUEUEDFILE lpFileInfo
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `dwFileId` | `DWORD` | An unsigned integer value which uniquely identifies the file in the queue. This value cannot be zero. |
| `lpFileInfo` | `LPHTTPQUEUEDFILE` | A pointer to a HTTPQUEUEDFILE structure which will contain information about the file. This parameter cannot be NULL. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the file identifier is not valid or the file has been removed from the queue, the return value is zero. To get extended error information, call HttpGetLastError.

### Remarks

- The file identifier can be obtained by several different functions, including HttpEnumQueuedFiles and HttpGetQueueStatus, which provides information about the current file being processed in the queue. Do not make any assumptions about the value of the identifier. Although the value is guaranteed to be unique for the specified queue, it is not guaranteed that file identifiers will be assigned in sequential order.

### Example

```cpp
// Get the number of files in the queue
LONG nFiles = HttpEnumQueuedFiles(hQueue, NULL, 0)

// Display information about the queued files
if (nFiles > 0)
{
	DWORD *pdwFileList = new DWORD[nFiles];

	nFiles = HttpEnumQueuedFiles(hQueue, pdwFileList, nFiles);

	for (LONG nIndex = 0; nIndex < nFiles; nIndex++)
	{
		HTTPQUEUEDFILE queuedFile;

		if (HttpGetQueuedFile(hQueue, pdwFileList[nIndex], &queuedFile) == FALSE)
			break;
			
		switch (queuedFile.dwMode)
		{
		case HTTP_QUEUE_DOWNLOAD:
			_tprintf(_T("%u: Download \"%s\" to \"%s\"\n"),
						queuedFile.dwFileId,
						queuedFile.szRemoteFile,
						queuedFile.szLocalFile);
				break;

		case HTTP_QUEUE_UPLOAD:
			_tprintf(_T("%u: Upload \"%s\" to \"%s\"\n"),
						queuedFile.dwFileId,
						queuedFile.szLocalFile,
						queuedFile.szRemoteFile);
				break;
		}
	}
	
	delete pdwFileList;
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddQueuedFile](#httpaddqueuedfile-function)
- [HttpEnumQueuedFiles](#httpenumqueuedfiles-function)
- [HttpFindQueuedFile](#httpfindqueuedfile-function)
- [HttpGetFirstQueuedFile](#httpgetfirstqueuedfile-function)
- [HttpGetNextQueuedFile](#httpgetnextqueuedfile-function)
- [HttpGetQueueStatus](#httpgetqueuestatus-function)

---

## HttpGetQueueStatus Function

Return the status of the current file transfer queue

### Prototype

```c
INT WINAPI HttpGetQueueStatus(
    HQUEUE hQueue,
    LPHTTPQUEUESTATUS lpQueueStatus
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `lpQueueStatus` | `LPHTTPQUEUESTATUS` | A pointer to a HTTPQUEUESTATUS structure which will contain information about the current state of the file transfer queue. If this parameter is NULL, the function will ignore the parameter and only return the current status of the queue. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the current queue status. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError. The following status values may be returned:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpCancelQueuedFile](#httpcancelqueuedfile-function)
- [HttpResetQueue](#httpresetqueue-function)
- [HttpResumeQueue](#httpresumequeue-function)
- [HttpStartQueue](#httpstartqueue-function)
- [HttpSuspendQueue](#httpsuspendqueue-function)
- [HttpStopQueue](#httpstopqueue-function)

---

## HttpGetQueueThread Function

Return a value which uniquely identifies the queue manager thread

### Prototype

```c
DWORD WINAPI HttpGetQueueThread(
    HQUEUE hQueue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is non-zero and specifies a unique identifier for the queue manager thread. If the function fails, it will return zero. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpGetQueueThread function can be used to obtain a unique identifier for the queue manager thread which is responsible for performing the file transfers. If the function returns zero, this indicates that either the queue handle is no longer valid, or the queue is idle and no files are currently being processed. To obtain the handle to a queue associated with a particular thread, call the HttpGetThreadQueue function.
- You should not store the thread ID or consider it a persistent value, even during the lifetime of the process. It is only valid while the queue manager is actively processing files in the queue. The thread ID value will change every time the HttpStartQueue function is called.
- Never use the thread ID to obtain a handle to the thread and call Windows API functions such as SuspendThread or TerminateThread. This can result inconsistency within the internal state of the queue manager and may result in incomplete or corrupted file transfers.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpGetQueueStatus](#httpgetqueuestatus-function)
- [HttpGetThreadQueue](#httpgetthreadqueue-function)
- [HttpStartQueue](#httpstartqueue-function)
- [HttpStopQueue](#httpstopqueue-function)

---

## HttpGetRedirectUrl Function

Return the URL for a redirected resource

### Prototype

```c
INT WINAPI HttpGetRedirectUrl(
    HCLIENT hClient,
    LPTSTR lpszResource,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResource` | `LPTSTR` | A pointer to a string buffer which will contain the URL of the redirected resource when the function returns. The string will be null terminated and the the buffer must be large enough to accommodate the entire URL or the function will fail. This parameter cannot be a NULL pointer. |
| `nMaxLength` | `INT` | The maximum number of characters that may be copied into the string buffer. This value must be greater than zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the URL. A return value of zero indicates that the request was not redirected. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- This function returns the complete URL for a request which has been redirected to a different resource. This is useful for applications which do not wish to use automatic redirection and instead prefer to handle the redirection by establishing a new connection by passing this value to the HttpConnectUrl function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpConnectUrl](#httpconnecturl-function)
- [HttpGetResourceUrl](#httpgetresourceurl-function)
- [HttpGetResponseHeader](#httpgetresponseheader-function)

---

## HttpGetRequestHeader Function

Return the value of the specified request header field

### Prototype

```c
BOOL WINAPI HttpGetRequestHeader(
    HCLIENT hClient,
    LPCTSTR lpszHeader,
    LPTSTR lpszValue,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszHeader` | `LPCTSTR` | Pointer to a string which specifies the header value to be returned. |
| `lpszValue` | `LPTSTR` | Pointer to a buffer which will contain the null-terminated string value of the specified header field. |
| `nMaxLength` | `INT` | Maximum number of characters that may be copied into the buffer, including the terminating null character. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the header field does not exist or the client handle is invalid, the function returns a value of zero. To get extended error information, call HttpGetLastError.

### Remarks

- When a resource is requested from the server, it consists of two parts. The first part is the command issued to the server, along with the name of the resource and any optional encoded parameters. The second part consists of one or more header fields which can be used to provide additional information to the server. For example, here is what the command and header may look like for a simple request:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetResponseHeader](#httpgetresponseheader-function)
- [HttpSetRequestHeader](#httpsetrequestheader-function)

---

## HttpGetResourceUrl Function

Return the URL for the current request

### Prototype

```c
INT WINAPI HttpGetResourceUrl(
    HCLIENT hClient,
    LPTSTR lpszResource,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResource` | `LPTSTR` | A pointer to a string buffer which will contain the URL of the current resource when the function returns. The string will be null terminated and the the buffer must be large enough to accommodate the entire URL or the function will fail. This parameter cannot be a NULL pointer. |
| `nMaxLength` | `INT` | The maximum number of characters that may be copied into the string buffer. This value must be greater than zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the URL. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- This function returns the URL for the current request which has been submitted to the server. This can be useful for applications which need to compose a URL for display or logging purposes, combining the connection information and resource path provided to functions such as HttpGetData or HttpPostData.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpConnectUrl](#httpconnecturl-function)
- [HttpGetData](#httpgetdata-function)
- [HttpGetRedirectUrl](#httpgetredirecturl-function)
- [HttpPostData](#httppostdata-function)

---

## HttpGetResponseHeader Function

Return the value of the specified response header field

### Prototype

```c
BOOL WINAPI HttpGetResponseHeader(
    HCLIENT hClient,
    LPCTSTR lpszHeader,
    LPTSTR lpszValue,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszHeader` | `LPCTSTR` | Pointer to a string which specifies the header value to be returned. |
| `lpszValue` | `LPTSTR` | Pointer to a buffer which will contain the null-terminated string value of the specified header field. |
| `nMaxLength` | `INT` | Maximum number of characters that may be copied into the buffer, including the terminating null character. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the header field does not exist or the client handle is invalid, the function returns a value of zero. To get extended error information, call HttpGetLastError.

### Remarks

- When a resource is returned by the server, it consists of three parts. The first part consists of a single line that indicates the result of the request. The second part is one or more header fields which provides specific information about the resource, such as its size in bytes. The third part consists of the resource data itself, such as the HTML document or image data. For example, this is what the response to a request for a simple HTML document can look like:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetContentLength](#httpgetcontentlength-function)
- [HttpGetContentType](#httpgetcontenttype-function)
- [HttpGetCookie](#httpgetcookie-function)
- [HttpGetFirstCookie](#httpgetfirstcookie-function)
- [HttpGetFirstHeader](#httpgetfirstheader-function)
- [HttpGetNextCookie](#httpgetnextcookie-function)
- [HttpGetNextHeader](#httpgetnextheader-function)
- [HttpGetRequestHeader](#httpgetrequestheader-function)
- [HttpSetRequestHeader](#httpsetrequestheader-function)

---

## HttpGetResultCode Function

Return the result code from the previous command

### Prototype

```c
INT WINAPI HttpGetResultCode(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- Result codes are three-digit numeric values returned by the server. They may be broken down into the following ranges:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpCommand](#httpcommand-function)
- [HttpGetResultString](#httpgetresultstring-function)

---

## HttpGetResultString Function

Return the result string from the previous command

### Prototype

```c
INT WINAPI HttpGetResultString(
    HCLIENT hClient,
    LPTSTR lpszResult,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResult` | `LPTSTR` | A pointer to the buffer that will contain the result string returned by the server. |
| `nMaxLength` | `INT` | The maximum number of characters that may be copied into the result string buffer, including the terminating null character. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the result string. If a value of zero is returned, this means that no result string was sent by the server. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpGetResultString function is most useful when an error occurs because the server will typically include a brief description of the cause of the error. This can then be parsed by the application or displayed to the user. The result string is updated each time the client sends a command to the server and then calls HttpGetResultCode to obtain the result code for the operation.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpCommand](#httpcommand-function)
- [HttpGetResultCode](#httpgetresultcode-function)

---

## HttpGetSecurityInformation Function

Return security information about the current client connection

### Prototype

```c
BOOL WINAPI HttpGetSecurityInformation(
    HCLIENT hClient,
    LPSECURITYINFO lpSecurityInfo
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpSecurityInfo` | `LPSECURITYINFO` | A pointer to a SECURITYINFO structure which contains information about the current client connection. The dwSize member of this structure must be initialized to the size of the structure before passing the address of the structure to this function. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetLastError.

### Remarks

- This function is used to obtain security related information about the current client connection to the server. It can be used to determine if a secure connection has been established, what security protocol was selected, and information about the server certificate. Note that a secure connection has not been established, the dwProtocol structure member will contain the value SECURITY_PROTOCOL_NONE.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpConnect](#httpconnect-function)
- [HttpDisconnect](#httpdisconnect-function)
- [HttpGetOption](#httpgetoption-function)
- [HttpProxyConnect](#httpproxyconnect-function)
- [HttpSetOption](#httpsetoption-function)
- [SECURITYINFO](#securityinfo-function)

---

## HttpGetStatus Function

Return the current client status

### Prototype

```c
INT WINAPI HttpGetStatus(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the client status code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpGetStatus function returns a numeric code which identifies the current state of the client session. The following values may be returned:
- In a multithreaded application, any thread in the current process may call this function to obtain status information for the specified client session. To obtain status information about a file transfer, use the HttpGetTransferStatus function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpIsBlocking](#httpisblocking-function)
- [HttpIsReadable](#httpisreadable-function)
- [HttpIsWritable](#httpiswritable-function)
- [HttpGetTransferStatus](#httpgettransferstatus-function)

---

## HttpGetTaskError Function

Return the last error code for the specified asynchronous task

### Prototype

```c
DWORD WINAPI HttpGetTaskError(
    UINT nTaskId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nTaskId` | `UINT` | The task identifier. |

### Return Value

- **Type**: `DWORD`
- If the asynchronous task has completed successfully, this function returns a value of zero. A non-zero return value indicates an error has occurred.

### Remarks

- The HttpGetTaskError function returns the last error code associated with the specified asynchronous task. If the task completed successfully, the return value will be zero. If the task is still active, the function will return the error ST_ERROR_TASK_ACTIVE. If the task has been suspended, the function will return ST_ERROR_TASK_SUSPENDED. Any other value indicates that the task completed, but the operation has failed and the error code will specify the cause of the failure.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpTaskAbort](#httptaskabort-function)
- [HttpTaskResume](#httptaskresume-function)
- [HttpTaskSuspend](#httptasksuspend-function)
- [HttpTaskWait](#httptaskwait-function)

---

## HttpGetTaskId Function

Return the unique task identifier associated with the specified client session

### Prototype

```c
UINT WINAPI HttpGetTaskId(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is non-zero integer value that specifies a unique asynchronous task identifier. If the client handle is not associated with an asynchronous task, the function will return a value of zero.

### Remarks

- The HttpGetTaskId function will return the task ID that is associated with a client session. This is a unique unsigned integer value that references the worker thread that was created to manage the asynchronous client session. This function should only be called within an event handler that is invoked by a background task that has been started using a function such as HttpAsyncGetFile.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpTaskAbort](#httptaskabort-function)
- [HttpTaskDone](#httptaskdone-function)
- [HttpTaskResume](#httptaskresume-function)
- [HttpTaskSuspend](#httptasksuspend-function)
- [HttpTaskWait](#httptaskwait-function)

---

## HttpGetText Function

Return the contents of a text resource to a string buffer

### Prototype

```c
INT WINAPI HttpGetText(
    HCLIENT hClient,
    LPCTSTR lpszResource,
    LPTSTR lpszBuffer,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResource` | `LPCTSTR` | A pointer to a string that specifies the resource that will be transferred to the local system. This may be the name of a file on the server, or it may specify the name of a script that will be executed and the output returned to the caller. This string may specify a valid URL for the current server that the client is connected to. |
| `lpszBuffer` | `LPTSTR` | A pointer to a string buffer which will contain the contents of the text file when the function returns. This buffer should be large enough to store the contents of the file, including a terminating null character. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer. This value must be larger than zero. If this value is smaller than the actual size of the text file, the data returned will be truncated. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpGetText function is used to retrieve the contents of a text resource and return it in a null-terminated string buffer. Because binary data can include embedded null characters which would truncate the string, this function should only be used with text files or script output that is known to be textual. For example, it is safe to use this function when a resource returns HTML or XML data, but should not be used if it returns an image or executable file.
- This function has been included as a convenience for applications that need to retrieve relatively small amounts of textual data and manipulate the contents as a string. If the Unicode version of this function is called, the text is automatically converted to a Unicode string. If the maximum amount of data being returned is unknown or the amount of text is very large, it is recommended that you use the HttpGetTextEx or HttpGetFile functions.
- If the ANSI version of this function is called, the text returned will always be UTF-8 encoded. If you need to return the text using a different code page, use the HttpGetTextEx function which will allow you to specify a different code page used for the conversion.
- If you use the HttpGetFileSize function to determine how large the string buffer should be prior to calling this function, it is important to be aware that the actual number of characters may differ based on the end-of-line conventions used by the host operating system. For example, if you call HttpGetFileSize to obtain the size of a text file on a UNIX system, the value will not be large enough to store the complete file because UNIX uses a single linefeed (LF) character to indicate the end-of-line, while a Windows system will use a carriage-return and linefeed (CRLF) pair. To accommodate this difference, you should always allocate extra memory for the string buffer to store the additional end-of-line characters.
- HTTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling HttpEnableEvents, or by registering a callback function using the HttpRegisterEvent function.
- To determine the current status of a file transfer while it is in progress, use the HttpGetTransferStatus function.

### Example

```cpp
LPTSTR lpszBuffer = (LPTSTR)calloc(MAXFILESIZE, sizeof(TCHAR));

if (lpszBuffer == NULL)
	return;

nResult = HttpGetText(hClient, lpszRemoteFile, lpszBuffer, MAXFILESIZE);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetData](#httpgetdata-function)
- [HttpGetFile](#httpgetfile-function)
- [HttpGetTextEx](#httpgettextex-function)
- [HttpPutData](#httpputdata-function)
- [HttpPutFile](#httpputfile-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpGetTextEx Function

Return the contents of a text resource with additional conversion options

### Prototype

```c
INT WINAPI HttpGetTextEx(
    HCLIENT hClient,
    LPCTSTR lpszResource,
    LPVOID lpvBuffer,
    LPINT lpcchBuffer,
    UINT nCodePage,
    DWORD dwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResource` | `LPCTSTR` | A pointer to a string that specifies the resource on the server. This may be the name of a file on the server, or it may specify the name of a script that will be executed and the output returned to the caller. This string may specify a valid URL for the current server. |
| `lpvBuffer` | `LPVOID` | A pointer to a null-terminated string buffer which will contain the text return by the server, or a pointer to a global memory handle which will reference the text when the function returns. If you are providing a pre-allocated string buffer, it must be large enough to store the terminating null character. |
| `lpcchBuffer` | `LPINT` | A pointer to an integer which should be initialized to the maximum number of characters which can be copied to the string specified by the lpvBuffer parameter. If the lpvBuffer parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the actual number of characters copied into the string. |
| `nCodePage` | `UINT` | An unsigned integer that specifies the ANSI code page which should be used to convert the text returned by the server. A value of zero specifies the default system code page should be used with the conversion. See the remarks below for more information. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |

### Options

- **dwOptions** Parameter

    - `HTTP_TRANSFER_DEFAULT`: The default transfer mode. The resource data is downloaded to the local system exactly as it is stored on the server. If you are requesting a text-based resource, the data may use a different end-of-line character sequence. For example, the end-of-line character may be a single linefeed character instead of a carriage return and linefeed pair.
    - `HTTP_TRANSFER_CONVERT`: If the resource being downloaded from the server is textual, the data is automatically converted so that the end of line character sequence is compatible with the Windows platform. Individual carriage return or linefeed characters are converted to carriage return/linefeed character sequences. This option is enabled by default.
    - `HTTP_TRANSFER_ERRORDATA`: This option causes the client to accept error data from the server if the request fails. If this option is specified, an error response from the server will not cause the function to fail. Instead, the response is returned to the client and the function will succeed. If this option is used, your application should call HttpGetResultCode to obtain the HTTP status code returned by the server. This will enable you to determine if the operation was successful.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpGetTextEx function is used to retrieve the contents of a text resource and return it in a null-terminated string buffer. Because binary data can include embedded null characters which would truncate the string, this function should only be used with text files or script output that is known to be textual. For example, it is safe to use this function when a resource returns HTML or XML data, but should not be used if it returns an image or executable file. Attempting to use this function to retrieve a resource which is not textual will result in an error.
- This function may be used in one of two ways, depending on the needs of the application. The first method is to pre-allocate a buffer large enough to store the contents of the file. In this case, the lpvBuffer parameter will point to the buffer that was allocated and the value the lpcchBuffer parameter points to should be initialized to the size of that buffer. The buffer must be large enough to contain the entire response from the server, including a terminating null character to indicate the end of the string. If the string buffer is too small, the function will fail.
- The second approach is to have the lpvBuffer parameter point to a global memory handle which will contain the text when the function returns. In this case, the value that the lpcchBuffer parameter points to must be initialized to zero. It is important to note that the memory handle returned by the function must be freed by the application, otherwise a memory leak will occur. See the example code below.
- Important: The lpcchBuffer parameter specifies the number of characters, not the number of bytes. If the Unicode version of this function is called, the string buffer will contain Unicode text . If the ANSI version of the function is called, the string will contain ANSI text using the code page specified by the nCodePage parameter. When the function returns, the lpcchBuffer parameter will contain the number of characters copied into the string buffer, not including the terminating null character.
- The nCodePage parameter is only meaningful when using the ANSI version of this function. If the Unicode version of the function is called, this value of this parameter should always be either CP_ACP or CP_UTF8. When the ANSI version of this function is called, the text returned by the server will be automatically converted to the requested code page. For example, if you specify CP_ACP as the code page and the server returns the text as UTF-8 encoded text, this function will attempt to convert the text to the local system's default code page. If the conversion cannot be performed, an the function will fail. This can occur if you use a code page which cannot represent the all of the characters in the string. In most cases, it is recommended you use CP_UTF8 as the code page.
- This function will attempt to determine the encoding used based on the character set returned by the server. If the character set used is not explicitly specified by the server, the function will try to determine the character set based on the contents of the server response. The function will always check if the text is UTF-8 encoded first, and then check if the text matches the default character set used by the local system (e.g.: windows-1252 or iso-8859-1). The function will fail if it cannot determine how the text should be converted to Unicode or the specified ANSI code page.
- If you use the HttpGetFileSize function to determine how large the string buffer should be prior to calling this function, it is important to be aware that the actual number of characters may differ based on the end-of-line conventions and character encoding used by the host operating system. For example, if you call HttpGetFileSize to obtain the size of a text file on a UNIX system, the value will not be large enough to store the complete file because UNIX uses a single linefeed (LF) character to indicate the end-of-line, while a Windows system will use a carriage-return and linefeed (CRLF) pair. To accommodate this difference, you should always allocate extra memory for the string buffer to store the additional end-of-line characters.
- This function will cause the current thread to block until the file transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the HTTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling HttpEnableEvents, or by registering a callback function using the HttpRegisterEvent function.
- To determine the current status of a file transfer while it is in progress, use the HttpGetTransferStatus function.

### Example

```cpp
HGLOBAL hgblBuffer = NULL;
DWORD cchBuffer = 0;

// Store the response in a block of global memory allocated by
// the GlobalAlloc function; the handle to this memory will be
// returned in the hgblBuffer parameter
nResult = HttpGetTextEx(hClient,
						lpszResource,
						&hgblBuffer,
						&cchBuffer,
						CP_UTF8,
						HTTP_TRANSFER_DEFAULT);

if (nResult != HTTP_ERROR)
{
	// Lock the global memory handle, returning a pointer to the
	// resource data
	LPTSTR lpszBuffer = (LPTSTR)GlobalLock(hgblBuffer);
	
	// After the data has been used, the handle must be unlocked
	// and freed, otherwise a memory leak will occur
	GlobalUnlock(hgblBuffer);
	GlobalFree(hgblBuffer);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetFile](#httpgetfile-function)
- [HttpGetText](#httpgettext-function)
- [HttpPostJson](#httppostjson-function)
- [HttpPostXml](#httppostxml-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpGetThreadQueue Function

Return the handle to a queue associated with the specified thread

### Prototype

```c
HQUEUE WINAPI HttpGetThreadQueue(
    DWORD dwThreadId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `dwThreadId` | `DWORD` | An unsigned integer value which specifies a unique identifier for the queue manager thread. If this value is zero, it will return the handle associated with the current thread. |

### Return Value

- **Type**: `HQUEUE`
- If the function succeeds, the return value is the handle to the queue. If the function fails, it will return INVAID_QUEUE. To get extended error information, call HttpGetLastError.

### Remarks

- All queued file transfers are handled by a queue manager which executes asynchronously in a background worker thread. This worker thread is created when the HttpStartQueue function is called and terminates when all files in the queue have been processed, or when the HttpStopQueue function is called. This function will return the queue handle associated with that worker thread.
- The most common use of this function would be to obtain the handle for the queue from within a queue event handler. The application would pass in a value of zero as the thread ID and the function will return the handle to the queue which invoked the event notification.
- If you call this function outside of an event handler and the dwThreadId parameter is zero, or if the queue is idle and not transferring files, this function will return INVALID_QUEUE. The thread ID is only valid while the queue manager is actively processing files in the queue.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpGetQueueStatus](#httpgetqueuestatus-function)
- [HttpGetQueueThread](#httpgetqueuethread-function)
- [HttpStartQueue](#httpstartqueue-function)
- [HttpStopQueue](#httpstopqueue-function)

---

## HttpGetTimeout Function

Return the number of seconds until an operation times out

### Prototype

```c
INT WINAPI HttpGetTimeout(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the timeout period in seconds. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The timeout value is only used with blocking client connections. A value of zero indicates that the default timeout period of 20 seconds should be used.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpConnect](#httpconnect-function)
- [HttpProxyConnect](#httpproxyconnect-function)
- [HttpSetTimeout](#httpsettimeout-function)

---

## HttpGetTransferStatus Function

Return data transfer statistics

### Prototype

```c
INT WINAPI HttpGetTransferStatus(
    HCLIENT hClient,
    LPHTTPTRANSFERSTATUS lpStatus
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpStatus` | `LPHTTPTRANSFERSTATUS` | A pointer to an HTTPTRANSFERSTATUS structure which contains information about the status of the current data transfer. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpGetTransferStatus function returns information about the current data transfer, including the average number of bytes transferred per second and the estimated amount of time until the transfer completes. If there is no data currently being transferred, this function will return the status of the last successful transfer made by the client.
- In a multithreaded application, any thread in the current process may call this function to obtain status information for the specified client session.
- If the option HTTP_OPTION_HIRES_TIMER has been specified when connecting to the server, the values of the dwTimeElapsed and dwTimeEstimated members of the HTTPTRANSFERSTATUS structure will be in milliseconds instead of seconds. You can use this option to obtain more accurate elapsed times when uploading or downloading small amounts of data over a fast network connection.
- If you are uploading or downloading large files which exceed 4GB, you should use the HttpGetTransferStatusEx function which returns the size as a 64-bit value.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `Unknown`

### See Also

- [HttpEnableEvents](#httpenableevents-function)
- [HttpGetTransferStatusEx](#httpgettransferstatusex-function)
- [HttpRegisterEvent](#httpregisterevent-function)
- [HTTPTRANSFERSTATUS](#httptransferstatus-function)
- [HTTPTRANSFERSTATUSEX](#httptransferstatusex-function)

---

## HttpInitialize Function

Initialize the library and validate the specified runtime license key

### Prototype

```c
BOOL WINAPI HttpInitialize(
    LPCTSTR lpszLicenseKey,
    LPINITDATA lpData
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszLicenseKey` | `LPCTSTR` | Pointer to a string that specifies the runtime license key to be validated. If this parameter is NULL, the library will validate the development license installed on the local system. |
| `lpData` | `LPINITDATA` | Pointer to an INITDATA data structure. This parameter may be NULL if the initialization data for the library is not required. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetLastError. All other client functions will fail until a license key has been successfully validated.

### Remarks

- This must be the first function that an application calls before using any of the other functions in the library. When a NULL license key is specified, the library will only function on the development system. Before redistributing the application to an end-user, you must insure that this function is called with a valid license key.
- If the lpData argument is specified, it must point to an INITDATA structure which has been initialized by setting the dwSize member to the size of the structure. All other structure members should be set to zero. If the function is successful, then the INITDATA structure will be filled with identifying information about the library.
- Although it is only required that HttpInitialize be called once for the current process, it may be called multiple times; however, each call must be matched by a corresponding call to HttpUninitialize.
- This function dynamically loads other system libraries and allocates thread local storage. If you are calling the functions in this library from within another DLL, it is important that you do not call the HttpInitialize or HttpUninitialize functions from the DllMain function because it can result in deadlocks or access violation errors. If the DLL is linked with the C runtime library (CRT), it will automatically call the constructors and destructors for static and global C++ objects and has the same restrictions.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpConnect](#httpconnect-function)
- [HttpDisconnect](#httpdisconnect-function)
- [HttpProxyConnect](#httpproxyconnect-function)
- [HttpUninitialize](#httpuninitialize-function)

---

## HttpIsBlocking Function

Determine if the client is blocked, waiting for information

### Prototype

```c
BOOL WINAPI HttpIsBlocking(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `BOOL`
- If the client is performing a blocking operation, the function returns a non-zero value. If the client is not performing a blocking operation, or the client handle is invalid, the function returns zero.

### Remarks

- Because a blocking operation can allow the application to be re-entered (for example, by pressing a button while the operation is being performed), it is possible that another blocking function may be called while it is in progress. Since only one thread of execution may perform a blocking operation at any one time, an error would occur. The HttpIsBlocking function can be used to determine if the client is already blocked, and if so, take some other action (such as warning the user that they must wait for the operation to complete).

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpCancel](#httpcancel-function)
- [HttpIsConnected](#httpisconnected-function)
- [HttpIsReadable](#httpisreadable-function)
- [HttpIsWritable](#httpiswritable-function)
- [HttpRead](#httpread-function)
- [HttpWrite](#httpwrite-function)

---

## HttpIsConnected Function

Determine if the client is connected to the server

### Prototype

```c
BOOL WINAPI HttpIsConnected(
    HCLIENT hClient
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |

### Return Value

- **Type**: `BOOL`
- If the client is connected to a server, the function returns a non-zero value. If the client is not connected, or the client handle is invalid, the function returns zero.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpIsBlocking](#httpisblocking-function)
- [HttpIsReadable](#httpisreadable-function)
- [HttpIsWritable](#httpiswritable-function)

---

## HttpIsReadable Function

Determine if data can be read from the server

### Prototype

```c
BOOL WINAPI HttpIsReadable(
    HCLIENT hClient,
    INT nTimeout,
    LPDWORD lpdwAvail
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nTimeout` | `INT` | Timeout for server response, in seconds. A value of zero specifies that the connection should be polled without blocking the current thread. |
| `lpdwAvail` | `LPDWORD` | A pointer to an unsigned integer which will contain the number of bytes available to read. This parameter may be NULL if this information is not required. |

### Return Value

- **Type**: `BOOL`
- If the client can read data from the server within the specified timeout period, the function returns a non-zero value. If the client cannot read any data, the function returns zero.

### Remarks

- On some platforms, this value will not exceed the size of the receive buffer (typically 64K bytes). Because of differences between TCP/IP stack implementations, it is not recommended that your application exclusively depend on this value to determine the exact number of bytes available. Instead, it should be used as a general indicator that there is data available to be read.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpGetStatus](#httpgetstatus-function)
- [HttpIsBlocking](#httpisblocking-function)
- [HttpIsConnected](#httpisconnected-function)
- [HttpIsWritable](#httpiswritable-function)
- [HttpRead](#httpread-function)

---

## HttpIsWritable Function

Determine if data can be written to the server

### Prototype

```c
BOOL WINAPI HttpIsWritable(
    HCLIENT hClient,
    INT nTimeout
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nTimeout` | `INT` | Timeout for server response, in seconds. A value of zero specifies that the connection should be polled without blocking the current thread. |

### Return Value

- **Type**: `BOOL`
- If the client can write data to the server within the specified timeout period, the function returns a non-zero value. If the client cannot write any data, the function returns zero.

### Remarks

- Although this function can be used to determine if some amount of data can be sent to the remote process it does not indicate the amount of data that can be written without blocking the client. In most cases, it is recommended that large amounts of data be broken into smaller logical blocks, typically some multiple of 512 bytes in length.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpGetStatus](#httpgetstatus-function)
- [HttpIsBlocking](#httpisblocking-function)
- [HttpIsConnected](#httpisconnected-function)
- [HttpIsReadable](#httpisreadable-function)
- [HttpWrite](#httpwrite-function)

---

## HttpOpenFile Function

Open a file on the server for reading

### Prototype

```c
INT WINAPI HttpOpenFile(
    HCLIENT hClient,
    LPCTSTR lpszFileName,
    DWORD dwOffset
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileName` | `LPCTSTR` | Points to a string that specifies the name of the remote file to open. |
| `dwOffset` | `DWORD` | Specifies a byte offset into the file. If this value is greater than zero, the server must support the ability to specify a byte range with the request to open the file, otherwise this function will fail. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- Only one file may be opened at a time for each client session. Use the HttpCloseFile function to close the file on the server.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpCloseFile](#httpclosefile-function)

---

## HttpPatchData Function

Submits JSON or XML patch data to the server and returns the response

### Prototype

```c
INT WINAPI HttpPatchData(
    HCLIENT hClient,
    LPCTSTR lpszResource,
    LPCTSTR lpszPatchData,
    LPVOID lpvResult,
    LPDWORD lpcbResult,
    DWORD dwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResource` | `LPCTSTR` | A pointer to a string that specifies the resource name that the patch data will be submitted to. Typically this is the name of a script on the server. |
| `lpszPatchData` | `LPCTSTR` | A pointer to a string that specifies the patch data that will be submitted to the server. |
| `lpvResult` | `LPVOID` | A pointer to a byte buffer which will contain the data returned by the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpcbResult` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvResult parameter. If the lpvResult parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the number of bytes of data returned by the server. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |

### Options

- **dwOptions** Parameter

    - `HTTP_PATCH_DEFAULT`: The default post mode. The contents of the buffer will be submitted without encoding. The data returned by the server is copied to the result buffer exactly as it is returned from the server.
    - `HTTP_PATCH_CONVERT`: If the data being returned from the server is textual, it is automatically converted so that the end of line character sequence is compatible with the Windows platform. Individual carriage return or linefeed characters are converted to carriage return/linefeed character sequences. Note that this option does not have any effect on the form data being submitted to the server, only on the data returned by the server.
    - `HTTP_PATCH_ERRORDATA`: This option causes the client to accept error data from the server if the request fails. If this option is specified, an error response from the server will not cause the function to fail. Instead, the response is returned to the client and the function will succeed.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpPatchData function is used to submit XML or JSON formatted patch data to a service, and then returns a copy of the response from the server into a local buffer. This function will not perform any encoding and will not automatically define the type of patch data being submitted. Your application is responsible for specifying the content type for the patch data, and ensuring that the XML or JSON data that is being submitted to the server is formatted correctly.
- This function sends a PATCH command to the server, which is similar to a POST or PUT request. It is used to make partial updates to a resource, rather than creating or replacing it entirely. The format of the patch data is specific to the service being used. If the resource being patched does not exist, the behavior is defined by the server. If enough information is provided, it may choose to create the resource just as if a PUT command was used, or it may return an error.
- Your application should use the HttpSetRequestHeader function to define the Content-Type header prior to calling the HttpPatchData function. One of the most common formats used is the JSON Merge Patch which is defined in RFC 7396. The value for the Content-Type header for this patch format is "application/merge-patch+json". Refer to your service API documentation to determine what patch formats are acceptable, along with any additional header values that must be defined.
- The function may be used in one of two ways, depending on the needs of the application. The first approach is to pre-allocate a buffer large enough to store the resulting output of the script. In this case, the lpvResult parameter will point to the buffer that was allocated by the client and the value that the lpcbResult parameter points to should be initialized to the size of that buffer.
- The second approach is to have the lpvResult parameter point to a global memory handle which will contain the data when the function returns. In this case, the value that the lpcbResult parameter points to must be initialized to zero. It is important to note that the memory handle returned by the function must be freed by the application, otherwise a memory leak will occur. See the example code below.
- It is important for your application to initialize the value of the lpcbResult parameter correctly. This parameter must be passed by reference and if it is not initialized properly it can cause unexpected behavior or corrupt the process heap. If an error occurs when issuing the PATCH request to the server, the variable passed to this function may have a value of zero when the function returns, indicating no data has been returned to the caller.
- When encountering a server error during a request, the HttpPatchData function normally returns HTTP_ERROR, and no data is copied into the caller-provided buffer. The last error code for the current thread is updated to reflect the general cause of the failure, allowing the application to handle this error condition appropriately. If the PATCH request fails, servers may also provide further details about the failure, such as XML or JSON formatted data containing specific error codes or diagnostic messages.
- To capture this error information, you can utilize the HTTP_PATCH_ERRORDATA option. When this option is enabled, the behavior of HttpPatchData changes; it does not return HTTP_ERROR for server error statuses. Instead, any error data provided in the server's response, regardless of its format, is copied into the result buffer provided by the caller. If this option is used, your application should call HttpGetResultCode to obtain the HTTP status code returned by the server. This will enable you to determine if the operation was successful.
- This function will cause the current thread to block until the post completes, a timeout occurs or the operation is canceled. During the transfer, the HTTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification can be enabled by registering a callback function using the HttpRegisterEvent function.
- To determine the current status of the transaction while it is in progress, use the HttpGetTransferStatus function.

### Example

```cpp
HGLOBAL hgblBuffer = (HGLOBAL)NULL;
LPBYTE lpBuffer = (LPBYTE)NULL;
DWORD cbBuffer = 0;

// Store the script output into block of global memory allocated by
// the GlobalAlloc function; the handle to this memory will be
// returned in the hgblBuffer parameter. Since the output from the
// script is textual, the HTTP_PATCH_CONVERT option is used

nResult = HttpPatchData(hClient,
					lpszResource,
					lpszPatchData,
					&hgblBuffer,
					&cbBuffer,
					HTTP_PATCH_CONVERT);

if (nResult != HTTP_ERROR)
{
	// Lock the global memory handle, returning a pointer to the
	// output data from the script
	lpBuffer = (LPBYTE)GlobalLock(hgblBuffer);
	
	// After the data has been used, the handle must be unlocked
	// and freed, otherwise a memory leak will occur
	GlobalUnlock(hgblBuffer);
	GlobalFree(hgblBuffer);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetData](#httpgetdata-function)
- [HttpGetTransferStatus](#httpgettransferstatus-function)
- [HttpPostData](#httppostdata-function)
- [HttpPostJson](#httppostjson-function)
- [HttpPostXml](#httppostxml-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpPostData Function

Submit data to the server using the POST command and returns the response

### Prototype

```c
INT WINAPI HttpPostData(
    HCLIENT hClient,
    LPCTSTR lpszResource,
    LPCVOID lpvBuffer,
    DWORD cbBuffer,
    LPVOID lpvResult,
    LPDWORD lpcbResult,
    DWORD dwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResource` | `LPCTSTR` | A pointer to a string that specifies the resource that the data will be posted to on the server. Typically this is the name of a script that will be executed. This string may specify a valid URL for the current server that the client is connected to. |
| `lpvBuffer` | `LPCVOID` | A pointer to the data that will be provided to the script. This parameter may be NULL if the script does not require any additional data from the client. |
| `cbBuffer` | `DWORD` | The number of bytes to copy from the buffer. If this lpvBuffer parameter is NULL, this value should be zero. |
| `lpvResult` | `LPVOID` | A pointer to a byte buffer which will contain the data returned by the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpcbResult` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvBuffer parameter. If the lpvResult parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the number of bytes of data returned by the server. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |

### Options

- **dwOptions** Parameter

    - `HTTP_POST_DEFAULT`: The default post mode. The contents of the buffer are encoded and sent as standard form data. The data returned by the server is copied to the result buffer exactly as it is returned from the server.
    - `HTTP_POST_CONVERT`: If the data being returned from the server is textual, it is automatically converted so that the end of line character sequence is compatible with the Windows platform. Individual carriage return or linefeed characters are converted to carriage return/linefeed character sequences. Note that this option does not have any effect on the form data being submitted to the server, only on the data returned by the server.
    - `HTTP_POST_MULTIPART`: The contents of the buffer being sent to the server consists of multipart form data and will be sent as-is without any encoding.
    - `HTTP_POST_ERRORDATA`: This option causes the client to accept error data from the server if the request fails. If this option is specified, an error response from the server will not cause the function to fail. Instead, the response is returned to the client and the function will succeed.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpPostData function is used to submit data to a script that executes on the server and then copy the output from that script into a local buffer. If you are submitting XML or JSON formatted data to the server, it is recommended that you use the HttpPostXml or HttpPostJson functions instead to ensure that the correct content type and encoding is automatically selected.
- The function may be used in one of two ways, depending on the needs of the application. The first method is to pre-allocate a buffer large enough to store the resulting output of the script. In this case, the lpvResult parameter will point to the buffer that was allocated by the client and the value that the lpcbResult parameter points to should be initialized to the size of that buffer.
- The second method that can be used is have the lpvResult parameter point to a global memory handle which will contain the data when the function returns. In this case, the value that the lpcbResult parameter points to must be initialized to zero. It is important to note that the memory handle returned by the function must be freed by the application, otherwise a memory leak will occur. See the example code below.
- It is important for your application to initialize the value of the lpcbResult parameter correctly. This parameter must be passed by reference and if it is not initialized properly it can cause unexpected behavior or corrupt the process heap. If an error occurs when issuing the POST request to the server, the variable passed to this function may have a value of zero when the function returns, indicating no data has been returned to the caller.
- When encountering a server error during a request, the HttpPostData function normally returns HTTP_ERROR, and no data is copied into the caller-provided buffer. The last error code for the current thread is updated to reflect the general cause of the failure, allowing the application to handle this error condition appropriately. If the POST request fails, servers may also provide further details about the failure, such as XML or JSON formatted data containing specific error codes or diagnostic messages.
- To capture this error information, you can utilize the HTTP_POST_ERRORDATA option. When this option is enabled, the behavior of HttpPostData changes; it does not return HTTP_ERROR for server error statuses. Instead, any error data provided in the server's response, regardless of its format, is copied into the result buffer provided by the caller. If this option is used, your application should call HttpGetResultCode to obtain the HTTP status code returned by the server. This will enable you to determine if the operation was successful.
- This function will cause the current thread to block until the post completes, a timeout occurs or the operation is canceled. During the transfer, the HTTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification can be enabled by registering a callback function using the HttpRegisterEvent function.
- To determine the current status of the transaction while it is in progress, use the HttpGetTransferStatus function.

### Example

```cpp
HGLOBAL hgblBuffer = (HGLOBAL)NULL;
LPBYTE lpBuffer = (LPBYTE)NULL;
DWORD cbBuffer = 0;

// Store the response in block of global memory allocated by
// the GlobalAlloc function; the handle to this memory will be
// returned in the hgblBuffer parameter. Since the output from the
// script is textual, the HTTP_POST_CONVERT option is used

nResult = HttpPostData(hClient,
					lpszResource,
					lpParameters,
					cbParameters,
					&hgblBuffer,
					&cbBuffer,
					HTTP_POST_CONVERT);

if (nResult != HTTP_ERROR)
{
	// Lock the global memory handle, returning a pointer to the
	// output data from the script
	lpBuffer = (LPBYTE)GlobalLock(hgblBuffer);
	
	// After the data has been used, the handle must be unlocked
	// and freed, otherwise a memory leak will occur
	GlobalUnlock(hgblBuffer);
	GlobalFree(hgblBuffer);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetData](#httpgetdata-function)
- [HttpGetTransferStatus](#httpgettransferstatus-function)
- [HttpPostJson](#httppostjson-function)
- [HttpPostXml](#httppostxml-function)
- [HttpPutData](#httpputdata-function)
- [HttpRegisterEvent](#httpregisterevent-function)
- [HttpSubmitRequest](#httpsubmitrequest-function)

---

## HttpPostFile Function

Submit the contents of a local file to the server

### Prototype

```c
INT WINAPI HttpPostFile(
    HCLIENT hClient,
    LPCTSTR lpszFileName,
    LPCTSTR lpszResource,
    LPCTSTR lpszFieldName,
    DWORD dwOptions,
    DWORD dwReserved
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszFileName` | `LPCTSTR` | A pointer to a string that specifies the file that will be transferred from the local system. The file pathing and name conventions must be that of the local host. |
| `lpszResource` | `LPCTSTR` | A pointer to a string that specifies the resource on the server that the file data will be posted to. Typically this is the name of a script that is responsible for processing and storing the file data. |
| `lpszFieldName` | `LPCTSTR` | A pointer to a string that corresponds to the form field name that the script expects. If this parameter is NULL or an empty string, a default field name of "File1" is used. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter may be any one of the following values: |
| `dwReserved` | `DWORD` | A reserved parameter. This value should always be zero. |

### Options

- **dwOptions** Parameter

    - `HTTP_TRANSFER_DEFAULT`: This option specifies the default transfer mode should be used. If the remote file exists, it will be overwritten with the contents of the uploaded file.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpPostFile function is similar to the HttpPutFile function in that it can be used to upload the contents of a local file to a server. However, instead of using the PUT command, the POST command is used to send the file data to a script that is executed on the server. This method has the advantage of not requiring any special configuration settings on the server, however it does require that the script be able to process multipart/form-data as defined in RFC 2388.
- To support uploading files from a form on a webpage, the FILE input type is used along with the action that specifies the script that will accept the file data and process it. For example, the HTML code could look like this:
- In this example, the script /cgi-bin/upload.cgi is responsible for processing the file data that is posted by the client, and the form field name "datafile" is used. The user can select a file, and when the Submit button is clicked, the file data is posted to the script. To simulate this using the HttpPostFile function, the lpszFileName parameter should be set to the name of the local file that will be posted to the server. The lpszResource parameter should be the name of the script, in this case "/cgi-bin/upload.cgi". The lpszFieldName parameter should be specified as the string "datafile" to match the name of the field used by the form.
- Note that the HttpPostFile function always submits the file contents as multipart/form-data with the content type set to application/octet-stream. The script that accepts the posted data must be able to parse the multipart header block and correctly process 8-bit data. If the script assumes that the data will be posted using a specific encoding type such as base64 then the file data may not be accepted or may be corrupted by the script.
- This function will cause the current thread to block until the file transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the HTTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling HttpEnableEvents, or by registering a callback function using the HttpRegisterEvent function.
- To determine the current status of a file transfer while it is in progress, use the HttpGetTransferStatus function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpEnableEvents](#httpenableevents-function)
- [HttpGetData](#httpgetdata-function)
- [HttpGetFile](#httpgetfile-function)
- [HttpGetTransferStatus](#httpgettransferstatus-function)
- [HttpPostData](#httppostdata-function)
- [HttpPutData](#httpputdata-function)
- [HttpPutFile](#httpputfile-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpPostJson Function

Post JSON formatted data to the server and returns the response

### Prototype

```c
INT WINAPI HttpPostJson(
    HCLIENT hClient,
    LPCTSTR lpszResource,
    LPCTSTR lpszJsonData,
    LPVOID lpvResult,
    LPDWORD lpcbResult,
    DWORD dwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResource` | `LPCTSTR` | A pointer to a string that specifies the resource name that the JSON data will be submitted to. Typically this is the name of a script on the server. |
| `lpszJsonData` | `LPCTSTR` | A pointer to a string that specifies the JSON data that will be submitted to the server. |
| `lpvResult` | `LPVOID` | A pointer to a byte buffer which will contain the data returned by the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpcbResult` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvResult parameter. If the lpvResult parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the number of bytes of data returned by the server. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |

### Options

- **dwOptions** Parameter

    - `HTTP_POST_DEFAULT`: The default post mode. The contents of the buffer will be submitted without encoding and should use the standard JSON format. The data returned by the server is copied to the result buffer exactly as it is returned from the server.
    - `HTTP_POST_CONVERT`: If the data being returned from the server is textual, it is automatically converted so that the end of line character sequence is compatible with the Windows platform. Individual carriage return or linefeed characters are converted to carriage return/linefeed character sequences. Note that this option does not have any effect on the form data being submitted to the server, only on the data returned by the server.
    - `HTTP_POST_ERRORDATA`: This option causes the client to accept error data from the server if the request fails. If this option is specified, an error response from the server will not cause the function to fail. Instead, the response is returned to the client and the function will succeed.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpPostJson function is used to submit JSON formatted data to a script that executes on the server and then copy the output from that script into a local buffer. This function automatically sets the correct content type and encoding required for submitting JSON data to a server, however it does not parse the JSON data itself to ensure that it is well-formed. Your application is responsible for ensuring that the JSON data that is being submitted to the server is formatted correctly.
- The function may be used in one of two ways, depending on the needs of the application. The first method is to pre-allocate a buffer large enough to store the resulting output of the script. In this case, the lpvResult parameter will point to the buffer that was allocated by the client and the value that the lpcbResult parameter points to should be initialized to the size of that buffer.
- The second method that can be used is have the lpvResult parameter point to a global memory handle which will contain the data when the function returns. In this case, the value that the lpcbResult parameter points to must be initialized to zero. It is important to note that the memory handle returned by the function must be freed by the application, otherwise a memory leak will occur. See the example code below.
- It is important for your application to initialize the value of the lpcbResult parameter correctly. This parameter must be passed by reference and if it is not initialized properly it can cause unexpected behavior or corrupt the process heap. If an error occurs when issuing the POST request to the server, the variable passed to this function may have a value of zero when the function returns, indicating no data has been returned to the caller.
- If the content type for the request has not been explicitly specified, it will be automatically updated by this function to use the "application/json" content type. You can override the default content type for the request by calling the HttpSetRequestHeader function prior to calling this function. Most servers require you to explicitly specify what type of data is being submitted by the client and will reject requests which do not correctly identify the content type.
- When encountering a server error during a request, the HttpPostJson function normally returns HTTP_ERROR, and no data is copied into the caller-provided buffer. The last error code for the current thread is updated to reflect the general cause of the failure, allowing the application to handle this error condition appropriately. If the POST request fails, servers may also provide further details about the failure, such as XML or JSON formatted data containing specific error codes or diagnostic messages.
- To capture this error information, you can utilize the HTTP_POST_ERRORDATA option. When this option is enabled, the behavior of HttpPostJson changes; it does not return HTTP_ERROR for server error statuses. Instead, any error data provided in the server's response, regardless of its format, is copied into the result buffer provided by the caller. If this option is used, your application should call HttpGetResultCode to obtain the HTTP status code returned by the server. This will enable you to determine if the operation was successful.
- This function will cause the current thread to block until the post completes, a timeout occurs or the operation is canceled. During the transfer, the HTTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification can be enabled by registering a callback function using the HttpRegisterEvent function.
- To determine the current status of the transaction while it is in progress, use the HttpGetTransferStatus function.

### Example

```cpp
HGLOBAL hgblBuffer = (HGLOBAL)NULL;
LPBYTE lpBuffer = (LPBYTE)NULL;
DWORD cbBuffer = 0;

// Store the response in a block of global memory allocated by
// the GlobalAlloc function; the handle to this memory will be
// returned in the hgblBuffer parameter. Since the output from the
// script is textual, the HTTP_POST_CONVERT option is used

nResult = HttpPostJson(hClient,
					lpszResource,
					lpszJsonData,
					&hgblBuffer,
					&cbBuffer,
					HTTP_POST_CONVERT);

if (nResult != HTTP_ERROR)
{
	// Lock the global memory handle, returning a pointer to the
	// output data from the script
	lpBuffer = (LPBYTE)GlobalLock(hgblBuffer);
	
	// After the data has been used, the handle must be unlocked
	// and freed, otherwise a memory leak will occur
	GlobalUnlock(hgblBuffer);
	GlobalFree(hgblBuffer);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetData](#httpgetdata-function)
- [HttpGetTransferStatus](#httpgettransferstatus-function)
- [HttpPatchData](#httppatchdata-function)
- [HttpPostData](#httppostdata-function)
- [HttpPostXml](#httppostxml-function)
- [HttpPutData](#httpputdata-function)
- [HttpRegisterEvent](#httpregisterevent-function)
- [HttpSubmitRequest](#httpsubmitrequest-function)

---

## HttpPostXml Function

Post XML formatted data to the server and returns the response

### Prototype

```c
INT WINAPI HttpPostXml(
    HCLIENT hClient,
    LPCTSTR lpszResource,
    LPCTSTR lpszXmlData,
    LPVOID lpvResult,
    LPDWORD lpcbResult,
    DWORD dwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResource` | `LPCTSTR` | A pointer to a string that specifies the resource name that the XML data will be submitted to. Typically this is the name of a script on the server. |
| `lpszXmlData` | `LPCTSTR` | A pointer to a string that specifies the XML data that will be submitted to the server. |
| `lpvResult` | `LPVOID` | A pointer to a byte buffer which will contain the data returned by the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpcbResult` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvResult parameter. If the lpvResult parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the number of bytes of data returned by the server. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |

### Options

- **dwOptions** Parameter

    - `HTTP_POST_DEFAULT`: The default post mode. The contents of the buffer will be submitted without encoding and should use the standard XML format. The data returned by the server is copied to the result buffer exactly as it is returned from the server.
    - `HTTP_POST_CONVERT`: If the data being returned from the server is textual, it is automatically converted so that the end of line character sequence is compatible with the Windows platform. Individual carriage return or linefeed characters are converted to carriage return/linefeed character sequences. Note that this option does not have any effect on the form data being submitted to the server, only on the data returned by the server.
    - `HTTP_POST_ERRORDATA`: This option causes the client to accept error data from the server if the request fails. If this option is specified, an error response from the server will not cause the function to fail. Instead, the response is returned to the client and the function will succeed.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpPostXml function is used to submit XML formatted data to a script that executes on the server and then copy the output from that script into a local buffer. This function automatically sets the correct content type and encoding required for submitting XML data to a server, however it does not parse the XML data itself to ensure that it is well-formed. Your application is responsible for ensuring that the XML data that is being submitted to the server is formatted correctly.
- The function may be used in one of two ways, depending on the needs of the application. The first method is to pre-allocate a buffer large enough to store the resulting output of the script. In this case, the lpvResult parameter will point to the buffer that was allocated by the client and the value that the lpcbResult parameter points to should be initialized to the size of that buffer.
- The second method that can be used is have the lpvResult parameter point to a global memory handle which will contain the data when the function returns. In this case, the value that the lpcbResult parameter points to must be initialized to zero. It is important to note that the memory handle returned by the function must be freed by the application, otherwise a memory leak will occur. See the example code below.
- It is important for your application to initialize the value of the lpcbResult parameter correctly. This parameter must be passed by reference and if it is not initialized properly it can cause unexpected behavior or corrupt the process heap. If an error occurs when issuing the POST request to the server, the variable passed to this function may have a value of zero when the function returns, indicating no data has been returned to the caller.
- If the content type for the request has not been explicitly specified, it will be automatically updated by this function to use the "text/xml" content type. You can override the default content type for the request by calling the HttpSetRequestHeader function prior to calling this function. Most servers require you to explicitly specify what type of data is being submitted by the client and will reject requests which do not correctly identify the content type.
- When encountering a server error during a request, the HttpPostXml function normally returns HTTP_ERROR, and no data is copied into the caller-provided buffer. The last error code for the current thread is updated to reflect the general cause of the failure, allowing the application to handle this error condition appropriately. If the POST request fails, servers may also provide further details about the failure, such as XML or JSON formatted data containing specific error codes or diagnostic messages.
- To capture this error information, you can utilize the HTTP_POST_ERRORDATA option. When this option is enabled, the behavior of HttpPostXml changes; it does not return HTTP_ERROR for server error statuses. Instead, any error data provided in the server's response, regardless of its format, is copied into the result buffer provided by the caller. If this option is used, your application should call HttpGetResultCode to obtain the HTTP status code returned by the server. This will enable you to determine if the operation was successful.
- This function will cause the current thread to block until the post completes, a timeout occurs or the operation is canceled. During the transfer, the HTTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification can be enabled by registering a callback function using the HttpRegisterEvent function.
- To determine the current status of the transaction while it is in progress, use the HttpGetTransferStatus function.

### Example

```cpp
HGLOBAL hgblBuffer = (HGLOBAL)NULL;
LPBYTE lpBuffer = (LPBYTE)NULL;
DWORD cbBuffer = 0;

// Store the response in a block of global memory allocated by
// the GlobalAlloc function; the handle to this memory will be
// returned in the hgblBuffer parameter. Since the output from the
// script is textual, the HTTP_POST_CONVERT option is used

nResult = HttpPostXml(hClient,
					lpszResource,
					lpszXmlData,
					&hgblBuffer,
					&cbBuffer,
					HTTP_POST_CONVERT);

if (nResult != HTTP_ERROR)
{
	// Lock the global memory handle, returning a pointer to the
	// output data from the script
	lpBuffer = (LPBYTE)GlobalLock(hgblBuffer);
	
	// After the data has been used, the handle must be unlocked
	// and freed, otherwise a memory leak will occur
	GlobalUnlock(hgblBuffer);
	GlobalFree(hgblBuffer);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetData](#httpgetdata-function)
- [HttpGetTransferStatus](#httpgettransferstatus-function)
- [HttpPatchData](#httppatchdata-function)
- [HttpPostData](#httppostdata-function)
- [HttpPostJson](#httppostjson-function)
- [HttpPutData](#httpputdata-function)
- [HttpRegisterEvent](#httpregisterevent-function)
- [HttpSubmitRequest](#httpsubmitrequest-function)

---

## HttpProxyConnect Function

Establish a connection with the specified proxy server

### Prototype

```c
HCLIENT WINAPI HttpProxyConnect(
    UINT nProxyType,
    LPCTSTR lpszProxyHost,
    UINT nProxyPort,
    LPCTSTR lpszProxyUser,
    LPCTSTR lpszProxyPassword,
    LPCTSTR lpszRemoteHost,
    UINT nRemotePort,
    UINT nTimeout,
    DWORD dwOptions,
    DWORD dwVersion,
    LPSECURITYCREDENTIALS lpCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nProxyType` | `UINT` | An unsigned integer which specifies the type of proxy that the client is connecting to. The supported proxy server types are as follows: |
| `lpszProxyHost` | `LPCTSTR` | A pointer to a string which specifies the proxy server host name or IP address. This argument is ignored if the proxy type is set to HTTP_PROXY_NONE or HTTP_PROXY_WINDOWS and no proxy configuration has been specified for the local system. |
| `nProxyPort` | `UINT` | The port number that the proxy server is listening for connections on. A value of zero specifies that the default port number 80 should be used. Note that in most cases, a proxy server is not configured to use the default port. This argument is ignored if the proxy type is set to HTTP_PROXY_NONE or HTTP_PROXY_WINDOWS and no proxy configuration has been specified for the local system. |
| `lpszProxyUser` | `LPCTSTR` | A pointer to a string which specifies the user name that will be used to authenticate the client session to the proxy server. If the server does not require user authentication, then a NULL pointer may be passed in this argument. |
| `lpszProxyPassword` | `LPCTSTR` | A pointer to a string which specifies the password that will be used to authenticate the client session to the proxy server. If the server does not require user authentication, then a NULL pointer may be passed in this argument. |
| `lpszRemoteHost` | `LPCTSTR` | A pointer to a string which specifies the name of the server to connect to through the proxy server. This may be a fully-qualified domain name or an IP address. |
| `nRemotePort` | `UINT` | The port number the server is listening on. A value of zero specifies that the default port number 80 should be used. For standard connections, the default port number is 80. For secure connections, the default port number is 443. |
| `nTimeout` | `UINT` | The number of seconds that the client will wait for a response from the server before failing the current operation. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `dwVersion` | `DWORD` | The requested protocol version used when sending requests to the server. The high word should specify the major version, and the low word should specify the minor version number. The HTTPVERSION macro can be used to create a version value and the following values are defined: |
| `lpCredentials` | `LPSECURITYCREDENTIALS` | Pointer to credentials structure SECURITYCREDENTIALS. This parameter is only used if the HTTP_OPTION_SECURE option is specified for the connection. This parameter may be NULL, in which case no client credentials will be provided to the server. If client credentials are required, the fields dwSize, lpszCertStore, and lpszCertName must be defined, while other fields may be left undefined. Set dwSize to the size of the SECURITYCREDENTIALS structure. |

### Options

- **nProxyType** Parameter

    - `HTTP_PROXY_NONE`: A direct connection will be established with the server. When this value is specified the proxy parameters are ignored.
    - `HTTP_PROXY_STANDARD`: A standard connection is established through the specified proxy server, and all resource requests will be specified using a complete URL. This proxy type should be used with standard connections.
    - `HTTP_PROXY_SECURE`: A secure connection is established through the specified proxy server. This proxy type should be used with secure connections and the HTTP_OPTION_SECURE option should also be set via the dwOptions parameter.
    - `HTTP_PROXY_WINDOWS`: The configuration options for the current system should be used. If the system is configured to use a proxy server, then the connection will be automatically established through that proxy; otherwise, a direct connection to the server is established. These settings are the same proxy server settings configured in Windows.
- **dwOptions** Parameter

    - `HTTP_OPTION_NOCACHE`: This instructs the server to not return a cached copy of the resource. When connected to an HTTP 1.0 or earlier server, this directive may be ignored.
    - `HTTP_OPTION_KEEPALIVE`: This instructs the server to maintain a persistent connection between requests. This can improve performance because it eliminates the need to establish a separate connection for each resource that is requested.
    - `HTTP_OPTION_REDIRECT`: This option specifies the client should automatically handle resource redirection. If the server indicates that the requested resource has moved to a new location, the client will close the current connection and request the resource from the new location. Note that it is possible that the redirected resource will be located on a different server.
    - `HTTP_OPTION_ERRORDATA`: This option specifies the client should return the content of an error response from the server, rather than returning an error code. Note that this option will disable automatic resource redirection, and should not be used with HTTP_OPTION_REDIRECT.
    - `HTTP_OPTION_NOUSERAGENT`: This option specifies the client should not include a User-Agent header with any requests made during the session. The user agent is a string which is used to identify the client application to the server. An application can provide its own custom user agent value using the HttpSetRequestHeader function.
    - `HTTP_OPTION_HTTP2`: This option specifies the client should attempt a HTTP/2 connection with the server. If a connection cannot be established using HTTP/2 the client will attempt to connect using an earlier version of the protocol. The value of the dwVersion parameter will be ignored when this option is used.
    - `HTTP_OPTION_TUNNEL`: This option specifies that a tunneled TCP connection and/or port-forwarding is being used to establish the connection to the server. This changes the behavior of the client with regards to internal checks of the destination IP address and remote port number, default capability selection and how the connection is established.
    - `HTTP_OPTION_TRUSTEDSITE`: This option specifies the server is trusted. The server certificate will not be validated and the connection will always be permitted. This option only affects connections using the TLS protocol.
    - `HTTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. Note that the server must support secure connections using the TLS protocol. The client will default to using TLS 1.2 or later for secure connections.
    - `HTTP_OPTION_SECURE_FALLBACK`: This option specifies the client should permit the use of less secure cipher suites for compatibility with legacy servers. If this option is specified, the client will allow connections using TLS 1.0 and cipher suites that use RC4, MD5 and SHA1.
    - `HTTP_OPTION_PREFER_IPV6`: This option specifies the client should prefer the use of IPv6 if the server hostname can be resolved to both an IPv6 and IPv4 address. This option is ignored if the local system does not have IPv6 enabled, or when the hostname can only be resolved to an IPv4 address. If the server hostname can only be resolved to an IPv6 address, the client will attempt to establish a connection using IPv6 regardless if this option has been specified.
    - `HTTP_OPTION_FREETHREAD`: This option specifies the handle returned by this function may be used by any thread, and is not limited to the thread which created it. The application is responsible for ensuring that access to the handle is synchronized across multiple threads.
    - `HTTP_OPTION_HIRES_TIMER`: This option specifies the elapsed time for data transfers should be returned in milliseconds instead of seconds. This will return more accurate transfer times for smaller amounts of data over fast network connections.
- **dwVersion** Parameter

    - `HTTP_VERSION_DEFAULT`: The client should use the default protocol version for this session. This is the same as specifying HTTP_VERSION_11 and is recommended to ensure the broadest compatibility with most servers.
    - `HTTP_VERSION_09`: The client should use the original one-line protocol which includes no version number and no request header block. This version has been deprecated and should only be used with legacy servers which do not support the protocol standard. This version of the protocol does not support virtual hosts and is not supported by most modern web services.
    - `HTTP_VERSION_10`: The client should use the HTTP/1.0 protocol standard originally defined in RFC 1945. This version of the protocol supports the use of request header blocks, however it does not support persistent connections or chunked data and has limited cache control mechanisms.
    - `HTTP_VERSION_11`: The client should use the HTTP/1.1 protocol standard defined in RFC 2616 and RFC 7230. This is the most widely used version of the protocol and is the default for client connections. It is recommended most applications use this version.
    - `HTTP_VERSION_20`: The client should use the HTTP/2 protocol standard defined in RFC 7540. This protocol version is a significant change from previous versions and can provide improved performance with header compression and optimizing how requests are serviced. If the client or server does not support HTTP/2, the client will automatically attempt to use an earlier version of the protocol.

### Return Value

- **Type**: `HCLIENT`
- If the function succeeds, the return value is a handle to the client session. If the function fails, the return value is INVALID_CLIENT. To get extended error information, call HttpGetLastError.

### Remarks

- This function will block the current thread until a connection has been established or the timeout period has elapsed. To prevent it from blocking the main user interface thread, the application should create a background worker thread and establish a connection by calling HttpProxyConnect in that thread. If the application requires multiple simultaneous connections, it is recommended you create a worker thread for each connection.
- If the HTTP_PROXY_WINDOWS proxy type is specified, then the proxy configuration for the local system is used. If no proxy server has been defined, then the proxy-related parameters will be ignored and the function will establish a connection directly to the server.
- The username and password information is only used when connecting to a server which supports version 1.1 or later of the protocol.
- The dwOptions argument can be used to specify the threading model that is used by the library when a connection is established. By default, the handle is initially attached to the thread that created it. From that point on, until the it is released, only the owner may call functions using that handle. The ownership of the handle may be transferred from one thread to another using the HttpAttachThread function.
- Specifying the HTTP_OPTION_FREETHREAD option enables any thread to call any function using the handle, regardless of which thread created it. It is important to note that this option disables certain internal safety checks which are performed by the library and may result in unexpected behavior unless access to the handle is synchronized. If one thread calls a function in the library, it must ensure that no other thread will call another function at the same time using the same handle.
- If the HTTP_OPTION_KEEPALIVE option is specified and the server does not support persistent connections, the client will automatically reconnect when each resource is requested. Although it will not provide any performance benefits, this allows the option to be used with all servers. This option is automatically enabled when using HTTP/2.
- Applications should use HTTP_VERSION_DEFAULT as the value for the dwVersion parameter. This will default to an appropriate version for the Windows platform and ensures the broadest compatibility with most servers. If your application specifies HTTP_VERSION_20, a secure connection using TLS 1.2 or later will always be used. The minimum required platform for HTTP/2.0 support is Windows 10 (Build 1903) or Windows Server 2019. Earlier versions of the Schannel SSP do not support the features required for a secure HTTP/2 connection.
- If your application requests a HTTP/2 connection and the server only accepts earlier versions of the protocol, the client will attempt to automatically downgrade the request to HTTP/1.1. If a connection using an earlier version of the protocol cannot be established, the function will fail and return INVALID_CLIENT.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpConnect](#httpconnect-function)
- [HttpConnectUrl](#httpconnecturl-function)
- [HttpDisconnect](#httpdisconnect-function)
- [HttpInitialize](#httpinitialize-function)

---

## HttpPutData Function

Create a file on the server using the contents of a local buffer

### Prototype

```c
INT WINAPI HttpPutData(
    HCLIENT hClient,
    LPCTSTR lpszRemoteFile,
    LPCVOID lpvBuffer,
    DWORD dwLength,
    DWORD dwReserved
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be created. This string may specify a valid URL for the current server that the client is connected to. |
| `lpvBuffer` | `LPCVOID` | A pointer to a buffer which will contain the data to be transferred from the client and stored in a file on the server. |
| `dwLength` | `DWORD` | The number of bytes to copy from the buffer. |
| `dwReserved` | `DWORD` | A reserved parameter. This value should always be zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpPutData function is used to store the contents of the specified buffer in a file on the server. Not all servers permit files to be created using this method, and some may require that specific configuration changes be made to the server in order to support this functionality. Consult your server's technical reference documentation to see if it supports the PUT command, and if so, what must be done to enable it. It may be required that the client authenticate itself using the HttpAuthenticate function prior to uploading the data.
- This function is designed for uploading the contents of a buffer to be stored as a file on the server. If you need to use the PUT command to as part of a RESTful API where the PUT command is used to submit data to the server, use the HttpPutDataEx function. That function will return the success or failure responses back to the client.
- This function will cause the current thread to block until the file transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the HTTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling HttpEnableEvents, or by registering a callback function using the HttpRegisterEvent function.
- To determine the current status of a transfer while it is in progress, use the HttpGetTransferStatus function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpEnableEvents](#httpenableevents-function)
- [HttpGetData](#httpgetdata-function)
- [HttpGetFile](#httpgetfile-function)
- [HttpGetTransferStatus](#httpgettransferstatus-function)
- [HttpPostData](#httppostdata-function)
- [HttpPutDataEx](#httpputdataex-function)
- [HttpPutFile](#httpputfile-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpPutDataEx Function

Submit data to the server using the PUT command and returns the response

### Prototype

```c
INT WINAPI HttpPutDataEx(
    HCLIENT hClient,
    LPCTSTR lpszResource,
    LPCVOID lpvBuffer,
    DWORD cbBuffer,
    LPVOID lpvResult,
    LPDWORD lpcbResult,
    DWORD dwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResource` | `LPCTSTR` | A pointer to a string which specifies the resource path on the server. This string may specify a valid URL for the current server that the client is connected to. |
| `lpvBuffer` | `LPCVOID` | A pointer to a buffer which will contain the data to be transferred from the client and submitted to the server. This parameter may not be NULL. |
| `cbBuffer` | `DWORD` | The number of bytes to copy from the buffer. This value must be larger than zero. |
| `lpvResult` | `LPVOID` | A pointer to a byte buffer which will contain the data returned by the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpcbResult` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvResult parameter. If the lpvResult parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the actual number of bytes of data that was returned. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |

### Options

- **dwOptions** Parameter

    - `HTTP_PUT_DEFAULT`: The default mode. The contents of the buffer are sent unmodified and the data returned by the server is copied to the result buffer exactly as it is returned from the server. This option should be used if the server is expected to return binary data in the response to the PUT request.
    - `HTTP_PUT_CONVERT`: If the data being returned from the server is textual, it is automatically converted so that the end of line character sequence is compatible with the Windows platform. Individual carriage return or linefeed characters are converted to carriage return/linefeed character sequences. Note that this option does not have any effect on the data being submitted to the server, only on the data returned by the server.
    - `HTTP_PUT_ERRORDATA`: This option causes the client to accept error data from the server if the request fails. If this option is specified, an error response from the server will not cause the function to fail. Instead, the response is returned to the client and the function will succeed.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpPutDataEx function is used to submit data to the server using the PUT command. This is typically used with RESTful APIs and is similar in functionality to the POST command. However, the data that is submitted will be sent to the server as-is and will not be encoded.
- The function may be used in one of two ways, depending on the needs of the application. The first method is to pre-allocate a buffer large enough to store the response from the server. In this case, the lpvResult parameter will point to the buffer allocated by the client and the value that the lpcbResult parameter points to should be initialized to the size of that buffer.
- The second method is to have the lpvResult parameter point to a global memory handle which will reference the data when the function returns. In this case, the value that the lpcbResult parameter points to must be initialized to zero. It is important to note that the memory handle returned by the function must be freed by the application, otherwise a memory leak will occur.
- If the Unicode version of this function is called and the server returns a text response to the PUT request, it is the application's responsibility to convert the contents of the lpvResult buffer to UTF-16 text. If the server returns text, most likely it will use UTF-8 encoding.
- If the content type for the request has not been explicitly specified, it will be automatically updated by this function to use the "application/octet-stream" content type. You can override the default content type for the request by calling the HttpSetRequestHeader function prior to calling this function. Most servers require you to explicitly specify what type of data is being submitted by the client and will reject requests which do not correctly identify the content type.
- It is common for servers to return additional information about a failed request in their response to the client. If you need to process this information, use the HTTP_PUT_ERRORDATA option which causes the error message to be returned in the lpvResult buffer provided by the caller. If this option is used, your application should call HttpGetResultCode to obtain the HTTP status code returned by the server. This will enable you to determine if the operation was successful.
- This function will cause the current thread to block until the data transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the HTTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling HttpEnableEvents, or by registering a callback function using the HttpRegisterEvent function.
- To determine the current status of a data transfer while it is in progress, use the HttpGetTransferStatus function.

### Example

```cpp
HGLOBAL hgblResponse = (HGLOBAL)NULL;
LPBYTE lpResponse = (LPBYTE)NULL;
DWORD cbResponse = 0;

// Store the response into block of global memory allocated by
// the GlobalAlloc function; the handle to this memory will be
// returned in the hgblBuffer parameter. Since the response from
// the server is textual, the HTTP_PUT_CONVERT option is used

nResult = HttpPutDataEx(hClient,
						lpszResource,
						lpRequest,
						cbRequest,
						&hgblResponse,
						&cbResponse,
						HTTP_PUT_CONVERT);

if (nResult != HTTP_ERROR)
{
	// Lock the global memory handle, returning a pointer to the
	// response from the server
	lpResponse = (LPBYTE)GlobalLock(hgblResponse);
	
	// After the data has been used, the handle must be unlocked
	// and freed, otherwise a memory leak will occur
	GlobalUnlock(hgblResponse);
	GlobalFree(hgblResponse);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpEnableEvents](#httpenableevents-function)
- [HttpGetData](#httpgetdata-function)
- [HttpGetFile](#httpgetfile-function)
- [HttpGetTransferStatus](#httpgettransferstatus-function)
- [HttpPostData](#httppostdata-function)
- [HttpPutData](#httpputdata-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpPutFile Function

Copy a file from the local system to the server

### Prototype

```c
INT WINAPI HttpPutFile(
    HCLIENT hClient,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    DWORD dwOffset
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file that will be transferred from the local system. The file pathing and name conventions must be that of the local system. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be created, overwritten or appended to. This string may specify a valid URL for the current server that the client is connected to. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter may be any one of the following values: |
| `dwOffset` | `DWORD` | Specifies a byte offset into the file. If this value is greater than zero, the server must support the ability to specify a byte range with the request to open the file, otherwise this function will fail. |

### Options

- **dwOptions** Parameter

    - `HTTP_TRANSFER_DEFAULT`: This option specifies the default transfer mode should be used. If the remote file exists, it will be overwritten with the contents of the uploaded file.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpPutFile function is used to transfer a file from the local system to a server. Not all servers permit files to be uploaded and some may require that specific configuration changes be made to the server in order to support this functionality. Consult your server's technical reference documentation to see if it supports the PUT command, and if so, what must be done to enable it. It may be required that the client authenticate itself using the HttpAuthenticate function prior to uploading the file.
- To upload large files that are over 4GB, use the HttpPutFileEx function.
- This function will cause the current thread to block until the file transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the HTTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling HttpEnableEvents, or by registering a callback function using the HttpRegisterEvent function.
- To determine the current status of a file transfer while it is in progress, use the HttpGetTransferStatus function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpEnableEvents](#httpenableevents-function)
- [HttpGetFile](#httpgetfile-function)
- [HttpGetTransferStatus](#httpgettransferstatus-function)
- [HttpPostData](#httppostdata-function)
- [HttpPostFile](#httppostfile-function)
- [HttpPutData](#httpputdata-function)
- [HttpPutFileEx](#httpputfileex-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpPutFileEx Function

Copy a file from the local system to the server, use with large files over 4GiB

### Prototype

```c
INT WINAPI HttpPutFileEx(
    HCLIENT hClient,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwOptions,
    ULARGE_INTEGER uiOffset
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file that will be transferred from the local system. The file pathing and name conventions must be that of the local host. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the file on the server that will be created, overwritten or appended to. The file naming conventions must be that of the host operating system. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter may be any one of the following values: |
| `uiOffset` | `ULARGE_INTEGER` | Specifies a byte offset into the file. If this value is greater than zero, the server must support the ability to specify a byte range with the request to open the file, otherwise this function will fail. |

### Options

- **dwOptions** Parameter

    - `HTTP_TRANSFER_DEFAULT`: This option specifies the default transfer mode should be used. If the remote file exists, it will be overwritten with the contents of the uploaded file.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpPutFileEx function is used to transfer a file from the local system to a server. Not all servers permit files to be uploaded and some may require that specific configuration changes be made to the server in order to support this functionality. Consult your server's technical reference documentation to see if it supports the PUT command, and if so, what must be done to enable it. It may be required that the client authenticate itself using the HttpAuthenticate function prior to uploading the file.
- This function will cause the current thread to block until the file transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the HTTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling HttpEnableEvents, or by registering a callback function using the HttpRegisterEvent function.
- To determine the current status of a file transfer while it is in progress, use the HttpGetTransferStatusEx function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpEnableEvents](#httpenableevents-function)
- [HttpGetFileEx](#httpgetfileex-function)
- [HttpGetTransferStatusEx](#httpgettransferstatusex-function)
- [HttpPostData](#httppostdata-function)
- [HttpPostFile](#httppostfile-function)
- [HttpPutData](#httpputdata-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpPutText Function

Create a text file on the server from the contents of a string buffer

### Prototype

```c
INT WINAPI HttpPutText(
    HCLIENT hClient,
    LPCTSTR lpszResource,
    LPCTSTR lpszBuffer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResource` | `LPCTSTR` | A pointer to a string that specifies the resource on the server which will be created or overwritten. This string may specify a valid URL for the current server. |
| `lpszBuffer` | `LPCTSTR` | A pointer to a string that contains the text which will be submitted to the server . |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpPutText function is used to create a text file on the server from the contents of a string. If the specified file already exists on the server, its contents will be overwritten. Not all servers permit files to be created using this method, and some may require that specific configuration changes be made to the server in order to support this functionality. Consult your server's technical reference documentation to see if it supports the PUT command, and if so, what must be done to enable it. It may be required that the client authenticate itself using the HttpAuthenticate command prior to uploading the data.
- If the Unicode version of this function is called, the string will be automatically converted to UTF-8 and then uploaded to the server. If you wish to upload UTF-16 Unicode or ANSI text to the server, you must use the HttpPutData function. This function should never be used to upload binary data.
- This function will cause the current thread to block until the file transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the HTTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling HttpEnableEvents, or by registering a callback function using the HttpRegisterEvent function.
- To determine the current status of a file transfer while it is in progress, use the HttpGetTransferStatus function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpEnableEvents](#httpenableevents-function)
- [HttpGetText](#httpgettext-function)
- [HttpGetTransferStatus](#httpgettransferstatus-function)
- [HttpPutData](#httpputdata-function)
- [HttpPutFile](#httpputfile-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpPutTextEx Function

Submit text to the server using the PUT command and returns the response

### Prototype

```c
INT WINAPI HttpPutTextEx(
    HCLIENT hClient,
    LPCTSTR lpszResource,
    LPCTSTR lpszBuffer,
    LPVOID lpvResult,
    LPDWORD lpcbResult,
    DWORD dwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszResource` | `LPCTSTR` | A pointer to a string which specifies the resource path on the server. This string may specify a valid URL for the current server. |
| `lpszBuffer` | `LPCTSTR` | A pointer to a string that contains the text that will be submitted to the server. This parameter cannot be NULL and may not specify an empty string. |
| `lpvResult` | `LPVOID` | A pointer to a byte buffer which will contain the data returned by the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpcbResult` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvResult parameter. If the lpvResult parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the actual number of bytes of data that was returned. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |

### Options

- **dwOptions** Parameter

    - `HTTP_PUT_DEFAULT`: The default mode. automatically converted so that the end of line character sequence is compatible with the Windows platform. Individual carriage return or linefeed characters are converted to carriage return/linefeed character sequences. Note that this option does not have any effect on the data being submitted to the server, only on the data returned by the server.
    - `HTTP_PUT_ERRORDATA`: This option causes the client to accept error data from the server if the request fails. If this option is specified, an error response from the server will not cause the function to fail. Instead, the response is returned to the client and the function will succeed.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpPutTextEx function is used to submit the contents of a null terminated string to the server using the PUT command. This is typically used with RESTful APIs and is similar in functionality to the POST command. However, the text that is submitted will not be encoded in the same way that the HttpPostData function submits data.
- If the Unicode version of this function is called, the text will be converted to UTF-8 and then submitted to the server. If you wish to submit the contents of the string as UTF-16 Unicode text, or the payload contains binary data, you must use the HttpPutDataEx function. This function should never be used to upload binary data. If the server returns a text response and the Unicode version of this function is called, it is the application's responsibility to convert the contents of the lpvResult buffer to UTF-16 text. If the server returns text, most likely it will use UTF-8 encoding.
- If the content type for the request has not been explicitly specified, it will be automatically updated by this function to use the "text/plain" content type. You can override the default content type for the request by calling the HttpSetRequestHeader function prior to calling this function. Most servers require you to explicitly specify what type of data is being submitted by the client and will reject requests which do not correctly identify the content type.
- It is common for servers to return additional information about a failed request in their response to the client. If you need to process this information, use the HTTP_PUT_ERRORDATA option which causes the error message to be returned in the lpvResult buffer provided by the caller. If this option is used, your application should call HttpGetResultCode to obtain the HTTP status code returned by the server. This will enable you to determine if the operation was successful.
- This function will cause the current thread to block until the data transfer completes, a timeout occurs or the transfer is canceled. During the transfer, the HTTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling HttpEnableEvents, or by registering a callback function using the HttpRegisterEvent function.
- To determine the current status of a data transfer while it is in progress, use the HttpGetTransferStatus function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpEnableEvents](#httpenableevents-function)
- [HttpGetText](#httpgettext-function)
- [HttpGetTransferStatus](#httpgettransferstatus-function)
- [HttpPutDataEx](#httpputdataex-function)
- [HttpPutFile](#httpputfile-function)
- [HttpPutText](#httpputtext-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpRead Function

Read data from the server

### Prototype

```c
INT WINAPI HttpRead(
    HCLIENT hClient,
    LPBYTE lpBuffer,
    INT cbBuffer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpBuffer` | `LPBYTE` | Pointer to the buffer in which the data will be copied. |
| `cbBuffer` | `INT` | The maximum number of bytes to read and copy into the specified buffer. This value must be greater than zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of bytes actually read. A return value of zero indicates that the server has closed the connection and there is no more data available to be read. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- When HttpRead is called and the client is in non-blocking mode, it is possible that the function will fail because there is no available data to read at that time. This should not be considered a fatal error. Instead, the application should simply wait to receive the next asynchronous notification that data is available.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpIsBlocking](#httpisblocking-function)
- [HttpIsReadable](#httpisreadable-function)
- [HttpIsWritable](#httpiswritable-function)
- [HttpWrite](#httpwrite-function)

---

## HttpRegisterEvent Function

Register an event callback function

### Prototype

```c
INT WINAPI HttpRegisterEvent(
    HCLIENT hClient,
    UINT nEventId,
    HTTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nEventId` | `UINT` | An unsigned integer which specifies which event should be registered with the specified callback function. One of the following values may be used: |
| `lpEventProc` | `HTTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the HttpEventProc callback function. If this parameter is NULL, the callback for the specified event is disabled. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. If the application targets the x86 (32-bit) platform, this parameter must be a 32-bit unsigned integer. If the application targets the x64 (64-bit) platform, this parameter must be a 64-bit unsigned integer. |

### Options

- **nEventId** Parameter

    - `HTTP_EVENT_CONNECT`: The connection to the server has completed.
    - `HTTP_EVENT_DISCONNECT`: The server has closed the connection to the client. The client should read any remaining data and disconnect.
    - `HTTP_EVENT_READ`: Data is available to read by the calling process. No additional messages will be posted until the client has read at least some of the data. This event is only generated if the client is in asynchronous mode.
    - `HTTP_EVENT_WRITE`: The client can now write data. This notification is sent after a connection has been established, or after a previous attempt to write data has failed because it would result in a blocking operation. This event is only generated if the client is in asynchronous mode.
    - `HTTP_EVENT_TIMEOUT`: The network operation has exceeded the specified timeout period. The client application may attempt to retry the operation, or may disconnect from the server and report an error to the user.
    - `HTTP_EVENT_CANCEL`: The current operation has been canceled. Under most circumstances the client should disconnect from the server and re-connect if needed. After an operation has been canceled, the server may abort the connection or refuse to accept further commands from the client.
    - `HTTP_EVENT_COMMAND`: A command has been issued by the client and the server response has been received and processed. This event can be used to log the result codes and messages returned by the server in response to actions taken by the client.
    - `HTTP_EVENT_PROGRESS`: The client is in the process of sending or receiving a file on the data channel. This event is called periodically during a transfer so that the client can update any user interface components such as a status control or progress bar.
    - `HTTP_EVENT_REDIRECT`: This event is generated when a the server indicates that the requested resource has been moved to a new location. The new resource location may be on the same server, or it may be located on another server. Check the value of the Location header field to determine where the resource has been moved to.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpRegisterEvent function associates a callback function with a specific event. The event handler is an HttpEventProc function that is invoked when the event occurs. Arguments are passed to the function to identify the client session, the event type and the user-defined value specified when the event handler is registered. If the event occurs because of an error condition, the error code will be provided to the handler.
- This function is typically used to register an event handler that is invoked while a file is being uploaded or downloaded. The HTTP_EVENT_PROGRESS event will only be generated periodically during the transfer to ensure the application is not flooded with event notifications. It is guaranteed that at least one HTTP_EVENT_PROGRESS notification will occur at the beginning of the transfer, and one at the end of the transfer when it has completed.
- The callback function specified by the lpEventProc parameter must be declared using the __stdcall calling convention. This ensures the arguments passed to the event handler are pushed on to the stack in the correct order. Failure to use the correct calling convention will corrupt the stack and cause the application to terminate abnormally.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpDisableEvents](#httpdisableevents-function)
- [HttpEnableEvents](#httpenableevents-function)
- [HttpEventProc](#httpeventproc-function)
- [HttpFreezeEvents](#httpfreezeevents-function)
- [HttpGetTransferStatus](#httpgettransferstatus-function)

---

## HttpRemoveQueuedFile Function

Remove a file from the transfer queue

### Prototype

```c
BOOL WINAPI HttpRemoveQueuedFile(
    HQUEUE hQueue,
    DWORD dwFileId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `dwFileId` | `DWORD` | An unsigned integer value which uniquely identifies the file in the queue. This value cannot be zero. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, it will return zero. To get extended error information, call HttpGetLastError.

### Remarks

- Files can only be removed from the queue when in an idle or paused state. If you attempt to remove a file while the queue manager is in the process of uploading or download files, the function will fail.
- The file identifier can be obtained by several different functions, including HttpEnumQueuedFiles and HttpGetQueueStatus, which provides information about the current file being processed in the queue. Do not make any assumptions about the value of the identifier. Although the value is guaranteed to be unique for the specified queue, it is not guaranteed that file identifiers will be assigned in sequential order.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpAddQueuedFile](#httpaddqueuedfile-function)
- [HttpClearQueue](#httpclearqueue-function)
- [HttpEnumQueuedFiles](#httpenumqueuedfiles-function)
- [HttpGetQueuedFile](#httpgetqueuedfile-function)
- [HttpGetQueueStatus](#httpgetqueuestatus-function)
- [HttpSuspendQueue](#httpsuspendqueue-function)
- [HttpResetQueue](#httpresetqueue-function)

---

## HttpResetQueue Function

Reset the internal state of file transfers in the specified queue

### Prototype

```c
BOOL WINAPI HttpResetQueue(
    HQUEUE hQueue,
    DWORD dwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `dwOptions` | `DWORD` | An integer value which specifies which files should be reset in the queue. It may be one of the following values: |

### Options

- **dwOptions** Parameter

    - `HTTP_QUEUE_RESET_ALL`: All files in the queue should be reset to their initial state.
    - `HTTP_QUEUE_RESET_COMPLETED`: All files in the queue which have been successfully transferred will be reset to their initial state.
    - `HTTP_QUEUE_RESET_FAILED`: All files in the queue which were not transferred will be reset to their initial state.
    - `HTTP_QUEUE_RESET_CANCELED`: All files in the queue which were canceled will be reset to their initial state.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, it will return zero. To get extended error information, call HttpGetLastError.

### Remarks

- When the HttpStartQueue function is called multiple times using the same queue handle, it will not attempt to transfer files which have already been successfully copied, and it will not attempt to re-transfer files if the previous transfer failed. This function resets queued files back to their initial state, prior to when the queue manager attempted to perform the transfer. The most common use would be to call the function with the HTTP_QUEUE_RESET_FAILED mode and then call HttpStartQueue to retry failed or canceled file transfers.
- Because canceled file transfers are also considered failed transfers, specifying HTTP_QUEUE_RESET_FAILED will reset queued files which either encountered an error during the transfer or were explicitly canceled by calling the HttpCancelQueuedFile function. The HTTP_QUEUE_RESET_CANCELED option will only reset the state of queued file transfers which were canceled.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpCancelQueuedFile](#httpcancelqueuedfile-function)
- [HttpGetQueuedFile](#httpgetqueuedfile-function)
- [HttpResumeQueue](#httpresumequeue-function)
- [HttpStartQueue](#httpstartqueue-function)
- [HttpStopQueue](#httpstopqueue-function)
- [HttpSuspendQueue](#httpsuspendqueue-function)

---

## HttpResumeQueue Function

Resume the transfer of files after queue processing has been paused

### Prototype

```c
BOOL WINAPI HttpResumeQueue(
    HQUEUE hQueue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, it will return zero. To get extended error information, call HttpGetLastError.

### Remarks

- This function signals the queue manager to resume processing files in the transfer queue after the HttpSuspendQueue function has been called. This function will fail if the queue is in an idle (stopped) state, and will be ignored if the queue manager is already transferring files. The HttpGetQueueStatus function can be called to obtain the current status of the queue.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpGetQueueStatus](#httpgetqueuestatus-function)
- [HttpResetQueue](#httpresetqueue-function)
- [HttpStartQueue](#httpstartqueue-function)
- [HttpStopQueue](#httpstopqueue-function)
- [HttpSuspendQueue](#httpsuspendqueue-function)

---

## HttpSetBearerToken Function

Set the value of the OAuth 2.0 bearer token for the client session

### Prototype

```c
INT WINAPI HttpSetBearerToken(
    HCLIENT hClient,
    LPTSTR lpszBearerToken
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszBearerToken` | `LPTSTR` | A pointer to a null terminated string buffer which contains the bearer token used to authorize client requests. If this parameter is NULL or a zero length string, the current bearer token will be cleared and no client authentication will be performed. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- Using OAuth 2.0 requires you to understand the process of how to request the bearer (access) token. Obtaining a bearer token requires registering your application with the web service provider, getting a unique client ID associated with your application and then requesting the token using the appropriate scope for the service. Obtaining the initial token will typically involve interactive confirmation on the part of the user, requiring they grant permission to your application to access the service.
- Your application should not store a bearer token for later use. They have a relatively short lifespan, typically about an hour, and are designed to be used with that session. You should specify offline access as part of the OAuth 2.0 scope if necessary and store the refresh token provided by the service. The refresh token has a much longer validity period and can be used to obtain a new bearer token when needed.

### Requirements

- Minimum Desktop Platform: Windows 7 (Service Pack 1)
- Minimum Server Platform: Windows Server 2008 R2 (Service Pack 1)
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAuthenticate](#httpauthenticate-function)
- [HttpGetBearerToken](#httpgetbearertoken-function)
- [HttpSetRequestHeader](#httpsetrequestheader-function)

---

## HttpSetContentType Function

Set the content type for the next request

### Prototype

```c
BOOL WINAPI HttpSetContentType(
    HCLIENT hClient,
    LPCTSTR lpszContentType
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszContentType` | `LPCTSTR` | A pointer to a null terminated string which contains the MIME content type of the data being submitted to the web server. If this parameter is NULL or an empty string, the current type will be cleared and the client will use a default type based on the request and content encoding. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, it will return a non-zero value. If the function fails, it will return zero. To get extended error information, call HttpGetLastError.

### Remarks

- The content type string must use the standard IANA format which consists of a type and subtype separated by a forward slash. Some common content types are:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetContentType](#httpgetcontenttype-function)
- [HttpSetRequestHeader](#httpsetrequestheader-function)

---

## HttpSetCookie Function

Set the value of the specified cookie

### Prototype

```c
BOOL WINAPI HttpSetCookie(
    HCLIENT hClient,
    LPCTSTR lpszCookieName,
    LPCTSTR lpszCookieValue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszCookieName` | `LPCTSTR` | Pointer to a string which specifies the name of the cookie that will be sent to the server when the next resource is requested. |
| `lpszCookieValue` | `LPCTSTR` | Pointer to a string which specifies the value of the cookie. To delete a cookie that has been previously set, this parameter should be NULL or point to an empty string. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpSetCookie function submits the cookie name and value to the server when a resource is requested or data is posted to a script. For more information about cookies and how they are used, refer to the HttpGetCookie function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpClearHeaders](#httpclearheaders-function)
- [HttpGetCookie](#httpgetcookie-function)
- [HttpGetFirstCookie](#httpgetfirstcookie-function)
- [HttpGetNextCookie](#httpgetnextcookie-function)
- [HttpSetRequestHeader](#httpsetrequestheader-function)

---

## HttpSetDefaultUserAgent Function

Set the default user agent string included with requests

### Prototype

```c
INT WINAPI HttpSetDefaultUserAgent(
    LPCTSTR lpszUserAgent
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszUserAgent` | `LPCTSTR` | A pointer to a null terminated string which specifies the new default user agent string. If this parameter is NULL or an empty string, the client will revert to using the default user agent string defined when the library was first initialized. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpSetDefaultUserAgent function changes the default user agent string which is included with each request made by the client. This default value is global and changing it will change the default user agent for all client sessions in all threads created by the process.
- The user agent string should use a format with the product name and version number separated by a slash. There can be multiple products listed in the user agent string separated by spaces, with additional optional information enclosed in parenthesis. For example, a valid user agent string for an application named "MyProgram" could look like this:
- MyProgram/1.0 (Win32)
- Some web services check the value of the user agent string to determine if a compatible client is being used to issue the request. The default value used by SocketTools is designed to emulate a common browser, but some services may require you change the user agent to use a specific value or include certain product names and versions.
- To change the user agent string for a specific client session, use the HttpSetRequestHeader function to set a value for the User-Agent header. To get the current value of the default user agent string, use the HttpGetDefaultUserAgent function.
- To prevent any user agent string from being included with a request, include the HTTP_OPTION_NOUSERAGENT option when connecting to the server or use HttpSetOption to enable that option after a connection has been established.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetDefaultUserAgent](#httpgetdefaultuseragent-function)
- [HttpSetOption](#httpsetoption-function)
- [HttpSetRequestHeader](#httpsetrequestheader-function)

---

## HttpSetEncodingType Function

Specifies the type of encoding to be applied to data submitted to the server

### Prototype

```c
INT WINAPI HttpSetEncodingType(
    HCLIENT hClient,
    INT nEncodingType
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nEncodingType` | `INT` | Specifies the content encoding type for the request. The following values are defined: |

### Options

- **nEncodingType** Parameter

    - `HTTP_ENCODING_NONE`: No encoding will be applied to the content of a request and no default content type will be specified. This encoding type should be used with REST APIs and other services which expect XML or JSON request payloads.
    - `HTTP_ENCODING_URL`: Non-printable and extended ASCII characters will be encoded so they can be safely used with URLs and form data. Encoded characters will be represented by a percent symbol prefix, followed by a two digit hexadecimal value which represents the ASCII character code. This encoding is typically used with web services which process HTML form data.
    - `HTTP_ENCODING_XML`: This encoding is identical to URL encoding, except spaces are not encoded. It is used with legacy web services which expect form data in an XML format and cannot process encoded whitespace. This encoding should not be specified for services which use REST APIs.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpSetEncodingType function explicitly sets the type of encoding used when optional parameter data is submitted with a request for a resource. If an encoding type is specified, and the content type for the request payload has not been defined, it will default to application/x-www-form-urlencoded.
- When submitting a JSON or XML request to a service using a REST API, your application should use HTTP_ENCODING_NONE and set the appropriate content type for the request payload. The HTTP_ENCODING_XML encoding type should only be used if the server expects URL encoded form data. The HttpPostJson and HttpPostXml functions will automatically set the correct encoding and content type for those requests.
- If an application specifies HTTP_ENCODING_NONE, parameter data is not encoded and no content type header will created by default. The client application can specify the content type by calling the HttpSetContentType function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpGetEncodingType](#httpgetencodingtype-function)
- [HttpPostData](#httppostdata-function)
- [HttpPostJson](#httppostjson-function)
- [HttpPostXml](#httppostxml-function)
- [HttpSetContentType](#httpsetcontenttype-function)
- [HttpSubmitForm](#httpsubmitform-function)

---

## HttpSetFormProperties Function

Modify the properties of the specified form

### Prototype

```c
INT WINAPI HttpSetFormProperties(
    HFORM hForm,
    LPHTTPFORMPROPERTIES lpFormProp
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hForm` | `HFORM` | Handle to the virtual form. |
| `lpFormProp` | `LPHTTPFORMPROPERTIES` | Points to a HTTPFORMPROPERTIES structure which specifies the new properties for the form. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpCreateForm](#httpcreateform-function)
- [HttpGetFormProperties](#httpgetformproperties-function)
- [HttpSubmitForm](#httpsubmitform-function)
- [HTTPFORMPROPERTIES](#httpformproperties-function)

---

## HttpSetLastError Function

Set the last error code

### Prototype

```c
VOID WINAPI HttpSetLastError(
    DWORD dwErrorCode
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `dwErrorCode` | `DWORD` | Specifies the last error code for the current thread. |

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- Error codes are unsigned 32-bit values which are private to each calling thread. Most functions will set the last error code value when they fail; a few functions set it when they succeed. Function failure is typically indicated by a return value such as FALSE, NULL, INVALID_CLIENT or HTTP_ERROR. Those functions which call HttpSetLastError when they succeed are noted on the function reference page.
- Applications can retrieve the value saved by this function by using the HttpGetLastError function. The use of HttpGetLastError is optional; an application can call the function to determine the specific reason for a function failure.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpGetErrorString](#httpgeterrorstring-function)
- [HttpGetLastError](#httpgetlasterror-function)

---

## HttpSetOption Function

Enable or disable the specified option

### Prototype

```c
INT WINAPI HttpSetOption(
    HCLIENT hClient,
    DWORD dwOption,
    BOOL bEnabled
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `dwOption` | `DWORD` | An unsigned integer which specifies one of the following options: |
| `bEnabled` | `BOOL` | An integer value which determines if the option should be enabled or disabled. A non-zero value specifies that the option should be enabled, while a zero value specifies that the option should be disabled. |

### Options

- **dwOption** Parameter

    - `HTTP_OPTION_NOCACHE`: This instructs the server to not return a cached copy of the resource. When connected to an HTTP 1.0 or earlier server, this directive may be ignored.
    - `HTTP_OPTION_KEEPALIVE`: This instructs the server to maintain a persistent connection between requests. This can improve performance because it eliminates the need to establish a separate connection for each resource that is requested. If the server does not support the keep-alive option, the client will automatically reconnect when each resource is requested. Although it will not provide any performance benefits, this allows the option to be used with all servers.
    - `HTTP_OPTION_REDIRECT`: This option specifies the client should automatically handle resource redirection. If the server indicates that the requested resource has moved to a new location, the client will close the current connection and request the resource from the new location. Note that it is possible that the redirected resource will be located on a different server.
    - `HTTP_OPTION_NOUSERAGENT`: This option specifies the client should not include a User-Agent header with any requests made during the session. The user agent is a string which is used to identify the client application to the server.
    - `HTTP_OPTION_ERRORDATA`: This option specifies the client should return the content of an error response from the server, rather than returning an error code. Note that this option will disable automatic resource redirection, and should not be used with HTTP_OPTION_REDIRECT.
    - `HTTP_OPTION_FREETHREAD`: This option specifies the handle returned by this function may be used by any thread, and is not limited to the thread which created it. The application is responsible for ensuring that access to the handle is synchronized across multiple threads.
    - `HTTP_OPTION_HIRES_TIMER`: This option specifies the elapsed time for data transfers should be returned in milliseconds instead of seconds. This will return more accurate transfer times for smaller amounts of data over fast network connections.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpSetOption function can only enable or disable the options listed above. Other options are only available when the connection is initially established. For example, you cannot use this function to enable security options or switch to using HTTP/2 after the connection has been made.
- If you use HTTP_OPTION_FREETHREAD to permit any thread to reference a client handle allocated in another thread, your application is responsible for ensuring it does not attempt to submit requests using the same handle on different threads at the same time. If two different threads attempt to perform an operation using the same handle, there is no guarantee as to which thread will complete the operation first.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpConnect](#httpconnect-function)
- [HttpGetOption](#httpgetoption-function)
- [HttpProxyConnect](#httpproxyconnect-function)

---

## HttpSetPriority Function

Set the priority for file transfers

### Prototype

```c
INT WINAPI HttpSetPriority(
    HCLIENT hClient,
    INT nPriority
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nPriority` | `INT` | An integer value which specifies the new priority for file transfers. It may be one of the following values: |

### Options

- **nPriority** Parameter

    - `HTTP_PRIORITY_NORMAL`: The default priority which balances resource utilization and transfer speed. It is recommended that most applications use this priority.
    - `HTTP_PRIORITY_BACKGROUND`: This priority significantly reduces the memory, processor and network resource utilization for the transfer. It is typically used with worker threads running in the background when the amount of time required perform the transfer is not critical.
    - `HTTP_PRIORITY_LOW`: This priority lowers the overall resource utilization for the transfer and meters the bandwidth allocated for the transfer. This priority will increase the average amount of time required to complete a file transfer.
    - `HTTP_PRIORITY_HIGH`: This priority increases the overall resource utilization for the transfer, allocating more memory for internal buffering. It can be used when it is important to transfer the file quickly, and there are no other threads currently performing file transfers at the time.
    - `HTTP_PRIORITY_CRITICAL`: This priority can significantly increase processor, memory and network utilization while attempting to transfer the file as quickly as possible. If the file transfer is being performed in the main UI thread, this priority can cause the application to appear to become non-responsive. No events will be generated during the transfer.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the previous file transfer priority. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpSetPriority function can be used to control the processor usage, memory and network bandwidth allocated for file transfers. The default priority balances resource utilization and transfer speed while ensuring that a single-threaded application remains responsive to the user. Lower priorities reduce the overall resource utilization at the expense of transfer speed. For example, if you create a worker thread to download a file in the background and want to ensure that it has a minimal impact on the process, the HTTP_PRIORITY_BACKGROUND value can be used.
- Higher priority values increase the memory allocated for the transfers and increases processor utilization for the transfer. The HTTP_PRIORITY_CRITICAL priority maximizes transfer speed at the expense of system resources. It is not recommended that you increase the file transfer priority unless you understand the implications of doing so and have thoroughly tested your application.
- If the file transfer is being performed in the main UI thread, increasing the priority may interfere with the normal processing of Windows messages and cause the application to appear to become non-responsive. It is also important to note that when the priority is set to HTTP_PRIORITY_CRITICAL, normal progress events will not be generated during the transfer.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpGetPriority](#httpgetpriority-function)

---

## HttpSetRequestHeader Function

Set the value of a request header field

### Prototype

```c
BOOL WINAPI HttpSetRequestHeader(
    HCLIENT hClient,
    LPCTSTR lpszHeader,
    LPCTSTR lpszValue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszHeader` | `LPCTSTR` | Points to a string which specifies the request header field name. |
| `lpszValue` | `LPCTSTR` | Points to a string which specifies the value of the request header field. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the client handle is invalid, the function returns a value of zero. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpSetRequestHeader function defines a header field and value that is submitted to the server when a resource is requested. If the header field has already been defined, it will be replaced by the new value. There are a number of header fields which are automatically created by the library, and others that are conditionally created depending on whether or not certain options are specified. The following header fields are automatically created by the library:
- Request headers are generated by functions that send resource requests. In some cases, header values are supplied by the requesting function only if the application has not previously defined the header. For others, the requesting function overrides what the application may have defined.
- If you use this function to set the Authorization header to a custom value for this client session, you must not call the HttpAuthenticate function. The HttpAuthenticate function will always override any custom Authorization header value and replace it with the credentials token generated from the username and password provided. If your application was using this function to specify an OAuth 2.0 bearer token, it is recommended you use the HttpSetBearerToken function instead.
- If you need to change the default content type for the next request, it is recommended you use the HttpSetContentType function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAuthenticate](#httpauthenticate-function)
- [HttpClearHeaders](#httpclearheaders-function)
- [HttpGetFirstHeader](#httpgetfirstheader-function)
- [HttpGetNextHeader](#httpgetnextheader-function)
- [HttpGetRequestHeader](#httpgetrequestheader-function)
- [HttpGetResponseHeader](#httpgetresponseheader-function)
- [HttpSetBearerToken](#httpsetbearertoken-function)
- [HttpSetContentType](#httpsetcontenttype-function)
- [HttpSetEncodingType](#httpsetencodingtype-function)

---

## HttpSetTimeout Function

Set the number of seconds until an operation times out

### Prototype

```c
INT WINAPI HttpSetTimeout(
    HCLIENT hClient,
    INT nTimeout
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `nTimeout` | `INT` | The number of seconds to wait for a blocking operation to complete. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is zero. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The timeout value is only used with blocking client connections.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpGetTimeout](#httpgettimeout-function)
- [HttpIsBlocking](#httpisblocking-function)
- [HttpIsReadable](#httpisreadable-function)
- [HttpIsWritable](#httpiswritable-function)

---

## HttpStartQueue Function

Begin transferring the files in the specified queue

### Prototype

```c
BOOL WINAPI HttpStartQueue(
    HQUEUE hQueue,
    DWORD dwQueueMode,
    DWORD dwReserved,
    HTTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `dwQueueMode` | `DWORD` | An unsigned integer which specifies which files in the queue should be transferred. It may be one of the following values: |
| `dwReserved` | `DWORD` | An unsigned integer reserved for internal use. This parameter value should always be zero. |
| `lpEventProc` | `HTTPEVENTPROC` | Specifies the procedure-instance address of an application defined callback function. For more information about the callback function, see the description of the HttpEventProc callback function. If this parameter is NULL, there will be no callback notifications. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. If the application targets the x86 (32-bit) platform, this parameter must be a 32-bit unsigned integer. If the application targets the x64 (64-bit) platform, this parameter must be a 64-bit unsigned integer. |

### Options

- **dwQueueMode** Parameter

    - `HTTP_QUEUE_ALL`: All files in the queue should be transferred.
    - `HTTP_QUEUE_DOWNLOAD`: Transfer only those files which have been queued for download.
    - `HTTP_QUEUE_UPLOAD`: Transfer only those files which have been queued for upload.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, it will return zero. To get extended error information, call HttpGetLastError.

### Remarks

- Queued file transfers are performed asynchronously using a background worker thread. If you provide the address to an event callback function, that function will always be invoked in the context of the queue manager thread. You must ensure that any access to global or static variables are synchronized, otherwise the results may be unpredictable. It is recommended that you do not declare any static variables within the callback function itself and you should avoid calling any functions which could cause the thread to block. For example, you should not attempt to establish other network connections from within the event handler.
- If your application has a graphical user interface, you should never attempt to directly modify a UI control from within the callback function. Controls should only be modified by the same UI thread that created their window. One common approach to address this issue is to post a user-defined message to the main window to signal that the user interface needs to be updated. The message handler would then process the user-defined message and update the user interface as needed.
- To obtain the handle to the queue from within an event handler, call the HttpGetThreadQueue function with the dwThreadId parameter set to a value of zero. This will return the handle for the current queue management session which invoked the callback function.
- If a callback function is provided, the HTTP_QUEUE_EVENT event notification will be invoked whenever the internal state of the queue has changed. The handle value passed to the callback function will be a handle to the queue, not to a client connection. The HttpGetQueueStatus function can be called within the event handler to obtain the current state of the queue. This will event will always occur when the queue manager begins processing files in the queue and after it has stopped. This event will also occur whenever the queue is suspended and then resumed.
- The HttpWaitForQueue function can be used to wait for the queue manager to complete processing the transfer queue.

### Example

```cpp
// Create a new queue
HQUEUE hQueue = HttpCreateQueue(INFINITE, HTTP_TIMEOUT, HTTP_OPTION_DEFAULT);

if (hQueue == INVALID_QUEUE)
	return;

// Add a file to the queue
DWORD dwFileId = HttpAddQueuedFile(
					hQueue,
					lpszLocalFile,
					lpszRemoteFile,
					HTTP_OPTION_DEFAULT,
					HTTP_TIMEOUT);

// Display information about the queued file
if (dwFileId != 0)
{
	HTTPQUEUEDFILE queuedFile;

	if (HttpGetQueuedFile(hQueue, dwFileId, &queuedFile))
	{
		switch (queuedFile.dwMode)
		{
		case HTTP_QUEUE_DOWNLOAD:
			_tprintf(_T("%u: Download \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szRemoteFile,
						queuedFile.szLocalFile);
				break;

		case HTTP_QUEUE_UPLOAD:
			_tprintf(_T("%u: Upload \"%s\" to \"%s\"\n"),
						dwFileId,
						queuedFile.szLocalFile,
						queuedFile.szRemoteFile);
				break;
		}
	}
}

// Start the queued file transfers and wait for it to complete
if (HttpStartQueue(hQueue, HTTP_QUEUE_ALL, 0, NULL, 0))
{
	HttpWaitForQueue(hQueue, INFINITE, &dwElapsed, &dwError);
	HttpStopQueue(hQueue);
}

// Remove all files from the queue
HttpDeleteQueue(hQueue);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpEventProc](#httpeventproc-function)
- [HttpGetQueueStatus](#httpgetqueuestatus-function)
- [HttpGetThreadQueue](#httpgetthreadqueue-function)
- [HttpResumeQueue](#httpresumequeue-function)
- [HttpStartQueue](#httpstartqueue-function)
- [HttpStopQueue](#httpstopqueue-function)
- [HttpSuspendQueue](#httpsuspendqueue-function)
- [HttpWaitForQueue](#httpwaitforqueue-function)

---

## HttpStopQueue Function

Stop transferring the files in the specified queue

### Prototype

```c
BOOL WINAPI HttpStopQueue(
    HQUEUE hQueue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, it will return zero. To get extended error information, call HttpGetLastError.

### Remarks

- When the HttpStopQueue function is called and there is a file transfer in progress, it will not immediately stop the upload or download of the file. Instead, the queue manager is signaled to stop processing additional files in the queue after the transfer has completed. To wait for the current transfer to complete, call the HttpWaitForQueue function.
- It is permitted to call HttpStopQueue from within a queue event handler. In this case, the current file transfer will complete and the queue manager will terminate.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpCancelQueuedFile](#httpcancelqueuedfile-function)
- [HttpResetQueue](#httpresetqueue-function)
- [HttpResumeQueue](#httpresumequeue-function)
- [HttpStartQueue](#httpstartqueue-function)
- [HttpSuspendQueue](#httpsuspendqueue-function)
- [HttpWaitForQueue](#httpwaitforqueue-function)

---

## HttpSubmitForm Function

Submit the specified form to the server for processing

### Prototype

```c
INT WINAPI HttpSubmitForm(
    HCLIENT hClient,
    HFORM hForm,
    LPVOID lpvResult,
    LPDWORD lpcbResult,
    DWORD dwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `hForm` | `HFORM` | Handle to the virtual form which contains the data to be submitted to the server. |
| `lpvResult` | `LPVOID` | A pointer to a byte buffer which will contain the data returned by the server, or a pointer to a global memory handle which will reference the data when the function returns. |
| `lpcbResult` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvBuffer parameter. If the lpvResult parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the actual number of bytes of data that was returned. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |

### Options

- **dwOptions** Parameter

    - `HTTP_SUBMIT_DEFAULT`: The default post mode. The contents of the buffer are encoded and sent as standard form data. The data returned by the server is copied to the result buffer exactly as it is returned from the server.
    - `HTTP_SUBMIT_CONVERT`: If the data being returned from the server is textual, it is automatically converted so that the end of line character sequence is compatible with the Windows platform. Individual carriage return or linefeed characters are converted to carriage return/linefeed character sequences. Note that this option does not have any effect on the form data being submitted to the server, only on the data returned by the server.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server result code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpSubmitForm function is used to submit form data to a script that executes on the server and then copy the output from that script into a local buffer. The function may be used in one of two ways, depending on the needs of the application. The first method is to pre-allocate a buffer large enough to store the resulting output of the script. In this case, the lpvResult parameter will point to the buffer that was allocated by the client and the value that the lpcbResult parameter points to should be initialized to the size of that buffer.
- The second method that can be used is have the lpvResult parameter point to a global memory handle which will contain the data when the function returns. In this case, the value that the lpcbResult parameter points to must be initialized to zero. It is important to note that the memory handle returned by the function must be freed by the application, otherwise a memory leak will occur. See the example code below.
- This function will cause the current thread to block until the post completes, a timeout occurs or the operation is canceled. During the transfer, the HTTP_EVENT_PROGRESS event will be periodically fired, enabling the application to update any user interface controls. Event notification must be enabled, either by calling HttpEnableEvents, or by registering a callback function using the HttpRegisterEvent function.
- To determine the current status of a transaction while it is in progress, use the HttpGetTransferStatus function.

### Example

```cpp
HFORM hForm = INVALID_FORM;
HGLOBAL hgblResult = (HGLOBAL)NULL;
DWORD cbResult = 0;
INT nResult = 0;

hForm = HttpCreateForm(_T("/login.php"), HTTP_METHOD_POST, HTTP_FORM_ENCODED);

if (hForm == INVALID_FORM)
	return;

HttpAddFormField(hForm, _T("UserName"), lpszUserName, (DWORD)-1L, 0);
HttpAddFormField(hForm, _T("Password"), lpszPassword, (DWORD)-1L, 0);

nResult = HttpSubmitForm(hClient, hForm, &hgblResult, &cbResult, 0);
HttpDestroyForm(hForm);

if (hgblResult != NULL)
{
	LPBYTE lpBuffer = (LPBYTE)GlobalLock(hgblResult);

	// lpBuffer points to data returned by the server after the form
	// data was submitted

	GlobalUnlock(hgblResult);
	GlobalFree(hgblResult);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddFormField](#httpaddformfield-function)
- [HttpAddFormFile](#httpaddformfile-function)
- [HttpClearForm](#httpclearform-function)
- [HttpCreateForm](#httpcreateform-function)
- [HttpDeleteFormField](#httpdeleteformfield-function)
- [HttpRegisterEvent](#httpregisterevent-function)

---

## HttpSubmitRequest Function

Submit a request to the server and return the response

### Prototype

```c
INT WINAPI HttpSubmitRequest(
    DWORD dwRequestType,
    LPCTSTR lpszResource,
    LPHTTPCONNECTION lpConnection,
    LPCVOID lpvRequest,
    DWORD dwRequestLength,
    LPVOID lpvResponse,
    LPDWORD lpdwResponseLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `dwRequestType` | `DWORD` | An unsigned integer which specifies the type of request being submitted to the server. It may be one of the following values: |
| `lpszResource` | `LPCTSTR` | A pointer to a null-terminated string which specifies the complete URL for the resource. Both standard and secure connections are supported, and query parameters may be included with the URL. This parameter cannot be NULL and must specify an absolute (fully qualified) URI which begins with either http:// or https://. |
| `lpConnection` | `LPHTTPCONNECTION` | A pointer to a HTTPCONNECTION structure which contains additional information about the client connection. This structure is required if your application must connect through a proxy server or when authentication is required to access a resource. This parameter can be NULL, in which case default values will be used when establishing the connection. |
| `lpvRequest` | `LPCVOID` | A pointer to a buffer which contains the payload data submitted to the server as part of the request. This parameter may point to a byte buffer or a null-terminated string. If there is no payload required for the request this parameter may be NULL. If the Unicode version of this function is called and the request buffer contains text, it will be automatically converted to UTF-8 prior to submitting the data to the server. If the dwRequestLength parameter is -1, the payload will always be processed as a null-terminated string and the function will fail if the buffer does not contain text characters. |
| `dwRequestLength` | `DWORD` | An unsigned integer which specifies the size of the request payload. If the payload contains text, this should specify the number of characters in the buffer. If the payload contains binary data, this value should specify the number of bytes in the buffer. If the lpvRequest parameter points to a null-terminated string, this value can be -1 and the length of the payload will be determined automatically. If the Unicode version of this function is called and the length is -1, the request payload will be UTF-8 encoded prior to being submitted to the server. |
| `lpvResponse` | `LPVOID` | A pointer to a byte buffer which will contain the data returned by the server, or a pointer to a global memory handle which will reference the data when the function returns. This parameter may be NULL if the response data is not required. If this parameter is NULL, the lpdwResponseLength parameter must also be NULL. If a response buffer is provided, the data will always be returned as a byte stream, even when the Unicode version of this function is called. If the server returns a text payload, it will typically be UTF-8 encoded and the application can convert the text to Unicode using the MultiByteToWideChar function. |
| `lpdwResponseLength` | `LPDWORD` | A pointer to an unsigned integer which should be initialized to the maximum number of bytes that can be copied to the buffer specified by the lpvResponse parameter. If the lpvResponse parameter points to a global memory handle, the length value should be initialized to zero. When the function returns, this value will be updated with the actual number of bytes of data that was returned. If the lpvResponse parameter is not NULL, this parameter cannot be NULL. |

### Options

- **dwRequestType** Parameter

    - `HTTP_METHOD_DEFAULT`: Perform a default request action based on the value of parameters passed to this function. If there is no request payload, the action will default to HTTP_METHOD_GET, otherwise it will default to HTTP_METHOD_POST. It is generally recommended that you explicitly specify the request method; however, this default value can be useful if your application does not know if a payload will be included with the request at the time the function is called.
    - `HTTP_METHOD_GET`: Use the GET method when submitting the request to the server. If this action is used, the lpvRequest and dwRequestLength parameters will be ignored. The buffer specified by the lpvResponse parameter will contain the server's response to the request.
    - `HTTP_METHOD_POST`: Use the POST method when submitting the request to the server. The payload specified by the lpvRequest parameter will be included with the request and the buffer specified by the lpvResponse parameter will contain the server's response to the request.
    - `HTTP_METHOD_PUT`: Use the PUT method when submitting the request to the server. The payload specified by the lpvRequest parameter will be included with the request. This method is typically used with persistent storage on the server, such as uploading the contents of a file. If the lpvResponse parameter is not NULL, it will contain any response from the server after the operation has completed.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the server status code. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError. The application should always check the return value to determine if the request was successful. If the server returns a 4xx or 5xx status code, this indicates the request was not accepted and the response buffer will typically contain information about the cause of the failure.

### Remarks

- The HttpSubmitRequest function provides a single high-level interface for submitting requests to a web server and returning the server's response. This function is entirely self-contained and does not require a client session handle. The current thread will block until the function returns and will not generate event notifications. If you need to download a large file from a web server and want progress updates, it is recommended you use the HttpDownloadFile function.
- If the service you are using requires authentication, you will need to allocate a HTTPCONNECTION structure and set the appropriate member values to specify the authentication method and user credentials. This structure also allows you to provide additional information, such as additional request header values, a custom timeout period and additional connection options.
- When the lpvRequest parameter is not NULL, the contents of the buffer will be examined to determine if it contains text or binary data. If the dwRequestLength parameter is -1, the lpvRequest parameter is always considered to be a pointer a null-terminated string, with the length calculated by counting the number of characters up to the terminating null character. If the request payload is text, the function will also attempt to determine if the payload looks like XML or JSON and will automatically set the appropriate content type. The application can explicitly provide a MIME content type by setting the lpszContentType member of the HTTPCONNECTION structure.

### Example

```cpp
// Submit an XML payload to the server and return the response in a global
// memory buffer allocated by the function
LPCTSTR lpszResource = _T("https://www.example.com/postxml"); 
LPCTSTR lpszRequest = _T("<?xml version=\"1.0\" encoding=\"utf-8\"?>\r\n") \
					_T("<test>\r\n") \
					_T("  <data param=\"A\">Value1</data>\r\n") \
					_T("  <data param=\"B\">Value2</data>\r\n") \
					_T("</test>\r\n");

// Provide additional connection information which includes user credentials
// and a custom header which includes an API token for the service; note that
// we need to initialize the dwSize member of the structure
HTTPCONNECTION httpConnection = { 0, };
httpConnection.dwSize = sizeof(httpConnection);
httpConnection.nAuthType = HTTP_AUTH_BASIC;
httpConnection.lpszUserName = _T("userid");
httpConnection.lpszPassword = _T("secret");
httpConnection.lpszContentType = _T("application/xml");
httpConnection.lpszHeaders = _T("X-API-Token: 99d2fe39-0246-4efa-98e0-4d775579fa5d");

// Declare the global memory handle which will contain the server response
// and initialize the length to 0, which tells the API that a HGLOBAL handle
// is being used rather than a pointer to a pre-allocated buffer
HGLOBAL hgblResponse = NULL;
DWORD dwLength = 0;

INT nResult = HttpSubmitRequest(
	HTTP_METHOD_POST,
	lpszResource,
	&httpConnection,
	lpszRequest,
	(DWORD)-1,
	&hgblResponse,
	&dwLength);

if (nResult != HTTP_ERROR && hgblResponse != NULL)
{
	LPBYTE lpBuffer = (LPBYTE)GlobalLock(hgblResponse);

	// The lpBuffer variable points to the data returned by the server and
	// the application is responsible for freeing the global memory handle

	GlobalUnlock(hgblResponse);
	GlobalFree(hgblResponse);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpDownloadFile](#httpdownloadfile-function)
- [HttpGetData](#httpgetdata-function)
- [HttpPostData](#httppostdata-function)
- [HttpPostJson](#httppostjson-function)
- [HttpPostXml](#httppostxml-function)
- [HttpUploadFile](#httpuploadfile-function)
- [HTTPCONNECTION](#httpconnection-function)

---

## HttpSuspendQueue Function

Pause the transfer of files in the specified queue

### Prototype

```c
BOOL WINAPI HttpSuspendQueue(
    HQUEUE hQueue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, it will return zero. To get extended error information, call HttpGetLastError.

### Remarks

- If there is a file transfer in progress when this function is called, the transfer will complete normally. The queue manager will enter a suspended state after the transfer has completed and before it begins processing the next file in the queue.
- It is permitted to call HttpSuspendQueue from within a queue event handler. In this case, the current file transfer will complete and the queue manager will stop processing additional files in the queue until it is resumed or stopped.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpCancelQueuedFile](#httpcancelqueuedfile-function)
- [HttpGetQueueStatus](#httpgetqueuestatus-function)
- [HttpResetQueue](#httpresetqueue-function)
- [HttpResumeQueue](#httpresumequeue-function)
- [HttpStartQueue](#httpstartqueue-function)
- [HttpStopQueue](#httpstopqueue-function)

---

## HttpTaskAbort Function

Abort the specified asynchronous task

### Prototype

```c
BOOL WINAPI HttpTaskAbort(
    UINT nTaskId,
    DWORD dwMilliseconds
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nTaskId` | `UINT` | The task identifier. |
| `dwMilliseconds` | `DWORD` | An unsigned integer that specifies the number of milliseconds to wait for the background task to abort. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds and the worker thread has terminated, the return value is non-zero. A return value of zero indicates that the worker thread is still running or an error has occurred. To get extended error information, call the HttpGetLastError function.

### Remarks

- The HttpTaskAbort function signals the background worker thread associated with the task ID to abort the current operation and terminate as soon as possible. If the dwMilliseconds parameter has a value of zero, the function returns immediately after the background thread has been signaled. If the dwMilliseconds parameter is non-zero, the function will wait that amount of time for the background thread to terminate.
- This function should never be called from within the event handler for an asynchronous task because it can cause the process to deadlock. To abort a file transfer within an event handler, use the HttpCancel function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpTaskDone](#httptaskdone-function)
- [HttpTaskResume](#httptaskresume-function)
- [HttpTaskSuspend](#httptasksuspend-function)
- [HttpTaskWait](#httptaskwait-function)

---

## HttpTaskDone Function

Determine if an asynchronous task has completed

### Prototype

```c
BOOL WINAPI HttpTaskDone(
    UINT nTaskId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nTaskId` | `UINT` | The task identifier. |

### Return Value

- **Type**: `BOOL`
- If the asynchronous task has completed, this function returns a non-zero value. A return value of zero indicates that the worker thread is still running or an error has occurred. To get extended error information, call the HttpGetLastError function.

### Remarks

- The HttpTaskDone function is used to determine if the specified asynchronous task has completed. If you use this function to poll the status of a background task from within the main UI thread, you must ensure that Windows messages are processed so that the application remains responsive to the end-user. To check if a background transfer has completed, it is recommended that you use a timer to periodically call this function rather than calling it repeatedly within a loop.
- To determine if the task completed successfully, the HttpGetTaskError function will return the last error code associated with the task. A return value of zero indicates success, while a non-zero return value specifies an error code that indicates the cause of the failure. The last error code for the task can also be retrieved using the HttpTaskWait function, which causes the application to wait for the asynchronous task to complete.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpGetTaskError](#httpgettaskerror-function)
- [HttpTaskAbort](#httptaskabort-function)
- [HttpTaskResume](#httptaskresume-function)
- [HttpTaskSuspend](#httptasksuspend-function)
- [HttpTaskWait](#httptaskwait-function)

---

## HttpTaskResume Function

Resume execution of an asynchronous task

### Prototype

```c
BOOL WINAPI HttpTaskResume(
    UINT nTaskId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nTaskId` | `UINT` | The task identifier. |

### Return Value

- **Type**: `BOOL`
- If the asynchronous task has resumed, this function returns a non-zero value. A return value of zero indicates that an error has occurred. To get extended error information, call the HttpGetLastError function.

### Remarks

- The HttpTaskResume function resumes execution of the background worker thread that was previously suspended using the HttpTaskSuspend function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpTaskAbort](#httptaskabort-function)
- [HttpTaskDone](#httptaskdone-function)
- [HttpTaskSuspend](#httptasksuspend-function)
- [HttpTaskWait](#httptaskwait-function)

---

## HttpTaskSuspend Function

Suspend execution of an asynchronous task

### Prototype

```c
BOOL WINAPI HttpTaskSuspend(
    UINT nTaskId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nTaskId` | `UINT` | The task identifier. |

### Return Value

- **Type**: `BOOL`
- If the asynchronous task has resumed, this function returns a non-zero value. A return value of zero indicates that an error has occurred. To get extended error information, call the HttpGetLastError function.

### Remarks

- The HttpTaskSuspend function will suspend execution of the background worker thread associated with the task. Once the task has been suspended, it will no longer be scheduled for execution, however the client session will remain active and the task may be resumed using the HttpTaskResume function. Note that if a task is suspended for a long period of time, the background operation may fail because it has exceeded the timeout period imposed by the server.
- This function should never be called from within the event handler for an asynchronous task because it can cause the process to deadlock.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpTaskAbort](#httptaskabort-function)
- [HttpTaskDone](#httptaskdone-function)
- [HttpTaskResume](#httptaskresume-function)
- [HttpTaskWait](#httptaskwait-function)

---

## HttpTaskWait Function

Wait for an asynchronous task to complete

### Prototype

```c
BOOL WINAPI HttpTaskWait(
    UINT nTaskId,
    DWORD dwMilliseconds,
    DWORD dwReserved,
    LPDWORD lpdwElapsed,
    LPDWORD lpdwError
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nTaskId` | `UINT` | The task identifier. |
| `dwMilliseconds` | `DWORD` | An unsigned integer that specifies the number of milliseconds to wait for the background task to complete. |
| `dwReserved` | `DWORD` | An unsigned integer reserved for future use. This value should always be zero. |
| `lpdwElapsed` | `LPDWORD` | A pointer to an unsigned integer that will contain elapsed time in milliseconds when the function returns. If this information is not required, this parameter may be NULL. |
| `lpdwError` | `LPDWORD` | A pointer to an unsigned integer that will contain the error code associated with the completed task. If this information is not required, this parameter may be NULL. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds and the worker thread has terminated, the return value is non-zero. A return value of zero indicates that the worker thread is still running or an error has occurred. To get extended error information, call the HttpGetLastError function.

### Remarks

- The HttpTaskWait function waits for the specified task to complete. If the task is active and the dwMilliseconds parameter is non-zero, this function will cause the current working thread to block until the task completes or the amount of time exceeds the number of milliseconds specified by the caller. If the dwMilliseconds parameter is zero, then this function will poll the status of the task and return immediately to the caller.
- If the specified task has already completed at the time this function is called, the function will return immediately without causing the current thread to block. If the lpdwElapsed parameter is not NULL, it will contain the number of milliseconds that it took for the task to complete. If the lpdwError parameter is not NULL, it will contain the last error code value that was set by the worker thread before it terminated. If this value is zero, that means that the background operation was successful and no error occurred. A non-zero value will indicate that the background operation has failed.
- You should not call this function from the main UI thread with a long timeout period to wait for a background task to complete. Windows messages will not be processed while this function is blocked waiting for the background task to complete, and this can cause your application to appear non-responsive to the end-user. If you have a GUI application and you need to periodically check to see if a task has completed, create a timer to periodically call the HttpTaskDone function. When it returns a non-zero value (indicating that the task has completed), you can safely call HttpTaskWait to obtain the elapsed time and last error code without blocking the current thread.
- This function should never be called from within the event handler for an asynchronous task because it can cause the process to deadlock.

### Example

```cpp
UINT nTaskId;

// Begin a file transfer in the background

nTaskId = HttpAsyncGetFile(hClient,
						lpszLocalFile,
						lpszRemoteFile,
						HTTP_TRANSFER_DEFAULT,
						0,
						NULL,
						0);

if (nTaskId != 0)
{
	DWORD dwError = NO_ERROR;
	DWORD dwElapsed = 0;

	// Wait for the transfer to complete
	HttpTaskWait(nTaskId, INFINTE, &dwElapsed, &dwError);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpTaskDone](#httptaskdone-function)
- [HttpTaskResume](#httptaskresume-function)
- [HttpTaskSuspend](#httptasksuspend-function)
- [HttpTaskWait](#httptaskwait-function)

---

## HttpUninitialize Function

Terminate use of the library by the application

### Prototype

```c
VOID WINAPI HttpUninitialize();
```

### Parameters

| Name | Type | Description |
|------|------|-------------|

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- An application is required to perform a successful HttpInitialize call before it can call any of the other library functions. When it has completed the use of library, the application must call HttpUninitialize to allow the library to free any resources allocated on behalf of the process. Any pending blocking or asynchronous calls in this process are canceled without posting any notification messages, and all sockets that were opened by the process are closed.
- There must be a call to HttpUninitialize for every successful call to HttpInitialize made by a process. In a multithreaded environment, operations for all threads in the client are terminated.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpDisconnect](#httpdisconnect-function)
- [HttpInitialize](#httpinitialize-function)

---

## HttpUploadFile Function

Upload a file from the local system to the server

### Prototype

```c
BOOL WINAPI HttpUploadFile(
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    UINT nTimeout,
    DWORD dwOptions,
    LPHTTPTRANSFERSTATUS lpStatus,
    HTTPEVENTPROC lpEventProc,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the file on the local system that will be uploaded to the server. The file pathing and name conventions must be that of the local host. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the complete URL of the file that will be created or overwritten on the server. The URL must follow the conventions for the Hypertext Transfer Protocol and may specify either a standard or secure connection, alternate port number, username, password and optional working directory. |
| `nTimeout` | `UINT` | The number of seconds that the client will wait for a response before failing the operation. A value of zero specifies that the default timeout period of sixty seconds will be used. |
| `dwOptions` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |
| `lpStatus` | `LPHTTPTRANSFERSTATUS` | A pointer to an HTTPTRANSFERSTATUS structure which contains information about the status of the current file transfer. If this information is not required, a NULL pointer may be specified as the parameter. |
| `lpEventProc` | `HTTPEVENTPROC` | Specifies the procedure-instance address of the application defined callback function. For more information about the callback function, see the description of the HttpEventProc callback function. If this parameter is NULL, the callback for the specified event is disabled. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. |

### Options

- **dwOptions** Parameter

    - `HTTP_OPTION_NOCACHE`: This instructs the server to not return a cached copy of the resource. When connected to an HTTP 1.0 or earlier server, this directive may be ignored.
    - `HTTP_OPTION_REDIRECT`: This option specifies the client should automatically handle resource redirection. If the server indicates that the requested resource has moved to a new location, the client will close the current connection and request the resource from the new location. Note that it is possible that the redirected resource will be located on a different server.
    - `HTTP_OPTION_PROXY`: This option specifies the client should use the default proxy configuration for the local system. If the system is configured to use a proxy server, then the connection will be automatically established through that proxy; otherwise, a direct connection to the server is established. The local proxy configuration can be changed using the system Control Panel.
    - `HTTP_OPTION_NOUSERAGENT`: This option specifies the client should not include a User-Agent header with any requests made during the session. The user agent is a string which is used to identify the client application to the server. If this option is not specified, a default user agent string will be included with the request.
    - `HTTP_OPTION_HTTP2`: This option specifies the client should attempt a HTTP/2 connection with the server. If a connection cannot be established using HTTP/2 the client will attempt to connect using an earlier version of the protocol.
    - `HTTP_OPTION_TUNNEL`: This option specifies that a tunneled TCP connection and/or port-forwarding is being used to establish the connection to the server. This changes the behavior of the client with regards to internal checks of the destination IP address and remote port number, default capability selection and how the connection is established.
    - `HTTP_OPTION_TRUSTEDSITE`: This option specifies the server is trusted. The server certificate will not be validated and the connection will always be permitted. This option only affects connections using the TLS protocol.
    - `HTTP_OPTION_SECURE`: This option specifies the client should attempt to establish a secure connection with the server. Note that the server must support secure connections using the TLS protocol. The client will default to using TLS 1.2 or later for secure connections.
    - `HTTP_OPTION_SECURE_FALLBACK`: This option specifies the client should permit the use of less secure cipher suites for compatibility with legacy servers. If this option is specified, the client will allow connections using TLS 1.0 and cipher suites that use RC4, MD5 and SHA1.
    - `HTTP_OPTION_PREFER_IPV6`: This option specifies the client should prefer the use of IPv6 if the server hostname can be resolved to both an IPv6 and IPv4 address. This option is ignored if the local system does not have IPv6 enabled, or when the hostname can only be resolved to an IPv4 address. If the server hostname can only be resolved to an IPv6 address, the client will attempt to establish a connection using IPv6 regardless if this option has been specified.
    - `HTTP_OPTION_HIRES_TIMER`: This option specifies the elapsed time for data transfers should be returned in milliseconds instead of seconds. This will return more accurate transfer times for smaller amounts of data over fast network connections.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpUploadFile function provides a convenient way for an application to upload a file in a single function call. Based on the connection information specified in the URL, it will connect to the server, authenticate the session and then upload the file to the server. The URL must be complete, and specify either a standard or secure HTTP scheme:
- If no user name and password is provided, then the client session will be authenticated as an anonymous user. The URL scheme will always determine if the connection is secure, not the option. In other words, if the "http" scheme is used and the HTTP_OPTION_SECURE option is specified, that option will be ignored. To establish a secure connection, the "https" scheme must be specified.
- Not all web servers permit files to be uploaded and some may require that specific configuration changes be made to the server in order to support this functionality. Consult your server's technical reference documentation to see if it supports the PUT command, and if so, what must be done to enable it. It may be required that the URL specify a username and password to upload a file.
- If your application requests a HTTP/2 connection and the server only accepts earlier versions of the protocol, the client will attempt to automatically downgrade the request to HTTP/1.1. If a connection using an earlier version of the protocol cannot be established, the method will fail and return a value of zero.
- The lpStatus parameter can be used by the application to determine the final status of the transfer, including the total number of bytes copied, the amount of time elapsed and other information related to the transfer process. If this information isn't needed, then this parameter may be specified as NULL.
- The lpEventProc parameter specifies a pointer to a function which will be periodically called during the file transfer process. This can be used to check the status of the transfer by calling HttpGetTransferStatus and then update the program's user interface. For example, the callback function could calculate the percentage for how much of the file has been transferred and then update a progress bar control. The dwParam parameter is used in conjunction with the event handler and specifies a user-defined value that is passed to the callback function. One common use in a C++ program is to pass the this pointer as the value, and then cast it back to an object pointer inside the callback function. If no event handler is required, then a NULL pointer can be specified as the value for lpEventProc and the dwParam parameter will be ignored.
- The HttpUploadFile function is designed to provide a simpler interface for uploading a file. However, complex connections such as those using a specific proxy server or a secure connection which uses a client certificate will require the program to establish the connection using HttpConnect or HttpProxyConnect and then use HttpPutFile to upload the file. If the server does not support the PUT command, you may be able to upload files using the HttpPostFile function. Refer to that function for more information.

### Example

```cpp
HTTPTRANSFERSTATUS httpStatus;
LPCTSTR lpszLocalFile = _T("c:\\temp\\database.mdb");
LPCTSTR lpszRemoteFile = _T("https://update:secret@www.example.com/updates/database.mdb");
BOOL bResult;

// Upload the file using the specified URL
bResult = HttpUploadFile(lpszLocalFile,
						lpszRemoteFile,
						HTTP_OPTION_DEFAULT,
						&httpStatus,
						NULL, 0);

if (!bResult)
{
	TCHAR szError[128];

	// Display a message box that describes the error
	HttpGetErrorString(HttpGetLastError(), szError, 128);
	MessageBox(NULL, szError, NULL, MB_ICONEXCLAMATION|MB_TASKMODAL);
	return;
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpDownloadFile](#httpdownloadfile-function)
- [HttpEventProc](#httpeventproc-function)
- [HttpGetTransferStatus](#httpgettransferstatus-function)
- [HttpPostFile](#httppostfile-function)
- [HttpPutFile](#httpputfile-function)
- [HttpSubmitRequest](#httpsubmitrequest-function)
- [HTTPTRANSFERSTATUS](#httptransferstatus-function)

---

## HttpValidateHostName Function

Validate the specified host name and return the resolved IP address

### Prototype

```c
BOOL WINAPI HttpValidateHostName(
    LPCTSTR lpszHostName,
    LPTSTR lpszAddress,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszHostName` | `LPCTSTR` | A pointer to a null terminated string which specifies the host name. The function will fail If this parameter is NULL or an empty string. |
| `lpszAddress` | `LPTSTR` | A pointer to a string buffer which will contain the IP address of the host. If specified, this string must be large enough to store the complete IP address, including the terminating null character. If this parameter is NULL or the nMaxLength parameter is zero, it will be ignored and the IP address will not be returned. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters which can be copied into the lpszAddress string buffer. The buffer must be large enough to store the complete address. Because this function can return either an IPv4 or IPv6 address, it is recommended the minimum length for the buffer to be 46 characters. If this parameter is zero, the lpszAddress parameter will be ignored. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the host name is valid and the return value will be non-zero. If the function fails, the host name could not be resolved to an IP address and the return value will be zero. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpValidateHostName function provides a convenient way to determine if a host name is valid by attempting to resolve the name into an IP address. If the Unicode version of this function is used, any non-ASCII characters in the host name will be automatically encoded into a compatible format and then resolved to an IP address. If you are unsure if an internationalized domain name will be specified as the host name, it is recommended you use the Unicode version.
- If the lpszHostName parameter specifies a valid IPv4 or IPv6 address string instead of a host name, this function will return a copy of that IP address in the buffer provided by the caller. This allows the function to be used in cases where a user may input either a host name or IP address.
- If you wish to validate a complete HTTP URL instead of a host name, use the HttpValidateUrl function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpConnectUrl](#httpconnecturl-function)
- [HttpValidateUrl](#httpvalidateurl-function)

---

## HttpValidateUrl Function

Check the contents of a string to ensure it represents a valid URL

### Prototype

```c
BOOL WINAPI HttpValidateUrl(
    LPCTSTR lpszUrl
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszUrl` | `LPCTSTR` | A pointer to a string that specifies the URL to validate. |

### Return Value

- **Type**: `BOOL`
- If the specified URL is valid and the host name can be resolved to an IP address, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpValidateUrl function will check the value of a string to ensure that it represents a complete, valid URL using either a standard or secure HTTP scheme. This function will not establish a connection with the server to verify that it exists, it will only attempt to resolve the host name to an IP address. If the remote host is specified as an IP address, this function will check to make sure that the address is formatted correctly. Note that if you wish to specify an IPv6 address, you must enclose the address in brackets.
- To establish a connection with a server using a URL, use the HttpConnectUrl function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpConnectUrl](#httpconnecturl-function)
- [HttpValidateHostName](#httpvalidatehostname-function)

---

## HttpVerifyFile Function

Compare the size of a local file against a file stored on the server

### Prototype

```c
BOOL WINAPI HttpVerifyFile(
    HCLIENT hClient,
    LPCTSTR lpszLocalFile,
    LPCTSTR lpszRemoteFile,
    DWORD dwReserved
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpszLocalFile` | `LPCTSTR` | A pointer to a string that specifies the name of file on the local system. |
| `lpszRemoteFile` | `LPCTSTR` | A pointer to a string that specifies the name of the file on the server. |
| `dwReserved` | `DWORD` | A reserved parameter. This value should always be zero. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetLastError.

### Remarks

- The HttpVerifyFile function will attempt to verify that the contents of the local and remote files are identical by comparing the size of the files. This function is provided for compatibility with the File Transfer Protocol API, and should not be considered a reliable method for comparing files. Web servers may not consistently return file size information for dynamically created content such as HTML pages which use server-side includes.
- It is not recommended that you use this function with text files because of the different end-of-line conventions used by different operating systems. For example, a text file on a Windows system uses a carriage-return and linefeed pair to indicate the end of a line of text. However, on a UNIX system, a single linefeed is used to indicate the end of a line. This can cause the HttpVerifyFile function to indicate the files are not identical, even though the only difference is in the end-of-line characters that are used.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpDeleteFile](#httpdeletefile-function)
- [HttpGetFile](#httpgetfile-function)
- [HttpGetFileSize](#httpgetfilesize-function)
- [HttpPutFile](#httpputfile-function)

---

## HttpWaitForQueue Function

Wait for the transfer of all queued files to complete

### Prototype

```c
BOOL WINAPI HttpWaitForQueue(
    HQUEUE hQueue,
    DWORD dwMilliseconds,
    LPDWORD lpdwElapsed,
    LPDWORD lpdwError
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hQueue` | `HQUEUE` | A handle to a file transfer queue. |
| `dwMilliseconds` | `DWORD` | An unsigned integer value which specifies the number of milliseconds to wait for the queue to complete processing. If this value is zero, the function will return immediately. If this value is INFINITE (0xFFFFFFFF), the function will block indefinitely until all files in the queue have been processed. |
| `lpdwElapsed` | `LPDWORD` | A pointer to an unsigned integer which will contain the number of milliseconds the queue manager has been active when the function returns. If this information is not needed, this parameter can be NULL. If this parameter is not NULL, it will always be initialized to a value of zero. |
| `lpdwError` | `LPDWORD` | A pointer to an unsigned integer which will contain the last error code set if a file transfer has failed or was canceled. If this information is not needed, this parameter can be NULL. If this parameter is not NULL, it will always be initialized to a value of zero. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero, which means the queue manager has completed transferring all queued files. If the function fails, or the timeout period elapses, it will return zero. To get extended error information, call HttpGetLastError.

### Remarks

- This function will cause the current thread to block until either the queue manager has completed processing all files in the queue, or until the specified number of milliseconds have elapsed. It is important to note that Windows messages will not be processed during this time. If you call this function within the main UI thread, it can potentially cause the application to become non-responsive. To determine the current state of the queue without blocking the current thread, call the HttpGetQueueStatus function.
- If the dwMilliseconds parameter is non-zero and file transfers have not completed within the specified amount of time, the function will return zero and the last error code will be set to ST_ERROR_OPERATION_TIMEOUT.
- If an event callback function has been specified when starting the queue, you should never call this function within the event handler. Attempting to do so can potentially create a situation which will cause the application to become non-responsive. The function will return zero if it determines it's being called within the context of the queue manager thread and will set the last error code to ST_ERROR_THREAD_DEADLOCK.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpGetQueueStatus](#httpgetqueuestatus-function)
- [HttpResetQueue](#httpresetqueue-function)
- [HttpResumeQueue](#httpresumequeue-function)
- [HttpStartQueue](#httpstartqueue-function)
- [HttpStopQueue](#httpstopqueue-function)
- [HttpSuspendQueue](#httpsuspendqueue-function)

---

## HttpWrite Function

Write data to the server

### Prototype

```c
INT WINAPI HttpWrite(
    HCLIENT hClient,
    LPBYTE lpBuffer,
    INT cbBuffer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hClient` | `HCLIENT` | Handle to the client session. |
| `lpBuffer` | `LPBYTE` | The pointer to the buffer which contains the data that is to be sent to the server. |
| `cbBuffer` | `INT` | The number of bytes to send from the specified buffer. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of bytes actually written. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetLastError.

### Remarks

- The return value may be less than the number of bytes specified by the cbBuffer parameter. In this case, the data has been partially written and it is the responsibility of the client application to send the remaining data at some later point. For non-blocking clients, the client must wait for an asynchronous notification message before it resumes sending data.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtpv11.lib`

### See Also

- [HttpIsBlocking](#httpisblocking-function)
- [HttpIsReadable](#httpisreadable-function)
- [HttpIsWritable](#httpiswritable-function)
- [HttpRead](#httpread-function)

---

## HTTPCONNECTION Structure

The HTTPCONNECTION structure provides additional information used when submitting a request to the server.

### Definition

```c
typedef struct _HTTPCONNECTION
{
    DWORD dwSize;
    DWORD dwOptions;
    DWORD dwVersion;
    UINT nTimeout;
    UINT nEncoding;
    UINT nProxyType;
    UINT nProxyPort;
    UINT nAuthType;
    LPCTSTR lpszProxyServer;
    LPCTSTR lpszProxyUser;
    LPCTSTR lpszProxyPassword;
    LPCTSTR lpszUserAgent;
    LPCTSTR lpszUserName;
    LPCTSTR lpszPassword;
    LPCTSTR lpszContentType;
    LPCTSTR lpszHeaders;
    LPSECURITYCREDENTIALS lpCredentials;
} HTTPCONNECTION, *LPHTTPCONNECTION;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | The size of this structure in bytes. If this member is not initialized to the correct value, the structure will be considered invalid. |
| `dwOptions` | `DWORD` | A bitmask of supported options. The value of this structure member is constructed by using a bitwise operator with any of the following values: |
| `dwVersion` | `DWORD` | A value which specifies the requested protocol version used when sending requests to the server. The high word should specify the major version, and the low word should specify the minor version number. If this value is zero, the default protocol version will be used. The HTTPVERSION macro can be used to create a version value, or the following values can be used: |
| `nTimeout` | `UINT` | The number of seconds that the client will wait for a response from the server before failing the operation. If this value is zero, a default timeout period of 20 seconds will be used. |
| `nEncoding` | `UINT` | A value which specifies the content encoding type for the request. If the value is zero, no encoding will be used. The following values are defined: |
| `nProxyType` | `UINT` | A value which specifies the type of proxy server the client is connecting to. A value of zero specifies no proxy server is being used and the client should establish a direct connection to the server. The following proxy server types are supported: |
| `nProxyPort` | `UINT` | A value which specifies the port the proxy server will use to accept connections. This value is ignored if the proxy type is set to HTTP_PROXY_NONE or HTTP_PROXY_WINDOWS and no proxy configuration has been specified for the local system. |
| `nAuthType` | `UINT` | A value which specifies the type of authentication used to establish the connection. If the value is zero, the client session will not be authenticated. The following values are defined: |
| `lpszProxyServer` | `LPCTSTR` | A pointer to a null terminated string which identifies the proxy server which should be used to establish the connection. If this value is ignored if the nProxyType member is zero. If a proxy server type has been been specified, this value cannot be a NULL pointer or an empty string. |
| `lpszProxyUser` | `LPCTSTR` | A pointer to a null terminated string which specifies the user name used to authenticate the connection to the proxy server. If the proxy server does not require user authentication, this member can be a NULL pointer or an empty string. This member is ignored if the nProxyType member is zero. |
| `lpszProxyPassword` | `LPCTSTR` | A pointer to a null terminated string which specifies the password used to authenticate the connection to the proxy server. If the proxy server does not require user authentication, this member can be a NULL pointer or an empty string. This member is ignored if the nProxyType member is zero. |
| `lpszUserAgent` | `LPCTSTR` | A pointer to a null terminated string which identifies the application which is making a request to the server. If this value is NULL or an empty string, a default user agent string will be included with the request. To prevent a user agent from being included with the request, use the HTTP_OPTION_NOUSERAGENT option. |
| `lpszUserName` | `LPCTSTR` | A pointer to a null terminated string which specifies the user name used to authenticate the client session. This member may be NULL or an empty string if a user name is not required for the specified authentication type. |
| `lpszPassword` | `LPCTSTR` | A pointer to a null terminated string which specifies the password used to authenticate the client session. This member may be NULL or an empty string if a password is not required for the specified authentication type. If the authentication type is HTTP_AUTH_BEARER, this value must be the bearer token issued by the service provider. |
| `lpszContentType` | `LPCTSTR` | A pointer to a null terminated string which specifies the MIME content type for the request. If this member is NULL or specifies an empty string, the content type will be automatically determined based on the contents of the request payload. This value will only be used with PUT and POST methods. |
| `lpszHeaders` | `LPCTSTR` | A pointer to a null terminated string which specifies one or more additional header values which should be included with the request. The string must contain header name and value pairs separated by a colon, and multiple header values must be terminated with a carriage return/linefeed (CRLF) sequence after each value. The header values defined in this string will override any default values. |
| `lpCredentials` | `LPSECURITYCREDENTIALS` | A pointer to a SECURITYCREDENTIALS structure. This value is only used if the HTTP_OPTION_SECURE option is specified in the dwOptions member. This member may be NULL, in which case no client credentials will be provided to the server. |

### Remarks

- This structure is used with the HttpSubmitRequest function to provide additional information used to establish a connection with the server. The dwSize member must be initialized to the actual size of the structure in bytes, and all other members should be initialized to a value of zero or NULL. If the structure is not initialized correctly, the function will fail and the last error code will be set to ST_ERROR_INVALID_PARAMETER.
- Member values which are zero or NULL pointers will either be ignored or cause the function to use appropriate default values.
- Applications should use HTTP_VERSION_DEFAULT as the value for the dwVersion parameter. This will default to an appropriate version for the Windows platform and ensures the broadest compatibility with most servers. If your application specifies HTTP_VERSION_20, a secure connection using TLS 1.2 or later will always be used. The minimum required platform for HTTP/2 support is Windows 10 (Build 1903) or Windows Server 2019. Earlier versions of the Schannel SSP do not support the features required for a secure HTTP/2 connection.
- If your application requests a HTTP/2 connection and the server only accepts earlier versions of the protocol, the client will attempt to automatically downgrade the request to HTTP/1.1. If a connection using an earlier version of the protocol cannot be established, the connection attempt will fail.
- If the server requires a secure connection with a client certificate, the HttpCreateSecurityCredentials function can be used to allocate a credentials structure which can be assigned to the lpCredentials member. Call HttpDeleteSecurityCredentials after the HttpSubmitRequest function has returned to ensure the memory allocated for the security credentials has been freed.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpCreateSecurityCredentials](#httpcreatesecuritycredentials-structure)
- [HttpSubmitRequest](#httpsubmitrequest-structure)
- [SECURITYCREDENTIALS](#securitycredentials-structure)

---

## HTTPFORMPROPERTIES Structure

This structure is used by the HttpGetFormProperties and HttpSetFormProperties function to return and modify the properties of the specified form.

### Definition

```c
typedef struct _HTTPFORMPROPERTIES
{
    UINT nFormMethod;
    UINT nFormType;
    LPCTSTR lpszFormAction;
    DWORD dwReserved1;
    DWORD dwReserved2;
} HTTPFORMPROPERTIES, *LPHTTPFORMPROPERTIES;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `nFormMethod` | `UINT` | An unsigned integer value which specifies how the form data will be submitted to the server. It may be one of the following values: |
| `nFormType` | `UINT` | An unsigned integer value which specifies the type of form and how the data will be encoded when it is submitted to the server. It may be one of the following values: |
| `lpszFormAction` | `LPCTSTR` | A pointer to a string which specifies the name of the resource that the form data will be submitted to. Typically this is the name of a script that is executed on the server. |
| `dwReserved1` | `DWORD` | A reserved structure member. |
| `dwReserved2` | `DWORD` | A reserved structure member. |

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpCreateForm](#httpcreateform-structure)
- [HttpGetFormProperties](#httpgetformproperties-structure)
- [HttpSetFormProperties](#httpsetformproperties-structure)
- [HttpSubmitForm](#httpsubmitform-structure)

---

## HTTPQUEUEDFILE Structure

This structure is used by the HttpGetFirstQueuedFile , HttpGetNextQueuedFile and HttpGetQueuedFile functions to return information about a file in the transfer queue.

### Definition

```c
typedef struct _HTTPQUEUEDFILE
{
    DWORD dwFileId;
    DWORD dwQueueMode;
    DWORD dwQueueFlags;
    DWORD dwTimeElapsed;
    DWORD dwLastError;
    ULARGE_INTEGER uiBytesCopied;
} HTTPQUEUEDFILE, *LPHTTPQUEUEDFILE;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwFileId` | `DWORD` | An unsigned integer which specifies a unique identifier for the queued file. The application should not make any assumptions about the value of the file identifiers. They should be considered opaque values which are only guaranteed to uniquely identify a file in the transfer queue. In particular, there is no guarantee that the file identifiers will be sequential and they should not be used as index values into an array. |
| `dwQueueMode` | `DWORD` | An unsigned integer value which specifies how the file was queued for transfer. It may be one of the following values: |
| `dwQueueFlags` | `DWORD` | An unsigned integer which specifies one or more bit flags which provides information about the status of the file transfer. It may be one or more of the following values: |
| `dwTimeElapsed` | `DWORD` | An unsigned integer which specifies the number of milliseconds required to complete the transfer. This value will be zero unless the file has been transferred successfully. |
| `dwLastError` | `DWORD` | An unsigned integer which specifies the last error code for a failed transfer. If the file was transferred successfully, this value will be zero. |
| `uiBytesCopied` | `ULARGE_INTEGER` | A value which specifies the number of bytes which were copied during the file transfer. The ULARGE_INTEGER type is a union of a structure and a 64-bit value which can be used on both 32-bit and 64-bit systems. For languages other than C/C++ you can define this structure member as an unsigned 64-bit integer type. |

### Remarks

- It is possible that the szLocalFile and szRemoteFile structure members will be different than the values passed to the HttpAddQueuedFile function. Those values are normalized, with any relative paths converted to absolute paths. Internationalized domain names will be encoded and the URL paths will be collapsed, removing any extraneous path information. For example, if the remote file name is specified as https://www.server.tld/folder1/../folder2/filename.txt it would be normalized as https://www.server.tld/folder2/filename.txt.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

### See Also

- [HttpAddQueuedFile](#httpaddqueuedfile-structure)
- [HttpAddQueuedFileEx](#httpaddqueuedfileex-structure)
- [HttpGetFirstQueuedFile](#httpgetfirstqueuedfile-structure)
- [HttpGetNextQueuedFile](#httpgetnextqueuedfile-structure)
- [HttpGetQueuedFile](#httpgetqueuedfile-structure)

---

## HTTPQUEUESTATUS Structure

This structure is used by the HttpGetQueueStatus function to return information about the current status of the file transfer queue.

### Definition

```c
typedef struct _HTTPQUEUESTATUS
{
    DWORD dwStatus;
    DWORD dwThreadId;
    DWORD dwQueuedFiles;
    DWORD dwPendingFiles;
    DWORD dwCopiedFiles;
    DWORD dwFailedFiles;
    DWORD dwTimeElapsed;
    DWORD dwCurrentFile;
    DWORD dwLastError;
    ULARGE_INTEGER uiBytesCopied;
    ULARGE_INTEGER uiBytesTotal;
} HTTPQUEUESTATUS, *LPHTTPQUEUESTATUS;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwStatus` | `DWORD` | An unsigned integer which specifies the current status of the queue. It can be one of the following values: |
| `dwThreadId` | `DWORD` | An unsigned integer which specifies the thread ID for the queue manager which is performing the file transfers. All file transfers are performed asynchronously in a background worker thread. If this structure member is zero, the queue is idle and not performing file transfers. The application should not use the thread ID to obtain a handle to suspend or terminate the thread. This can potentially result in unexpected behavior or instability within the application. |
| `dwQueuedFiles` | `DWORD` | An unsigned integer which specifies the total number of queued files. This value includes pending and completed file transfers. |
| `dwPendingFiles` | `DWORD` | An unsigned integer which specifies the number of files which are queued to be transferred. |
| `dwCopiedFiles` | `DWORD` | An unsigned integer which specifies the number of files which have been successfully transferred. This value reflects the total number of files which have the HTTP_QUEUE_FLAG_COMPLETED status. |
| `dwFailedFiles` | `DWORD` | An unsigned integer which specifies the number of files which have failed to transfer or the file transfer has been canceled. This value reflects the total number of files which have the HTTP_QUEUE_FLAG_FAILED status. |
| `dwTimeElapsed` | `DWORD` | An unsigned integer which specifies the total amount of time, in milliseconds, the queue manager has been active performing a file transfer. If the queue is idle, this value will reflect the total run time for the previously active queue. A value of zero indicates the queue was never active or the queue state has been reset with a call to HttpResetQueue . |
| `dwCurrentFile` | `DWORD` | An unsigned integer which specifies the unique identifier for the current file being transferred. If no file transfer is in progress, this member will have a value of zero. If the value is non-zero, it can be passed to the HttpGetQueuedFile function to obtain information about the queued file. |
| `dwLastError` | `DWORD` | An unsigned integer which specifies the last error code for a failed file transfer. If there have been no errors, this value will be zero. |
| `uiBytesCopied` | `ULARGE_INTEGER` | A value which specifies the number of bytes which were copied during the current or last transfer. The ULARGE_INTEGER type is a union of a structure and a 64-bit value which can be used on both 32-bit and 64-bit systems. For languages other than C/C++ you can define this structure member as an unsigned 64-bit integer type. |
| `uiBytesTotal` | `ULARGE_INTEGER` | A value which specifies the total number of bytes which were copied during the current queue run. The ULARGE_INTEGER type is a union of a structure and a 64-bit value which can be used on both 32-bit and 64-bit systems. For languages other than C/C++ you can define this structure member as an unsigned 64-bit integer type. |

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

### See Also

- [HttpGetQueuedFile](#httpgetqueuedfile-structure)
- [HttpGetQueueStatus](#httpgetqueuestatus-structure)
- [HttpCancelQueuedFile](#httpcancelqueuedfile-structure)
- [HttpResetQueue](#httpresetqueue-structure)
- [HttpResumeQueue](#httpresumequeue-structure)
- [HttpStartQueue](#httpstartqueue-structure)
- [HttpStopQueue](#httpstopqueue-structure)
- [HttpSuspendQueue](#httpsuspendqueue-structure)

---

## HTTPTRANSFERSTATUS Structure

This structure is used by the HttpGetTransferStatus function to return information about a data transfer in progress.

### Definition

```c
typedef struct _HTTPTRANSFERSTATUS
{
    DWORD dwBytesTotal;
    DWORD dwBytesCopied;
    DWORD dwBytesPerSecond;
    DWORD dwTimeElapsed;
    DWORD dwTimeEstimated;
} HTTPTRANSFERSTATUS, *LPHTTPTRANSFERSTATUS;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwBytesTotal` | `DWORD` | The total number of bytes that will be transferred. If the data is being downloaded from the server to the local host, this is the size of the requested resource. If the data is being uploaded from the local host to the server, it is the size of the local file or memory buffer. If the size of the resource cannot be determined, this value will be zero. |
| `dwBytesCopied` | `DWORD` | The total number of bytes that have been copied. |
| `dwBytesPerSecond` | `DWORD` | The average number of bytes that have been copied per second. |
| `dwTimeElapsed` | `DWORD` | The number of seconds that have elapsed since the file transfer started. |
| `dwTimeEstimated` | `DWORD` | The estimated number of seconds until the data transfer is completed. This is based on the average number of bytes transferred per second. |

### Remarks

- If the option HTTP_OPTION_HIRES_TIMER has been specified when connecting to the server, the values returned in the dwTimeElapsed and dwTimeEstimated members will be in milliseconds instead of seconds. You can use this option to obtain more accurate elapsed times when uploading or downloading small amounts of data over a fast network connection.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

### See Also

- [HttpEnableEvents](#httpenableevents-structure)
- [HttpGetTransferStatus](#httpgettransferstatus-structure)
- [HttpGetTransferStatusEx](#httpgettransferstatusex-structure)
- [HttpRegisterEvent](#httpregisterevent-structure)
- [HTTPTRANSFERSTATUSEX](#httptransferstatusex-structure)

---

## HTTPTRANSFERSTATUSEX Structure

This structure is used by the HttpGetTransferStatusEx function to return information about a data transfer in progress. This structure is designed for use with extended functions that support files larger than 4GB.

### Definition

```c
typedef struct _HTTPTRANSFERSTATUSEX
{
    ULARGE_INTEGER uiBytesTotal;
    ULARGE_INTEGER uiBytesCopied;
    DWORD dwBytesPerSecond;
    DWORD dwTimeElapsed;
    DWORD dwTimeEstimated;
} HTTPTRANSFERSTATUSEX, *LPHTTPTRANSFERSTATUSEX;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `uiBytesTotal` | `ULARGE_INTEGER` | The total number of bytes that will be transferred. If the data is being downloaded from the server to the local host, this is the size of the requested resource. If the data is being uploaded from the local host to the server, it is the size of the local file or memory buffer. If the size of the resource cannot be determined, this value will be zero. |
| `uiBytesCopied` | `ULARGE_INTEGER` | The total number of bytes that have been copied. |
| `dwBytesPerSecond` | `DWORD` | The average number of bytes that have been copied per second. |
| `dwTimeElapsed` | `DWORD` | The number of seconds that have elapsed since the file transfer started. |
| `dwTimeEstimated` | `DWORD` | The estimated number of seconds until the data transfer is completed. This is based on the average number of bytes transferred per second. |

### Remarks

- If the option HTTP_OPTION_HIRES_TIMER has been specified when connecting to the server, the values returned in the dwTimeElapsed and dwTimeEstimated members will be in milliseconds instead of seconds. You can use this option to obtain more accurate elapsed times when uploading or downloading small amounts of data over a fast network connection.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

### See Also

- [HttpEnableEvents](#httpenableevents-structure)
- [HttpGetTransferStatus](#httpgettransferstatus-structure)
- [HttpGetTransferStatusEx](#httpgettransferstatusex-structure)
- [HttpRegisterEvent](#httpregisterevent-structure)
- [HTTPTRANSFERSTATUS](#httptransferstatus-structure)

---

## INITDATA Structure

This structure contains information about the SocketTools library when the initialization function returns.

### Definition

```c
typedef struct _INITDATA
{
    DWORD dwSize;
    DWORD dwVersionMajor;
    DWORD dwVersionMinor;
    DWORD dwVersionBuild;
    DWORD dwOptions;
    DWORD_PTR dwReserved1;
    DWORD_PTR dwReserved2;
    TCHAR szDescription;
} INITDATA, *LPINITDATA;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | Size of this structure. This structure member must be set to the size of the structure prior to calling the initialization function. Failure to do so will cause the function to fail. |
| `dwVersionMajor` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. When the function returns, it will contain the major version number for the library. |
| `dwVersionMinor` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. When the function returns, it will contain the minor version number for the library. |
| `dwVersionBuild` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. When the function returns, it will contain the build number for the library. |
| `dwOptions` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. This member is reserved for future use. |
| `dwReserved1` | `DWORD_PTR` | This member must be initialized to a value of zero prior to calling the initialization function. This member is reserved for future use. |
| `dwReserved2` | `DWORD_PTR` | This member must be initialized to a value of zero prior to calling the initialization function. This member is reserved for future use. |
| `szDescription` | `TCHAR` | A null terminated string which describes the library. |

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

---

## SECURITYCREDENTIALS Structure

The SECURITYCREDENTIALS structure specifies the information needed by the library to specify additional security credentials, such as a client certificate, when establishing a secure connection.

### Definition

```c
typedef struct _SECURITYCREDENTIALS
{
    DWORD dwSize;
    DWORD dwProtocol;
    DWORD dwOptions;
    DWORD dwReserved;
    LPCTSTR lpszHostName;
    LPCTSTR lpszUserName;
    LPCTSTR lpszPassword;
    LPCTSTR lpszCertStore;
    LPCTSTR lpszCertName;
    LPCTSTR lpszKeyFile;
} SECURITYCREDENTIALS, *LPSECURITYCREDENTIALS;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | Size of this structure. If the structure is being allocated dynamically, this member must be set to the size of the structure and all other unused structure members must be initialized to a value of zero or NULL. |
| `dwProtocol` | `DWORD` | A bitmask of supported security protocols. The value of this structure member is constructed by using a bitwise operator with any of the following values: |
| `dwOptions` | `DWORD` | A value which specifies one or options. This member is constructed by using a bitwise operator with any of the following values: |
| `dwReserved` | `DWORD` | This structure member is reserved for future use and should always be initialized to zero. |
| `lpszHostName` | `LPCTSTR` | A pointer to a null terminated string which specifies the hostname that will be used when validating the server certificate. If this member is NULL, then the server certificate will be validated against the hostname used to establish the connection. |
| `lpszUserName` | `LPCTSTR` | A pointer to a null terminated string which identifies the owner of client certificate. Currently this member is not used by the library and should always be initialized as a NULL pointer. |
| `lpszPassword` | `LPCTSTR` | A pointer to a null terminated string which specifies the password needed to access the certificate. Currently this member is only used if the CREDENTIAL_STORE_FILENAME option has been specified. If there is no password associated with the certificate, then this member should be initialized as a NULL pointer. |
| `lpszCertStore` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the certificate store to open. A certificate store is a collection of certificates and their private keys, typically organized by how they are used. If this value is NULL or points to an empty string, the default certificate store "MY" will be used. |
| `lpszCertName` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the certificate to use. The library will first search the certificate store for a certificate with a matching "friendly name"; this is a name for the certificate that is assigned by the user. Note that the name must match completely, but the comparison is not case sensitive. If no matching certificate is found, the library will then attempt to find a certificate that has a matching common name (also called the certificate subject). This comparison is less stringent, and the first partial match will be returned. If this second search fails, the library will return an error indicating that the certificate could not be found. If the SECURITY_PROTOCOL_SSH protocol has been specified, this member should be NULL. |
| `lpszKeyFile` | `LPCTSTR` | This member is not used and should always be NULL. The private key cannot be specified separately and must be associated with the certificate. |

### Remarks

- An application only needs to create this structure if the server requires the client to provide a certificate as part of the process of negotiating the secure session. If a certificate is required, note that it must have a private key associated with it. Attempting to use a certificate that does not have a private key will result in an error during the connection process indicating that the client credentials could not be established.
- If you are using a local certificate store, with the certificate and private key stored in the registry, you can explicitly specify whether the certificate store for the current user or the local machine (all users) should be used. This is done by prefixing the certificate store name with "HKCU:" for the current user, or "HKLM:" for the local machine. For example, a certificate store name of "HKLM:MY" would specify the personal certificate store for the local machine, rather than the current user. If neither prefix is specified, then it will default to the certificate store for the current user. You can manage these certificates using the CertMgr.msc Microsoft Management Console (MMC) snap-in.
- It is possible to load the certificate from a file rather than from current user's certificate store. The dwOptions member should be set to CREDENTIAL_STORE_FILENAME and the lpszCertStore member should specify the name of the file that contains the certificate and its private key. The file must be in Private Information Exchange (PFX) format, also known as PKCS #12. These certificate files typically have an extension of .pfx or .p12. Note that if a password was specified when the certificate file was created, it must be provided in the lpszPassword member or the library will be unable to access the certificate.
- Note that the lpszUserName and lpszPassword members are values which are used to access the certificate store or private key file. They are not the credentials which are used when establishing the connection with the remote host or authenticating the client session.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

---

## SECURITYINFO Structure

The SECURITYINFO structure contains security related information about the connection, including the protocol, cipher suite and certificate.

### Definition

```c
typedef struct _SECURITYINFO
{
    DWORD dwSize;
    DWORD dwProtocol;
    DWORD dwCipher;
    DWORD dwCipherStrength;
    DWORD dwHash;
    DWORD dwHashStrength;
    DWORD dwKeyExchange;
    DWORD dwCertStatus;
    SYSTEMTIME stCertIssued;
    SYSTEMTIME stCertExpires;
    LPCTSTR lpszCertIssuer;
    LPCTSTR lpszCertSubject;
    LPCTSTR lpszFingerprint;
} SECURITYINFO, *LPSECURITYINFO;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | Specifies the size of the data structure. This member must always be initialized to the size of the structure in bytes prior to passing the address of this structure to the function. If this this member is not initialized, an error will be returned indicating that an invalid parameter has been passed to the function. |
| `dwProtocol` | `DWORD` | A numeric value which specifies the security protocol selected when establishing the connection. |
| `dwCipher` | `DWORD` | A numeric value which specifies the cipher that was selected when establishing the secure connection. |
| `dwCipherStrength` | `DWORD` | A numeric value which specifies the strength (the length of the cipher key in bits) of the cipher that was selected. Typically this value will be 128 or 256. 40-bit and 56-bit key lengths are considered weak encryption, and subject to brute force attacks. 128-bit and 256-bit key lengths are considered to be secure, and are the recommended key length for secure communications. |
| `dwHash` | `DWORD` | A numeric value which specifies the hash algorithm which was selected. |
| `dwHashStrength` | `DWORD` | A numeric value which specifies the strength (the length in bits) of the message digest that was selected. |
| `dwKeyExchange` | `DWORD` | A numeric value which specifies the key exchange algorithm which was selected. |
| `dwCertStatus` | `DWORD` | A numeric value which specifies the status of the certificate returned by the secure server. |
| `stCertIssued` | `SYSTEMTIME` | A structure which contains the date and time that the certificate was issued by the certificate authority. If the issue date cannot be determined for the certificate, the SYSTEMTIME structure members will have zero values. |
| `stCertExpires` | `SYSTEMTIME` | A structure which contains the date and time that the certificate expires. If the expiration date cannot be determined for the certificate, the SYSTEMTIME structure members will have zero values. |
| `lpszCertIssuer` | `LPCTSTR` | A pointer to a string which contains information about the organization that issued the certificate. This string consists of one or more comma-separated tokens. Each token consists of an identifier, followed by an equal sign and a value. If the certificate issuer could not be determined, this member may be NULL. |
| `lpszCertSubject` | `LPCTSTR` | A pointer to a string which contains information about the organization that the certificate was issued to. This string consists of one or more comma-separated tokens. Each token consists of an identifier, followed by an equal sign and a value. If the certificate subject could not be determined, this member may be NULL. |
| `lpszFingerprint` | `LPCTSTR` | A pointer to a string which contains a sequence of hexadecimal values that uniquely identify the server. This member may be NULL. |

### Remarks

- The size of this structure is typically determined using the sizeof operator in C/C++ and most other languages have a similar method for obtaining the size of a data structure or user-defined type. It is important to note the size of this structure will be different on 32-bit and 64-bit platforms due to the difference in the length of the structure members which are pointers.
- When evaluating structure members which are string pointers, such as lpszCertIssuer and lpszCertSubject, you should always check to ensure their values are not NULL (zero) before attempting to dereference them. If those values are undefined, it is not guaranteed they will point to zero-length strings.
- There are additional protocols and ciphers defined which are not listed above because they are considered insecure and are no longer supported. It is important to note that most servers will reject attempts to use unsupported protocols such as SSL 3.0 and will either abort the connection or issue an error message and then immediately disconnect.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

