# Hypertext Transfer Protocol Server

## Functions

- [HttpAddVirtualHost](#httpaddvirtualhost-function)
- [HttpAddVirtualHostAlias](#httpaddvirtualhostalias-function)
- [HttpAddVirtualPath](#httpaddvirtualpath-function)
- [HttpAddVirtualUser](#httpaddvirtualuser-function)
- [HttpAuthenticateClient](#httpauthenticateclient-function)
- [HttpCheckVirtualPath](#httpcheckvirtualpath-function)
- [HttpCreateServerCredentials](#httpcreateservercredentials-function)
- [HttpDeleteAllClientHeaders](#httpdeleteallclientheaders-function)
- [HttpDeleteClientHeader](#httpdeleteclientheader-function)
- [HttpDeleteServerCredentials](#httpdeleteservercredentials-function)
- [HttpDeleteVirtualHost](#httpdeletevirtualhost-function)
- [HttpDeleteVirtualPath](#httpdeletevirtualpath-function)
- [HttpDeleteVirtualUser](#httpdeletevirtualuser-function)
- [HttpDisconnectClient](#httpdisconnectclient-function)
- [HttpEnableClientAccess](#httpenableclientaccess-function)
- [HttpEnableCommand](#httpenablecommand-function)
- [HttpEnumServerClients](#httpenumserverclients-function)
- [HttpGetActiveClient](#httpgetactiveclient-function)
- [HttpGetAllClientHeaders](#httpgetallclientheaders-function)
- [HttpGetClientAccess](#httpgetclientaccess-function)
- [HttpGetClientAddress](#httpgetclientaddress-function)
- [HttpGetClientCredentials](#httpgetclientcredentials-function)
- [HttpGetClientDirectory](#httpgetclientdirectory-function)
- [HttpGetClientHeader](#httpgetclientheader-function)
- [HttpGetClientIdleTime](#httpgetclientidletime-function)
- [HttpGetClientLocalPath](#httpgetclientlocalpath-function)
- [HttpGetClientServer](#httpgetclientserver-function)
- [HttpGetClientThreadId](#httpgetclientthreadid-function)
- [HttpGetClientUserName](#httpgetclientusername-function)
- [HttpGetClientVariable](#httpgetclientvariable-function)
- [HttpGetClientVirtualHost](#httpgetclientvirtualhost-function)
- [HttpGetClientVirtualHostId](#httpgetclientvirtualhostid-function)
- [HttpGetClientVirtualPath](#httpgetclientvirtualpath-function)
- [HttpGetCommandFile](#httpgetcommandfile-function)
- [HttpGetCommandLine](#httpgetcommandline-function)
- [HttpGetCommandName](#httpgetcommandname-function)
- [HttpGetCommandQuery](#httpgetcommandquery-function)
- [HttpGetCommandResource](#httpgetcommandresource-function)
- [HttpGetCommandResult](#httpgetcommandresult-function)
- [HttpGetCommandUrl](#httpgetcommandurl-function)
- [HttpGetProgramExitCode](#httpgetprogramexitcode-function)
- [HttpGetProgramName](#httpgetprogramname-function)
- [HttpGetProgramOutput](#httpgetprogramoutput-function)
- [HttpGetProgramText](#httpgetprogramtext-function)
- [HttpGetServerAddress](#httpgetserveraddress-function)
- [HttpGetServerDirectory](#httpgetserverdirectory-function)
- [HttpGetServerError](#httpgetservererror-function)
- [HttpGetServerIdentity](#httpgetserveridentity-function)
- [HttpGetServerLogFile](#httpgetserverlogfile-function)
- [HttpGetServerMemoryUsage](#httpgetservermemoryusage-function)
- [HttpGetServerName](#httpgetservername-function)
- [HttpGetServerOptions](#httpgetserveroptions-function)
- [HttpGetServerPriority](#httpgetserverpriority-function)
- [HttpGetServerStackSize](#httpgetserverstacksize-function)
- [HttpGetServerTransferInfo](#httpgetservertransferinfo-function)
- [HttpGetServerUuid](#httpgetserveruuid-function)
- [HttpGetServerUuidString](#httpgetserveruuidstring-function)
- [HttpGetVirtualHostId](#httpgetvirtualhostid-function)
- [HttpGetVirtualHostName](#httpgetvirtualhostname-function)
- [HttpIsClientAuthenticated](#httpisclientauthenticated-function)
- [HttpIsCommandEnabled](#httpiscommandenabled-function)
- [HttpReceiveRequest](#httpreceiverequest-function)
- [HttpRedirectRequest](#httpredirectrequest-function)
- [HttpRegisterHandler](#httpregisterhandler-function)
- [HttpRegisterProgram](#httpregisterprogram-function)
- [HttpRenameServerLogFile](#httprenameserverlogfile-function)
- [HttpRequireAuthentication](#httprequireauthentication-function)
- [HttpSendErrorResponse](#httpsenderrorresponse-function)
- [HttpSendResponse](#httpsendresponse-function)
- [HttpSendResponseData](#httpsendresponsedata-function)
- [HttpServerAsyncNotify](#httpserverasyncnotify-function)
- [HttpServerDisableTrace](#httpserverdisabletrace-function)
- [HttpServerEnableTrace](#httpserverenabletrace-function)
- [HttpServerInitialize](#httpserverinitialize-function)
- [HttpServerProc](#httpserverproc-function)
- [HttpServerRestart](#httpserverrestart-function)
- [HttpServerResume](#httpserverresume-function)
- [HttpServerStart](#httpserverstart-function)
- [HttpServerStop](#httpserverstop-function)
- [HttpServerSuspend](#httpserversuspend-function)
- [HttpServerThrottle](#httpserverthrottle-function)
- [HttpServerUninitialize](#httpserveruninitialize-function)
- [HttpSetClientAccess](#httpsetclientaccess-function)
- [HttpSetClientHeader](#httpsetclientheader-function)
- [HttpSetClientIdleTime](#httpsetclientidletime-function)
- [HttpSetClientVariable](#httpsetclientvariable-function)
- [HttpSetCommandFile](#httpsetcommandfile-function)
- [HttpSetServerError](#httpsetservererror-function)
- [HttpSetServerIdentity](#httpsetserveridentity-function)
- [HttpSetServerLogFile](#httpsetserverlogfile-function)
- [HttpSetServerName](#httpsetservername-function)
- [HttpSetServerPriority](#httpsetserverpriority-function)
- [HttpSetServerStackSize](#httpsetserverstacksize-function)
## Structures

- [HTTPCLIENTCREDENTIALS](#httpclientcredentials-structure)
- [HTTPREQUEST](#httprequest-structure)
- [HTTPRESPONSE](#httpresponse-structure)
- [HTTPSERVERCONFIG](#httpserverconfig-structure)
- [HTTPSERVERTRANSFER](#httpservertransfer-structure)
- [INITDATA](#initdata-structure)
- [SECURITYCREDENTIALS](#securitycredentials-structure)

---

## HttpAddVirtualHost Function

Add a new virtual host to the server virtual host table

### Prototype

```c
UINT WINAPI HttpAddVirtualHost(
    HSERVER hServer,
    LPCTSTR lpszHostName,
    UINT nHostPort,
    LPCTSTR lpszDirectory
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszHostName` | `LPCTSTR` | A pointer to a string which specifies the hostname that will be added to the virtual host table. This parameter must specify a valid hostname and cannot be a NULL pointer or a zero-length string. |
| `nHostPort` | `UINT` | An integer value which specifies the port number for the virtual host. This value must be zero or the same value as the original port number that the server was configured to use. |
| `lpszDirectory` | `LPCTSTR` | A pointer to a NULL terminated string which specifies the root document directory for the virtual host. If this parameter is NULL or a zero-length string, the virtual host will use the same root directory that was specified when the server was started. This parameter may contain environment variables enclosed in % symbols. |

### Return Value

- **Type**: `UINT`
- If the function is successful, it will return a non-zero integer value that identifies the virtual host. If the function fails, it will return INVALID_VIRTUAL_HOST and the last error code will be updated to indicate the cause of the failure.

### Remarks

- Virtual hosting is a method for sharing multiple domain names on a single instance of a server. The client provides the server with the hostname that it has used to establish the connection, and that name is compared against a table of virtual hosts configured for the server. If the hostname matches a virtual host, the client will use the root directory and any virtual paths that have been assigned to that host.
- When the server is first started, a default virtual host with an ID of zero is automatically created and is identified as VIRTUAL_HOST_DEFAULT. This virtual host uses the same hostname, port number and root directory that the server instance was created with. The application should treat all other host IDs as opaque values and never make assumptions about how they are allocated.
- The nHostPort parameter should always be specified with a value of zero, or the same port number that the server was configured to use. Port-based virtual hosting is currently not supported and this parameter is included for future use.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddVirtualHostAlias](#httpaddvirtualhostalias-function)
- [HttpAddVirtualPath](#httpaddvirtualpath-function)
- [HttpAddVirtualUser](#httpaddvirtualuser-function)
- [HttpDeleteVirtualHost](#httpdeletevirtualhost-function)

---

## HttpAddVirtualHostAlias Function

Add an alternate host name for an existing virtual host

### Prototype

```c
BOOL WINAPI HttpAddVirtualHostAlias(
    HSERVER hServer,
    UINT nHostId,
    LPCTSTR lpszHostAlias
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nHostId` | `UINT` | An integer value which identifies the virtual host. |
| `lpszHostAlias` | `LPCTSTR` | A pointer to a string which specifies the alias for the virtual host. The alias must be a valid domain name that uniquely identifies the host. This parameter cannot be a NULL pointer or specify an empty string. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle is invalid or the virtual host ID does not specify a valid host, the function will return zero. If the function fails, the last error code will be updated to indicate the cause of the failure.

### Remarks

- The HttpAddVirtualHostAlias function adds an alias for an existing virtual host. This enables a client to establish a connection using a number of different domain names which all reference the same virtual host. When the server responds to the client, it will identify itself with the primary domain name assigned to the virtual host rather than the alias provided by the client.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddVirtualHost](#httpaddvirtualhost-function)
- [HttpAddVirtualPath](#httpaddvirtualpath-function)

---

## HttpAddVirtualPath Function

Add a new virtual path for the specified host

### Prototype

```c
BOOL WINAPI HttpAddVirtualPath(
    HSERVER hServer,
    UINT nHostId,
    DWORD dwFileAccess,
    LPCTSTR lpszVirtualPath,
    LPCTSTR lpszLocalPath
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nHostId` | `UINT` | An integer value which identifies the virtual host. |
| `dwFileAccess` | `DWORD` | An integer value which specifies the access clients will be given to the virtual path. For a list of file access permissions, see User and File Access Constants. |
| `lpszVirtualPath` | `LPCTSTR` | A pointer to a string which specifies the virtual path that will be created. This parameter cannot be a NULL pointer or an empty string. The maximum length of the virtual path is 1024 characters. |
| `lpszLocalPath` | `LPCTSTR` | A pointer to a string which specifies the local directory or file name that the virtual path will be mapped to. This path must exist and can be no longer than MAX_PATH characters. This parameter cannot be a NULL pointer or an empty string. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle is invalid or the virtual host ID does not specify a valid host, the function will return zero. If the function fails, the last error code will be updated to indicate the cause of the failure.

### Remarks

- The HttpAddVirtualPath function maps a virtual path name to a directory or file name on the local system. Virtual paths are assigned to specific hosts and if multiple virtual hosts are created for the server, each can have its own virtual paths which map to different files. To create a virtual path for the default server, the nHostId parameter should be specified as VIRTUAL_HOST_DEFAULT.
- It is recommended that the lpszLocalPath parameter always specify the full path to the local file or directory. If the path is relative, it will be considered relative to the current working directory for the process and expanded to its full path name. The local path can include environment variables surrounded by % symbols. For example, if the value %ProgramData% is included in the path, it will be expanded to the full path for the common application data folder. The local path cannot specify a Windows system folder or the root directory of a mounted drive volume.
- The local file or directory does not need to located in the document root directory for the server or virtual host. It can specify any valid local path that the server process has the appropriate permissions to access. You should exercise caution when creating virtual paths to files or directories outside of the server root directory. If the lpszLocalPath parameter specifies a directory, clients will have access to that directory and all subdirectories using its virtual path.
- If you wish to password protect the virtual file or directory, include the HTTP_ACCESS_PROTECTED flag in the file permissions. The default command handlers will recognize this flag and require that the client authenticate itself to grant access to the resource. If the server application implements a custom command handler, it is responsible for checking for the presence of this flag and perform the appropriate checks to ensure that the client session has been authenticated.
- If the server was started in restricted mode, the client will be unable to access documents outside of the server root directory and its subdirectories. This restriction also applies to virtual paths that reference documents or other resources outside of the root directory. To allow a client to access a document outside of the server root directory, the HttpSetClientAccess function should be used to grant the client HTTP_ACCESS_READ permission.
- The HttpGetClientVirtualPath function will return the virtual path that is associated with a local file or directory. The HttpGetClientLocalPath function will return the full path to a local file or directory that is mapped to a virtual path.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddVirtualHost](#httpaddvirtualhost-function)
- [HttpCheckVirtualPath](#httpcheckvirtualpath-function)
- [HttpGetClientLocalPath](#httpgetclientlocalpath-function)
- [HttpGetClientVirtualPath](#httpgetclientvirtualpath-function)
- [HttpDeleteVirtualPath](#httpdeletevirtualpath-function)

---

## HttpAddVirtualUser Function

Add a new virtual user for the specified host

### Prototype

```c
BOOL WINAPI HttpAddVirtualUser(
    HSERVER hServer,
    UINT nHostId,
    DWORD dwUserAccess,
    LPCTSTR lpszUserName,
    LPCTSTR lpszPassword,
    LPCTSTR lpszDirectory
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nHostId` | `UINT` | An integer value which identifies the virtual host. |
| `dwUserAccess` | `DWORD` | An integer value which specifies the access clients will be given when authenticated as this user. For a list of user access permissions, see User and File Access Constants. |
| `lpszUserName` | `LPCTSTR` | A pointer to a string which specifies the user name. The maximum length of a username is 63 characters and it is recommended that names be limited to alphanumeric characters. Whitespace, control characters and certain symbols such as path delimiters and wildcard characters are not permitted. If an invalid character is included in the name, the function will fail with an error indicating the username is invalid. This parameter cannot be NULL and the name must be at least three characters in length. Usernames are not case sensitive. |
| `lpszPassword` | `LPCTSTR` | A pointer to a string which specifies the user password. The maximum length of a password is 63 characters and is limited to printable characters. Whitespace and control characters are not permitted. If an invalid character is included in the password, the function will fail with an error indicating the password is invalid. This parameter cannot be NULL and must be at least one character in length. Passwords are case sensitive. |
| `lpszDirectory` | `LPCTSTR` | A pointer to a string which specifies the local directory that is considered to be the virtual user's home directory. This path must exist and can be no longer than MAX_PATH characters. The maximum length of the local path is 260 characters. The directory cannot be located in a Windows system folder or the root directory of a mounted disk volume. If this parameter is NULL or an empty string, the server root directory will be assigned as the user home directory. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle is invalid or the virtual host ID does not specify a valid host, the function will return zero. If the function fails, the last error code will be updated to indicate the cause of the failure.

### Remarks

- The HttpAddVirtualUser function adds a virtual user that is associated with the specified virtual host. If a client attempts to access a protected document and provides credentials, the server will attempt to automatically authenticate the session by searching for virtual user with the same username and password. If a match is found, then the client session is assigned the same access permissions as the virtual user.
- If the server is started with the HTTP_SERVER_MULTIUSER option, then documents in the virtual user's home directory can be accessed by specifying their username using a specially formatted request URL. For example, if a virtual user named "Thomas" is created, the documents in that user's home directory could be accessed as http://servername/~thomas/document.html
- All files and subdirectories in the user's home directory are considered to be read-only. A client cannot create files in a user's home directory, even if they are authenticated as that user. In addition, CGI programs and scripts cannot be executed from a user's home directory.
- If you wish to modify the information for a user, it is not necessary to delete the username first. If this function is called with a username that already exists, that record is replaced with the values passed to this function.
- The virtual users created by this function exist only as long as the server is active. If you wish to maintain a persistent database of users and passwords, you are responsible for its implementation based on the requirements of your specific application. For example, a simple implementation would be to store the user information in a local XML or INI file and then read that configuration file after the server has started, calling this function for each user that is listed.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddVirtualHost](#httpaddvirtualhost-function)
- [HttpDeleteVirtualUser](#httpdeletevirtualuser-function)

---

## HttpAuthenticateClient Function

Authenticate the client and assign access rights for the session

### Prototype

```c
BOOL WINAPI HttpAuthenticateClient(
    HSERVER hServer,
    UINT nClientId,
    DWORD dwUserAccess
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `dwUserAccess` | `DWORD` | An unsigned integer which specifies one or more user access rights. For a list of user access rights that can be granted to the client, see User and File Access Constants. |

### Return Value

- **Type**: `BOOL`
- If the the client session could be authenticated, the return value is non-zero. If the server handle and client ID do not specify a valid client session, or the client has already been authenticated, this function will return zero.

### Remarks

- The HttpAuthenticateClient function is used to authenticate a specific client session, typically in response to an HTTP_CLIENT_USERAUTH event that indicates a client has provided authentication credentials as part of the request for a document or other resource.
- To enable the server to automatically authenticate a client session, use the HttpAddVirtualUser function to add one or more virtual users. The server will search the list of virtual users for a match to the credentials provided by the client and will set the appropriate permissions for the session without requiring a event handler to manually authenticate the session using this function.
- If the server was started with the HTTP_SERVER_LOCALUSER option and the client session is not authenticated using this function, the server will attempt to authenticate the client session using the local Windows user database. Although this option can be convenient because it does not require the implementation of an event handler for the HTTP_CLIENT_USERAUTH event, it can be used by clients to attempt to discover valid usernames and passwords for the local system. It is recommended that you use the HttpAddVirtualUser function to create virtual users rather than using the local user database.
- It is recommended that most applications specify HTTP_ACCESS_DEFAULT as the dwUserAccess value for a client session, since this allows the server automatically grant the appropriate access based on the server configuration options.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpAddVirtualUser](#httpaddvirtualuser-function)
- [HttpGetClientCredentials](#httpgetclientcredentials-function)
- [HttpGetClientDirectory](#httpgetclientdirectory-function)

---

## HttpCheckVirtualPath Function

Determine if the client has permission to access the specified virtual path

### Prototype

```c
BOOL WINAPI HttpCheckVirtualPath(
    HSERVER hServer,
    UINT nClientId,
    LPCTSTR lpszVirtualPath,
    DWORD dwFileAccess
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszVirtualPath` | `LPCTSTR` | A pointer to a string which specifies the virtual path that should be checked. This path must be absolute and cannot be a NULL pointer or an empty string. The maximum length of the virtual path is 1024 characters. |
| `dwFileAccess` | `DWORD` | An unsigned integer value which specifies the access permissions that should be checked. For a list of file access permissions, see User and File Access Constants. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle is invalid or the client ID does not specify a valid client, the function will return zero. If the function fails, the last error code will be updated to indicate the cause of the failure.

### Remarks

- The HttpCheckVirtualPath function is used to determine if the client has permission to access the virtual file or directory, based on the value of the dwFileAccess parameter. For example, if the dwFileAccess parameter has the value HTTP_ACCESS_WRITE, this function will check if the client has write permission for the file or directory. The function will return a non-zero value if the client does have the requested permission, or zero if it does not.
- Applications that implement their own custom handlers for standard HTTP commands should use this function to ensure that the client has the appropriate permissions to access the requested resource. Failure to check the access permissions for the client can result in the client being able to access restricted documents and other resources. It is recommended that most applications use the default command handlers.
- To obtain the path to the local file or directory that the virtual path is mapped to, use the HttpGetClientLocalPath function.

### Example

```cpp
TCHAR szPathName[1024];

// Get the current request URL path
INT cchPathName = HttpGetCommandResource(
					hServer,
					nClientId,
					szPathName,
					1024);

if (cchPathName == 0)
{
	HttpSendErrorResponse(hServer, nClientId, 500, NULL);
	return;
}

// Check if the client has write access to that resource
BOOL bAllowed = HttpCheckVirtualPath(
					hServer,
					nClientId,
					szPathName,
					HTTP_ACCESS_WRITE);
				
if (!bAllowed)
{
	HttpSendErrorResponse(hServer, nClientId, 403, NULL);
	return;
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddVirtualPath](#httpaddvirtualpath-function)
- [HttpDeleteVirtualPath](#httpdeletevirtualpath-function)
- [HttpGetClientLocalPath](#httpgetclientlocalpath-function)
- [HttpGetClientVirtualPath](#httpgetclientvirtualpath-function)

---

## HttpCreateServerCredentials Function

Create a new server security credentials structure

### Prototype

```c
BOOL WINAPI HttpCreateServerCredentials(
    DWORD dwProtocol,
    DWORD dwOptions,
    LPCTSTR lpszUserName,
    LPCTSTR lpszPassword,
    LPCTSTR lpszCertStore,
    LPCTSTR lpszCertName,
    LPVOID lpvReserved,
    LPSECURITYCREDENTIALS lppCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `dwProtocol` | `DWORD` | A bitmask of supported security protocols. This parameter is constructed by using a bitwise operator with any of the following values: |
| `dwOptions` | `DWORD` | A value which specifies one or options. This value should always be zero for connections using SSH. This member is constructed by using a bitwise operator with any of the following values: |
| `lpszUserName` | `LPCTSTR` | A pointer to a string which specifies the certificate owner's username. A value of NULL specifies that no username is required. Currently this parameter is not used and any value specified will be ignored. |
| `lpszPassword` | `LPCTSTR` | A pointer to a string which specifies the certificate owner's password. A value of NULL specifies that no password is required. This parameter is only used if a PKCS #12 (PFX) certificate file is specified and that certificate has been secured with a password. This value will be ignored the current user or local machine certificate store is specified. |
| `lpszCertStore` | `LPCTSTR` | A pointer to a string which specifies the name of the certificate store to open. A certificate store is a collection of certificates and their private keys, typically organized by how they are used. If this value is NULL or points to an empty string, the default certificate store "MY" will be used. |
| `lpszCertName` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the certificate to use. The function will first search the certificate store for a certificate with a matching "friendly name"; this is a name for the certificate that is assigned by the user. Note that the name must match completely, but the comparison is not case sensitive. If no matching certificate is found, the function will then attempt to find a certificate that has a matching common name (also called the certificate subject). This comparison is less stringent, and the first partial match will be returned. If this second search fails, the function will return an error indicating that the certificate could not be found. |
| `lpvReserved` | `LPVOID` | Pointer reserved for future use. Set it to NULL when using this function. |
| `lppCredentials` | `LPSECURITYCREDENTIALS` | Pointer to an LPSECURITYCREDENTIALS pointer. The memory for the credentials structure will be allocated by this function and must be released by calling the HttpDeleteSecurityCredentials function when it is no longer needed. The pointer value must be set to NULL before the function is called. It is important to note that this is a pointer to a pointer variable, not a pointer to the SECURITYCREDENTIALS structure itself. |

### Options

- **dwProtocol** Parameter

    - `SECURITY_PROTOCOL_DEFAULT`: The default security protocol will be used when establishing a connection. This option will always request the latest version of the preferred security protocol and is the recommended value. Currently the default security protocol is TLS 1.2.
    - `SECURITY_PROTOCOL_TLS`: Either the TLS 1.2 or 1.3 protocol should be used when establishing a secure connection. The correct protocol is automatically selected, based on what version of the protocol is supported by the server. If this is the only protocol specified, SSL will be excluded from the list of supported protocols. This may be necessary for some servers which reject any attempt to use the older SSL protocol and require that only TLS be used.
    - `SECURITY_PROTOCOL_TLS10`: The TLS 1.0 protocol should be used when establishing a secure connection. This version is supported on all Windows platforms, however some servers may reject connections using version 1.0 in favor of using version 1.2. This version should only be used for backwards compatibility with older servers that have not been updated to use the current version of TLS.
    - `SECURITY_PROTOCOL_TLS11`: The TLS 1.1 protocol should be used when establishing a secure connection. This version is supported on Windows 7 and later desktop platforms, and Windows Server 2008 R2 and later server platforms. Some servers may reject connections using version 1.1 in favor of using version 1.2. This version should only be used for backwards compatibility with older servers that have not been updated to use the current version of TLS.
    - `SECURITY_PROTOCOL_TLS12`: The TLS 1.2 protocol should be used when establishing a secure connection. This version is supported on Windows 7 and later desktop platforms, and Windows Server 2008 R2 and later server platforms. This version of TLS offers the broadest compatibility with most servers.
    - `SECURITY_PROTOCOL_TLS13`: The TLS 1.3 protocol should be used when establishing a secure connection. This is the newest version of the protocol and is only supported on Windows 11, Windows Server 2022 and later versions of Windows. If this version is not supported by the operating system, TLS 1.2 will be used instead.
- **dwOptions** Parameter

    - `CREDENTIAL_STORE_CURRENT_USER`: The library will attempt to open a store for the current user using the certificate store name provided in this structure. If no options are specified, then this is the default behavior.
    - `CREDENTIAL_STORE_LOCAL_MACHINE`: The library will attempt to open a local machine store using the certificate store name provided in this structure. If this option is specified, the library will always search for a local machine store before searching for the store by that name for the current user.
    - `CREDENTIAL_STORE_FILENAME`: The certificate store name is a file that contains the certificate and private key that will be used.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetServerError.

### Remarks

- The structure that is created by this function may be used as server credentials when accepting a secure connection. This is particularly useful for programming languages other than C/C++ which may not support C structures or pointers. The pointer to the SECURITYCREDENTIALS structure can be declared as an unsigned integer variable which is passed by reference to this function, and then passed by value to the HttpServerStart function.
- An application only needs to call this function to support secure connections using TLS. When a certificate is specified, it must have a private key associated with it. Attempting to use a certificate which does not have a private key will result in an error during the startup process indicating that the server credentials are invalid.
- If you are using a local certificate store, with the certificate and private key stored in the registry, you can explicitly specify whether the certificate store for the current user or the local machine (all users) should be used. This is done by prefixing the certificate store name with "HKCU:" for the current user, or "HKLM:" for the local machine. For example, a certificate store name of "HKLM:MY" would specify the personal certificate store for the local machine, rather than the current user. If neither prefix is specified, then it will default to the certificate store for the current user. You can manage these certificates using the CertMgr.msc Microsoft Management Console (MMC) snap-in.
- It is possible to load the certificate from a file rather than from current user's certificate store. The dwOptions parameter should be set to CREDENTIAL_STORE_FILENAME and the lpszCertStore parameter should specify the name of the file that contains the certificate and its private key. The file must be in Private Information Exchange (PFX) format, also known as PKCS #12.These certificate files typically have an extension of .pfx or .p12. If a password was specified when the certificate was created, it must be provided in the lpszPassword parameter or the library will be unable to access the certificate.

### Example

```cpp
// Create the server credentials that identifies the certificate
// that will be used for secure connections
LPSECURITYCREDENTIALS lpSecCred = NULL;

HttpCreateServerCredentials(SECURITY_PROTOCOL_DEFAULT,
							0,
							NULL,
							NULL,
							lpszCertStore,
							lpszCertName,
							NULL,
							&lpSecCred);

// Start the server
hServer = HttpServerStart(lpszLocalHost,
						HTTP_PORT_SECURE,
						HTTP_SERVER_SECURE,
						&httpConfig,
						lpEventHandler,
						0,
						lpSecCred);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpDeleteServerCredentials](#httpdeleteservercredentials-function)
- [HttpServerStart](#httpserverstart-function)
- [SECURITYCREDENTIALS](#securitycredentials-function)

---

## HttpDeleteAllClientHeaders Function

Delete all of the request or response headers for the specified client session

### Prototype

```c
BOOL WINAPI HttpDeleteAllClientHeaders(
    HSERVER hServer,
    UINT nClientId,
    UINT nHeaderType
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | Delete all of the request or response headers for the specified client session. |
| `nHeaderType` | `UINT` | Specifies the type of headers to delete. It may be one of the following values: |

### Options

- **nHeaderType** Parameter

    - `HTTP_HEADERS_REQUEST`: Delete all of the request headers that were provided by the client. Request header values provide additional information to the server about the type of request being made.
    - `HTTP_HEADERS_RESPONSE`: Delete all of the response headers that were created by the server in response to a request made by the client. Response header values provide additional information to the client about the type of information that is being returned by the server.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- The HttpDeleteAllClientHeaders function is used to delete all of the request or response headers that were set as the result of the client issuing a request for a document or other resource. If this function is used to delete all of the response headers, the server will automatically generate a standard set of response headers when it returns the requested information to the client.
- It is not necessary to call this function inside an HTTP_CLIENT_DISCONNECT event handler to delete the header values that were set during the client session. This is done automatically when the client disconnects from the server.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpDeleteClientHeader](#httpdeleteclientheader-function)
- [HttpSetClientHeader](#httpsetclientheader-function)

---

## HttpDeleteClientHeader Function

Delete a request or response header for the specified client session

### Prototype

```c
BOOL WINAPI HttpDeleteClientHeader(
    HSERVER hServer,
    UINT nClientId,
    UINT nHeaderType,
    LPCTSTR lpszHeaderName
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `nHeaderType` | `UINT` | Specifies the type of header to delete. It may be one of the following values: |
| `lpszHeaderName` | `LPCTSTR` | A pointer to a string that specifies the name of the header that should be deleted. Header names are not case-sensitive and should not include the colon which acts as a delimiter that separates the header name from its value. This parameter cannot be a NULL pointer or an empty string. |

### Options

- **nHeaderType** Parameter

    - `HTTP_HEADERS_REQUEST`: Delete a request header that was provided by the client. Request header values provide additional information to the server about the type of request being made.
    - `HTTP_HEADERS_RESPONSE`: Delete a response header that was created by the server. Response header values provide additional information to the client about the type of information that is being returned by the server.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero. If the function fails, the HttpGetServerError function will return more information about the last error that has occurred.

### Remarks

- The HttpDeleteClientHeader function will delete a request or response header for the specified client session. There are a number of required response headers that are always sent to a client and deleting the header using this function will cause the server to automatically generate a new default header value. You should not delete response header values unless you are certain of the impact that it would have on the normal operation of the client.
- It is not necessary for you to delete a header value to change the value of an existing header. The HttpSetClientHeader function will replace an existing header value with a new value, or create a new header if the header name does not already exist.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpDeleteAllClientHeaders](#httpdeleteallclientheaders-function)
- [HttpGetClientHeader](#httpgetclientheader-function)
- [HttpSetClientHeader](#httpsetclientheader-function)

---

## HttpDeleteServerCredentials Function

Delete a previously created security credentials structure

### Prototype

```c
VOID WINAPI HttpDeleteServerCredentials(
    LPSECURITYCREDENTIALS lppCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lppCredentials` | `LPSECURITYCREDENTIALS` | Pointer to an LPSECURITYCREDENTIALS pointer. On exit from the function, the pointer value will be NULL. |

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- This function can be used to release the memory allocated for the credentials after the server has been started.

### Example

```cpp
if (lpSecCred != NULL)
	HttpDeleteServerCredentials(&lpSecCred);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpCreateServerCredentials](#httpcreateservercredentials-function)
- [HttpServerStop](#httpserverstop-function)

---

## HttpDeleteVirtualHost Function

Delete a virtual host associated with the specified server

### Prototype

```c
BOOL WINAPI HttpDeleteVirtualHost(
    HSERVER hServer,
    UINT nHostId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nHostId` | `UINT` | An integer value which identifies the virtual host. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle is invalid or the virtual host ID does not specify a valid host, the function will return zero. If the function fails, the last error code will be updated to indicate the cause of the failure.

### Remarks

- The HttpDeleteVirtualHost function removes a virtual host that was created by a previous call to the HttpAddVirtualHost function. All virtual paths and users associated with the specified host are no longer valid. It is not necessary to call this function to delete any of the virtual hosts prior to stopping the server. Part of the normal shutdown process is releasing the resources allocated for each virtual host that was added to the server.
- This function cannot be used to delete the virtual host with an ID of zero, which is the default virtual host that is allocated when the server is started.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpAddVirtualHost](#httpaddvirtualhost-function)
- [HttpAddVirtualPath](#httpaddvirtualpath-function)
- [HttpAddVirtualUser](#httpaddvirtualuser-function)
- [HttpDeleteVirtualPath](#httpdeletevirtualpath-function)
- [HttpDeleteVirtualUser](#httpdeletevirtualuser-function)

---

## HttpDeleteVirtualPath Function

Delete a virtual path from the specified virtual host

### Prototype

```c
BOOL WINAPI HttpDeleteVirtualPath(
    HSERVER hServer,
    UINT nHostId,
    LPCTSTR lpszVirtualPath
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nHostId` | `UINT` | An integer value which identifies the virtual host. |
| `lpszVirtualPath` | `LPCTSTR` | A pointer to a string which specifies the virtual path that will be removed. This path must be absolute and cannot be a NULL pointer or an empty string. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle is invalid or the virtual host ID does not specify a valid host, the function will return zero. If the function fails, the last error code will be updated to indicate the cause of the failure.

### Remarks

- This function removes a virtual path that was created by a previous call to the HttpAddVirtualPath function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddVirtualHost](#httpaddvirtualhost-function)
- [HttpAddVirtualPath](#httpaddvirtualpath-function)
- [HttpGetClientLocalPath](#httpgetclientlocalpath-function)
- [HttpGetClientVirtualPath](#httpgetclientvirtualpath-function)

---

## HttpDeleteVirtualUser Function

Delete a virtual user from the specified virtual host

### Prototype

```c
BOOL WINAPI HttpDeleteVirtualUser(
    HSERVER hServer,
    UINT nHostId,
    LPCTSTR lpszUserName
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nHostId` | `UINT` | An integer value which identifies the virtual host. |
| `lpszUserName` | `LPCTSTR` | A pointer to a string which specifies the user that will be removed. This parameter cannot be a NULL pointer or an empty string. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle is invalid or the virtual host ID does not specify a valid host, the function will return zero. If the function fails, the last error code will be updated to indicate the cause of the failure.

### Remarks

- This function removes a virtual user that was created by a previous call to the HttpAddVirtualUser function. This function will not match partial usernames and wildcard characters cannot be used to delete multiple users. Usernames are not case sensitive.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddVirtualHost](#httpaddvirtualhost-function)
- [HttpAddVirtualUser](#httpaddvirtualuser-function)

---

## HttpDisconnectClient Function

Disconnect the specific client session, closing the control channel and aborting any file transfer

### Prototype

```c
BOOL WINAPI HttpDisconnectClient(
    HSERVER hServer,
    UINT nClientId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- The HttpDisconnectClient function will close the control channel, disconnecting the client from the server and terminating the client session thread. Resources that we allocated for the client, such as memory and open handles, will be released back to the operating system. If the client was in the process of transferring a file, the transfer will be aborted.
- This function sends an internal control message that notifies the server that this session should be terminated. When the session thread is signaled that it should terminate, it will abort any active data transfers and begin to release the resources allocated for that session. To ensure that the client session terminates gracefully, there may be a brief period of time where the session thread is still active after this function has returned.
- After this function returns, the application should never use the same client ID with another function. Client IDs are unique to the session over the lifetime of the server, and are not reused.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpServerRestart](#httpserverrestart-function)
- [HttpServerStop](#httpserverstop-function)

---

## HttpEnableClientAccess Function

Enable or disable access rights for the specified client session

### Prototype

```c
BOOL WINAPI HttpEnableClientAccess(
    HSERVER hServer,
    UINT nClientId,
    DWORD dwUserAccess,
    BOOL bEnable
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `dwUserAccess` | `DWORD` | An unsigned integer which specifies an access right to enable or disable. For a list of user access rights that can be granted to the client, see User and File Access Constants. |
| `bEnable` | `BOOL` | An integer value which specifies if permission should be granted or revoked for the specified access right. If this value is non-zero, permission is granted to the client to perform the action specified by the dwUserAccess parameter. If this value is zero, that permission is revoked. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- The HttpEnableClientAccess function is used to enable or disable access to specific functionality by the client. The function can only change a single access right and cannot be used to enable or disable multiple access rights in a single function call. To change multiple user access rights for the client, use the HttpSetClientAccess function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpAuthenticateClient](#httpauthenticateclient-function)
- [HttpGetClientAccess](#httpgetclientaccess-function)
- [HttpSetClientAccess](#httpsetclientaccess-function)

---

## HttpEnableCommand Function

Enable or disable a specific server command

### Prototype

```c
BOOL WINAPI HttpEnableCommand(
    HSERVER hServer,
    LPCTSTR lpszCommand,
    BOOL bEnable
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszCommand` | `LPCTSTR` | A pointer to a NULL terminated string that specifies the name of the command to be enabled or disabled. The command name is not case-sensitive, but the value must otherwise match the exact name. Partial matches are not recognized by this function. This parameter cannot be NULL. |
| `bEnable` | `BOOL` | An integer value which specifies if the command should be enabled or disabled. If the value is non-zero, the command is enabled. If the value is zero, the command will be disabled. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle is invalid or the command is not recognized, the function will return zero. If the function fails, the HttpGetServerError function will return more information about the last error that has occurred.

### Remarks

- The HttpEnableCommand function is used to enable or disable access to a specific command on the server. This function is typically used to enable or disable certain commands for security purposes. For example, the PUT command can be disabled, preventing any client from attempting to upload files directly to the server. The HttpIsCommandEnabled function can be used to determine if a command is enabled or not.
- The command name provided to this function must match the commands defined in RFC 2616 or related protocol standards. Refer to Hypertext Transfer Protocol Commands for a complete list of server commands.
- Some commands cannot be disabled because they are required to perform essential server functions. For example, the GET and HEAD commands cannot be disabled. If you attempt to disable a required command, this function will return zero and the last error code will be set to ST_ERROR_COMMAND_REQUIRED. Because this function affects all clients connected to the server, it should not be used to limit access to certain commands for specific clients. Instead, use an event handler to filter the commands.
- The OPTIONS and TRACE commands are disabled by default for all server instances and must be explicitly enabled using the EnableCommand method if you wish permit clients to use them. It is not recommended that you enable these commands if your server is going to be publicly accessible over the Internet. If the server started with the option HTTP_SERVER_READONLY, commands that can be used to create or modify files on the server will be disabled by default.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAuthenticateClient](#httpauthenticateclient-function)
- [HttpIsCommandEnabled](#httpiscommandenabled-function)

---

## HttpEnumServerClients Function

Returns a list of active client sessions established with the specified server

### Prototype

```c
INT WINAPI HttpEnumServerClients(
    HSERVER hServer,
    DWORD dwReserved,
    UINT lpClients,
    INT nMaxClients
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | Handle to the server socket. |
| `dwReserved` | `DWORD` | An unsigned integer value that is reserved for future use. This parameter should always be zero. |
| `lpClients` | `UINT` | Pointer to an array of unsigned integers which will contain client IDs that uniquely identifies each client when the function returns. If this parameter is NULL, then the function will return the number of active client connections established with the server. |
| `nMaxClients` | `INT` | Maximum number of client IDs to be returned in the lpClients array. If the lpClients parameter is NULL, this parameter should have a value of zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of active client connections to the server. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetServerError.

### Remarks

- If the nMaxClients parameter is less than the number of active client connections, the function will fail and the last error code will be set to the error ST_ERROR_BUFFER_TOO_SMALL. To dynamically determine the number of active connections, call the function with the lpClients parameter with a value of NULL, and the nMaxClients parameter with a value of zero.

### Example

```cpp
INT nClients = HttpEnumServerClients(hServer, 0, NULL, 0);

if (nClients > 0)
{
	UINT *lpClients = NULL;

	// Allocate memory for an array of client IDs
	lpClients = (UINT *)LocalAlloc(LPTR, nClients * sizeof(UINT));

	if (lpClients == NULL)
	{
		// Virtual memory has been exhausted
		return;
	}

	nClients = HttpEnumServerClients(hServer, 0, lpClients, nClients);

	if (nClients == HTTP_ERROR)
	{
		// Unable to obtain list of connected clients
		return;
	}

	for (INT nIndex = 0; nIndex < nClients; nIndex++)
	{
		TCHAR szUserName[HTTP_MAXUSERNAME];

		if (HttpGetClientUserName(hServer, lpClients[nIndex], szUserName, HTTP_MAXUSERNAME))
		{
			// Perform some action with the client user name
		}
	}

	// Free the memory allocated for the client IDs
	LocalFree((HLOCAL)lpClients);    
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpServerStart](#httpserverstart-function)

---

## HttpGetActiveClient Function

Return the client ID for the active client session associated with the current thread

### Prototype

```c
UINT WINAPI HttpGetActiveClient(
    HSERVER hServer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is the unique ID associated with the client session for the current thread. If the server handle is invalid or there is no client session active on the current thread, the return value is zero.

### Remarks

- The HttpGetActiveClient function is used to obtain the client ID associated with the current thread. This means this function will only return a client ID if it is called within an event handler or a function called by an event handler. If this function is called by a function that is not executing within the context of an event handler it will return a value of zero.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpEnumServerClients](#httpenumserverclients-function)

---

## HttpGetAllClientHeaders Function

Return all client request or response headers in a string buffer

### Prototype

```c
INT WINAPI HttpGetAllClientHeaders(
    HSERVER hServer,
    UINT nClientId,
    UINT nHeaderType,
    LPTSTR lpszHeaders,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `nHeaderType` | `UINT` | Specifies the type of header. It may be one of the following values: |
| `lpszHeaders` | `LPTSTR` | A pointer to a string buffer that will contain all of the client request or response headers when the function returns. Each header name is separated from its value by the colon (:) and each header is terminated with a carriage return and linefeed (CRLF) sequence. The end of the header block is terminated with a null character. |
| `nMaxLength` | `INT` | An integer that specifies the maximum number of characters that can be copied into the header value buffer, including the terminating null character. If the lpszHeaders parameter is NULL, this value must be zero. |

### Options

- **nHeaderType** Parameter

    - `HTTP_HEADERS_REQUEST`: Return the value of a request header that was provided by the client. Request header values provide additional information to the server about the type of request being made.
    - `HTTP_HEADERS_RESPONSE`: Return the value of a response header that was created by the server. Response header values provide additional information to the client about the type of information that is being returned by the server.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the complete header block, not including the terminating null character. If the server handle and client ID do not specify a valid client session, the function will return zero. If the lpszHeaders parameter is not NULL and the buffer is not large enough to store the complete header value, the function will return zero and the last error code will be set to ST_ERROR_BUFFER_TOO_SMALL. If the function fails, the HttpGetServerError function will return more information about the last error that has occurred.

### Remarks

- Refer to Hypertext Transfer Protocol Headers for a list of common request and response headers that are used.

### Example

```cpp
LPTSTR lpszHeaders = NULL;

// Get the size of the complete header block
INT nLength = HttpGetAllClientHeaders(hServer, nClientId, HTTP_HEADERS_REQUEST, NULL, 0);

if (nLength > 0)
{
	// Allocate memory for the header block
	lpszHeaders = LocalAlloc(LPTR, nLength + 1);

	// Return a copy of all of the request headers
	HttpGetAllClientHeaders(
		hServer,
		nClientId,
		HTTP_HEADERS_REQUEST,
		lpszHeaders,
		nLength + 1);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpDeleteClientHeader](#httpdeleteclientheader-function)
- [HttpGetClientHeader](#httpgetclientheader-function)
- [HttpSetClientHeader](#httpsetclientheader-function)

---

## HttpGetClientAccess Function

Return the access rights that have been granted to the client session

### Prototype

```c
BOOL WINAPI HttpGetClientAccess(
    HSERVER hServer,
    UINT nClientId,
    LPDWORD lpdwUserAccess
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpdwUserAccess` | `LPDWORD` | A pointer to an unsigned integer which specifies one or more access rights for the client session. For a list of user access permissions that can be granted to the client, see User and File Access Constants. This parameter cannot be NULL. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero. This function can only be used with authenticated clients. If the client session has not been authenticated, the return value will be zero.

### Remarks

- The HttpGetClientAccess function is used to obtain all of the access rights that are currently granted to the client session. The HttpEnableClientAccess function can be used to enable or disable specific permissions, and the HttpSetClientAccess function can change multiple access rights at once.

### Example

```cpp
DWORD dwUserAccess = 0;

// Check if the client has execute permission
if (HttpGetClientAccess(hServer, nClientId, &dwUserAccess))
{
	if (dwUserAccess & HTTP_ACCESS_EXECUTE)
	{
		_tprintf(_T("Client %u can execute programs and scripts\n"), nClientId);
		return;
	}
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpAuthenticateClient](#httpauthenticateclient-function)
- [HttpEnableClientAccess](#httpenableclientaccess-function)
- [HttpSetClientAccess](#httpsetclientaccess-function)

---

## HttpGetClientAddress Function

Return the IP address of the specified client session

### Prototype

```c
INT WINAPI HttpGetClientAddress(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszAddress,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszAddress` | `LPTSTR` | A pointer to a string buffer that will contain the client IP address, terminated with a null character. To accommodate both IPv4 and IPv6 addresses, this buffer should be at least 46 characters in length. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters can be copied into the string buffer, including the terminating null character. This value must be greater than zero. If the buffer size is too small, the function will fail. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If either the server handle or the client ID is invalid, or the buffer is not large enough to store the complete address, the function will return a value of zero.

### Remarks

- The format and length of IPv4 and IPv6 address strings are very different. An IPv4 address string looks like "192.168.0.20", while an IPv6 address string can look something like "fd7c:2f6a:4f4f:ba34::a32". If your application checks for the format of these address strings, it needs to be aware of the differences. You also need to make sure that you're providing enough space to display or store an address to avoid buffer overruns.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetServerAddress](#httpgetserveraddress-function)

---

## HttpGetClientCredentials Function

Return the credentials for the specified client session

### Prototype

```c
BOOL WINAPI HttpGetClientCredentials(
    HSERVER hServer,
    UINT nClientId,
    LPHTTPCLIENTCREDENTIALS lpCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpCredentials` | `LPHTTPCLIENTCREDENTIALS` | A pointer to an HTTPCLIENTCREDENTIALS structure that will contain information about the user when the function returns. This parameter cannot be NULL. |

### Return Value

- **Type**: `BOOL`
- If the user credentials for the client session are available, the return value is non-zero. If the server handle and client ID do not specify a valid client session, or the client has not requested authentication, this function will return zero.

### Remarks

- The HttpGetClientCredentials function is used to obtain the username and password that was provided by the client when it requested authentication. Typically this function is used in an event handler to validate the credentials provided by the client. If the credentials are considered valid, the event handler would then call the HttpAuthenticateClient function to specify that the session has been authenticated.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAuthenticateClient](#httpauthenticateclient-function)
- [HttpRequireAuthentication](#httprequireauthentication-function)
- [HTTPCLIENTCREDENTIALS](#httpclientcredentials-function)

---

## HttpGetClientDirectory Function

Return the root document directory for a client session

### Prototype

```c
INT WINAPI HttpGetClientDirectory(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszDirectory,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszDirectory` | `LPTSTR` | A pointer to a string buffer that will contain the root directory for the specified client session, terminated with a null character. This buffer should be at least MAX_PATH characters in length. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. This value must be larger than zero or the function will fail. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- This function returns the full path to the root document directory for the specified client session. If no virtual hosts have been configured, then this path will be the same as the root directory assigned to the server when it was started. If the server has been configured with multiple virtual hosts, this function will return the path to the root directory associated with the hostname provided by the client.
- To convert a full path to the virtual path for a specific client session, use the HttpGetClientVirtualPath function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetClientVirtualPath](#httpgetclientvirtualpath-function)

---

## HttpGetClientHeader Function

Return the value of a request or response header for the specified client session

### Prototype

```c
INT WINAPI HttpGetClientHeader(
    HSERVER hServer,
    UINT nClientId,
    UINT nHeaderType,
    LPCTSTR lpszHeaderName,
    LPTSTR lpszHeaderValue,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `nHeaderType` | `UINT` | Specifies the type of header. It may be one of the following values: |
| `lpszHeaderName` | `LPCTSTR` | A pointer to a string that specifies the name of the header field. Header names are not case-sensitive and should not include the colon which acts as a delimiter that separates the header name from its value. This parameter cannot be a NULL pointer or an empty string. |
| `lpszHeaderValue` | `LPTSTR` | A pointer to a buffer that will contain the header value, terminated with a null character. To determine the length of the header value, this parameter can be NULL and the nMaxLength parameter should be specified with a value of zero. |
| `nMaxLength` | `INT` | An integer that specifies the maximum number of characters that can be copied into the header value buffer, including the terminating null character. If the lpszHeaderValue parameter is NULL, this value must be zero. |

### Options

- **nHeaderType** Parameter

    - `HTTP_HEADERS_REQUEST`: Return the value of a request header that was provided by the client. Request header values provide additional information to the server about the type of request being made.
    - `HTTP_HEADERS_RESPONSE`: Return the value of a response header that was created by the server. Response header values provide additional information to the client about the type of information that is being returned by the server.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the header value, not including the terminating null character. If the server handle and client ID do not specify a valid client session, or there is no header that matches the given name, the function will return zero. If the lpszHeaderValue parameter is not NULL and the buffer is not large enough to store the complete header value, the function will return zero and the last error code will be set to ST_ERROR_BUFFER_TOO_SMALL. If the function fails, the HttpGetServerError function will return more information about the last error that has occurred.

### Remarks

- The HttpGetClientHeader function will return the value of a request or response header for the specified client session. If the lpszHeaderName value matches an existing header field, its value will be copied to the string buffer provided by the caller.
- Refer to Hypertext Transfer Protocol Headers for a list of common request and response headers that are used.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpDeleteClientHeader](#httpdeleteclientheader-function)
- [HttpGetAllClientHeaders](#httpgetallclientheaders-function)
- [HttpSetClientHeader](#httpsetclientheader-function)

---

## HttpGetClientIdleTime Function

Return the idle timeout period for the specified client

### Prototype

```c
UINT WINAPI HttpGetClientIdleTime(
    HSERVER hServer,
    UINT nClientId,
    UINT lpnElapsed
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpnElapsed` | `UINT` | A pointer to an unsigned integer value that will contain the number of seconds the client session has been idle. This parameter may be NULL if this information is not required. |

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is client idle timeout period in seconds. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- The HttpGetClientIdleTime function will return the number of seconds that the client may remain idle before being automatically disconnected by the server. The idle time of a client session is based on the last time a command was issued to the server or when a data transfer completed. The server will never disconnect a client that is in the process of sending or receiving data, regardless of the idle timeout period.
- The default idle timeout period for a client session is 60 seconds, however the server can be configured to use a different value. The minimum timeout period for a client is 10 seconds, the maximum is 300 seconds (5 minutes). An application can change the timeout period for a specific client session using the HttpSetClientIdleTime function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpSetClientIdleTime](#httpsetclientidletime-function)

---

## HttpGetClientLocalPath Function

Return the full local path for the specified virtual path

### Prototype

```c
INT WINAPI HttpGetClientLocalPath(
    HSERVER hServer,
    UINT nClientId,
    LPCTSTR lpszVirtualPath,
    LPTSTR lpszLocalPath,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszVirtualPath` | `LPCTSTR` | A pointer to a string that specifies an virtual path on the server. This parameter cannot be NULL. |
| `lpszLocalPath` | `LPTSTR` | A pointer to a string buffer that will contain the full local path, terminated with a null-character. This buffer should be at least MAX_PATH characters to accommodate the complete path. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. This value must be greater than zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If the server handle and client ID do not specify a valid client session, the function will return zero. If the string buffer is not large enough to contain the complete path, this function will return zero and the last error code will be set to ST_ERROR_BUFFER_TOO_SMALL.

### Remarks

- The HttpGetClientLocalPath function takes a virtual path and returns the full path to the specified file or directory on the local system. The virtual path may be absolute or relative to the root directory for the client session.
- To obtain the virtual path for a local file or directory, use the HttpGetClientVirtualPath function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetClientVirtualPath](#httpgetclientvirtualpath-function)

---

## HttpGetClientServer Function

Return the handle to the server that created the specified client session

### Prototype

```c
HSERVER WINAPI HttpGetClientServer(
    UINT nClientId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |

### Return Value

- **Type**: `HSERVER`
- If the function succeeds, the return value is the handle to the server that created the client session. If the function fails, the return value is INVALID_SERVER. To get extended error information, call the HttpGetServerError function.

### Remarks

- The HttpGetClientServer function returns the handle to the server that created the client session and is typically used within a notification message handler. If the server is in the process of shutting down, or the client session thread is terminating, this function will fail and return INVALID_SERVER indicating that the session ID is invalid.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpServerAsyncNotify](#httpserverasyncnotify-function)

---

## HttpGetClientThreadId Function

Returns the thread ID associated with the specified client session

### Prototype

```c
DWORD WINAPI HttpGetClientThreadId(
    HSERVER hServer,
    UINT nClientId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is a thread ID. If the function fails, the return value is zero. To get extended error information, call the HttpGetServerError function.

### Remarks

- The HttpGetClientThreadId function returns a thread ID that can be used to identify the thread that is managing the client session. The thread ID can be used with other Windows API functions such as OpenThread. Exercise caution when using thread-related functions, interfering with the normal operation of the thread can have unexpected results. You should never use this function to obtain a thread handle and then call the TerminateThread function to terminate a client session. This will prevent the thread from releasing the resources that were allocated for the session and can leave the server in an unstable state. To terminate a client session, use the HttpDisconnectClient function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpEnumServerClients](#httpenumserverclients-function)
- [HttpGetActiveClient](#httpgetactiveclient-function)

---

## HttpGetClientUserName Function

Return the user name associated with the specified client session

### Prototype

```c
INT WINAPI HttpGetClientUserName(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszUserName,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszUserName` | `LPTSTR` | A pointer to a string buffer that will contain the user name associated with the client session. This buffer must be large enough to store the complete user name, including the terminating null character. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. This parameter must have a value larger than zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- The HttpGetClientUserName function returns the user name associated with an authenticated client session. If the client has not authenticated itself, this function will return zero and the lpszUserName parameter will be set to an empty string.
- The HttpIsClientAuthenticated function can be used to determine if the client has provided credentials as part of the request made to the server.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAuthenticateClient](#httpauthenticateclient-function)
- [HttpGetClientAccess](#httpgetclientaccess-function)
- [HttpIsClientAuthenticated](#httpisclientauthenticated-function)

---

## HttpGetClientVariable Function

Return the value of a CGI environment variable for the specified client

### Prototype

```c
INT WINAPI HttpGetClientVariable(
    HSERVER hServer,
    UINT nClientId,
    LPCTSTR lpszName,
    LPTSTR lpszValue,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszName` | `LPCTSTR` | A pointer to a string that specifies the name of the environment variable. Variable names are not case-sensitive and should not include the equal sign which acts as a delimiter that separates the variable name from its value. This parameter cannot be a NULL pointer or an empty string. |
| `lpszValue` | `LPTSTR` | A pointer to a buffer that will contain the value of the environment variable, terminated with a null character. To determine the length of the header value, this parameter can be NULL and the nMaxLength parameter should be specified with a value of zero. |
| `nMaxLength` | `INT` | An integer that specifies the maximum number of characters that can be copied into the value buffer, including the terminating null character. If the lpszValue parameter is NULL, this value must be zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the environment variable value, not including the terminating null character. If the server handle and client ID do not specify a valid client session, or there is no environment variable that matches the given name, the function will return zero. If the lpszValue parameter is not NULL and the buffer is not large enough to store the complete header value, the function will return zero and the last error code will be set to ST_ERROR_BUFFER_TOO_SMALL. If the function fails, the HttpGetServerError function will return more information about the last error that has occurred.

### Remarks

- The HttpGetClientVariable function will return the value of an environment variable that has been defined for the client. Each client session inherits a copy of the process environment block, which is then modified to define various environment variables that are used with CGI programs and scripts. The HttpSetClientVariable function can be used to change existing environment variables or create new variables.
- The standard CGI environment variables that are defined by the server are not created until the client request has been processed. This means that environment variables such as REMOTE_ADDR and SERVER_NAME will not be defined inside an HTTP_CLIENT_CONNECT event handler.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpSetClientVariable](#httpsetclientvariable-function)

---

## HttpGetClientVirtualHost Function

Return the name of the virtual host the client used to establish the connection

### Prototype

```c
INT WINAPI HttpGetClientVirtualHost(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszHostName,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszHostName` | `LPTSTR` | A pointer to a string buffer that will contain the virtual host name. The string buffer will be null terminated and must be large enough to store the complete hostname. If this parameter is NULL, the function will only return the length of the current command in characters, not including the terminating null character. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. If the maximum length specified is smaller than the actual length of the parameter, this function will fail. If the lpszHostName parameter is NULL, this value should be zero. |

### Return Value

- **Type**: `INT`
- An integer value which specifies the number of characters copied into the buffer, not including the terminating null character. If the function fails, the return value will be zero and the HttpGetServerError function can be used to retrieve the last error code.

### Remarks

- The HttpGetClientVirtualHost function is used to obtain the hostname that the client used to establish a connection with the server. This function is typically used within an event handler to determine the hostname associated with the request made by the client. It should not be called inside a HTTP_CLIENT_CONNECT event handler because the virtual host has not been selected at that point. If the virtual hostname is not available at the time this function is called, the function will return zero and the last error code will be set to ST_ERROR_VIRTUAL_HOST_NOT_FOUND.
- The HttpGetClientVirtualHostId function can be used to obtain the virtual host ID associated with the hostname.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetClientVirtualHostId](#httpgetclientvirtualhostid-function)
- [HttpGetCommandUrl](#httpgetcommandurl-function)

---

## HttpGetClientVirtualHostId Function

Return the virtual host ID associated with the specified client session

### Prototype

```c
UINT WINAPI HttpGetClientVirtualHostId(
    HSERVER hServer,
    UINT nClientId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |

### Return Value

- **Type**: `UINT`
- An unsigned integer value which specifies the virtual host ID. If the function fails, the return value will be INVALID_VIRTUAL_HOST and the HttpGetServerError function can be used to retrieve the last error code.

### Remarks

- The HttpGetClientVirtualHostId function is used to obtain the virtual host ID associated with the hostname the client used to establish a connection with the server. This function should not be called inside a HTTP_CLIENT_CONNECT event handler because the virtual host has not been selected at that point. If the virtual host ID is not available at the time this function is called, the function will return INVALID_VIRTUAL_HOST and the last error code will be set to ST_ERROR_VIRTUAL_HOST_NOT_FOUND.
- The HttpGetClientVirtualHost function can be used to obtain the hostname that the client used to establish the connection.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpGetClientVirtualHost](#httpgetclientvirtualhost-function)
- [HttpGetCommandUrl](#httpgetcommandurl-function)
- [HttpGetVirtualHostId](#httpgetvirtualhostid-function)
- [HttpGetVirtualHostName](#httpgetvirtualhostname-function)

---

## HttpGetClientVirtualPath Function

Return the virtual path for a local file on the server

### Prototype

```c
INT WINAPI HttpGetClientVirtualPath(
    HSERVER hServer,
    UINT nClientId,
    LPCTSTR lpszLocalPath,
    LPTSTR lpszVirtualPath,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszLocalPath` | `LPCTSTR` | A pointer to a string that specifies an absolute path on the local system. This parameter cannot be NULL. |
| `lpszVirtualPath` | `LPTSTR` | A pointer to a string buffer that will contain the virtual path, terminated with a null-character. This buffer should be at least MAX_PATH characters to accommodate the complete path. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. This value must be greater than zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If the server handle and client ID do not specify a valid client session, the function will return zero. If the string buffer is not large enough to contain the complete path, this function will return zero and the last error code will be set to ST_ERROR_BUFFER_TOO_SMALL.

### Remarks

- A virtual path for the client is relative to the root directory for the specified client session. These virtual paths are what the client will see as an absolute path on the server. For example, if the server was configured to use "C:\ProgramData\MyServer" as the root directory, and the lpszLocalPath parameter was specified as "C:\ProgramData\MyServer\Documents\Research", this function would return the virtual path to that directory as "/Documents/Research".
- If the lpszLocalPath parameter specifies a file or directory outside of the server root directory, this function will return zero and the last error code will be set to ST_ERROR_INVALID_FILE_NAME. This function can only be used with authenticated clients. If the nClientId parameter specifies a client session that has not been authenticated, this function will return zero and the last error code will be ST_ERROR_AUTHENTICATION_REQUIRED.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetCommandFile](#httpgetcommandfile-function)
- [HttpGetClientLocalPath](#httpgetclientlocalpath-function)

---

## HttpGetCommandFile Function

Return the full path to the local file name or directory specified by the client

### Prototype

```c
INT WINAPI HttpGetCommandFile(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszFileName,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszFileName` | `LPTSTR` | A pointer to a string buffer that will contain the full path to a file name or directory specified by the client when it issued a command. The string buffer will be null terminated and must be large enough to store the complete file path. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer. It is recommended that the buffer be at least MAX_PATH characters in size. If the maximum length specified is smaller than the actual length of the full path, this function will fail. |

### Return Value

- **Type**: `INT`
- An integer value which specifies the number of characters copied into the buffer, not including the terminating null character. If the function fails, the return value will be zero and the HttpGetServerError function can be used to retrieve the last error code.

### Remarks

- The HttpGetCommandFile function is used to obtain the full path to a local file name or directory specified by the client as an argument to a standard HTTP command. For example, if the client sends the GET command to the server, this function will return the complete path to the local file that the client wants to retrieve. This function will only work with those standard commands that perform some action on a file or directory.
- This function should always be used to obtain the file name for a command that performs a file or directory operation. It normalizes the path provided by the client and ensures that it specifies a file or directory name in the correct location. The HttpGetCommandUrl function can be used to obtain the URL that was provided by the client.
- To map a virtual path to a file or directory on the local system, use the HttpAddVirtualPath function. To redirect a client to use a different URL to access the resource, use the HttpRedirectRequest function.
- The HttpSetCommandFile function can be used to change the name of the local file or directory that is the target of the command, however using this function to redirect access to a resource can have unintended side-effects, particularly in the case where the URL provided by the client actually resolves to an executable CGI program that handles the request.
- If the client has provided a URL that resolves to a CGI program that handles the request, this function behaves differently than if the URL is resolved to a local file or directory. If the client uses the GET or POST command that results in a program being executed to handle the request, this function will return the path to the server root directory along with any additional path information provided in the URL. In other words, the file name returned by this function will be the same as the PATH_TRANSLATED value passed to the CGI program.
- This function should only be called after the client request has been received by the server, typically inside a HTTP_CLIENT_COMMAND or HTTP_CLIENT_EXECUTE event handler. It should not be called inside a HTTP_CLIENT_CONNECT event handler because the server has not processed the client request at that point.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddVirtualPath](#httpaddvirtualpath-function)
- [HttpGetCommandUrl](#httpgetcommandurl-function)
- [HttpRedirectRequest](#httpredirectrequest-function)
- [HttpSetCommandFile](#httpsetcommandfile-function)

---

## HttpGetCommandLine Function

Return the complete command line issued by the client

### Prototype

```c
INT WINAPI HttpGetCommandLine(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszCmdLine,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszCmdLine` | `LPTSTR` | A pointer to a string buffer that will contain the command, including all arguments. The string buffer will be null terminated and must be large enough to store the complete command line. If this parameter is NULL, the function will return the length of the command line. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer. The internal limit on the maximum length of a command is 1024 characters. If the maximum length specified is smaller than the actual length of the complete command, this function will fail. |

### Return Value

- **Type**: `INT`
- An integer value which specifies the number of characters copied into the buffer, not including the terminating null character. If the function fails, the return value will be zero and the HttpGetServerError function can be used to retrieve the last error code. If the last error code has a value of zero then no command has been issued by the client.

### Remarks

- The HttpGetCommandLine function is used to obtain the command that was issued by the client, and is commonly used inside HTTP_CLIENT_COMMAND and HTTP_CLIENT_RESULT event handlers to pre-process and post-process client commands, respectively. When the function returns, the string buffer provided by the caller will contain the complete command, including the resource path and requested HTTP version. Any extraneous whitespace will be removed, however all encoding will be preserved.
- To obtain the complete URL associated with the request issued by the client, use the HttpGetCommandUrl function. If the command sent by the client is used to perform an action on a file or directory, the HttpGetCommandFile function should be called to obtain the full path to the local file rather than using the resource path.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetCommandFile](#httpgetcommandfile-function)
- [HttpGetCommandUrl](#httpgetcommandurl-function)

---

## HttpGetCommandName Function

Return the name of the command that was issued by the client

### Prototype

```c
INT WINAPI HttpGetCommandName(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszCommand,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszCommand` | `LPTSTR` | A pointer to a string buffer that will contain the command name. The string buffer will be null terminated and must be large enough to store the complete command name. If this parameter is NULL, the function will only return the length of the current command in characters, not including the terminating null character. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. If the maximum length specified is smaller than the actual length of the parameter, this function will fail. If the lpszCommand parameter is NULL, this value should be zero. |

### Return Value

- **Type**: `INT`
- An integer value which specifies the number of characters copied into the buffer, not including the terminating null character. If the function fails, the return value will be zero and the HttpGetServerError function can be used to retrieve the last error code. If the last error code is returned as a value of zero, this means that no command has been issued by the client.

### Remarks

- The HttpGetCommandName function is used to obtain the name of the last command that was issued by the client. The command name returned by this function will always be capitalized, regardless of how it was sent by the client. This function is typically used inside HTTP_CLIENT_COMMAND and HTTP_CLIENT_RESULT event handlers to pre-process and post-process client commands, respectively. It should not be called inside a HTTP_CLIENT_CONNECT event handler because the server has not processed the client request at that point.
- The HttpGetCommandUrl function can be used to return the resource that was requested by the client.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetCommandFile](#httpgetcommandfile-function)
- [HttpGetCommandUrl](#httpgetcommandurl-function)

---

## HttpGetCommandQuery Function

Return the query parameters included with the command

### Prototype

```c
INT WINAPI HttpGetCommandQuery(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszParameters,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszParameters` | `LPTSTR` | A pointer to a string buffer that will contain the query parameters when the function returns. The string buffer will be null terminated up to the maximum number of characters specified by the caller. If this parameter is NULL the function will return the length of the query string. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer. If the lpszParameters parameter is NULL, this value should be zero. |

### Return Value

- **Type**: `INT`
- An integer value which specifies the number of characters copied into the buffer, not including the terminating null character. If the function fails, the return value will be zero and the HttpGetServerError function can be used to retrieve the last error code. If the client did not provide any query parameters, this function will return zero and the last error code will be zero.

### Remarks

- The HttpGetCommandQuery function is used to obtain a copy of the query parameters that were included in the request URL. If there were no query parameters, the string buffer will be empty and the return value will be zero. If the request did include query parameters, they will be returned to the caller in their original, encoded form.
- This function should not be called within a HTTP_CLIENT_CONNECT event handler because the client request has not been processed at that point.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetCommandName](#httpgetcommandname-function)
- [HttpGetCommandResource](#httpgetcommandresource-function)
- [HttpReceiveRequest](#httpreceiverequest-function)

---

## HttpGetCommandResource Function

Return the path for the resource requested by the client

### Prototype

```c
INT WINAPI HttpGetCommandResource(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszResource,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszResource` | `LPTSTR` | A pointer to a string buffer that will contain the URL path provided by the client for the current command. The string buffer will be null terminated and must be large enough to store the complete path. If this parameter is NULL, the function will only return the length of the path. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. If the lpszResource parameter is NULL, this value should be zero. If this value is less than the length of the URL, the function will fail. |

### Return Value

- **Type**: `INT`
- An integer value which specifies the number of characters copied into the buffer, not including the terminating null character. If the function fails, the return value will be zero and the HttpGetServerError function can be used to retrieve the last error code.

### Remarks

- The HttpGetCommandResource function returns the URL path that the client provided to access the requested resource. The path will not include the URI scheme, user credentials or query parameters. The HttpGetCommandFile function can be used to determine the name of the local file on the server that will be accessed using this URL.
- If you require the complete URL, not just the path to the resource, use the HttpGetCommandUrl function.
- This function should only be called after the client request has been received by the server, typically inside a HTTP_CLIENT_COMMAND event handler. It should not be called inside a HTTP_CLIENT_CONNECT event handler because the server has not processed the client request at that point.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetCommandFile](#httpgetcommandfile-function)
- [HttpGetCommandQuery](#httpgetcommandquery-function)
- [HttpGetCommandUrl](#httpgetcommandurl-function)
- [HttpRedirectRequest](#httpredirectrequest-function)

---

## HttpGetCommandResult Function

Return the result code and a description of the last command processed by the server

### Prototype

```c
INT WINAPI HttpGetCommandResult(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszResult,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszResult` | `LPTSTR` | A pointer to a string buffer that will contain the description of the result code. The string buffer will be null terminated up to the maximum number of characters specified by the caller. This parameter can be NULL if this information is not required. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer. If the lpszResult parameter is NULL, this value should be zero. |

### Return Value

- **Type**: `INT`
- An integer value which specifies the result code for the last command issued by the client. A return value of zero indicates that the command has not completed and there is no result code available.

### Remarks

- The HttpGetCommandResult function is used to determine the result of the last command that was issued by the client and is typically called in the HTTP_CLIENT_RESULT event handler. This function should only be called after a command has been processed or the HttpSendResponse function has been called.
- The result code is a three-digit integer value that indicates the success or failure of a command. Whenever a client sends a command to the server, the server must respond with this numeric code and a brief description of the the result. Result codes are generally broken down into the following categories:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpReceiveRequest](#httpreceiverequest-function)
- [HttpSendResponse](#httpsendresponse-function)

---

## HttpGetCommandUrl Function

Return the complete URL of the resource requested by the client

### Prototype

```c
INT WINAPI HttpGetCommandUrl(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszCmdUrl,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszCmdUrl` | `LPTSTR` | A pointer to a string buffer that will contain the URL provided by the client for the current command. The string buffer will be null terminated and must be large enough to store the complete URL. If this parameter is NULL, the function will only return the length of the URL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. If the lpszCmdUrl parameter is NULL, this value should be zero. If this value is less than the length of the URL, the function will fail. |

### Return Value

- **Type**: `INT`
- An integer value which specifies the number of characters copied into the buffer, not including the terminating null character. If the function fails, the return value will be zero and the HttpGetServerError function can be used to retrieve the last error code.

### Remarks

- The HttpGetCommandUrl function returns the complete URL that the client provided to access the requested resource. The URL will include any query parameters that were specified by the client, but it will not include any user credentials. The HttpGetCommandFile function can be used to determine the name of the local file on the server that will be accessed using this URL.
- If you only require the URL path, without the URI scheme or the query parameters, use the HttpGetCommandResource function.
- This function should only be called after the client request has been received by the server, typically inside a HTTP_CLIENT_COMMAND event handler. It should not be called inside a HTTP_CLIENT_CONNECT event handler because the server has not processed the client request at that point.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetCommandFile](#httpgetcommandfile-function)
- [HttpGetCommandResource](#httpgetcommandresource-function)
- [HttpRedirectRequest](#httpredirectrequest-function)

---

## HttpGetProgramExitCode Function

Return the exit code of the last program executed by the client

### Prototype

```c
BOOL WINAPI HttpGetProgramExitCode(
    HSERVER hServer,
    UINT nClientId,
    LPDWORD lpdwExitCode
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpdwExitCode` | `LPDWORD` | A pointer to an unsigned integer that will contain the program exit code when the function returns. This parameter cannot be NULL. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- The HttpGetProgramExitCode function returns the exit code of a registered CGI program or script that was executed. By convention, most programs return an exit code in the range of 0-255, with an exit code of zero indicating success. The exit code is commonly used by programs to communicate status information back to the server application.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpGetProgramOutput](#httpgetprogramoutput-function)
- [HttpRegisterProgram](#httpregisterprogram-function)

---

## HttpGetProgramName Function

Return the name of the CGI program executed by the client

### Prototype

```c
INT WINAPI HttpGetProgramName(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszProgramName,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszProgramName` | `LPTSTR` | A pointer to a string buffer that will contain the name of the CGI program executed by the client. This parameter cannot be NULL and should be at least MAX_PATH characters in size. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters that can be copied into the string buffer, including the terminating null character. This parameter must have a value greater than zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the length of the executable file name. If the server handle and client ID do not specify a valid client session, the function will return zero. If the client has not executed a CGI program this function will return zero and the last error code will be set to zero.

### Remarks

- The HttpGetProgramName function returns the local file name of the CGI program that was executed in response to a request from the client. This is the full path to the executable that was registered with the server using the HttpRegisterProgram function. If the client specified a regular document or directory, this function will return a value of zero, indicating that no CGI program has been executed to handle the request.
- To obtain the resource URL that was provided by the client, use the HttpGetCommandUrl function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetProgramExitCode](#httpgetprogramexitcode-function)
- [HttpGetProgramOutput](#httpgetprogramoutput-function)
- [HttpRegisterProgram](#httpregisterprogram-function)

---

## HttpGetProgramOutput Function

Return a copy of the standard output from a CGI program executed by the client

### Prototype

```c
DWORD WINAPI HttpGetProgramOutput(
    HSERVER hServer,
    UINT nClientId,
    LPBYTE lpBuffer,
    DWORD dwBufferSize
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpBuffer` | `LPBYTE` | A pointer to a buffer that will contain the output from the last program executed by the client. If this parameter is NULL, the function will return the number of bytes of data that was output by the program. Note that this output is not null terminated. |
| `dwBufferSize` | `DWORD` | The maximum number of bytes that can be copied into the buffer. If the lpBuffer parameter is NULL, this value should be zero. |

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is the number of bytes copied into the specified buffer. If the server handle and client ID do not specify a valid client session, the function will return zero. If the client has not executed any programs, the return value will be zero.

### Remarks

- The HttpGetProgramOutput function is used to obtain a copy of the output generated by a CGI program. To determine the number of bytes of output available to read, call this function with the lpBuffer parameter as NULL and the dwBufferSize parameter with a value of zero. The return value will be the number of bytes of data that was output by the program. It should be noted that for Unicode builds, the buffer is a byte array, not an array of characters, and will not be null terminated.
- This function returns the raw output from the program which may contain a response header block, escape sequences, control characters and embedded nulls. When the application processes the output returned by this function, it should never coerce the buffer pointer to an LPTSTR value because there is no guarantee that the data will be null-terminated. To obtain the output from the program as a string, use the HttpGetProgramText function.
- This function should only be used within an HTTP_CLIENT_EXECUTE event handler, which occurs after the program has terminated.

### Example

```cpp
LPBYTE lpBuffer = NULL;  // A pointer to the output buffer
DWORD cbBuffer = 0;      // Number of bytes in the output buffer

// Determine the number of bytes in the output buffer
cbBuffer = HttpGetProgramOutput(hServer, nClientId, NULL, 0);

if (cbBuffer > 0)
{
	// Allocate memory for the buffer
	lpBuffer = (LPBYTE)LocalAlloc(LPTR, cbBuffer + 1);

	// Copy the program output to the buffer
	if (lpBuffer != NULL)
		cbBuffer = HttpGetProgramOutput(hServer, nClientId, lpBuffer, cbBuffer + 1);
}

// Free the memory allocated for the buffer when finished
if (lpBuffer != NULL)
{
	LocalFree((HLOCAL)lpBuffer);
	lpBuffer = NULL;
	cbBuffer = 0;
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpGetProgramExitCode](#httpgetprogramexitcode-function)
- [HttpGetProgramText](#httpgetprogramtext-function)
- [HttpRegisterProgram](#httpregisterprogram-function)

---

## HttpGetProgramText Function

Return a copy of the standard output from a CGI program in a string buffer

### Prototype

```c
INT WINAPI HttpGetProgramText(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszBuffer,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszBuffer` | `LPTSTR` | A pointer to a buffer that will contain the output from the last program executed by the client as a string. If this parameter is NULL, the function will return the number of bytes of characters that was output by the program, not including a terminating null character. |
| `nMaxLength` | `INT` | The maximum number of bytes that can be copied into the buffer. If the lpszBuffer parameter is NULL, this value should be zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the specified string buffer, not including the terminating null character. If the server handle and client ID do not specify a valid client session, the function will return zero. If the client has not executed any programs, the return value will be zero.

### Remarks

- The HttpGetProgramText function is used to obtain a copy of the output generated by a CGI program. To determine the number of characters of output available to read, call this function with the lpszBuffer parameter as NULL and the nMaxLength parameter with a value of zero. The return value will be the number of characters that were output by the program. If the application dynamically allocates the string buffer, make sure that it allocates an extra character for the terminating null character.
- This function will only return textual output from the program and any non-printable control characters and the escape character will be replaced with a space. To obtain the unfiltered output from the program, use the HttpGetProgramOutput function. If the program outputs a response header block, this will be included in the string buffer.
- This function should only be used within an HTTP_CLIENT_EXECUTE event handler, which occurs after the program has terminated.

### Example

```cpp
LPTSTR lpszBuffer = NULL;  // A pointer to the output buffer
INT cchBuffer = 0;         // Number of bytes in the output buffer

// Determine the number of bytes in the output buffer
cchBuffer = HttpGetProgramText(hServer, nClientId, NULL, 0);

if (cchBuffer > 0)
{
	// Allocate memory for the string buffer
	lpszBuffer = (LPTSTR)LocalAlloc(LPTR, (cchBuffer + 1) * sizeof(TCHAR));

	// Copy the program output to the buffer
	if (lpszBuffer != NULL)
		cchBuffer = HttpGetProgramText(hServer, nClientId, lpszBuffer, cchBuffer + 1);
}

// Free the memory allocated for the buffer when finished
if (lpszBuffer != NULL)
{
	LocalFree((HLOCAL)lpszBuffer);
	lpszBuffer = NULL;
	cchBuffer = 0;
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetProgramExitCode](#httpgetprogramexitcode-function)
- [HttpGetProgramOutput](#httpgetprogramoutput-function)
- [HttpRegisterProgram](#httpregisterprogram-function)

---

## HttpGetServerAddress Function

Return the IP address for the server

### Prototype

```c
INT WINAPI HttpGetServerAddress(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszAddress,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. This value may be zero. |
| `lpszAddress` | `LPTSTR` | A pointer to a string buffer that will contain the server IP address, terminated with a null character. To accommodate both IPv4 and IPv6 addresses, this buffer should be at least 46 characters in length. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters can be copied into the string buffer, including the terminating null character. This value must be greater than zero. If the buffer size is too small, the function will fail. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If either the server handle or the client ID is invalid, or the buffer is not large enough to store the complete address, the function will return a value of zero.

### Remarks

- This function will return the IP address assigned to the specified server as a printable string. If the nClientId parameter has a value of zero, this function will return the IP address assigned to the local system. If the HTTP_SERVER_NATROUTER option was specified when the server was started, this function will return the external IP address assigned to the system. If the nClientId parameter specifies a valid client session, this function will return the IP address that the client used to establish the connection with the server. To determine the IP address assigned to the client, use the HttpGetClientAddress function.
- The format and length of IPv4 and IPv6 address strings are very different. An IPv4 address string looks like "192.168.0.20", while an IPv6 address string can look something like "fd7c:2f6a:4f4f:ba34::a32". If your application checks for the format of these address strings, it needs to be aware of the differences. You also need to make sure that you're providing enough space to display or store an address to avoid buffer overruns.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetClientAddress](#httpgetclientaddress-function)
- [HttpGetServerName](#httpgetservername-function)

---

## HttpGetServerDirectory Function

Return the full path to the root directory assigned to the specified server

### Prototype

```c
INT WINAPI HttpGetServerDirectory(
    HSERVER hServer,
    LPTSTR lpszDirectory,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszDirectory` | `LPTSTR` | A pointer to a string buffer that will contain the server root directory, terminated with a null character. It is recommended that this buffer be at least MAX_PATH characters in length. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters can be copied into the string buffer, including the terminating null character. This value must be greater than zero. If the buffer size is too small, the function will fail. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If the server handle is invalid, or the buffer is not large enough to store the complete path, the function will return a value of zero.

### Remarks

- The HttpGetServerDirectory function will return the full path to the root directory assigned to the server instance. The root directory may be specified as part of the server configuration, or if no directory is specified by the application, a temporary root directory will be created and this function can be used to obtain the full path to the directory. When the application specifies a root directory, it may use environment variables such as %AppData% in the path. This function will return the fully resolved path name, with all environment variables expanded.
- There is no corresponding function to change the server root directory after the server has started. To change the root directory, you must stop the server using the HttpServerStop function and then start another instance of the server with a configuration that specifies the new directory.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetServerAddress](#httpgetserveraddress-function)
- [HttpGetServerIdentity](#httpgetserveridentity-function)
- [HttpGetServerName](#httpgetservername-function)

---

## HttpGetServerError Function

Return information about the last server error that occurred

### Prototype

```c
DWORD WINAPI HttpGetServerError(
    HSERVER hServer,
    LPTSTR lpszError,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszError` | `LPTSTR` | A pointer to a string buffer that will contain a description of the error. If the error description is not needed, this parameter may be NULL. |
| `nMaxLength` | `INT` | An integer that specifies the maximum number of characters that can be copied into the error string buffer, including the terminating null character. If the lpszError parameter is NULL, this value should be zero. |

### Return Value

- **Type**: `DWORD`
- An unsigned integer value that specifies the last error that occurred. A value of zero indicates that there was no error.

### Remarks

- Error codes are unsigned 32-bit values which are private to each server. You should call the HttpGetServerError function immediately when a function's return value indicates that an error has occurred. That is because some functions clear the last error code when they succeed.
- If the hServer parameter is specified with a value of INVALID_SERVER, this function will return the last error that occurred for the current thread. This value should only be used when the function does not have access to a valid server handle, such as when the HttpServerStart function fails.
- It is important to note that the error codes returned by this method are different than the command result codes that are defined in RFC 2616, the standard protocol specification for HTTP. This function is used to determine reason that an API function has failed, and should not be used to determine if a command issued by the client was successful. The HttpSendResponse function is used to send responses to the client, and the HttpGetCommandResult function can be used to determine the result of the last command sent by the client.
- Most functions will set the last error code value when they fail; a few functions set it when they succeed. Function failure is typically indicated by a return value such as FALSE, NULL, INVALID_SERVER or HTTP_ERROR. Those functions which clear the last error code when they succeed are noted on the function reference page.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetCommandResult](#httpgetcommandresult-function)
- [HttpSendResponse](#httpsendresponse-function)
- [HttpSetServerError](#httpsetservererror-function)

---

## HttpGetServerIdentity Function

Return the identity and version information for the specified server

### Prototype

```c
INT WINAPI HttpGetServerIdentity(
    HSERVER hServer,
    LPTSTR lpszIdentity,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszIdentity` | `LPTSTR` | A pointer to a string buffer that will contain the identity of the server when the function returns, terminated with a null character. This parameter cannot be NULL. It is recommended that this buffer be at least 32 characters in length. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters can be copied into the string buffer, including the terminating null character. This value must be greater than zero. If the buffer size is too small, the function will fail. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If the server handle is invalid, or the buffer is not large enough to store the complete path, the function will return a value of zero.

### Remarks

- The HttpGetServerIdentity function returns the identity string that was specified as part of the server configuration. It is used for informational purposes only and does not affect the operation of the server. Typically the string specifies the name of the application and a version number. The HttpSetServerIdentity function can be used to change the identity string associated with the server.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpSetServerIdentity](#httpsetserveridentity-function)

---

## HttpGetServerLogFile Function

Return the current log file format and full path for the file

### Prototype

```c
BOOL WINAPI HttpGetServerLogFile(
    HSERVER hServer,
    UINT lpnLogFormat,
    UINT lpnLogLevel,
    LPTSTR lpszFileName,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpnLogFormat` | `UINT` | A pointer to an integer value that will contain the log file format being used when the function returns. If this information is not needed, this parameter may be NULL. The following formats are supported: |
| `lpnLogLevel` | `UINT` | A pointer to an integer value that will contain the level of detail the server uses when generating the log file. The minimum value is 1 and the maximum value is 10. If this information is not needed, this parameter may be NULL. |
| `lpszFileName` | `LPTSTR` | A pointer to a string buffer that will contain the full path to the log file. This parameter may be NULL if this information is not required. |
| `nMaxLength` | `INT` | An integer that specifies the maximum number of characters that can be copied into the file name string, including the terminating null character. If the lpszFileName parameter is NULL, this value should be zero. |

### Options

- **lpnLogFormat** Parameter

    - `HTTP_LOGFILE_NONE`: This value specifies that the server should not create or update a log file.
    - `HTTP_LOGFILE_COMMON`: This value specifies that the log file should use the common log format that records a subset of information in a fixed format. This log format usually only provides information about file transfers.
    - `HTTP_LOGFILE_COMBINED`: This value specifies that the server should use the combined log file format. This format is similar to the common format, however it includes the client referrer and user agent. This is the format that most Apache web servers use by default.
    - `HTTP_LOGFILE_EXTENDED`: This value specifies that the log file should use the standard W3C extended log file format. This is an extensible format that can provide additional information about the client session.

### Return Value

- **Type**: `BOOL`
- An integer value which specifies the current log file format. Refer to the HTTPSERVERCONFIG structure definition for a list of supported log file formats. If the server handle is invalid or logging has not been enabled, this function will return a value of zero.

### Remarks

- If the server is configured with logging enabled, but a log file name is not explicitly provided, then the server will automatically generate one. This function can be used to get the full path to the current log file along with the format that is being used to record client session data. Normally the log file is held open by the server thread while it is active, however you can call the HttpRenameServerLogFile function to explicitly rename or delete the log file.
- To change the name of the log file, the log file format or level of detail, use the HttpSetServerLogFile function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpRenameServerLogFile](#httprenameserverlogfile-function)
- [HttpSetServerLogFile](#httpsetserverlogfile-function)

---

## HttpGetServerMemoryUsage Function

Return the amount of memory allocated for the server and all client sessions

### Prototype

```c
BOOL WINAPI HttpGetServerMemoryUsage(
    HSERVER hServer,
    ULARGE_INTEGER lpMemUsage
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpMemUsage` | `ULARGE_INTEGER` | A pointer to a ULARGE_INTEGER variable which will specify how much memory has been allocated by the server. This parameter will be initialized to a value of zero by the function and updated with the total number of bytes allocated by the server and all active client sessions when it returns. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero and the memory usage value will be updated. If the server handle is invalid, or the server cannot be locked, the return value is zero. Call the HttpGetServerError function to determine the cause of the failure.

### Remarks

- This function returns the amount of memory allocated by the server and all active client sessions. It enumerates all of memory allocations made by the server process and client session threads and returns the total number of bytes allocated for the server process. This value reflects the amount of memory explicitly allocated by this library and does not reflect the total working set size of the process, or memory allocated by any other libraries. To determine the working set size for the process, refer to the Win32 GetProcessWorkingSetSize and GetProcessMemoryInfo functions.
- This function forces the server into a locked state, and all client sessions will block until the function returns. Because this function enumerates all heaps allocated for the server process, it can be an expensive operation, particularly when there are a large number of active clients connected to the server. Frequent use of this function can significantly degrade the performance of the server. It is primarily intended for use as a debugging tool to determine if memory usage is the result of an increase in active client sessions. If the value returned by the function remains reasonably constant, but the amount of memory allocated for the process continues to grow, it could indicate a memory leak in some other area of the application.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpGetServerStackSize](#httpgetserverstacksize-function)
- [HttpSetServerStackSize](#httpsetserverstacksize-function)

---

## HttpGetServerName Function

Return the host name assigned to the server or specified client session

### Prototype

```c
INT WINAPI HttpGetServerName(
    HSERVER hServer,
    UINT nClientId,
    LPTSTR lpszHostName,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. This value may be zero. |
| `lpszHostName` | `LPTSTR` | A pointer to a string buffer that will contain the server host name, terminated with a null character. It is recommended that this buffer be at least 64 characters in length. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters can be copied into the string buffer, including the terminating null character. This value must be greater than zero. If the buffer size is too small, the function will fail. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If either the server handle or the client ID is invalid, or the buffer is not large enough to store the complete hostname, the function will return a value of zero.

### Remarks

- This function will return the host name assigned to the specified server. If the nClientId parameter has a value of zero, the function will return the default host name that was specified as part of the server configuration. If no host name was explicitly assigned to the server, then it will return the local system name. If the nClientId parameter specifies a client session, then it this function will return the host name that the client used to establish the connection.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetServerAddress](#httpgetserveraddress-function)

---

## HttpGetServerOptions Function

Return the configuration options for the specified server

### Prototype

```c
BOOL WINAPI HttpGetServerOptions(
    HSERVER hServer,
    LPDWORD lpdwOptions
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpdwOptions` | `LPDWORD` | A pointer to an unsigned integer that will contain the options that were specified when the server was started. This parameter cannot be NULL. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle is invalid, the function will return a value of zero.

### Remarks

- This function will return the options that were specified when the server was started. For a list of server options see Server Option Constants.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpServerStart](#httpserverstart-function)

---

## HttpGetServerPriority Function

Return the current priority assigned to the specified server

### Prototype

```c
INT WINAPI HttpGetServerPriority(
    HSERVER hServer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the priority for the specified server. If the function fails, the return value is HTTP_PRIORITY_INVALID. To get extended error information, call HttpGetServerError.

### Remarks

- The HttpGetServerPriority function can be used to determine the current priority assigned to the server. It will return one of the following values:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpServerStart](#httpserverstart-function)
- [HttpSetServerPriority](#httpsetserverpriority-function)

---

## HttpGetServerStackSize Function

Return the initial size of the stack allocated for threads created by the server

### Prototype

```c
DWORD WINAPI HttpGetServerStackSize(
    SOCKET hServer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `SOCKET` | The server handle. |

### Return Value

- **Type**: `DWORD`
- If the function succeeds, the return value is the amount of memory that will be allocated for the stack in bytes. If the function fails, the return value is zero. To get extended error information, call HttpGetServerError.

### Remarks

- The HttpGetServerStackSize function returns the initial amount of memory that is committed to the stack for each thread created by the server. By default, the stack size for each thread is set to 256K for 32-bit processes and 512K for 64-bit processes.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpGetServerMemoryUsage](#httpgetservermemoryusage-function)
- [HttpServerStart](#httpserverstart-function)
- [HttpSetServerStackSize](#httpsetserverstacksize-function)

---

## HttpGetServerTransferInfo Function

Return information about the current file transfer

### Prototype

```c
BOOL WINAPI HttpGetServerTransferInfo(
    HSERVER hServer,
    UINT nClientId,
    LPHTTPSERVERTRANSFER lpTransferInfo
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpTransferInfo` | `LPHTTPSERVERTRANSFER` | A pointer to an HTTPSERVERTRANSFER structure that will contain information about the last file transfer. This parameter cannot be NULL, and the dwSize member of the structure must be initialized to specify the structure size prior to calling this function. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- The HttpGetServerTransferInfo function is used to obtain information about the last file transfer that was performed by the server for the specified client. This function is typically called within an event handler to determine how many bytes of data were transferred, the type of file and the full path to the file on the local system.
- This function will only return information about a file transfer using the GET or PUT commands, with any other command causing this function to fail.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpReceveRequest](#httpreceverequest-function)
- [HttpSendResponse](#httpsendresponse-function)
- [HTTPSERVERTRANSFER](#httpservertransfer-function)

---

## HttpGetServerUuid Function

Return the UUID assigned to the specified server

### Prototype

```c
INT WINAPI HttpGetServerUuid(
    HSERVER hServer,
    UUID lpUuid
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpUuid` | `UUID` | A pointer to a UUID structure that will contain the server UUID when the function returns. This parameter cannot be NULL. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is non-zero. If either the server handle is invalid or the pointer to the UUID structure is NULL, the function will return a value of zero.

### Remarks

- The HttpGetServerUuid function returns the Universally Unique Identifier (UUID) that has been assigned to the server. The UUID may either be generated by the application and assigned as part of the server configuration, or an ephemeral UUID may be automatically generated when the server is started. To obtain a printable string version of the UUID, use the HttpGetServerUuidString function.
- There is no corresponding function to change the UUID assigned to an active server. The server UUID is assigned when the server is started, and it must be a unique value that is maintained throughout the lifetime of the server. To change the UUID associated with the server, the server must be stopped using the HttpServerStop function and another instance of the server started with the new UUID.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpGetServerUuidString](#httpgetserveruuidstring-function)
- [HTTPSERVERCONFIG](#httpserverconfig-function)

---

## HttpGetServerUuidString Function

Return the UUID assigned to the server as a printable string

### Prototype

```c
INT WINAPI HttpGetServerUuidString(
    HSERVER hServer,
    LPTSTR lpszHostUuid,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszHostUuid` | `LPTSTR` | A pointer to a string buffer that will contain the server UUID, terminated with a null character. It is recommended that this buffer be at least 40 characters in length. This parameter cannot be NULL. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters can be copied into the string buffer, including the terminating null character. This value must be greater than zero. If the buffer size is too small, the function will fail. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If either the server handle or the buffer is not large enough to store the complete UUID string, the function will return a value of zero.

### Remarks

- The HttpGetServerUuidString function returns the Universally Unique Identifier (UUID) that has been assigned to the server. The UUID may either be generated by the application and assigned as part of the server configuration, or an ephemeral UUID may be automatically generated when the server is started. To obtain the numeric UUID value, use the HttpGetServerUuid function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetServerUuid](#httpgetserveruuid-function)
- [HTTPSERVERCONFIG](#httpserverconfig-function)

---

## HttpGetVirtualHostId Function

Return the virtual host ID associated with the specified hostname

### Prototype

```c
UINT WINAPI HttpGetVirtualHostId(
    HSERVER hServer,
    LPCTSTR lpszHostName,
    UINT nHostPort
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszHostName` | `LPCTSTR` | A string that specifies the virtual host name. |
| `nHostPort` | `UINT` | An integer value which specifies the port number for the virtual host. This value must be zero or the same value as the original port number that the server was configured to use. |

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is the host ID that uniquely identifies the virtual host. If the server handle is invalid, or there is no virtual host with the specified name, the function will return VIRTUAL_HOST_UNKNOWN. If the function fails, the last error code will be updated to indicate the cause of the failure.

### Remarks

- The HttpGetVirtualHostId function is used to obtain the unique virtual host ID that is associated with a specific hostname. This function will match both the primary virtual hostname added using the HttpAddVirtualHost function, as well as any aliases that were added using the HttpAddVirtualHostAlias function. To obtain the virtual host ID associated with the active client session, use the HttpGetClientVirtualHostId function.
- The nHostPort parameter should always be specified with a value of zero, or the same port number that the server was configured to use. Port-based virtual hosting is currently not supported and this parameter is included for future use.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddVirtualHost](#httpaddvirtualhost-function)
- [HttpAddVirtualHostAlias](#httpaddvirtualhostalias-function)
- [HttpDeleteVirtualHost](#httpdeletevirtualhost-function)
- [HttpGetClientVirtualHostId](#httpgetclientvirtualhostid-function)
- [HttpGetVirtualHostName](#httpgetvirtualhostname-function)

---

## HttpGetVirtualHostName Function

Return the hostname associated with the specified virtual host ID

### Prototype

```c
INT WINAPI HttpGetVirtualHostName(
    HSERVER hServer,
    UINT nHostId,
    LPTSTR lpszHostName,
    INT nMaxLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nHostId` | `UINT` | An integer value which identifies the virtual host. |
| `lpszHostName` | `LPTSTR` | A pointer to a string buffer that will contain the virtual host name, terminated with a null character. It is recommended that this buffer be at least 64 characters in length. If this parameter is NULL, the function will return the length of the virtual hostname. |
| `nMaxLength` | `INT` | An integer value that specifies the maximum number of characters can be copied into the string buffer, including the terminating null character. If the lpszHostName parameter is NULL this value must be zero. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of characters copied into the string buffer, not including the terminating null character. If either the server handle or the host ID is invalid, or the buffer is not large enough to store the complete hostname, the function will return a value of zero.

### Remarks

- The HttpGetVirtualHostName function returns the primary hostname associated with the specified virtual host ID. This is the same hostname that was specified when the virtual host was added to the server configuration using the HttpAddVirtualHost function. To obtain the hostname that was used by the active client session to connect to the server, use the HttpGetClientVirtualHost function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddVirtualHost](#httpaddvirtualhost-function)
- [HttpAddVirtualHostAlias](#httpaddvirtualhostalias-function)
- [HttpDeleteVirtualHost](#httpdeletevirtualhost-function)
- [HttpGetClientVirtualHost](#httpgetclientvirtualhost-function)
- [HttpGetVirtualHostId](#httpgetvirtualhostid-function)

---

## HttpIsClientAuthenticated Function

Determine if the specified client session has been authenticated

### Prototype

```c
BOOL WINAPI HttpIsClientAuthenticated(
    HSERVER hServer,
    UINT nClientId
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |

### Return Value

- **Type**: `BOOL`
- If the client session has been authenticated, this function will return a non-zero value, otherwise it will return zero. If the server handle and client ID are valid, this function will clear the last error code.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpAuthenticateClient](#httpauthenticateclient-function)
- [HttpGetClientCredentials](#httpgetclientcredentials-function)
- [HttpRequireAuthentication](#httprequireauthentication-function)

---

## HttpIsCommandEnabled Function

Determine if the specified command is currently enabled or disabled

### Prototype

```c
BOOL WINAPI HttpIsCommandEnabled(
    HSERVER hServer,
    LPCTSTR lpszCommand
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszCommand` | `LPCTSTR` | A pointer to a NULL terminated string that specifies the name of the command. The command name is not case-sensitive, but the value must otherwise match the exact command name. Partial matches are not recognized by this function. This parameter cannot be NULL. |

### Return Value

- **Type**: `BOOL`
- If the command is enabled, this function will return a non-zero value. If the command is disabled, the server handle is invalid or the command name does not match a supported command, this function will return zero.

### Remarks

- The HttpIsCommandEnabled function is used to determine whether a specific command is enabled. Typically this function is used in an event handler to make sure the command issued by a client is recognized by the server and enabled for use. Commands can be enabled and disabled using the HttpEnableCommand function.
- This function does not account for the permissions granted to a specific client session. Clients are assigned access rights when they are authenticated using the HttpAuthenticateClient function, and certain commands can be limited by the permissions granted to the client. For example, even if the PUT command is enabled, a client must have the HTTP_ACCESS_WRITE permission to use the command to upload a file to the server. For a list of access rights, see User Access Constants.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAuthenticateClient](#httpauthenticateclient-function)
- [HttpEnableCommand](#httpenablecommand-function)
- [HttpGetCommandName](#httpgetcommandname-function)

---

## HttpReceiveRequest Function

Receive the request that was sent by the client to the server

### Prototype

```c
BOOL WINAPI HttpReceiveRequest(
    HSERVER hServer,
    UINT nClientId,
    DWORD dwOptions,
    LPHTTPREQUEST lpRequest,
    LPVOID lpvBuffer,
    LPDWORD lpdwLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `dwOptions` | `DWORD` | An unsigned integer which specifies how the client request data will be stored. It may be one of the following values: |
| `lpRequest` | `LPHTTPREQUEST` | A pointer to a HTTPREQUEST structure which contains information about the request from the client. This parameter cannot be NULL. The structure that is passed to this function must have all members set to a value of zero except the dwSize member, which must be initialized to the size of the structure. |
| `lpvBuffer` | `LPVOID` | A pointer to the buffer that will contain any request data that was submitted by the client. The dwOptions parameter determines if this pointer references a block of memory, a null-terminated string buffer, a global memory handle or a file name. If this parameter is NULL, any data submitted by the client will not be copied. |
| `lpdwLength` | `LPDWORD` | A pointer to an unsigned integer that will contain the number of bytes of data submitted by the client when the function returns. If the lpvBuffer parameter specifies a memory or string buffer, this value must be initialized to the maximum size of the buffer before the function is called. If the lpvBuffer parameter points to a global memory handle, this value must be initialized to zero. If lpvBuffer is NULL or specifies a file name, this parameter may be NULL. |

### Options

- **dwOptions** Parameter

    - `HTTP_REQUEST_DEFAULT`: If the lpdwLength parameter points to a integer with a non-zero value, the lpvBuffer parameter is considered to be a pointer to a block of memory that has been allocated to store the request data. This is the same as specifying the HTTP_REQUEST_MEMORY option. If the lpdwLength parameter points to an integer with a value of zero, the lpvBuffer parameter is considered to be a pointer to an HGLOBAL memory handle. This is the same as specifying the HTTP_REQUEST_HGLOBAL option.
    - `HTTP_REQUEST_MEMORY`: The lpvBuffer parameter is a pointer to a block of memory that has been allocated to store the request data. The maximum number of bytes of data that can stored is determined by the value of the integer that the lpdwLength parameter points to. When the function returns, that value will updated with with actual number of bytes copied into the buffer.
    - `HTTP_REQUEST_STRING`: The lpvBuffer parameter is a pointer to a string buffer that has been allocated to store the request data. The maximum number of bytes of data that can be copied is determined by the value of the integer that the lpdwLength parameter points to. When the function returns, that value will updated with with actual number of bytes copied into the buffer. If the Unicode version of this function is called, the request data will be converted to a null-terminated Unicode string.
    - `HTTP_REQUEST_HGLOBAL`: The lpvBuffer parameter is a pointer to an HGLOBAL memory handle. When the function returns, the handle will reference a block of memory that contains the request data submitted by the client. The lpdwLength parameter will contain the number of bytes copied to the buffer.
    - `HTTP_REQUEST_FILE`: The lpvBuffer parameter is a pointer to a string which specifies the name of a file that will contain the request data. If the file does not exist, it will be created. If it does exist, the contents will be replaced. This option is typically used in conjunction with the PUT command. If the lpdwLength parameter is not NULL, the value it points to will be updated with the actual number of bytes stored in the file.
    - `HTTP_REQUEST_HANDLE`: The lpvBuffer parameter is a handle to an open file. This option is typically used in conjunction with the POST or PUT commands. If the lpdwLength parameter is not NULL, the value it points to will be updated with the actual number of bytes written to the file. If this option is specified, the request data will be written from the current position in the file and will advance the file pointer by the number of bytes received from the client.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetServerError.

### Remarks

- The HttpReceiveRequest function is called within a HTTP_CLIENT_COMMAND event handler to process the command issued by the client and return information about the request to the server application. It is only necessary for the application to call this function if it wants to implement its own custom handling for a command. It is recommended that most applications use the default command processing for standard commands such as GET and POST to ensure that the appropriate security checks are performed and the response conforms to the protocol standard.
- This function may only be called once per command issued by the client and the data referenced in the HTTPREQUEST structure only remains valid while the client is connected to the server. You should never attempt to directly modify the data referenced by any of the structure members. If you wish to store or modify any of the string values returned in the structure, you should allocate a buffer large enough to store the contents of the string, including the terminating null character, and copy the string into that buffer.
- If the HTTP_REQUEST_HGLOBAL option is used to return a copy of the request data in a global memory buffer, the HGLOBAL handle must be freed by the application when the data is no longer needed. Failure to free this handle will result in a memory leak.
- If the HTTP_REQUEST_HANDLE option is used to write a copy of the request data to an open file, the handle must reference a disk file that was opened or created using the CreateFile function with GENERIC_WRITE access. It cannot be a handle to a device or named pipe. If the function succeeds, the file pointer is advanced by the number of bytes of request data submitted by the client. If the function fails, the file pointer is returned to its original position prior to the function being called.

### Example

```cpp
// Initialize the HTTPREQUEST structure
HTTPREQUEST httpRequest;
ZeroMemory(&httpRequest, sizeof(httpRequest));
httpRequest.dwSize = sizeof(httpRequest);

// Return the data in a global memory buffer
HGLOBAL hgblBuffer = NULL;
DWORD dwLength = 0;

bSuccess = HttpReceiveRequest(hServer,
							nClientId,
							HTTP_REQUEST_HGLOBAL,
							&httpRequest,
							&hgblBuffer,
							&dwLength);

if (bSuccess && hgblBuffer != NULL)
{
	LPBYTE lpBuffer = (LPBYTE)GlobalLock(hgblBuffer);

	if (lpBuffer != NULL)
	{
		// Process dwLength bytes of data submitted by the client
	}

	GlobalUnlock(hgblBuffer);
	GlobalFree(hgblBuffer);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpSendResponse](#httpsendresponse-function)
- [HTTPREQUEST](#httprequest-function)

---

## HttpRedirectRequest Function

Redirect the request from the client to another URL

### Prototype

```c
BOOL WINAPI HttpRedirectRequest(
    HSERVER hServer,
    UINT nClientId,
    UINT nMethod,
    LPCTSTR lpszLocation
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `nMethod` | `UINT` | An integer value that specifies if the redirection is permanent or temporary. The following values may be used: |
| `lpszLocation` | `LPCTSTR` | A pointer to a string that specifies the new location for the requested resource. This value must be a complete URL, including the http:// or https:// scheme. This parameter cannot be NULL or point to zero-length string. |

### Options

- **nMethod** Parameter

    - `HTTP_REDIRECT_PERMANENT`: This value is used for permanent redirection, indicating that the client should update any record of the link with the new URL specified by the lpszLocation parameter. This result is cacheable and when the client makes subsequent requests for the resource, it should always use the new URL.
    - `HTTP_REDIRECT_TEMPORARY`: This value is used for temporary redirection, indicating that the client should issue a request for the resource using the new URL specified by the lpszLocation parameter, but subsequent requests should continue to use the original URL.
    - `HTTP_REDIRECT_OTHER`: This value is used for temporary redirection, however it instructs the client that it should use the GET command to request the redirected resource. This option is typically used to redirect a client after it has used the POST command.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetServerError.

### Remarks

- The HttpRedirectRequest function can be used within a HTTP_CLIENT_COMMAND event handler to redirect the client to a new location for the resource that it has requested. This redirection can be permanent or temporary, depending on whether the server expects the client to continue to use the original URL when requesting the resource.
- If the HTTP_REDIRECT_TEMPORARY method is used, the actual status code that is returned to the client depends on the version of the protocol that is being used. If the client has issued the request using HTTP 1.0 then the server will return a 302 code to the client. If the client used HTTP 1.1, the server will return a 307 code to the client that indicates it should use the same command verb (GET, POST, etc.) when requesting the resource at the new location.
- If the HTTP_REDIRECT_OTHER method is used, the status code that is returned to the client depends on which version of the protocol is being used. For clients who are using HTTP 1.0, the server will return a 302 code to the client just as with the HTTP_REDIRECT_TEMPORARY method. If the client is using HTTP 1.1, the server will return a 303 code to the client that indicates it should always use the GET command to request the new resource, regardless if a different command was originally used (POST, PUT, etc.)
- This function provides a simplified interface for sending a redirection status code that also implicitly sets the Location response header to the value of the lpszLocation parameter. If the server application needs to send alternate redirection codes such as 305 (Use Proxy) then it should use the HttpSendReponse function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpRequireAuthentication](#httprequireauthentication-function)
- [HttpSendErrorResponse](#httpsenderrorresponse-function)
- [HttpSendResponse](#httpsendresponse-function)

---

## HttpRegisterHandler Function

Register a CGI program for use and associate it with a file name extension

### Prototype

```c
BOOL WINAPI HttpRegisterHandler(
    HSERVER hServer,
    UINT nHostId,
    LPCTSTR lpszExtension,
    LPCTSTR lpszProgramFile,
    LPCTSTR lpszParameters,
    LPCTSTR lpszDirectory
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nHostId` | `UINT` | An unsigned integer that identifies the virtual host associated with the program. The value VIRTUAL_HOST_DEFAULT should be used for the default host that is created when the server is first started. |
| `lpszExtension` | `LPCTSTR` | A pointer to a string which specifies the file name extension that is associated with the CGI program. This parameter cannot be NULL. |
| `lpszProgramFile` | `LPCTSTR` | A pointer to a string that specifies the full path to the executable program. This parameter cannot be NULL. |
| `lpszParameters` | `LPCTSTR` | A pointer to a string that specifies additional parameters for the program. This value will be passed to the program as command line arguments. If the program does not require any command line parameters, this value may be NULL or point to an empty string. |
| `lpszDirectory` | `LPCTSTR` | A pointer to a string that specifies the current working directory for the program. If this parameter is NULL or points to an empty string, the server will use the root document directory for the virtual host. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetServerError.

### Remarks

- The HttpRegisterHandler function registers an executable CGI program and associates it with a file name extension. When the client issues a GET or POST command that specifies a file with that extension, the program will be executed and the output return to the client.
- The lpszProgramFile string specifies file name of the CGI program. You should not install any executable programs in the server root directory or its subdirectories. A client should never have the ability to directly access the executable file itself. It is permitted to have multiple file name extensions that reference the same program. The only requirement is that the extension be unique for the given host. The program name may contain environment variables surrounded by % symbols. For example, %ProgramFiles% would be expanded to the C:\Program Files folder.
- It is important to note that the program specified by lpszProgramFile must be an executable file, not a script or batch file. If the program name does not contain a directory path, then the standard Windows pathing rules will be used when searching for an executable file that matches the given name. It is recommended that you always provide a full path to the executable file.
- The lpszParameters string can specify additional command line parameters that should be passed to the CGI program as arguments. This string can also contain a placeholder named "%1" that will be replaced by the full path to the local script filename. If no placeholder is included in the parameters, or lpszParameters is a NULL pointer, the script file name will be passed to the program as its only argument.
- The executable program that is registered using this program must be a console application that conforms to the CGI/1.1 specification defined in RFC 3875. Request data submitted by the client as part of a POST will be provided to the program as standard input. The output from the program must be written to standard output. The first lines of output from the program should be any response headers, followed by an empty line. Each line should be terminated with a carriage-return and linefeed (CRLF) sequence. If the CGI program outputs additional data to be processed by the client, it should provide Content-Type and Content-Length response headers.
- The application can obtain a copy of the output from the command by calling the HttpGetProgramOutput function from within a HTTP_CLIENT_EXECUTE event handler.
- When developing a CGI program, it is important to take into consideration the environment that it will be executing in. The program will be started as a child process of the server application, and will inherit the same privileges. This means that it will typically have access to the boot drive, the Windows folders and the system registry. CGI programs must ensure that all query parameters and request data submitted by the client have been validated.
- If the server is running on a system with User Account Control (UAC) enabled and does not have elevated privileges, do not register a program that requires elevated privileges or has a manifest that specifies the requestedExecutionLevel as requiring administrative privileges.

### Example

```cpp
// Register a handler for VBScript
HttpRegisterHandler(hServer,
					VIRTUAL_HOST_DEFAULT,
					_T("vbs"),		
					_T("%SystemRoot%\\System32\\cscript.exe"),
					_T("/nologo /b \"%1\""),
					NULL);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetProgramExitCode](#httpgetprogramexitcode-function)
- [HttpGetProgramOutput](#httpgetprogramoutput-function)
- [HttpRegisterProgram](#httpregisterprogram-function)

---

## HttpRegisterProgram Function

Register a CGI program for use and associate it with a virtual path on the server

### Prototype

```c
BOOL WINAPI HttpRegisterProgram(
    HSERVER hServer,
    UINT nHostId,
    LPCTSTR lpszVirtualPath,
    LPCTSTR lpszProgramFile,
    LPCTSTR lpszParameters,
    LPCTSTR lpszDirectory
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nHostId` | `UINT` | An unsigned integer that identifies the virtual host associated with the program. The value VIRTUAL_HOST_DEFAULT should be used for the default host that is created when the server is first started. |
| `lpszVirtualPath` | `LPCTSTR` | A pointer to a string which specifies the virtual path to the CGI program. This must be an absolute path, but does not have to specify a pre-existing virtual path or map to the directory structure of the root document directory for the server. This parameter cannot be NULL. The maximum length of the virtual path is 1024 characters. |
| `lpszProgramFile` | `LPCTSTR` | A pointer to a string that specifies the full path to the executable program. This parameter cannot be NULL. |
| `lpszParameters` | `LPCTSTR` | A pointer to a string that specifies additional parameters for the program. This value will be passed to the program as command line arguments. If the program does not require any command line parameters, this value may be NULL or point to an empty string. |
| `lpszDirectory` | `LPCTSTR` | A pointer to a string that specifies the current working directory for the program. If this parameter is NULL or points to an empty string, the server will use the root document directory for the virtual host. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetServerError.

### Remarks

- The HttpRegisterProgram function registers an executable CGI program and associates it with a virtual path. When the client issues a GET or POST command specifying the virtual path associated with the program, the program will be executed and the output return to the client.
- The lpszProgramFile string specifies file name of the CGI program. You should not install any executable programs in the server root directory or its subdirectories. A client should never have the ability to directly access the executable file itself. It is permitted to have multiple virtual paths that reference the same executable file. The only requirement is that the virtual path be unique for the given host. The program name may contain environment variables surrounded by % symbols. For example, %ProgramFiles% would be expanded to the C:\Program Files folder.
- It is important to note that the program specified by lpszProgramFile must be an executable file, not a script or batch file. If the program name does not contain a directory path, then the standard Windows pathing rules will be used when searching for an executable file that matches the given name. It is recommended that you always provide a full path to the executable file.
- The lpszParameters string can specify additional command line parameters that should be passed to the CGI program as arguments. This string can also contain a placeholder named "%1" that will be replaced by the virtual path associated with the program. If lpszParameters is NULL or a zero-length string, then no additional parameters are passed to the program.
- The executable program that is registered using this program must be a console application that conforms to the CGI/1.1 specification defined in RFC 3875. Request data submitted by the client as part of a POST will be provided to the program as standard input. The output from the program must be written to standard output. The first lines of output from the program should be any response headers, followed by an empty line. Each line should be terminated with a carriage-return and linefeed (CRLF) sequence. If the CGI program outputs additional data to be processed by the client, it should provide Content-Type and Content-Length response headers.
- The application can obtain a copy of the output from the command by calling the HttpGetProgramOutput function from within a HTTP_CLIENT_EXECUTE event handler.
- When developing a CGI program, it is important to take into consideration the environment that it will be executing in. The program will be started as a child process of the server application, and will inherit the same privileges. This means that it will typically have access to the boot drive, the Windows folders and the system registry. CGI programs must ensure that all query parameters and request data submitted by the client have been validated.
- If the server is running on a system with User Account Control (UAC) enabled and does not have elevated privileges, do not register a program that requires elevated privileges or has a manifest that specifies the requestedExecutionLevel as requiring administrative privileges.

### Example

```cpp
HttpRegisterProgram(hServer,
					VIRTUAL_HOST_DEFAULT,
					HTTP_METHOD_DEFAULT,
					_T("/order/invoice"),		
					_T("%ProgramData%\\MyServer\\Programs\\invoice.exe"),
					NULL,
					NULL);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetProgramExitCode](#httpgetprogramexitcode-function)
- [HttpGetProgramOutput](#httpgetprogramoutput-function)
- [HttpRegisterHandler](#httpregisterhandler-function)

---

## HttpRenameServerLogFile Function

Rename or delete the current log file being updated by the server

### Prototype

```c
BOOL WINAPI HttpRenameServerLogFile(
    HSERVER hServer,
    LPCTSTR lpszFileName
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszFileName` | `LPCTSTR` | A pointer to a string that specifies the file name the current log file should be renamed to. If this parameter is NULL or an empty string, the current log file will be deleted. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle does not specify a valid server, the function will return zero. If logging is not currently enabled for the server, this function will return zero.

### Remarks

- The HttpRenameServerLogFile function is used to rename or delete the current log file. Note that this does not change the current log file name or disable logging by the server. It only changes the file name of the current log file, or removes the log file if the lpszFileName parameter is NULL. This can be useful if you want your server to perform log file rotation, archiving the current log file. By renaming the current log file, the server will automatically create a new log file with original file name.
- This function must be used to rename or delete the current log file while logging is active because the server holds an open handle on the file. The application should not use the HttpGetServerLogFile function to obtain the log file name and then use the MoveFileEx or DeleteFile functions with that file.
- To disable logging, use the HttpSetServerLogFile function and specify the logging format as HTTP_LOGFILE_NONE.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetServerLogFile](#httpgetserverlogfile-function)
- [HttpSetServerLogFile](#httpsetserverlogfile-function)

---

## HttpRequireAuthentication Function

Send a response to the client indicating that authentication is required

### Prototype

```c
BOOL WINAPI HttpRequireAuthentication(
    HSERVER hServer,
    UINT nClientId,
    UINT nAuthType,
    LPCTSTR lpszRealm
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `nAuthType` | `UINT` | An integer value that corresponds to a result code, informing the client if the redirection is permanent or temporary. The following values may be used: |
| `lpszRealm` | `LPCTSTR` | A pointer to a string that is displayed by a web browser to indicate to the user which username and password they should use. If this parameter is NULL or an empty string, the domain name the client used to establish the connection will be used. |

### Options

- **nAuthType** Parameter

    - `HTTP_AUTH_BASIC`: This option specifies the Basic authentication scheme should be used. This option is supported by all clients that support at least version 1.0 of the protocol.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetServerError.

### Remarks

- The HttpRequireAuthentication function can be used within a HTTP_CLIENT_COMMAND event handler to indicate to the client that it must provide a username and password to access the requested resource. The client should respond by issuing another request that includes the required credentials. To determine if a client has included credentials with its request, use the HttpIsClientAuthenticated function. The HttpGetClientCredentials function will return the username and password that was provided by the client.
- Some clients may require that the session be secure if authentication is requested or display warning messages to the user if the connection is not secure. It is recommended that you enable security using the HTTP_OPTION_SECURE option if your application will require clients to authenticate before accessing specific resources.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetClientCredentials](#httpgetclientcredentials-function)
- [HttpIsClientAuthenticated](#httpisclientauthenticated-function)
- [HttpSendResponse](#httpsendresponse-function)

---

## HttpSendErrorResponse Function

Send a customized error response to the specified client

### Prototype

```c
BOOL WINAPI HttpSendErrorResponse(
    HSERVER hServer,
    UINT nClientId,
    UINT nErrorCode,
    LPCTSTR lpszMessage
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `nErrorCode` | `UINT` | An integer value that specifies the error code that should be sent to the client. This value should correspond to the error result codes defined for HTTP in RFC 2616, which are three-digit values in the range of 400 through 599. The function will fail if an invalid error code is specified. |
| `lpszMessage` | `LPCTSTR` | A pointer to a string that describes the error. If this parameter is NULL or specifies a zero-length string, a default message will be selected based on the error code. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetServerError.

### Remarks

- The HttpSendErrorResponse function sends a response to the client indicating that an error has occurred, providing a numeric error code and HTML formatted text which may be displayed to the user. The lpszMessage parameter should provide a brief description of the error that will be included in the output sent to the client. Note that the message should not contain any special formatting control characters or HTML markup.
- This function provides a simplified interface for sending an error response to the client. In some cases, a browser may choose to display its own error message to the user in place of the generic HTML document generated by this function. If you want your application to send a customized HTML document for a specific type of error, you should use the HttpSendResponse function.
- If you wish to redirect the client to use an alternate URL to access the requested resource, it is recommended that you use the HttpRedirectRequest function rather than sending an error response.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpRedirectRequest](#httpredirectrequest-function)
- [HttpSendResponse](#httpsendresponse-function)

---

## HttpSendResponse Function

Send a response from the server to the specified client

### Prototype

```c
BOOL WINAPI HttpSendResponse(
    HSERVER hServer,
    UINT nClientId,
    DWORD dwOptions,
    LPHTTPRESPONSE lpResponse,
    LPVOID lpvBuffer,
    DWORD dwLength
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `dwOptions` | `DWORD` | An unsigned integer which specifies how the client request data will be copied. It may be one of the following values: |
| `lpResponse` | `LPHTTPRESPONSE` | A pointer to a HTTPRESPONSE structure which contains additional information about the response to the client. The structure that is passed by reference to this function must have the dwSize member initialized to the size of the structure or the function will fail. This parameter may be NULL, in which case a default response of "200 OK" is sent to the client along with any data specified by the lpvBuffer parameter. |
| `lpvBuffer` | `LPVOID` | A pointer to the buffer that will contain any response data that should be sent to the client. The dwOptions parameter determines if this pointer references a block of memory, a null-terminated string buffer, a global memory handle or a file name. This parameter may be NULL, in which case no data will be sent to the client. If this function is called in response to a HEAD command being sent by the client, this parameter is ignored. |
| `dwLength` | `DWORD` | An unsigned integer that specifies the number of bytes of data to be sent to the client. If the lpvBuffer parameter is NULL, this value must be zero. If this function is called in response to a HEAD command being sent by the client, this parameter is ignored. |

### Options

- **dwOptions** Parameter

    - `HTTP_RESPONSE_DEFAULT`: The lpvBuffer parameter is a pointer to a block of memory that contains the response data. The number of bytes of data that in the buffer is specified by the dwLength parameter. This is the same as specifying the HTTP_RESPONSE_MEMORY option.
    - `HTTP_RESPONSE_MEMORY`: The lpvBuffer parameter is a pointer to a block of memory that contains the response data. The number of bytes of data that in the buffer is specified by the dwLength parameter. The data will be sent to the client as a stream of bytes. If the server application was compiled using Unicode, it is responsibility of the application to convert any Unicode text to either ANSI or UTF-8, depending on the resource that was requested by the client.
    - `HTTP_RESPONSE_STRING`: The lpvBuffer parameter is a pointer to a string buffer that contains the response data. The maximum number of bytes of data that will be sent to the client is determined by the dwLength parameter. If the value of the dwLength parameter exceeds the string length, the value will be ignored and the contents of the string will be sent up to the terminating null character. If the Unicode version of this function is called, the string will be converted to a byte array before being sent to the client.
    - `HTTP_RESPONSE_HGLOBAL`: The lpvBuffer parameter is an HGLOBAL memory handle which references a block of memory that contains the response data. The number of bytes of data that in the buffer is specified by the dwLength parameter. The data will be sent to the client as a stream of bytes. It is the responsibility of the application to free the global memory handle after it is no longer needed.
    - `HTTP_RESPONSE_FILE`: The lpvBuffer parameter is a pointer to a string which specifies the name of a file that contains the response data. If the file does not exist, or does not specify a regular file, this function will fail. The dwLength parameter is ignored. If the content type for the specified file is not explicitly defined in the response, the function will attempt to automatically determine the correct type based on the file name extension and/or the contents of the file.
    - `HTTP_RESPONSE_HANDLE`: The lpvBuffer parameter is a handle to an open file and the dwLength parameter specifies the number of bytes to be read from the file and send to the client. If this option is specified, the response data will be read from the current position in the file and will advance the file pointer by the number of bytes sent to the client.
    - `HTTP_RESPONSE_DYNAMIC`: The response data will be generated dynamically. This prevents the content length from being included in the response header, and forces the connection to close, regardless if the client has requested to keep the connection open. This option must be specified if the application wishes to use the HttpSendResponseData function to send additional data to the client.
    - `HTTP_RESPONSE_NOCACHE`: Informs the client that the data being returned by the server should not be cached. Typically this is used in conjunction with the HTTP_RESPONSE_DYNAMIC option when the data is being generated dynamically.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetServerError.

### Remarks

- The HttpSendResponse function is called within a HTTP_CLIENT_COMMAND event handler to respond to the request made by the client. This function may only be called once after a command has been received, and must be called after the HttpReceiveRequest function. It is only necessary for the application to call this function if it wants to implement its own custom handling for a command. It is recommended that most applications use the default command processing for standard commands such as GET and POST to ensure that the appropriate security checks are performed and the response conforms to the protocol standard.
- If the HTTP_RESPONSE_HANDLE option is used to read a copy of the response data from an open file, the handle must reference a disk file that was opened using the CreateFile function with GENERIC_READ access. It cannot be a handle to a device or named pipe. If the dwLength parameter is larger than the total number of bytes available to be read from the current position in the file, the function will stop sending data to the client when it reaches the end-of-file. If the function succeeds, the file pointer is advanced by the number of bytes of response data sent to the the client. If the function fails, the file pointer is returned to its original position prior to the function being called.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpRecieveRequest](#httprecieverequest-function)
- [HttpSendResponseData](#httpsendresponsedata-function)
- [HTTPRESPONSE](#httpresponse-function)

---

## HttpSendResponseData Function

Send additional data to the client in response to a command

### Prototype

```c
INT WINAPI HttpSendResponseData(
    HSERVER hServer,
    UINT nClientId,
    LPBYTE lpBuffer,
    DWORD dwLength,
    LPDWORD lpdwResponse
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpBuffer` | `LPBYTE` | A pointer to a buffer that contains the response data that should be sent to the client. This parameter cannot be NULL and must point to a valid byte buffer. If the response contains non-ASCII text characters, it should be UTF-8 encoded. |
| `dwLength` | `DWORD` | An unsigned integer that specifies the size of the response data sent to the client. This value must be greater than zero and should never exceed the number of bytes stored in the buffer specified by the lpBuffer parameter. |
| `lpdwResponse` | `LPDWORD` | A pointer to an unsigned integer which will contain the total number of bytes successfully sent to the client in response to the request. This parameter may be NULL, in which case it is ignored. |

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the number of bytes of data sent to the client. If the function fails, the return value is HTTP_ERROR. To get extended error information, call HttpGetServerError.

### Remarks

- The HttpSendResponseData function is called within a HTTP_CLIENT_COMMAND event handler to send data to the client in response to a request. This function can only be used to send dynamically generated content after the HttpSendResponse function has been called. The HTTP_RESPONSE_DYNAMIC option must have been specified when responding to the client or this function will fail.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpRecieveRequest](#httprecieverequest-function)
- [HttpSendResponse](#httpsendresponse-function)
- [HTTPRESPONSE](#httpresponse-function)

---

## HttpServerAsyncNotify Function

Enable or disable asynchronous notification of changes in server status

### Prototype

```c
BOOL WINAPI HttpServerAsyncNotify(
    HSERVER hServer,
    HWND hWnd,
    UINT uMsg
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `hWnd` | `HWND` | A handle to the window whose window procedure will receive the notification message. |
| `uMsg` | `UINT` | The user-defined message that will be sent to the notification window. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call the HttpGetServerError function.

### Remarks

- The HttpServerAsyncNotify function is used by an application to enable or disable asynchronous notifications. The message window is typically the main UI window and these notifications are used signal to the application that it should update the user interface. If the hWnd parameter is not NULL, it must specify a valid window handle and the user-defined message must have a value of WM_USER or higher. The application cannot specify a notification message that is reserved by the operating system. The pseudo-handle HWND_BROADCAST cannot be specified as the notification window. If the hWnd parameter is NULL, notifications for the specified server will be disabled.
- When asynchronous notifications are enabled for a server, the server will post the user-defined message to the window whenever there is a change in status or after a client has connected or disconnected from the server. The wParam message parameter will contain the notification message and the lParam message parameter will contain the handle to the server or the client ID. The following notification messages are defined:
- If asynchronous notifications are enabled, you should never use those notifications as a replacement for an event handler. When an event occurs, the callback function that handles the event is invoked in the context of the thread that manages the client session. The application should exchange data with the client within that event handler and not in response to a notification message. These notification messages should only be used to update the application UI in response to changes in the status of the server.
- The HTTP_NOTIFY_CONNECT and HTTP_NOTIFY_DISCONNECT notifications are different from the other server notifications because the lParam message parameter does not specify the server handle, but rather the unique client ID associated with the session that connected to or disconnected from the server. Use the HttpGetClientServer function to obtain a handle to the server that created the client session. Note that at the time the application processes the HTTP_NOTIFY_DISCONNECT notification message, the client session will have already terminated.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpGetClientServer](#httpgetclientserver-function)
- [HttpServerStart](#httpserverstart-function)

---

## HttpServerDisableTrace Function

Disable logging of network function calls

### Prototype

```c
BOOL WINAPI HttpServerDisableTrace();
```

### Parameters

| Name | Type | Description |
|------|------|-------------|

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetServerError.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpServerEnableTrace](#httpserverenabletrace-function)

---

## HttpServerEnableTrace Function

Enable logging of network function calls to a file

### Prototype

```c
BOOL WINAPI HttpServerEnableTrace(
    LPCTSTR lpszTraceFile,
    DWORD dwTraceFlags
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszTraceFile` | `LPCTSTR` | A pointer to a string that specifies the name of the log file. If this parameter is NULL or points to an empty string, a log file is created in the temporary directory for the current user. |
| `dwTraceFlags` | `DWORD` | An unsigned integer that specifies one or more options. This parameter is constructed by using a bitwise operator with any of the following values: |

### Options

- **dwTraceFlags** Parameter

    - `TRACE_DEFAULT`: All function calls are written to the trace file. This is the default value.
    - `TRACE_ERROR`: Only those function calls which fail are recorded in the trace file.
    - `TRACE_WARNING`: Only those function calls which fail, or return values which indicate a warning, are recorded in the trace file.
    - `TRACE_HEXDUMP`: All functions calls are written to the trace file, plus all the data that is sent or received is displayed, in both ASCII and hexadecimal format.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetServerError.

### Remarks

- When trace logging is enabled, the log file is opened, appended to and closed for each socket function call. Using the same file name, you can do the same in your application to add additional information to the file if needed. This can provide an application-level context for the entries made by the library. Make sure that the file is closed after the data has been written. If a file name is not specified by the caller, a file named cstrace.log will be created in the temporary directory for the current user.
- The TRACE_HEXDUMP option can produce very large files, since all data that is being sent and received by the application is logged. To reduce the size of the file, you can enable and disable logging around limited sections of code that you wish to analyze.
- To redistribute an application that includes this debug logging functionality, the cstrcv11.dll library must be included as part of the installation package. This library provides the trace logging features, and if it is not available the HttpServerEnableTrace function will fail. Note that this is a standard Windows DLL and does not need to be registered, it only needs to be redistributed with your application.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpServerDisableTrace](#httpserverdisabletrace-function)

---

## HttpServerInitialize Function

Initialize the library and validate the specified license key at runtime

### Prototype

```c
BOOL WINAPI HttpServerInitialize(
    LPCTSTR lpszLicenseKey,
    LPINITDATA lpData
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszLicenseKey` | `LPCTSTR` | Pointer to a string that specifies the runtime license key to be validated. If this parameter is NULL, the library will validate the development license installed on the local system. |
| `lpData` | `LPINITDATA` | Pointer to an INITDATA data structure. This parameter may be NULL if the initialization data for the library is not required. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetServerError. All other functions will fail until a license key has been successfully validated.

### Remarks

- This must be the first function that an application calls before using any of the other functions in the library. When a NULL license key is specified, the library will only function on the development system. Before redistributing the application to an end-user, you must insure that this function is called with a valid license key.
- If the lpData argument is specified, it must point to an INITDATA structure which has been initialized by setting the dwSize member to the size of the structure. All other structure members should be set to zero. If the function is successful, then the INITDATA structure will be filled with identifying information about the library.
- Although it is only required that HttpServerInitialize be called once for the current process, it may be called multiple times; however, each call must be matched by a corresponding call to HttpServerUninitialize.
- This function dynamically loads other system libraries and allocates thread local storage. If you are calling the functions in this library from within another DLL, it is important that you do not call the HttpServerInitialize or HttpServerUninitialize functions from the DllMain function because it can result in deadlocks or access violation errors. If the DLL is linked with the C runtime library (CRT), it will automatically call the constructors and destructors for static and global C++ objects and has the same restrictions.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpServerStart](#httpserverstart-function)
- [HttpServerStop](#httpserverstop-function)
- [HttpServerUninitialize](#httpserveruninitialize-function)
- [INITDATA](#initdata-function)

---

## HttpServerProc Function

Callback function used to process server events

### Prototype

```c
VOID __cdecl HttpServerProc(
    HSERVER hServer,
    UINT nClientId,
    UINT nEventId,
    DWORD dwError,
    DWORD_PTR dwParam
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client that has issued a request to the server. |
| `nEventId` | `UINT` | An unsigned integer which specifies which event occurred. For a list of events, see Server Event Constants. |
| `dwError` | `DWORD` | An unsigned integer which specifies any error that occurred. If no error occurred, then this parameter will be zero. The HttpGetServerError function can be used to obtain additional information about the error code. |
| `dwParam` | `DWORD_PTR` | A user-defined integer value which was specified when the server was started. This value is guaranteed to be large enough to store a pointer or handle value on both 32-bit and 64-bit platforms. |

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- The HTTP_CLIENT_COMMAND event can be used to filter commands issued by the client. If the command performs an operation on a file or directory, the HttpGetCommandFile function can be used to obtain the file name on the server that the client specified. It is possible for the application to change the file name using the HttpSetCommandFile function to direct the server to use a different file than the one specified by the client. If the file name is changed and the event handler returns a value of zero, the server will perform the default action for the command using the new file name.
- The callback function will be called in the context of the thread that is currently managing the client session. You must ensure that any access to global or static variables are synchronized, otherwise the results may be unpredictable. It is recommended that you do not declare any static variables within the callback function itself.
- If the application has a graphical user interface, you should never attempt to directly modify a UI control from within an event handler. Controls should only be modified by the same UI thread that created their window. To change the user interface in response to a server event, use the HttpServerAsyncNotify function to enable asynchronous notifications and update the UI in response to the notification message.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpServerAsyncNotify](#httpserverasyncnotify-function)
- [HttpServerStart](#httpserverstart-function)

---

## HttpServerRestart Function

Restart the server, terminating all active client sessions

### Prototype

```c
HSERVER WINAPI HttpServerRestart(
    HSERVER hServer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |

### Return Value

- **Type**: `HSERVER`
- If the function succeeds, the return value is the new handle for the specified server. If the function fails, the return value is INVALID_SERVER. To get extended error information, call HttpGetServerError.

### Remarks

- The HttpServerRestart function will restart the specified server, terminating all active client sessions. The server handle that is returned by the function is the handle for the new server instance, and the old handle value is no longer valid. If the function is unable to restart the server for any reason, the server thread is terminated. The server retains all of the configuration parameters from the previous instance, however the statistical information (such as the number of clients, files transferred, etc.) will be reset.
- If an application calls this function from within an event handler, the active client session (the client for which the event handler was invoked) may not get a disconnect notification. It is recommended that this function only be called by the same thread that created the server using the HttpServerStart function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpServerStart](#httpserverstart-function)
- [HttpServerStop](#httpserverstop-function)

---

## HttpServerResume Function

Resume accepting client connections on the specified server

### Prototype

```c
BOOL WINAPI HttpServerResume(
    HSERVER hServer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | Handle to the server. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetServerError.

### Remarks

- The HttpServerResume function instructs the server to resume accepting new client connections after the HttpServerSuspend function has been called.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpServerRestart](#httpserverrestart-function)
- [HttpServerStart](#httpserverstart-function)
- [HttpServerStop](#httpserverstop-function)
- [HttpServerSuspend](#httpserversuspend-function)
- [HttpServerThrottle](#httpserverthrottle-function)

---

## HttpServerStart Function

Start the server and begin accepting client connections

### Prototype

```c
HSERVER WINAPI HttpServerStart(
    LPCTSTR lpszLocalHost,
    UINT nLocalPort,
    DWORD dwOptions,
    LPHTTPSERVERCONFIG lpServerConfig,
    HTTPSERVPROC lpServerProc,
    DWORD_PTR dwServerParam,
    LPSECURITYCREDENTIALS lpCredentials
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `lpszLocalHost` | `LPCTSTR` | A pointer to a string which specifies the local hostname or IP address address that the server should be bound to. If this parameter is NULL or an empty string, then an appropriate address will automatically be used. If a specific address is used, the server will only accept client connections on the network interface that is bound to that address. |
| `nLocalPort` | `UINT` | The port number the server should use to accept client connections. If a value of zero is specified, the server will use the standard port number 21 to listen for connections, or port 990 if the server is configured to use implicit TLS. The port number used by the application must be unique and multiple instances of a server cannot use the same port number. It is recommended that a port number greater than 5000 be used for private, application-specific implementations. |
| `dwOptions` | `DWORD` | An unsigned integer value that specifies the options used when creating an instance of the server. For a list of options, see Server Option Constants. |
| `lpServerConfig` | `LPHTTPSERVERCONFIG` | A pointer to an HTTPSERVERCONFIG structure that specifies the configuration options for the server. If this parameter is NULL, then default configuration parameters will be used that starts the server in a restrictive mode. |
| `lpServerProc` | `HTTPSERVPROC` | Specifies the address of the application defined callback function. For more information about the callback function, see the description of the HttpServerProc callback function. If this parameter is NULL, a default internal handler is used to process client commands. |
| `dwServerParam` | `DWORD_PTR` | A user-defined integer value that is passed to the callback function. If the lpServerProc parameter is NULL, this value should be zero. This value is guaranteed to be large enough to store a pointer or handle value on both 32-bit and 64-bit platforms. |
| `lpCredentials` | `LPSECURITYCREDENTIALS` | Pointer to a SECURITYCREDENTIALS structure. If this parameter is NULL, the default security credentials for the server host name will be used. If security is enabled for the server, it is recommended that you provide a pointer to this structure with specific information about the server certificate that should be used. If the security options are not specified in the server configuration, this parameter is ignored. |

### Return Value

- **Type**: `HSERVER`
- If the function succeeds, the return value is a handle to a server session. If the function fails, the return value is INVALID_SERVER. To get extended error information, call HttpGetServerError.

### Remarks

- In most cases, the lpszLocalHost parameter should be a NULL pointer or an empty string. On a multihomed system, this will enable the server to accept connections on any appropriately configured network adapter. Specifying a hostname or IP address will limit client connections to that particular address. Note that the hostname or address must be one that is assigned to the local system, otherwise an error will occur.
- If an IPv6 address is specified as the local address, the system must have an IPv6 stack installed and configured, otherwise the function will fail.
- To listen for connections on any suitable IPv4 interface, specify the special dotted-quad address "0.0.0.0". You can accept connections from clients using either IPv4 or IPv6 on the same socket by specifying the special IPv6 address "::0", however this is only supported on Windows 7 and Windows Server 2008 R2 or later platforms. If no local address is specified, then the server will only listen for connections from clients using IPv4. This behavior is by design for backwards compatibility with systems that do not have an IPv6 TCP/IP stack installed.
- The handle returned by this function references the listening socket that was created when the server was started. The service is managed in another thread, and all interaction with the server and active client connections are performed inside the event handler. To disconnect all active connections, close the listening socket and terminate the server thread, call the HttpServerStop function.
- The host UUID that is defined as part of the server configuration should be generated using the uuidgen utility that is included with the Windows SDK. You should not use the UUID that is provided in the example code, it is for demonstration purposes only. If no host UUID is specified in the server configuration, an ephemeral UUID will be generated automatically when the server is started.
- If the server is started with security enabled, the lpCredentials parameter should be used to provide the server certificate information in a SECURITYCREDENTIALS structure. If the pointer is NULL, this function will search for a certificate that matches the hostname provided as part of the server configuration. This requires that the server certificate be installed in the personal certificate store of the current process user, and it must have a private key associated with it. To use a certificate with a different name, or one that is stored in a PFX file, a SECURITYCREDENTIALS structure must be defined and passed to this function.

### Example

```cpp
HSERVER hServer;
HTTPSERVERCONFIG httpConfig;

// Initialize the server configuration
ZeroMemory(&httpConfig, sizeof(HTTPSERVERCONFIG));
httpConfig.dwSize = sizeof(httpConfig);
httpConfig.nMaxClients = 100;
httpConfig.nMaxClientsPerAdress = 8;
httpConfig.nMaxRequests = 5;
httpConfig.nLogFormat = HTTP_LOGFILE_EXTENDED;
httpConfig.nLogLevel = 5;
httpConfig.lpszIdentity = _T("MyProgram");
httpConfig.lpszHostName = _T("server.company.com");
httpConfig.lpszHostUuid = _T("10000000-1000-1000-1000-100000000000");
httpConfig.lpszDirectory = _T("%ProgramData%\\MyProgram\\Files");
httpConfig.lpszLogFile = _T("%ProgramData%\\MyProgram\\Server.log");

// Start the server
hServer = HttpServerStart(lpszLocalHost,
						HTTP_PORT_DEFAULT,
						HTTP_SERVER_DEFAULT,
						&httpConfig,
						lpEventHandler,
						0,
						NULL);
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpEnumServerClients](#httpenumserverclients-function)
- [HttpServerProc](#httpserverproc-function)
- [HttpServerRestart](#httpserverrestart-function)
- [HttpServerStop](#httpserverstop-function)
- [HTTPSERVERCONFIG](#httpserverconfig-function)
- [SECURITYCREDENTIALS](#securitycredentials-function)

---

## HttpServerStop Function

Stop the server and terminate all active client connections

### Prototype

```c
BOOL WINAPI HttpServerStop(
    HSERVER hServer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle is invalid, the function will return a value of zero.

### Remarks

- The HttpServerStop function instructs the server to stop accepting client connections, disconnects all active client connections and terminates the thread that is managing the server session. The handle is no longer valid after the server has been stopped and should no longer be used. Note that it is possible that the actual handle value may be re-used at a later point when a new server is started. An application should always consider the server handle to be opaque and never depend on it being a specific value.
- If an application calls this function from within an event handler, the active client session (the client for which the event handler was invoked) may not get a disconnect notification. It is recommended that this function only be called by the same thread that created the server using the HttpServerStart function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpServerRestart](#httpserverrestart-function)
- [HttpServerStart](#httpserverstart-function)

---

## HttpServerSuspend Function

Suspend accepting client connections on the specified server

### Prototype

```c
BOOL WINAPI HttpServerSuspend(
    HSERVER hServer
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | Handle to the server. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetServerError.

### Remarks

- The HttpServerSuspend function instructs the server to suspend accepting new client connections. Any incoming client connections will be rejected with an error message indicating that the server is currently unavailable. To resume accepting client connections, call the HttpServerResume function. Suspending the server will have no effect on clients that have already established a connection with the server.
- It is recommended that you only suspend a server if absolutely necessary, and only for brief periods of time. If you want to limit the number of active client connections or control the connection rate for clients, use the HttpServerThrottle function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpServerRestart](#httpserverrestart-function)
- [HttpServerResume](#httpserverresume-function)
- [HttpServerStart](#httpserverstart-function)
- [HttpServerStop](#httpserverstop-function)
- [HttpServerThrottle](#httpserverthrottle-function)

---

## HttpServerThrottle Function

Limit the number of active client connections, connections per address and connection rate

### Prototype

```c
BOOL WINAPI HttpServerThrottle(
    HSERVER hServer,
    UINT nMaxClients,
    UINT nMaxClientsPerAddress,
    DWORD dwConnectionRate
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | Handle to the server. |
| `nMaxClients` | `UINT` | A value which specifies the maximum number of clients that may connect to the server. A value of zero specifies that there is no fixed limit to the number of client connections. |
| `nMaxClientsPerAddress` | `UINT` | A value which specifies the maximum number of clients that may connect to the server from the same IP address. A value of zero specifies that there is no fixed limit to the number of client connections per address. By default, there is a limit of four client connections per address. |
| `dwConnectionRate` | `DWORD` | A value which specifies a restriction on the rate of client connections, limiting the number of connections that will be accepted within that period of time. A value of zero specifies that there is no restriction on the rate of client connections. The higher this value, the fewer the number of connections that will be accepted within a specific period of time. By default, there is no limit on the client connection rate. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetServerError.

### Remarks

- The HttpServerThrottle function is used to limit the number of connections and the connection rate to minimize the potential impact of a large number of client connections over a short period of time. This can be used to protect the server from a client application that is malfunctioning or a deliberate denial-of-service attack in which the attacker attempts to flood the server with connection attempts.
- If the maximum number of client connections or maximum number of connections per address is exceeded, the server will reject subsequent connection attempts until the number of active client sessions drops below the specified threshold. Note that adjusting these values lower than the current connection limits will not affect clients that have already connected to the server. For example, if the HttpServerStart function is called with the maximum number of clients set to 100, and then HttpServerThrottle is called lowering that value to 75, no existing client connections will be affected by the change. However, the server will not accept any new connections until the number of active clients drops below 75.
- Increasing the connection rate value will force the server to slow down the rate at which it will accept incoming client connection requests. For example, setting this parameter to a value of 1000 would limit the server to accepting one client connection every second, while a value of 250 would allow the server to accept four client connections per second. Note that significantly increasing the amount of time the server must wait to accept client connections can exceed the connection backlog queue, resulting in client connections being rejected.
- It is recommended that you always specify conservative connection limits for your server application based on expected usage. Allowing an unlimited number of client connections can potentially expose the system to denial-of-service attacks and should never be done for servers that are accessible over the Internet.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpServerRestart](#httpserverrestart-function)
- [HttpServerResume](#httpserverresume-function)
- [HttpServerStart](#httpserverstart-function)
- [HttpServerSuspend](#httpserversuspend-function)

---

## HttpServerUninitialize Function

Terminate use of the library by the application

### Prototype

```c
VOID WINAPI HttpServerUninitialize();
```

### Parameters

| Name | Type | Description |
|------|------|-------------|

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- An application is required to perform a successful HttpServerInitialize call before it can call any of the other library functions. When it has completed the use of library, the application must call HttpServerUninitialize to allow the library to free any resources allocated on behalf of the process. Any pending blocking or asynchronous calls in this process are canceled without posting any notification messages, and all sockets that were opened by the process are closed.
- There must be a call to HttpServerUninitialize for every successful call to HttpServerInitialize made by a process. Operations for all threads in the server are terminated.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpServerInitialize](#httpserverinitialize-function)
- [HttpServerStart](#httpserverstart-function)
- [HttpServerStop](#httpserverstop-function)

---

## HttpSetClientAccess Function

Change the access rights associated with the specified client session

### Prototype

```c
BOOL WINAPI HttpSetClientAccess(
    HSERVER hServer,
    UINT nClientId,
    DWORD dwUserAccess
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `dwUserAccess` | `DWORD` | An unsigned integer which specifies one or more user access rights. For a list of user access rights that can be granted to the client, see User and File Access Constants. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero. This function can only be used with authenticated clients. If the client session has not been authenticated, the return value will be zero.

### Remarks

- The HttpSetClientAccess function can change the multiple access rights for a client session. The HttpEnableClientAccess function can be used to grant or revoke a specific permission for the client session.
- If the dwUserAccess parameter has a value of HTTP_ACCESS_DEFAULT, then default permissions will be granted to the client session based on the configuration of the server. This is the recommended value for most clients. It is important to consider the implications of changing the access permissions granted to a client session. For example, if you do not grant clients HTTP_ACCESS_READ permission, it can effectively disable the site because the server will return 403 Forbidden errors for all GET and HEAD requests.
- This function should typically be called in the HTTP_CLIENT_CONNECT event handler to assign general permissions to the client, or in the HTTP_CLIENT_COMMAND event handler after the client has issued a request and provided any authentication credentials that are required.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpAuthenticateClient](#httpauthenticateclient-function)
- [HttpEnableClientAccess](#httpenableclientaccess-function)
- [HttpGetClientAccess](#httpgetclientaccess-function)

---

## HttpSetClientHeader Function

Create or change the value of a request or response header for the client session

### Prototype

```c
BOOL WINAPI HttpSetClientHeader(
    HSERVER hServer,
    UINT nClientId,
    UINT nHeaderType,
    LPCTSTR lpszHeaderName,
    LPCTSTR lpszHeaderValue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `nHeaderType` | `UINT` | Specifies the type of header to create or modify. It may be one of the following values: |
| `lpszHeaderName` | `LPCTSTR` | A pointer to a string that specifies the name of the header that should be created or modified. Header names are not case-sensitive and should not include the colon which acts as a delimiter that separates the header name from its value. This parameter cannot be a NULL pointer or an empty string. |
| `lpszHeaderValue` | `LPCTSTR` | A pointer to a string that specifies the new value of the header. If this parameter is a NULL pointer or an empty string, it has the same effect as deleting the header value from the list of request or response headers. |

### Options

- **nHeaderType** Parameter

    - `HTTP_HEADERS_REQUEST`: Change a request header that was provided by the client. Request header values provide additional information to the server about the type of request being made.
    - `HTTP_HEADERS_RESPONSE`: Change a response header that was created by the server. Response header values provide additional information to the client about the type of information that is being returned by the server.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero. If the function fails, the HttpGetServerError function will return more information about the last error that has occurred.

### Remarks

- The HttpSetClientHeader function will change the value of a request or response header for the specified client session. If the lpszHeaderName value matches an existing header field, its value will be replaced. If the header name is not defined, then a new header will be created with the given value. You should not change the value of most standard response header values unless you are certain of the impact that it would have on the normal operation of the client.
- If you wish to define a custom header value that would be included in the response to a client request, you should prefix the header name with "X-" to avoid potential conflicts with the standard response headers. For example, if you wanted to identify a customer, you could create a header field with the name "X-Customer-ID" and set the value to the customer ID number. The client application would receive this custom header value as part of the response to its request for a document.
- Refer to Hypertext Transfer Protocol Headers for a list of common request and response headers that are used.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpDeleteClientHeader](#httpdeleteclientheader-function)
- [HttpGetClientHeader](#httpgetclientheader-function)

---

## HttpSetClientIdleTime Function

Change the idle timeout period for the specified client session

### Prototype

```c
UINT WINAPI HttpSetClientIdleTime(
    HSERVER hServer,
    UINT nClientId,
    UINT nTimeout
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `nTimeout` | `UINT` | An unsigned integer value that specifies the number of seconds that the client may remain idle. If this value is zero, the default idle timeout period for the server will be used. |

### Return Value

- **Type**: `UINT`
- If the function succeeds, the return value is the previous client idle timeout period in seconds. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- The HttpSetClientIdleTime function is will change the number of seconds that the client may remain idle before being automatically disconnected by the server. The minimum timeout period for a client is 10 seconds, the maximum is 300 seconds (5 minutes). The idle time of a client session is based on the last time a command was issued to the server or when a data transfer completed.
- If the value INFINITE is specified as the timeout period, the client activity timer will be refreshed, extending the idle timeout period for the session. This is typically done inside an event handler to prevent the client from being disconnected due to inactivity.
- To obtain the current idle timeout period for a client, along with the amount of time the client has been idle, use the HttpGetClientIdleTime function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpGetClientIdleTime](#httpgetclientidletime-function)

---

## HttpSetClientVariable Function

Create or change the value of a CGI environment variable for the specified client

### Prototype

```c
BOOL WINAPI HttpSetClientVariable(
    HSERVER hServer,
    UINT nClientId,
    LPCTSTR lpszName,
    LPCTSTR lpszValue
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszName` | `LPCTSTR` | A pointer to a string that specifies the name of the environment variable that should be created or modified. Environment variables are not case-sensitive and should not include the equal sign which acts as a delimiter that separates the variable name from its value. This parameter cannot be a NULL pointer or an empty string. |
| `lpszValue` | `LPCTSTR` | A pointer to a string that specifies the new value of the environment variable. If this parameter is a NULL pointer or an empty string, it has the same effect as deleting the variable from the environment block for the client session. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero. If the function fails, the HttpGetServerError function will return more information about the last error that has occurred.

### Remarks

- The HttpSetClientVariable function will change the value of a environment variable for the specified client session. If the lpszName value matches an existing variable, its value will be replaced. If the variable is not defined, then a new variable will be created with the given value. The value of an environment variable can be obtained using the HttpGetClientVariable function.
- The server will automatically create a number of different environment variables that will be passed to a program or script executed by the server. These variables are defined in RFC 3875 as part of the Common Gateway Interface (CGI) 1.1 specification. The following variables are defined by the server and should not be modified directly by the application:

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetClientVariable](#httpgetclientvariable-function)

---

## HttpSetCommandFile Function

Change the name of the local file or directory that is the target of the current command

### Prototype

```c
BOOL WINAPI HttpSetCommandFile(
    HSERVER hServer,
    UINT nClientId,
    LPCTSTR lpszFileName
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. |
| `lpszFileName` | `LPCTSTR` | A pointer to a string that specifies the new file name. This parameter may be NULL to specify that the original file or directory name should be used. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle and client ID do not specify a valid client session, the function will return zero.

### Remarks

- The HttpSetCommandFile function is used by the application to change the target file or directory name for the current command from within an HTTP_EVENT_COMMAND event handler. This can be used to effectively redirect the client to use a different file than the one that was actually requested. For example, if the client issues the GET command to download a file from the server, this function can be used to redirect the command to use a different file name. To obtain the full path to the file or directory that is the target of the current command, use the HttpGetCommandFile function.
- The lpszFileName parameter specifies the path to the new file or directory name. If the path is absolute, then it will be used as-is. If the path is relative, it will be relative to the root directory for the client session. Because the root document directory for the client can depend on the hostname that the client used when connecting to the server, it is recommended that you always use an absolute path. The full path to this file is not limited to the server root directory or its subdirectory, it can specify a file anywhere on the local system. If this parameter is a NULL pointer, or points to an empty string, then the server will revert to using the actual file or directory name specified by the command. This enables the application to effectively undo a previous call to this function to change the target file name.
- Typically this function would be used to redirect a client to a file or directory that it may not normally have access to. Exercise caution when using this function to provide access to data that is stored outside of the server root directory. Incorrect use of this function could expose the server to security risks or cause unpredictable behavior by client applications. In most cases it is preferable to use the HttpAddVirtualPath function to create a virtual path or file name on the server, or the HttpRedirectRequest function to request the client use a different URL to access the resource.
- This function should only be called within the context of the HTTP_EVENT_COMMAND event, and only for those commands that perform an action on a file or directory. If the current command does not target a file or directory, this function will return zero and the last error code will be set to ST_ERROR_INVALID_COMMAND.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpAddVirtualPath](#httpaddvirtualpath-function)
- [HttpGetCommandFile](#httpgetcommandfile-function)
- [HttpReceiveRequest](#httpreceiverequest-function)
- [HttpRedirectRequest](#httpredirectrequest-function)
- [HttpSendResponse](#httpsendresponse-function)

---

## HttpSetServerError Function

Set the last error code for the specified server session

### Prototype

```c
VOID WINAPI HttpSetServerError(
    HSERVER hServer,
    DWORD dwError
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `dwError` | `DWORD` | An unsigned integer that specifies an error code. |

### Return Value

- **Type**: `VOID`
- None.

### Remarks

- Error codes are unsigned 32-bit values which are private to each server session. Most functions will set the last error code value when they fail; a few functions set it when they succeed. Function failure is typically indicated by a return value such as FALSE, NULL, INVALID_SERVER or HTTP_ERROR.
- If the hServer parameter is specified as INVALID_SERVER, this function will set the last error code for the current thread, but will not change the error code associated with any server session. This should only be done if the application does not have access to a valid server handle.
- If the dwError parameter is specified with a value of zero, this effectively clears the error code for the last function that failed. Those functions which clear the last error code when they succeed are noted on the function reference page.
- Applications can retrieve the value saved by this function by using the HttpGetServerError function to determine the specific reason for a function failure.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpGetCommandResult](#httpgetcommandresult-function)
- [HttpGetServerError](#httpgetservererror-function)
- [HttpSendResponse](#httpsendresponse-function)

---

## HttpSetServerIdentity Function

Change the identity and version information for the specified server

### Prototype

```c
BOOL WINAPI HttpSetServerIdentity(
    HSERVER hServer,
    LPCTSTR lpszIdentity
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `lpszIdentity` | `LPCTSTR` | A pointer to a string that identifies the server. If this parameter is NULL or specifies an empty string, the current identity for the server is reset to a default value. The maximum length of the identity string is 64 characters, including the terminating null character. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle is invalid, the function will return a value of zero.

### Remarks

- The HttpSetClientIdentity function changes a string value used by the server to identify itself to clients. The identity string does not have any standard format and is used for informational purposes only. Typically it consists of the application name and a version number. Changing the server identity has no effect on the operation of the server. To obtain the identity string currently associated with the server, use the HttpGetServerIdentity function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetServerIdentity](#httpgetserveridentity-function)

---

## HttpSetServerLogFile Function

Change the current log format, level of detail and file name

### Prototype

```c
BOOL WINAPI HttpSetServerLogFile(
    HSERVER hServer,
    UINT nLogFormat,
    UINT nLogLevel,
    LPCTSTR lpszFileName
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nLogFormat` | `UINT` | An integer value that specifies the format used when creating or updating the server log file. The following formats are supported: |
| `nLogLevel` | `UINT` | An integer value that specifies the level of detail that should generated in the log file. The minimum value is 1 and the maximum value is 10. If this parameter is zero, it is the same as specifying a log file format of HTTP_LOGFILE_NONE and will disable logging by the server. |
| `lpszFileName` | `LPCTSTR` | A pointer to a string that specifies the name of the log file that should be created or appended to. If the server was configured with logging enabled and this parameter is NULL or an empty string, the current log file name will not be changed. If the log file does not exist, it will be created. If it does exist, the contents of the log file will be appended to. |

### Options

- **nLogFormat** Parameter

    - `HTTP_LOGFILE_NONE`: This value specifies that the server should not create or update a log file.
    - `HTTP_LOGFILE_COMMON`: This value specifies that the log file should use the common log format that records a subset of information in a fixed format. This log format usually only provides information about GET, PUT and POST requests.
    - `HTTP_LOGFILE_COMBINED`: This value specifies that the server should use the combined log file format. This format is similar to the common format, however it includes the client referrer and user agent. This is the format that most Apache web servers use by default.
    - `HTTP_LOGFILE_EXTENDED`: This value specifies that the log file should use the standard W3C extended log file format. This is an extensible format that can provide additional information about the client session. This format typically generates the largest logfiles.

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the server handle does not specify a valid server, the function will return zero.

### Remarks

- The HttpSetServerLogFile function can be used to change the current log file name, the format of the log file or the level of detail recorded in the log file. In some situations it may be desirable to delete the current log file contents when changing the format or ensure that a new log file is created. To do this, combine the nLogFormat parameter with the constant HTTP_LOGFILE_DELETE.
- The higher the value of the nLogLevel parameter, the greater the level of detail that is recorded by the server. A log level of 1 instructs the server to only record GET, POST and PUT requests, while a level of 10 instructs the server to record all commands processed by the server. Because a higher level of logging detail can negatively impact the performance of the server, it is recommended that you do not exceed a level of 5 for most applications. A log level of 10 should only be used for debugging purposes.

### Example

```cpp
UINT nLogFormat = HTTP_LOGFILE_NONE;
UINT nLogLevel = 0;
UINT nNewLevel = 5;
BOOL bChanged = FALSE;

// Change the level of detail for the current log file if logging
// has been enabled and the current level is a lower value

if (HttpGetServerLogFile(hServer, &nLogFormat, &nLogLevel, NULL, 0))
{
	if (nLogFormat != HTTP_LOGFILE_NONE && nLogLevel < nNewLevel)
		bChanged = HttpSetServerLogFile(hServer, nLogFormat, nNewLevel, NULL);
}
```

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetServerLogFile](#httpgetserverlogfile-function)
- [HttpRenameServerLogFile](#httprenameserverlogfile-function)

---

## HttpSetServerName Function

Change the hostname assigned to the specified server or client session

### Prototype

```c
BOOL WINAPI HttpSetServerName(
    HSERVER hServer,
    UINT nClientId,
    LPCTSTR lpszHostName
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nClientId` | `UINT` | An unsigned integer which uniquely identifies the client session. This value may be zero. |
| `lpszHostName` | `LPCTSTR` | A pointer to a string that specifies the new host name assigned to the server or client session. If this value is NULL or points to an empty string, the current host name will be changed to use the default host name. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If either the server handle or the client ID is invalid, or the buffer is not large enough to store the complete hostname, the function will return a value of zero.

### Remarks

- This function will change the host name assigned to the specified client session. If the nClientId parameter has a value of zero, the function will change default host name that was assigned to the server as part of the server configuration. If the nClientId parameter specifies a valid client session and the lpszHostName parameter is NULL, the host name associated with the client session will be changed to the current host name assigned to the server.
- When a client connects to the server, it can specify the host name that it used to establish the connection by sending the HOST command. This is typically used with virtual hosting, where one server may accept client connections for multiple domains. The HttpGetServerName function will return the host name specified by the client, and HttpSetServerName can be used by the application to either explicitly assign a different host name to the client session, or override the host name provided by the client.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetServerAddress](#httpgetserveraddress-function)
- [HttpGetServerName](#httpgetservername-function)

---

## HttpSetServerPriority Function

Change the priority assigned to the specified server

### Prototype

```c
INT WINAPI HttpSetServerPriority(
    HSERVER hServer,
    INT nPriority
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `HSERVER` | The server handle. |
| `nPriority` | `INT` | An integer value which specifies the new priority for the server. It may be one of the following values: |

### Options

- **nPriority** Parameter

    - `HTTP_PRIORITY_BACKGROUND`: This priority significantly reduces the memory, processor and network resource utilization for the server. It is typically used with lightweight services running in the background that are designed for few client connections. The server thread will be assigned a lower scheduling priority and will be frequently forced to yield execution to other threads.
    - `HTTP_PRIORITY_LOW`: This priority lowers the overall resource utilization for the server and meters the processor utilization for the server thread. The server thread will be assigned a lower scheduling priority and will occasionally be forced to yield execution to other threads.
    - `HTTP_PRIORITY_NORMAL`: The default priority which balances resource and processor utilization. This is the priority that is initially assigned to the server when it is started, and it is recommended that most applications use this priority.
    - `HTTP_PRIORITY_HIGH`: This priority increases the overall resource utilization for the server and the thread will be given higher scheduling priority. It is not recommended that this priority be used on a system with a single processor.
    - `HTTP_PRIORITY_CRITICAL`: This priority can significantly increase processor, memory and network utilization. The server thread will be given higher scheduling priority and will be more responsive to client connection requests. It is not recommended that this priority be used on a system with a single processor.

### Return Value

- **Type**: `INT`
- If the function succeeds, the return value is the previous priority assigned to the server. If the function fails, the return value is HTTP_PRIORITY_INVALID. To get extended error information, call HttpGetServerError.

### Remarks

- The HttpSetServerPriority function can be used to change the current priority assigned to the specified server. Client connections that are accepted after this function is called will inherit the new priority as their default priority. Previously existing client connections will not be affected by this function.
- Higher priority values increase the thread priority and processor utilization for each client session. You should only change the server priority if you understand the impact it will have on the system and have thoroughly tested your application. Configuring the server to run with a higher priority can have a negative effect on the performance of other programs running on the system.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpGetServerPriority](#httpgetserverpriority-function)
- [HttpServerStart](#httpserverstart-function)

---

## HttpSetServerStackSize Function

Change the initial size of the stack allocated for threads created by the server.

### Prototype

```c
BOOL WINAPI HttpSetServerStackSize(
    SOCKET hServer,
    DWORD dwStackSize
);
```

### Parameters

| Name | Type | Description |
|------|------|-------------|
| `hServer` | `SOCKET` | Handle to the server socket. |
| `dwStackSize` | `DWORD` | The amount of memory that will be committed to the stack for each thread created by the server. If this value is zero, a default stack size will be used. |

### Return Value

- **Type**: `BOOL`
- If the function succeeds, the return value is non-zero. If the function fails, the return value is zero. To get extended error information, call HttpGetServerError.

### Remarks

- The HttpSetServerStackSize function changes the initial amount of memory that is committed to the stack for each thread created by the server. By default, the stack size for each thread is set to 256K for 32-bit processes and 512K for 64-bit processes. Increasing or decreasing the stack size will only affect new threads that are created by the server, it will not affect those threads that have already been created to manage active client sessions. It is recommended that most applications use the default stack size.
- You should not change the stack size unless you understand the impact that it will have on your system and have thoroughly tested your application. Increasing the initial commit size of the stack will remove pages from the total system commit limit, and every page of memory that is reserved for stack cannot be used for any other purpose.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Library: `cshtsv11.lib`

### See Also

- [HttpGetServerMemoryUsage](#httpgetservermemoryusage-function)
- [HttpGetServerStackSize](#httpgetserverstacksize-function)
- [HttpServerStart](#httpserverstart-function)

---

## HTTPCLIENTCREDENTIALS Structure

The HTTPCLIENTCREDENTIALS structure defines the credentials used to authenticate a specific user.

### Definition

```c
typedef struct _HTTPCLIENTCREDENTIALS
{
    DWORD dwSize;
    DWORD dwFlags;
    UINT nAuthType;
    UINT nHostPort;
} HTTPCLIENTCREDENTIALS, *LPHTTPCLIENTCREDENTIALS;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | An unsigned integer value that specifies the size of the structure. |
| `dwFlags` | `DWORD` | An unsigned integer value is reserved for future use. This value will always be zero. |
| `nAuthType` | `UINT` | An unsigned integer value that identifies the authentication method. |
| `nHostPort` | `UINT` | The server port number. |

### Remarks

- When an instance of this structure is passed to the HttpGetClientCredentials function, this member must be initialized to the size of the structure and all other members must be initialized with a value of zero.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

### See Also

- [HttpGetClientCredentials](#httpgetclientcredentials-structure)

---

## HTTPREQUEST Structure

The HTTPREQUEST structure provides information about the request made by the client.

### Definition

```c
typedef struct _HTTPREQUEST
{
    DWORD dwSize;
    DWORD dwFlags;
    DWORD dwVersion;
    DWORD dwAccess;
    DWORD dwLength;
    DWORD dwReserved;
    UINT nHostId;
    UINT nHostPort;
    LPCSTR lpszCommand;
    LPCSTR lpszHostName;
    LPCSTR lpszUserName;
    LPCSTR lpszPassword;
    LPCSTR lpszResource;
    LPCSTR lpszParameters;
    LPCSTR lpszDirectory;
    LPCSTR lpszPathInfo;
    LPCSTR lpszProgram;
    LPCSTR lpszScriptFile;
    LPCSTR lpszLocalFile;
    LPCSTR lpszMediaType;
} HTTPREQUEST, *LPHTTPREQUEST;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | An unsigned integer value that specifies the size of the structure. |
| `dwFlags` | `DWORD` | An unsigned integer value that provides additional information about the request. It may be one or more of the following values: |
| `dwVersion` | `DWORD` | An unsigned integer value that specifies the protocol version used. It may be one of the following values: |
| `dwAccess` | `DWORD` | An unsigned integer value that specifies the access permissions that were assigned to the resource. For a list of file access permissions, see User and File Access Constants . |
| `dwLength` | `DWORD` | An unsigned integer value that will specify the number of bytes of request data provided by the client. If the client did not submit any data with the request, this member will have a value of zero. |
| `dwReserved` | `DWORD` | An unsigned integer value that is reserved for future use. |
| `nHostId` | `UINT` | An integer value that identifies the virtual host that was specified by the client. This is based on the value of the Host request header included in the request. This value will be zero if a host name is not specified by the client, or does not match one of the virtual hosts that have been created. |
| `nHostPort` | `UINT` | An integer value that specifies the port number that the client used to establish the connection. This will be the same port number that was used when starting the server. |
| `lpszCommand` | `LPCSTR` | A pointer to a string that specifies the command that was issued by the client. The command will always be in upper case. Refer to Hypertext Transfer Protocol Commands for a list of standard commands. |
| `lpszHostName` | `LPCSTR` | A pointer to a string that identifies the hostname or IP address that the client used to establish the connection. This will typically correspond to the hostname assigned to the server, or to one of the virtual hosts that have been created. |
| `lpszUserName` | `LPCSTR` | A pointer to a string that specifies the username provided with the request. This member is only set if the client has included authentication credentials as part of the request. If the client has not provided any credentials, this member will be NULL. |
| `lpszPassword` | `LPCSTR` | A pointer to a string that specifies the password provided with the request. This member is only set if the client has included authentication credentials as part of the request. If the client has not provided any credentials, this member will be NULL. |
| `lpszResource` | `LPCSTR` | A pointer to a string that specifies the URL path provided by the client. |
| `lpszParameters` | `LPCSTR` | A pointer to a string that specifies any query parameters that were included in the request made by the client. If the URL did not include any query parameters, this member will be NULL. |
| `lpszDirectory` | `LPCSTR` | A pointer to a string the specifies the full path to the root directory for the virtual host. |
| `lpszPathInfo` | `LPCSTR` | A pointer to a string that specifies additional path information provided by the client when referencing an executable CGI program or script in the URL. For example, if a program is mapped to the virtual path "/orders/invoice" and the client requests "/orders/invoice/pdf/10001" this member will be the string "/pdf/10001". If there is no path information associated with the request, this member will be NULL. |
| `lpszProgram` | `LPCSTR` | A pointer to a string that specifies the local path to the CGI program that should be executed to process the request made by the client. If this member is NULL, it indicates that the client has provided a URL that maps to a local file or directory. |
| `lpszScriptFile` | `LPCSTR` | A pointer to a string that specifies the local path to the script file that will be executed by the handler. If this member is NULL, it indicates that the request URL was not mapped to registered script handler. |
| `lpszLocalFile` | `LPCSTR` | A pointer to a string that specifies the local path to the directory or file name referenced by the URL. If the lpszPathInfo member is not NULL, then this member will point to a local file name based the path information appended to the root directory for the virtual host. |
| `lpszMediaType` | `LPCSTR` | A pointer to a string that identifies the request data using the standard Internet media types defined in RFC 2046. It is used to designate the format for various types of content and has two parts, a primary and secondary media type separated by a forward slash. Common examples are "text/plain", "text/html" and "application/octet-stream". If the client did not submit any data with the request, this member will be NULL. |

### Remarks

- This structure is used with the HttpReceiveRequest function and all members should be initialized to a value of zero, except for the dwSize member which should be initialized to size of the structure. Failure to properly initialize the structure will cause the function call to fail.
- The value of the lpszLocalFile member depends on whether the client has requested a static document, or if the URL is mapped to a registered program or script handler. If the request is for a static document, then the dwFlags member will not have the HTTP_REQUEST_FLAG_PROGRAM bit flag set and the lpszLocalFile member will be the full path to the document. If the URL is mapped to a registered program or script, then the lpszLocalFile member will be the full path to the server root directory, If the request URL included additional path information, that will be appended to the root directory.
- The value of the lpszScriptFile member is only defined if the dwFlags member has the HTTP_REQUEST_FLAG_SCRIPT bit flag set. This indicates that the request URL references a file that is an executable script with a handler that was registered using the HttpRegisterHandler function.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpReceiveRequest](#httpreceiverequest-structure)
- [HttpSendResponse](#httpsendresponse-structure)
- [HTTPRESPONSE](#httpresponse-structure)

---

## HTTPRESPONSE Structure

The HTTPRESPONSE structure provides additional information about the response to the client.

### Definition

```c
typedef struct _HTTPRESPONSE
{
    DWORD dwSize;
    DWORD dwFlags;
    DWORD dwVersion;
    DWORD dwReserved;
    UINT nExpires;
    UINT nResultCode;
    LPCTSTR lpszReason;
    LPCTSTR lpszMediaType;
} HTTPRESPONSE, *LPHTTPRESPONSE;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | An unsigned integer value that specifies the size of the structure. |
| `dwFlags` | `DWORD` | An unsigned integer value that specifies one or more response flags. This member is reserved for future use and should always have a value of zero. |
| `dwVersion` | `DWORD` | An unsigned integer value that specifies the protocol version used. It may be one of the following values: |
| `dwReserved` | `DWORD` | An unsigned integer value that is reserved for future use. |
| `nExpires` | `UINT` | An integer value that specifies the number of seconds until the client should consider any cached response data to be stale. If this value is zero, the default cache expiration time for the server will be used. The default cache expiration time is 7200 seconds (2 hours). The value of this structure member is ignored if the HTTP_RESPONSE_NOCACHE option is specified when the response is sent to the client. |
| `nResultCode` | `UINT` | An integer value that specifies the result code that should be sent in response to the client request. The result code is a three-digit number that indicates success or failure. For more information, refer to the HttpGetCommandResult function. |
| `lpszReason` | `LPCTSTR` | A string that that describes the result code sent to the client. The description should be brief and should not contain any formatting characters or HTML markup. This parameter may be NULL, in which case a default description of the result code will be used. |
| `lpszMediaType` | `LPCTSTR` | A string that specifies the Internet media type for the data that is being sent to the client as defined in RFC 2046. The format for the content type string consists of two parts, a primary and secondary media type separated by a forward slash. Common examples are "text/plain", "text/html" and "application/octet-stream". If this member is NULL, the library will attempt to automatically determine the appropriate media type. |

### Remarks

- This structure is used with the HttpSendResponse function and the dwSize member must be initialized to size of the structure. Failure to properly initialize the structure will cause the function call to fail.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpGetCommandResult](#httpgetcommandresult-structure)
- [HttpReceiveRequest](#httpreceiverequest-structure)
- [HttpSendResponse](#httpsendresponse-structure)
- [HTTPREQUEST](#httprequest-structure)

---

## HTTPSERVERCONFIG Structure

The HTTPSERVERCONFIG structure provides the configuration information used to create an instance of an HTTP server.

### Definition

```c
typedef struct _HTTPSERVERCONFIG
{
    DWORD dwSize;
    UINT nMaxClients;
    UINT nMaxClientsPerAddress;
    UINT nMaxRequests;
    UINT nMaxPostSize;
    UINT nLogFormat;
    UINT nLogLevel;
    UINT nCacheTime;
    UINT nIdleTime;
    UINT nExecTime;
    LPCTSTR lpszIdentity;
    LPCTSTR lpszHostUuid;
    LPCTSTR lpszHostName;
    LPCTSTR lpszRootPath;
    LPCTSTR lpszTempPath;
    LPCTSTR lpszLogFile;
} HTTPSERVERCONFIG, *LPHTTPSERVERCONFIG;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | An unsigned integer value that specifies the size of the structure. |
| `nMaxClients` | `UINT` | An integer value that specifies the maximum number of active client connections that will be accepted by the server. If the maximum number of clients is reached, any further connections are rejected by the server until one or more clients close their connection to the server or are disconnected. A value of zero specifies the default configuration value of 100 connections should be used. |
| `nMaxClientsPerAddress` | `UINT` | An integer value that specifies the maximum number of active client connections per IP address that will be accepted by the server. If the maximum number of clients from the same IP address is reached, any further connections are rejected until one of the clients closes its connection to the server. A value of zero specifies the default configuration value of 8 connections per address should be used. |
| `nMaxRequests` | `UINT` | An integer value that specifies the maximum number of a requests a client may make per connection. When a client reaches the maximum number of requests, the server will close the connection and the client must establish a new connection to send another request. If this member has a value of zero, the server will allow 5 requests per connection. The minimum value is 1 and the maximum is 100. |
| `nMaxPostSize` | `UINT` | An integer value that specifies the maximum size of the request data that may be submitted by a client with a POST command. If the amount of request data submitted to the server exceeds this limit, the server will return a 413 error to the client and the connection will be closed. If this member has a value of zero, the server will permit the client to submit up to 4 MB (4,194,304 bytes) of data. The minimum value is 100 KB (102,400 bytes) and the maximum value is 100 MB (104,857,600 bytes). |
| `nLogFormat` | `UINT` | An integer value that specifies the format used when creating or updating the server log file. The following formats are supported: |
| `nLogLevel` | `UINT` | An integer value that specifies the level of detail that should generated in the log file. The minimum value is 1 and the maximum value is 10. If the nLogFormat member specifies a valid log file format and this value is zero, a default level of detail will be selected based on the format. The common log file format generally contains less information by default, only logging the data transfers between the client and server. The W3C extended log file format defaults to a higher level of detail that includes additional information about the client session. The higher the level of detail, the larger the log file will be. |
| `nCacheTime` | `UINT` | An integer value that specifies the amount of time that the client should store a document in its cache before requesting it from the server again. A value of zero specifies that the default value of 7200 seconds (2 hours) should be used. |
| `nIdleTime` | `UINT` | An integer value that specifies the maximum number of seconds that a client session may be idle before the server closes the control connection to the client. A value of zero specifies the default value of 60 seconds. If the value is non-zero, the minimum value is 10 seconds and the maximum value is 300 seconds (5 minutes). This value is used to initialize the default idle timeout period for each client session. The server determines if a client is idle based on the time the last command was issued and whether or not a file transfer is in progress. |
| `nExecTime` | `UINT` | An unsigned integer value that specifies the maximum number of seconds that an external CGI program is permitted to run on the server. Programs are registered using the HttpRegisterProgram function, and are executed when the client sends a request for a resource that is associated with the program. If this value is zero, the default timeout period of 5 seconds will be used. The minimum execution time is 1 second and the maximum time limit is 30 seconds. |
| `lpszIdentity` | `LPCTSTR` | A pointer to a string that identifies the server. It is used for informational purposes only and has no effect on the operation of the server. If this member is not initialized to a value, then a default identity will be used. The server identity is provided when a client establishes the initial connection and when the client sends the STAT or CSID commands. If this member is defined, it is recommended that you only use printable ASCII characters. |
| `lpszHostUuid` | `LPCTSTR` | A pointer to a string that specifies a Universally Unique Identifier (UUID) that is used to uniquely identify the server. This value can be used when storing information about the server, and should be generated using a utility such as uuidgen which is included with Visual Studio. This structure member may be initialized to an empty string, in which case a temporary UUID will be randomly generated. |
| `lpszHostName` | `LPCTSTR` | A pointer to a string that specifies the fully-qualified host name for the server. If this structure member is initialized with an empty string, the local host name assigned to the Windows system will be used. This value does not need to correspond to the actual host name associated with the server's IP address. This value is used for informational purposes only and has no effect on the operation of the server. |
| `lpszRootPath` | `LPCTSTR` | A pointer to a string that specifies the path to the root directory for the server. If this structure member is initialized with an empty string, the current working directory for the process will be used as the root directory. It is recommended that you provide a full path to an existing directory and do not specify the root of a local or network drive. If the path does not exist at the time the server is started, it will be automatically created. |
| `lpszTempPath` | `LPCTSTR` | A pointer to a string that specifies the path to the temporary directory for the server. If this structure member is initialized with an empty string, the current temporary directory for the process will be used. The temporary directory cannot be the same as the root directory, and it is strongly recommended that you do not specify the root of a local or network drive. If the path does not exist at the time the server is started, it will be automatically created. |
| `lpszLogFile` | `LPCTSTR` | A pointer to a string that specifies the name of the server log file to create, if a logging format has been specified. If logging is enabled and this member is an empty string, then a default log file name will be created. If the file name does not include a path, then the file is created in the server log directory. If the file name includes a path, the log file will be created using that specific name. If the server is in multi-user mode, then the default location for log files will be the Logs subdirectory in the server root directory. If the server is not in multi-user mode, the default location for log files will be the temporary directory for the current process. |

### Remarks

- When an instance of this structure is passed to the HttpServerStart function, the dwSize member must be initialized to the size of the structure, otherwise the function will fail with an error indicating that the configuration is invalid.
- The nMaxClients member limits the total number of client connections and the nMaxClientsPerAddress member limits the number of simultaneous connections can originate from the same address. If either client limit is exceeded, the server will automatically close the connection. For more control over how the server accepts client connections, use the HttpServerThrottle function. It is not recommended that you set the maximum clients per address below a value of 4. Lower values can negatively impact the performance of some clients, particularly web browsers.
- The nMaxPostSize member limits the amount of data that a client can submit to the server using a POST command. The default limit is 4 MB which should be sufficient for most applications. One situation where you may need to increase this value is if you expect the client to upload large files using the POST command. Increasing this limit will potentially increase the amount of virtual memory that the server will allocate. Note that this value does not limit amount of data that can be uploaded using the PUT command.
- When specifying the root directory for the server configuration, it is important to consider that a client's default access to files on the system will be limited to these directories and any subdirectories. If a root directory is not specified, then one will be created using the current working directory for the process. The root directory path may include environment variables surrounded by % symbols and these will be expanded.
- For servers that are publicly accessible, or where you want files to be a accessible across multiple server sessions, you should always populate the szHostUuid member with a valid UUID string, and the lpszRootPath member should specify an absolute path to an existing directory.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

### See Also

- [HttpServerStart](#httpserverstart-structure)
- [HttpServerStop](#httpserverstop-structure)
- [HttpServerThrottle](#httpserverthrottle-structure)

---

## HTTPSERVERTRANSFER Structure

The HTTPSERVERTRANSFER structure provides information about the last file transfer performed by a client.

### Definition

```c
typedef struct _HTTPSERVERTRANSFER
{
    DWORD dwSize;
    DWORD dwReserved;
    DWORD dwFileAccess;
    DWORD dwTimeElapsed;
    ULARGE_INTEGER uiBytesCopied;
} HTTPSERVERTRANSFER, *LPHTTPSERVERTRANSFER;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | An unsigned integer value that specifies the size of the structure. |
| `dwReserved` | `DWORD` | An unsigned integer value that is reserved for future use. This value will always be zero. |
| `dwFileAccess` | `DWORD` | An unsigned integer value that specifies the how the local file was accessed. It can be one of the following values: |
| `dwTimeElapsed` | `DWORD` | The amount of time that it took for the file transfer to complete in milliseconds. This value is limited to the resolution of the system timer, which is typically in the range of 10 to 16 milliseconds. This value may be zero if the transfer occurred over a local network or on the same host using a loopback address. |
| `uiBytesCopied` | `ULARGE_INTEGER` | A 64-bit integer value that specifies the total number of bytes copied during the file transfer. This value is represented by a ULARGE_INTEGER union which provides support for those programming languages that do not have intrinsic support for 64-bit integers. For more information, refer to the Windows SDK documentation. The application should not make the assumption that this is the actual size of the file. |

### Remarks

- When an instance of this structure is passed to the HttpGetServerTransferInfo function, the dwSize member must be initialized to the size of the structure, otherwise the function will fail with an error indicating that the parameter is invalid. All other members should be initialized to a value of zero.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`

### See Also

- [HttpGetServerTransferInfo](#httpgetservertransferinfo-structure)

---

## INITDATA Structure

This structure contains information about the SocketTools library when the initialization function returns.

### Definition

```c
typedef struct _INITDATA
{
    DWORD dwSize;
    DWORD dwVersionMajor;
    DWORD dwVersionMinor;
    DWORD dwVersionBuild;
    DWORD dwOptions;
    DWORD_PTR dwReserved1;
    DWORD_PTR dwReserved2;
    TCHAR szDescription;
} INITDATA, *LPINITDATA;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | Size of this structure. This structure member must be set to the size of the structure prior to calling the initialization function. Failure to do so will cause the function to fail. |
| `dwVersionMajor` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. When the function returns, it will contain the major version number for the library. |
| `dwVersionMinor` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. When the function returns, it will contain the minor version number for the library. |
| `dwVersionBuild` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. When the function returns, it will contain the build number for the library. |
| `dwOptions` | `DWORD` | This member must be initialized to a value of zero prior to calling the initialization function. This member is reserved for future use. |
| `dwReserved1` | `DWORD_PTR` | This member must be initialized to a value of zero prior to calling the initialization function. This member is reserved for future use. |
| `dwReserved2` | `DWORD_PTR` | This member must be initialized to a value of zero prior to calling the initialization function. This member is reserved for future use. |
| `szDescription` | `TCHAR` | A null terminated string which describes the library. |

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

---

## SECURITYCREDENTIALS Structure

The SECURITYCREDENTIALS structure specifies the information needed by the library to specify the security protocol and server certificate when accepting a secure connection.

### Definition

```c
typedef struct _SECURITYCREDENTIALS
{
    DWORD dwSize;
    DWORD dwProtocol;
    DWORD dwOptions;
    DWORD dwReserved;
    LPCTSTR lpszHostName;
    LPCTSTR lpszUserName;
    LPCTSTR lpszPassword;
    LPCTSTR lpszCertStore;
    LPCTSTR lpszCertName;
    LPCTSTR lpszKeyFile;
} SECURITYCREDENTIALS, *LPSECURITYCREDENTIALS;
```

### Members

| Name | Type | Description |
|------|------|-------------|
| `dwSize` | `DWORD` | Size of this structure. If the structure is being allocated dynamically, this member must be set to the size of the structure and all other unused structure members must be initialized to a value of zero or NULL. |
| `dwProtocol` | `DWORD` | A bitmask of supported security protocols. The value of this structure member is constructed by using a bitwise operator with any of the following values: |
| `dwOptions` | `DWORD` | A value which specifies one or options. This member is constructed by using a bitwise operator with any of the following values: |
| `dwReserved` | `DWORD` | This structure member is reserved for future use and should always be initialized to zero. |
| `lpszHostName` | `LPCTSTR` | A pointer to a null terminated string which specifies the hostname that will be used when validating the server certificate. If this member is NULL, then the server certificate will be validated against the hostname used to establish the connection. |
| `lpszUserName` | `LPCTSTR` | A pointer to a null terminated string which identifies the owner of client certificate. Currently this member is not used by the library and should always be initialized as a NULL pointer. |
| `lpszPassword` | `LPCTSTR` | A pointer to a null terminated string which specifies the password needed to access the certificate. Currently this member is only used if the CREDENTIAL_STORE_FILENAME option has been specified. If there is no password associated with the certificate, then this member should be initialized as a NULL pointer. |
| `lpszCertStore` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the certificate store to open. A certificate store is a collection of certificates and their private keys, typically organized by how they are used. If this value is NULL or points to an empty string, the default certificate store "MY" will be used. |
| `lpszCertName` | `LPCTSTR` | A pointer to a null terminated string which specifies the name of the certificate to use. The library will first search the certificate store for a certificate with a matching "friendly name"; this is a name for the certificate that is assigned by the user. Note that the name must match completely, but the comparison is not case sensitive. If no matching certificate is found, the library will then attempt to find a certificate that has a matching common name (also called the certificate subject). This comparison is less stringent, and the first partial match will be returned. If this second search fails, the library will return an error indicating that the certificate could not be found. If the SECURITY_PROTOCOL_SSH protocol has been specified, this member should be NULL. |
| `lpszKeyFile` | `LPCTSTR` | This member is not used and should always be NULL. The private key cannot be specified separately and must be associated with the certificate. |

### Remarks

- A client application only needs to create this structure if the server requires that the client provide a certificate as part of the process of negotiating the secure session. If a certificate is required, note that it must have a private key associated with it. Attempting to use a certificate that does not have a private key will result in an error during the connection process indicating that the client credentials could not be established.
- If you are using a local certificate store, with the certificate and private key stored in the registry, you can explicitly specify whether the certificate store for the current user or the local machine (all users) should be used. This is done by prefixing the certificate store name with "HKCU:" for the current user, or "HKLM:" for the local machine. For example, a certificate store name of "HKLM:MY" would specify the personal certificate store for the local machine, rather than the current user. If neither prefix is specified, then it will default to the certificate store for the current user. You can manage these certificates using the CertMgr.msc Microsoft Management Console (MMC) snap-in.
- It is possible to load the certificate from a file rather than from current user's certificate store. The dwOptions member should be set to CREDENTIAL_STORE_FILENAME and the lpszCertStore member should specify the name of the file that contains the certificate and its private key. The file must be in Private Information Exchange (PFX) format, also known as PKCS #12. These certificate files typically have an extension of .pfx or .p12. Note that if a password was specified when the certificate file was created, it must be provided in the lpszPassword member or the library will be unable to access the certificate.
- Note that the lpszUserName and lpszPassword members are values which are used to access the certificate store or private key file. They are not the credentials which are used when establishing the connection with the remote host or authenticating the client session.

### Requirements

- Minimum Desktop Platform: Windows 7 Service Pack 1
- Minimum Server Platform: Windows Server 2008 R2 Service Pack 1
- Header: `cstools11.h`
- Unicode: Implemented as Unicode and ANSI versions.

